/* AppWindow.c generated by valac 0.44.3, the Vala compiler
 * generated from AppWindow.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io)
*               2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* AppWindow is the parent window for most windows in Photos (FullscreenWindow is the exception).*/
/* There are multiple types of AppWindows (LibraryWindow, DirectWindow) for different tasks, but only*/
/* one AppWindow may exist per process.  Thus, if the user closes an AppWindow, the program exits.*/
/**/
/* AppWindow also offers support for going into fullscreen mode.  It handles the interface*/
/* notifications Page is expecting when switching back and forth.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;
typedef struct _PageWindowPrivate PageWindowPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;
typedef struct _AppWindowPrivate AppWindowPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
enum  {
	APP_WINDOW_0_PROPERTY,
	APP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* app_window_properties[APP_WINDOW_NUM_PROPERTIES];

#define TYPE_FULLSCREEN_WINDOW (fullscreen_window_get_type ())
#define FULLSCREEN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FULLSCREEN_WINDOW, FullscreenWindow))
#define FULLSCREEN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FULLSCREEN_WINDOW, FullscreenWindowClass))
#define IS_FULLSCREEN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FULLSCREEN_WINDOW))
#define IS_FULLSCREEN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FULLSCREEN_WINDOW))
#define FULLSCREEN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FULLSCREEN_WINDOW, FullscreenWindowClass))

typedef struct _FullscreenWindow FullscreenWindow;
typedef struct _FullscreenWindowClass FullscreenWindowClass;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_CHECKERBOARD_PAGE (checkerboard_page_get_type ())
#define CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPage))
#define CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))
#define IS_CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_PAGE))
#define IS_CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_PAGE))
#define CHECKERBOARD_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))

typedef struct _CheckerboardPage CheckerboardPage;
typedef struct _CheckerboardPageClass CheckerboardPageClass;

#define TYPE_COMMAND_DESCRIPTION (command_description_get_type ())
#define COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescription))
#define IS_COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_DESCRIPTION))
#define COMMAND_DESCRIPTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescriptionIface))

typedef struct _CommandDescription CommandDescription;
typedef struct _CommandDescriptionIface CommandDescriptionIface;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PageWindow {
	GtkApplicationWindow parent_instance;
	PageWindowPrivate * priv;
	GtkUIManager* ui;
};

struct _PageWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*switched_pages) (PageWindow* self, Page* old_page, Page* new_page);
	void (*set_current_page) (PageWindow* self, Page* page);
	void (*clear_current_page) (PageWindow* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _AppWindow {
	PageWindow parent_instance;
	AppWindowPrivate * priv;
	GtkActionGroup** common_action_groups;
	gint common_action_groups_length1;
	Dimensions dimensions;
	GtkHeaderBar* header;
	GtkButton* redo_btn;
	GtkButton* undo_btn;
	GSettings* window_settings;
};

struct _AppWindowClass {
	PageWindowClass parent_class;
	void (*on_fullscreen) (AppWindow* self);
	gchar* (*get_app_role) (AppWindow* self);
	void (*on_quit) (AppWindow* self);
	GtkActionGroup** (*create_common_action_groups) (AppWindow* self, gint* result_length1);
	void (*update_common_action_availability) (AppWindow* self, Page* old_page, Page* new_page);
	void (*update_common_actions) (AppWindow* self, Page* page, gint selected_count, gint count);
};

struct _AppWindowPrivate {
	gint pos_x;
	gint pos_y;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _CommandDescriptionIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (CommandDescription* self);
	gchar* (*get_explanation) (CommandDescription* self);
};

static gint AppWindow_private_offset;
static gpointer app_window_parent_class = NULL;
extern AppWindow* app_window_instance;
AppWindow* app_window_instance = NULL;
static FullscreenWindow* app_window_fullscreen_window;
static FullscreenWindow* app_window_fullscreen_window = NULL;
static CommandManager* app_window_command_manager;
static CommandManager* app_window_command_manager = NULL;

GType page_window_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
GType app_window_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType fullscreen_window_get_type (void) G_GNUC_CONST;
gpointer command_manager_ref (gpointer instance);
void command_manager_unref (gpointer instance);
GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_command_manager (GValue* value,
                                gpointer v_object);
void value_take_command_manager (GValue* value,
                                 gpointer v_object);
gpointer value_get_command_manager (const GValue* value);
GType command_manager_get_type (void) G_GNUC_CONST;
#define APP_WINDOW_ACTION_PREFIX "win."
#define APP_WINDOW_ACTION_FULLSCREEN "action_fullscreen"
#define APP_WINDOW_ACTION_JUMP_TO_FILE "action_jump_to_file"
#define APP_WINDOW_ACTION_QUIT "action_quit"
#define APP_WINDOW_ACTION_REDO "action_redo"
#define APP_WINDOW_ACTION_SELECT_ALL "action_select_all"
#define APP_WINDOW_ACTION_SELECT_NONE "action_select_none"
#define APP_WINDOW_ACTION_UNDO "action_undo"
void app_window_on_fullscreen (AppWindow* self);
static void _app_window_on_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void app_window_on_jump_to_file (AppWindow* self);
static void _app_window_on_jump_to_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
void app_window_on_quit (AppWindow* self);
static void _app_window_on_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void app_window_on_redo (AppWindow* self);
static void _app_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void app_window_on_select_all (AppWindow* self);
static void _app_window_on_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static void app_window_on_select_none (AppWindow* self);
static void _app_window_on_select_none_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void app_window_on_undo (AppWindow* self);
static void _app_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
AppWindow* app_window_construct (GType object_type);
PageWindow* page_window_construct (GType object_type);
static void app_window_real_on_fullscreen (AppWindow* self);
AppWindow* app_window_get_instance (void);
FullscreenWindow* app_window_get_fullscreen (void);
void app_window_error_message (const gchar* title,
                               const gchar* message,
                               GtkWindow* parent);
GtkResponseType app_window_cancel_affirm_question (const gchar* message,
                                                   const gchar* affirmative,
                                                   const gchar* title);
#define RESOURCES_APP_TITLE N_ ("Photos")
GQuark database_error_quark (void);
void app_window_database_error (GError* err);
void app_window_panic (const gchar* msg);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
void application_panic (Application* self);
gchar* app_window_get_app_role (AppWindow* self);
static gchar* app_window_real_get_app_role (AppWindow* self);
static void app_window_real_on_quit (AppWindow* self);
void application_exit (Application* self);
Page* page_window_get_current_page (PageWindow* self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
ViewCollection* page_get_view (Page* self);
gint view_collection_get_selected_count (ViewCollection* self);
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
DataSource* data_view_get_source (DataView* self);
static void app_window_show_file_uri (AppWindow* self,
                               GFile* file,
                               GError** error);
GFile* media_source_get_master_file (MediaSource* self);
gchar* resources_jump_to_file_failed (GError* err);
static void app_window_real_destroy (GtkWidget* base);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GtkActionGroup** app_window_create_common_action_groups (AppWindow* self,
                                                         gint* result_length1);
static GtkActionGroup** app_window_real_create_common_action_groups (AppWindow* self,
                                                              gint* result_length1);
GtkActionGroup** app_window_get_common_action_groups (AppWindow* self,
                                                      gint* result_length1);
static GtkActionGroup** _vala_array_dup1 (GtkActionGroup** self,
                                   int length);
void app_window_go_fullscreen (AppWindow* self,
                               Page* page);
FullscreenWindow* fullscreen_window_new (Page* page);
FullscreenWindow* fullscreen_window_construct (GType object_type,
                                               Page* page);
void page_switching_to_fullscreen (Page* self,
                                   FullscreenWindow* fsw);
void app_window_end_fullscreen (AppWindow* self);
void page_returning_from_fullscreen (Page* self,
                                     FullscreenWindow* fsw);
GtkAction* app_window_get_common_action (AppWindow* self,
                                         const gchar* name);
void app_window_set_common_action_sensitive (AppWindow* self,
                                             const gchar* name,
                                             gboolean sensitive);
void app_window_set_common_action_visible (AppWindow* self,
                                           const gchar* name,
                                           gboolean visible);
static void app_window_real_switched_pages (PageWindow* base,
                                     Page* old_page,
                                     Page* new_page);
void app_window_update_common_action_availability (AppWindow* self,
                                                   Page* old_page,
                                                   Page* new_page);
static void app_window_on_update_common_actions (AppWindow* self);
static void _app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            GeeIterable* removed,
                                                                            gpointer self);
static void _app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                                   gpointer self);
static void _app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                               GeeIterable* changed,
                                                                               gpointer self);
void app_window_update_common_actions (AppWindow* self,
                                       Page* page,
                                       gint selected_count,
                                       gint count);
gint data_collection_get_count (DataCollection* self);
void page_window_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page);
static void app_window_real_update_common_action_availability (AppWindow* self,
                                                        Page* old_page,
                                                        Page* new_page);
GType checkerboard_page_get_type (void) G_GNUC_CONST;
static void app_window_real_update_common_actions (AppWindow* self,
                                            Page* page,
                                            gint selected_count,
                                            gint count);
static void app_window_on_command_manager_altered (AppWindow* self);
CommandManager* app_window_get_command_manager (void);
GType command_description_get_type (void) G_GNUC_CONST;
static void app_window_decorate_command_manager_action (AppWindow* self,
                                                 const gchar* name,
                                                 GtkButton* button,
                                                 const gchar* default_explanation,
                                                 CommandDescription* desc);
CommandDescription* command_manager_get_undo_description (CommandManager* self);
CommandDescription* command_manager_get_redo_description (CommandManager* self);
gchar* command_description_get_name (CommandDescription* self);
gboolean command_manager_undo (CommandManager* self);
gboolean command_manager_redo (CommandManager* self);
void view_collection_select_all (ViewCollection* self);
void view_collection_unselect_all (ViewCollection* self);
static gboolean app_window_real_configure_event (GtkWidget* base,
                                          GdkEventConfigure* event);
static GObject * app_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
#define COMMAND_MANAGER_DEFAULT_DEPTH 20
CommandManager* command_manager_new (gint depth);
CommandManager* command_manager_construct (GType object_type,
                                           gint depth);
static void _app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                     gboolean can_undo,
                                                                     gboolean can_redo,
                                                                     gpointer self);
#define GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME "io.elementary.photos"
#define GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME ".preferences"
#define GSETTINGS_CONFIGURATION_ENGINE_WINDOW_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME ".window"
gchar* build_dummy_ui_string (GtkActionGroup** groups,
                              gint groups_length1);
static void app_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry APP_WINDOW_action_entries[7] = {{APP_WINDOW_ACTION_FULLSCREEN, _app_window_on_fullscreen_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_JUMP_TO_FILE, _app_window_on_jump_to_file_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_QUIT, _app_window_on_quit_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_REDO, _app_window_on_redo_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_SELECT_ALL, _app_window_on_select_all_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_SELECT_NONE, _app_window_on_select_none_gsimple_action_activate_callback}, {APP_WINDOW_ACTION_UNDO, _app_window_on_undo_gsimple_action_activate_callback}};

static inline gpointer
app_window_get_instance_private (AppWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AppWindow_private_offset);
}

static void
_app_window_on_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_fullscreen ((AppWindow*) self);
#line 503 "AppWindow.c"
}

static void
_app_window_on_jump_to_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_jump_to_file ((AppWindow*) self);
#line 513 "AppWindow.c"
}

static void
_app_window_on_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_quit ((AppWindow*) self);
#line 523 "AppWindow.c"
}

static void
_app_window_on_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_redo ((AppWindow*) self);
#line 533 "AppWindow.c"
}

static void
_app_window_on_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_select_all ((AppWindow*) self);
#line 543 "AppWindow.c"
}

static void
_app_window_on_select_none_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_select_none ((AppWindow*) self);
#line 553 "AppWindow.c"
}

static void
_app_window_on_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 55 "../src/AppWindow.vala"
	app_window_on_undo ((AppWindow*) self);
#line 563 "AppWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../src/AppWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 571 "AppWindow.c"
}

AppWindow*
app_window_construct (GType object_type)
{
	AppWindow * self = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
#line 65 "../src/AppWindow.vala"
	self = (AppWindow*) page_window_construct (object_type);
#line 67 "../src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 67 "../src/AppWindow.vala"
	_vala_assert (_tmp0_ == NULL, "instance == null");
#line 68 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 68 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_instance);
#line 68 "../src/AppWindow.vala"
	app_window_instance = _tmp1_;
#line 65 "../src/AppWindow.vala"
	return self;
#line 594 "AppWindow.c"
}

static void
app_window_real_on_fullscreen (AppWindow* self)
{
#line 125 "../src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_on_fullscreen'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 125 "../src/AppWindow.vala"
	return;
#line 604 "AppWindow.c"
}

void
app_window_on_fullscreen (AppWindow* self)
{
#line 125 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->on_fullscreen (self);
#line 614 "AppWindow.c"
}

AppWindow*
app_window_get_instance (void)
{
	AppWindow* result = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
#line 128 "../src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 128 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "../src/AppWindow.vala"
	result = _tmp1_;
#line 128 "../src/AppWindow.vala"
	return result;
#line 631 "AppWindow.c"
}

FullscreenWindow*
app_window_get_fullscreen (void)
{
	FullscreenWindow* result = NULL;
	FullscreenWindow* _tmp0_;
	FullscreenWindow* _tmp1_;
#line 132 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 132 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 132 "../src/AppWindow.vala"
	result = _tmp1_;
#line 132 "../src/AppWindow.vala"
	return result;
#line 648 "AppWindow.c"
}

void
app_window_error_message (const gchar* title,
                          const gchar* message,
                          GtkWindow* parent)
{
	GraniteMessageDialog* dialog = NULL;
	GraniteMessageDialog* _tmp0_;
	GtkWindow* _tmp1_ = NULL;
	GtkWindow* _tmp2_;
	GraniteMessageDialog* _tmp4_;
	GraniteMessageDialog* _tmp5_;
	GraniteMessageDialog* _tmp6_;
#line 135 "../src/AppWindow.vala"
	g_return_if_fail (title != NULL);
#line 136 "../src/AppWindow.vala"
	_tmp0_ = granite_message_dialog_new_with_image_from_icon_name (title, message, "dialog-error", GTK_BUTTONS_CLOSE);
#line 136 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 136 "../src/AppWindow.vala"
	dialog = _tmp0_;
#line 142 "../src/AppWindow.vala"
	_tmp2_ = _g_object_ref0 (parent);
#line 142 "../src/AppWindow.vala"
	_tmp1_ = _tmp2_;
#line 142 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 677 "AppWindow.c"
		AppWindow* _tmp3_;
#line 142 "../src/AppWindow.vala"
		_tmp3_ = app_window_get_instance ();
#line 142 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp1_);
#line 142 "../src/AppWindow.vala"
		_tmp1_ = (GtkWindow*) _tmp3_;
#line 685 "AppWindow.c"
	}
#line 142 "../src/AppWindow.vala"
	_tmp4_ = dialog;
#line 142 "../src/AppWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp4_, _tmp1_);
#line 143 "../src/AppWindow.vala"
	_tmp5_ = dialog;
#line 143 "../src/AppWindow.vala"
	gtk_dialog_run ((GtkDialog*) _tmp5_);
#line 144 "../src/AppWindow.vala"
	_tmp6_ = dialog;
#line 144 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp6_);
#line 135 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 135 "../src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 703 "AppWindow.c"
}

GtkResponseType
app_window_cancel_affirm_question (const gchar* message,
                                   const gchar* affirmative,
                                   const gchar* title)
{
	GtkResponseType result = 0;
	const gchar* _tmp0_ = NULL;
	GraniteMessageDialog* dialog = NULL;
	GraniteMessageDialog* _tmp1_;
	AppWindow* _tmp2_;
	AppWindow* _tmp3_;
	gint response = 0;
#line 147 "../src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 147 "../src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 149 "../src/AppWindow.vala"
	_tmp0_ = title;
#line 149 "../src/AppWindow.vala"
	if (_tmp0_ == NULL) {
#line 149 "../src/AppWindow.vala"
		_tmp0_ = _ (RESOURCES_APP_TITLE);
#line 728 "AppWindow.c"
	}
#line 148 "../src/AppWindow.vala"
	_tmp1_ = granite_message_dialog_new_with_image_from_icon_name (_tmp0_, message, "dialog-question", GTK_BUTTONS_CANCEL);
#line 148 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 148 "../src/AppWindow.vala"
	dialog = _tmp1_;
#line 154 "../src/AppWindow.vala"
	_tmp2_ = app_window_get_instance ();
#line 154 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 154 "../src/AppWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) dialog, (GtkWindow*) _tmp3_);
#line 154 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 155 "../src/AppWindow.vala"
	gtk_dialog_add_button ((GtkDialog*) dialog, affirmative, (gint) GTK_RESPONSE_YES);
#line 156 "../src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) dialog);
#line 157 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 159 "../src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 159 "../src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 159 "../src/AppWindow.vala"
	return result;
#line 756 "AppWindow.c"
}

void
app_window_database_error (GError* err)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 163 "../src/AppWindow.vala"
	_tmp0_ = err->message;
#line 163 "../src/AppWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("A fatal error occurred when accessing Photos' library.  Photos cannot " \
"continue.\n" \
"\n" \
"%s"), _tmp0_);
#line 163 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 163 "../src/AppWindow.vala"
	app_window_panic (_tmp2_);
#line 163 "../src/AppWindow.vala"
	_g_free0 (_tmp2_);
#line 775 "AppWindow.c"
}

void
app_window_panic (const gchar* msg)
{
	Application* _tmp0_;
	Application* _tmp1_;
#line 167 "../src/AppWindow.vala"
	g_return_if_fail (msg != NULL);
#line 168 "../src/AppWindow.vala"
	g_critical ("AppWindow.vala:168: %s", msg);
#line 169 "../src/AppWindow.vala"
	app_window_error_message (msg, NULL, NULL);
#line 171 "../src/AppWindow.vala"
	_tmp0_ = application_get_instance ();
#line 171 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 171 "../src/AppWindow.vala"
	application_panic (_tmp1_);
#line 171 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 797 "AppWindow.c"
}

static gchar*
app_window_real_get_app_role (AppWindow* self)
{
#line 174 "../src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_get_app_role'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 174 "../src/AppWindow.vala"
	return NULL;
#line 807 "AppWindow.c"
}

gchar*
app_window_get_app_role (AppWindow* self)
{
#line 174 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "../src/AppWindow.vala"
	return APP_WINDOW_GET_CLASS (self)->get_app_role (self);
#line 817 "AppWindow.c"
}

static void
app_window_real_on_quit (AppWindow* self)
{
	Application* _tmp0_;
	Application* _tmp1_;
#line 177 "../src/AppWindow.vala"
	_tmp0_ = application_get_instance ();
#line 177 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 177 "../src/AppWindow.vala"
	application_exit (_tmp1_);
#line 177 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 833 "AppWindow.c"
}

void
app_window_on_quit (AppWindow* self)
{
#line 176 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->on_quit (self);
#line 843 "AppWindow.c"
}

static void
app_window_on_jump_to_file (AppWindow* self)
{
	Page* _tmp0_;
	Page* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	gboolean _tmp4_;
	MediaSource* media = NULL;
	Page* _tmp5_;
	Page* _tmp6_;
	ViewCollection* _tmp7_;
	ViewCollection* _tmp8_;
	DataView* _tmp9_;
	DataView* _tmp10_;
	DataSource* _tmp11_;
	DataSource* _tmp12_;
	MediaSource* _tmp13_;
	MediaSource* _tmp14_;
	MediaSource* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 180 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 181 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 181 "../src/AppWindow.vala"
	_tmp2_ = page_get_view (_tmp1_);
#line 181 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 181 "../src/AppWindow.vala"
	_tmp4_ = view_collection_get_selected_count (_tmp3_) != 1;
#line 181 "../src/AppWindow.vala"
	_data_collection_unref0 (_tmp3_);
#line 181 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 181 "../src/AppWindow.vala"
	if (_tmp4_) {
#line 182 "../src/AppWindow.vala"
		return;
#line 887 "AppWindow.c"
	}
#line 184 "../src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 184 "../src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 184 "../src/AppWindow.vala"
	_tmp7_ = page_get_view (_tmp6_);
#line 184 "../src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 184 "../src/AppWindow.vala"
	_tmp9_ = view_collection_get_selected_at (_tmp8_, 0);
#line 184 "../src/AppWindow.vala"
	_tmp10_ = _tmp9_;
#line 184 "../src/AppWindow.vala"
	_tmp11_ = data_view_get_source (_tmp10_);
#line 184 "../src/AppWindow.vala"
	_tmp12_ = _tmp11_;
#line 184 "../src/AppWindow.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, TYPE_MEDIA_SOURCE) ? ((MediaSource*) _tmp12_) : NULL);
#line 184 "../src/AppWindow.vala"
	_tmp14_ = _tmp13_;
#line 184 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp10_);
#line 184 "../src/AppWindow.vala"
	_data_collection_unref0 (_tmp8_);
#line 184 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 184 "../src/AppWindow.vala"
	media = _tmp14_;
#line 185 "../src/AppWindow.vala"
	_tmp15_ = media;
#line 185 "../src/AppWindow.vala"
	if (_tmp15_ == NULL) {
#line 186 "../src/AppWindow.vala"
		_g_object_unref0 (media);
#line 186 "../src/AppWindow.vala"
		return;
#line 925 "AppWindow.c"
	}
	{
		AppWindow* _tmp16_;
		AppWindow* _tmp17_;
		MediaSource* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
#line 189 "../src/AppWindow.vala"
		_tmp16_ = app_window_get_instance ();
#line 189 "../src/AppWindow.vala"
		_tmp17_ = _tmp16_;
#line 189 "../src/AppWindow.vala"
		_tmp18_ = media;
#line 189 "../src/AppWindow.vala"
		_tmp19_ = media_source_get_master_file (_tmp18_);
#line 189 "../src/AppWindow.vala"
		_tmp20_ = _tmp19_;
#line 189 "../src/AppWindow.vala"
		app_window_show_file_uri (_tmp17_, _tmp20_, &_inner_error0_);
#line 189 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp20_);
#line 189 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp17_);
#line 189 "../src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 951 "AppWindow.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		GError* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 188 "../src/AppWindow.vala"
		err = _inner_error0_;
#line 188 "../src/AppWindow.vala"
		_inner_error0_ = NULL;
#line 191 "../src/AppWindow.vala"
		_tmp21_ = err;
#line 191 "../src/AppWindow.vala"
		_tmp22_ = resources_jump_to_file_failed (_tmp21_);
#line 191 "../src/AppWindow.vala"
		_tmp23_ = _tmp22_;
#line 191 "../src/AppWindow.vala"
		app_window_error_message (_tmp23_, NULL, NULL);
#line 191 "../src/AppWindow.vala"
		_g_free0 (_tmp23_);
#line 188 "../src/AppWindow.vala"
		_g_error_free0 (err);
#line 978 "AppWindow.c"
	}
	__finally8:
#line 188 "../src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/AppWindow.vala"
		_g_object_unref0 (media);
#line 188 "../src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 188 "../src/AppWindow.vala"
		g_clear_error (&_inner_error0_);
#line 188 "../src/AppWindow.vala"
		return;
#line 991 "AppWindow.c"
	}
#line 180 "../src/AppWindow.vala"
	_g_object_unref0 (media);
#line 995 "AppWindow.c"
}

static void
app_window_real_destroy (GtkWidget* base)
{
	AppWindow * self;
#line 195 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 196 "../src/AppWindow.vala"
	app_window_on_quit (self);
#line 1006 "AppWindow.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 203 "../src/AppWindow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1014 "AppWindow.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 203 "../src/AppWindow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1022 "AppWindow.c"
}

static void
app_window_show_file_uri (AppWindow* self,
                          GFile* file,
                          GError** error)
{
	GAppInfo* app_info = NULL;
	GAppInfo* _tmp0_;
	GList* file_list = NULL;
	GFile* _tmp1_;
	GdkWindow* _tmp2_;
	GdkScreen* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkAppLaunchContext* _tmp5_;
	GdkAppLaunchContext* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 199 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/AppWindow.vala"
	g_return_if_fail (file != NULL);
#line 200 "../src/AppWindow.vala"
	_tmp0_ = g_app_info_get_default_for_type ("inode/directory", TRUE);
#line 200 "../src/AppWindow.vala"
	app_info = _tmp0_;
#line 201 "../src/AppWindow.vala"
	file_list = NULL;
#line 202 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 202 "../src/AppWindow.vala"
	file_list = g_list_append (file_list, _tmp1_);
#line 203 "../src/AppWindow.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 203 "../src/AppWindow.vala"
	_tmp3_ = gdk_window_get_screen (_tmp2_);
#line 203 "../src/AppWindow.vala"
	_tmp4_ = gdk_screen_get_display (_tmp3_);
#line 203 "../src/AppWindow.vala"
	_tmp5_ = gdk_display_get_app_launch_context (_tmp4_);
#line 203 "../src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 203 "../src/AppWindow.vala"
	g_app_info_launch (app_info, file_list, (GAppLaunchContext*) _tmp6_, &_inner_error0_);
#line 203 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 203 "../src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/AppWindow.vala"
		g_propagate_error (error, _inner_error0_);
#line 203 "../src/AppWindow.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 203 "../src/AppWindow.vala"
		_g_object_unref0 (app_info);
#line 203 "../src/AppWindow.vala"
		return;
#line 1078 "AppWindow.c"
	}
#line 199 "../src/AppWindow.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 199 "../src/AppWindow.vala"
	_g_object_unref0 (app_info);
#line 1084 "AppWindow.c"
}

static GtkActionGroup**
app_window_real_create_common_action_groups (AppWindow* self,
                                             gint* result_length1)
{
	GtkActionGroup** result = NULL;
	GtkActionGroup** groups = NULL;
	GtkActionGroup** _tmp0_;
	gint groups_length1;
	gint _groups_size_;
	GtkActionGroup** _tmp1_;
	gint _tmp1__length1;
#line 207 "../src/AppWindow.vala"
	_tmp0_ = g_new0 (GtkActionGroup*, 0 + 1);
#line 207 "../src/AppWindow.vala"
	groups = _tmp0_;
#line 207 "../src/AppWindow.vala"
	groups_length1 = 0;
#line 207 "../src/AppWindow.vala"
	_groups_size_ = groups_length1;
#line 208 "../src/AppWindow.vala"
	_tmp1_ = groups;
#line 208 "../src/AppWindow.vala"
	_tmp1__length1 = groups_length1;
#line 208 "../src/AppWindow.vala"
	if (result_length1) {
#line 208 "../src/AppWindow.vala"
		*result_length1 = _tmp1__length1;
#line 1114 "AppWindow.c"
	}
#line 208 "../src/AppWindow.vala"
	result = _tmp1_;
#line 208 "../src/AppWindow.vala"
	return result;
#line 1120 "AppWindow.c"
}

GtkActionGroup**
app_window_create_common_action_groups (AppWindow* self,
                                        gint* result_length1)
{
#line 206 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../src/AppWindow.vala"
	return APP_WINDOW_GET_CLASS (self)->create_common_action_groups (self, result_length1);
#line 1131 "AppWindow.c"
}

static GtkActionGroup**
_vala_array_dup1 (GtkActionGroup** self,
                  int length)
{
	GtkActionGroup** result;
	int i;
#line 212 "../src/AppWindow.vala"
	result = g_new0 (GtkActionGroup*, length + 1);
#line 212 "../src/AppWindow.vala"
	for (i = 0; i < length; i++) {
#line 1144 "AppWindow.c"
		GtkActionGroup* _tmp0_;
#line 212 "../src/AppWindow.vala"
		_tmp0_ = _g_object_ref0 (self[i]);
#line 212 "../src/AppWindow.vala"
		result[i] = _tmp0_;
#line 1150 "AppWindow.c"
	}
#line 212 "../src/AppWindow.vala"
	return result;
#line 1154 "AppWindow.c"
}

GtkActionGroup**
app_window_get_common_action_groups (AppWindow* self,
                                     gint* result_length1)
{
	GtkActionGroup** result = NULL;
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
	GtkActionGroup** _tmp1_;
	gint _tmp1__length1;
	GtkActionGroup** _tmp2_;
	gint _tmp2__length1;
#line 211 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 212 "../src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 212 "../src/AppWindow.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 212 "../src/AppWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 212 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 212 "../src/AppWindow.vala"
	_tmp2__length1 = _tmp1__length1;
#line 212 "../src/AppWindow.vala"
	if (result_length1) {
#line 212 "../src/AppWindow.vala"
		*result_length1 = _tmp2__length1;
#line 1186 "AppWindow.c"
	}
#line 212 "../src/AppWindow.vala"
	result = _tmp2_;
#line 212 "../src/AppWindow.vala"
	return result;
#line 1192 "AppWindow.c"
}

void
app_window_go_fullscreen (AppWindow* self,
                          Page* page)
{
	FullscreenWindow* _tmp0_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	FullscreenWindow* fsw = NULL;
	FullscreenWindow* _tmp4_;
	Page* _tmp5_;
	Page* _tmp6_;
	gboolean _tmp7_;
	FullscreenWindow* _tmp11_;
	FullscreenWindow* _tmp12_;
	FullscreenWindow* _tmp13_;
#line 215 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 217 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 217 "../src/AppWindow.vala"
	if (_tmp0_ != NULL) {
#line 1218 "AppWindow.c"
		FullscreenWindow* _tmp1_;
#line 218 "../src/AppWindow.vala"
		_tmp1_ = app_window_fullscreen_window;
#line 218 "../src/AppWindow.vala"
		gtk_window_present ((GtkWindow*) _tmp1_);
#line 220 "../src/AppWindow.vala"
		return;
#line 1226 "AppWindow.c"
	}
#line 223 "../src/AppWindow.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 223 "../src/AppWindow.vala"
	self->priv->pos_x = _tmp2_;
#line 223 "../src/AppWindow.vala"
	self->priv->pos_y = _tmp3_;
#line 224 "../src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 226 "../src/AppWindow.vala"
	_tmp4_ = fullscreen_window_new (page);
#line 226 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 226 "../src/AppWindow.vala"
	fsw = _tmp4_;
#line 228 "../src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 228 "../src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 228 "../src/AppWindow.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 228 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 228 "../src/AppWindow.vala"
	if (_tmp7_) {
#line 1252 "AppWindow.c"
		Page* _tmp8_;
		Page* _tmp9_;
		FullscreenWindow* _tmp10_;
#line 229 "../src/AppWindow.vala"
		_tmp8_ = page_window_get_current_page ((PageWindow*) self);
#line 229 "../src/AppWindow.vala"
		_tmp9_ = _tmp8_;
#line 229 "../src/AppWindow.vala"
		_tmp10_ = fsw;
#line 229 "../src/AppWindow.vala"
		page_switching_to_fullscreen (_tmp9_, _tmp10_);
#line 229 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp9_);
#line 1266 "AppWindow.c"
	}
#line 231 "../src/AppWindow.vala"
	_tmp11_ = fsw;
#line 231 "../src/AppWindow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 231 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 231 "../src/AppWindow.vala"
	app_window_fullscreen_window = _tmp12_;
#line 232 "../src/AppWindow.vala"
	_tmp13_ = app_window_fullscreen_window;
#line 232 "../src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) _tmp13_);
#line 215 "../src/AppWindow.vala"
	_g_object_unref0 (fsw);
#line 1282 "AppWindow.c"
}

void
app_window_end_fullscreen (AppWindow* self)
{
	FullscreenWindow* _tmp0_;
	Page* _tmp1_;
	Page* _tmp2_;
	gboolean _tmp3_;
	FullscreenWindow* _tmp7_;
	FullscreenWindow* _tmp8_;
#line 235 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 236 "../src/AppWindow.vala"
	if (_tmp0_ == NULL) {
#line 237 "../src/AppWindow.vala"
		return;
#line 1302 "AppWindow.c"
	}
#line 239 "../src/AppWindow.vala"
	gtk_window_move ((GtkWindow*) self, self->priv->pos_x, self->priv->pos_y);
#line 241 "../src/AppWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 243 "../src/AppWindow.vala"
	_tmp1_ = page_window_get_current_page ((PageWindow*) self);
#line 243 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 243 "../src/AppWindow.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 243 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 243 "../src/AppWindow.vala"
	if (_tmp3_) {
#line 1318 "AppWindow.c"
		Page* _tmp4_;
		Page* _tmp5_;
		FullscreenWindow* _tmp6_;
#line 244 "../src/AppWindow.vala"
		_tmp4_ = page_window_get_current_page ((PageWindow*) self);
#line 244 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 244 "../src/AppWindow.vala"
		_tmp6_ = app_window_fullscreen_window;
#line 244 "../src/AppWindow.vala"
		page_returning_from_fullscreen (_tmp5_, _tmp6_);
#line 244 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp5_);
#line 1332 "AppWindow.c"
	}
#line 246 "../src/AppWindow.vala"
	_tmp7_ = app_window_fullscreen_window;
#line 246 "../src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 247 "../src/AppWindow.vala"
	_tmp8_ = app_window_fullscreen_window;
#line 247 "../src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp8_);
#line 248 "../src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 248 "../src/AppWindow.vala"
	app_window_fullscreen_window = NULL;
#line 250 "../src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) self);
#line 1348 "AppWindow.c"
}

GtkAction*
app_window_get_common_action (AppWindow* self,
                              const gchar* name)
{
	GtkAction* result = NULL;
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
#line 253 "../src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../src/AppWindow.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 254 "../src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 254 "../src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 1366 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 254 "../src/AppWindow.vala"
		group_collection = _tmp0_;
#line 254 "../src/AppWindow.vala"
		group_collection_length1 = _tmp0__length1;
#line 254 "../src/AppWindow.vala"
		for (group_it = 0; group_it < _tmp0__length1; group_it = group_it + 1) {
#line 1378 "AppWindow.c"
			GtkActionGroup* _tmp1_;
			GtkActionGroup* group = NULL;
#line 254 "../src/AppWindow.vala"
			_tmp1_ = _g_object_ref0 (group_collection[group_it]);
#line 254 "../src/AppWindow.vala"
			group = _tmp1_;
#line 1385 "AppWindow.c"
			{
				GtkAction* action = NULL;
				GtkActionGroup* _tmp2_;
				GtkAction* _tmp3_;
				GtkAction* _tmp4_;
				GtkAction* _tmp5_;
#line 255 "../src/AppWindow.vala"
				_tmp2_ = group;
#line 255 "../src/AppWindow.vala"
				_tmp3_ = gtk_action_group_get_action (_tmp2_, name);
#line 255 "../src/AppWindow.vala"
				_tmp4_ = _g_object_ref0 (_tmp3_);
#line 255 "../src/AppWindow.vala"
				action = _tmp4_;
#line 256 "../src/AppWindow.vala"
				_tmp5_ = action;
#line 256 "../src/AppWindow.vala"
				if (_tmp5_ != NULL) {
#line 257 "../src/AppWindow.vala"
					result = action;
#line 257 "../src/AppWindow.vala"
					_g_object_unref0 (group);
#line 257 "../src/AppWindow.vala"
					return result;
#line 1410 "AppWindow.c"
				}
#line 254 "../src/AppWindow.vala"
				_g_object_unref0 (action);
#line 254 "../src/AppWindow.vala"
				_g_object_unref0 (group);
#line 1416 "AppWindow.c"
			}
		}
	}
#line 260 "../src/AppWindow.vala"
	g_warning ("AppWindow.vala:260: No common action found: %s", name);
#line 262 "../src/AppWindow.vala"
	result = NULL;
#line 262 "../src/AppWindow.vala"
	return result;
#line 1426 "AppWindow.c"
}

void
app_window_set_common_action_sensitive (AppWindow* self,
                                        const gchar* name,
                                        gboolean sensitive)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 265 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 266 "../src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 266 "../src/AppWindow.vala"
	action = _tmp0_;
#line 267 "../src/AppWindow.vala"
	_tmp1_ = action;
#line 267 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1449 "AppWindow.c"
		GtkAction* _tmp2_;
#line 268 "../src/AppWindow.vala"
		_tmp2_ = action;
#line 268 "../src/AppWindow.vala"
		gtk_action_set_sensitive (_tmp2_, sensitive);
#line 1455 "AppWindow.c"
	}
#line 265 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1459 "AppWindow.c"
}

void
app_window_set_common_action_visible (AppWindow* self,
                                      const gchar* name,
                                      gboolean visible)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 271 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 272 "../src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 272 "../src/AppWindow.vala"
	action = _tmp0_;
#line 273 "../src/AppWindow.vala"
	_tmp1_ = action;
#line 273 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1482 "AppWindow.c"
		GtkAction* _tmp2_;
#line 274 "../src/AppWindow.vala"
		_tmp2_ = action;
#line 274 "../src/AppWindow.vala"
		gtk_action_set_visible (_tmp2_, visible);
#line 1488 "AppWindow.c"
	}
#line 271 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1492 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       GeeIterable* removed,
                                                                       gpointer self)
{
#line 281 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1503 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                              gpointer self)
{
#line 282 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1512 "AppWindow.c"
}

static void
_app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                          GeeIterable* changed,
                                                                          gpointer self)
{
#line 283 "../src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 1522 "AppWindow.c"
}

static void
app_window_real_switched_pages (PageWindow* base,
                                Page* old_page,
                                Page* new_page)
{
	AppWindow * self;
#line 277 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 278 "../src/AppWindow.vala"
	app_window_update_common_action_availability (self, old_page, new_page);
#line 280 "../src/AppWindow.vala"
	if (old_page != NULL) {
#line 1537 "AppWindow.c"
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
		guint _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
		guint _tmp8_;
#line 281 "../src/AppWindow.vala"
		_tmp0_ = page_get_view (old_page);
#line 281 "../src/AppWindow.vala"
		_tmp1_ = _tmp0_;
#line 281 "../src/AppWindow.vala"
		g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 281 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self);
#line 281 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp1_);
#line 282 "../src/AppWindow.vala"
		_tmp3_ = page_get_view (old_page);
#line 282 "../src/AppWindow.vala"
		_tmp4_ = _tmp3_;
#line 282 "../src/AppWindow.vala"
		g_signal_parse_name ("selection-group-altered", TYPE_VIEW_COLLECTION, &_tmp5_, NULL, FALSE);
#line 282 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self);
#line 282 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp4_);
#line 283 "../src/AppWindow.vala"
		_tmp6_ = page_get_view (old_page);
#line 283 "../src/AppWindow.vala"
		_tmp7_ = _tmp6_;
#line 283 "../src/AppWindow.vala"
		g_signal_parse_name ("items-state-changed", TYPE_VIEW_COLLECTION, &_tmp8_, NULL, FALSE);
#line 283 "../src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self);
#line 283 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp7_);
#line 1577 "AppWindow.c"
	}
#line 286 "../src/AppWindow.vala"
	if (new_page != NULL) {
#line 1581 "AppWindow.c"
		ViewCollection* _tmp9_;
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
		ViewCollection* _tmp12_;
		ViewCollection* _tmp13_;
		ViewCollection* _tmp14_;
		ViewCollection* _tmp15_;
		ViewCollection* _tmp16_;
		ViewCollection* _tmp17_;
		ViewCollection* _tmp18_;
#line 287 "../src/AppWindow.vala"
		_tmp9_ = page_get_view (new_page);
#line 287 "../src/AppWindow.vala"
		_tmp10_ = _tmp9_;
#line 287 "../src/AppWindow.vala"
		g_signal_connect_object ((DataCollection*) _tmp10_, "contents-altered", (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self, 0);
#line 287 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp10_);
#line 288 "../src/AppWindow.vala"
		_tmp11_ = page_get_view (new_page);
#line 288 "../src/AppWindow.vala"
		_tmp12_ = _tmp11_;
#line 288 "../src/AppWindow.vala"
		g_signal_connect_object (_tmp12_, "selection-group-altered", (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self, 0);
#line 288 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp12_);
#line 289 "../src/AppWindow.vala"
		_tmp13_ = page_get_view (new_page);
#line 289 "../src/AppWindow.vala"
		_tmp14_ = _tmp13_;
#line 289 "../src/AppWindow.vala"
		g_signal_connect_object (_tmp14_, "items-state-changed", (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self, 0);
#line 289 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp14_);
#line 291 "../src/AppWindow.vala"
		_tmp15_ = page_get_view (new_page);
#line 291 "../src/AppWindow.vala"
		_tmp16_ = _tmp15_;
#line 291 "../src/AppWindow.vala"
		_tmp17_ = page_get_view (new_page);
#line 291 "../src/AppWindow.vala"
		_tmp18_ = _tmp17_;
#line 291 "../src/AppWindow.vala"
		app_window_update_common_actions (self, new_page, view_collection_get_selected_count (_tmp16_), data_collection_get_count ((DataCollection*) _tmp18_));
#line 291 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp18_);
#line 291 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp16_);
#line 1630 "AppWindow.c"
	}
#line 295 "../src/AppWindow.vala"
	PAGE_WINDOW_CLASS (app_window_parent_class)->switched_pages (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), old_page, new_page);
#line 1634 "AppWindow.c"
}

static void
app_window_real_update_common_action_availability (AppWindow* self,
                                                   Page* old_page,
                                                   Page* new_page)
{
	gboolean is_checkerboard = FALSE;
	GAction* _tmp0_;
	GAction* _tmp1_;
#line 302 "../src/AppWindow.vala"
	is_checkerboard = G_TYPE_CHECK_INSTANCE_TYPE (new_page, TYPE_CHECKERBOARD_PAGE);
#line 304 "../src/AppWindow.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_ALL);
#line 304 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), is_checkerboard);
#line 305 "../src/AppWindow.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_NONE);
#line 305 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), is_checkerboard);
#line 1655 "AppWindow.c"
}

void
app_window_update_common_action_availability (AppWindow* self,
                                              Page* old_page,
                                              Page* new_page)
{
#line 301 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->update_common_action_availability (self, old_page, new_page);
#line 1667 "AppWindow.c"
}

static void
app_window_real_update_common_actions (AppWindow* self,
                                       Page* page,
                                       gint selected_count,
                                       gint count)
{
	GAction* _tmp1_;
#line 311 "../src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 312 "../src/AppWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_CHECKERBOARD_PAGE)) {
#line 1681 "AppWindow.c"
		GAction* _tmp0_;
#line 313 "../src/AppWindow.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_SELECT_ALL);
#line 313 "../src/AppWindow.vala"
		g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), count > 0);
#line 1687 "AppWindow.c"
	}
#line 316 "../src/AppWindow.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, APP_WINDOW_ACTION_JUMP_TO_FILE);
#line 316 "../src/AppWindow.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction), selected_count == 1);
#line 318 "../src/AppWindow.vala"
	app_window_on_command_manager_altered (self);
#line 1695 "AppWindow.c"
}

void
app_window_update_common_actions (AppWindow* self,
                                  Page* page,
                                  gint selected_count,
                                  gint count)
{
#line 311 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->update_common_actions (self, page, selected_count, count);
#line 1708 "AppWindow.c"
}

static void
app_window_on_update_common_actions (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 321 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 322 "../src/AppWindow.vala"
	page = _tmp0_;
#line 323 "../src/AppWindow.vala"
	_tmp1_ = page;
#line 323 "../src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 1727 "AppWindow.c"
		Page* _tmp2_;
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 324 "../src/AppWindow.vala"
		_tmp2_ = page;
#line 324 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 324 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 324 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 324 "../src/AppWindow.vala"
		_tmp6_ = page;
#line 324 "../src/AppWindow.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 324 "../src/AppWindow.vala"
		_tmp8_ = _tmp7_;
#line 324 "../src/AppWindow.vala"
		app_window_update_common_actions (self, _tmp2_, view_collection_get_selected_count (_tmp5_), data_collection_get_count ((DataCollection*) _tmp8_));
#line 324 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp8_);
#line 324 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 1755 "AppWindow.c"
	}
#line 321 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 1759 "AppWindow.c"
}

static gpointer
_command_manager_ref0 (gpointer self)
{
#line 328 "../src/AppWindow.vala"
	return self ? command_manager_ref (self) : NULL;
#line 1767 "AppWindow.c"
}

CommandManager*
app_window_get_command_manager (void)
{
	CommandManager* result = NULL;
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 328 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 328 "../src/AppWindow.vala"
	_tmp1_ = _command_manager_ref0 (_tmp0_);
#line 328 "../src/AppWindow.vala"
	result = _tmp1_;
#line 328 "../src/AppWindow.vala"
	return result;
#line 1784 "AppWindow.c"
}

static void
app_window_on_command_manager_altered (AppWindow* self)
{
	GtkButton* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	CommandDescription* _tmp3_;
	CommandDescription* _tmp4_;
	GtkButton* _tmp5_;
	CommandManager* _tmp6_;
	CommandManager* _tmp7_;
	CommandDescription* _tmp8_;
	CommandDescription* _tmp9_;
#line 331 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/AppWindow.vala"
	_tmp0_ = self->undo_btn;
#line 332 "../src/AppWindow.vala"
	_tmp1_ = app_window_get_command_manager ();
#line 332 "../src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 332 "../src/AppWindow.vala"
	_tmp3_ = command_manager_get_undo_description (_tmp2_);
#line 332 "../src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 332 "../src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, APP_WINDOW_ACTION_UNDO, _tmp0_, _ ("Undo"), _tmp4_);
#line 332 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 332 "../src/AppWindow.vala"
	_command_manager_unref0 (_tmp2_);
#line 333 "../src/AppWindow.vala"
	_tmp5_ = self->redo_btn;
#line 333 "../src/AppWindow.vala"
	_tmp6_ = app_window_get_command_manager ();
#line 333 "../src/AppWindow.vala"
	_tmp7_ = _tmp6_;
#line 333 "../src/AppWindow.vala"
	_tmp8_ = command_manager_get_redo_description (_tmp7_);
#line 333 "../src/AppWindow.vala"
	_tmp9_ = _tmp8_;
#line 333 "../src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, APP_WINDOW_ACTION_REDO, _tmp5_, _ ("Redo"), _tmp9_);
#line 333 "../src/AppWindow.vala"
	_g_object_unref0 (_tmp9_);
#line 333 "../src/AppWindow.vala"
	_command_manager_unref0 (_tmp7_);
#line 1834 "AppWindow.c"
}

static void
app_window_decorate_command_manager_action (AppWindow* self,
                                            const gchar* name,
                                            GtkButton* button,
                                            const gchar* default_explanation,
                                            CommandDescription* desc)
{
	GSimpleAction* action = NULL;
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
#line 336 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 336 "../src/AppWindow.vala"
	g_return_if_fail (button != NULL);
#line 336 "../src/AppWindow.vala"
	g_return_if_fail (default_explanation != NULL);
#line 337 "../src/AppWindow.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 337 "../src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 337 "../src/AppWindow.vala"
	action = _tmp1_;
#line 338 "../src/AppWindow.vala"
	_tmp2_ = action;
#line 338 "../src/AppWindow.vala"
	if (_tmp2_ == NULL) {
#line 339 "../src/AppWindow.vala"
		_g_object_unref0 (action);
#line 339 "../src/AppWindow.vala"
		return;
#line 1870 "AppWindow.c"
	}
#line 342 "../src/AppWindow.vala"
	if (desc != NULL) {
#line 1874 "AppWindow.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GSimpleAction* _tmp7_;
#line 343 "../src/AppWindow.vala"
		_tmp3_ = command_description_get_name (desc);
#line 343 "../src/AppWindow.vala"
		_tmp4_ = _tmp3_;
#line 343 "../src/AppWindow.vala"
		_tmp5_ = g_strdup_printf ("%s %s", default_explanation, _tmp4_);
#line 343 "../src/AppWindow.vala"
		_tmp6_ = _tmp5_;
#line 343 "../src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, _tmp6_);
#line 343 "../src/AppWindow.vala"
		_g_free0 (_tmp6_);
#line 343 "../src/AppWindow.vala"
		_g_free0 (_tmp4_);
#line 344 "../src/AppWindow.vala"
		_tmp7_ = action;
#line 344 "../src/AppWindow.vala"
		g_simple_action_set_enabled (_tmp7_, TRUE);
#line 1898 "AppWindow.c"
	} else {
		GSimpleAction* _tmp8_;
#line 346 "../src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, default_explanation);
#line 347 "../src/AppWindow.vala"
		_tmp8_ = action;
#line 347 "../src/AppWindow.vala"
		g_simple_action_set_enabled (_tmp8_, FALSE);
#line 1907 "AppWindow.c"
	}
#line 336 "../src/AppWindow.vala"
	_g_object_unref0 (action);
#line 1911 "AppWindow.c"
}

static void
app_window_on_undo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 351 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 352 "../src/AppWindow.vala"
	command_manager_undo (_tmp0_);
#line 1924 "AppWindow.c"
}

static void
app_window_on_redo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 355 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 356 "../src/AppWindow.vala"
	command_manager_redo (_tmp0_);
#line 1937 "AppWindow.c"
}

static void
app_window_on_select_all (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 359 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 360 "../src/AppWindow.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_CHECKERBOARD_PAGE) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 360 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 360 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 1957 "AppWindow.c"
	}
#line 360 "../src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 361 "../src/AppWindow.vala"
	_tmp2_ = page;
#line 361 "../src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 1965 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 362 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 362 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 362 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 362 "../src/AppWindow.vala"
		view_collection_select_all (_tmp5_);
#line 362 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 1979 "AppWindow.c"
	}
#line 359 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 1983 "AppWindow.c"
}

static void
app_window_on_select_none (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 365 "../src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 366 "../src/AppWindow.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_CHECKERBOARD_PAGE) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 366 "../src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 366 "../src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 2003 "AppWindow.c"
	}
#line 366 "../src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 367 "../src/AppWindow.vala"
	_tmp2_ = page;
#line 367 "../src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 2011 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 368 "../src/AppWindow.vala"
		_tmp3_ = page;
#line 368 "../src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 368 "../src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 368 "../src/AppWindow.vala"
		view_collection_unselect_all (_tmp5_);
#line 368 "../src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 2025 "AppWindow.c"
	}
#line 365 "../src/AppWindow.vala"
	_g_object_unref0 (page);
#line 2029 "AppWindow.c"
}

static gboolean
app_window_real_configure_event (GtkWidget* base,
                                 GdkEventConfigure* event)
{
	AppWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 371 "../src/AppWindow.vala"
	self = (AppWindow*) base;
#line 371 "../src/AppWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 372 "../src/AppWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp0_, NULL);
#line 372 "../src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 372 "../src/AppWindow.vala"
	if (!_tmp1_) {
#line 2050 "AppWindow.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 373 "../src/AppWindow.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 373 "../src/AppWindow.vala"
		self->dimensions.width = _tmp2_;
#line 373 "../src/AppWindow.vala"
		self->dimensions.height = _tmp3_;
#line 2059 "AppWindow.c"
	}
#line 375 "../src/AppWindow.vala"
	result = GTK_WIDGET_CLASS (app_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 375 "../src/AppWindow.vala"
	return result;
#line 2065 "AppWindow.c"
}

static void
_app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                gboolean can_undo,
                                                                gboolean can_redo,
                                                                gpointer self)
{
#line 74 "../src/AppWindow.vala"
	app_window_on_command_manager_altered ((AppWindow*) self);
#line 2076 "AppWindow.c"
}

static GObject *
app_window_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppWindow * self;
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkHeaderBar* _tmp7_;
	GtkHeaderBar* _tmp8_;
	GtkHeaderBar* _tmp9_;
	Application* application_instance = NULL;
	Application* _tmp10_;
	Application* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	Application* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	Application* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	Application* _tmp23_;
	gchar* _tmp24_;
	gchar** _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	Application* _tmp27_;
	gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	Application* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	Application* _tmp35_;
	gchar* _tmp36_;
	gchar** _tmp37_;
	gchar** _tmp38_;
	gint _tmp38__length1;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp39_;
	GtkCssProvider* _tmp40_;
	GdkScreen* _tmp41_;
	GtkCssProvider* _tmp42_;
	GSettings* _tmp43_;
	gint _tmp44_ = 0;
	GtkActionGroup** _tmp45_;
	GtkActionGroup** _tmp46_;
	gint _tmp46__length1;
	GtkUIManager* _tmp56_;
	GtkUIManager* _tmp57_;
	GtkAccelGroup* _tmp58_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/AppWindow.vala"
	parent_class = G_OBJECT_CLASS (app_window_parent_class);
#line 71 "../src/AppWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 72 "../src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 72 "../src/AppWindow.vala"
	_vala_assert (_tmp0_ == NULL, "command_manager == null");
#line 73 "../src/AppWindow.vala"
	_tmp1_ = command_manager_new (COMMAND_MANAGER_DEFAULT_DEPTH);
#line 73 "../src/AppWindow.vala"
	_command_manager_unref0 (app_window_command_manager);
#line 73 "../src/AppWindow.vala"
	app_window_command_manager = _tmp1_;
#line 74 "../src/AppWindow.vala"
	_tmp2_ = app_window_command_manager;
#line 74 "../src/AppWindow.vala"
	g_signal_connect_object (_tmp2_, "altered", (GCallback) _app_window_on_command_manager_altered_command_manager_altered, self, 0);
#line 76 "../src/AppWindow.vala"
	_tmp3_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-redo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 76 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 76 "../src/AppWindow.vala"
	_g_object_unref0 (self->redo_btn);
#line 76 "../src/AppWindow.vala"
	self->redo_btn = _tmp3_;
#line 77 "../src/AppWindow.vala"
	_tmp4_ = self->redo_btn;
#line 77 "../src/AppWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_REDO);
#line 79 "../src/AppWindow.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 79 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 79 "../src/AppWindow.vala"
	_g_object_unref0 (self->undo_btn);
#line 79 "../src/AppWindow.vala"
	self->undo_btn = _tmp5_;
#line 80 "../src/AppWindow.vala"
	_tmp6_ = self->undo_btn;
#line 80 "../src/AppWindow.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_UNDO);
#line 82 "../src/AppWindow.vala"
	_tmp7_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 82 "../src/AppWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 82 "../src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 82 "../src/AppWindow.vala"
	self->header = _tmp7_;
#line 83 "../src/AppWindow.vala"
	_tmp8_ = self->header;
#line 83 "../src/AppWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp8_, TRUE);
#line 85 "../src/AppWindow.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, "multimedia-photo-manager");
#line 86 "../src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ (RESOURCES_APP_TITLE));
#line 88 "../src/AppWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) self, APP_WINDOW_action_entries, (gint) G_N_ELEMENTS (APP_WINDOW_action_entries), self);
#line 89 "../src/AppWindow.vala"
	_tmp9_ = self->header;
#line 89 "../src/AppWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp9_);
#line 91 "../src/AppWindow.vala"
	_tmp10_ = application_get_instance ();
#line 91 "../src/AppWindow.vala"
	application_instance = _tmp10_;
#line 92 "../src/AppWindow.vala"
	_tmp11_ = application_instance;
#line 92 "../src/AppWindow.vala"
	_tmp12_ = g_strdup ("F11");
#line 92 "../src/AppWindow.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 92 "../src/AppWindow.vala"
	_tmp13_[0] = _tmp12_;
#line 92 "../src/AppWindow.vala"
	_tmp14_ = _tmp13_;
#line 92 "../src/AppWindow.vala"
	_tmp14__length1 = 1;
#line 92 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp11_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_FULLSCREEN, _tmp14_);
#line 92 "../src/AppWindow.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 93 "../src/AppWindow.vala"
	_tmp15_ = application_instance;
#line 93 "../src/AppWindow.vala"
	_tmp16_ = g_strdup ("<Ctrl><Shift>M");
#line 93 "../src/AppWindow.vala"
	_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 93 "../src/AppWindow.vala"
	_tmp17_[0] = _tmp16_;
#line 93 "../src/AppWindow.vala"
	_tmp18_ = _tmp17_;
#line 93 "../src/AppWindow.vala"
	_tmp18__length1 = 1;
#line 93 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp15_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_JUMP_TO_FILE, _tmp18_);
#line 93 "../src/AppWindow.vala"
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/AppWindow.vala"
	_tmp19_ = application_instance;
#line 94 "../src/AppWindow.vala"
	_tmp20_ = g_strdup ("<Ctrl>Q");
#line 94 "../src/AppWindow.vala"
	_tmp21_ = g_new0 (gchar*, 1 + 1);
#line 94 "../src/AppWindow.vala"
	_tmp21_[0] = _tmp20_;
#line 94 "../src/AppWindow.vala"
	_tmp22_ = _tmp21_;
#line 94 "../src/AppWindow.vala"
	_tmp22__length1 = 1;
#line 94 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp19_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_QUIT, _tmp22_);
#line 94 "../src/AppWindow.vala"
	_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
#line 95 "../src/AppWindow.vala"
	_tmp23_ = application_instance;
#line 95 "../src/AppWindow.vala"
	_tmp24_ = g_strdup ("<Ctrl><Shift>Z");
#line 95 "../src/AppWindow.vala"
	_tmp25_ = g_new0 (gchar*, 1 + 1);
#line 95 "../src/AppWindow.vala"
	_tmp25_[0] = _tmp24_;
#line 95 "../src/AppWindow.vala"
	_tmp26_ = _tmp25_;
#line 95 "../src/AppWindow.vala"
	_tmp26__length1 = 1;
#line 95 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp23_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_REDO, _tmp26_);
#line 95 "../src/AppWindow.vala"
	_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 96 "../src/AppWindow.vala"
	_tmp27_ = application_instance;
#line 96 "../src/AppWindow.vala"
	_tmp28_ = g_strdup ("<Ctrl>A");
#line 96 "../src/AppWindow.vala"
	_tmp29_ = g_new0 (gchar*, 1 + 1);
#line 96 "../src/AppWindow.vala"
	_tmp29_[0] = _tmp28_;
#line 96 "../src/AppWindow.vala"
	_tmp30_ = _tmp29_;
#line 96 "../src/AppWindow.vala"
	_tmp30__length1 = 1;
#line 96 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp27_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_SELECT_ALL, _tmp30_);
#line 96 "../src/AppWindow.vala"
	_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 97 "../src/AppWindow.vala"
	_tmp31_ = application_instance;
#line 97 "../src/AppWindow.vala"
	_tmp32_ = g_strdup ("<Ctrl><Shift>A");
#line 97 "../src/AppWindow.vala"
	_tmp33_ = g_new0 (gchar*, 1 + 1);
#line 97 "../src/AppWindow.vala"
	_tmp33_[0] = _tmp32_;
#line 97 "../src/AppWindow.vala"
	_tmp34_ = _tmp33_;
#line 97 "../src/AppWindow.vala"
	_tmp34__length1 = 1;
#line 97 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp31_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_SELECT_NONE, _tmp34_);
#line 97 "../src/AppWindow.vala"
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/AppWindow.vala"
	_tmp35_ = application_instance;
#line 98 "../src/AppWindow.vala"
	_tmp36_ = g_strdup ("<Ctrl>Z");
#line 98 "../src/AppWindow.vala"
	_tmp37_ = g_new0 (gchar*, 1 + 1);
#line 98 "../src/AppWindow.vala"
	_tmp37_[0] = _tmp36_;
#line 98 "../src/AppWindow.vala"
	_tmp38_ = _tmp37_;
#line 98 "../src/AppWindow.vala"
	_tmp38__length1 = 1;
#line 98 "../src/AppWindow.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp35_, APP_WINDOW_ACTION_PREFIX APP_WINDOW_ACTION_UNDO, _tmp38_);
#line 98 "../src/AppWindow.vala"
	_tmp38_ = (_vala_array_free (_tmp38_, _tmp38__length1, (GDestroyNotify) g_free), NULL);
#line 100 "../src/AppWindow.vala"
	_tmp39_ = gtk_css_provider_new ();
#line 100 "../src/AppWindow.vala"
	css_provider = _tmp39_;
#line 101 "../src/AppWindow.vala"
	_tmp40_ = css_provider;
#line 101 "../src/AppWindow.vala"
	gtk_css_provider_load_from_resource (_tmp40_, "io/elementary/photos/application.css");
#line 102 "../src/AppWindow.vala"
	_tmp41_ = gdk_screen_get_default ();
#line 102 "../src/AppWindow.vala"
	_tmp42_ = css_provider;
#line 102 "../src/AppWindow.vala"
	gtk_style_context_add_provider_for_screen (_tmp41_, (GtkStyleProvider*) _tmp42_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 104 "../src/AppWindow.vala"
	_tmp43_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_WINDOW_PREFS_SCHEMA_NAME);
#line 104 "../src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 104 "../src/AppWindow.vala"
	self->window_settings = _tmp43_;
#line 111 "../src/AppWindow.vala"
	_tmp45_ = app_window_create_common_action_groups (self, &_tmp44_);
#line 111 "../src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 111 "../src/AppWindow.vala"
	self->common_action_groups = _tmp45_;
#line 111 "../src/AppWindow.vala"
	self->common_action_groups_length1 = _tmp44_;
#line 112 "../src/AppWindow.vala"
	_tmp46_ = self->common_action_groups;
#line 112 "../src/AppWindow.vala"
	_tmp46__length1 = self->common_action_groups_length1;
#line 2362 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 112 "../src/AppWindow.vala"
		group_collection = _tmp46_;
#line 112 "../src/AppWindow.vala"
		group_collection_length1 = _tmp46__length1;
#line 112 "../src/AppWindow.vala"
		for (group_it = 0; group_it < _tmp46__length1; group_it = group_it + 1) {
#line 2374 "AppWindow.c"
			GtkActionGroup* _tmp47_;
			GtkActionGroup* group = NULL;
#line 112 "../src/AppWindow.vala"
			_tmp47_ = _g_object_ref0 (group_collection[group_it]);
#line 112 "../src/AppWindow.vala"
			group = _tmp47_;
#line 2381 "AppWindow.c"
			{
				GtkUIManager* _tmp48_;
				GtkActionGroup* _tmp49_;
#line 113 "../src/AppWindow.vala"
				_tmp48_ = ((PageWindow*) self)->ui;
#line 113 "../src/AppWindow.vala"
				_tmp49_ = group;
#line 113 "../src/AppWindow.vala"
				gtk_ui_manager_insert_action_group (_tmp48_, _tmp49_, 0);
#line 112 "../src/AppWindow.vala"
				_g_object_unref0 (group);
#line 2393 "AppWindow.c"
			}
		}
	}
	{
		GtkUIManager* _tmp50_;
		GtkActionGroup** _tmp51_;
		gint _tmp51__length1;
		gchar* _tmp52_;
		gchar* _tmp53_;
#line 116 "../src/AppWindow.vala"
		_tmp50_ = ((PageWindow*) self)->ui;
#line 116 "../src/AppWindow.vala"
		_tmp51_ = self->common_action_groups;
#line 116 "../src/AppWindow.vala"
		_tmp51__length1 = self->common_action_groups_length1;
#line 116 "../src/AppWindow.vala"
		_tmp52_ = build_dummy_ui_string (_tmp51_, (gint) _tmp51__length1);
#line 116 "../src/AppWindow.vala"
		_tmp53_ = _tmp52_;
#line 116 "../src/AppWindow.vala"
		gtk_ui_manager_add_ui_from_string (_tmp50_, _tmp53_, (gssize) -1, &_inner_error0_);
#line 116 "../src/AppWindow.vala"
		_g_free0 (_tmp53_);
#line 116 "../src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2419 "AppWindow.c"
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* err = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
#line 115 "../src/AppWindow.vala"
		err = _inner_error0_;
#line 115 "../src/AppWindow.vala"
		_inner_error0_ = NULL;
#line 118 "../src/AppWindow.vala"
		_tmp54_ = err;
#line 118 "../src/AppWindow.vala"
		_tmp55_ = _tmp54_->message;
#line 118 "../src/AppWindow.vala"
		g_error ("AppWindow.vala:118: Unable to add AppWindow UI: %s", _tmp55_);
#line 115 "../src/AppWindow.vala"
		_g_error_free0 (err);
#line 2441 "AppWindow.c"
	}
	__finally9:
#line 115 "../src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/AppWindow.vala"
		_g_object_unref0 (css_provider);
#line 115 "../src/AppWindow.vala"
		_g_object_unref0 (application_instance);
#line 115 "../src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/AppWindow.vala"
		g_clear_error (&_inner_error0_);
#line 2454 "AppWindow.c"
	}
#line 121 "../src/AppWindow.vala"
	_tmp56_ = ((PageWindow*) self)->ui;
#line 121 "../src/AppWindow.vala"
	gtk_ui_manager_ensure_update (_tmp56_);
#line 122 "../src/AppWindow.vala"
	_tmp57_ = ((PageWindow*) self)->ui;
#line 122 "../src/AppWindow.vala"
	_tmp58_ = gtk_ui_manager_get_accel_group (_tmp57_);
#line 122 "../src/AppWindow.vala"
	gtk_window_add_accel_group ((GtkWindow*) self, _tmp58_);
#line 71 "../src/AppWindow.vala"
	_g_object_unref0 (css_provider);
#line 71 "../src/AppWindow.vala"
	_g_object_unref0 (application_instance);
#line 71 "../src/AppWindow.vala"
	return obj;
#line 2472 "AppWindow.c"
}

static void
app_window_class_init (AppWindowClass * klass,
                       gpointer klass_data)
{
#line 27 "../src/AppWindow.vala"
	app_window_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/AppWindow.vala"
	g_type_class_adjust_private_offset (klass, &AppWindow_private_offset);
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->on_fullscreen = (void (*) (AppWindow*)) app_window_real_on_fullscreen;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->get_app_role = (gchar* (*) (AppWindow*)) app_window_real_get_app_role;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->on_quit = (void (*) (AppWindow*)) app_window_real_on_quit;
#line 27 "../src/AppWindow.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) app_window_real_destroy;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->create_common_action_groups = (GtkActionGroup** (*) (AppWindow*, gint*)) app_window_real_create_common_action_groups;
#line 27 "../src/AppWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow*, Page*, Page*)) app_window_real_switched_pages;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_action_availability = (void (*) (AppWindow*, Page*, Page*)) app_window_real_update_common_action_availability;
#line 27 "../src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_actions = (void (*) (AppWindow*, Page*, gint, gint)) app_window_real_update_common_actions;
#line 27 "../src/AppWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) app_window_real_configure_event;
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_window_constructor;
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_window_finalize;
#line 2505 "AppWindow.c"
}

static void
app_window_instance_init (AppWindow * self,
                          gpointer klass)
{
#line 27 "../src/AppWindow.vala"
	self->priv = app_window_get_instance_private (self);
#line 37 "../src/AppWindow.vala"
	self->priv->pos_x = 0;
#line 38 "../src/AppWindow.vala"
	self->priv->pos_y = 0;
#line 2518 "AppWindow.c"
}

static void
app_window_finalize (GObject * obj)
{
	AppWindow * self;
#line 27 "../src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 35 "../src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 39 "../src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 41 "../src/AppWindow.vala"
	_g_object_unref0 (self->redo_btn);
#line 42 "../src/AppWindow.vala"
	_g_object_unref0 (self->undo_btn);
#line 44 "../src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 27 "../src/AppWindow.vala"
	G_OBJECT_CLASS (app_window_parent_class)->finalize (obj);
#line 2539 "AppWindow.c"
}

GType
app_window_get_type (void)
{
	static volatile gsize app_window_type_id__volatile = 0;
	if (g_once_init_enter (&app_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppWindow), 0, (GInstanceInitFunc) app_window_instance_init, NULL };
		GType app_window_type_id;
		app_window_type_id = g_type_register_static (TYPE_PAGE_WINDOW, "AppWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		AppWindow_private_offset = g_type_add_instance_private (app_window_type_id, sizeof (AppWindowPrivate));
		g_once_init_leave (&app_window_type_id__volatile, app_window_type_id);
	}
	return app_window_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

