/* ExportDialog.c generated by valac 0.44.3, the Vala compiler
 * generated from ExportDialog.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*               2017 elementary  LLC. (https://github.com/elementary/photos)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define TYPE_EXPORT_DIALOG (export_dialog_get_type ())
#define EXPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT_DIALOG, ExportDialog))
#define EXPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT_DIALOG, ExportDialogClass))
#define IS_EXPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT_DIALOG))
#define IS_EXPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT_DIALOG))
#define EXPORT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT_DIALOG, ExportDialogClass))

typedef struct _ExportDialog ExportDialog;
typedef struct _ExportDialogClass ExportDialogClass;
typedef struct _ExportDialogPrivate ExportDialogPrivate;
enum  {
	EXPORT_DIALOG_0_PROPERTY,
	EXPORT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* export_dialog_properties[EXPORT_DIALOG_NUM_PROPERTIES];
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ExportDialog {
	GtkDialog parent_instance;
	ExportDialogPrivate * priv;
};

struct _ExportDialogClass {
	GtkDialogClass parent_class;
};

struct _ExportDialogPrivate {
	GtkComboBoxText* quality_combo;
	GtkComboBoxText* constraint_combo;
	GtkComboBoxText* format_combo;
	GtkCheckButton* export_metadata;
	GeeArrayList* format_options;
	GtkEntry* pixels_entry;
	GtkWidget* export_button;
	gboolean in_insert;
};

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

static gint ExportDialog_private_offset;
static gpointer export_dialog_parent_class = NULL;
static ScaleConstraint export_dialog_current_constraint;
static ScaleConstraint export_dialog_current_constraint = SCALE_CONSTRAINT_ORIGINAL;
static ExportFormatParameters export_dialog_current_parameters;
static ExportFormatParameters export_dialog_current_parameters = {0};
static gint export_dialog_current_scale;
static gint export_dialog_current_scale = 1200;

GType export_dialog_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
void export_format_parameters_current (ExportFormatParameters* result);
#define EXPORT_DIALOG_NUM_SPECIAL_FORMATS 2
#define EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL _ ("Unmodified")
#define EXPORT_DIALOG_CURRENT_FORMAT_LABEL _ ("Current")
ExportDialog* export_dialog_new (const gchar* title);
ExportDialog* export_dialog_construct (GType object_type,
                                       const gchar* title);
static void export_dialog_format_add_option (ExportDialog* self,
                                      const gchar* format_name);
static void export_dialog_format_set_active_text (ExportDialog* self,
                                           const gchar* text);
static PhotoFileFormat export_dialog_get_specified_format (ExportDialog* self);
PhotoFileFormat* photo_file_format_get_writeable (gint* result_length1);
static gchar* export_dialog_get_label_for_parameters (ExportDialog* self,
                                               ExportFormatParameters* params);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
gchar* photo_file_format_properties_get_user_visible_name (PhotoFileFormatProperties* self);
gboolean export_dialog_execute (ExportDialog* self,
                                gint* scale,
                                ScaleConstraint* constraint,
                                ExportFormatParameters* parameters);
gboolean photo_file_format_can_write (PhotoFileFormat self);
PhotoFileFormat photo_file_format_get_system_default_format (void);
static void export_dialog_on_format_changed (ExportDialog* self);
static void export_dialog_on_constraint_changed (ExportDialog* self);
static void export_dialog_on_pixels_changed (ExportDialog* self);
static void export_dialog_on_pixels_insert_text (ExportDialog* self,
                                          const gchar* text,
                                          gint length,
                                          gint* position);
static GObject * export_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
gchar* jpeg_quality_to_string (JpegQuality self);
gchar* scale_constraint_to_string (ScaleConstraint self);
static void _export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void _export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self);
static void _export_dialog_on_pixels_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                    const gchar* new_text,
                                                                    gint new_text_length,
                                                                    gint* position,
                                                                    gpointer self);
static void _export_dialog___lambda40_ (ExportDialog* self);
static void __export_dialog___lambda40__gtk_entry_activate (GtkEntry* _sender,
                                                     gpointer self);
static void export_dialog_finalize (GObject * obj);

const ScaleConstraint EXPORT_DIALOG_CONSTRAINT_ARRAY[4] = {SCALE_CONSTRAINT_ORIGINAL, SCALE_CONSTRAINT_DIMENSIONS, SCALE_CONSTRAINT_WIDTH, SCALE_CONSTRAINT_HEIGHT};
const JpegQuality EXPORT_DIALOG_QUALITY_ARRAY[4] = {JPEG_QUALITY_LOW, JPEG_QUALITY_MEDIUM, JPEG_QUALITY_HIGH, JPEG_QUALITY_MAXIMUM};

static inline gpointer
export_dialog_get_instance_private (ExportDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ExportDialog_private_offset);
}

ExportDialog*
export_dialog_construct (GType object_type,
                         const gchar* title)
{
	ExportDialog * self = NULL;
#line 50 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 51 "../src/Dialogs/ExportDialog.vala"
	self = (ExportDialog*) g_object_new (object_type, "deletable", FALSE, "resizable", FALSE, "title", title, NULL);
#line 50 "../src/Dialogs/ExportDialog.vala"
	return self;
#line 236 "ExportDialog.c"
}

ExportDialog*
export_dialog_new (const gchar* title)
{
#line 50 "../src/Dialogs/ExportDialog.vala"
	return export_dialog_construct (TYPE_EXPORT_DIALOG, title);
#line 244 "ExportDialog.c"
}

static void
export_dialog_format_add_option (ExportDialog* self,
                                 const gchar* format_name)
{
	GeeArrayList* _tmp0_;
	GtkComboBoxText* _tmp1_;
#line 148 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (format_name != NULL);
#line 149 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->format_options;
#line 149 "../src/Dialogs/ExportDialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, format_name);
#line 150 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = self->priv->format_combo;
#line 150 "../src/Dialogs/ExportDialog.vala"
	gtk_combo_box_text_append_text (_tmp1_, format_name);
#line 265 "ExportDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 156 "../src/Dialogs/ExportDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 273 "ExportDialog.c"
}

static void
export_dialog_format_set_active_text (ExportDialog* self,
                                      const gchar* text)
{
	gint selection_ticker = 0;
#line 153 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (text != NULL);
#line 154 "../src/Dialogs/ExportDialog.vala"
	selection_ticker = 0;
#line 287 "ExportDialog.c"
	{
		GeeArrayList* _current_text_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _current_text_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _current_text_index = 0;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = self->priv->format_options;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 156 "../src/Dialogs/ExportDialog.vala"
		_current_text_list = _tmp1_;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = _current_text_list;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 156 "../src/Dialogs/ExportDialog.vala"
		_tmp4_ = _tmp3_;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_current_text_size = _tmp4_;
#line 156 "../src/Dialogs/ExportDialog.vala"
		_current_text_index = -1;
#line 156 "../src/Dialogs/ExportDialog.vala"
		while (TRUE) {
#line 315 "ExportDialog.c"
			gchar* current_text = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			const gchar* _tmp7_;
			gint _tmp9_;
#line 156 "../src/Dialogs/ExportDialog.vala"
			_current_text_index = _current_text_index + 1;
#line 156 "../src/Dialogs/ExportDialog.vala"
			if (!(_current_text_index < _current_text_size)) {
#line 156 "../src/Dialogs/ExportDialog.vala"
				break;
#line 327 "ExportDialog.c"
			}
#line 156 "../src/Dialogs/ExportDialog.vala"
			_tmp5_ = _current_text_list;
#line 156 "../src/Dialogs/ExportDialog.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _current_text_index);
#line 156 "../src/Dialogs/ExportDialog.vala"
			current_text = (gchar*) _tmp6_;
#line 157 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = current_text;
#line 157 "../src/Dialogs/ExportDialog.vala"
			if (g_strcmp0 (_tmp7_, text) == 0) {
#line 339 "ExportDialog.c"
				GtkComboBoxText* _tmp8_;
#line 158 "../src/Dialogs/ExportDialog.vala"
				_tmp8_ = self->priv->format_combo;
#line 158 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_set_active ((GtkComboBox*) _tmp8_, selection_ticker);
#line 159 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (current_text);
#line 159 "../src/Dialogs/ExportDialog.vala"
				_g_object_unref0 (_current_text_list);
#line 159 "../src/Dialogs/ExportDialog.vala"
				return;
#line 351 "ExportDialog.c"
			}
#line 161 "../src/Dialogs/ExportDialog.vala"
			_tmp9_ = selection_ticker;
#line 161 "../src/Dialogs/ExportDialog.vala"
			selection_ticker = _tmp9_ + 1;
#line 156 "../src/Dialogs/ExportDialog.vala"
			_g_free0 (current_text);
#line 359 "ExportDialog.c"
		}
#line 156 "../src/Dialogs/ExportDialog.vala"
		_g_object_unref0 (_current_text_list);
#line 363 "ExportDialog.c"
	}
#line 164 "../src/Dialogs/ExportDialog.vala"
	g_error ("ExportDialog.vala:164: format_set_active_text: text '%s' isn't in comb" \
"o box", text);
#line 367 "ExportDialog.c"
}

static PhotoFileFormat
export_dialog_get_specified_format (ExportDialog* self)
{
	PhotoFileFormat result = 0;
	gint index = 0;
	GtkComboBoxText* _tmp0_;
	PhotoFileFormat* writeable_formats = NULL;
	gint _tmp1_ = 0;
	PhotoFileFormat* _tmp2_;
	gint writeable_formats_length1;
	gint _writeable_formats_size_;
	PhotoFileFormat _tmp3_;
#line 167 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 168 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->format_combo;
#line 168 "../src/Dialogs/ExportDialog.vala"
	index = gtk_combo_box_get_active ((GtkComboBox*) _tmp0_);
#line 169 "../src/Dialogs/ExportDialog.vala"
	if (index < EXPORT_DIALOG_NUM_SPECIAL_FORMATS) {
#line 170 "../src/Dialogs/ExportDialog.vala"
		index = EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
#line 392 "ExportDialog.c"
	}
#line 172 "../src/Dialogs/ExportDialog.vala"
	index = index - EXPORT_DIALOG_NUM_SPECIAL_FORMATS;
#line 173 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = photo_file_format_get_writeable (&_tmp1_);
#line 173 "../src/Dialogs/ExportDialog.vala"
	writeable_formats = _tmp2_;
#line 173 "../src/Dialogs/ExportDialog.vala"
	writeable_formats_length1 = _tmp1_;
#line 173 "../src/Dialogs/ExportDialog.vala"
	_writeable_formats_size_ = writeable_formats_length1;
#line 174 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = writeable_formats[index];
#line 174 "../src/Dialogs/ExportDialog.vala"
	result = _tmp3_;
#line 174 "../src/Dialogs/ExportDialog.vala"
	writeable_formats = (g_free (writeable_formats), NULL);
#line 174 "../src/Dialogs/ExportDialog.vala"
	return result;
#line 412 "ExportDialog.c"
}

static gchar*
export_dialog_get_label_for_parameters (ExportDialog* self,
                                        ExportFormatParameters* params)
{
	gchar* result = NULL;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
#line 177 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 178 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = *params;
#line 178 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = _tmp0_.mode;
#line 178 "../src/Dialogs/ExportDialog.vala"
	switch (_tmp1_) {
#line 178 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 434 "ExportDialog.c"
		{
			gchar* _tmp2_;
#line 180 "../src/Dialogs/ExportDialog.vala"
			_tmp2_ = g_strdup (EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
#line 180 "../src/Dialogs/ExportDialog.vala"
			result = _tmp2_;
#line 180 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 443 "ExportDialog.c"
		}
#line 178 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 447 "ExportDialog.c"
		{
			gchar* _tmp3_;
#line 183 "../src/Dialogs/ExportDialog.vala"
			_tmp3_ = g_strdup (EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
#line 183 "../src/Dialogs/ExportDialog.vala"
			result = _tmp3_;
#line 183 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 456 "ExportDialog.c"
		}
#line 178 "../src/Dialogs/ExportDialog.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 460 "ExportDialog.c"
		{
			ExportFormatParameters _tmp4_;
			PhotoFileFormat _tmp5_;
			PhotoFileFormatProperties* _tmp6_;
			PhotoFileFormatProperties* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp4_ = *params;
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp5_ = _tmp4_.specified_format;
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp6_ = photo_file_format_get_properties (_tmp5_);
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = _tmp6_;
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp8_ = photo_file_format_properties_get_user_visible_name (_tmp7_);
#line 186 "../src/Dialogs/ExportDialog.vala"
			_tmp9_ = _tmp8_;
#line 186 "../src/Dialogs/ExportDialog.vala"
			_photo_file_format_properties_unref0 (_tmp7_);
#line 186 "../src/Dialogs/ExportDialog.vala"
			result = _tmp9_;
#line 186 "../src/Dialogs/ExportDialog.vala"
			return result;
#line 486 "ExportDialog.c"
		}
		default:
		{
#line 189 "../src/Dialogs/ExportDialog.vala"
			g_error ("ExportDialog.vala:189: get_label_for_parameters: unrecognized export f" \
"ormat mode");
#line 492 "ExportDialog.c"
		}
	}
}

gboolean
export_dialog_execute (ExportDialog* self,
                       gint* scale,
                       ScaleConstraint* constraint,
                       ExportFormatParameters* parameters)
{
	gint _vala_scale = 0;
	ScaleConstraint _vala_constraint = 0;
	gboolean result = FALSE;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	ExportFormatParameters _tmp4_;
	ExportFormatMode _tmp5_;
	ExportFormatParameters _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean ok = FALSE;
#line 196 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/Dialogs/ExportDialog.vala"
	g_return_val_if_fail (parameters != NULL, FALSE);
#line 198 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 202 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = *parameters;
#line 202 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = _tmp0_.mode;
#line 202 "../src/Dialogs/ExportDialog.vala"
	if (_tmp1_ != EXPORT_FORMAT_MODE_LAST) {
#line 526 "ExportDialog.c"
		ScaleConstraint _tmp2_;
		GtkComboBoxText* _tmp3_;
#line 203 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
#line 203 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = _vala_constraint;
#line 203 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_constraint = _tmp2_;
#line 204 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = self->priv->constraint_combo;
#line 204 "../src/Dialogs/ExportDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp3_, 0);
#line 539 "ExportDialog.c"
	}
#line 207 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = *parameters;
#line 207 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = _tmp4_.mode;
#line 207 "../src/Dialogs/ExportDialog.vala"
	if (_tmp5_ == EXPORT_FORMAT_MODE_LAST) {
#line 547 "ExportDialog.c"
		ExportFormatParameters _tmp6_;
#line 208 "../src/Dialogs/ExportDialog.vala"
		_tmp6_ = export_dialog_current_parameters;
#line 208 "../src/Dialogs/ExportDialog.vala"
		*parameters = _tmp6_;
#line 553 "ExportDialog.c"
	} else {
		gboolean _tmp7_ = FALSE;
		ExportFormatParameters _tmp8_;
		ExportFormatMode _tmp9_;
#line 209 "../src/Dialogs/ExportDialog.vala"
		_tmp8_ = *parameters;
#line 209 "../src/Dialogs/ExportDialog.vala"
		_tmp9_ = _tmp8_.mode;
#line 209 "../src/Dialogs/ExportDialog.vala"
		if (_tmp9_ == EXPORT_FORMAT_MODE_SPECIFIED) {
#line 564 "ExportDialog.c"
			ExportFormatParameters _tmp10_;
			PhotoFileFormat _tmp11_;
#line 209 "../src/Dialogs/ExportDialog.vala"
			_tmp10_ = *parameters;
#line 209 "../src/Dialogs/ExportDialog.vala"
			_tmp11_ = _tmp10_.specified_format;
#line 209 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = !photo_file_format_can_write (_tmp11_);
#line 573 "ExportDialog.c"
		} else {
#line 209 "../src/Dialogs/ExportDialog.vala"
			_tmp7_ = FALSE;
#line 577 "ExportDialog.c"
		}
#line 209 "../src/Dialogs/ExportDialog.vala"
		if (_tmp7_) {
#line 210 "../src/Dialogs/ExportDialog.vala"
			(*parameters).specified_format = photo_file_format_get_system_default_format ();
#line 583 "ExportDialog.c"
		}
	}
#line 212 "../src/Dialogs/ExportDialog.vala"
	_tmp12_ = *parameters;
#line 212 "../src/Dialogs/ExportDialog.vala"
	_tmp13_ = export_dialog_get_label_for_parameters (self, &_tmp12_);
#line 212 "../src/Dialogs/ExportDialog.vala"
	_tmp14_ = _tmp13_;
#line 212 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_set_active_text (self, _tmp14_);
#line 212 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp14_);
#line 213 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_format_changed (self);
#line 215 "../src/Dialogs/ExportDialog.vala"
	ok = gtk_dialog_run ((GtkDialog*) self) == ((gint) GTK_RESPONSE_OK);
#line 216 "../src/Dialogs/ExportDialog.vala"
	if (ok) {
#line 602 "ExportDialog.c"
		gint index = 0;
		GtkComboBoxText* _tmp15_;
		ScaleConstraint _tmp16_;
		ScaleConstraint _tmp17_;
		GtkEntry* _tmp18_;
		const gchar* _tmp19_;
		ScaleConstraint _tmp20_;
		gboolean _tmp21_ = FALSE;
		GtkCheckButton* _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
		GtkComboBoxText* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gboolean _tmp31_;
#line 217 "../src/Dialogs/ExportDialog.vala"
		_tmp15_ = self->priv->constraint_combo;
#line 217 "../src/Dialogs/ExportDialog.vala"
		index = gtk_combo_box_get_active ((GtkComboBox*) _tmp15_);
#line 218 "../src/Dialogs/ExportDialog.vala"
		_vala_assert (index >= 0, "index >= 0");
#line 219 "../src/Dialogs/ExportDialog.vala"
		_tmp16_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[index];
#line 219 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = _tmp16_;
#line 220 "../src/Dialogs/ExportDialog.vala"
		_tmp17_ = _vala_constraint;
#line 220 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_constraint = _tmp17_;
#line 222 "../src/Dialogs/ExportDialog.vala"
		_tmp18_ = self->priv->pixels_entry;
#line 222 "../src/Dialogs/ExportDialog.vala"
		_tmp19_ = gtk_entry_get_text (_tmp18_);
#line 222 "../src/Dialogs/ExportDialog.vala"
		_vala_scale = atoi (_tmp19_);
#line 223 "../src/Dialogs/ExportDialog.vala"
		_tmp20_ = _vala_constraint;
#line 223 "../src/Dialogs/ExportDialog.vala"
		if (_tmp20_ != SCALE_CONSTRAINT_ORIGINAL) {
#line 224 "../src/Dialogs/ExportDialog.vala"
			_vala_assert (_vala_scale > 0, "scale > 0");
#line 644 "ExportDialog.c"
		}
#line 225 "../src/Dialogs/ExportDialog.vala"
		export_dialog_current_scale = _vala_scale;
#line 227 "../src/Dialogs/ExportDialog.vala"
		_tmp22_ = self->priv->export_metadata;
#line 227 "../src/Dialogs/ExportDialog.vala"
		_tmp23_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp22_);
#line 227 "../src/Dialogs/ExportDialog.vala"
		_tmp24_ = _tmp23_;
#line 227 "../src/Dialogs/ExportDialog.vala"
		if (_tmp24_) {
#line 656 "ExportDialog.c"
			GtkCheckButton* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
#line 227 "../src/Dialogs/ExportDialog.vala"
			_tmp25_ = self->priv->export_metadata;
#line 227 "../src/Dialogs/ExportDialog.vala"
			_tmp26_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp25_);
#line 227 "../src/Dialogs/ExportDialog.vala"
			_tmp27_ = _tmp26_;
#line 227 "../src/Dialogs/ExportDialog.vala"
			_tmp21_ = _tmp27_;
#line 668 "ExportDialog.c"
		} else {
#line 227 "../src/Dialogs/ExportDialog.vala"
			_tmp21_ = FALSE;
#line 672 "ExportDialog.c"
		}
#line 227 "../src/Dialogs/ExportDialog.vala"
		(*parameters).export_metadata = _tmp21_;
#line 229 "../src/Dialogs/ExportDialog.vala"
		_tmp28_ = self->priv->format_combo;
#line 229 "../src/Dialogs/ExportDialog.vala"
		_tmp29_ = gtk_combo_box_text_get_active_text (_tmp28_);
#line 229 "../src/Dialogs/ExportDialog.vala"
		_tmp30_ = _tmp29_;
#line 229 "../src/Dialogs/ExportDialog.vala"
		_tmp31_ = g_strcmp0 (_tmp30_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
#line 229 "../src/Dialogs/ExportDialog.vala"
		_g_free0 (_tmp30_);
#line 229 "../src/Dialogs/ExportDialog.vala"
		if (_tmp31_) {
#line 688 "ExportDialog.c"
			ExportFormatMode _tmp32_;
#line 230 "../src/Dialogs/ExportDialog.vala"
			export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_UNMODIFIED;
#line 230 "../src/Dialogs/ExportDialog.vala"
			_tmp32_ = export_dialog_current_parameters.mode;
#line 230 "../src/Dialogs/ExportDialog.vala"
			(*parameters).mode = _tmp32_;
#line 696 "ExportDialog.c"
		} else {
			GtkComboBoxText* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gboolean _tmp36_;
#line 231 "../src/Dialogs/ExportDialog.vala"
			_tmp33_ = self->priv->format_combo;
#line 231 "../src/Dialogs/ExportDialog.vala"
			_tmp34_ = gtk_combo_box_text_get_active_text (_tmp33_);
#line 231 "../src/Dialogs/ExportDialog.vala"
			_tmp35_ = _tmp34_;
#line 231 "../src/Dialogs/ExportDialog.vala"
			_tmp36_ = g_strcmp0 (_tmp35_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
#line 231 "../src/Dialogs/ExportDialog.vala"
			_g_free0 (_tmp35_);
#line 231 "../src/Dialogs/ExportDialog.vala"
			if (_tmp36_) {
#line 714 "ExportDialog.c"
				ExportFormatMode _tmp37_;
#line 232 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_CURRENT;
#line 232 "../src/Dialogs/ExportDialog.vala"
				_tmp37_ = export_dialog_current_parameters.mode;
#line 232 "../src/Dialogs/ExportDialog.vala"
				(*parameters).mode = _tmp37_;
#line 722 "ExportDialog.c"
			} else {
				ExportFormatMode _tmp38_;
				PhotoFileFormat _tmp39_;
				ExportFormatParameters _tmp40_;
				PhotoFileFormat _tmp41_;
#line 234 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.mode = EXPORT_FORMAT_MODE_SPECIFIED;
#line 234 "../src/Dialogs/ExportDialog.vala"
				_tmp38_ = export_dialog_current_parameters.mode;
#line 234 "../src/Dialogs/ExportDialog.vala"
				(*parameters).mode = _tmp38_;
#line 235 "../src/Dialogs/ExportDialog.vala"
				export_dialog_current_parameters.specified_format = export_dialog_get_specified_format (self);
#line 235 "../src/Dialogs/ExportDialog.vala"
				_tmp39_ = export_dialog_current_parameters.specified_format;
#line 235 "../src/Dialogs/ExportDialog.vala"
				(*parameters).specified_format = _tmp39_;
#line 236 "../src/Dialogs/ExportDialog.vala"
				_tmp40_ = export_dialog_current_parameters;
#line 236 "../src/Dialogs/ExportDialog.vala"
				_tmp41_ = _tmp40_.specified_format;
#line 236 "../src/Dialogs/ExportDialog.vala"
				if (_tmp41_ == PHOTO_FILE_FORMAT_JFIF) {
#line 746 "ExportDialog.c"
					GtkComboBoxText* _tmp42_;
					JpegQuality _tmp43_;
					JpegQuality _tmp44_;
#line 237 "../src/Dialogs/ExportDialog.vala"
					_tmp42_ = self->priv->quality_combo;
#line 237 "../src/Dialogs/ExportDialog.vala"
					_tmp43_ = EXPORT_DIALOG_QUALITY_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp42_)];
#line 237 "../src/Dialogs/ExportDialog.vala"
					export_dialog_current_parameters.quality = _tmp43_;
#line 237 "../src/Dialogs/ExportDialog.vala"
					_tmp44_ = export_dialog_current_parameters.quality;
#line 237 "../src/Dialogs/ExportDialog.vala"
					(*parameters).quality = _tmp44_;
#line 760 "ExportDialog.c"
				}
			}
		}
	} else {
#line 240 "../src/Dialogs/ExportDialog.vala"
		_vala_scale = 0;
#line 241 "../src/Dialogs/ExportDialog.vala"
		_vala_constraint = SCALE_CONSTRAINT_ORIGINAL;
#line 769 "ExportDialog.c"
	}
#line 244 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 246 "../src/Dialogs/ExportDialog.vala"
	result = ok;
#line 246 "../src/Dialogs/ExportDialog.vala"
	if (scale) {
#line 246 "../src/Dialogs/ExportDialog.vala"
		*scale = _vala_scale;
#line 779 "ExportDialog.c"
	}
#line 246 "../src/Dialogs/ExportDialog.vala"
	if (constraint) {
#line 246 "../src/Dialogs/ExportDialog.vala"
		*constraint = _vala_constraint;
#line 785 "ExportDialog.c"
	}
#line 246 "../src/Dialogs/ExportDialog.vala"
	return result;
#line 789 "ExportDialog.c"
}

static void
export_dialog_on_constraint_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	gboolean jpeg = FALSE;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoFileFormatProperties* _tmp5_;
	PhotoFileFormatProperties* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	GtkEntry* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GtkComboBoxText* _tmp12_;
#line 249 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->constraint_combo;
#line 250 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
#line 250 "../src/Dialogs/ExportDialog.vala"
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = self->priv->format_combo;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = _tmp3_;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = photo_file_format_get_properties (PHOTO_FILE_FORMAT_JFIF);
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp6_ = _tmp5_;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp7_ = photo_file_format_properties_get_user_visible_name (_tmp6_);
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp8_ = _tmp7_;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) == 0;
#line 251 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp8_);
#line 251 "../src/Dialogs/ExportDialog.vala"
	_photo_file_format_properties_unref0 (_tmp6_);
#line 251 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp4_);
#line 251 "../src/Dialogs/ExportDialog.vala"
	jpeg = _tmp9_;
#line 253 "../src/Dialogs/ExportDialog.vala"
	_tmp10_ = self->priv->pixels_entry;
#line 253 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, !original);
#line 254 "../src/Dialogs/ExportDialog.vala"
	if (!original) {
#line 254 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = jpeg;
#line 850 "ExportDialog.c"
	} else {
#line 254 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = FALSE;
#line 854 "ExportDialog.c"
	}
#line 254 "../src/Dialogs/ExportDialog.vala"
	_tmp12_ = self->priv->quality_combo;
#line 254 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, _tmp11_);
#line 255 "../src/Dialogs/ExportDialog.vala"
	if (original) {
#line 862 "ExportDialog.c"
		GtkWidget* _tmp13_;
#line 256 "../src/Dialogs/ExportDialog.vala"
		_tmp13_ = self->priv->export_button;
#line 256 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive (_tmp13_, TRUE);
#line 868 "ExportDialog.c"
	} else {
#line 258 "../src/Dialogs/ExportDialog.vala"
		export_dialog_on_pixels_changed (self);
#line 872 "ExportDialog.c"
	}
}

static void
export_dialog_on_format_changed (ExportDialog* self)
{
	gboolean original = FALSE;
	GtkComboBoxText* _tmp0_;
	ScaleConstraint _tmp1_;
	GtkComboBoxText* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 261 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = self->priv->constraint_combo;
#line 262 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = EXPORT_DIALOG_CONSTRAINT_ARRAY[gtk_combo_box_get_active ((GtkComboBox*) _tmp0_)];
#line 262 "../src/Dialogs/ExportDialog.vala"
	original = _tmp1_ == SCALE_CONSTRAINT_ORIGINAL;
#line 264 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = self->priv->format_combo;
#line 264 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = gtk_combo_box_text_get_active_text (_tmp2_);
#line 264 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = _tmp3_;
#line 264 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL) == 0;
#line 264 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp4_);
#line 264 "../src/Dialogs/ExportDialog.vala"
	if (_tmp5_) {
#line 906 "ExportDialog.c"
		GtkComboBoxText* _tmp6_;
		GtkComboBoxText* _tmp7_;
		GtkComboBoxText* _tmp8_;
		GtkEntry* _tmp9_;
		GtkCheckButton* _tmp10_;
		GtkCheckButton* _tmp11_;
#line 269 "../src/Dialogs/ExportDialog.vala"
		_tmp6_ = self->priv->constraint_combo;
#line 269 "../src/Dialogs/ExportDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, 0);
#line 270 "../src/Dialogs/ExportDialog.vala"
		_tmp7_ = self->priv->constraint_combo;
#line 270 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 271 "../src/Dialogs/ExportDialog.vala"
		_tmp8_ = self->priv->quality_combo;
#line 271 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 272 "../src/Dialogs/ExportDialog.vala"
		_tmp9_ = self->priv->pixels_entry;
#line 272 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 273 "../src/Dialogs/ExportDialog.vala"
		_tmp10_ = self->priv->export_metadata;
#line 273 "../src/Dialogs/ExportDialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp10_, FALSE);
#line 274 "../src/Dialogs/ExportDialog.vala"
		_tmp11_ = self->priv->export_metadata;
#line 274 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 937 "ExportDialog.c"
	} else {
		GtkComboBoxText* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_;
#line 275 "../src/Dialogs/ExportDialog.vala"
		_tmp12_ = self->priv->format_combo;
#line 275 "../src/Dialogs/ExportDialog.vala"
		_tmp13_ = gtk_combo_box_text_get_active_text (_tmp12_);
#line 275 "../src/Dialogs/ExportDialog.vala"
		_tmp14_ = _tmp13_;
#line 275 "../src/Dialogs/ExportDialog.vala"
		_tmp15_ = g_strcmp0 (_tmp14_, EXPORT_DIALOG_CURRENT_FORMAT_LABEL) == 0;
#line 275 "../src/Dialogs/ExportDialog.vala"
		_g_free0 (_tmp14_);
#line 275 "../src/Dialogs/ExportDialog.vala"
		if (_tmp15_) {
#line 955 "ExportDialog.c"
			GtkComboBoxText* _tmp16_;
			GtkComboBoxText* _tmp17_;
			GtkEntry* _tmp18_;
			GtkCheckButton* _tmp19_;
#line 282 "../src/Dialogs/ExportDialog.vala"
			_tmp16_ = self->priv->constraint_combo;
#line 282 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
#line 283 "../src/Dialogs/ExportDialog.vala"
			_tmp17_ = self->priv->quality_combo;
#line 283 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, FALSE);
#line 284 "../src/Dialogs/ExportDialog.vala"
			_tmp18_ = self->priv->pixels_entry;
#line 284 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, !original);
#line 285 "../src/Dialogs/ExportDialog.vala"
			_tmp19_ = self->priv->export_metadata;
#line 285 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
#line 976 "ExportDialog.c"
		} else {
			GtkComboBoxText* _tmp20_;
			gboolean jpeg = FALSE;
			gboolean _tmp21_ = FALSE;
			GtkComboBoxText* _tmp22_;
			GtkCheckButton* _tmp23_;
#line 290 "../src/Dialogs/ExportDialog.vala"
			_tmp20_ = self->priv->constraint_combo;
#line 290 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, TRUE);
#line 291 "../src/Dialogs/ExportDialog.vala"
			jpeg = export_dialog_get_specified_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 292 "../src/Dialogs/ExportDialog.vala"
			if (!original) {
#line 292 "../src/Dialogs/ExportDialog.vala"
				_tmp21_ = jpeg;
#line 993 "ExportDialog.c"
			} else {
#line 292 "../src/Dialogs/ExportDialog.vala"
				_tmp21_ = FALSE;
#line 997 "ExportDialog.c"
			}
#line 292 "../src/Dialogs/ExportDialog.vala"
			_tmp22_ = self->priv->quality_combo;
#line 292 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, _tmp21_);
#line 293 "../src/Dialogs/ExportDialog.vala"
			_tmp23_ = self->priv->export_metadata;
#line 293 "../src/Dialogs/ExportDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, TRUE);
#line 1007 "ExportDialog.c"
		}
	}
}

static void
export_dialog_on_pixels_changed (ExportDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	GtkWidget* _tmp4_;
#line 297 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = self->priv->pixels_entry;
#line 298 "../src/Dialogs/ExportDialog.vala"
	if (((gint) gtk_entry_get_text_length (_tmp1_)) > 0) {
#line 1024 "ExportDialog.c"
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
#line 298 "../src/Dialogs/ExportDialog.vala"
		_tmp2_ = self->priv->pixels_entry;
#line 298 "../src/Dialogs/ExportDialog.vala"
		_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 298 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = atoi (_tmp3_) > 0;
#line 1033 "ExportDialog.c"
	} else {
#line 298 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = FALSE;
#line 1037 "ExportDialog.c"
	}
#line 298 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = self->priv->export_button;
#line 298 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_sensitive (_tmp4_, _tmp0_);
#line 1043 "ExportDialog.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 1060 "ExportDialog.c"
}

static void
export_dialog_on_pixels_insert_text (ExportDialog* self,
                                     const gchar* text,
                                     gint length,
                                     gint* position)
{
	gchar* new_text = NULL;
	gchar* _tmp2_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GtkEntry* _tmp17_;
#line 301 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Dialogs/ExportDialog.vala"
	g_return_if_fail (text != NULL);
#line 303 "../src/Dialogs/ExportDialog.vala"
	if (self->priv->in_insert) {
#line 304 "../src/Dialogs/ExportDialog.vala"
		return;
#line 1083 "ExportDialog.c"
	}
#line 306 "../src/Dialogs/ExportDialog.vala"
	self->priv->in_insert = TRUE;
#line 308 "../src/Dialogs/ExportDialog.vala"
	if (length == -1) {
#line 1089 "ExportDialog.c"
		gint _tmp0_;
		gint _tmp1_;
#line 309 "../src/Dialogs/ExportDialog.vala"
		_tmp0_ = strlen (text);
#line 309 "../src/Dialogs/ExportDialog.vala"
		_tmp1_ = _tmp0_;
#line 309 "../src/Dialogs/ExportDialog.vala"
		length = (gint) _tmp1_;
#line 1098 "ExportDialog.c"
	}
#line 312 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = g_strdup ("");
#line 312 "../src/Dialogs/ExportDialog.vala"
	new_text = _tmp2_;
#line 1104 "ExportDialog.c"
	{
		gint ctr = 0;
#line 313 "../src/Dialogs/ExportDialog.vala"
		ctr = 0;
#line 1109 "ExportDialog.c"
		{
			gboolean _tmp3_ = FALSE;
#line 313 "../src/Dialogs/ExportDialog.vala"
			_tmp3_ = TRUE;
#line 313 "../src/Dialogs/ExportDialog.vala"
			while (TRUE) {
#line 313 "../src/Dialogs/ExportDialog.vala"
				if (!_tmp3_) {
#line 1118 "ExportDialog.c"
					gint _tmp4_;
#line 313 "../src/Dialogs/ExportDialog.vala"
					_tmp4_ = ctr;
#line 313 "../src/Dialogs/ExportDialog.vala"
					ctr = _tmp4_ + 1;
#line 1124 "ExportDialog.c"
				}
#line 313 "../src/Dialogs/ExportDialog.vala"
				_tmp3_ = FALSE;
#line 313 "../src/Dialogs/ExportDialog.vala"
				if (!(ctr < length)) {
#line 313 "../src/Dialogs/ExportDialog.vala"
					break;
#line 1132 "ExportDialog.c"
				}
#line 314 "../src/Dialogs/ExportDialog.vala"
				if (g_ascii_isdigit (string_get (text, (glong) ctr))) {
#line 1136 "ExportDialog.c"
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 315 "../src/Dialogs/ExportDialog.vala"
					_tmp5_ = new_text;
#line 315 "../src/Dialogs/ExportDialog.vala"
					_tmp6_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 315 "../src/Dialogs/ExportDialog.vala"
					_tmp7_ = _tmp6_;
#line 315 "../src/Dialogs/ExportDialog.vala"
					_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 315 "../src/Dialogs/ExportDialog.vala"
					_g_free0 (new_text);
#line 315 "../src/Dialogs/ExportDialog.vala"
					new_text = _tmp8_;
#line 315 "../src/Dialogs/ExportDialog.vala"
					_g_free0 (_tmp7_);
#line 1155 "ExportDialog.c"
				}
			}
		}
	}
#line 319 "../src/Dialogs/ExportDialog.vala"
	_tmp9_ = new_text;
#line 319 "../src/Dialogs/ExportDialog.vala"
	_tmp10_ = strlen (_tmp9_);
#line 319 "../src/Dialogs/ExportDialog.vala"
	_tmp11_ = _tmp10_;
#line 319 "../src/Dialogs/ExportDialog.vala"
	if (_tmp11_ > 0) {
#line 1168 "ExportDialog.c"
		GtkEntry* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 320 "../src/Dialogs/ExportDialog.vala"
		_tmp12_ = self->priv->pixels_entry;
#line 320 "../src/Dialogs/ExportDialog.vala"
		_tmp13_ = new_text;
#line 320 "../src/Dialogs/ExportDialog.vala"
		_tmp14_ = new_text;
#line 320 "../src/Dialogs/ExportDialog.vala"
		_tmp15_ = strlen (_tmp14_);
#line 320 "../src/Dialogs/ExportDialog.vala"
		_tmp16_ = _tmp15_;
#line 320 "../src/Dialogs/ExportDialog.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp12_, "insert-text", _tmp13_, (gint) _tmp16_, position);
#line 1186 "ExportDialog.c"
	}
#line 322 "../src/Dialogs/ExportDialog.vala"
	_tmp17_ = self->priv->pixels_entry;
#line 322 "../src/Dialogs/ExportDialog.vala"
	g_signal_stop_emission_by_name (_tmp17_, "insert-text");
#line 324 "../src/Dialogs/ExportDialog.vala"
	self->priv->in_insert = FALSE;
#line 301 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (new_text);
#line 1196 "ExportDialog.c"
}

static void
_export_dialog_on_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
#line 139 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_constraint_changed ((ExportDialog*) self);
#line 1205 "ExportDialog.c"
}

static void
_export_dialog_on_format_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
#line 140 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_format_changed ((ExportDialog*) self);
#line 1214 "ExportDialog.c"
}

static void
_export_dialog_on_pixels_changed_gtk_editable_changed (GtkEditable* _sender,
                                                       gpointer self)
{
#line 141 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_pixels_changed ((ExportDialog*) self);
#line 1223 "ExportDialog.c"
}

static void
_export_dialog_on_pixels_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                               const gchar* new_text,
                                                               gint new_text_length,
                                                               gint* position,
                                                               gpointer self)
{
#line 142 "../src/Dialogs/ExportDialog.vala"
	export_dialog_on_pixels_insert_text ((ExportDialog*) self, new_text, new_text_length, position);
#line 1235 "ExportDialog.c"
}

static void
_export_dialog___lambda40_ (ExportDialog* self)
{
#line 144 "../src/Dialogs/ExportDialog.vala"
	gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 1243 "ExportDialog.c"
}

static void
__export_dialog___lambda40__gtk_entry_activate (GtkEntry* _sender,
                                                gpointer self)
{
#line 143 "../src/Dialogs/ExportDialog.vala"
	_export_dialog___lambda40_ ((ExportDialog*) self);
#line 1252 "ExportDialog.c"
}

static GObject *
export_dialog_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ExportDialog * self;
	GtkLabel* format_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GtkComboBoxText* _tmp5_;
	gint _tmp6_ = 0;
	PhotoFileFormat* _tmp7_;
	GtkLabel* quality_label = NULL;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkComboBoxText* _tmp17_;
	GtkComboBoxText* _tmp18_;
	gint ctr = 0;
	GtkLabel* constraint_label = NULL;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkComboBoxText* _tmp32_;
	GtkComboBoxText* _tmp33_;
	GtkEntry* _tmp42_;
	GtkEntry* _tmp43_;
	GtkEntry* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GtkEntry* _tmp47_;
	GtkLabel* pixels_label = NULL;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkEntry* _tmp50_;
	GtkCheckButton* _tmp51_;
	GtkCheckButton* _tmp52_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp53_;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkLabel* _tmp59_;
	GtkGrid* _tmp60_;
	GtkComboBoxText* _tmp61_;
	GtkGrid* _tmp62_;
	GtkLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkGrid* _tmp66_;
	GtkLabel* _tmp67_;
	GtkGrid* _tmp68_;
	GtkComboBoxText* _tmp69_;
	GtkGrid* _tmp70_;
	GtkEntry* _tmp71_;
	GtkGrid* _tmp72_;
	GtkLabel* _tmp73_;
	GtkGrid* _tmp74_;
	GtkCheckButton* _tmp75_;
	GtkBox* _tmp76_;
	GtkGrid* _tmp77_;
	GtkWidget* _tmp78_;
	GtkWidget* _tmp79_;
	GtkWidget* _tmp80_;
	GtkWidget* _tmp81_;
	GtkWidget* _tmp82_;
	GtkWidget* _tmp83_;
	ScaleConstraint _tmp84_;
	GtkComboBoxText* _tmp87_;
	GtkComboBoxText* _tmp88_;
	GtkEntry* _tmp89_;
	GtkEntry* _tmp90_;
	GtkEntry* _tmp91_;
#line 56 "../src/Dialogs/ExportDialog.vala"
	parent_class = G_OBJECT_CLASS (export_dialog_parent_class);
#line 56 "../src/Dialogs/ExportDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 56 "../src/Dialogs/ExportDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
#line 57 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Format:"));
#line 57 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 57 "../src/Dialogs/ExportDialog.vala"
	format_label = _tmp0_;
#line 58 "../src/Dialogs/ExportDialog.vala"
	_tmp1_ = format_label;
#line 58 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 59 "../src/Dialogs/ExportDialog.vala"
	_tmp2_ = format_label;
#line 59 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp2_, TRUE);
#line 60 "../src/Dialogs/ExportDialog.vala"
	_tmp3_ = format_label;
#line 60 "../src/Dialogs/ExportDialog.vala"
	_tmp4_ = self->priv->format_combo;
#line 60 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp3_, (GtkWidget*) _tmp4_);
#line 62 "../src/Dialogs/ExportDialog.vala"
	_tmp5_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 62 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 62 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_combo);
#line 62 "../src/Dialogs/ExportDialog.vala"
	self->priv->format_combo = _tmp5_;
#line 63 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_add_option (self, EXPORT_DIALOG_UNMODIFIED_FORMAT_LABEL);
#line 64 "../src/Dialogs/ExportDialog.vala"
	export_dialog_format_add_option (self, EXPORT_DIALOG_CURRENT_FORMAT_LABEL);
#line 65 "../src/Dialogs/ExportDialog.vala"
	_tmp7_ = photo_file_format_get_writeable (&_tmp6_);
#line 1377 "ExportDialog.c"
	{
		PhotoFileFormat* format_collection = NULL;
		gint format_collection_length1 = 0;
		gint _format_collection_size_ = 0;
		gint format_it = 0;
#line 65 "../src/Dialogs/ExportDialog.vala"
		format_collection = _tmp7_;
#line 65 "../src/Dialogs/ExportDialog.vala"
		format_collection_length1 = _tmp6_;
#line 65 "../src/Dialogs/ExportDialog.vala"
		for (format_it = 0; format_it < _tmp6_; format_it = format_it + 1) {
#line 1389 "ExportDialog.c"
			PhotoFileFormat format = 0;
#line 65 "../src/Dialogs/ExportDialog.vala"
			format = format_collection[format_it];
#line 1393 "ExportDialog.c"
			{
				PhotoFileFormat _tmp8_;
				PhotoFileFormatProperties* _tmp9_;
				PhotoFileFormatProperties* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 66 "../src/Dialogs/ExportDialog.vala"
				_tmp8_ = format;
#line 66 "../src/Dialogs/ExportDialog.vala"
				_tmp9_ = photo_file_format_get_properties (_tmp8_);
#line 66 "../src/Dialogs/ExportDialog.vala"
				_tmp10_ = _tmp9_;
#line 66 "../src/Dialogs/ExportDialog.vala"
				_tmp11_ = photo_file_format_properties_get_user_visible_name (_tmp10_);
#line 66 "../src/Dialogs/ExportDialog.vala"
				_tmp12_ = _tmp11_;
#line 66 "../src/Dialogs/ExportDialog.vala"
				export_dialog_format_add_option (self, _tmp12_);
#line 66 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp12_);
#line 66 "../src/Dialogs/ExportDialog.vala"
				_photo_file_format_properties_unref0 (_tmp10_);
#line 1416 "ExportDialog.c"
			}
		}
#line 65 "../src/Dialogs/ExportDialog.vala"
		format_collection = (g_free (format_collection), NULL);
#line 1421 "ExportDialog.c"
	}
#line 69 "../src/Dialogs/ExportDialog.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Quality:"));
#line 69 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 69 "../src/Dialogs/ExportDialog.vala"
	quality_label = _tmp13_;
#line 70 "../src/Dialogs/ExportDialog.vala"
	_tmp14_ = quality_label;
#line 70 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_END);
#line 71 "../src/Dialogs/ExportDialog.vala"
	_tmp15_ = quality_label;
#line 71 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp15_, TRUE);
#line 72 "../src/Dialogs/ExportDialog.vala"
	_tmp16_ = quality_label;
#line 72 "../src/Dialogs/ExportDialog.vala"
	_tmp17_ = self->priv->quality_combo;
#line 72 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp16_, (GtkWidget*) _tmp17_);
#line 74 "../src/Dialogs/ExportDialog.vala"
	_tmp18_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 74 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp18_);
#line 74 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->quality_combo);
#line 74 "../src/Dialogs/ExportDialog.vala"
	self->priv->quality_combo = _tmp18_;
#line 75 "../src/Dialogs/ExportDialog.vala"
	ctr = 0;
#line 1453 "ExportDialog.c"
	{
		JpegQuality* quality_collection = NULL;
		gint quality_collection_length1 = 0;
		gint _quality_collection_size_ = 0;
		gint quality_it = 0;
#line 76 "../src/Dialogs/ExportDialog.vala"
		quality_collection = EXPORT_DIALOG_QUALITY_ARRAY;
#line 76 "../src/Dialogs/ExportDialog.vala"
		quality_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_QUALITY_ARRAY);
#line 76 "../src/Dialogs/ExportDialog.vala"
		for (quality_it = 0; quality_it < G_N_ELEMENTS (EXPORT_DIALOG_QUALITY_ARRAY); quality_it = quality_it + 1) {
#line 1465 "ExportDialog.c"
			JpegQuality quality = 0;
#line 76 "../src/Dialogs/ExportDialog.vala"
			quality = quality_collection[quality_it];
#line 1469 "ExportDialog.c"
			{
				GtkComboBoxText* _tmp19_;
				JpegQuality _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				JpegQuality _tmp23_;
				ExportFormatParameters _tmp24_;
				JpegQuality _tmp25_;
				gint _tmp27_;
#line 77 "../src/Dialogs/ExportDialog.vala"
				_tmp19_ = self->priv->quality_combo;
#line 77 "../src/Dialogs/ExportDialog.vala"
				_tmp20_ = quality;
#line 77 "../src/Dialogs/ExportDialog.vala"
				_tmp21_ = jpeg_quality_to_string (_tmp20_);
#line 77 "../src/Dialogs/ExportDialog.vala"
				_tmp22_ = _tmp21_;
#line 77 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_text_append_text (_tmp19_, _tmp22_);
#line 77 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp22_);
#line 78 "../src/Dialogs/ExportDialog.vala"
				_tmp23_ = quality;
#line 78 "../src/Dialogs/ExportDialog.vala"
				_tmp24_ = export_dialog_current_parameters;
#line 78 "../src/Dialogs/ExportDialog.vala"
				_tmp25_ = _tmp24_.quality;
#line 78 "../src/Dialogs/ExportDialog.vala"
				if (_tmp23_ == _tmp25_) {
#line 1499 "ExportDialog.c"
					GtkComboBoxText* _tmp26_;
#line 79 "../src/Dialogs/ExportDialog.vala"
					_tmp26_ = self->priv->quality_combo;
#line 79 "../src/Dialogs/ExportDialog.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp26_, ctr);
#line 1505 "ExportDialog.c"
				}
#line 80 "../src/Dialogs/ExportDialog.vala"
				_tmp27_ = ctr;
#line 80 "../src/Dialogs/ExportDialog.vala"
				ctr = _tmp27_ + 1;
#line 1511 "ExportDialog.c"
			}
		}
	}
#line 83 "../src/Dialogs/ExportDialog.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Scaling constraint:"));
#line 83 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp28_);
#line 83 "../src/Dialogs/ExportDialog.vala"
	constraint_label = _tmp28_;
#line 84 "../src/Dialogs/ExportDialog.vala"
	_tmp29_ = constraint_label;
#line 84 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
#line 85 "../src/Dialogs/ExportDialog.vala"
	_tmp30_ = constraint_label;
#line 85 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_use_underline (_tmp30_, TRUE);
#line 86 "../src/Dialogs/ExportDialog.vala"
	_tmp31_ = constraint_label;
#line 86 "../src/Dialogs/ExportDialog.vala"
	_tmp32_ = self->priv->constraint_combo;
#line 86 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp31_, (GtkWidget*) _tmp32_);
#line 88 "../src/Dialogs/ExportDialog.vala"
	_tmp33_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 88 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 88 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->constraint_combo);
#line 88 "../src/Dialogs/ExportDialog.vala"
	self->priv->constraint_combo = _tmp33_;
#line 89 "../src/Dialogs/ExportDialog.vala"
	ctr = 0;
#line 1545 "ExportDialog.c"
	{
		ScaleConstraint* constraint_collection = NULL;
		gint constraint_collection_length1 = 0;
		gint _constraint_collection_size_ = 0;
		gint constraint_it = 0;
#line 90 "../src/Dialogs/ExportDialog.vala"
		constraint_collection = EXPORT_DIALOG_CONSTRAINT_ARRAY;
#line 90 "../src/Dialogs/ExportDialog.vala"
		constraint_collection_length1 = G_N_ELEMENTS (EXPORT_DIALOG_CONSTRAINT_ARRAY);
#line 90 "../src/Dialogs/ExportDialog.vala"
		for (constraint_it = 0; constraint_it < G_N_ELEMENTS (EXPORT_DIALOG_CONSTRAINT_ARRAY); constraint_it = constraint_it + 1) {
#line 1557 "ExportDialog.c"
			ScaleConstraint constraint = 0;
#line 90 "../src/Dialogs/ExportDialog.vala"
			constraint = constraint_collection[constraint_it];
#line 1561 "ExportDialog.c"
			{
				GtkComboBoxText* _tmp34_;
				ScaleConstraint _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				ScaleConstraint _tmp38_;
				ScaleConstraint _tmp39_;
				gint _tmp41_;
#line 91 "../src/Dialogs/ExportDialog.vala"
				_tmp34_ = self->priv->constraint_combo;
#line 91 "../src/Dialogs/ExportDialog.vala"
				_tmp35_ = constraint;
#line 91 "../src/Dialogs/ExportDialog.vala"
				_tmp36_ = scale_constraint_to_string (_tmp35_);
#line 91 "../src/Dialogs/ExportDialog.vala"
				_tmp37_ = _tmp36_;
#line 91 "../src/Dialogs/ExportDialog.vala"
				gtk_combo_box_text_append_text (_tmp34_, _tmp37_);
#line 91 "../src/Dialogs/ExportDialog.vala"
				_g_free0 (_tmp37_);
#line 92 "../src/Dialogs/ExportDialog.vala"
				_tmp38_ = constraint;
#line 92 "../src/Dialogs/ExportDialog.vala"
				_tmp39_ = export_dialog_current_constraint;
#line 92 "../src/Dialogs/ExportDialog.vala"
				if (_tmp38_ == _tmp39_) {
#line 1588 "ExportDialog.c"
					GtkComboBoxText* _tmp40_;
#line 93 "../src/Dialogs/ExportDialog.vala"
					_tmp40_ = self->priv->constraint_combo;
#line 93 "../src/Dialogs/ExportDialog.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp40_, ctr);
#line 1594 "ExportDialog.c"
				}
#line 94 "../src/Dialogs/ExportDialog.vala"
				_tmp41_ = ctr;
#line 94 "../src/Dialogs/ExportDialog.vala"
				ctr = _tmp41_ + 1;
#line 1600 "ExportDialog.c"
			}
		}
	}
#line 97 "../src/Dialogs/ExportDialog.vala"
	_tmp42_ = (GtkEntry*) gtk_entry_new ();
#line 97 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp42_);
#line 97 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->pixels_entry);
#line 97 "../src/Dialogs/ExportDialog.vala"
	self->priv->pixels_entry = _tmp42_;
#line 98 "../src/Dialogs/ExportDialog.vala"
	_tmp43_ = self->priv->pixels_entry;
#line 98 "../src/Dialogs/ExportDialog.vala"
	gtk_entry_set_max_length (_tmp43_, 6);
#line 99 "../src/Dialogs/ExportDialog.vala"
	_tmp44_ = self->priv->pixels_entry;
#line 99 "../src/Dialogs/ExportDialog.vala"
	_tmp45_ = g_strdup_printf ("%d", export_dialog_current_scale);
#line 99 "../src/Dialogs/ExportDialog.vala"
	_tmp46_ = _tmp45_;
#line 99 "../src/Dialogs/ExportDialog.vala"
	gtk_entry_set_text (_tmp44_, _tmp46_);
#line 99 "../src/Dialogs/ExportDialog.vala"
	_g_free0 (_tmp46_);
#line 100 "../src/Dialogs/ExportDialog.vala"
	_tmp47_ = self->priv->pixels_entry;
#line 100 "../src/Dialogs/ExportDialog.vala"
	g_object_set (_tmp47_, "xalign", (gfloat) 1, NULL);
#line 102 "../src/Dialogs/ExportDialog.vala"
	_tmp48_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_pixels"));
#line 102 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp48_);
#line 102 "../src/Dialogs/ExportDialog.vala"
	pixels_label = _tmp48_;
#line 103 "../src/Dialogs/ExportDialog.vala"
	_tmp49_ = pixels_label;
#line 103 "../src/Dialogs/ExportDialog.vala"
	_tmp50_ = self->priv->pixels_entry;
#line 103 "../src/Dialogs/ExportDialog.vala"
	gtk_label_set_mnemonic_widget (_tmp49_, (GtkWidget*) _tmp50_);
#line 105 "../src/Dialogs/ExportDialog.vala"
	_tmp51_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Export metadata"));
#line 105 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp51_);
#line 105 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_metadata);
#line 105 "../src/Dialogs/ExportDialog.vala"
	self->priv->export_metadata = _tmp51_;
#line 106 "../src/Dialogs/ExportDialog.vala"
	_tmp52_ = self->priv->export_metadata;
#line 106 "../src/Dialogs/ExportDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp52_, TRUE);
#line 108 "../src/Dialogs/ExportDialog.vala"
	_tmp53_ = (GtkGrid*) gtk_grid_new ();
#line 108 "../src/Dialogs/ExportDialog.vala"
	g_object_ref_sink (_tmp53_);
#line 108 "../src/Dialogs/ExportDialog.vala"
	grid = _tmp53_;
#line 109 "../src/Dialogs/ExportDialog.vala"
	_tmp54_ = grid;
#line 109 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_set_column_spacing (_tmp54_, 12);
#line 110 "../src/Dialogs/ExportDialog.vala"
	_tmp55_ = grid;
#line 110 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_set_row_spacing (_tmp55_, 6);
#line 111 "../src/Dialogs/ExportDialog.vala"
	_tmp56_ = grid;
#line 111 "../src/Dialogs/ExportDialog.vala"
	g_object_set ((GtkWidget*) _tmp56_, "margin", 12, NULL);
#line 112 "../src/Dialogs/ExportDialog.vala"
	_tmp57_ = grid;
#line 112 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp57_, 0);
#line 113 "../src/Dialogs/ExportDialog.vala"
	_tmp58_ = grid;
#line 113 "../src/Dialogs/ExportDialog.vala"
	_tmp59_ = format_label;
#line 113 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 0, 0, 1, 1);
#line 114 "../src/Dialogs/ExportDialog.vala"
	_tmp60_ = grid;
#line 114 "../src/Dialogs/ExportDialog.vala"
	_tmp61_ = self->priv->format_combo;
#line 114 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 1, 0, 1, 1);
#line 115 "../src/Dialogs/ExportDialog.vala"
	_tmp62_ = grid;
#line 115 "../src/Dialogs/ExportDialog.vala"
	_tmp63_ = quality_label;
#line 115 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 1, 1, 1);
#line 116 "../src/Dialogs/ExportDialog.vala"
	_tmp64_ = grid;
#line 116 "../src/Dialogs/ExportDialog.vala"
	_tmp65_ = self->priv->quality_combo;
#line 116 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 1, 1, 1, 1);
#line 117 "../src/Dialogs/ExportDialog.vala"
	_tmp66_ = grid;
#line 117 "../src/Dialogs/ExportDialog.vala"
	_tmp67_ = constraint_label;
#line 117 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 0, 2, 1, 1);
#line 118 "../src/Dialogs/ExportDialog.vala"
	_tmp68_ = grid;
#line 118 "../src/Dialogs/ExportDialog.vala"
	_tmp69_ = self->priv->constraint_combo;
#line 118 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp68_, (GtkWidget*) _tmp69_, 1, 2, 1, 1);
#line 119 "../src/Dialogs/ExportDialog.vala"
	_tmp70_ = grid;
#line 119 "../src/Dialogs/ExportDialog.vala"
	_tmp71_ = self->priv->pixels_entry;
#line 119 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp70_, (GtkWidget*) _tmp71_, 1, 3, 1, 1);
#line 120 "../src/Dialogs/ExportDialog.vala"
	_tmp72_ = grid;
#line 120 "../src/Dialogs/ExportDialog.vala"
	_tmp73_ = pixels_label;
#line 120 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp72_, (GtkWidget*) _tmp73_, 2, 3, 1, 1);
#line 121 "../src/Dialogs/ExportDialog.vala"
	_tmp74_ = grid;
#line 121 "../src/Dialogs/ExportDialog.vala"
	_tmp75_ = self->priv->export_metadata;
#line 121 "../src/Dialogs/ExportDialog.vala"
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 1, 4, 1, 1);
#line 123 "../src/Dialogs/ExportDialog.vala"
	_tmp76_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 123 "../src/Dialogs/ExportDialog.vala"
	_tmp77_ = grid;
#line 123 "../src/Dialogs/ExportDialog.vala"
	gtk_container_add ((GtkContainer*) G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, gtk_box_get_type (), GtkBox), (GtkWidget*) _tmp77_);
#line 125 "../src/Dialogs/ExportDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 127 "../src/Dialogs/ExportDialog.vala"
	_tmp78_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Export"), (gint) GTK_RESPONSE_OK);
#line 127 "../src/Dialogs/ExportDialog.vala"
	_tmp79_ = _g_object_ref0 (_tmp78_);
#line 127 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_button);
#line 127 "../src/Dialogs/ExportDialog.vala"
	self->priv->export_button = _tmp79_;
#line 128 "../src/Dialogs/ExportDialog.vala"
	_tmp80_ = self->priv->export_button;
#line 128 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_set_can_default (_tmp80_, TRUE);
#line 129 "../src/Dialogs/ExportDialog.vala"
	_tmp81_ = self->priv->export_button;
#line 129 "../src/Dialogs/ExportDialog.vala"
	g_object_set (_tmp81_, "has-default", TRUE, NULL);
#line 130 "../src/Dialogs/ExportDialog.vala"
	_tmp82_ = self->priv->export_button;
#line 130 "../src/Dialogs/ExportDialog.vala"
	gtk_widget_grab_focus (_tmp82_);
#line 132 "../src/Dialogs/ExportDialog.vala"
	_tmp83_ = gtk_dialog_get_action_area ((GtkDialog*) self);
#line 132 "../src/Dialogs/ExportDialog.vala"
	g_object_set (_tmp83_, "margin", 5, NULL);
#line 134 "../src/Dialogs/ExportDialog.vala"
	_tmp84_ = export_dialog_current_constraint;
#line 134 "../src/Dialogs/ExportDialog.vala"
	if (_tmp84_ == SCALE_CONSTRAINT_ORIGINAL) {
#line 1766 "ExportDialog.c"
		GtkEntry* _tmp85_;
		GtkComboBoxText* _tmp86_;
#line 135 "../src/Dialogs/ExportDialog.vala"
		_tmp85_ = self->priv->pixels_entry;
#line 135 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp85_, FALSE);
#line 136 "../src/Dialogs/ExportDialog.vala"
		_tmp86_ = self->priv->quality_combo;
#line 136 "../src/Dialogs/ExportDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp86_, FALSE);
#line 1777 "ExportDialog.c"
	}
#line 139 "../src/Dialogs/ExportDialog.vala"
	_tmp87_ = self->priv->constraint_combo;
#line 139 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp87_, "changed", (GCallback) _export_dialog_on_constraint_changed_gtk_combo_box_changed, self, 0);
#line 140 "../src/Dialogs/ExportDialog.vala"
	_tmp88_ = self->priv->format_combo;
#line 140 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp88_, "changed", (GCallback) _export_dialog_on_format_changed_gtk_combo_box_changed, self, 0);
#line 141 "../src/Dialogs/ExportDialog.vala"
	_tmp89_ = self->priv->pixels_entry;
#line 141 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp89_, "changed", (GCallback) _export_dialog_on_pixels_changed_gtk_editable_changed, self, 0);
#line 142 "../src/Dialogs/ExportDialog.vala"
	_tmp90_ = self->priv->pixels_entry;
#line 142 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp90_, "insert-text", (GCallback) _export_dialog_on_pixels_insert_text_gtk_editable_insert_text, self, 0);
#line 143 "../src/Dialogs/ExportDialog.vala"
	_tmp91_ = self->priv->pixels_entry;
#line 143 "../src/Dialogs/ExportDialog.vala"
	g_signal_connect_object (_tmp91_, "activate", (GCallback) __export_dialog___lambda40__gtk_entry_activate, self, 0);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (grid);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (pixels_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (constraint_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (quality_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (format_label);
#line 56 "../src/Dialogs/ExportDialog.vala"
	return obj;
#line 1811 "ExportDialog.c"
}

static void
export_dialog_class_init (ExportDialogClass * klass,
                          gpointer klass_data)
{
	ExportFormatParameters _tmp0_ = {0};
#line 21 "../src/Dialogs/ExportDialog.vala"
	export_dialog_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Dialogs/ExportDialog.vala"
	g_type_class_adjust_private_offset (klass, &ExportDialog_private_offset);
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = export_dialog_constructor;
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = export_dialog_finalize;
#line 38 "../src/Dialogs/ExportDialog.vala"
	export_format_parameters_current (&_tmp0_);
#line 38 "../src/Dialogs/ExportDialog.vala"
	export_dialog_current_parameters = _tmp0_;
#line 1831 "ExportDialog.c"
}

static void
export_dialog_instance_init (ExportDialog * self,
                             gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 21 "../src/Dialogs/ExportDialog.vala"
	self->priv = export_dialog_get_instance_private (self);
#line 45 "../src/Dialogs/ExportDialog.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 45 "../src/Dialogs/ExportDialog.vala"
	self->priv->format_options = _tmp0_;
#line 48 "../src/Dialogs/ExportDialog.vala"
	self->priv->in_insert = FALSE;
#line 1847 "ExportDialog.c"
}

static void
export_dialog_finalize (GObject * obj)
{
	ExportDialog * self;
#line 21 "../src/Dialogs/ExportDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXPORT_DIALOG, ExportDialog);
#line 41 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->quality_combo);
#line 42 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->constraint_combo);
#line 43 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_combo);
#line 44 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_metadata);
#line 45 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->format_options);
#line 46 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->pixels_entry);
#line 47 "../src/Dialogs/ExportDialog.vala"
	_g_object_unref0 (self->priv->export_button);
#line 21 "../src/Dialogs/ExportDialog.vala"
	G_OBJECT_CLASS (export_dialog_parent_class)->finalize (obj);
#line 1872 "ExportDialog.c"
}

GType
export_dialog_get_type (void)
{
	static volatile gsize export_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&export_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ExportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportDialog), 0, (GInstanceInitFunc) export_dialog_instance_init, NULL };
		GType export_dialog_type_id;
		export_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ExportDialog", &g_define_type_info, 0);
		ExportDialog_private_offset = g_type_add_instance_private (export_dialog_type_id, sizeof (ExportDialogPrivate));
		g_once_init_leave (&export_dialog_type_id__volatile, export_dialog_type_id);
	}
	return export_dialog_type_id__volatile;
}

