/* Orientation.c generated by valac 0.44.3, the Vala compiler
 * generated from Orientation.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

GType orientation_get_type (void) G_GNUC_CONST;
gchar* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void) G_GNUC_CONST;
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
Rotation* orientation_to_rotations (Orientation self,
                                    gint* result_length1);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
void orientation_rotate_point (Orientation self,
                               Dimensions* space,
                               GdkPoint* point,
                               GdkPoint* result);
gboolean dimensions_has_area (Dimensions *self);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void box_get_points (Box *self,
                     GdkPoint* top_left,
                     GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1,
                      GdkPoint* corner2,
                      Box* result);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
GdkPixbuf* rotation_perform (Rotation self,
                             GdkPixbuf* pixbuf);
Rotation rotation_opposite (Rotation self);

gchar*
orientation_to_string (Orientation self)
{
	gchar* result = NULL;
#line 33 "../src/Orientation.vala"
	switch (self) {
#line 33 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 140 "Orientation.c"
		{
			gchar* _tmp0_;
#line 35 "../src/Orientation.vala"
			_tmp0_ = g_strdup ("top-left");
#line 35 "../src/Orientation.vala"
			result = _tmp0_;
#line 35 "../src/Orientation.vala"
			return result;
#line 149 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 153 "Orientation.c"
		{
			gchar* _tmp1_;
#line 38 "../src/Orientation.vala"
			_tmp1_ = g_strdup ("top-right");
#line 38 "../src/Orientation.vala"
			result = _tmp1_;
#line 38 "../src/Orientation.vala"
			return result;
#line 162 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 166 "Orientation.c"
		{
			gchar* _tmp2_;
#line 41 "../src/Orientation.vala"
			_tmp2_ = g_strdup ("bottom-right");
#line 41 "../src/Orientation.vala"
			result = _tmp2_;
#line 41 "../src/Orientation.vala"
			return result;
#line 175 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 179 "Orientation.c"
		{
			gchar* _tmp3_;
#line 44 "../src/Orientation.vala"
			_tmp3_ = g_strdup ("bottom-left");
#line 44 "../src/Orientation.vala"
			result = _tmp3_;
#line 44 "../src/Orientation.vala"
			return result;
#line 188 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 192 "Orientation.c"
		{
			gchar* _tmp4_;
#line 47 "../src/Orientation.vala"
			_tmp4_ = g_strdup ("left-top");
#line 47 "../src/Orientation.vala"
			result = _tmp4_;
#line 47 "../src/Orientation.vala"
			return result;
#line 201 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 205 "Orientation.c"
		{
			gchar* _tmp5_;
#line 50 "../src/Orientation.vala"
			_tmp5_ = g_strdup ("right-top");
#line 50 "../src/Orientation.vala"
			result = _tmp5_;
#line 50 "../src/Orientation.vala"
			return result;
#line 214 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 218 "Orientation.c"
		{
			gchar* _tmp6_;
#line 53 "../src/Orientation.vala"
			_tmp6_ = g_strdup ("right-bottom");
#line 53 "../src/Orientation.vala"
			result = _tmp6_;
#line 53 "../src/Orientation.vala"
			return result;
#line 227 "Orientation.c"
		}
#line 33 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 231 "Orientation.c"
		{
			gchar* _tmp7_;
#line 56 "../src/Orientation.vala"
			_tmp7_ = g_strdup ("left-bottom");
#line 56 "../src/Orientation.vala"
			result = _tmp7_;
#line 56 "../src/Orientation.vala"
			return result;
#line 240 "Orientation.c"
		}
		default:
		{
			gchar* _tmp8_;
#line 59 "../src/Orientation.vala"
			_tmp8_ = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 59 "../src/Orientation.vala"
			result = _tmp8_;
#line 59 "../src/Orientation.vala"
			return result;
#line 251 "Orientation.c"
		}
	}
}

Orientation
orientation_rotate_clockwise (Orientation self)
{
	Orientation result = 0;
#line 64 "../src/Orientation.vala"
	switch (self) {
#line 64 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 264 "Orientation.c"
		{
#line 66 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 66 "../src/Orientation.vala"
			return result;
#line 270 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 274 "Orientation.c"
		{
#line 69 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 69 "../src/Orientation.vala"
			return result;
#line 280 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 284 "Orientation.c"
		{
#line 72 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 72 "../src/Orientation.vala"
			return result;
#line 290 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 294 "Orientation.c"
		{
#line 75 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 75 "../src/Orientation.vala"
			return result;
#line 300 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 304 "Orientation.c"
		{
#line 78 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 78 "../src/Orientation.vala"
			return result;
#line 310 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 314 "Orientation.c"
		{
#line 81 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 81 "../src/Orientation.vala"
			return result;
#line 320 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 324 "Orientation.c"
		{
#line 84 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 84 "../src/Orientation.vala"
			return result;
#line 330 "Orientation.c"
		}
#line 64 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 334 "Orientation.c"
		{
#line 87 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 87 "../src/Orientation.vala"
			return result;
#line 340 "Orientation.c"
		}
		default:
		{
#line 90 "../src/Orientation.vala"
			g_error ("Orientation.vala:90: rotate_clockwise: %d", (gint) self);
#line 346 "Orientation.c"
		}
	}
}

Orientation
orientation_rotate_counterclockwise (Orientation self)
{
	Orientation result = 0;
#line 95 "../src/Orientation.vala"
	switch (self) {
#line 95 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 359 "Orientation.c"
		{
#line 97 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 97 "../src/Orientation.vala"
			return result;
#line 365 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 369 "Orientation.c"
		{
#line 100 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 100 "../src/Orientation.vala"
			return result;
#line 375 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 379 "Orientation.c"
		{
#line 103 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 103 "../src/Orientation.vala"
			return result;
#line 385 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 389 "Orientation.c"
		{
#line 106 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 106 "../src/Orientation.vala"
			return result;
#line 395 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 399 "Orientation.c"
		{
#line 109 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 109 "../src/Orientation.vala"
			return result;
#line 405 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 409 "Orientation.c"
		{
#line 112 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 112 "../src/Orientation.vala"
			return result;
#line 415 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 419 "Orientation.c"
		{
#line 115 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 115 "../src/Orientation.vala"
			return result;
#line 425 "Orientation.c"
		}
#line 95 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 429 "Orientation.c"
		{
#line 118 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 118 "../src/Orientation.vala"
			return result;
#line 435 "Orientation.c"
		}
		default:
		{
#line 121 "../src/Orientation.vala"
			g_error ("Orientation.vala:121: rotate_counterclockwise: %d", (gint) self);
#line 441 "Orientation.c"
		}
	}
}

Orientation
orientation_flip_top_to_bottom (Orientation self)
{
	Orientation result = 0;
#line 126 "../src/Orientation.vala"
	switch (self) {
#line 126 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 454 "Orientation.c"
		{
#line 128 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 128 "../src/Orientation.vala"
			return result;
#line 460 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 464 "Orientation.c"
		{
#line 131 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 131 "../src/Orientation.vala"
			return result;
#line 470 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 474 "Orientation.c"
		{
#line 134 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 134 "../src/Orientation.vala"
			return result;
#line 480 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 484 "Orientation.c"
		{
#line 137 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 137 "../src/Orientation.vala"
			return result;
#line 490 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 494 "Orientation.c"
		{
#line 140 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 140 "../src/Orientation.vala"
			return result;
#line 500 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 504 "Orientation.c"
		{
#line 143 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 143 "../src/Orientation.vala"
			return result;
#line 510 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 514 "Orientation.c"
		{
#line 146 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 146 "../src/Orientation.vala"
			return result;
#line 520 "Orientation.c"
		}
#line 126 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 524 "Orientation.c"
		{
#line 149 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 149 "../src/Orientation.vala"
			return result;
#line 530 "Orientation.c"
		}
		default:
		{
#line 152 "../src/Orientation.vala"
			g_error ("Orientation.vala:152: flip_top_to_bottom: %d", (gint) self);
#line 536 "Orientation.c"
		}
	}
}

Orientation
orientation_flip_left_to_right (Orientation self)
{
	Orientation result = 0;
#line 157 "../src/Orientation.vala"
	switch (self) {
#line 157 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 549 "Orientation.c"
		{
#line 159 "../src/Orientation.vala"
			result = ORIENTATION_TOP_RIGHT;
#line 159 "../src/Orientation.vala"
			return result;
#line 555 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 559 "Orientation.c"
		{
#line 162 "../src/Orientation.vala"
			result = ORIENTATION_TOP_LEFT;
#line 162 "../src/Orientation.vala"
			return result;
#line 565 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 569 "Orientation.c"
		{
#line 165 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_LEFT;
#line 165 "../src/Orientation.vala"
			return result;
#line 575 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 579 "Orientation.c"
		{
#line 168 "../src/Orientation.vala"
			result = ORIENTATION_BOTTOM_RIGHT;
#line 168 "../src/Orientation.vala"
			return result;
#line 585 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 589 "Orientation.c"
		{
#line 171 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_TOP;
#line 171 "../src/Orientation.vala"
			return result;
#line 595 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 599 "Orientation.c"
		{
#line 174 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_TOP;
#line 174 "../src/Orientation.vala"
			return result;
#line 605 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 609 "Orientation.c"
		{
#line 177 "../src/Orientation.vala"
			result = ORIENTATION_LEFT_BOTTOM;
#line 177 "../src/Orientation.vala"
			return result;
#line 615 "Orientation.c"
		}
#line 157 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 619 "Orientation.c"
		{
#line 180 "../src/Orientation.vala"
			result = ORIENTATION_RIGHT_BOTTOM;
#line 180 "../src/Orientation.vala"
			return result;
#line 625 "Orientation.c"
		}
		default:
		{
#line 183 "../src/Orientation.vala"
			g_error ("Orientation.vala:183: flip_left_to_right: %d", (gint) self);
#line 631 "Orientation.c"
		}
	}
}

Orientation
orientation_perform (Orientation self,
                     Rotation rotation)
{
	Orientation result = 0;
#line 188 "../src/Orientation.vala"
	switch (rotation) {
#line 188 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 645 "Orientation.c"
		{
#line 190 "../src/Orientation.vala"
			result = orientation_rotate_clockwise (self);
#line 190 "../src/Orientation.vala"
			return result;
#line 651 "Orientation.c"
		}
#line 188 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 655 "Orientation.c"
		{
#line 193 "../src/Orientation.vala"
			result = orientation_rotate_counterclockwise (self);
#line 193 "../src/Orientation.vala"
			return result;
#line 661 "Orientation.c"
		}
#line 188 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 665 "Orientation.c"
		{
#line 196 "../src/Orientation.vala"
			result = orientation_flip_left_to_right (self);
#line 196 "../src/Orientation.vala"
			return result;
#line 671 "Orientation.c"
		}
#line 188 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 675 "Orientation.c"
		{
#line 199 "../src/Orientation.vala"
			result = orientation_flip_top_to_bottom (self);
#line 199 "../src/Orientation.vala"
			return result;
#line 681 "Orientation.c"
		}
		default:
		{
#line 202 "../src/Orientation.vala"
			g_error ("Orientation.vala:202: perform: %d", (gint) rotation);
#line 687 "Orientation.c"
		}
	}
}

Rotation*
orientation_to_rotations (Orientation self,
                          gint* result_length1)
{
	Rotation* result = NULL;
#line 207 "../src/Orientation.vala"
	switch (self) {
#line 207 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 701 "Orientation.c"
		{
			Rotation* _tmp0_;
			Rotation* _tmp1_;
			gint _tmp1__length1;
#line 210 "../src/Orientation.vala"
			_tmp0_ = g_new0 (Rotation, 0);
#line 210 "../src/Orientation.vala"
			_tmp1_ = _tmp0_;
#line 210 "../src/Orientation.vala"
			_tmp1__length1 = 0;
#line 210 "../src/Orientation.vala"
			if (result_length1) {
#line 210 "../src/Orientation.vala"
				*result_length1 = _tmp1__length1;
#line 716 "Orientation.c"
			}
#line 210 "../src/Orientation.vala"
			result = _tmp1_;
#line 210 "../src/Orientation.vala"
			return result;
#line 722 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 726 "Orientation.c"
		{
			Rotation* _tmp2_;
			Rotation* _tmp3_;
			gint _tmp3__length1;
#line 213 "../src/Orientation.vala"
			_tmp2_ = g_new0 (Rotation, 1);
#line 213 "../src/Orientation.vala"
			_tmp2_[0] = ROTATION_MIRROR;
#line 213 "../src/Orientation.vala"
			_tmp3_ = _tmp2_;
#line 213 "../src/Orientation.vala"
			_tmp3__length1 = 1;
#line 213 "../src/Orientation.vala"
			if (result_length1) {
#line 213 "../src/Orientation.vala"
				*result_length1 = _tmp3__length1;
#line 743 "Orientation.c"
			}
#line 213 "../src/Orientation.vala"
			result = _tmp3_;
#line 213 "../src/Orientation.vala"
			return result;
#line 749 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 753 "Orientation.c"
		{
			Rotation* _tmp4_;
			Rotation* _tmp5_;
			gint _tmp5__length1;
#line 216 "../src/Orientation.vala"
			_tmp4_ = g_new0 (Rotation, 1);
#line 216 "../src/Orientation.vala"
			_tmp4_[0] = ROTATION_UPSIDE_DOWN;
#line 216 "../src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 216 "../src/Orientation.vala"
			_tmp5__length1 = 1;
#line 216 "../src/Orientation.vala"
			if (result_length1) {
#line 216 "../src/Orientation.vala"
				*result_length1 = _tmp5__length1;
#line 770 "Orientation.c"
			}
#line 216 "../src/Orientation.vala"
			result = _tmp5_;
#line 216 "../src/Orientation.vala"
			return result;
#line 776 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 780 "Orientation.c"
		{
			Rotation* _tmp6_;
			Rotation* _tmp7_;
			gint _tmp7__length1;
#line 220 "../src/Orientation.vala"
			_tmp6_ = g_new0 (Rotation, 2);
#line 220 "../src/Orientation.vala"
			_tmp6_[0] = ROTATION_MIRROR;
#line 220 "../src/Orientation.vala"
			_tmp6_[1] = ROTATION_UPSIDE_DOWN;
#line 220 "../src/Orientation.vala"
			_tmp7_ = _tmp6_;
#line 220 "../src/Orientation.vala"
			_tmp7__length1 = 2;
#line 220 "../src/Orientation.vala"
			if (result_length1) {
#line 220 "../src/Orientation.vala"
				*result_length1 = _tmp7__length1;
#line 799 "Orientation.c"
			}
#line 220 "../src/Orientation.vala"
			result = _tmp7_;
#line 220 "../src/Orientation.vala"
			return result;
#line 805 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 809 "Orientation.c"
		{
			Rotation* _tmp8_;
			Rotation* _tmp9_;
			gint _tmp9__length1;
#line 223 "../src/Orientation.vala"
			_tmp8_ = g_new0 (Rotation, 2);
#line 223 "../src/Orientation.vala"
			_tmp8_[0] = ROTATION_COUNTERCLOCKWISE;
#line 223 "../src/Orientation.vala"
			_tmp8_[1] = ROTATION_UPSIDE_DOWN;
#line 223 "../src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 223 "../src/Orientation.vala"
			_tmp9__length1 = 2;
#line 223 "../src/Orientation.vala"
			if (result_length1) {
#line 223 "../src/Orientation.vala"
				*result_length1 = _tmp9__length1;
#line 828 "Orientation.c"
			}
#line 223 "../src/Orientation.vala"
			result = _tmp9_;
#line 223 "../src/Orientation.vala"
			return result;
#line 834 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 838 "Orientation.c"
		{
			Rotation* _tmp10_;
			Rotation* _tmp11_;
			gint _tmp11__length1;
#line 226 "../src/Orientation.vala"
			_tmp10_ = g_new0 (Rotation, 1);
#line 226 "../src/Orientation.vala"
			_tmp10_[0] = ROTATION_CLOCKWISE;
#line 226 "../src/Orientation.vala"
			_tmp11_ = _tmp10_;
#line 226 "../src/Orientation.vala"
			_tmp11__length1 = 1;
#line 226 "../src/Orientation.vala"
			if (result_length1) {
#line 226 "../src/Orientation.vala"
				*result_length1 = _tmp11__length1;
#line 855 "Orientation.c"
			}
#line 226 "../src/Orientation.vala"
			result = _tmp11_;
#line 226 "../src/Orientation.vala"
			return result;
#line 861 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 865 "Orientation.c"
		{
			Rotation* _tmp12_;
			Rotation* _tmp13_;
			gint _tmp13__length1;
#line 229 "../src/Orientation.vala"
			_tmp12_ = g_new0 (Rotation, 2);
#line 229 "../src/Orientation.vala"
			_tmp12_[0] = ROTATION_CLOCKWISE;
#line 229 "../src/Orientation.vala"
			_tmp12_[1] = ROTATION_UPSIDE_DOWN;
#line 229 "../src/Orientation.vala"
			_tmp13_ = _tmp12_;
#line 229 "../src/Orientation.vala"
			_tmp13__length1 = 2;
#line 229 "../src/Orientation.vala"
			if (result_length1) {
#line 229 "../src/Orientation.vala"
				*result_length1 = _tmp13__length1;
#line 884 "Orientation.c"
			}
#line 229 "../src/Orientation.vala"
			result = _tmp13_;
#line 229 "../src/Orientation.vala"
			return result;
#line 890 "Orientation.c"
		}
#line 207 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 894 "Orientation.c"
		{
			Rotation* _tmp14_;
			Rotation* _tmp15_;
			gint _tmp15__length1;
#line 232 "../src/Orientation.vala"
			_tmp14_ = g_new0 (Rotation, 1);
#line 232 "../src/Orientation.vala"
			_tmp14_[0] = ROTATION_COUNTERCLOCKWISE;
#line 232 "../src/Orientation.vala"
			_tmp15_ = _tmp14_;
#line 232 "../src/Orientation.vala"
			_tmp15__length1 = 1;
#line 232 "../src/Orientation.vala"
			if (result_length1) {
#line 232 "../src/Orientation.vala"
				*result_length1 = _tmp15__length1;
#line 911 "Orientation.c"
			}
#line 232 "../src/Orientation.vala"
			result = _tmp15_;
#line 232 "../src/Orientation.vala"
			return result;
#line 917 "Orientation.c"
		}
		default:
		{
#line 235 "../src/Orientation.vala"
			g_error ("Orientation.vala:235: to_rotations: %d", (gint) self);
#line 923 "Orientation.c"
		}
	}
}

void
orientation_rotate_dimensions (Orientation self,
                               Dimensions* dim,
                               Dimensions* result)
{
#line 239 "../src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 240 "../src/Orientation.vala"
	switch (self) {
#line 240 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 945 "Orientation.c"
		{
			Dimensions _tmp0_;
#line 246 "../src/Orientation.vala"
			_tmp0_ = *dim;
#line 246 "../src/Orientation.vala"
			*result = _tmp0_;
#line 246 "../src/Orientation.vala"
			return;
#line 954 "Orientation.c"
		}
#line 240 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 240 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 964 "Orientation.c"
		{
			Dimensions _tmp1_;
			Dimensions _tmp2_;
			Dimensions _tmp3_ = {0};
#line 253 "../src/Orientation.vala"
			_tmp1_ = *dim;
#line 253 "../src/Orientation.vala"
			_tmp2_ = *dim;
#line 253 "../src/Orientation.vala"
			dimensions_init (&_tmp3_, _tmp1_.height, _tmp2_.width);
#line 253 "../src/Orientation.vala"
			*result = _tmp3_;
#line 253 "../src/Orientation.vala"
			return;
#line 979 "Orientation.c"
		}
		default:
		{
#line 256 "../src/Orientation.vala"
			g_error ("Orientation.vala:256: rotate_dimensions: %d", (gint) self);
#line 985 "Orientation.c"
		}
	}
}

void
orientation_derotate_dimensions (Orientation self,
                                 Dimensions* dim,
                                 Dimensions* result)
{
	Dimensions _tmp0_;
	Dimensions _tmp1_ = {0};
#line 260 "../src/Orientation.vala"
	g_return_if_fail (dim != NULL);
#line 261 "../src/Orientation.vala"
	_tmp0_ = *dim;
#line 261 "../src/Orientation.vala"
	orientation_rotate_dimensions (self, &_tmp0_, &_tmp1_);
#line 261 "../src/Orientation.vala"
	*result = _tmp1_;
#line 261 "../src/Orientation.vala"
	return;
#line 1007 "Orientation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 269 "../src/Orientation.vala"
	return self ? g_object_ref (self) : NULL;
#line 1015 "Orientation.c"
}

GdkPixbuf*
orientation_rotate_pixbuf (Orientation self,
                           GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* rotated = NULL;
#line 264 "../src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 266 "../src/Orientation.vala"
	switch (self) {
#line 266 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1030 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 269 "../src/Orientation.vala"
			_tmp0_ = _g_object_ref0 (pixbuf);
#line 269 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 269 "../src/Orientation.vala"
			rotated = _tmp0_;
#line 270 "../src/Orientation.vala"
			break;
#line 1041 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1045 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 274 "../src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 274 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 274 "../src/Orientation.vala"
			rotated = _tmp1_;
#line 275 "../src/Orientation.vala"
			break;
#line 1056 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1060 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 278 "../src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN);
#line 278 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 278 "../src/Orientation.vala"
			rotated = _tmp2_;
#line 279 "../src/Orientation.vala"
			break;
#line 1071 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1075 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 283 "../src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 283 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 283 "../src/Orientation.vala"
			rotated = _tmp3_;
#line 284 "../src/Orientation.vala"
			break;
#line 1086 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1090 "Orientation.c"
		{
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 287 "../src/Orientation.vala"
			_tmp4_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 287 "../src/Orientation.vala"
			_tmp5_ = _tmp4_;
#line 287 "../src/Orientation.vala"
			_tmp6_ = gdk_pixbuf_flip (_tmp5_, FALSE);
#line 287 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 287 "../src/Orientation.vala"
			rotated = _tmp6_;
#line 287 "../src/Orientation.vala"
			_g_object_unref0 (_tmp5_);
#line 288 "../src/Orientation.vala"
			break;
#line 1109 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1113 "Orientation.c"
		{
			GdkPixbuf* _tmp7_;
#line 291 "../src/Orientation.vala"
			_tmp7_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 291 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 291 "../src/Orientation.vala"
			rotated = _tmp7_;
#line 292 "../src/Orientation.vala"
			break;
#line 1124 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1128 "Orientation.c"
		{
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
#line 295 "../src/Orientation.vala"
			_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 295 "../src/Orientation.vala"
			_tmp9_ = _tmp8_;
#line 295 "../src/Orientation.vala"
			_tmp10_ = gdk_pixbuf_flip (_tmp9_, FALSE);
#line 295 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 295 "../src/Orientation.vala"
			rotated = _tmp10_;
#line 295 "../src/Orientation.vala"
			_g_object_unref0 (_tmp9_);
#line 296 "../src/Orientation.vala"
			break;
#line 1147 "Orientation.c"
		}
#line 266 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1151 "Orientation.c"
		{
			GdkPixbuf* _tmp11_;
#line 299 "../src/Orientation.vala"
			_tmp11_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 299 "../src/Orientation.vala"
			_g_object_unref0 (rotated);
#line 299 "../src/Orientation.vala"
			rotated = _tmp11_;
#line 300 "../src/Orientation.vala"
			break;
#line 1162 "Orientation.c"
		}
		default:
		{
#line 303 "../src/Orientation.vala"
			g_error ("Orientation.vala:303: rotate_pixbuf: %d", (gint) self);
#line 1168 "Orientation.c"
		}
	}
#line 306 "../src/Orientation.vala"
	result = rotated;
#line 306 "../src/Orientation.vala"
	return result;
#line 1175 "Orientation.c"
}

void
orientation_rotate_point (Orientation self,
                          Dimensions* space,
                          GdkPoint* point,
                          GdkPoint* result)
{
	GdkPoint _tmp0_;
	GdkPoint _tmp1_;
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_;
	Dimensions _tmp5_;
	GdkPoint rotated = {0};
#line 310 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 310 "../src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 311 "../src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area ()");
#line 312 "../src/Orientation.vala"
	_tmp0_ = *point;
#line 312 "../src/Orientation.vala"
	_vala_assert (_tmp0_.x >= 0, "point.x >= 0");
#line 313 "../src/Orientation.vala"
	_tmp1_ = *point;
#line 313 "../src/Orientation.vala"
	_tmp2_ = *space;
#line 313 "../src/Orientation.vala"
	_vala_assert (_tmp1_.x < _tmp2_.width, "point.x < space.width");
#line 314 "../src/Orientation.vala"
	_tmp3_ = *point;
#line 314 "../src/Orientation.vala"
	_vala_assert (_tmp3_.y >= 0, "point.y >= 0");
#line 315 "../src/Orientation.vala"
	_tmp4_ = *point;
#line 315 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 315 "../src/Orientation.vala"
	_vala_assert (_tmp4_.y < _tmp5_.height, "point.y < space.height");
#line 317 "../src/Orientation.vala"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 319 "../src/Orientation.vala"
	switch (self) {
#line 319 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1223 "Orientation.c"
		{
			GdkPoint _tmp6_;
#line 322 "../src/Orientation.vala"
			_tmp6_ = *point;
#line 322 "../src/Orientation.vala"
			rotated = _tmp6_;
#line 323 "../src/Orientation.vala"
			break;
#line 1232 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1236 "Orientation.c"
		{
			Dimensions _tmp7_;
			GdkPoint _tmp8_;
			GdkPoint _tmp9_;
#line 327 "../src/Orientation.vala"
			_tmp7_ = *space;
#line 327 "../src/Orientation.vala"
			_tmp8_ = *point;
#line 327 "../src/Orientation.vala"
			rotated.x = (_tmp7_.width - _tmp8_.x) - 1;
#line 328 "../src/Orientation.vala"
			_tmp9_ = *point;
#line 328 "../src/Orientation.vala"
			rotated.y = _tmp9_.y;
#line 329 "../src/Orientation.vala"
			break;
#line 1253 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1257 "Orientation.c"
		{
			Dimensions _tmp10_;
			GdkPoint _tmp11_;
			Dimensions _tmp12_;
			GdkPoint _tmp13_;
#line 333 "../src/Orientation.vala"
			_tmp10_ = *space;
#line 333 "../src/Orientation.vala"
			_tmp11_ = *point;
#line 333 "../src/Orientation.vala"
			rotated.x = (_tmp10_.width - _tmp11_.x) - 1;
#line 334 "../src/Orientation.vala"
			_tmp12_ = *space;
#line 334 "../src/Orientation.vala"
			_tmp13_ = *point;
#line 334 "../src/Orientation.vala"
			rotated.y = (_tmp12_.height - _tmp13_.y) - 1;
#line 335 "../src/Orientation.vala"
			break;
#line 1277 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1281 "Orientation.c"
		{
			GdkPoint _tmp14_;
			Dimensions _tmp15_;
			GdkPoint _tmp16_;
#line 339 "../src/Orientation.vala"
			_tmp14_ = *point;
#line 339 "../src/Orientation.vala"
			rotated.x = _tmp14_.x;
#line 340 "../src/Orientation.vala"
			_tmp15_ = *space;
#line 340 "../src/Orientation.vala"
			_tmp16_ = *point;
#line 340 "../src/Orientation.vala"
			rotated.y = (_tmp15_.height - _tmp16_.y) - 1;
#line 341 "../src/Orientation.vala"
			break;
#line 1298 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1302 "Orientation.c"
		{
			GdkPoint _tmp17_;
			GdkPoint _tmp18_;
#line 345 "../src/Orientation.vala"
			_tmp17_ = *point;
#line 345 "../src/Orientation.vala"
			rotated.x = _tmp17_.y;
#line 346 "../src/Orientation.vala"
			_tmp18_ = *point;
#line 346 "../src/Orientation.vala"
			rotated.y = _tmp18_.x;
#line 347 "../src/Orientation.vala"
			break;
#line 1316 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1320 "Orientation.c"
		{
			Dimensions _tmp19_;
			GdkPoint _tmp20_;
			GdkPoint _tmp21_;
#line 351 "../src/Orientation.vala"
			_tmp19_ = *space;
#line 351 "../src/Orientation.vala"
			_tmp20_ = *point;
#line 351 "../src/Orientation.vala"
			rotated.x = (_tmp19_.height - _tmp20_.y) - 1;
#line 352 "../src/Orientation.vala"
			_tmp21_ = *point;
#line 352 "../src/Orientation.vala"
			rotated.y = _tmp21_.x;
#line 353 "../src/Orientation.vala"
			break;
#line 1337 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1341 "Orientation.c"
		{
			Dimensions _tmp22_;
			GdkPoint _tmp23_;
			Dimensions _tmp24_;
			GdkPoint _tmp25_;
#line 357 "../src/Orientation.vala"
			_tmp22_ = *space;
#line 357 "../src/Orientation.vala"
			_tmp23_ = *point;
#line 357 "../src/Orientation.vala"
			rotated.x = (_tmp22_.height - _tmp23_.y) - 1;
#line 358 "../src/Orientation.vala"
			_tmp24_ = *space;
#line 358 "../src/Orientation.vala"
			_tmp25_ = *point;
#line 358 "../src/Orientation.vala"
			rotated.y = (_tmp24_.width - _tmp25_.x) - 1;
#line 359 "../src/Orientation.vala"
			break;
#line 1361 "Orientation.c"
		}
#line 319 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1365 "Orientation.c"
		{
			GdkPoint _tmp26_;
			Dimensions _tmp27_;
			GdkPoint _tmp28_;
#line 363 "../src/Orientation.vala"
			_tmp26_ = *point;
#line 363 "../src/Orientation.vala"
			rotated.x = _tmp26_.y;
#line 364 "../src/Orientation.vala"
			_tmp27_ = *space;
#line 364 "../src/Orientation.vala"
			_tmp28_ = *point;
#line 364 "../src/Orientation.vala"
			rotated.y = (_tmp27_.width - _tmp28_.x) - 1;
#line 365 "../src/Orientation.vala"
			break;
#line 1382 "Orientation.c"
		}
		default:
		{
#line 368 "../src/Orientation.vala"
			g_error ("Orientation.vala:368: rotate_point: %d", (gint) self);
#line 1388 "Orientation.c"
		}
	}
#line 371 "../src/Orientation.vala"
	*result = rotated;
#line 371 "../src/Orientation.vala"
	return;
#line 1395 "Orientation.c"
}

void
orientation_derotate_point (Orientation self,
                            Dimensions* space,
                            GdkPoint* point,
                            GdkPoint* result)
{
	GdkPoint derotated = {0};
#line 375 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 375 "../src/Orientation.vala"
	g_return_if_fail (point != NULL);
#line 376 "../src/Orientation.vala"
	_vala_assert (dimensions_has_area (space), "space.has_area ()");
#line 378 "../src/Orientation.vala"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 380 "../src/Orientation.vala"
	switch (self) {
#line 380 "../src/Orientation.vala"
		case ORIENTATION_TOP_LEFT:
#line 1417 "Orientation.c"
		{
			GdkPoint _tmp0_;
#line 383 "../src/Orientation.vala"
			_tmp0_ = *point;
#line 383 "../src/Orientation.vala"
			derotated = _tmp0_;
#line 384 "../src/Orientation.vala"
			break;
#line 1426 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_TOP_RIGHT:
#line 1430 "Orientation.c"
		{
			Dimensions _tmp1_;
			GdkPoint _tmp2_;
			GdkPoint _tmp3_;
#line 388 "../src/Orientation.vala"
			_tmp1_ = *space;
#line 388 "../src/Orientation.vala"
			_tmp2_ = *point;
#line 388 "../src/Orientation.vala"
			derotated.x = (_tmp1_.width - _tmp2_.x) - 1;
#line 389 "../src/Orientation.vala"
			_tmp3_ = *point;
#line 389 "../src/Orientation.vala"
			derotated.y = _tmp3_.y;
#line 390 "../src/Orientation.vala"
			break;
#line 1447 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_RIGHT:
#line 1451 "Orientation.c"
		{
			Dimensions _tmp4_;
			GdkPoint _tmp5_;
			Dimensions _tmp6_;
			GdkPoint _tmp7_;
#line 394 "../src/Orientation.vala"
			_tmp4_ = *space;
#line 394 "../src/Orientation.vala"
			_tmp5_ = *point;
#line 394 "../src/Orientation.vala"
			derotated.x = (_tmp4_.width - _tmp5_.x) - 1;
#line 395 "../src/Orientation.vala"
			_tmp6_ = *space;
#line 395 "../src/Orientation.vala"
			_tmp7_ = *point;
#line 395 "../src/Orientation.vala"
			derotated.y = (_tmp6_.height - _tmp7_.y) - 1;
#line 396 "../src/Orientation.vala"
			break;
#line 1471 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_BOTTOM_LEFT:
#line 1475 "Orientation.c"
		{
			GdkPoint _tmp8_;
			Dimensions _tmp9_;
			GdkPoint _tmp10_;
#line 400 "../src/Orientation.vala"
			_tmp8_ = *point;
#line 400 "../src/Orientation.vala"
			derotated.x = _tmp8_.x;
#line 401 "../src/Orientation.vala"
			_tmp9_ = *space;
#line 401 "../src/Orientation.vala"
			_tmp10_ = *point;
#line 401 "../src/Orientation.vala"
			derotated.y = (_tmp9_.height - _tmp10_.y) - 1;
#line 402 "../src/Orientation.vala"
			break;
#line 1492 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_LEFT_TOP:
#line 1496 "Orientation.c"
		{
			GdkPoint _tmp11_;
			GdkPoint _tmp12_;
#line 406 "../src/Orientation.vala"
			_tmp11_ = *point;
#line 406 "../src/Orientation.vala"
			derotated.x = _tmp11_.y;
#line 407 "../src/Orientation.vala"
			_tmp12_ = *point;
#line 407 "../src/Orientation.vala"
			derotated.y = _tmp12_.x;
#line 408 "../src/Orientation.vala"
			break;
#line 1510 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_TOP:
#line 1514 "Orientation.c"
		{
			GdkPoint _tmp13_;
			Dimensions _tmp14_;
			GdkPoint _tmp15_;
#line 412 "../src/Orientation.vala"
			_tmp13_ = *point;
#line 412 "../src/Orientation.vala"
			derotated.x = _tmp13_.y;
#line 413 "../src/Orientation.vala"
			_tmp14_ = *space;
#line 413 "../src/Orientation.vala"
			_tmp15_ = *point;
#line 413 "../src/Orientation.vala"
			derotated.y = (_tmp14_.height - _tmp15_.x) - 1;
#line 414 "../src/Orientation.vala"
			break;
#line 1531 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_RIGHT_BOTTOM:
#line 1535 "Orientation.c"
		{
			Dimensions _tmp16_;
			GdkPoint _tmp17_;
			Dimensions _tmp18_;
			GdkPoint _tmp19_;
#line 418 "../src/Orientation.vala"
			_tmp16_ = *space;
#line 418 "../src/Orientation.vala"
			_tmp17_ = *point;
#line 418 "../src/Orientation.vala"
			derotated.x = (_tmp16_.width - _tmp17_.y) - 1;
#line 419 "../src/Orientation.vala"
			_tmp18_ = *space;
#line 419 "../src/Orientation.vala"
			_tmp19_ = *point;
#line 419 "../src/Orientation.vala"
			derotated.y = (_tmp18_.height - _tmp19_.x) - 1;
#line 420 "../src/Orientation.vala"
			break;
#line 1555 "Orientation.c"
		}
#line 380 "../src/Orientation.vala"
		case ORIENTATION_LEFT_BOTTOM:
#line 1559 "Orientation.c"
		{
			Dimensions _tmp20_;
			GdkPoint _tmp21_;
			GdkPoint _tmp22_;
#line 424 "../src/Orientation.vala"
			_tmp20_ = *space;
#line 424 "../src/Orientation.vala"
			_tmp21_ = *point;
#line 424 "../src/Orientation.vala"
			derotated.x = (_tmp20_.width - _tmp21_.y) - 1;
#line 425 "../src/Orientation.vala"
			_tmp22_ = *point;
#line 425 "../src/Orientation.vala"
			derotated.y = _tmp22_.x;
#line 426 "../src/Orientation.vala"
			break;
#line 1576 "Orientation.c"
		}
		default:
		{
#line 429 "../src/Orientation.vala"
			g_error ("Orientation.vala:429: rotate_point: %d", (gint) self);
#line 1582 "Orientation.c"
		}
	}
#line 432 "../src/Orientation.vala"
	*result = derotated;
#line 432 "../src/Orientation.vala"
	return;
#line 1589 "Orientation.c"
}

void
orientation_rotate_box (Orientation self,
                        Dimensions* space,
                        Box* box,
                        Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_;
	Dimensions _tmp3_;
	GdkPoint _tmp4_;
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	Dimensions _tmp7_;
	GdkPoint _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	GdkPoint _tmp11_;
	GdkPoint _tmp12_ = {0};
	Dimensions _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	Box _tmp18_ = {0};
#line 436 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 436 "../src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 438 "../src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 438 "../src/Orientation.vala"
	top_left = _tmp0_;
#line 438 "../src/Orientation.vala"
	bottom_right = _tmp1_;
#line 440 "../src/Orientation.vala"
	_tmp2_ = top_left;
#line 440 "../src/Orientation.vala"
	_tmp3_ = *space;
#line 440 "../src/Orientation.vala"
	top_left.x = CLAMP (_tmp2_.x, 0, _tmp3_.width - 1);
#line 441 "../src/Orientation.vala"
	_tmp4_ = top_left;
#line 441 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 441 "../src/Orientation.vala"
	top_left.y = CLAMP (_tmp4_.y, 0, _tmp5_.height - 1);
#line 443 "../src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 443 "../src/Orientation.vala"
	_tmp7_ = *space;
#line 443 "../src/Orientation.vala"
	bottom_right.x = CLAMP (_tmp6_.x, 0, _tmp7_.width - 1);
#line 444 "../src/Orientation.vala"
	_tmp8_ = bottom_right;
#line 444 "../src/Orientation.vala"
	_tmp9_ = *space;
#line 444 "../src/Orientation.vala"
	bottom_right.y = CLAMP (_tmp8_.y, 0, _tmp9_.height - 1);
#line 446 "../src/Orientation.vala"
	_tmp10_ = *space;
#line 446 "../src/Orientation.vala"
	_tmp11_ = top_left;
#line 446 "../src/Orientation.vala"
	orientation_rotate_point (self, &_tmp10_, &_tmp11_, &_tmp12_);
#line 446 "../src/Orientation.vala"
	top_left = _tmp12_;
#line 447 "../src/Orientation.vala"
	_tmp13_ = *space;
#line 447 "../src/Orientation.vala"
	_tmp14_ = bottom_right;
#line 447 "../src/Orientation.vala"
	orientation_rotate_point (self, &_tmp13_, &_tmp14_, &_tmp15_);
#line 447 "../src/Orientation.vala"
	bottom_right = _tmp15_;
#line 449 "../src/Orientation.vala"
	_tmp16_ = top_left;
#line 449 "../src/Orientation.vala"
	_tmp17_ = bottom_right;
#line 449 "../src/Orientation.vala"
	box_from_points (&_tmp16_, &_tmp17_, &_tmp18_);
#line 449 "../src/Orientation.vala"
	*result = _tmp18_;
#line 449 "../src/Orientation.vala"
	return;
#line 1679 "Orientation.c"
}

void
orientation_derotate_box (Orientation self,
                          Dimensions* space,
                          Box* box,
                          Box* result)
{
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Dimensions _tmp2_;
	GdkPoint _tmp3_;
	GdkPoint _tmp4_ = {0};
	Dimensions _tmp5_;
	GdkPoint _tmp6_;
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_;
	GdkPoint _tmp9_;
	Box _tmp10_ = {0};
#line 453 "../src/Orientation.vala"
	g_return_if_fail (space != NULL);
#line 453 "../src/Orientation.vala"
	g_return_if_fail (box != NULL);
#line 455 "../src/Orientation.vala"
	box_get_points (box, &_tmp0_, &_tmp1_);
#line 455 "../src/Orientation.vala"
	top_left = _tmp0_;
#line 455 "../src/Orientation.vala"
	bottom_right = _tmp1_;
#line 457 "../src/Orientation.vala"
	_tmp2_ = *space;
#line 457 "../src/Orientation.vala"
	_tmp3_ = top_left;
#line 457 "../src/Orientation.vala"
	orientation_derotate_point (self, &_tmp2_, &_tmp3_, &_tmp4_);
#line 457 "../src/Orientation.vala"
	top_left = _tmp4_;
#line 458 "../src/Orientation.vala"
	_tmp5_ = *space;
#line 458 "../src/Orientation.vala"
	_tmp6_ = bottom_right;
#line 458 "../src/Orientation.vala"
	orientation_derotate_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 458 "../src/Orientation.vala"
	bottom_right = _tmp7_;
#line 460 "../src/Orientation.vala"
	_tmp8_ = top_left;
#line 460 "../src/Orientation.vala"
	_tmp9_ = bottom_right;
#line 460 "../src/Orientation.vala"
	box_from_points (&_tmp8_, &_tmp9_, &_tmp10_);
#line 460 "../src/Orientation.vala"
	*result = _tmp10_;
#line 460 "../src/Orientation.vala"
	return;
#line 1737 "Orientation.c"
}

GType
orientation_get_type (void)
{
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}

GdkPixbuf*
rotation_perform (Rotation self,
                  GdkPixbuf* pixbuf)
{
	GdkPixbuf* result = NULL;
#line 470 "../src/Orientation.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 471 "../src/Orientation.vala"
	switch (self) {
#line 471 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1764 "Orientation.c"
		{
			GdkPixbuf* _tmp0_;
#line 473 "../src/Orientation.vala"
			_tmp0_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE);
#line 473 "../src/Orientation.vala"
			result = _tmp0_;
#line 473 "../src/Orientation.vala"
			return result;
#line 1773 "Orientation.c"
		}
#line 471 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1777 "Orientation.c"
		{
			GdkPixbuf* _tmp1_;
#line 476 "../src/Orientation.vala"
			_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE);
#line 476 "../src/Orientation.vala"
			result = _tmp1_;
#line 476 "../src/Orientation.vala"
			return result;
#line 1786 "Orientation.c"
		}
#line 471 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 1790 "Orientation.c"
		{
			GdkPixbuf* _tmp2_;
#line 479 "../src/Orientation.vala"
			_tmp2_ = gdk_pixbuf_flip (pixbuf, TRUE);
#line 479 "../src/Orientation.vala"
			result = _tmp2_;
#line 479 "../src/Orientation.vala"
			return result;
#line 1799 "Orientation.c"
		}
#line 471 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1803 "Orientation.c"
		{
			GdkPixbuf* _tmp3_;
#line 482 "../src/Orientation.vala"
			_tmp3_ = gdk_pixbuf_flip (pixbuf, FALSE);
#line 482 "../src/Orientation.vala"
			result = _tmp3_;
#line 482 "../src/Orientation.vala"
			return result;
#line 1812 "Orientation.c"
		}
		default:
		{
#line 485 "../src/Orientation.vala"
			g_error ("Orientation.vala:485: Unknown rotation: %d", (gint) self);
#line 1818 "Orientation.c"
		}
	}
}

Rotation
rotation_opposite (Rotation self)
{
	Rotation result = 0;
#line 490 "../src/Orientation.vala"
	switch (self) {
#line 490 "../src/Orientation.vala"
		case ROTATION_CLOCKWISE:
#line 1831 "Orientation.c"
		{
#line 492 "../src/Orientation.vala"
			result = ROTATION_COUNTERCLOCKWISE;
#line 492 "../src/Orientation.vala"
			return result;
#line 1837 "Orientation.c"
		}
#line 490 "../src/Orientation.vala"
		case ROTATION_COUNTERCLOCKWISE:
#line 1841 "Orientation.c"
		{
#line 495 "../src/Orientation.vala"
			result = ROTATION_CLOCKWISE;
#line 495 "../src/Orientation.vala"
			return result;
#line 1847 "Orientation.c"
		}
#line 490 "../src/Orientation.vala"
		case ROTATION_MIRROR:
#line 490 "../src/Orientation.vala"
		case ROTATION_UPSIDE_DOWN:
#line 1853 "Orientation.c"
		{
#line 499 "../src/Orientation.vala"
			result = self;
#line 499 "../src/Orientation.vala"
			return result;
#line 1859 "Orientation.c"
		}
		default:
		{
#line 502 "../src/Orientation.vala"
			g_error ("Orientation.vala:502: Unknown rotation: %d", (gint) self);
#line 1865 "Orientation.c"
		}
	}
}

GType
rotation_get_type (void)
{
	static volatile gsize rotation_type_id__volatile = 0;
	if (g_once_init_enter (&rotation_type_id__volatile)) {
		static const GEnumValue values[] = {{ROTATION_CLOCKWISE, "ROTATION_CLOCKWISE", "clockwise"}, {ROTATION_COUNTERCLOCKWISE, "ROTATION_COUNTERCLOCKWISE", "counterclockwise"}, {ROTATION_MIRROR, "ROTATION_MIRROR", "mirror"}, {ROTATION_UPSIDE_DOWN, "ROTATION_UPSIDE_DOWN", "upside-down"}, {0, NULL, NULL}};
		GType rotation_type_id;
		rotation_type_id = g_enum_register_static ("Rotation", values);
		g_once_init_leave (&rotation_type_id__volatile, rotation_type_id);
	}
	return rotation_type_id__volatile;
}

