/* AbstractSearchRow.c generated by valac 0.44.3, the Vala compiler
 * generated from AbstractSearchRow.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*               2018 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Represents a row-type.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>

#define TYPE_SEARCH_ROW (search_row_get_type ())
#define SEARCH_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_ROW, SearchRow))
#define SEARCH_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_ROW, SearchRowClass))
#define IS_SEARCH_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_ROW))
#define IS_SEARCH_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_ROW))
#define SEARCH_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_ROW, SearchRowClass))

typedef struct _SearchRow SearchRow;
typedef struct _SearchRowClass SearchRowClass;
typedef struct _SearchRowPrivate SearchRowPrivate;

#define TYPE_SEARCH_CONDITION (search_condition_get_type ())
#define SEARCH_CONDITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_CONDITION, SearchCondition))
#define SEARCH_CONDITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_CONDITION, SearchConditionClass))
#define IS_SEARCH_CONDITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_CONDITION))
#define IS_SEARCH_CONDITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_CONDITION))
#define SEARCH_CONDITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_CONDITION, SearchConditionClass))

typedef struct _SearchCondition SearchCondition;
typedef struct _SearchConditionClass SearchConditionClass;

#define TYPE_SEARCH_ROW_CONTAINER (search_row_container_get_type ())
#define SEARCH_ROW_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_ROW_CONTAINER, SearchRowContainer))
#define SEARCH_ROW_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_ROW_CONTAINER, SearchRowContainerClass))
#define IS_SEARCH_ROW_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_ROW_CONTAINER))
#define IS_SEARCH_ROW_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_ROW_CONTAINER))
#define SEARCH_ROW_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_ROW_CONTAINER, SearchRowContainerClass))

typedef struct _SearchRowContainer SearchRowContainer;
typedef struct _SearchRowContainerClass SearchRowContainerClass;
enum  {
	SEARCH_ROW_0_PROPERTY,
	SEARCH_ROW_PARENT_PROPERTY,
	SEARCH_ROW_NUM_PROPERTIES
};
static GParamSpec* search_row_properties[SEARCH_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SearchRow {
	GtkGrid parent_instance;
	SearchRowPrivate * priv;
};

struct _SearchRowClass {
	GtkGridClass parent_class;
	SearchCondition* (*get_search_condition) (SearchRow* self);
	void (*populate) (SearchRow* self, SearchCondition* sc);
	gboolean (*is_complete) (SearchRow* self);
};

struct _SearchRowPrivate {
	SearchRowContainer* _parent;
};

static gint SearchRow_private_offset;
static gpointer search_row_parent_class = NULL;

GType search_row_get_type (void) G_GNUC_CONST;
gpointer search_condition_ref (gpointer instance);
void search_condition_unref (gpointer instance);
GParamSpec* param_spec_search_condition (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void value_set_search_condition (GValue* value,
                                 gpointer v_object);
void value_take_search_condition (GValue* value,
                                  gpointer v_object);
gpointer value_get_search_condition (const GValue* value);
GType search_condition_get_type (void) G_GNUC_CONST;
GType search_row_container_get_type (void) G_GNUC_CONST;
SearchCondition* search_row_get_search_condition (SearchRow* self);
static SearchCondition* search_row_real_get_search_condition (SearchRow* self);
void search_row_populate (SearchRow* self,
                          SearchCondition* sc);
static void search_row_real_populate (SearchRow* self,
                               SearchCondition* sc);
gboolean search_row_is_complete (SearchRow* self);
static gboolean search_row_real_is_complete (SearchRow* self);
SearchRow* search_row_construct (GType object_type);
SearchRowContainer* search_row_get_parent (SearchRow* self);
static void search_row_set_parent (SearchRow* self,
                            SearchRowContainer* value);
static GObject * search_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void search_row_finalize (GObject * obj);
static void _vala_search_row_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_search_row_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
search_row_get_instance_private (SearchRow* self)
{
	return G_STRUCT_MEMBER_P (self, SearchRow_private_offset);
}

static SearchCondition*
search_row_real_get_search_condition (SearchRow* self)
{
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_get_search_condition'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	return NULL;
#line 140 "AbstractSearchRow.c"
}

SearchCondition*
search_row_get_search_condition (SearchRow* self)
{
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/AbstractSearchRow.vala"
	return SEARCH_ROW_GET_CLASS (self)->get_search_condition (self);
#line 150 "AbstractSearchRow.c"
}

static void
search_row_real_populate (SearchRow* self,
                          SearchCondition* sc)
{
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_populate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	return;
#line 161 "AbstractSearchRow.c"
}

void
search_row_populate (SearchRow* self,
                     SearchCondition* sc)
{
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Widgets/AbstractSearchRow.vala"
	SEARCH_ROW_GET_CLASS (self)->populate (self, sc);
#line 172 "AbstractSearchRow.c"
}

static gboolean
search_row_real_is_complete (SearchRow* self)
{
	gboolean _tmp0_ = FALSE;
#line 36 "../src/Widgets/AbstractSearchRow.vala"
	g_critical ("Type `%s' does not implement abstract method `search_row_is_complete'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 36 "../src/Widgets/AbstractSearchRow.vala"
	return _tmp0_;
#line 183 "AbstractSearchRow.c"
}

gboolean
search_row_is_complete (SearchRow* self)
{
#line 36 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/AbstractSearchRow.vala"
	return SEARCH_ROW_GET_CLASS (self)->is_complete (self);
#line 193 "AbstractSearchRow.c"
}

SearchRow*
search_row_construct (GType object_type)
{
	SearchRow * self = NULL;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self = (SearchRow*) g_object_new (object_type, NULL);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	return self;
#line 204 "AbstractSearchRow.c"
}

SearchRowContainer*
search_row_get_parent (SearchRow* self)
{
	SearchRowContainer* result;
	SearchRowContainer* _tmp0_;
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	_tmp0_ = self->priv->_parent;
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	return result;
#line 220 "AbstractSearchRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "AbstractSearchRow.c"
}

static void
search_row_set_parent (SearchRow* self,
                       SearchRowContainer* value)
{
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	if (search_row_get_parent (self) != value) {
#line 239 "AbstractSearchRow.c"
		SearchRowContainer* _tmp0_;
#line 23 "../src/Widgets/AbstractSearchRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/AbstractSearchRow.vala"
		_g_object_unref0 (self->priv->_parent);
#line 23 "../src/Widgets/AbstractSearchRow.vala"
		self->priv->_parent = _tmp0_;
#line 23 "../src/Widgets/AbstractSearchRow.vala"
		g_object_notify_by_pspec ((GObject *) self, search_row_properties[SEARCH_ROW_PARENT_PROPERTY]);
#line 249 "AbstractSearchRow.c"
	}
}

static GObject *
search_row_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SearchRow * self;
#line 25 "../src/Widgets/AbstractSearchRow.vala"
	parent_class = G_OBJECT_CLASS (search_row_parent_class);
#line 25 "../src/Widgets/AbstractSearchRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 25 "../src/Widgets/AbstractSearchRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_ROW, SearchRow);
#line 26 "../src/Widgets/AbstractSearchRow.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 6);
#line 25 "../src/Widgets/AbstractSearchRow.vala"
	return obj;
#line 271 "AbstractSearchRow.c"
}

static void
search_row_class_init (SearchRowClass * klass,
                       gpointer klass_data)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	search_row_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_type_class_adjust_private_offset (klass, &SearchRow_private_offset);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->get_search_condition = (SearchCondition* (*) (SearchRow*)) search_row_real_get_search_condition;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->populate = (void (*) (SearchRow*, SearchCondition*)) search_row_real_populate;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	((SearchRowClass *) klass)->is_complete = (gboolean (*) (SearchRow*)) search_row_real_is_complete;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_search_row_get_property;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_search_row_set_property;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_OBJECT_CLASS (klass)->constructor = search_row_constructor;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_OBJECT_CLASS (klass)->finalize = search_row_finalize;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_ROW_PARENT_PROPERTY, search_row_properties[SEARCH_ROW_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", TYPE_SEARCH_ROW_CONTAINER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 298 "AbstractSearchRow.c"
}

static void
search_row_instance_init (SearchRow * self,
                          gpointer klass)
{
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self->priv = search_row_get_instance_private (self);
#line 307 "AbstractSearchRow.c"
}

static void
search_row_finalize (GObject * obj)
{
	SearchRow * self;
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_ROW, SearchRow);
#line 23 "../src/Widgets/AbstractSearchRow.vala"
	_g_object_unref0 (self->priv->_parent);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	G_OBJECT_CLASS (search_row_parent_class)->finalize (obj);
#line 320 "AbstractSearchRow.c"
}

GType
search_row_get_type (void)
{
	static volatile gsize search_row_type_id__volatile = 0;
	if (g_once_init_enter (&search_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SearchRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchRow), 0, (GInstanceInitFunc) search_row_instance_init, NULL };
		GType search_row_type_id;
		search_row_type_id = g_type_register_static (gtk_grid_get_type (), "SearchRow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		SearchRow_private_offset = g_type_add_instance_private (search_row_type_id, sizeof (SearchRowPrivate));
		g_once_init_leave (&search_row_type_id__volatile, search_row_type_id);
	}
	return search_row_type_id__volatile;
}

static void
_vala_search_row_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	SearchRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SEARCH_ROW, SearchRow);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		case SEARCH_ROW_PARENT_PROPERTY:
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		g_value_set_object (value, search_row_get_parent (self));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		break;
#line 353 "AbstractSearchRow.c"
		default:
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		break;
#line 359 "AbstractSearchRow.c"
	}
}

static void
_vala_search_row_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	SearchRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SEARCH_ROW, SearchRow);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		case SEARCH_ROW_PARENT_PROPERTY:
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		search_row_set_parent (self, g_value_get_object (value));
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		break;
#line 379 "AbstractSearchRow.c"
		default:
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/AbstractSearchRow.vala"
		break;
#line 385 "AbstractSearchRow.c"
	}
}

