/* SliderAssembly.c generated by valac 0.44.3, the Vala compiler
 * generated from SliderAssembly.vala, do not modify */

/* Copyright 2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_SLIDER_ASSEMBLY (slider_assembly_get_type ())
#define SLIDER_ASSEMBLY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLIDER_ASSEMBLY, SliderAssembly))
#define SLIDER_ASSEMBLY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLIDER_ASSEMBLY, SliderAssemblyClass))
#define IS_SLIDER_ASSEMBLY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLIDER_ASSEMBLY))
#define IS_SLIDER_ASSEMBLY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLIDER_ASSEMBLY))
#define SLIDER_ASSEMBLY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLIDER_ASSEMBLY, SliderAssemblyClass))

typedef struct _SliderAssembly SliderAssembly;
typedef struct _SliderAssemblyClass SliderAssemblyClass;
typedef struct _SliderAssemblyPrivate SliderAssemblyPrivate;
enum  {
	SLIDER_ASSEMBLY_0_PROPERTY,
	SLIDER_ASSEMBLY_TOOLTIP_PROPERTY,
	SLIDER_ASSEMBLY_INVERTED_PROPERTY,
	SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY,
	SLIDER_ASSEMBLY_NUM_PROPERTIES
};
static GParamSpec* slider_assembly_properties[SLIDER_ASSEMBLY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SLIDER_ASSEMBLY_VALUE_CHANGED_SIGNAL,
	SLIDER_ASSEMBLY_NUM_SIGNALS
};
static guint slider_assembly_signals[SLIDER_ASSEMBLY_NUM_SIGNALS] = {0};

struct _SliderAssembly {
	GtkGrid parent_instance;
	SliderAssemblyPrivate * priv;
};

struct _SliderAssemblyClass {
	GtkGridClass parent_class;
};

struct _SliderAssemblyPrivate {
	GtkScale* slider;
	GtkEventBox* decrease_box;
	GtkEventBox* increase_box;
	GtkEventBox* active_box;
	guint click_id;
	guint initial_wait_id;
};

static gint SliderAssembly_private_offset;
static gpointer slider_assembly_parent_class = NULL;

GType slider_assembly_get_type (void) G_GNUC_CONST;
SliderAssembly* slider_assembly_new (gdouble min,
                                     gdouble max,
                                     gdouble step,
                                     gdouble initial_val);
SliderAssembly* slider_assembly_construct (GType object_type,
                                           gdouble min,
                                           gdouble max,
                                           gdouble step,
                                           gdouble initial_val);
void slider_assembly_set_slider_value (SliderAssembly* self,
                                       gdouble value);
static void slider_assembly_on_slider_value_changed (SliderAssembly* self);
static gboolean slider_assembly_step_callback (SliderAssembly* self);
void slider_assembly_increase_step (SliderAssembly* self);
void slider_assembly_decrease_step (SliderAssembly* self);
static gboolean slider_assembly_get_inverted (SliderAssembly* self);
static gboolean slider_assembly_on_button_pressed (SliderAssembly* self,
                                            GtkWidget* sender,
                                            GdkEventButton* event);
static void slider_assembly_clear_timeouts (SliderAssembly* self);
static gboolean __lambda20_ (SliderAssembly* self);
static gboolean _slider_assembly_step_callback_gsource_func (gpointer self);
static gboolean ___lambda20__gsource_func (gpointer self);
static gboolean slider_assembly_on_button_released (SliderAssembly* self,
                                             GtkWidget* sender,
                                             GdkEventButton* event);
static void slider_assembly_clear_timeout (guint* id);
void slider_assembly_set_tooltip (SliderAssembly* self,
                                  const gchar* value);
void slider_assembly_set_inverted (SliderAssembly* self,
                                   gboolean value);
gdouble slider_assembly_get_slider_value (SliderAssembly* self);
static GObject * slider_assembly_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
#define RESOURCES_ICON_ZOOM_OUT "zoom-out-symbolic"
static gboolean _slider_assembly_on_button_pressed_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean _slider_assembly_on_button_released_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self);
static gboolean _slider_assembly___lambda21_ (SliderAssembly* self);
static gboolean __slider_assembly___lambda21__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                      GdkEventCrossing* event,
                                                                      gpointer self);
static void _slider_assembly_on_slider_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                       gpointer self);
#define RESOURCES_ICON_ZOOM_IN "zoom-in-symbolic"
static gboolean _slider_assembly___lambda22_ (SliderAssembly* self);
static gboolean __slider_assembly___lambda22__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                      GdkEventCrossing* event,
                                                                      gpointer self);
static void slider_assembly_finalize (GObject * obj);
static void _vala_slider_assembly_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_slider_assembly_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
slider_assembly_get_instance_private (SliderAssembly* self)
{
	return G_STRUCT_MEMBER_P (self, SliderAssembly_private_offset);
}

SliderAssembly*
slider_assembly_construct (GType object_type,
                           gdouble min,
                           gdouble max,
                           gdouble step,
                           gdouble initial_val)
{
	SliderAssembly * self = NULL;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
#line 98 "../src/Widgets/SliderAssembly.vala"
	self = (SliderAssembly*) g_object_new (object_type, NULL);
#line 99 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 99 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_range ((GtkRange*) _tmp0_, min, max);
#line 100 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = self->priv->slider;
#line 100 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_increments ((GtkRange*) _tmp1_, step, step);
#line 101 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_set_slider_value (self, initial_val);
#line 98 "../src/Widgets/SliderAssembly.vala"
	return self;
#line 174 "SliderAssembly.c"
}

SliderAssembly*
slider_assembly_new (gdouble min,
                     gdouble max,
                     gdouble step,
                     gdouble initial_val)
{
#line 98 "../src/Widgets/SliderAssembly.vala"
	return slider_assembly_construct (TYPE_SLIDER_ASSEMBLY, min, max, step, initial_val);
#line 185 "SliderAssembly.c"
}

static void
slider_assembly_on_slider_value_changed (SliderAssembly* self)
{
#line 104 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Widgets/SliderAssembly.vala"
	g_signal_emit (self, slider_assembly_signals[SLIDER_ASSEMBLY_VALUE_CHANGED_SIGNAL], 0);
#line 195 "SliderAssembly.c"
}

static gboolean
slider_assembly_step_callback (SliderAssembly* self)
{
	gboolean result = FALSE;
	GtkEventBox* _tmp0_;
	GtkEventBox* _tmp1_;
#line 108 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->active_box;
#line 109 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = self->priv->increase_box;
#line 109 "../src/Widgets/SliderAssembly.vala"
	if (_tmp0_ == _tmp1_) {
#line 110 "../src/Widgets/SliderAssembly.vala"
		slider_assembly_increase_step (self);
#line 214 "SliderAssembly.c"
	} else {
#line 112 "../src/Widgets/SliderAssembly.vala"
		slider_assembly_decrease_step (self);
#line 218 "SliderAssembly.c"
	}
#line 115 "../src/Widgets/SliderAssembly.vala"
	result = TRUE;
#line 115 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 224 "SliderAssembly.c"
}

void
slider_assembly_increase_step (SliderAssembly* self)
{
	gdouble new_value = 0.0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkScale* _tmp22_;
#line 118 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = slider_assembly_get_inverted (self);
#line 120 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = _tmp0_;
#line 120 "../src/Widgets/SliderAssembly.vala"
	if (!_tmp1_) {
#line 242 "SliderAssembly.c"
		GtkScale* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		GtkScale* _tmp7_;
		GtkAdjustment* _tmp8_;
		GtkAdjustment* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp2_ = self->priv->slider;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp3_ = gtk_range_get_adjustment ((GtkRange*) _tmp2_);
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp4_ = _tmp3_;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp6_ = _tmp5_;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp7_ = self->priv->slider;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp8_ = gtk_range_get_adjustment ((GtkRange*) _tmp7_);
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp9_ = _tmp8_;
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp10_ = gtk_adjustment_get_step_increment (_tmp9_);
#line 121 "../src/Widgets/SliderAssembly.vala"
		_tmp11_ = _tmp10_;
#line 121 "../src/Widgets/SliderAssembly.vala"
		new_value = _tmp6_ + _tmp11_;
#line 275 "SliderAssembly.c"
	} else {
		GtkScale* _tmp12_;
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		GtkScale* _tmp17_;
		GtkAdjustment* _tmp18_;
		GtkAdjustment* _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp12_ = self->priv->slider;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp13_ = gtk_range_get_adjustment ((GtkRange*) _tmp12_);
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp14_ = _tmp13_;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp15_ = gtk_adjustment_get_value (_tmp14_);
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp16_ = _tmp15_;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp17_ = self->priv->slider;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp18_ = gtk_range_get_adjustment ((GtkRange*) _tmp17_);
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp19_ = _tmp18_;
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp20_ = gtk_adjustment_get_step_increment (_tmp19_);
#line 123 "../src/Widgets/SliderAssembly.vala"
		_tmp21_ = _tmp20_;
#line 123 "../src/Widgets/SliderAssembly.vala"
		new_value = _tmp16_ - _tmp21_;
#line 309 "SliderAssembly.c"
	}
#line 126 "../src/Widgets/SliderAssembly.vala"
	_tmp22_ = self->priv->slider;
#line 126 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_value ((GtkRange*) _tmp22_, new_value);
#line 315 "SliderAssembly.c"
}

void
slider_assembly_decrease_step (SliderAssembly* self)
{
	gdouble new_value = 0.0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkScale* _tmp22_;
#line 129 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = slider_assembly_get_inverted (self);
#line 131 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = _tmp0_;
#line 131 "../src/Widgets/SliderAssembly.vala"
	if (!_tmp1_) {
#line 333 "SliderAssembly.c"
		GtkScale* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		GtkScale* _tmp7_;
		GtkAdjustment* _tmp8_;
		GtkAdjustment* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp2_ = self->priv->slider;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp3_ = gtk_range_get_adjustment ((GtkRange*) _tmp2_);
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp4_ = _tmp3_;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp6_ = _tmp5_;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp7_ = self->priv->slider;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp8_ = gtk_range_get_adjustment ((GtkRange*) _tmp7_);
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp9_ = _tmp8_;
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp10_ = gtk_adjustment_get_step_increment (_tmp9_);
#line 132 "../src/Widgets/SliderAssembly.vala"
		_tmp11_ = _tmp10_;
#line 132 "../src/Widgets/SliderAssembly.vala"
		new_value = _tmp6_ - _tmp11_;
#line 366 "SliderAssembly.c"
	} else {
		GtkScale* _tmp12_;
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		GtkScale* _tmp17_;
		GtkAdjustment* _tmp18_;
		GtkAdjustment* _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp12_ = self->priv->slider;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp13_ = gtk_range_get_adjustment ((GtkRange*) _tmp12_);
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp14_ = _tmp13_;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp15_ = gtk_adjustment_get_value (_tmp14_);
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp16_ = _tmp15_;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp17_ = self->priv->slider;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp18_ = gtk_range_get_adjustment ((GtkRange*) _tmp17_);
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp19_ = _tmp18_;
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp20_ = gtk_adjustment_get_step_increment (_tmp19_);
#line 134 "../src/Widgets/SliderAssembly.vala"
		_tmp21_ = _tmp20_;
#line 134 "../src/Widgets/SliderAssembly.vala"
		new_value = _tmp16_ + _tmp21_;
#line 400 "SliderAssembly.c"
	}
#line 137 "../src/Widgets/SliderAssembly.vala"
	_tmp22_ = self->priv->slider;
#line 137 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_value ((GtkRange*) _tmp22_, new_value);
#line 406 "SliderAssembly.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 143 "../src/Widgets/SliderAssembly.vala"
	return self ? g_object_ref (self) : NULL;
#line 414 "SliderAssembly.c"
}

static gboolean
_slider_assembly_step_callback_gsource_func (gpointer self)
{
	gboolean result;
	result = slider_assembly_step_callback ((SliderAssembly*) self);
#line 145 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 424 "SliderAssembly.c"
}

static gboolean
__lambda20_ (SliderAssembly* self)
{
	gboolean result = FALSE;
#line 145 "../src/Widgets/SliderAssembly.vala"
	self->priv->click_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 20, _slider_assembly_step_callback_gsource_func, g_object_ref (self), g_object_unref);
#line 146 "../src/Widgets/SliderAssembly.vala"
	self->priv->initial_wait_id = (guint) 0;
#line 147 "../src/Widgets/SliderAssembly.vala"
	result = FALSE;
#line 147 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 439 "SliderAssembly.c"
}

static gboolean
___lambda20__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda20_ ((SliderAssembly*) self);
#line 144 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 449 "SliderAssembly.c"
}

static gboolean
slider_assembly_on_button_pressed (SliderAssembly* self,
                                   GtkWidget* sender,
                                   GdkEventButton* event)
{
	gboolean result = FALSE;
	GtkEventBox* _tmp0_;
#line 140 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 140 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 140 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 141 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeouts (self);
#line 143 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (sender, gtk_event_box_get_type (), GtkEventBox));
#line 143 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->active_box);
#line 143 "../src/Widgets/SliderAssembly.vala"
	self->priv->active_box = _tmp0_;
#line 144 "../src/Widgets/SliderAssembly.vala"
	self->priv->initial_wait_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ___lambda20__gsource_func, g_object_ref (self), g_object_unref);
#line 150 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_step_callback (self);
#line 152 "../src/Widgets/SliderAssembly.vala"
	result = TRUE;
#line 152 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 481 "SliderAssembly.c"
}

static gboolean
slider_assembly_on_button_released (SliderAssembly* self,
                                    GtkWidget* sender,
                                    GdkEventButton* event)
{
	gboolean result = FALSE;
#line 155 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 155 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 155 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 156 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeouts (self);
#line 158 "../src/Widgets/SliderAssembly.vala"
	result = TRUE;
#line 158 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 502 "SliderAssembly.c"
}

static void
slider_assembly_clear_timeouts (SliderAssembly* self)
{
#line 161 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeout (&self->priv->initial_wait_id);
#line 163 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeout (&self->priv->click_id);
#line 514 "SliderAssembly.c"
}

static void
slider_assembly_clear_timeout (guint* id)
{
#line 167 "../src/Widgets/SliderAssembly.vala"
	if ((*id) != ((guint) 0)) {
#line 168 "../src/Widgets/SliderAssembly.vala"
		g_source_remove (*id);
#line 169 "../src/Widgets/SliderAssembly.vala"
		*id = (guint) 0;
#line 526 "SliderAssembly.c"
	}
}

void
slider_assembly_set_tooltip (SliderAssembly* self,
                             const gchar* value)
{
	GtkScale* _tmp0_;
#line 32 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 33 "../src/Widgets/SliderAssembly.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 32 "../src/Widgets/SliderAssembly.vala"
	g_object_notify_by_pspec ((GObject *) self, slider_assembly_properties[SLIDER_ASSEMBLY_TOOLTIP_PROPERTY]);
#line 543 "SliderAssembly.c"
}

static gboolean
slider_assembly_get_inverted (SliderAssembly* self)
{
	gboolean result;
	GtkScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 41 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 42 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = gtk_range_get_inverted ((GtkRange*) _tmp0_);
#line 42 "../src/Widgets/SliderAssembly.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Widgets/SliderAssembly.vala"
	result = _tmp2_;
#line 42 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 565 "SliderAssembly.c"
}

void
slider_assembly_set_inverted (SliderAssembly* self,
                              gboolean value)
{
	GtkScale* _tmp0_;
#line 38 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 39 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_inverted ((GtkRange*) _tmp0_, value);
#line 38 "../src/Widgets/SliderAssembly.vala"
	g_object_notify_by_pspec ((GObject *) self, slider_assembly_properties[SLIDER_ASSEMBLY_INVERTED_PROPERTY]);
#line 581 "SliderAssembly.c"
}

gdouble
slider_assembly_get_slider_value (SliderAssembly* self)
{
	gdouble result;
	GtkScale* _tmp0_;
#line 47 "../src/Widgets/SliderAssembly.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 48 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 48 "../src/Widgets/SliderAssembly.vala"
	result = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 48 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 597 "SliderAssembly.c"
}

void
slider_assembly_set_slider_value (SliderAssembly* self,
                                  gdouble value)
{
	GtkScale* _tmp0_;
#line 50 "../src/Widgets/SliderAssembly.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = self->priv->slider;
#line 51 "../src/Widgets/SliderAssembly.vala"
	gtk_range_set_value ((GtkRange*) _tmp0_, value);
#line 50 "../src/Widgets/SliderAssembly.vala"
	g_object_notify_by_pspec ((GObject *) self, slider_assembly_properties[SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY]);
#line 613 "SliderAssembly.c"
}

static gboolean
_slider_assembly_on_button_pressed_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = slider_assembly_on_button_pressed ((SliderAssembly*) self, _sender, event);
#line 65 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 625 "SliderAssembly.c"
}

static gboolean
_slider_assembly_on_button_released_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self)
{
	gboolean result;
	result = slider_assembly_on_button_released ((SliderAssembly*) self, _sender, event);
#line 66 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 637 "SliderAssembly.c"
}

static gboolean
_slider_assembly___lambda21_ (SliderAssembly* self)
{
	gboolean result = FALSE;
#line 68 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeouts (self);
#line 70 "../src/Widgets/SliderAssembly.vala"
	result = FALSE;
#line 70 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 650 "SliderAssembly.c"
}

static gboolean
__slider_assembly___lambda21__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                             GdkEventCrossing* event,
                                                             gpointer self)
{
	gboolean result;
	result = _slider_assembly___lambda21_ ((SliderAssembly*) self);
#line 67 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 662 "SliderAssembly.c"
}

static void
_slider_assembly_on_slider_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                  gpointer self)
{
#line 76 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_on_slider_value_changed ((SliderAssembly*) self);
#line 671 "SliderAssembly.c"
}

static gboolean
_slider_assembly___lambda22_ (SliderAssembly* self)
{
	gboolean result = FALSE;
#line 90 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_clear_timeouts (self);
#line 92 "../src/Widgets/SliderAssembly.vala"
	result = FALSE;
#line 92 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 684 "SliderAssembly.c"
}

static gboolean
__slider_assembly___lambda22__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                             GdkEventCrossing* event,
                                                             gpointer self)
{
	gboolean result;
	result = _slider_assembly___lambda22_ ((SliderAssembly*) self);
#line 89 "../src/Widgets/SliderAssembly.vala"
	return result;
#line 696 "SliderAssembly.c"
}

static GObject *
slider_assembly_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SliderAssembly * self;
	GtkImage* decrease = NULL;
	GtkImage* _tmp0_;
	GtkEventBox* _tmp1_;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkImage* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkEventBox* _tmp7_;
	GtkEventBox* _tmp8_;
	GtkEventBox* _tmp9_;
	GtkScale* _tmp10_;
	GtkScale* _tmp11_;
	GtkScale* _tmp12_;
	GtkScale* _tmp13_;
	GtkScale* _tmp14_;
	GtkImage* increase = NULL;
	GtkImage* _tmp15_;
	GtkEventBox* _tmp16_;
	GtkEventBox* _tmp17_;
	GtkEventBox* _tmp18_;
	GtkEventBox* _tmp19_;
	GtkImage* _tmp20_;
	GtkEventBox* _tmp21_;
	GtkEventBox* _tmp22_;
	GtkEventBox* _tmp23_;
	GtkEventBox* _tmp24_;
#line 55 "../src/Widgets/SliderAssembly.vala"
	parent_class = G_OBJECT_CLASS (slider_assembly_parent_class);
#line 55 "../src/Widgets/SliderAssembly.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "../src/Widgets/SliderAssembly.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLIDER_ASSEMBLY, SliderAssembly);
#line 56 "../src/Widgets/SliderAssembly.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 57 "../src/Widgets/SliderAssembly.vala"
	gtk_widget_set_margin_top ((GtkWidget*) self, 5);
#line 58 "../src/Widgets/SliderAssembly.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 5);
#line 60 "../src/Widgets/SliderAssembly.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_ICON_ZOOM_OUT, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 60 "../src/Widgets/SliderAssembly.vala"
	g_object_ref_sink (_tmp0_);
#line 60 "../src/Widgets/SliderAssembly.vala"
	decrease = _tmp0_;
#line 61 "../src/Widgets/SliderAssembly.vala"
	_tmp1_ = (GtkEventBox*) gtk_event_box_new ();
#line 61 "../src/Widgets/SliderAssembly.vala"
	g_object_ref_sink (_tmp1_);
#line 61 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->decrease_box);
#line 61 "../src/Widgets/SliderAssembly.vala"
	self->priv->decrease_box = _tmp1_;
#line 62 "../src/Widgets/SliderAssembly.vala"
	_tmp2_ = self->priv->decrease_box;
#line 62 "../src/Widgets/SliderAssembly.vala"
	gtk_event_box_set_above_child (_tmp2_, TRUE);
#line 63 "../src/Widgets/SliderAssembly.vala"
	_tmp3_ = self->priv->decrease_box;
#line 63 "../src/Widgets/SliderAssembly.vala"
	gtk_event_box_set_visible_window (_tmp3_, FALSE);
#line 64 "../src/Widgets/SliderAssembly.vala"
	_tmp4_ = self->priv->decrease_box;
#line 64 "../src/Widgets/SliderAssembly.vala"
	_tmp5_ = decrease;
#line 64 "../src/Widgets/SliderAssembly.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 65 "../src/Widgets/SliderAssembly.vala"
	_tmp6_ = self->priv->decrease_box;
#line 65 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp6_, "button-press-event", (GCallback) _slider_assembly_on_button_pressed_gtk_widget_button_press_event, self, 0);
#line 66 "../src/Widgets/SliderAssembly.vala"
	_tmp7_ = self->priv->decrease_box;
#line 66 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp7_, "button-release-event", (GCallback) _slider_assembly_on_button_released_gtk_widget_button_release_event, self, 0);
#line 67 "../src/Widgets/SliderAssembly.vala"
	_tmp8_ = self->priv->decrease_box;
#line 67 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp8_, "leave-notify-event", (GCallback) __slider_assembly___lambda21__gtk_widget_leave_notify_event, self, 0);
#line 73 "../src/Widgets/SliderAssembly.vala"
	_tmp9_ = self->priv->decrease_box;
#line 73 "../src/Widgets/SliderAssembly.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
#line 75 "../src/Widgets/SliderAssembly.vala"
	_tmp10_ = (GtkScale*) gtk_scale_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 75 "../src/Widgets/SliderAssembly.vala"
	g_object_ref_sink (_tmp10_);
#line 75 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->slider);
#line 75 "../src/Widgets/SliderAssembly.vala"
	self->priv->slider = _tmp10_;
#line 76 "../src/Widgets/SliderAssembly.vala"
	_tmp11_ = self->priv->slider;
#line 76 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkRange*) _tmp11_, "value-changed", (GCallback) _slider_assembly_on_slider_value_changed_gtk_range_value_changed, self, 0);
#line 77 "../src/Widgets/SliderAssembly.vala"
	_tmp12_ = self->priv->slider;
#line 77 "../src/Widgets/SliderAssembly.vala"
	gtk_scale_set_draw_value (_tmp12_, FALSE);
#line 78 "../src/Widgets/SliderAssembly.vala"
	_tmp13_ = self->priv->slider;
#line 78 "../src/Widgets/SliderAssembly.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp13_, 150, -1);
#line 80 "../src/Widgets/SliderAssembly.vala"
	_tmp14_ = self->priv->slider;
#line 80 "../src/Widgets/SliderAssembly.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp14_);
#line 82 "../src/Widgets/SliderAssembly.vala"
	_tmp15_ = (GtkImage*) gtk_image_new_from_icon_name (RESOURCES_ICON_ZOOM_IN, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 82 "../src/Widgets/SliderAssembly.vala"
	g_object_ref_sink (_tmp15_);
#line 82 "../src/Widgets/SliderAssembly.vala"
	increase = _tmp15_;
#line 83 "../src/Widgets/SliderAssembly.vala"
	_tmp16_ = (GtkEventBox*) gtk_event_box_new ();
#line 83 "../src/Widgets/SliderAssembly.vala"
	g_object_ref_sink (_tmp16_);
#line 83 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->increase_box);
#line 83 "../src/Widgets/SliderAssembly.vala"
	self->priv->increase_box = _tmp16_;
#line 84 "../src/Widgets/SliderAssembly.vala"
	_tmp17_ = self->priv->increase_box;
#line 84 "../src/Widgets/SliderAssembly.vala"
	gtk_event_box_set_above_child (_tmp17_, TRUE);
#line 85 "../src/Widgets/SliderAssembly.vala"
	_tmp18_ = self->priv->increase_box;
#line 85 "../src/Widgets/SliderAssembly.vala"
	gtk_event_box_set_visible_window (_tmp18_, FALSE);
#line 86 "../src/Widgets/SliderAssembly.vala"
	_tmp19_ = self->priv->increase_box;
#line 86 "../src/Widgets/SliderAssembly.vala"
	_tmp20_ = increase;
#line 86 "../src/Widgets/SliderAssembly.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 87 "../src/Widgets/SliderAssembly.vala"
	_tmp21_ = self->priv->increase_box;
#line 87 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp21_, "button-press-event", (GCallback) _slider_assembly_on_button_pressed_gtk_widget_button_press_event, self, 0);
#line 88 "../src/Widgets/SliderAssembly.vala"
	_tmp22_ = self->priv->increase_box;
#line 88 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp22_, "button-release-event", (GCallback) _slider_assembly_on_button_released_gtk_widget_button_release_event, self, 0);
#line 89 "../src/Widgets/SliderAssembly.vala"
	_tmp23_ = self->priv->increase_box;
#line 89 "../src/Widgets/SliderAssembly.vala"
	g_signal_connect_object ((GtkWidget*) _tmp23_, "leave-notify-event", (GCallback) __slider_assembly___lambda22__gtk_widget_leave_notify_event, self, 0);
#line 95 "../src/Widgets/SliderAssembly.vala"
	_tmp24_ = self->priv->increase_box;
#line 95 "../src/Widgets/SliderAssembly.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 55 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (increase);
#line 55 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (decrease);
#line 55 "../src/Widgets/SliderAssembly.vala"
	return obj;
#line 864 "SliderAssembly.c"
}

static void
slider_assembly_class_init (SliderAssemblyClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/SliderAssembly.vala"
	g_type_class_adjust_private_offset (klass, &SliderAssembly_private_offset);
#line 21 "../src/Widgets/SliderAssembly.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slider_assembly_get_property;
#line 21 "../src/Widgets/SliderAssembly.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slider_assembly_set_property;
#line 21 "../src/Widgets/SliderAssembly.vala"
	G_OBJECT_CLASS (klass)->constructor = slider_assembly_constructor;
#line 21 "../src/Widgets/SliderAssembly.vala"
	G_OBJECT_CLASS (klass)->finalize = slider_assembly_finalize;
#line 21 "../src/Widgets/SliderAssembly.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLIDER_ASSEMBLY_TOOLTIP_PROPERTY, slider_assembly_properties[SLIDER_ASSEMBLY_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/SliderAssembly.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLIDER_ASSEMBLY_INVERTED_PROPERTY, slider_assembly_properties[SLIDER_ASSEMBLY_INVERTED_PROPERTY] = g_param_spec_boolean ("inverted", "inverted", "inverted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/SliderAssembly.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY, slider_assembly_properties[SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY] = g_param_spec_double ("slider-value", "slider-value", "slider-value", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Widgets/SliderAssembly.vala"
	slider_assembly_signals[SLIDER_ASSEMBLY_VALUE_CHANGED_SIGNAL] = g_signal_new ("value-changed", TYPE_SLIDER_ASSEMBLY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 891 "SliderAssembly.c"
}

static void
slider_assembly_instance_init (SliderAssembly * self,
                               gpointer klass)
{
#line 21 "../src/Widgets/SliderAssembly.vala"
	self->priv = slider_assembly_get_instance_private (self);
#line 26 "../src/Widgets/SliderAssembly.vala"
	self->priv->click_id = (guint) 0;
#line 27 "../src/Widgets/SliderAssembly.vala"
	self->priv->initial_wait_id = (guint) 0;
#line 904 "SliderAssembly.c"
}

static void
slider_assembly_finalize (GObject * obj)
{
	SliderAssembly * self;
#line 21 "../src/Widgets/SliderAssembly.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLIDER_ASSEMBLY, SliderAssembly);
#line 22 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->slider);
#line 23 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->decrease_box);
#line 24 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->increase_box);
#line 25 "../src/Widgets/SliderAssembly.vala"
	_g_object_unref0 (self->priv->active_box);
#line 21 "../src/Widgets/SliderAssembly.vala"
	G_OBJECT_CLASS (slider_assembly_parent_class)->finalize (obj);
#line 923 "SliderAssembly.c"
}

GType
slider_assembly_get_type (void)
{
	static volatile gsize slider_assembly_type_id__volatile = 0;
	if (g_once_init_enter (&slider_assembly_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SliderAssemblyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slider_assembly_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SliderAssembly), 0, (GInstanceInitFunc) slider_assembly_instance_init, NULL };
		GType slider_assembly_type_id;
		slider_assembly_type_id = g_type_register_static (gtk_grid_get_type (), "SliderAssembly", &g_define_type_info, 0);
		SliderAssembly_private_offset = g_type_add_instance_private (slider_assembly_type_id, sizeof (SliderAssemblyPrivate));
		g_once_init_leave (&slider_assembly_type_id__volatile, slider_assembly_type_id);
	}
	return slider_assembly_type_id__volatile;
}

static void
_vala_slider_assembly_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SliderAssembly * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SLIDER_ASSEMBLY, SliderAssembly);
#line 21 "../src/Widgets/SliderAssembly.vala"
	switch (property_id) {
#line 21 "../src/Widgets/SliderAssembly.vala"
		case SLIDER_ASSEMBLY_INVERTED_PROPERTY:
#line 21 "../src/Widgets/SliderAssembly.vala"
		g_value_set_boolean (value, slider_assembly_get_inverted (self));
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 21 "../src/Widgets/SliderAssembly.vala"
		case SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY:
#line 21 "../src/Widgets/SliderAssembly.vala"
		g_value_set_double (value, slider_assembly_get_slider_value (self));
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 962 "SliderAssembly.c"
		default:
#line 21 "../src/Widgets/SliderAssembly.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 968 "SliderAssembly.c"
	}
}

static void
_vala_slider_assembly_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SliderAssembly * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SLIDER_ASSEMBLY, SliderAssembly);
#line 21 "../src/Widgets/SliderAssembly.vala"
	switch (property_id) {
#line 21 "../src/Widgets/SliderAssembly.vala"
		case SLIDER_ASSEMBLY_TOOLTIP_PROPERTY:
#line 21 "../src/Widgets/SliderAssembly.vala"
		slider_assembly_set_tooltip (self, g_value_get_string (value));
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 21 "../src/Widgets/SliderAssembly.vala"
		case SLIDER_ASSEMBLY_INVERTED_PROPERTY:
#line 21 "../src/Widgets/SliderAssembly.vala"
		slider_assembly_set_inverted (self, g_value_get_boolean (value));
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 21 "../src/Widgets/SliderAssembly.vala"
		case SLIDER_ASSEMBLY_SLIDER_VALUE_PROPERTY:
#line 21 "../src/Widgets/SliderAssembly.vala"
		slider_assembly_set_slider_value (self, g_value_get_double (value));
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 1000 "SliderAssembly.c"
		default:
#line 21 "../src/Widgets/SliderAssembly.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/SliderAssembly.vala"
		break;
#line 1006 "SliderAssembly.c"
	}
}

