/* AbstractViewManager.c generated by valac 0.44.3, the Vala compiler
 * generated from AbstractViewManager.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* A ViewManager allows an interface for ViewCollection to monitor a SourceCollection and*/
/* (selectively) add DataViews automatically.*/

#include <glib-object.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewManagerPrivate ViewManagerPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
typedef struct _ParamSpecViewManager ParamSpecViewManager;

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

static gpointer view_manager_parent_class = NULL;

gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_view_manager (GValue* value,
                             gpointer v_object);
void value_take_view_manager (GValue* value,
                              gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
gboolean view_manager_include_in_view (ViewManager* self,
                                       DataSource* source);
static gboolean view_manager_real_include_in_view (ViewManager* self,
                                            DataSource* source);
DataView* view_manager_create_view (ViewManager* self,
                                    DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self,
                                         DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager * obj);

static gboolean
view_manager_real_include_in_view (ViewManager* self,
                                   DataSource* source)
{
	gboolean result = FALSE;
#line 26 "../src/core/AbstractViewManager.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 27 "../src/core/AbstractViewManager.vala"
	result = TRUE;
#line 27 "../src/core/AbstractViewManager.vala"
	return result;
#line 129 "AbstractViewManager.c"
}

gboolean
view_manager_include_in_view (ViewManager* self,
                              DataSource* source)
{
#line 26 "../src/core/AbstractViewManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/core/AbstractViewManager.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 140 "AbstractViewManager.c"
}

static DataView*
view_manager_real_create_view (ViewManager* self,
                               DataSource* source)
{
#line 32 "../src/core/AbstractViewManager.vala"
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/core/AbstractViewManager.vala"
	return NULL;
#line 151 "AbstractViewManager.c"
}

DataView*
view_manager_create_view (ViewManager* self,
                          DataSource* source)
{
#line 32 "../src/core/AbstractViewManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/core/AbstractViewManager.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 162 "AbstractViewManager.c"
}

ViewManager*
view_manager_construct (GType object_type)
{
	ViewManager* self = NULL;
#line 22 "../src/core/AbstractViewManager.vala"
	self = (ViewManager*) g_type_create_instance (object_type);
#line 22 "../src/core/AbstractViewManager.vala"
	return self;
#line 173 "AbstractViewManager.c"
}

static void
value_view_manager_init (GValue* value)
{
#line 22 "../src/core/AbstractViewManager.vala"
	value->data[0].v_pointer = NULL;
#line 181 "AbstractViewManager.c"
}

static void
value_view_manager_free_value (GValue* value)
{
#line 22 "../src/core/AbstractViewManager.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/core/AbstractViewManager.vala"
		view_manager_unref (value->data[0].v_pointer);
#line 191 "AbstractViewManager.c"
	}
}

static void
value_view_manager_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 22 "../src/core/AbstractViewManager.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/core/AbstractViewManager.vala"
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
#line 203 "AbstractViewManager.c"
	} else {
#line 22 "../src/core/AbstractViewManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 207 "AbstractViewManager.c"
	}
}

static gpointer
value_view_manager_peek_pointer (const GValue* value)
{
#line 22 "../src/core/AbstractViewManager.vala"
	return value->data[0].v_pointer;
#line 216 "AbstractViewManager.c"
}

static gchar*
value_view_manager_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 22 "../src/core/AbstractViewManager.vala"
	if (collect_values[0].v_pointer) {
#line 227 "AbstractViewManager.c"
		ViewManager * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/core/AbstractViewManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/core/AbstractViewManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 234 "AbstractViewManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/core/AbstractViewManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 238 "AbstractViewManager.c"
		}
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = view_manager_ref (object);
#line 242 "AbstractViewManager.c"
	} else {
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = NULL;
#line 246 "AbstractViewManager.c"
	}
#line 22 "../src/core/AbstractViewManager.vala"
	return NULL;
#line 250 "AbstractViewManager.c"
}

static gchar*
value_view_manager_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	ViewManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/core/AbstractViewManager.vala"
	if (!object_p) {
#line 22 "../src/core/AbstractViewManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 265 "AbstractViewManager.c"
	}
#line 22 "../src/core/AbstractViewManager.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/core/AbstractViewManager.vala"
		*object_p = NULL;
#line 271 "AbstractViewManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/core/AbstractViewManager.vala"
		*object_p = value->data[0].v_pointer;
#line 275 "AbstractViewManager.c"
	} else {
#line 22 "../src/core/AbstractViewManager.vala"
		*object_p = view_manager_ref (value->data[0].v_pointer);
#line 279 "AbstractViewManager.c"
	}
#line 22 "../src/core/AbstractViewManager.vala"
	return NULL;
#line 283 "AbstractViewManager.c"
}

GParamSpec*
param_spec_view_manager (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecViewManager* spec;
#line 22 "../src/core/AbstractViewManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
#line 22 "../src/core/AbstractViewManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/core/AbstractViewManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/core/AbstractViewManager.vala"
	return G_PARAM_SPEC (spec);
#line 302 "AbstractViewManager.c"
}

gpointer
value_get_view_manager (const GValue* value)
{
#line 22 "../src/core/AbstractViewManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
#line 22 "../src/core/AbstractViewManager.vala"
	return value->data[0].v_pointer;
#line 312 "AbstractViewManager.c"
}

void
value_set_view_manager (GValue* value,
                        gpointer v_object)
{
	ViewManager * old;
#line 22 "../src/core/AbstractViewManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 22 "../src/core/AbstractViewManager.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/core/AbstractViewManager.vala"
	if (v_object) {
#line 22 "../src/core/AbstractViewManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 22 "../src/core/AbstractViewManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/core/AbstractViewManager.vala"
		view_manager_ref (value->data[0].v_pointer);
#line 334 "AbstractViewManager.c"
	} else {
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = NULL;
#line 338 "AbstractViewManager.c"
	}
#line 22 "../src/core/AbstractViewManager.vala"
	if (old) {
#line 22 "../src/core/AbstractViewManager.vala"
		view_manager_unref (old);
#line 344 "AbstractViewManager.c"
	}
}

void
value_take_view_manager (GValue* value,
                         gpointer v_object)
{
	ViewManager * old;
#line 22 "../src/core/AbstractViewManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 22 "../src/core/AbstractViewManager.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/core/AbstractViewManager.vala"
	if (v_object) {
#line 22 "../src/core/AbstractViewManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 22 "../src/core/AbstractViewManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = v_object;
#line 365 "AbstractViewManager.c"
	} else {
#line 22 "../src/core/AbstractViewManager.vala"
		value->data[0].v_pointer = NULL;
#line 369 "AbstractViewManager.c"
	}
#line 22 "../src/core/AbstractViewManager.vala"
	if (old) {
#line 22 "../src/core/AbstractViewManager.vala"
		view_manager_unref (old);
#line 375 "AbstractViewManager.c"
	}
}

static void
view_manager_class_init (ViewManagerClass * klass,
                         gpointer klass_data)
{
#line 22 "../src/core/AbstractViewManager.vala"
	view_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/core/AbstractViewManager.vala"
	((ViewManagerClass *) klass)->finalize = view_manager_finalize;
#line 22 "../src/core/AbstractViewManager.vala"
	((ViewManagerClass *) klass)->include_in_view = (gboolean (*) (ViewManager*, DataSource*)) view_manager_real_include_in_view;
#line 22 "../src/core/AbstractViewManager.vala"
	((ViewManagerClass *) klass)->create_view = (DataView* (*) (ViewManager*, DataSource*)) view_manager_real_create_view;
#line 391 "AbstractViewManager.c"
}

static void
view_manager_instance_init (ViewManager * self,
                            gpointer klass)
{
#line 22 "../src/core/AbstractViewManager.vala"
	self->ref_count = 1;
#line 400 "AbstractViewManager.c"
}

static void
view_manager_finalize (ViewManager * obj)
{
	ViewManager * self;
#line 22 "../src/core/AbstractViewManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_MANAGER, ViewManager);
#line 22 "../src/core/AbstractViewManager.vala"
	g_signal_handlers_destroy (self);
#line 411 "AbstractViewManager.c"
}

GType
view_manager_get_type (void)
{
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}

gpointer
view_manager_ref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 22 "../src/core/AbstractViewManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/core/AbstractViewManager.vala"
	return instance;
#line 438 "AbstractViewManager.c"
}

void
view_manager_unref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 22 "../src/core/AbstractViewManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/core/AbstractViewManager.vala"
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
#line 22 "../src/core/AbstractViewManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 452 "AbstractViewManager.c"
	}
}

