/* TopDisplay.c generated by valac 0.44.3, the Vala compiler
 * generated from TopDisplay.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>

#define TYPE_TOP_DISPLAY (top_display_get_type ())
#define TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOP_DISPLAY, TopDisplay))
#define TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOP_DISPLAY, TopDisplayClass))
#define IS_TOP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOP_DISPLAY))
#define IS_TOP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOP_DISPLAY))
#define TOP_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOP_DISPLAY, TopDisplayClass))

typedef struct _TopDisplay TopDisplay;
typedef struct _TopDisplayClass TopDisplayClass;
typedef struct _TopDisplayPrivate TopDisplayPrivate;
enum  {
	TOP_DISPLAY_0_PROPERTY,
	TOP_DISPLAY_TITLE_PROPERTY,
	TOP_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* top_display_properties[TOP_DISPLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TopDisplay {
	GtkStack parent_instance;
	TopDisplayPrivate * priv;
};

struct _TopDisplayClass {
	GtkStackClass parent_class;
};

struct _TopDisplayPrivate {
	GtkLabel* title_label;
	GtkLabel* background_progress_label;
	GtkProgressBar* background_progress_bar;
	gint current_priority;
	guint background_progress_pulse_id;
};

static gint TopDisplay_private_offset;
static gpointer top_display_parent_class = NULL;

GType top_display_get_type (void) G_GNUC_CONST;
#define TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC 250
TopDisplay* top_display_new (void);
TopDisplay* top_display_construct (GType object_type);
void top_display_start_pulse_background_progress_bar (TopDisplay* self,
                                                      const gchar* label,
                                                      gint priority);
void top_display_stop_pulse_background_progress_bar (TopDisplay* self,
                                                     gint priority,
                                                     gboolean clear);
static void top_display_set_show_progress (TopDisplay* self,
                                    gboolean value);
static gboolean top_display_on_pulse_background_progress_bar (TopDisplay* self);
static gboolean _top_display_on_pulse_background_progress_bar_gsource_func (gpointer self);
void top_display_clear_background_progress_bar (TopDisplay* self,
                                                gint priority);
void top_display_update_background_progress_bar (TopDisplay* self,
                                                 const gchar* label,
                                                 gint priority,
                                                 gdouble count,
                                                 gdouble total);
void top_display_set_title (TopDisplay* self,
                            const gchar* value);
static GObject * top_display_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void top_display_finalize (GObject * obj);
static void _vala_top_display_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
top_display_get_instance_private (TopDisplay* self)
{
	return G_STRUCT_MEMBER_P (self, TopDisplay_private_offset);
}

TopDisplay*
top_display_construct (GType object_type)
{
	TopDisplay * self = NULL;
#line 50 "../src/library/TopDisplay.vala"
	self = (TopDisplay*) g_object_new (object_type, "transition-type", GTK_STACK_TRANSITION_TYPE_CROSSFADE, NULL);
#line 49 "../src/library/TopDisplay.vala"
	return self;
#line 119 "TopDisplay.c"
}

TopDisplay*
top_display_new (void)
{
#line 49 "../src/library/TopDisplay.vala"
	return top_display_construct (TYPE_TOP_DISPLAY);
#line 127 "TopDisplay.c"
}

static gboolean
_top_display_on_pulse_background_progress_bar_gsource_func (gpointer self)
{
	gboolean result;
	result = top_display_on_pulse_background_progress_bar ((TopDisplay*) self);
#line 96 "../src/library/TopDisplay.vala"
	return result;
#line 137 "TopDisplay.c"
}

void
top_display_start_pulse_background_progress_bar (TopDisplay* self,
                                                 const gchar* label,
                                                 gint priority)
{
	GtkLabel* _tmp0_;
	GtkProgressBar* _tmp1_;
#line 80 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 81 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 82 "../src/library/TopDisplay.vala"
		return;
#line 155 "TopDisplay.c"
	}
#line 84 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 86 "../src/library/TopDisplay.vala"
	self->priv->current_priority = priority;
#line 88 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_label;
#line 88 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp0_, label);
#line 89 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->background_progress_bar;
#line 89 "../src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp1_);
#line 90 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 92 "../src/library/TopDisplay.vala"
	if (self->priv->background_progress_pulse_id > ((guint) 0)) {
#line 93 "../src/library/TopDisplay.vala"
		g_source_remove (self->priv->background_progress_pulse_id);
#line 175 "TopDisplay.c"
	}
#line 96 "../src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) TOP_DISPLAY_BACKGROUND_PROGRESS_PULSE_MSEC, _top_display_on_pulse_background_progress_bar_gsource_func, g_object_ref (self), g_object_unref);
#line 179 "TopDisplay.c"
}

static gboolean
top_display_on_pulse_background_progress_bar (TopDisplay* self)
{
	gboolean result = FALSE;
	GtkProgressBar* _tmp0_;
#line 99 "../src/library/TopDisplay.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_bar;
#line 100 "../src/library/TopDisplay.vala"
	gtk_progress_bar_pulse (_tmp0_);
#line 101 "../src/library/TopDisplay.vala"
	result = TRUE;
#line 101 "../src/library/TopDisplay.vala"
	return result;
#line 197 "TopDisplay.c"
}

void
top_display_stop_pulse_background_progress_bar (TopDisplay* self,
                                                gint priority,
                                                gboolean clear)
{
#line 104 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 106 "../src/library/TopDisplay.vala"
		return;
#line 211 "TopDisplay.c"
	}
#line 108 "../src/library/TopDisplay.vala"
	if (self->priv->background_progress_pulse_id > ((guint) 0)) {
#line 109 "../src/library/TopDisplay.vala"
		g_source_remove (self->priv->background_progress_pulse_id);
#line 110 "../src/library/TopDisplay.vala"
		self->priv->background_progress_pulse_id = (guint) 0;
#line 219 "TopDisplay.c"
	}
#line 113 "../src/library/TopDisplay.vala"
	if (clear) {
#line 114 "../src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, priority);
#line 225 "TopDisplay.c"
	}
}

void
top_display_update_background_progress_bar (TopDisplay* self,
                                            const gchar* label,
                                            gint priority,
                                            gdouble count,
                                            gdouble total)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gdouble fraction = 0.0;
	GtkProgressBar* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 117 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/library/TopDisplay.vala"
	g_return_if_fail (label != NULL);
#line 118 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 119 "../src/library/TopDisplay.vala"
		return;
#line 251 "TopDisplay.c"
	}
#line 122 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 124 "../src/library/TopDisplay.vala"
	if (count <= 0.0) {
#line 124 "../src/library/TopDisplay.vala"
		_tmp1_ = TRUE;
#line 259 "TopDisplay.c"
	} else {
#line 124 "../src/library/TopDisplay.vala"
		_tmp1_ = total <= 0.0;
#line 263 "TopDisplay.c"
	}
#line 124 "../src/library/TopDisplay.vala"
	if (_tmp1_) {
#line 124 "../src/library/TopDisplay.vala"
		_tmp0_ = TRUE;
#line 269 "TopDisplay.c"
	} else {
#line 124 "../src/library/TopDisplay.vala"
		_tmp0_ = count >= total;
#line 273 "TopDisplay.c"
	}
#line 124 "../src/library/TopDisplay.vala"
	if (_tmp0_) {
#line 125 "../src/library/TopDisplay.vala"
		top_display_clear_background_progress_bar (self, priority);
#line 126 "../src/library/TopDisplay.vala"
		return;
#line 281 "TopDisplay.c"
	}
#line 129 "../src/library/TopDisplay.vala"
	self->priv->current_priority = priority;
#line 131 "../src/library/TopDisplay.vala"
	fraction = count / total;
#line 132 "../src/library/TopDisplay.vala"
	_tmp2_ = self->priv->background_progress_bar;
#line 132 "../src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp2_, fraction);
#line 133 "../src/library/TopDisplay.vala"
	_tmp3_ = self->priv->background_progress_label;
#line 133 "../src/library/TopDisplay.vala"
	_tmp4_ = g_strdup_printf (_ ("%s (%d%%)"), label, (gint) (fraction * 100.0));
#line 133 "../src/library/TopDisplay.vala"
	_tmp5_ = _tmp4_;
#line 133 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp3_, _tmp5_);
#line 133 "../src/library/TopDisplay.vala"
	_g_free0 (_tmp5_);
#line 134 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, TRUE);
#line 303 "TopDisplay.c"
}

void
top_display_clear_background_progress_bar (TopDisplay* self,
                                           gint priority)
{
	GtkProgressBar* _tmp0_;
	GtkLabel* _tmp1_;
#line 143 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/library/TopDisplay.vala"
	if (priority < self->priv->current_priority) {
#line 145 "../src/library/TopDisplay.vala"
		return;
#line 318 "TopDisplay.c"
	}
#line 148 "../src/library/TopDisplay.vala"
	top_display_stop_pulse_background_progress_bar (self, priority, FALSE);
#line 150 "../src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 152 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->background_progress_bar;
#line 152 "../src/library/TopDisplay.vala"
	gtk_progress_bar_set_fraction (_tmp0_, 0.0);
#line 153 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->background_progress_label;
#line 153 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp1_, "");
#line 154 "../src/library/TopDisplay.vala"
	top_display_set_show_progress (self, FALSE);
#line 334 "TopDisplay.c"
}

static void
top_display_set_show_progress (TopDisplay* self,
                               gboolean value)
{
#line 34 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/library/TopDisplay.vala"
	if (value) {
#line 36 "../src/library/TopDisplay.vala"
		gtk_stack_set_visible_child_name ((GtkStack*) self, "progress");
#line 347 "TopDisplay.c"
	} else {
		GtkLabel* _tmp0_;
#line 38 "../src/library/TopDisplay.vala"
		_tmp0_ = self->priv->title_label;
#line 38 "../src/library/TopDisplay.vala"
		gtk_stack_set_visible_child ((GtkStack*) self, (GtkWidget*) _tmp0_);
#line 354 "TopDisplay.c"
	}
}

void
top_display_set_title (TopDisplay* self,
                       const gchar* value)
{
	GtkLabel* _tmp0_;
#line 44 "../src/library/TopDisplay.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/library/TopDisplay.vala"
	_tmp0_ = self->priv->title_label;
#line 45 "../src/library/TopDisplay.vala"
	gtk_label_set_label (_tmp0_, value);
#line 44 "../src/library/TopDisplay.vala"
	g_object_notify_by_pspec ((GObject *) self, top_display_properties[TOP_DISPLAY_TITLE_PROPERTY]);
#line 371 "TopDisplay.c"
}

static GObject *
top_display_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TopDisplay * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkProgressBar* _tmp6_;
	GtkProgressBar* _tmp7_;
	GtkGrid* progress_grid = NULL;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkLabel* _tmp13_;
	GtkGrid* _tmp14_;
	GtkProgressBar* _tmp15_;
	GtkLabel* _tmp16_;
	GtkGrid* _tmp17_;
#line 53 "../src/library/TopDisplay.vala"
	parent_class = G_OBJECT_CLASS (top_display_parent_class);
#line 53 "../src/library/TopDisplay.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 54 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, FALSE);
#line 56 "../src/library/TopDisplay.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Photos"));
#line 56 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp0_);
#line 56 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->title_label);
#line 56 "../src/library/TopDisplay.vala"
	self->priv->title_label = _tmp0_;
#line 57 "../src/library/TopDisplay.vala"
	_tmp1_ = self->priv->title_label;
#line 57 "../src/library/TopDisplay.vala"
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_MIDDLE);
#line 58 "../src/library/TopDisplay.vala"
	_tmp2_ = self->priv->title_label;
#line 58 "../src/library/TopDisplay.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 58 "../src/library/TopDisplay.vala"
	gtk_style_context_add_class (_tmp3_, GTK_STYLE_CLASS_TITLE);
#line 60 "../src/library/TopDisplay.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
#line 60 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp4_);
#line 60 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 60 "../src/library/TopDisplay.vala"
	self->priv->background_progress_label = _tmp4_;
#line 61 "../src/library/TopDisplay.vala"
	_tmp5_ = self->priv->background_progress_label;
#line 61 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
#line 63 "../src/library/TopDisplay.vala"
	_tmp6_ = (GtkProgressBar*) gtk_progress_bar_new ();
#line 63 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp6_);
#line 63 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 63 "../src/library/TopDisplay.vala"
	self->priv->background_progress_bar = _tmp6_;
#line 64 "../src/library/TopDisplay.vala"
	_tmp7_ = self->priv->background_progress_bar;
#line 64 "../src/library/TopDisplay.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
#line 66 "../src/library/TopDisplay.vala"
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
#line 66 "../src/library/TopDisplay.vala"
	g_object_ref_sink (_tmp8_);
#line 66 "../src/library/TopDisplay.vala"
	progress_grid = _tmp8_;
#line 67 "../src/library/TopDisplay.vala"
	_tmp9_ = progress_grid;
#line 67 "../src/library/TopDisplay.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp9_, GTK_ORIENTATION_VERTICAL);
#line 68 "../src/library/TopDisplay.vala"
	_tmp10_ = progress_grid;
#line 68 "../src/library/TopDisplay.vala"
	gtk_grid_set_row_spacing (_tmp10_, 6);
#line 69 "../src/library/TopDisplay.vala"
	_tmp11_ = progress_grid;
#line 69 "../src/library/TopDisplay.vala"
	g_object_set ((GtkWidget*) _tmp11_, "width-request", 200, NULL);
#line 70 "../src/library/TopDisplay.vala"
	_tmp12_ = progress_grid;
#line 70 "../src/library/TopDisplay.vala"
	_tmp13_ = self->priv->background_progress_label;
#line 70 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 71 "../src/library/TopDisplay.vala"
	_tmp14_ = progress_grid;
#line 71 "../src/library/TopDisplay.vala"
	_tmp15_ = self->priv->background_progress_bar;
#line 71 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 73 "../src/library/TopDisplay.vala"
	_tmp16_ = self->priv->title_label;
#line 73 "../src/library/TopDisplay.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp16_);
#line 74 "../src/library/TopDisplay.vala"
	_tmp17_ = progress_grid;
#line 74 "../src/library/TopDisplay.vala"
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp17_, "progress");
#line 53 "../src/library/TopDisplay.vala"
	_g_object_unref0 (progress_grid);
#line 53 "../src/library/TopDisplay.vala"
	return obj;
#line 493 "TopDisplay.c"
}

static void
top_display_class_init (TopDisplayClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/library/TopDisplay.vala"
	top_display_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/library/TopDisplay.vala"
	g_type_class_adjust_private_offset (klass, &TopDisplay_private_offset);
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_top_display_set_property;
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->constructor = top_display_constructor;
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (klass)->finalize = top_display_finalize;
#line 20 "../src/library/TopDisplay.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOP_DISPLAY_TITLE_PROPERTY, top_display_properties[TOP_DISPLAY_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 512 "TopDisplay.c"
}

static void
top_display_instance_init (TopDisplay * self,
                           gpointer klass)
{
#line 20 "../src/library/TopDisplay.vala"
	self->priv = top_display_get_instance_private (self);
#line 25 "../src/library/TopDisplay.vala"
	self->priv->current_priority = 0;
#line 26 "../src/library/TopDisplay.vala"
	self->priv->background_progress_pulse_id = 0U;
#line 525 "TopDisplay.c"
}

static void
top_display_finalize (GObject * obj)
{
	TopDisplay * self;
#line 20 "../src/library/TopDisplay.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TOP_DISPLAY, TopDisplay);
#line 21 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->title_label);
#line 22 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_label);
#line 23 "../src/library/TopDisplay.vala"
	_g_object_unref0 (self->priv->background_progress_bar);
#line 20 "../src/library/TopDisplay.vala"
	G_OBJECT_CLASS (top_display_parent_class)->finalize (obj);
#line 542 "TopDisplay.c"
}

GType
top_display_get_type (void)
{
	static volatile gsize top_display_type_id__volatile = 0;
	if (g_once_init_enter (&top_display_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TopDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) top_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TopDisplay), 0, (GInstanceInitFunc) top_display_instance_init, NULL };
		GType top_display_type_id;
		top_display_type_id = g_type_register_static (gtk_stack_get_type (), "TopDisplay", &g_define_type_info, 0);
		TopDisplay_private_offset = g_type_add_instance_private (top_display_type_id, sizeof (TopDisplayPrivate));
		g_once_init_leave (&top_display_type_id__volatile, top_display_type_id);
	}
	return top_display_type_id__volatile;
}

static void
_vala_top_display_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	TopDisplay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TOP_DISPLAY, TopDisplay);
#line 20 "../src/library/TopDisplay.vala"
	switch (property_id) {
#line 20 "../src/library/TopDisplay.vala"
		case TOP_DISPLAY_TITLE_PROPERTY:
#line 20 "../src/library/TopDisplay.vala"
		top_display_set_title (self, g_value_get_string (value));
#line 20 "../src/library/TopDisplay.vala"
		break;
#line 575 "TopDisplay.c"
		default:
#line 20 "../src/library/TopDisplay.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/library/TopDisplay.vala"
		break;
#line 581 "TopDisplay.c"
	}
}

