/* file.c generated by valac 0.44.3, the Vala compiler
 * generated from file.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <time.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

gboolean claim_file (GFile* file,
                     GError** error);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
glong find_last_offset (const gchar* str,
                        gchar c);
guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
void delete_all_files (GFile* dir,
                       GeeSet* exceptions,
                       ProgressMonitor monitor,
                       gpointer monitor_target,
                       guint64 file_count,
                       GCancellable* cancellable,
                       GError** error);
time_t query_file_modified (GFile* file,
                            GError** error);
gboolean query_is_directory (GFile* file);
gboolean query_is_directory_empty (GFile* dir,
                                   GError** error);
gchar* get_display_pathname (GFile* file);
gchar* strip_pretty_path (const gchar* path);
gchar* get_file_info_id (GFileInfo* info);
void skip_uint64 (GInputStream* input,
                  guint64 skip_amount,
                  GError** error);
guint64 count_files_in_directory (GFile* dir,
                                  GError** error);
gboolean file_equal (GFile* a,
                     GFile* b);
guint file_hash (GFile* file);

static gpointer
_g_error_copy0 (gpointer self)
{
#line 36 "../src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 85 "file.c"
}

gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 25 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 97 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 27 "../src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 27 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 27 "../src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 27 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "file.c"
			goto __catch407_g_error;
		}
#line 30 "../src/util/file.vala"
		result = TRUE;
#line 30 "../src/util/file.vala"
		return result;
#line 116 "file.c"
	}
	goto __finally407;
	__catch407_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 26 "../src/util/file.vala"
		err = _inner_error0_;
#line 26 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 33 "../src/util/file.vala"
		_tmp2_ = err;
#line 33 "../src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 131 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 34 "../src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 34 "../src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 34 "../src/util/file.vala"
			_tmp5_ = err;
#line 34 "../src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 34 "../src/util/file.vala"
			g_warning ("file.vala:34: claim_file %s: %s", _tmp4_, _tmp6_);
#line 34 "../src/util/file.vala"
			_g_free0 (_tmp4_);
#line 36 "../src/util/file.vala"
			_tmp7_ = err;
#line 36 "../src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 36 "../src/util/file.vala"
			_inner_error0_ = _tmp8_;
#line 36 "../src/util/file.vala"
			_g_error_free0 (err);
#line 158 "file.c"
			goto __finally407;
		}
#line 39 "../src/util/file.vala"
		result = FALSE;
#line 39 "../src/util/file.vala"
		_g_error_free0 (err);
#line 39 "../src/util/file.vala"
		return result;
#line 167 "file.c"
	}
	__finally407:
#line 26 "../src/util/file.vala"
	g_propagate_error (error, _inner_error0_);
#line 26 "../src/util/file.vala"
	return _tmp9_;
#line 174 "file.c"
}

GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* result = NULL;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 49 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 49 "../src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 51 "../src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 51 "../src/util/file.vala"
	file = _tmp0_;
#line 52 "../src/util/file.vala"
	_tmp2_ = file;
#line 52 "../src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error0_);
#line 52 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 52 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 52 "../src/util/file.vala"
		return NULL;
#line 216 "file.c"
	}
#line 52 "../src/util/file.vala"
	if (_tmp1_) {
#line 53 "../src/util/file.vala"
		_vala_collision = FALSE;
#line 55 "../src/util/file.vala"
		result = file;
#line 55 "../src/util/file.vala"
		if (collision) {
#line 55 "../src/util/file.vala"
			*collision = _vala_collision;
#line 228 "file.c"
		}
#line 55 "../src/util/file.vala"
		return result;
#line 232 "file.c"
	}
#line 59 "../src/util/file.vala"
	_vala_collision = TRUE;
#line 62 "../src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 62 "../src/util/file.vala"
	_g_free0 (name);
#line 62 "../src/util/file.vala"
	name = _tmp3_;
#line 62 "../src/util/file.vala"
	_g_free0 (ext);
#line 62 "../src/util/file.vala"
	ext = _tmp4_;
#line 246 "file.c"
	{
		gint ctr = 0;
#line 65 "../src/util/file.vala"
		ctr = 1;
#line 251 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 65 "../src/util/file.vala"
			_tmp5_ = TRUE;
#line 65 "../src/util/file.vala"
			while (TRUE) {
#line 258 "file.c"
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar* new_name = NULL;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				GFile* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GFile* _tmp18_;
#line 65 "../src/util/file.vala"
				if (!_tmp5_) {
#line 269 "file.c"
					gint _tmp6_;
#line 65 "../src/util/file.vala"
					_tmp6_ = ctr;
#line 65 "../src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 275 "file.c"
				}
#line 65 "../src/util/file.vala"
				_tmp5_ = FALSE;
#line 65 "../src/util/file.vala"
				if (!(ctr < G_MAXINT)) {
#line 65 "../src/util/file.vala"
					break;
#line 283 "file.c"
				}
#line 66 "../src/util/file.vala"
				_tmp8_ = ext;
#line 66 "../src/util/file.vala"
				if (_tmp8_ != NULL) {
#line 289 "file.c"
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 66 "../src/util/file.vala"
					_tmp9_ = name;
#line 66 "../src/util/file.vala"
					_tmp10_ = ext;
#line 66 "../src/util/file.vala"
					_tmp11_ = g_strdup_printf ("%s_%d.%s", _tmp9_, ctr, _tmp10_);
#line 66 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 66 "../src/util/file.vala"
					_tmp7_ = _tmp11_;
#line 303 "file.c"
				} else {
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 66 "../src/util/file.vala"
					_tmp12_ = name;
#line 66 "../src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d", _tmp12_, ctr);
#line 66 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 66 "../src/util/file.vala"
					_tmp7_ = _tmp13_;
#line 315 "file.c"
				}
#line 66 "../src/util/file.vala"
				_tmp14_ = g_strdup (_tmp7_);
#line 66 "../src/util/file.vala"
				new_name = _tmp14_;
#line 68 "../src/util/file.vala"
				_tmp15_ = new_name;
#line 68 "../src/util/file.vala"
				_tmp16_ = g_file_get_child (dir, _tmp15_);
#line 68 "../src/util/file.vala"
				_g_object_unref0 (file);
#line 68 "../src/util/file.vala"
				file = _tmp16_;
#line 69 "../src/util/file.vala"
				_tmp18_ = file;
#line 69 "../src/util/file.vala"
				_tmp17_ = claim_file (_tmp18_, &_inner_error0_);
#line 69 "../src/util/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/util/file.vala"
					g_propagate_error (error, _inner_error0_);
#line 69 "../src/util/file.vala"
					_g_free0 (new_name);
#line 69 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 69 "../src/util/file.vala"
					_g_free0 (ext);
#line 69 "../src/util/file.vala"
					_g_free0 (name);
#line 69 "../src/util/file.vala"
					_g_object_unref0 (file);
#line 69 "../src/util/file.vala"
					return NULL;
#line 349 "file.c"
				}
#line 69 "../src/util/file.vala"
				if (_tmp17_) {
#line 70 "../src/util/file.vala"
					result = file;
#line 70 "../src/util/file.vala"
					_g_free0 (new_name);
#line 70 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 70 "../src/util/file.vala"
					_g_free0 (ext);
#line 70 "../src/util/file.vala"
					_g_free0 (name);
#line 70 "../src/util/file.vala"
					if (collision) {
#line 70 "../src/util/file.vala"
						*collision = _vala_collision;
#line 367 "file.c"
					}
#line 70 "../src/util/file.vala"
					return result;
#line 371 "file.c"
				}
#line 65 "../src/util/file.vala"
				_g_free0 (new_name);
#line 65 "../src/util/file.vala"
				_g_free0 (_tmp7_);
#line 377 "file.c"
			}
		}
	}
#line 73 "../src/util/file.vala"
	_tmp19_ = g_file_get_path (dir);
#line 73 "../src/util/file.vala"
	_tmp20_ = _tmp19_;
#line 73 "../src/util/file.vala"
	g_warning ("file.vala:73: generate_unique_filename %s for %s: unable to claim file", _tmp20_, basename);
#line 73 "../src/util/file.vala"
	_g_free0 (_tmp20_);
#line 75 "../src/util/file.vala"
	result = NULL;
#line 75 "../src/util/file.vala"
	_g_free0 (ext);
#line 75 "../src/util/file.vala"
	_g_free0 (name);
#line 75 "../src/util/file.vala"
	_g_object_unref0 (file);
#line 75 "../src/util/file.vala"
	if (collision) {
#line 75 "../src/util/file.vala"
		*collision = _vala_collision;
#line 401 "file.c"
	}
#line 75 "../src/util/file.vala"
	return result;
#line 405 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 428 "file.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 437 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 456 "file.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 460 "file.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 466 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 476 "file.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 484 "file.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 488 "file.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 494 "file.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 504 "file.c"
}

void
disassemble_filename (const gchar* basename,
                      gchar* * name,
                      gchar* * ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
#line 78 "../src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 79 "../src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 80 "../src/util/file.vala"
	if (offset <= ((glong) 0)) {
#line 521 "file.c"
		gchar* _tmp0_;
#line 81 "../src/util/file.vala"
		_tmp0_ = g_strdup (basename);
#line 81 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 81 "../src/util/file.vala"
		_vala_name = _tmp0_;
#line 82 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 82 "../src/util/file.vala"
		_vala_ext = NULL;
#line 533 "file.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 84 "../src/util/file.vala"
		_tmp1_ = string_substring (basename, (glong) 0, offset);
#line 84 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 84 "../src/util/file.vala"
		_vala_name = _tmp1_;
#line 85 "../src/util/file.vala"
		_tmp2_ = string_substring (basename, offset + 1, (glong) -1);
#line 85 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 85 "../src/util/file.vala"
		_vala_ext = _tmp2_;
#line 549 "file.c"
	}
#line 78 "../src/util/file.vala"
	if (name) {
#line 78 "../src/util/file.vala"
		*name = _vala_name;
#line 555 "file.c"
	} else {
#line 78 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 559 "file.c"
	}
#line 78 "../src/util/file.vala"
	if (ext) {
#line 78 "../src/util/file.vala"
		*ext = _vala_ext;
#line 565 "file.c"
	} else {
#line 78 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 569 "file.c"
	}
}

guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	guint64 result = 0ULL;
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 90 "../src/util/file.vala"
	g_return_val_if_fail (file_or_dir != NULL, 0ULL);
#line 91 "../src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 92 "../src/util/file.vala"
	_tmp0_ = type;
#line 92 "../src/util/file.vala"
	if (_tmp0_ == G_FILE_TYPE_REGULAR) {
#line 593 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp12_;
#line 93 "../src/util/file.vala"
		info = NULL;
#line 598 "file.c"
		{
			GFileInfo* _tmp1_ = NULL;
			GFileInfo* _tmp2_;
			GFileInfo* _tmp3_;
#line 95 "../src/util/file.vala"
			_tmp2_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 95 "../src/util/file.vala"
			_tmp1_ = _tmp2_;
#line 95 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 609 "file.c"
				goto __catch408_g_error;
			}
#line 95 "../src/util/file.vala"
			_tmp3_ = _tmp1_;
#line 95 "../src/util/file.vala"
			_tmp1_ = NULL;
#line 95 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 95 "../src/util/file.vala"
			info = _tmp3_;
#line 94 "../src/util/file.vala"
			_g_object_unref0 (_tmp1_);
#line 622 "file.c"
		}
		goto __finally408;
		__catch408_g_error:
		{
			GError* err = NULL;
			GError* _tmp4_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 94 "../src/util/file.vala"
			err = _inner_error0_;
#line 94 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 98 "../src/util/file.vala"
			_tmp4_ = err;
#line 98 "../src/util/file.vala"
			if (g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 641 "file.c"
				GError* _tmp5_;
				GError* _tmp6_;
#line 99 "../src/util/file.vala"
				_tmp5_ = err;
#line 99 "../src/util/file.vala"
				_tmp6_ = _g_error_copy0 (_tmp5_);
#line 99 "../src/util/file.vala"
				_inner_error0_ = _tmp6_;
#line 99 "../src/util/file.vala"
				_g_error_free0 (err);
#line 652 "file.c"
				goto __finally408;
			}
#line 101 "../src/util/file.vala"
			_tmp7_ = g_file_get_path (file_or_dir);
#line 101 "../src/util/file.vala"
			_tmp8_ = _tmp7_;
#line 101 "../src/util/file.vala"
			_tmp9_ = err;
#line 101 "../src/util/file.vala"
			_tmp10_ = _tmp9_->message;
#line 101 "../src/util/file.vala"
			g_debug ("file.vala:101: Unable to query filesize for %s: %s", _tmp8_, _tmp10_);
#line 101 "../src/util/file.vala"
			_g_free0 (_tmp8_);
#line 103 "../src/util/file.vala"
			result = (guint64) 0;
#line 103 "../src/util/file.vala"
			_g_error_free0 (err);
#line 103 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 103 "../src/util/file.vala"
			return result;
#line 675 "file.c"
		}
		__finally408:
#line 94 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 680 "file.c"
			guint64 _tmp11_ = 0ULL;
#line 94 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 94 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 94 "../src/util/file.vala"
			return _tmp11_;
#line 688 "file.c"
		}
#line 106 "../src/util/file.vala"
		_tmp12_ = info;
#line 106 "../src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp12_);
#line 106 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 106 "../src/util/file.vala"
		return result;
#line 698 "file.c"
	} else {
		GFileType _tmp13_;
#line 107 "../src/util/file.vala"
		_tmp13_ = type;
#line 107 "../src/util/file.vala"
		if (_tmp13_ != G_FILE_TYPE_DIRECTORY) {
#line 108 "../src/util/file.vala"
			result = (guint64) 0;
#line 108 "../src/util/file.vala"
			return result;
#line 709 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp14_ = NULL;
		GFileEnumerator* _tmp15_;
		GFileEnumerator* _tmp16_;
		GFileEnumerator* _tmp17_;
#line 113 "../src/util/file.vala"
		_tmp15_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 113 "../src/util/file.vala"
		_tmp14_ = _tmp15_;
#line 113 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 723 "file.c"
			goto __catch409_g_error;
		}
#line 113 "../src/util/file.vala"
		_tmp16_ = _tmp14_;
#line 113 "../src/util/file.vala"
		_tmp14_ = NULL;
#line 113 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 113 "../src/util/file.vala"
		enumerator = _tmp16_;
#line 115 "../src/util/file.vala"
		_tmp17_ = enumerator;
#line 115 "../src/util/file.vala"
		if (_tmp17_ == NULL) {
#line 116 "../src/util/file.vala"
			result = (guint64) 0;
#line 116 "../src/util/file.vala"
			_g_object_unref0 (_tmp14_);
#line 116 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 116 "../src/util/file.vala"
			return result;
#line 746 "file.c"
		}
#line 112 "../src/util/file.vala"
		_g_object_unref0 (_tmp14_);
#line 750 "file.c"
	}
	goto __finally409;
	__catch409_g_error:
	{
		GError* err = NULL;
		gboolean _tmp18_ = FALSE;
		GError* _tmp19_;
		GError* _tmp21_;
		GError* _tmp22_;
#line 112 "../src/util/file.vala"
		err = _inner_error0_;
#line 112 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 119 "../src/util/file.vala"
		_tmp19_ = err;
#line 119 "../src/util/file.vala"
		if (g_error_matches (_tmp19_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 119 "../src/util/file.vala"
			_tmp18_ = TRUE;
#line 770 "file.c"
		} else {
			GError* _tmp20_;
#line 119 "../src/util/file.vala"
			_tmp20_ = err;
#line 119 "../src/util/file.vala"
			_tmp18_ = g_error_matches (_tmp20_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 777 "file.c"
		}
#line 119 "../src/util/file.vala"
		if (_tmp18_) {
#line 120 "../src/util/file.vala"
			result = (guint64) 0;
#line 120 "../src/util/file.vala"
			_g_error_free0 (err);
#line 120 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 120 "../src/util/file.vala"
			return result;
#line 789 "file.c"
		}
#line 122 "../src/util/file.vala"
		_tmp21_ = err;
#line 122 "../src/util/file.vala"
		_tmp22_ = _g_error_copy0 (_tmp21_);
#line 122 "../src/util/file.vala"
		_inner_error0_ = _tmp22_;
#line 122 "../src/util/file.vala"
		_g_error_free0 (err);
#line 799 "file.c"
		goto __finally409;
	}
	__finally409:
#line 112 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 805 "file.c"
		guint64 _tmp23_ = 0ULL;
#line 112 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 112 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 112 "../src/util/file.vala"
		return _tmp23_;
#line 813 "file.c"
	}
#line 125 "../src/util/file.vala"
	total_bytes = (guint64) 0;
#line 127 "../src/util/file.vala"
	info = NULL;
#line 128 "../src/util/file.vala"
	while (TRUE) {
#line 821 "file.c"
		GFileInfo* _tmp24_ = NULL;
		GFileEnumerator* _tmp25_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp28_;
		GFileInfo* _tmp29_;
		guint64 _tmp30_ = 0ULL;
		GFileInfo* _tmp31_;
		const gchar* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
		guint64 _tmp35_;
#line 128 "../src/util/file.vala"
		_tmp25_ = enumerator;
#line 128 "../src/util/file.vala"
		_tmp26_ = g_file_enumerator_next_file (_tmp25_, cancellable, &_inner_error0_);
#line 128 "../src/util/file.vala"
		_tmp24_ = _tmp26_;
#line 128 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 841 "file.c"
			guint64 _tmp27_ = 0ULL;
#line 128 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 128 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 128 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 128 "../src/util/file.vala"
			return _tmp27_;
#line 851 "file.c"
		}
#line 128 "../src/util/file.vala"
		_tmp28_ = _tmp24_;
#line 128 "../src/util/file.vala"
		_tmp24_ = NULL;
#line 128 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 128 "../src/util/file.vala"
		info = _tmp28_;
#line 128 "../src/util/file.vala"
		_tmp29_ = info;
#line 128 "../src/util/file.vala"
		if (!(_tmp29_ != NULL)) {
#line 128 "../src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 128 "../src/util/file.vala"
			break;
#line 869 "file.c"
		}
#line 129 "../src/util/file.vala"
		_tmp31_ = info;
#line 129 "../src/util/file.vala"
		_tmp32_ = g_file_info_get_name (_tmp31_);
#line 129 "../src/util/file.vala"
		_tmp33_ = g_file_get_child (file_or_dir, _tmp32_);
#line 129 "../src/util/file.vala"
		_tmp34_ = _tmp33_;
#line 129 "../src/util/file.vala"
		_tmp35_ = query_total_file_size (_tmp34_, cancellable, &_inner_error0_);
#line 129 "../src/util/file.vala"
		_g_object_unref0 (_tmp34_);
#line 129 "../src/util/file.vala"
		_tmp30_ = _tmp35_;
#line 129 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 887 "file.c"
			guint64 _tmp36_ = 0ULL;
#line 129 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (_tmp24_);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 129 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 129 "../src/util/file.vala"
			return _tmp36_;
#line 899 "file.c"
		}
#line 129 "../src/util/file.vala"
		total_bytes = total_bytes + _tmp30_;
#line 128 "../src/util/file.vala"
		_g_object_unref0 (_tmp24_);
#line 905 "file.c"
	}
#line 131 "../src/util/file.vala"
	result = total_bytes;
#line 131 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 131 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 131 "../src/util/file.vala"
	return result;
#line 915 "file.c"
}

void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  gpointer monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileType _tmp0_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp7_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError* _inner_error0_ = NULL;
#line 138 "../src/util/file.vala"
	g_return_if_fail (dir != NULL);
#line 140 "../src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 141 "../src/util/file.vala"
	_tmp0_ = type;
#line 141 "../src/util/file.vala"
	if (_tmp0_ != G_FILE_TYPE_DIRECTORY) {
#line 942 "file.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 142 "../src/util/file.vala"
		_tmp1_ = g_file_get_path (dir);
#line 142 "../src/util/file.vala"
		_tmp2_ = _tmp1_;
#line 142 "../src/util/file.vala"
		_tmp3_ = g_strdup_printf ("%s is not a directory", _tmp2_);
#line 142 "../src/util/file.vala"
		_tmp4_ = _tmp3_;
#line 142 "../src/util/file.vala"
		_tmp5_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp4_);
#line 142 "../src/util/file.vala"
		_tmp6_ = _tmp5_;
#line 142 "../src/util/file.vala"
		_g_free0 (_tmp4_);
#line 142 "../src/util/file.vala"
		_g_free0 (_tmp2_);
#line 142 "../src/util/file.vala"
		_inner_error0_ = _tmp6_;
#line 142 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 142 "../src/util/file.vala"
		return;
#line 971 "file.c"
	}
#line 144 "../src/util/file.vala"
	_tmp7_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 144 "../src/util/file.vala"
	enumerator = _tmp7_;
#line 144 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 144 "../src/util/file.vala"
		return;
#line 983 "file.c"
	}
#line 146 "../src/util/file.vala"
	info = NULL;
#line 147 "../src/util/file.vala"
	i = (guint64) 0;
#line 148 "../src/util/file.vala"
	while (TRUE) {
#line 991 "file.c"
		GFileInfo* _tmp8_ = NULL;
		GFileEnumerator* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp17_;
		const gchar* _tmp18_;
		GFile* _tmp19_;
		gboolean _tmp26_ = FALSE;
#line 148 "../src/util/file.vala"
		_tmp9_ = enumerator;
#line 148 "../src/util/file.vala"
		_tmp10_ = g_file_enumerator_next_file (_tmp9_, cancellable, &_inner_error0_);
#line 148 "../src/util/file.vala"
		_tmp8_ = _tmp10_;
#line 148 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 148 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 148 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 148 "../src/util/file.vala"
			return;
#line 1020 "file.c"
		}
#line 148 "../src/util/file.vala"
		_tmp11_ = _tmp8_;
#line 148 "../src/util/file.vala"
		_tmp8_ = NULL;
#line 148 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 148 "../src/util/file.vala"
		info = _tmp11_;
#line 148 "../src/util/file.vala"
		_tmp12_ = info;
#line 148 "../src/util/file.vala"
		if (!(_tmp12_ != NULL)) {
#line 148 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 148 "../src/util/file.vala"
			break;
#line 1038 "file.c"
		}
#line 149 "../src/util/file.vala"
		_tmp13_ = info;
#line 149 "../src/util/file.vala"
		if (g_file_info_get_file_type (_tmp13_) != G_FILE_TYPE_REGULAR) {
#line 150 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 150 "../src/util/file.vala"
			continue;
#line 1048 "file.c"
		}
#line 152 "../src/util/file.vala"
		if (exceptions != NULL) {
#line 1052 "file.c"
			GFileInfo* _tmp15_;
			const gchar* _tmp16_;
#line 152 "../src/util/file.vala"
			_tmp15_ = info;
#line 152 "../src/util/file.vala"
			_tmp16_ = g_file_info_get_name (_tmp15_);
#line 152 "../src/util/file.vala"
			_tmp14_ = gee_collection_contains ((GeeCollection*) exceptions, _tmp16_);
#line 1061 "file.c"
		} else {
#line 152 "../src/util/file.vala"
			_tmp14_ = FALSE;
#line 1065 "file.c"
		}
#line 152 "../src/util/file.vala"
		if (_tmp14_) {
#line 153 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 153 "../src/util/file.vala"
			continue;
#line 1073 "file.c"
		}
#line 155 "../src/util/file.vala"
		_tmp17_ = info;
#line 155 "../src/util/file.vala"
		_tmp18_ = g_file_info_get_name (_tmp17_);
#line 155 "../src/util/file.vala"
		_tmp19_ = g_file_get_child (dir, _tmp18_);
#line 155 "../src/util/file.vala"
		file = _tmp19_;
#line 1083 "file.c"
		{
			GFile* _tmp20_;
#line 157 "../src/util/file.vala"
			_tmp20_ = file;
#line 157 "../src/util/file.vala"
			g_file_delete (_tmp20_, cancellable, &_inner_error0_);
#line 157 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1092 "file.c"
				goto __catch410_g_error;
			}
		}
		goto __finally410;
		__catch410_g_error:
		{
			GError* err = NULL;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 156 "../src/util/file.vala"
			err = _inner_error0_;
#line 156 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 159 "../src/util/file.vala"
			_tmp21_ = file;
#line 159 "../src/util/file.vala"
			_tmp22_ = g_file_get_path (_tmp21_);
#line 159 "../src/util/file.vala"
			_tmp23_ = _tmp22_;
#line 159 "../src/util/file.vala"
			_tmp24_ = err;
#line 159 "../src/util/file.vala"
			_tmp25_ = _tmp24_->message;
#line 159 "../src/util/file.vala"
			g_warning ("file.vala:159: Unable to delete file %s: %s", _tmp23_, _tmp25_);
#line 159 "../src/util/file.vala"
			_g_free0 (_tmp23_);
#line 156 "../src/util/file.vala"
			_g_error_free0 (err);
#line 1125 "file.c"
		}
		__finally410:
#line 156 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (file);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (_tmp8_);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 156 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 156 "../src/util/file.vala"
			return;
#line 1142 "file.c"
		}
#line 162 "../src/util/file.vala"
		if (monitor != NULL) {
#line 162 "../src/util/file.vala"
			_tmp26_ = file_count > ((guint64) 0);
#line 1148 "file.c"
		} else {
#line 162 "../src/util/file.vala"
			_tmp26_ = FALSE;
#line 1152 "file.c"
		}
#line 162 "../src/util/file.vala"
		if (_tmp26_) {
#line 163 "../src/util/file.vala"
			i = i + 1;
#line 163 "../src/util/file.vala"
			monitor (file_count, i, TRUE, monitor_target);
#line 1160 "file.c"
		}
#line 148 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 148 "../src/util/file.vala"
		_g_object_unref0 (_tmp8_);
#line 1166 "file.c"
	}
#line 138 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 138 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1172 "file.c"
}

time_t
query_file_modified (GFile* file,
                     GError** error)
{
	time_t result = 0;
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GTimeVal _tmp2_ = {0};
	GError* _inner_error0_ = NULL;
#line 167 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 168 "../src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 168 "../src/util/file.vala"
	info = _tmp0_;
#line 168 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1192 "file.c"
		time_t _tmp1_ = 0;
#line 168 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 168 "../src/util/file.vala"
		return _tmp1_;
#line 1198 "file.c"
	}
#line 171 "../src/util/file.vala"
	g_file_info_get_modification_time (info, &_tmp2_);
#line 171 "../src/util/file.vala"
	result = (time_t) _tmp2_.tv_sec;
#line 171 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 171 "../src/util/file.vala"
	return result;
#line 1208 "file.c"
}

gboolean
query_is_directory (GFile* file)
{
	gboolean result = FALSE;
#line 174 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 175 "../src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) == G_FILE_TYPE_DIRECTORY;
#line 175 "../src/util/file.vala"
	return result;
#line 1221 "file.c"
}

gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	gboolean result = FALSE;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 178 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 179 "../src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 180 "../src/util/file.vala"
		result = FALSE;
#line 180 "../src/util/file.vala"
		return result;
#line 1244 "file.c"
	}
#line 182 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 182 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 182 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1252 "file.c"
		gboolean _tmp1_ = FALSE;
#line 182 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 182 "../src/util/file.vala"
		return _tmp1_;
#line 1258 "file.c"
	}
#line 184 "../src/util/file.vala"
	_tmp2_ = enumerator;
#line 184 "../src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 185 "../src/util/file.vala"
		result = FALSE;
#line 185 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 185 "../src/util/file.vala"
		return result;
#line 1270 "file.c"
	}
#line 187 "../src/util/file.vala"
	_tmp4_ = enumerator;
#line 187 "../src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 187 "../src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 187 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1280 "file.c"
		gboolean _tmp6_ = FALSE;
#line 187 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 187 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 187 "../src/util/file.vala"
		return _tmp6_;
#line 1288 "file.c"
	}
#line 187 "../src/util/file.vala"
	result = _tmp3_ == NULL;
#line 187 "../src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 187 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 187 "../src/util/file.vala"
	return result;
#line 1298 "file.c"
}

gchar*
get_display_pathname (GFile* file)
{
	gchar* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 190 "../src/util/file.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 192 "../src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 192 "../src/util/file.vala"
	path = _tmp0_;
#line 193 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 193 "../src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 193 "../src/util/file.vala"
	home = _tmp2_;
#line 195 "../src/util/file.vala"
	_tmp3_ = path;
#line 195 "../src/util/file.vala"
	_tmp4_ = home;
#line 195 "../src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1332 "file.c"
		gchar* _tmp5_;
#line 196 "../src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 196 "../src/util/file.vala"
		result = _tmp5_;
#line 196 "../src/util/file.vala"
		_g_free0 (home);
#line 196 "../src/util/file.vala"
		_g_free0 (path);
#line 196 "../src/util/file.vala"
		return result;
#line 1344 "file.c"
	}
#line 198 "../src/util/file.vala"
	_tmp6_ = path;
#line 198 "../src/util/file.vala"
	_tmp7_ = home;
#line 198 "../src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1352 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 199 "../src/util/file.vala"
		_tmp8_ = path;
#line 199 "../src/util/file.vala"
		_tmp9_ = home;
#line 199 "../src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 199 "../src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 199 "../src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 199 "../src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 199 "../src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 199 "../src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 199 "../src/util/file.vala"
		_g_free0 (_tmp13_);
#line 199 "../src/util/file.vala"
		result = _tmp15_;
#line 199 "../src/util/file.vala"
		_g_free0 (home);
#line 199 "../src/util/file.vala"
		_g_free0 (path);
#line 199 "../src/util/file.vala"
		return result;
#line 1387 "file.c"
	}
#line 201 "../src/util/file.vala"
	result = path;
#line 201 "../src/util/file.vala"
	_g_free0 (home);
#line 201 "../src/util/file.vala"
	return result;
#line 1395 "file.c"
}

gchar*
strip_pretty_path (const gchar* path)
{
	gchar* result = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 204 "../src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 205 "../src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1411 "file.c"
		gchar* _tmp0_;
#line 206 "../src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 206 "../src/util/file.vala"
		result = _tmp0_;
#line 206 "../src/util/file.vala"
		return result;
#line 1419 "file.c"
	}
#line 208 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 208 "../src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 208 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 208 "../src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 208 "../src/util/file.vala"
	_g_free0 (_tmp3_);
#line 208 "../src/util/file.vala"
	result = _tmp5_;
#line 208 "../src/util/file.vala"
	return result;
#line 1437 "file.c"
}

gchar*
get_file_info_id (GFileInfo* info)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 211 "../src/util/file.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 212 "../src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 212 "../src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 212 "../src/util/file.vala"
	result = _tmp1_;
#line 212 "../src/util/file.vala"
	return result;
#line 1456 "file.c"
}

void
skip_uint64 (GInputStream* input,
             guint64 skip_amount,
             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 216 "../src/util/file.vala"
	g_return_if_fail (input != NULL);
#line 217 "../src/util/file.vala"
	while (TRUE) {
#line 217 "../src/util/file.vala"
		if (!(skip_amount > ((guint64) 0))) {
#line 217 "../src/util/file.vala"
			break;
#line 1473 "file.c"
		}
#line 219 "../src/util/file.vala"
		if (skip_amount >= ((guint64) G_MAXSSIZE)) {
#line 220 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) G_MAXSSIZE, NULL, &_inner_error0_);
#line 220 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 220 "../src/util/file.vala"
				return;
#line 1485 "file.c"
			}
#line 221 "../src/util/file.vala"
			skip_amount = skip_amount - G_MAXSSIZE;
#line 1489 "file.c"
		} else {
#line 223 "../src/util/file.vala"
			g_input_stream_skip (input, (gsize) skip_amount, NULL, &_inner_error0_);
#line 223 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/util/file.vala"
				g_propagate_error (error, _inner_error0_);
#line 223 "../src/util/file.vala"
				return;
#line 1499 "file.c"
			}
#line 224 "../src/util/file.vala"
			skip_amount = (guint64) 0;
#line 1503 "file.c"
		}
	}
}

guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 result = 0ULL;
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 230 "../src/util/file.vala"
	g_return_val_if_fail (dir != NULL, 0ULL);
#line 231 "../src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 232 "../src/util/file.vala"
		result = (guint64) 0;
#line 232 "../src/util/file.vala"
		return result;
#line 1526 "file.c"
	}
#line 234 "../src/util/file.vala"
	count = (guint64) 0;
#line 235 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 235 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 235 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1536 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 235 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 235 "../src/util/file.vala"
		return _tmp1_;
#line 1542 "file.c"
	}
#line 238 "../src/util/file.vala"
	info = NULL;
#line 239 "../src/util/file.vala"
	while (TRUE) {
#line 1548 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 239 "../src/util/file.vala"
		_tmp3_ = enumerator;
#line 239 "../src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 239 "../src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 239 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1563 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 239 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 239 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 239 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 239 "../src/util/file.vala"
			return _tmp5_;
#line 1573 "file.c"
		}
#line 239 "../src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 239 "../src/util/file.vala"
		_tmp2_ = NULL;
#line 239 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 239 "../src/util/file.vala"
		info = _tmp6_;
#line 239 "../src/util/file.vala"
		_tmp7_ = info;
#line 239 "../src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 239 "../src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 239 "../src/util/file.vala"
			break;
#line 1591 "file.c"
		}
#line 240 "../src/util/file.vala"
		_tmp8_ = count;
#line 240 "../src/util/file.vala"
		count = _tmp8_ + 1;
#line 239 "../src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1599 "file.c"
	}
#line 242 "../src/util/file.vala"
	result = count;
#line 242 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 242 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 242 "../src/util/file.vala"
	return result;
#line 1609 "file.c"
}

gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 247 "../src/util/file.vala"
	if (a != NULL) {
#line 247 "../src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1623 "file.c"
	} else {
#line 247 "../src/util/file.vala"
		_tmp1_ = FALSE;
#line 1627 "file.c"
	}
#line 247 "../src/util/file.vala"
	if (_tmp1_) {
#line 247 "../src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1633 "file.c"
	} else {
#line 247 "../src/util/file.vala"
		_tmp0_ = FALSE;
#line 1637 "file.c"
	}
#line 247 "../src/util/file.vala"
	result = _tmp0_;
#line 247 "../src/util/file.vala"
	return result;
#line 1643 "file.c"
}

guint
file_hash (GFile* file)
{
	guint result = 0U;
	guint _tmp0_ = 0U;
#line 252 "../src/util/file.vala"
	if (file != NULL) {
#line 252 "../src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1655 "file.c"
	} else {
#line 252 "../src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1659 "file.c"
	}
#line 252 "../src/util/file.vala"
	result = _tmp0_;
#line 252 "../src/util/file.vala"
	return result;
#line 1665 "file.c"
}

