/* DirectoryMonitor.c generated by valac 0.44.3, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery () must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories*/
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e.*/
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info (), get_file_id (), and*/
/* get_etag ().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;
enum  {
	DIRECTORY_MONITOR_0_PROPERTY,
	DIRECTORY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* directory_monitor_properties[DIRECTORY_MONITOR_NUM_PROPERTIES];
typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;
enum  {
	DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL,
	DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL,
	DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_CREATED_SIGNAL,
	DIRECTORY_MONITOR_FILE_MOVED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_FILE_DELETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL,
	DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL,
	DIRECTORY_MONITOR_CLOSED_SIGNAL,
	DIRECTORY_MONITOR_NUM_SIGNALS
};
static guint directory_monitor_signals[DIRECTORY_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _dir_child_size;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _dir_child_index;
	GFile* dir_child;
	GeeArrayList* _tmp10_;
	gpointer _tmp11_;
	GFileInfo* dir_info;
	DirectoryMonitorFileInfoMap* _tmp12_;
	GFile* _tmp13_;
	GFileInfo* _tmp14_;
	GFileInfo* _tmp15_;
	GFile* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GFile* _tmp19_;
	GFileInfo* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	GFileInfo* _tmp26_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp27_;
	GeeArrayList* _tmp28_;
	gint _file_child_size;
	GeeArrayList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _file_child_index;
	GFile* file_child;
	GeeArrayList* _tmp32_;
	gpointer _tmp33_;
	GFileInfo* file_info;
	DirectoryMonitorFileInfoMap* _tmp34_;
	GFile* _tmp35_;
	GFileInfo* _tmp36_;
	GFileInfo* _tmp37_;
	GFile* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GFile* _tmp41_;
	GFile* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GFile* _tmp45_;
	GFile* _tmp46_;
	GFileInfo* _tmp47_;
	DirectoryMonitorFileInfoMap* _tmp48_;
	gboolean updated;
	DirectoryMonitorFileInfoMap* _tmp49_;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* file_children;
	GeeArrayList* _tmp0_;
	GeeArrayList* dir_children;
	GeeArrayList* _tmp1_;
	gint count;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _dir_child_size;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _dir_child_index;
	GFile* dir_child;
	GeeArrayList* _tmp10_;
	gpointer _tmp11_;
	GFile* _tmp12_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
	gint _file_child_size;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _file_child_index;
	GFile* file_child;
	GeeArrayList* _tmp18_;
	gpointer _tmp19_;
	DirectoryMonitorFileInfoMap* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	DirectoryMonitorFileInfoMap* _tmp23_;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFileInfo* _tmp5_;
	GCancellable* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
	GError* err;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GFileInfo* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFileInfo* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GFileInfo* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFileInfo* _tmp25_;
	GEnumValue* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* enumerator;
	GCancellable* _tmp29_;
	GFileEnumerator* _tmp30_;
	gboolean _tmp31_;
	GList* infos;
	GFileEnumerator* _tmp32_;
	GCancellable* _tmp33_;
	GList* _tmp34_;
	GList* _tmp35_;
	GList* _tmp36_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp37_;
	GFileInfo* info;
	GFileInfo* _tmp38_;
	GFileInfo* _tmp39_;
	const gchar* _tmp40_;
	GFile* _tmp41_;
	GFile* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GFileInfo* _tmp45_;
	GFileInfo* _tmp46_;
	GeeHashMap* _tmp47_;
	GeeHashMap* _tmp48_;
	GeeHashMap* _tmp49_;
	GFileInfo* _tmp50_;
	const gchar* _tmp51_;
	GFile* _tmp52_;
	GFile* _tmp53_;
	GFileInfo* _tmp54_;
	GeeHashMap* _tmp55_;
	GeeHashMap* _tmp56_;
	GeeHashMap* _tmp57_;
	GFileInfo* _tmp58_;
	const gchar* _tmp59_;
	GFile* _tmp60_;
	GFile* _tmp61_;
	GFileInfo* _tmp62_;
	GError* err2;
	gchar* _tmp63_;
	gchar* _tmp64_;
	GError* _tmp65_;
	const gchar* _tmp66_;
	GFileInfo* _tmp67_;
	GFileInfo* _tmp68_;
	GFileInfo* _tmp69_;
	GeeHashMap* _tmp70_;
	GeeHashMap* _tmp71_;
	gboolean _tmp72_;
	GeeHashMap* _tmp73_;
	GeeIterator* _subdir_it;
	GeeHashMap* _tmp74_;
	GeeSet* _tmp75_;
	GeeSet* _tmp76_;
	GeeSet* _tmp77_;
	GeeIterator* _tmp78_;
	GeeIterator* _tmp79_;
	GeeIterator* _tmp80_;
	GFile* subdir;
	GeeIterator* _tmp81_;
	gpointer _tmp82_;
	GFile* _tmp83_;
	GeeHashMap* _tmp84_;
	GFile* _tmp85_;
	gpointer _tmp86_;
	GFileInfo* _tmp87_;
	GFile* _tmp88_;
	GeeHashMap* _tmp89_;
	GFile* _tmp90_;
	gpointer _tmp91_;
	GFileInfo* _tmp92_;
	GError* _inner_error0_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMapIterator* _tmp2_;
	gpointer _tmp3_;
	GFile* _tmp4_;
	GeeMapIterator* _tmp5_;
	gpointer _tmp6_;
	GFileInfo* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	GFile* _tmp10_;
	GeeMapIterator* _tmp11_;
	gpointer _tmp12_;
	GFileInfo* _tmp13_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};

static gint DirectoryMonitor_private_offset;
static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gint DirectoryMonitorFileInfoMap_private_offset;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                           gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                            gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value,
                                                 gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType directory_monitor_ftype_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
DirectoryMonitor* directory_monitor_new (GFile* root,
                                         gboolean recurse,
                                         gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type,
                                               GFile* root,
                                               gboolean recurse,
                                               gboolean monitoring);
void directory_monitor_mdbg (const gchar* msg);
gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self,
                                            GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                                 GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                                   GFile* old_root,
                                                   GFile* new_root,
                                                   GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                                 GFile* file,
                                                 GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self,
                                          GFile* old_root,
                                          GFile* new_root,
                                          GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                               GFile* old_root,
                                               GFile* new_root,
                                               GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self,
                                                        GFile* file,
                                                        GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self,
                                               GFile* file,
                                               GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                             GFile* dir,
                                                             GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self,
                                                    GFile* dir,
                                                    GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self,
                                                const gchar* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                     const gchar* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                     GFile* file,
                                                     GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile* * old_file,
                                                GFileInfo* * old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                                   GFile* old_file,
                                                   GFile* new_file,
                                                   GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                               GFile* old_file,
                                               GFile* new_file,
                                               GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* file,
                                                                  GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                              GFile* file,
                                                              GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                            GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                     GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                                 GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                          GFile* dir,
                                                          GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                         GFile* root,
                                                         DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                        GFile* old_dir,
                                                        GFileInfo* old_dir_info,
                                                        GFile* new_dir,
                                                        GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self,
                                                 GFile* dir,
                                                 GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                      GFile* dir,
                                                      GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                              GFile* old_dir,
                                                              GFileInfo* old_dir_info,
                                                              GFile* new_dir,
                                                              GFileInfo* new_dir_info,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                     GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static void directory_monitor_async_internal_notify_directory_moved_async_ready_wrapper (GObject *source_object,
                                                                                  GAsyncResult *res,
                                                                                  void *user_data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                                   GFile* root,
                                                   GeeCollection* files,
                                                   GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                                     GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self,
                                           GFile* dir,
                                           GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self,
                                        GFile* dir,
                                        GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self,
                                               GFile* old_dir,
                                               GFile* new_dir,
                                               GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                                    GFile* old_dir,
                                                    GFile* new_dir,
                                                    GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self,
                                                 GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                      GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                       GFile* dir,
                                                                       GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                              GFile* dir,
                                                              GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                   GFile* dir,
                                                                   GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                            GFile* dir);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                                 GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       gboolean already_removed,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                              GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static void directory_monitor_async_notify_directory_deleted_async_ready_wrapper (GObject *source_object,
                                                                           GAsyncResult *res,
                                                                           void *user_data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self,
                                                 GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                      GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self,
                                       GFile* file);
gboolean directory_monitor_has_started (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self,
                                      GFile* dir,
                                      GFileInfo* dir_info,
                                      gboolean in_discovery,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self,
                                       GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                       GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
const gchar* g_file_type_to_string (GFileType self);
static void directory_monitor_explore_async_data_free (gpointer _data);
static void directory_monitor_explore_async_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                                   GFile* file,
                                                   GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                                    gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
gchar* get_file_info_id (GFileInfo* info);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                               GeeMap* map,
                                               gboolean in_discovery,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                      GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static void directory_monitor_notify_directory_files_async_ready_wrapper (GObject *source_object,
                                                                   GAsyncResult *res,
                                                                   void *user_data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                               GFile* file,
                                               GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                        GFile* file,
                                                                        GFile* other_file,
                                                                        GFileMonitorEvent event_type,
                                                                        gpointer self);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                                                       GFile* file,
                                                                                       GFile* other_file,
                                                                                       GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type,
                                                                                             DirectoryMonitor* owner,
                                                                                             GFile* file,
                                                                                             GFile* other_file,
                                                                                             GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                              GObject* source,
                                                              GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                     GAsyncResult* res,
                                                                                     gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self,
                                            DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                                   GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileInfo* info,
                                                      GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self,
                                            GFile* file);
gulong now_ms (void);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self,
                                              GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                                       GFile* file,
                                                       GCancellable* cancellable);
static void directory_monitor_real_root_moved (DirectoryMonitor* self,
                                        GFile* old_root,
                                        GFile* new_root,
                                        GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                          GFile* root);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                              const gchar* reason);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_file_created (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self,
                                        GFile* old_file,
                                        GFile* new_file,
                                        GFileInfo* new_file_info);
static void directory_monitor_real_file_altered (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                       GFile* file,
                                                       GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                     GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                          GFile* file);
static void directory_monitor_real_directory_created (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                             GFile* old_dir,
                                             GFile* new_dir,
                                             GFileInfo* new_dir_info);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                            GFile* dir,
                                                            GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                          GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                               GFile* dir);
static void directory_monitor_real_closed (DirectoryMonitor* self);
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj);
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                         GFile* file,
                                                         GFileInfo* info,
                                                         GFile* * normalized,
                                                         gchar* * id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                                 GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj);
static void directory_monitor_finalize (GObject * obj);

static inline gpointer
directory_monitor_get_instance_private (DirectoryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitor_private_offset);
}

static GType
directory_monitor_ftype_get_type (void)
{
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 472 "../src/DirectoryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 1011 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_construct (GType object_type,
                             GFile* root,
                             gboolean recurse,
                             gboolean monitoring)
{
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
#line 471 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 471 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 472 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 472 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 472 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp0_;
#line 473 "../src/DirectoryMonitor.vala"
	self->priv->recurse = recurse;
#line 474 "../src/DirectoryMonitor.vala"
	self->priv->monitoring = monitoring;
#line 471 "../src/DirectoryMonitor.vala"
	return self;
#line 1038 "DirectoryMonitor.c"
}

DirectoryMonitor*
directory_monitor_new (GFile* root,
                       gboolean recurse,
                       gboolean monitoring)
{
#line 471 "../src/DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 1048 "DirectoryMonitor.c"
}

void
directory_monitor_mdbg (const gchar* msg)
{
#line 477 "../src/DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 1056 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_recursive (DirectoryMonitor* self)
{
	gboolean result = FALSE;
#line 483 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 484 "../src/DirectoryMonitor.vala"
	result = self->priv->recurse;
#line 484 "../src/DirectoryMonitor.vala"
	return result;
#line 1069 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_monitoring (DirectoryMonitor* self)
{
	gboolean result = FALSE;
#line 487 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 488 "../src/DirectoryMonitor.vala"
	result = self->priv->monitoring;
#line 488 "../src/DirectoryMonitor.vala"
	return result;
#line 1082 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_deleted (DirectoryMonitor* self,
                                            GFile* root)
{
	GFile* _tmp0_;
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 492 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 492 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, root), "this.root.equal (root)");
#line 494 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 495 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL], 0, root);
#line 1100 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_deleted (DirectoryMonitor* self,
                                       GFile* root)
{
#line 491 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 491 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
#line 1111 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_root_moved (DirectoryMonitor* self,
                                              GFile* old_root,
                                              GFile* new_root,
                                              GFileInfo* new_root_info)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
#line 498 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 498 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 498 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 499 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 499 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, old_root, NULL);
#line 500 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 502 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 502 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_root, new_root_info);
#line 503 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 505 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (new_root);
#line 505 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 505 "../src/DirectoryMonitor.vala"
	self->priv->root = _tmp2_;
#line 507 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
#line 1153 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_root_moved (DirectoryMonitor* self,
                                          GFile* old_root,
                                          GFile* new_root,
                                          GFileInfo* new_root_info)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 510 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 510 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 510 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 511 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 511 "../src/DirectoryMonitor.vala"
	_vala_assert (g_file_equal (_tmp0_, old_root), "this.root.equal (old_root)");
#line 513 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (old_root);
#line 513 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 513 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_file_get_path (new_root);
#line 513 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 513 "../src/DirectoryMonitor.vala"
	_tmp5_ = g_strdup_printf ("root moved: %s -> %s", _tmp2_, _tmp4_);
#line 513 "../src/DirectoryMonitor.vala"
	_tmp6_ = _tmp5_;
#line 513 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp6_);
#line 513 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp6_);
#line 513 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 513 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 514 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL], 0, old_root, new_root, new_root_info);
#line 1201 "DirectoryMonitor.c"
}

void
directory_monitor_notify_root_moved (DirectoryMonitor* self,
                                     GFile* old_root,
                                     GFile* new_root,
                                     GFileInfo* new_root_info)
{
#line 510 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 510 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
#line 1214 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_discovery_started (DirectoryMonitor* self)
{
#line 518 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 519 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL], 0);
#line 1224 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_started (DirectoryMonitor* self)
{
#line 517 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 517 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
#line 1234 "DirectoryMonitor.c"
}

static void
directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self,
                                                        GFile* file,
                                                        GFileInfo* info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 522 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 522 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 523 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 523 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_file_info_map_update (_tmp0_, file, info)) {
#line 1251 "DirectoryMonitor.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 524 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (file);
#line 524 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 524 "../src/DirectoryMonitor.vala"
		g_debug ("DirectoryMonitor.vala:524: DirectoryMonitor.internal_notify_file_disco" \
"vered: %s discovered but not added to file map", _tmp2_);
#line 524 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp2_);
#line 527 "../src/DirectoryMonitor.vala"
		return;
#line 1264 "DirectoryMonitor.c"
	}
#line 530 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, file, info);
#line 1268 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self,
                                                   GFile* file,
                                                   GFileInfo* info)
{
#line 522 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
#line 1280 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_discovered (DirectoryMonitor* self,
                                               GFile* file,
                                               GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 533 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 533 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 534 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 534 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 534 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file discovered: %s", _tmp1_);
#line 534 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 534 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 534 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 534 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 535 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL], 0, file, info);
#line 1312 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_discovered (DirectoryMonitor* self,
                                          GFile* file,
                                          GFileInfo* info)
{
#line 533 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 533 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
#line 1324 "DirectoryMonitor.c"
}

static void
directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                             GFile* dir,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 539 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 539 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 540 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 542 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, dir, info);
#line 1346 "DirectoryMonitor.c"
}

void
directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self,
                                                        GFile* dir,
                                                        GFileInfo* info)
{
#line 538 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 538 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
#line 1358 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self,
                                                    GFile* dir,
                                                    GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 545 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 545 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 546 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 546 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 546 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory discovered: %s", _tmp1_);
#line 546 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 546 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 546 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 546 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 547 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL], 0, dir, info);
#line 1390 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_discovered (DirectoryMonitor* self,
                                               GFile* dir,
                                               GFileInfo* info)
{
#line 545 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 545 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
#line 1402 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self,
                                                const gchar* reason)
{
#line 550 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 551 "../src/DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:551: discovery failed: %s", reason);
#line 552 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL], 0, reason);
#line 1415 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_failed (DirectoryMonitor* self,
                                           const gchar* reason)
{
#line 550 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
#line 1426 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self)
{
#line 556 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL], 0);
#line 1434 "DirectoryMonitor.c"
}

void
directory_monitor_notify_discovery_completed (DirectoryMonitor* self)
{
#line 555 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
#line 1444 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_file_created (DirectoryMonitor* self,
                                                GFile* file,
                                                GFileInfo* info)
{
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 559 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 559 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 562 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp1_);
#line 562 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 562 "../src/DirectoryMonitor.vala"
	old_file = _tmp0_;
#line 562 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 562 "../src/DirectoryMonitor.vala"
	old_file_info = _tmp1_;
#line 562 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1475 "DirectoryMonitor.c"
		GFile* _tmp3_;
#line 563 "../src/DirectoryMonitor.vala"
		_tmp3_ = old_file;
#line 563 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, _tmp3_, file, info);
#line 1481 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp4_;
#line 565 "../src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->files;
#line 565 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp4_, file, info);
#line 566 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 568 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, file, info);
#line 1493 "DirectoryMonitor.c"
	}
#line 559 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 559 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 1499 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 572 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 572 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 573 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 573 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 573 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file created: %s", _tmp1_);
#line 573 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 573 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 573 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 573 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 574 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL], 0, file, info);
#line 1531 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_created (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info)
{
#line 572 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 572 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
#line 1543 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_file_moved (DirectoryMonitor* self,
                                              GFile* old_file,
                                              GFile* new_file,
                                              GFileInfo* new_file_info)
{
	DirectoryMonitorFileInfoMap* _tmp0_;
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp1_;
#line 577 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 577 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 577 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 577 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 580 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 580 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_tmp0_, old_file, NULL);
#line 582 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 582 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp1_, new_file, new_file_info);
#line 583 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 585 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
#line 1575 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 588 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 588 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 588 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 589 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_file);
#line 589 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 589 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_file);
#line 589 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 589 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("file moved: %s -> %s", _tmp1_, _tmp3_);
#line 589 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 589 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 589 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 589 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 589 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 590 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL], 0, old_file, new_file, new_file_info);
#line 1618 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                     GFile* old_file,
                                     GFile* new_file,
                                     GFileInfo* new_file_info)
{
#line 588 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 588 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1631 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 593 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 594 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 594 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 594 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file altered: %s", _tmp1_);
#line 594 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 594 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 594 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 594 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 595 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL], 0, file);
#line 1660 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                       GFile* file)
{
#line 593 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 593 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
#line 1671 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self,
                                                             GFile* file,
                                                             GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 598 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 599 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 599 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, file, info);
#line 600 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 602 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, file, info);
#line 1695 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 605 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 605 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 606 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 606 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 606 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file alteration completed: %s", _tmp1_);
#line 606 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 606 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 606 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 606 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 607 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL], 0, file, info);
#line 1727 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                    GFile* file,
                                                    GFileInfo* info)
{
#line 605 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
#line 1739 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 610 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 611 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 611 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 611 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file attributes altered: %s", _tmp1_);
#line 611 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 611 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 611 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 611 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 612 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL], 0, file);
#line 1768 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                  GFile* file)
{
#line 610 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 610 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file);
#line 1779 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self,
                                                GFile* file)
{
	gboolean removed = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 615 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 615 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 616 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 616 "../src/DirectoryMonitor.vala"
	removed = directory_monitor_file_info_map_remove (_tmp0_, file, NULL);
#line 617 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 619 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, file);
#line 1800 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 622 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 623 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 623 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 623 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("file deleted: %s", _tmp1_);
#line 623 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 623 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 623 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 623 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 624 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL], 0, file);
#line 1829 "DirectoryMonitor.c"
}

void
directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                       GFile* file)
{
#line 622 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
#line 1840 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_directory_created (DirectoryMonitor* self,
                                                     GFile* dir,
                                                     GFileInfo* info)
{
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
#line 627 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 627 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 630 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp1_);
#line 630 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 630 "../src/DirectoryMonitor.vala"
	old_dir = _tmp0_;
#line 630 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 630 "../src/DirectoryMonitor.vala"
	old_dir_info = _tmp1_;
#line 630 "../src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 1871 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
#line 636 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->files;
#line 636 "../src/DirectoryMonitor.vala"
		_tmp4_ = old_dir;
#line 636 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 636 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (_tmp3_, _tmp4_, _tmp5_);
#line 638 "../src/DirectoryMonitor.vala"
		_tmp6_ = old_dir;
#line 638 "../src/DirectoryMonitor.vala"
		_tmp7_ = old_dir_info;
#line 638 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, _tmp6_, _tmp7_, dir, info);
#line 1891 "DirectoryMonitor.c"
	} else {
		gboolean updated = FALSE;
		DirectoryMonitorFileInfoMap* _tmp8_;
#line 640 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->files;
#line 640 "../src/DirectoryMonitor.vala"
		updated = directory_monitor_file_info_map_update (_tmp8_, dir, info);
#line 641 "../src/DirectoryMonitor.vala"
		_vala_assert (updated, "updated");
#line 643 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, dir, info);
#line 1903 "DirectoryMonitor.c"
	}
#line 627 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 627 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 1909 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_created (DirectoryMonitor* self,
                                                 GFile* dir,
                                                 GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 647 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 647 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 648 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 648 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 648 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory created: %s", _tmp1_);
#line 648 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 648 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 648 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 648 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 649 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL], 0, dir, info);
#line 1941 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_created (DirectoryMonitor* self,
                                            GFile* dir,
                                            GFileInfo* info)
{
#line 647 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 647 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
#line 1953 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self,
                                                   GFile* old_dir,
                                                   GFileInfo* old_dir_info,
                                                   GFile* new_dir,
                                                   GFileInfo* new_dir_info)
{
#line 652 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 652 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 652 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir_info != NULL);
#line 652 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 652 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 654 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, old_dir, old_dir_info, new_dir, new_dir_info, NULL, NULL);
#line 1975 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, _data_);
#line 1995 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_async_ready_wrapper (GObject *source_object,
                                                                             GAsyncResult *res,
                                                                             void *user_data)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _task_data_;
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 73 "../src/DirectoryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2010 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2014 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self,
                                                         GFile* old_dir,
                                                         GFileInfo* old_dir_info,
                                                         GFile* new_dir,
                                                         GFileInfo* new_dir_info,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, directory_monitor_async_internal_notify_directory_moved_async_ready_wrapper, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	if (_callback_ == NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 2042 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->old_dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->old_dir_info = _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp3_ = _g_object_ref0 (new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->new_dir = _tmp3_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->new_dir_info = _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2076 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self,
                                                                GAsyncResult* _res_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2086 "DirectoryMonitor.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 659 "../src/DirectoryMonitor.vala"
	return result;
#line 2098 "DirectoryMonitor.c"
}

static void
directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 674 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 674 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 674 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 674 "../src/DirectoryMonitor.vala"
	_data_->_task_complete_ = TRUE;
#line 674 "../src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2117 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
#line 690 "../src/DirectoryMonitor.vala"
	return result;
#line 2127 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_)
{
#line 657 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 657 "../src/DirectoryMonitor.vala"
		case 0:
#line 2137 "DirectoryMonitor.c"
		goto _state_0;
#line 657 "../src/DirectoryMonitor.vala"
		case 1:
#line 2141 "DirectoryMonitor.c"
		goto _state_1;
#line 657 "../src/DirectoryMonitor.vala"
		case 2:
#line 2145 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 657 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2150 "DirectoryMonitor.c"
	}
	_state_0:
#line 659 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 659 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 660 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 660 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 661 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 661 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 661 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 661 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->old_dir, (GeeCollection*) _data_->_tmp3_, (GeeCollection*) _data_->_tmp4_);
#line 662 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2171 "DirectoryMonitor.c"
		{
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _g_object_ref0 (_data_->_tmp5_);
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp6_;
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = _data_->_dir_child_list;
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp7_);
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp9_;
#line 666 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 666 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 666 "../src/DirectoryMonitor.vala"
				if (!(_data_->_dir_child_index < _data_->_dir_child_size)) {
#line 666 "../src/DirectoryMonitor.vala"
					break;
#line 2197 "DirectoryMonitor.c"
				}
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_list;
#line 666 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp10_, _data_->_dir_child_index);
#line 666 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp11_;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = _data_->self->priv->files;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp13_ = _data_->dir_child;
#line 667 "../src/DirectoryMonitor.vala"
				_data_->_tmp14_ = directory_monitor_file_info_map_get_info (_data_->_tmp12_, _data_->_tmp13_);
#line 667 "../src/DirectoryMonitor.vala"
				_data_->dir_info = _data_->_tmp14_;
#line 668 "../src/DirectoryMonitor.vala"
				_data_->_tmp15_ = _data_->dir_info;
#line 668 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp15_ == NULL) {
#line 669 "../src/DirectoryMonitor.vala"
					_data_->_tmp16_ = _data_->dir_child;
#line 669 "../src/DirectoryMonitor.vala"
					_data_->_tmp17_ = g_file_get_path (_data_->_tmp16_);
#line 669 "../src/DirectoryMonitor.vala"
					_data_->_tmp18_ = _data_->_tmp17_;
#line 669 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:669: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp18_);
#line 669 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp18_);
#line 671 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_info);
#line 671 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_child);
#line 671 "../src/DirectoryMonitor.vala"
					continue;
#line 2233 "DirectoryMonitor.c"
				}
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->dir_child;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->dir_info;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->dir_child;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = g_file_get_basename (_data_->_tmp21_);
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp24_ = g_file_get_child (_data_->new_dir, _data_->_tmp23_);
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_tmp26_ = _data_->dir_info;
#line 674 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 674 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved (_data_->self, _data_->_tmp19_, _data_->_tmp20_, _data_->_tmp25_, _data_->_tmp26_, directory_monitor_async_internal_notify_directory_moved_ready, _data_);
#line 674 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2257 "DirectoryMonitor.c"
				_state_1:
#line 674 "../src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (_data_->self, _data_->_res_);
#line 674 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 674 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp23_);
#line 666 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_info);
#line 666 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2269 "DirectoryMonitor.c"
			}
#line 666 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2273 "DirectoryMonitor.c"
		}
		{
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_tmp27_ = _data_->file_children;
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_tmp28_ = _g_object_ref0 (_data_->_tmp27_);
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp28_;
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_tmp29_ = _data_->_file_child_list;
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp29_);
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp31_;
#line 679 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 679 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 679 "../src/DirectoryMonitor.vala"
				if (!(_data_->_file_child_index < _data_->_file_child_size)) {
#line 679 "../src/DirectoryMonitor.vala"
					break;
#line 2300 "DirectoryMonitor.c"
				}
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->_file_child_list;
#line 679 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp32_, _data_->_file_child_index);
#line 679 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp33_;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->self->priv->files;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = _data_->file_child;
#line 680 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = directory_monitor_file_info_map_get_info (_data_->_tmp34_, _data_->_tmp35_);
#line 680 "../src/DirectoryMonitor.vala"
				_data_->file_info = _data_->_tmp36_;
#line 681 "../src/DirectoryMonitor.vala"
				_data_->_tmp37_ = _data_->file_info;
#line 681 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp37_ == NULL) {
#line 682 "../src/DirectoryMonitor.vala"
					_data_->_tmp38_ = _data_->file_child;
#line 682 "../src/DirectoryMonitor.vala"
					_data_->_tmp39_ = g_file_get_path (_data_->_tmp38_);
#line 682 "../src/DirectoryMonitor.vala"
					_data_->_tmp40_ = _data_->_tmp39_;
#line 682 "../src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:682: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp40_);
#line 682 "../src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp40_);
#line 684 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_info);
#line 684 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_child);
#line 684 "../src/DirectoryMonitor.vala"
					continue;
#line 2336 "DirectoryMonitor.c"
				}
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp41_ = _data_->file_child;
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp42_ = _data_->file_child;
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp43_ = g_file_get_basename (_data_->_tmp42_);
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp44_ = _data_->_tmp43_;
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp45_ = g_file_get_child (_data_->new_dir, _data_->_tmp44_);
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp46_ = _data_->_tmp45_;
#line 687 "../src/DirectoryMonitor.vala"
				_data_->_tmp47_ = _data_->file_info;
#line 687 "../src/DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (_data_->self, _data_->_tmp41_, _data_->_tmp46_, _data_->_tmp47_);
#line 687 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp46_);
#line 687 "../src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp44_);
#line 690 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, _data_, NULL);
#line 691 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 691 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2364 "DirectoryMonitor.c"
				_state_2:
				;
#line 679 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_info);
#line 679 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2371 "DirectoryMonitor.c"
			}
#line 679 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2375 "DirectoryMonitor.c"
		}
	}
#line 697 "../src/DirectoryMonitor.vala"
	_data_->_tmp48_ = _data_->self->priv->files;
#line 697 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_data_->_tmp48_, _data_->old_dir, NULL);
#line 699 "../src/DirectoryMonitor.vala"
	_data_->_tmp49_ = _data_->self->priv->files;
#line 699 "../src/DirectoryMonitor.vala"
	_data_->updated = directory_monitor_file_info_map_update (_data_->_tmp49_, _data_->new_dir, _data_->new_dir_info);
#line 700 "../src/DirectoryMonitor.vala"
	_vala_assert (_data_->updated, "updated");
#line 703 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (_data_->self, _data_->old_dir, _data_->old_dir_info);
#line 704 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->new_dir, _data_->new_dir_info);
#line 706 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (_data_->self, _data_->old_dir, _data_->new_dir, _data_->new_dir_info);
#line 657 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 657 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 657 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 657 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 657 "../src/DirectoryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 657 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2406 "DirectoryMonitor.c"
		}
	}
#line 657 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 657 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 2413 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_moved (DirectoryMonitor* self,
                                               GFile* old_dir,
                                               GFile* new_dir,
                                               GFileInfo* new_dir_info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
#line 709 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 709 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 709 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 710 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (old_dir);
#line 710 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 710 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_file_get_path (new_dir);
#line 710 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 710 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_strdup_printf ("directory moved: %s -> %s", _tmp1_, _tmp3_);
#line 710 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 710 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 710 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 710 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 710 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 711 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL], 0, old_dir, new_dir, new_dir_info);
#line 713 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->root;
#line 713 "../src/DirectoryMonitor.vala"
	if (g_file_equal (old_dir, _tmp6_)) {
#line 714 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
#line 2463 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_moved (DirectoryMonitor* self,
                                          GFile* old_dir,
                                          GFile* new_dir,
                                          GFileInfo* new_dir_info)
{
#line 709 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 709 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 2477 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_altered (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 717 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 718 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 718 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 718 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory altered: %s", _tmp1_);
#line 718 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 718 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 718 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 718 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 719 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL], 0, dir);
#line 2506 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_altered (DirectoryMonitor* self,
                                            GFile* dir)
{
#line 717 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 717 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
#line 2517 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                                  GFile* dir,
                                                                  GFileInfo* info)
{
	gboolean updated = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 722 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 723 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 723 "../src/DirectoryMonitor.vala"
	updated = directory_monitor_file_info_map_update (_tmp0_, dir, info);
#line 724 "../src/DirectoryMonitor.vala"
	_vala_assert (updated, "updated");
#line 726 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
#line 2541 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                              GFile* dir,
                                                              GFileInfo* info)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 729 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 729 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 730 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 730 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 730 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory alteration completed: %s", _tmp1_);
#line 730 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 730 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 730 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 730 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 731 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL], 0, dir, info);
#line 2573 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self,
                                                         GFile* dir,
                                                         GFileInfo* info)
{
#line 729 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 729 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
#line 2585 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                            GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 734 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 735 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 735 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 735 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory attributes altered: %s", _tmp1_);
#line 735 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 735 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 735 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 735 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 736 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL], 0, dir);
#line 2614 "DirectoryMonitor.c"
}

void
directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self,
                                                       GFile* dir)
{
#line 734 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 734 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir);
#line 2625 "DirectoryMonitor.c"
}

static void
directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self,
                                                     GFile* dir)
{
	GFileInfo* info = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
#line 739 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 739 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 740 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 740 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, dir);
#line 740 "../src/DirectoryMonitor.vala"
	info = _tmp1_;
#line 741 "../src/DirectoryMonitor.vala"
	_vala_assert (info != NULL, "info != null");
#line 744 "../src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, dir, info);
#line 746 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, dir, FALSE, NULL, NULL);
#line 739 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 2653 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_data_free (gpointer _data)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, _data_);
#line 2667 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _task_data_;
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 73 "../src/DirectoryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2682 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2686 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self,
                                                  GFile* dir,
                                                  gboolean already_removed,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, directory_monitor_async_notify_directory_deleted_async_ready_wrapper, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	if (_callback_ == NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 2709 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->already_removed = already_removed;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2727 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self,
                                                         GAsyncResult* _res_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2737 "DirectoryMonitor.c"
}

static void
directory_monitor_async_notify_directory_deleted_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 769 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 769 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 769 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 769 "../src/DirectoryMonitor.vala"
	_data_->_task_complete_ = TRUE;
#line 769 "../src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2756 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
#line 778 "../src/DirectoryMonitor.vala"
	return result;
#line 2766 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_)
{
#line 749 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 749 "../src/DirectoryMonitor.vala"
		case 0:
#line 2776 "DirectoryMonitor.c"
		goto _state_0;
#line 749 "../src/DirectoryMonitor.vala"
		case 1:
#line 2780 "DirectoryMonitor.c"
		goto _state_1;
#line 749 "../src/DirectoryMonitor.vala"
		case 2:
#line 2784 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 749 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2789 "DirectoryMonitor.c"
	}
	_state_0:
#line 757 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 757 "../src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp0_;
#line 758 "../src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 758 "../src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp1_;
#line 759 "../src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->self->priv->files;
#line 759 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _data_->file_children;
#line 759 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->dir_children;
#line 759 "../src/DirectoryMonitor.vala"
	_data_->count = directory_monitor_file_info_map_get_children (_data_->_tmp2_, _data_->dir, (GeeCollection*) _data_->_tmp3_, (GeeCollection*) _data_->_tmp4_);
#line 760 "../src/DirectoryMonitor.vala"
	if (_data_->count > 0) {
#line 2810 "DirectoryMonitor.c"
		{
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->dir_children;
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _g_object_ref0 (_data_->_tmp5_);
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp6_;
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = _data_->_dir_child_list;
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp7_);
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp9_;
#line 768 "../src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 768 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 768 "../src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_dir_child_index + 1;
#line 768 "../src/DirectoryMonitor.vala"
				if (!(_data_->_dir_child_index < _data_->_dir_child_size)) {
#line 768 "../src/DirectoryMonitor.vala"
					break;
#line 2836 "DirectoryMonitor.c"
				}
#line 768 "../src/DirectoryMonitor.vala"
				_data_->_tmp10_ = _data_->_dir_child_list;
#line 768 "../src/DirectoryMonitor.vala"
				_data_->_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp10_, _data_->_dir_child_index);
#line 768 "../src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp11_;
#line 769 "../src/DirectoryMonitor.vala"
				_data_->_tmp12_ = _data_->dir_child;
#line 769 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 769 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted (_data_->self, _data_->_tmp12_, FALSE, directory_monitor_async_notify_directory_deleted_ready, _data_);
#line 769 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2852 "DirectoryMonitor.c"
				_state_1:
#line 769 "../src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (_data_->self, _data_->_res_);
#line 768 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2858 "DirectoryMonitor.c"
			}
#line 768 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2862 "DirectoryMonitor.c"
		}
		{
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_tmp13_ = _data_->file_children;
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _g_object_ref0 (_data_->_tmp13_);
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp14_;
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_tmp15_ = _data_->_file_child_list;
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp15_);
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp17_;
#line 773 "../src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 773 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 773 "../src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_file_child_index + 1;
#line 773 "../src/DirectoryMonitor.vala"
				if (!(_data_->_file_child_index < _data_->_file_child_size)) {
#line 773 "../src/DirectoryMonitor.vala"
					break;
#line 2889 "DirectoryMonitor.c"
				}
#line 773 "../src/DirectoryMonitor.vala"
				_data_->_tmp18_ = _data_->_file_child_list;
#line 773 "../src/DirectoryMonitor.vala"
				_data_->_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp18_, _data_->_file_child_index);
#line 773 "../src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp19_;
#line 774 "../src/DirectoryMonitor.vala"
				_data_->_tmp20_ = _data_->self->priv->files;
#line 774 "../src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->file_child;
#line 774 "../src/DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (_data_->_tmp20_, _data_->_tmp21_, NULL);
#line 776 "../src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->file_child;
#line 776 "../src/DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (_data_->self, _data_->_tmp22_);
#line 778 "../src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, _data_, NULL);
#line 779 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 779 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 2913 "DirectoryMonitor.c"
				_state_2:
				;
#line 773 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2918 "DirectoryMonitor.c"
			}
#line 773 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2922 "DirectoryMonitor.c"
		}
	}
#line 783 "../src/DirectoryMonitor.vala"
	if (!_data_->already_removed) {
#line 784 "../src/DirectoryMonitor.vala"
		_data_->_tmp23_ = _data_->self->priv->files;
#line 784 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_data_->_tmp23_, _data_->dir, NULL);
#line 2931 "DirectoryMonitor.c"
	}
#line 786 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (_data_->self, _data_->dir);
#line 749 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 749 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 749 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 749 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 749 "../src/DirectoryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 749 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2947 "DirectoryMonitor.c"
		}
	}
#line 749 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 749 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 2954 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self,
                                                 GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
#line 789 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 790 "../src/DirectoryMonitor.vala"
	_tmp0_ = g_file_get_path (dir);
#line 790 "../src/DirectoryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 790 "../src/DirectoryMonitor.vala"
	_tmp2_ = g_strdup_printf ("directory deleted: %s", _tmp1_);
#line 790 "../src/DirectoryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 790 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 790 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp3_);
#line 790 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp1_);
#line 791 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL], 0, dir);
#line 793 "../src/DirectoryMonitor.vala"
	_tmp4_ = self->priv->root;
#line 793 "../src/DirectoryMonitor.vala"
	if (g_file_equal (dir, _tmp4_)) {
#line 794 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, dir);
#line 2990 "DirectoryMonitor.c"
	}
}

void
directory_monitor_notify_directory_deleted (DirectoryMonitor* self,
                                            GFile* dir)
{
#line 789 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 789 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
#line 3002 "DirectoryMonitor.c"
}

static void
directory_monitor_real_notify_closed (DirectoryMonitor* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 798 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 798 "../src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 798 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 798 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("monitoring of %s closed", _tmp2_);
#line 798 "../src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 798 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 798 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 798 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 799 "../src/DirectoryMonitor.vala"
	g_signal_emit (self, directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL], 0);
#line 3031 "DirectoryMonitor.c"
}

void
directory_monitor_notify_closed (DirectoryMonitor* self)
{
#line 797 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 797 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
#line 3041 "DirectoryMonitor.c"
}

GFile*
directory_monitor_get_root (DirectoryMonitor* self)
{
	GFile* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 802 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 803 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 803 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 803 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 803 "../src/DirectoryMonitor.vala"
	return result;
#line 3060 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_in_root (DirectoryMonitor* self,
                              GFile* file)
{
	gboolean result = FALSE;
	GFile* _tmp0_;
#line 806 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 806 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 807 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 807 "../src/DirectoryMonitor.vala"
	result = g_file_has_prefix (file, _tmp0_);
#line 807 "../src/DirectoryMonitor.vala"
	return result;
#line 3079 "DirectoryMonitor.c"
}

gboolean
directory_monitor_has_started (DirectoryMonitor* self)
{
	gboolean result = FALSE;
#line 810 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 811 "../src/DirectoryMonitor.vala"
	result = self->priv->started;
#line 811 "../src/DirectoryMonitor.vala"
	return result;
#line 3092 "DirectoryMonitor.c"
}

void
directory_monitor_start_discovery (DirectoryMonitor* self)
{
	GFile* _tmp0_;
#line 814 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 815 "../src/DirectoryMonitor.vala"
	_vala_assert (!self->priv->started, "!started");
#line 817 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 818 "../src/DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 820 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 823 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 824 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 824 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async (self, _tmp0_, NULL, TRUE, NULL, NULL);
#line 3115 "DirectoryMonitor.c"
}

static void
directory_monitor_real_close (DirectoryMonitor* self)
{
	GCancellable* _tmp0_;
	GeeHashMap* _tmp11_;
#line 831 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 831 "../src/DirectoryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 3127 "DirectoryMonitor.c"
	{
		GeeIterator* _monitor_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 834 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 834 "../src/DirectoryMonitor.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 834 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 834 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 834 "../src/DirectoryMonitor.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 834 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 834 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 834 "../src/DirectoryMonitor.vala"
		_monitor_it = _tmp6_;
#line 834 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 3154 "DirectoryMonitor.c"
			GeeIterator* _tmp7_;
			GFileMonitor* monitor = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GFileMonitor* _tmp10_;
#line 834 "../src/DirectoryMonitor.vala"
			_tmp7_ = _monitor_it;
#line 834 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 834 "../src/DirectoryMonitor.vala"
				break;
#line 3166 "DirectoryMonitor.c"
			}
#line 834 "../src/DirectoryMonitor.vala"
			_tmp8_ = _monitor_it;
#line 834 "../src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 834 "../src/DirectoryMonitor.vala"
			monitor = (GFileMonitor*) _tmp9_;
#line 835 "../src/DirectoryMonitor.vala"
			_tmp10_ = monitor;
#line 835 "../src/DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, _tmp10_);
#line 834 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3180 "DirectoryMonitor.c"
		}
#line 834 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_monitor_it);
#line 3184 "DirectoryMonitor.c"
	}
#line 837 "../src/DirectoryMonitor.vala"
	_tmp11_ = self->priv->monitors;
#line 837 "../src/DirectoryMonitor.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp11_);
#line 839 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 3192 "DirectoryMonitor.c"
}

void
directory_monitor_close (DirectoryMonitor* self)
{
#line 829 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 829 "../src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
#line 3202 "DirectoryMonitor.c"
}

static DirectoryMonitorFType
directory_monitor_get_ftype (GFileInfo* info)
{
	DirectoryMonitorFType result = 0;
	GFileType file_type = 0;
	GFileType _tmp0_;
#line 842 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 843 "../src/DirectoryMonitor.vala"
	file_type = g_file_info_get_file_type (info);
#line 844 "../src/DirectoryMonitor.vala"
	_tmp0_ = file_type;
#line 844 "../src/DirectoryMonitor.vala"
	switch (_tmp0_) {
#line 844 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_REGULAR:
#line 3221 "DirectoryMonitor.c"
		{
#line 846 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 846 "../src/DirectoryMonitor.vala"
			return result;
#line 3227 "DirectoryMonitor.c"
		}
#line 844 "../src/DirectoryMonitor.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 3231 "DirectoryMonitor.c"
		{
#line 849 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 849 "../src/DirectoryMonitor.vala"
			return result;
#line 3237 "DirectoryMonitor.c"
		}
		default:
		{
			GFileType _tmp1_;
			GEnumValue* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 852 "../src/DirectoryMonitor.vala"
			_tmp1_ = file_type;
#line 852 "../src/DirectoryMonitor.vala"
			_tmp2_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), _tmp1_);
#line 852 "../src/DirectoryMonitor.vala"
			_tmp3_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp2_ != NULL) ? _tmp2_->value_name : NULL);
#line 852 "../src/DirectoryMonitor.vala"
			_tmp4_ = _tmp3_;
#line 852 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp4_);
#line 852 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp4_);
#line 853 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 853 "../src/DirectoryMonitor.vala"
			return result;
#line 3261 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_explore_async_data_free (gpointer _data)
{
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorExploreAsyncData, _data_);
#line 3279 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	DirectoryMonitorExploreAsyncData* _task_data_;
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 73 "../src/DirectoryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3294 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3298 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async (DirectoryMonitor* self,
                                 GFile* dir,
                                 GFileInfo* dir_info,
                                 gboolean in_discovery,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, directory_monitor_explore_async_async_ready_wrapper, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	if (_callback_ == NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 3323 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->dir_info = _tmp2_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3347 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_finish (DirectoryMonitor* self,
                                  GAsyncResult* _res_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3357 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_async_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	DirectoryMonitorExploreAsyncData* _data_;
#line 870 "../src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 870 "../src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 870 "../src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 870 "../src/DirectoryMonitor.vala"
	_data_->_task_complete_ = TRUE;
#line 870 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3376 "DirectoryMonitor.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 924 "../src/DirectoryMonitor.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3384 "DirectoryMonitor.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 924 "../src/DirectoryMonitor.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3392 "DirectoryMonitor.c"
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 942 "../src/DirectoryMonitor.vala"
	return result;
#line 3403 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_)
{
#line 857 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 857 "../src/DirectoryMonitor.vala"
		case 0:
#line 3413 "DirectoryMonitor.c"
		goto _state_0;
#line 857 "../src/DirectoryMonitor.vala"
		case 1:
#line 3417 "DirectoryMonitor.c"
		goto _state_1;
#line 857 "../src/DirectoryMonitor.vala"
		case 2:
#line 3421 "DirectoryMonitor.c"
		goto _state_2;
#line 857 "../src/DirectoryMonitor.vala"
		case 3:
#line 3425 "DirectoryMonitor.c"
		goto _state_3;
#line 857 "../src/DirectoryMonitor.vala"
		case 4:
#line 3429 "DirectoryMonitor.c"
		goto _state_4;
#line 857 "../src/DirectoryMonitor.vala"
		case 5:
#line 3433 "DirectoryMonitor.c"
		goto _state_5;
		default:
#line 857 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 3438 "DirectoryMonitor.c"
	}
	_state_0:
#line 858 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->files;
#line 858 "../src/DirectoryMonitor.vala"
	if (directory_monitor_file_info_map_contains (_data_->_tmp0_, _data_->dir, _data_->dir_info)) {
#line 859 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = g_file_get_path (_data_->dir);
#line 859 "../src/DirectoryMonitor.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 859 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:859: Directory loop detected at %s, not explorin" \
"g", _data_->_tmp2_);
#line 859 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp2_);
#line 861 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 863 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 863 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 863 "../src/DirectoryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 863 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3463 "DirectoryMonitor.c"
			}
		}
#line 863 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 863 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3470 "DirectoryMonitor.c"
	}
#line 867 "../src/DirectoryMonitor.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->dir_info);
#line 867 "../src/DirectoryMonitor.vala"
	_data_->local_dir_info = _data_->_tmp3_;
#line 868 "../src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->local_dir_info;
#line 868 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp4_ == NULL) {
#line 3480 "DirectoryMonitor.c"
		{
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_state_ = 1;
#line 870 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp6_, directory_monitor_explore_async_ready, _data_);
#line 870 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3490 "DirectoryMonitor.c"
			_state_1:
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = g_file_query_info_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->_tmp7_;
#line 870 "../src/DirectoryMonitor.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3498 "DirectoryMonitor.c"
				goto __catch31_g_error;
			}
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->_tmp5_;
#line 870 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = NULL;
#line 870 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 870 "../src/DirectoryMonitor.vala"
			_data_->local_dir_info = _data_->_tmp8_;
#line 869 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp5_);
#line 3511 "DirectoryMonitor.c"
		}
		goto __finally31;
		__catch31_g_error:
		{
#line 869 "../src/DirectoryMonitor.vala"
			_data_->err = _data_->_inner_error0_;
#line 869 "../src/DirectoryMonitor.vala"
			_data_->_inner_error0_ = NULL;
#line 873 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = g_file_get_path (_data_->dir);
#line 873 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 873 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->err;
#line 873 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 873 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:873: Unable to retrieve info on %s: %s", _data_->_tmp10_, _data_->_tmp12_);
#line 873 "../src/DirectoryMonitor.vala"
			_g_free0 (_data_->_tmp10_);
#line 875 "../src/DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 877 "../src/DirectoryMonitor.vala"
			_g_error_free0 (_data_->err);
#line 877 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 877 "../src/DirectoryMonitor.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 877 "../src/DirectoryMonitor.vala"
			if (_data_->_state_ != 0) {
#line 877 "../src/DirectoryMonitor.vala"
				while (!_data_->_task_complete_) {
#line 877 "../src/DirectoryMonitor.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3546 "DirectoryMonitor.c"
				}
			}
#line 877 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 877 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3553 "DirectoryMonitor.c"
		}
		__finally31:
#line 869 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 869 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 869 "../src/DirectoryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 869 "../src/DirectoryMonitor.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 869 "../src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 869 "../src/DirectoryMonitor.vala"
			return FALSE;
#line 3568 "DirectoryMonitor.c"
		}
	}
#line 881 "../src/DirectoryMonitor.vala"
	_data_->_tmp13_ = _data_->local_dir_info;
#line 881 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_is_hidden (_data_->_tmp13_)) {
#line 882 "../src/DirectoryMonitor.vala"
		_data_->_tmp14_ = g_file_get_path (_data_->dir);
#line 882 "../src/DirectoryMonitor.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 882 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:882: Ignoring hidden directory %s", _data_->_tmp15_);
#line 882 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp15_);
#line 884 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 886 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 886 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 886 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 886 "../src/DirectoryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 886 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3595 "DirectoryMonitor.c"
			}
		}
#line 886 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 886 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3602 "DirectoryMonitor.c"
	}
#line 892 "../src/DirectoryMonitor.vala"
	_data_->_tmp16_ = _data_->local_dir_info;
#line 892 "../src/DirectoryMonitor.vala"
	_data_->_tmp17_ = get_file_info_id (_data_->_tmp16_);
#line 892 "../src/DirectoryMonitor.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 892 "../src/DirectoryMonitor.vala"
	_data_->_tmp19_ = _data_->_tmp18_ == NULL;
#line 892 "../src/DirectoryMonitor.vala"
	_g_free0 (_data_->_tmp18_);
#line 892 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp19_) {
#line 893 "../src/DirectoryMonitor.vala"
		_data_->_tmp20_ = g_file_get_path (_data_->dir);
#line 893 "../src/DirectoryMonitor.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 893 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:893: Unable to retrieve file ID on %s: skipping", _data_->_tmp21_);
#line 893 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp21_);
#line 895 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 897 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 897 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 897 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 897 "../src/DirectoryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 897 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3636 "DirectoryMonitor.c"
			}
		}
#line 897 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 897 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3643 "DirectoryMonitor.c"
	}
#line 901 "../src/DirectoryMonitor.vala"
	_data_->_tmp22_ = _data_->local_dir_info;
#line 901 "../src/DirectoryMonitor.vala"
	if (g_file_info_get_file_type (_data_->_tmp22_) != G_FILE_TYPE_DIRECTORY) {
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp23_ = g_file_get_path (_data_->dir);
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->local_dir_info;
#line 903 "../src/DirectoryMonitor.vala"
		_data_->_tmp26_ = g_enum_get_value (g_type_class_ref (g_file_type_get_type ()), g_file_info_get_file_type (_data_->_tmp25_));
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp27_ = g_strdup_printf (_ ("Unable to monitor %s: Not a directory (%s)"), _data_->_tmp24_, (_data_->_tmp26_ != NULL) ? _data_->_tmp26_->value_name : NULL);
#line 902 "../src/DirectoryMonitor.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 902 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (_data_->self, _data_->_tmp28_);
#line 902 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp28_);
#line 902 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp24_);
#line 905 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 907 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 907 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 907 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 907 "../src/DirectoryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 907 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3679 "DirectoryMonitor.c"
			}
		}
#line 907 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 907 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3686 "DirectoryMonitor.c"
	}
#line 914 "../src/DirectoryMonitor.vala"
	_data_->dir_map = NULL;
#line 915 "../src/DirectoryMonitor.vala"
	_data_->file_map = NULL;
#line 3692 "DirectoryMonitor.c"
	{
#line 918 "../src/DirectoryMonitor.vala"
		_data_->_tmp29_ = _data_->self->priv->cancellable;
#line 918 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 2;
#line 918 "../src/DirectoryMonitor.vala"
		g_file_enumerate_children_async (_data_->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp29_, directory_monitor_explore_async_ready, _data_);
#line 918 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3702 "DirectoryMonitor.c"
		_state_2:
#line 918 "../src/DirectoryMonitor.vala"
		_data_->_tmp30_ = g_file_enumerate_children_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 918 "../src/DirectoryMonitor.vala"
		_data_->enumerator = _data_->_tmp30_;
#line 918 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3710 "DirectoryMonitor.c"
			goto __catch32_g_error;
		}
		{
#line 920 "../src/DirectoryMonitor.vala"
			_data_->_tmp31_ = TRUE;
#line 920 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 920 "../src/DirectoryMonitor.vala"
				if (!_data_->_tmp31_) {
#line 3720 "DirectoryMonitor.c"
				}
#line 920 "../src/DirectoryMonitor.vala"
				_data_->_tmp31_ = FALSE;
#line 921 "../src/DirectoryMonitor.vala"
				_data_->_tmp32_ = _data_->enumerator;
#line 921 "../src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->self->priv->cancellable;
#line 921 "../src/DirectoryMonitor.vala"
				_data_->_state_ = 3;
#line 921 "../src/DirectoryMonitor.vala"
				g_file_enumerator_next_files_async (_data_->_tmp32_, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp33_, directory_monitor_explore_async_ready, _data_);
#line 921 "../src/DirectoryMonitor.vala"
				return FALSE;
#line 3734 "DirectoryMonitor.c"
				_state_3:
#line 921 "../src/DirectoryMonitor.vala"
				_data_->_tmp34_ = g_file_enumerator_next_files_finish (_data_->_tmp32_, _data_->_res_, &_data_->_inner_error0_);
#line 921 "../src/DirectoryMonitor.vala"
				_data_->infos = _data_->_tmp34_;
#line 921 "../src/DirectoryMonitor.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 921 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->enumerator);
#line 3744 "DirectoryMonitor.c"
					goto __catch32_g_error;
				}
#line 923 "../src/DirectoryMonitor.vala"
				_data_->_tmp35_ = _data_->infos;
#line 923 "../src/DirectoryMonitor.vala"
				if (_data_->_tmp35_ == NULL) {
#line 924 "../src/DirectoryMonitor.vala"
					(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 924 "../src/DirectoryMonitor.vala"
					break;
#line 3755 "DirectoryMonitor.c"
				}
#line 926 "../src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->infos;
#line 3759 "DirectoryMonitor.c"
				{
#line 926 "../src/DirectoryMonitor.vala"
					_data_->info_collection = _data_->_tmp36_;
#line 926 "../src/DirectoryMonitor.vala"
					for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 926 "../src/DirectoryMonitor.vala"
						_data_->_tmp37_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 926 "../src/DirectoryMonitor.vala"
						_data_->info = _data_->_tmp37_;
#line 3769 "DirectoryMonitor.c"
						{
#line 928 "../src/DirectoryMonitor.vala"
							_data_->_tmp38_ = _data_->info;
#line 928 "../src/DirectoryMonitor.vala"
							if (g_file_info_get_is_hidden (_data_->_tmp38_)) {
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp39_ = _data_->info;
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp40_ = g_file_info_get_name (_data_->_tmp39_);
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp41_ = g_file_get_child (_data_->dir, _data_->_tmp40_);
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp42_ = _data_->_tmp41_;
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp43_ = g_file_get_path (_data_->_tmp42_);
#line 929 "../src/DirectoryMonitor.vala"
								_data_->_tmp44_ = _data_->_tmp43_;
#line 929 "../src/DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:929: Skipping hidden file/directory %s", _data_->_tmp44_);
#line 929 "../src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp44_);
#line 929 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->_tmp42_);
#line 932 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 932 "../src/DirectoryMonitor.vala"
								continue;
#line 3797 "DirectoryMonitor.c"
							}
#line 936 "../src/DirectoryMonitor.vala"
							_data_->_tmp45_ = _data_->info;
#line 936 "../src/DirectoryMonitor.vala"
							if (!directory_monitor_is_file_symlink_supported (_data_->_tmp45_)) {
#line 937 "../src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 937 "../src/DirectoryMonitor.vala"
								continue;
#line 3807 "DirectoryMonitor.c"
							}
#line 939 "../src/DirectoryMonitor.vala"
							_data_->_tmp46_ = _data_->info;
#line 939 "../src/DirectoryMonitor.vala"
							switch (g_file_info_get_file_type (_data_->_tmp46_)) {
#line 939 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_REGULAR:
#line 3815 "DirectoryMonitor.c"
								{
#line 941 "../src/DirectoryMonitor.vala"
									_data_->_tmp47_ = _data_->file_map;
#line 941 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp47_ == NULL) {
#line 942 "../src/DirectoryMonitor.vala"
										_data_->_tmp48_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 942 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->file_map);
#line 942 "../src/DirectoryMonitor.vala"
										_data_->file_map = _data_->_tmp48_;
#line 3827 "DirectoryMonitor.c"
									}
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp49_ = _data_->file_map;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp50_ = _data_->info;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp51_ = g_file_info_get_name (_data_->_tmp50_);
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp52_ = g_file_get_child (_data_->dir, _data_->_tmp51_);
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp53_ = _data_->_tmp52_;
#line 944 "../src/DirectoryMonitor.vala"
									_data_->_tmp54_ = _data_->info;
#line 944 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp49_, _data_->_tmp53_, _data_->_tmp54_);
#line 944 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp53_);
#line 945 "../src/DirectoryMonitor.vala"
									break;
#line 3847 "DirectoryMonitor.c"
								}
#line 939 "../src/DirectoryMonitor.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 3851 "DirectoryMonitor.c"
								{
#line 948 "../src/DirectoryMonitor.vala"
									_data_->_tmp55_ = _data_->dir_map;
#line 948 "../src/DirectoryMonitor.vala"
									if (_data_->_tmp55_ == NULL) {
#line 949 "../src/DirectoryMonitor.vala"
										_data_->_tmp56_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 949 "../src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->dir_map);
#line 949 "../src/DirectoryMonitor.vala"
										_data_->dir_map = _data_->_tmp56_;
#line 3863 "DirectoryMonitor.c"
									}
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp57_ = _data_->dir_map;
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp58_ = _data_->info;
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp59_ = g_file_info_get_name (_data_->_tmp58_);
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp60_ = g_file_get_child (_data_->dir, _data_->_tmp59_);
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp61_ = _data_->_tmp60_;
#line 951 "../src/DirectoryMonitor.vala"
									_data_->_tmp62_ = _data_->info;
#line 951 "../src/DirectoryMonitor.vala"
									gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp57_, _data_->_tmp61_, _data_->_tmp62_);
#line 951 "../src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp61_);
#line 952 "../src/DirectoryMonitor.vala"
									break;
#line 3883 "DirectoryMonitor.c"
								}
								default:
								{
#line 956 "../src/DirectoryMonitor.vala"
									break;
#line 3889 "DirectoryMonitor.c"
								}
							}
#line 926 "../src/DirectoryMonitor.vala"
							_g_object_unref0 (_data_->info);
#line 3894 "DirectoryMonitor.c"
						}
					}
				}
#line 920 "../src/DirectoryMonitor.vala"
				(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 3900 "DirectoryMonitor.c"
			}
		}
#line 917 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->enumerator);
#line 3905 "DirectoryMonitor.c"
	}
	goto __finally32;
	__catch32_g_error:
	{
#line 917 "../src/DirectoryMonitor.vala"
		_data_->err2 = _data_->_inner_error0_;
#line 917 "../src/DirectoryMonitor.vala"
		_data_->_inner_error0_ = NULL;
#line 961 "../src/DirectoryMonitor.vala"
		_data_->_tmp63_ = g_file_get_path (_data_->dir);
#line 961 "../src/DirectoryMonitor.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 961 "../src/DirectoryMonitor.vala"
		_data_->_tmp65_ = _data_->err2;
#line 961 "../src/DirectoryMonitor.vala"
		_data_->_tmp66_ = _data_->_tmp65_->message;
#line 961 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:961: Aborted directory traversal of %s: %s", _data_->_tmp64_, _data_->_tmp66_);
#line 961 "../src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp64_);
#line 963 "../src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 965 "../src/DirectoryMonitor.vala"
		_g_error_free0 (_data_->err2);
#line 965 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 965 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 965 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 965 "../src/DirectoryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 965 "../src/DirectoryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 965 "../src/DirectoryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 965 "../src/DirectoryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3944 "DirectoryMonitor.c"
			}
		}
#line 965 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 965 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3951 "DirectoryMonitor.c"
	}
	__finally32:
#line 917 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 917 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 917 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 917 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 917 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 917 "../src/DirectoryMonitor.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 917 "../src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 917 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 3970 "DirectoryMonitor.c"
	}
#line 969 "../src/DirectoryMonitor.vala"
	if (_data_->in_discovery) {
#line 970 "../src/DirectoryMonitor.vala"
		_data_->_tmp67_ = _data_->local_dir_info;
#line 970 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (_data_->self, _data_->dir, _data_->_tmp67_);
#line 3978 "DirectoryMonitor.c"
	} else {
#line 972 "../src/DirectoryMonitor.vala"
		_data_->_tmp68_ = _data_->local_dir_info;
#line 972 "../src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (_data_->self, _data_->dir, _data_->_tmp68_);
#line 3984 "DirectoryMonitor.c"
	}
#line 976 "../src/DirectoryMonitor.vala"
	_data_->_tmp69_ = _data_->local_dir_info;
#line 976 "../src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->dir, _data_->_tmp69_);
#line 979 "../src/DirectoryMonitor.vala"
	_data_->_tmp70_ = _data_->file_map;
#line 979 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp70_ != NULL) {
#line 980 "../src/DirectoryMonitor.vala"
		_data_->_tmp71_ = _data_->file_map;
#line 980 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 4;
#line 980 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files (_data_->self, (GeeMap*) _data_->_tmp71_, _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 980 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4002 "DirectoryMonitor.c"
		_state_4:
#line 980 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (_data_->self, _data_->_res_);
#line 4006 "DirectoryMonitor.c"
	}
#line 983 "../src/DirectoryMonitor.vala"
	if (_data_->self->priv->recurse) {
#line 983 "../src/DirectoryMonitor.vala"
		_data_->_tmp73_ = _data_->dir_map;
#line 983 "../src/DirectoryMonitor.vala"
		_data_->_tmp72_ = _data_->_tmp73_ != NULL;
#line 4014 "DirectoryMonitor.c"
	} else {
#line 983 "../src/DirectoryMonitor.vala"
		_data_->_tmp72_ = FALSE;
#line 4018 "DirectoryMonitor.c"
	}
#line 983 "../src/DirectoryMonitor.vala"
	if (_data_->_tmp72_) {
#line 4022 "DirectoryMonitor.c"
		{
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp74_ = _data_->dir_map;
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp75_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _data_->_tmp74_);
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp76_ = _data_->_tmp75_;
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp77_ = _data_->_tmp76_;
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp78_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp77_);
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_tmp79_ = _data_->_tmp78_;
#line 984 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp77_);
#line 984 "../src/DirectoryMonitor.vala"
			_data_->_subdir_it = _data_->_tmp79_;
#line 984 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 984 "../src/DirectoryMonitor.vala"
				_data_->_tmp80_ = _data_->_subdir_it;
#line 984 "../src/DirectoryMonitor.vala"
				if (!gee_iterator_next (_data_->_tmp80_)) {
#line 984 "../src/DirectoryMonitor.vala"
					break;
#line 4048 "DirectoryMonitor.c"
				}
#line 984 "../src/DirectoryMonitor.vala"
				_data_->_tmp81_ = _data_->_subdir_it;
#line 984 "../src/DirectoryMonitor.vala"
				_data_->_tmp82_ = gee_iterator_get (_data_->_tmp81_);
#line 984 "../src/DirectoryMonitor.vala"
				_data_->subdir = (GFile*) _data_->_tmp82_;
#line 985 "../src/DirectoryMonitor.vala"
				_data_->self->priv->outstanding_exploration_dirs = _data_->self->priv->outstanding_exploration_dirs + 1;
#line 985 "../src/DirectoryMonitor.vala"
				if (_data_->self->priv->outstanding_exploration_dirs > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_tmp83_ = _data_->subdir;
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_tmp84_ = _data_->dir_map;
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_tmp85_ = _data_->subdir;
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_tmp86_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp84_, _data_->_tmp85_);
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_tmp87_ = (GFileInfo*) _data_->_tmp86_;
#line 986 "../src/DirectoryMonitor.vala"
					_data_->_state_ = 5;
#line 986 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp83_, _data_->_tmp87_, _data_->in_discovery, directory_monitor_explore_async_ready, _data_);
#line 986 "../src/DirectoryMonitor.vala"
					return FALSE;
#line 4076 "DirectoryMonitor.c"
					_state_5:
#line 986 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_finish (_data_->self, _data_->_res_);
#line 986 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp87_);
#line 4082 "DirectoryMonitor.c"
				} else {
#line 988 "../src/DirectoryMonitor.vala"
					_data_->_tmp88_ = _data_->subdir;
#line 988 "../src/DirectoryMonitor.vala"
					_data_->_tmp89_ = _data_->dir_map;
#line 988 "../src/DirectoryMonitor.vala"
					_data_->_tmp90_ = _data_->subdir;
#line 988 "../src/DirectoryMonitor.vala"
					_data_->_tmp91_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp89_, _data_->_tmp90_);
#line 988 "../src/DirectoryMonitor.vala"
					_data_->_tmp92_ = (GFileInfo*) _data_->_tmp91_;
#line 988 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp88_, _data_->_tmp92_, _data_->in_discovery, NULL, NULL);
#line 988 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp92_);
#line 4098 "DirectoryMonitor.c"
				}
#line 984 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->subdir);
#line 4102 "DirectoryMonitor.c"
			}
#line 984 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_subdir_it);
#line 4106 "DirectoryMonitor.c"
		}
	}
#line 992 "../src/DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (_data_->self, _data_->in_discovery);
#line 857 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_map);
#line 857 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_map);
#line 857 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->local_dir_info);
#line 857 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 857 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 857 "../src/DirectoryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 857 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4125 "DirectoryMonitor.c"
		}
	}
#line 857 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 857 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4132 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_data_free (gpointer _data)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = _data;
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 73 "../src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, _data_);
#line 4146 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_async_ready_wrapper (GObject *source_object,
                                                              GAsyncResult *res,
                                                              void *user_data)
{
	DirectoryMonitorNotifyDirectoryFilesData* _task_data_;
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 73 "../src/DirectoryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 4161 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 4165 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files (DirectoryMonitor* self,
                                          GeeMap* map,
                                          gboolean in_discovery,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	DirectoryMonitor* _tmp0_;
	GeeMap* _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, directory_monitor_notify_directory_files_async_ready_wrapper, _user_data_);
#line 73 "../src/DirectoryMonitor.vala"
	if (_callback_ == NULL) {
#line 73 "../src/DirectoryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 4188 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
#line 73 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 73 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (map);
#line 73 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 73 "../src/DirectoryMonitor.vala"
	_data_->map = _tmp1_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_->in_discovery = in_discovery;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_files_co (_data_);
#line 4206 "DirectoryMonitor.c"
}

static void
directory_monitor_notify_directory_files_finish (DirectoryMonitor* self,
                                                 GAsyncResult* _res_)
{
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
#line 73 "../src/DirectoryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4216 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_notify_directory_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
#line 1003 "../src/DirectoryMonitor.vala"
	return result;
#line 4226 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_)
{
#line 995 "../src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 995 "../src/DirectoryMonitor.vala"
		case 0:
#line 4236 "DirectoryMonitor.c"
		goto _state_0;
#line 995 "../src/DirectoryMonitor.vala"
		case 1:
#line 4240 "DirectoryMonitor.c"
		goto _state_1;
		default:
#line 995 "../src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 4245 "DirectoryMonitor.c"
	}
	_state_0:
#line 996 "../src/DirectoryMonitor.vala"
	_data_->_tmp0_ = gee_map_map_iterator (_data_->map);
#line 996 "../src/DirectoryMonitor.vala"
	_data_->iter = _data_->_tmp0_;
#line 997 "../src/DirectoryMonitor.vala"
	while (TRUE) {
#line 997 "../src/DirectoryMonitor.vala"
		_data_->_tmp1_ = _data_->iter;
#line 997 "../src/DirectoryMonitor.vala"
		if (!gee_map_iterator_next (_data_->_tmp1_)) {
#line 997 "../src/DirectoryMonitor.vala"
			break;
#line 4260 "DirectoryMonitor.c"
		}
#line 998 "../src/DirectoryMonitor.vala"
		if (_data_->in_discovery) {
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp2_ = _data_->iter;
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp3_ = gee_map_iterator_get_key (_data_->_tmp2_);
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp4_ = (GFile*) _data_->_tmp3_;
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->iter;
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp6_ = gee_map_iterator_get_value (_data_->_tmp5_);
#line 999 "../src/DirectoryMonitor.vala"
			_data_->_tmp7_ = (GFileInfo*) _data_->_tmp6_;
#line 999 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (_data_->self, _data_->_tmp4_, _data_->_tmp7_);
#line 999 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 999 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 4282 "DirectoryMonitor.c"
		} else {
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->iter;
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp9_ = gee_map_iterator_get_key (_data_->_tmp8_);
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp10_ = (GFile*) _data_->_tmp9_;
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->iter;
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp12_ = gee_map_iterator_get_value (_data_->_tmp11_);
#line 1001 "../src/DirectoryMonitor.vala"
			_data_->_tmp13_ = (GFileInfo*) _data_->_tmp12_;
#line 1001 "../src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (_data_->self, _data_->_tmp10_, _data_->_tmp13_);
#line 1001 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 1001 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 4302 "DirectoryMonitor.c"
		}
#line 1003 "../src/DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, _data_, NULL);
#line 1004 "../src/DirectoryMonitor.vala"
		_data_->_state_ = 1;
#line 1004 "../src/DirectoryMonitor.vala"
		return FALSE;
#line 4310 "DirectoryMonitor.c"
		_state_1:
		;
	}
#line 995 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->iter);
#line 995 "../src/DirectoryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 995 "../src/DirectoryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 995 "../src/DirectoryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 995 "../src/DirectoryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4324 "DirectoryMonitor.c"
		}
	}
#line 995 "../src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 995 "../src/DirectoryMonitor.vala"
	return FALSE;
#line 4331 "DirectoryMonitor.c"
}

static void
directory_monitor_explore_directory_completed (DirectoryMonitor* self,
                                               gboolean in_discovery)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1010 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../src/DirectoryMonitor.vala"
	_vala_assert (self->priv->outstanding_exploration_dirs > 0, "outstanding_exploration_dirs > 0");
#line 1012 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->outstanding_exploration_dirs;
#line 1012 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = _tmp0_ - 1;
#line 1014 "../src/DirectoryMonitor.vala"
	if (in_discovery) {
#line 1014 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->outstanding_exploration_dirs == 0;
#line 4352 "DirectoryMonitor.c"
	} else {
#line 1014 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4356 "DirectoryMonitor.c"
	}
#line 1014 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 1015 "../src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 4362 "DirectoryMonitor.c"
	}
}

static void
_directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender,
                                                                   GFile* file,
                                                                   GFile* other_file,
                                                                   GFileMonitorEvent event_type,
                                                                   gpointer self)
{
#line 1043 "../src/DirectoryMonitor.vala"
	directory_monitor_on_monitor_notification ((DirectoryMonitor*) self, file, other_file, event_type);
#line 4375 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_add_monitor (DirectoryMonitor* self,
                               GFile* dir,
                               GFileInfo* info)
{
	gboolean result = FALSE;
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp13_;
	const gchar* _tmp14_;
	GFileMonitor* _tmp15_;
	GFileMonitor* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 1021 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1021 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1021 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1022 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1023 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1023 "../src/DirectoryMonitor.vala"
		return result;
#line 4412 "DirectoryMonitor.c"
	}
#line 1025 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1025 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1025 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1026 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1026 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1027 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1027 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1027 "../src/DirectoryMonitor.vala"
		return result;
#line 4430 "DirectoryMonitor.c"
	}
#line 1030 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1030 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1030 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_)) {
#line 1031 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1031 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1031 "../src/DirectoryMonitor.vala"
		return result;
#line 4444 "DirectoryMonitor.c"
	}
#line 1033 "../src/DirectoryMonitor.vala"
	monitor = NULL;
#line 4448 "DirectoryMonitor.c"
	{
		GFileMonitor* _tmp5_ = NULL;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 1035 "../src/DirectoryMonitor.vala"
		_tmp6_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error0_);
#line 1035 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp6_;
#line 1035 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4459 "DirectoryMonitor.c"
			goto __catch33_g_error;
		}
#line 1035 "../src/DirectoryMonitor.vala"
		_tmp7_ = _tmp5_;
#line 1035 "../src/DirectoryMonitor.vala"
		_tmp5_ = NULL;
#line 1035 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1035 "../src/DirectoryMonitor.vala"
		monitor = _tmp7_;
#line 1034 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 4472 "DirectoryMonitor.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 1034 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 1034 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 1037 "../src/DirectoryMonitor.vala"
		_tmp8_ = g_file_get_path (dir);
#line 1037 "../src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 1037 "../src/DirectoryMonitor.vala"
		_tmp10_ = err;
#line 1037 "../src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->message;
#line 1037 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1037: Unable to monitor %s: %s", _tmp9_, _tmp11_);
#line 1037 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp9_);
#line 1039 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1039 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 1039 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1039 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1039 "../src/DirectoryMonitor.vala"
		return result;
#line 4508 "DirectoryMonitor.c"
	}
	__finally33:
#line 1034 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4513 "DirectoryMonitor.c"
		gboolean _tmp12_ = FALSE;
#line 1034 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1034 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1034 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1034 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 1034 "../src/DirectoryMonitor.vala"
		return _tmp12_;
#line 4525 "DirectoryMonitor.c"
	}
#line 1042 "../src/DirectoryMonitor.vala"
	_tmp13_ = self->priv->monitors;
#line 1042 "../src/DirectoryMonitor.vala"
	_tmp14_ = id;
#line 1042 "../src/DirectoryMonitor.vala"
	_tmp15_ = monitor;
#line 1042 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp14_, _tmp15_);
#line 1043 "../src/DirectoryMonitor.vala"
	_tmp16_ = monitor;
#line 1043 "../src/DirectoryMonitor.vala"
	g_signal_connect_object (_tmp16_, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1045 "../src/DirectoryMonitor.vala"
	_tmp17_ = g_file_get_path (dir);
#line 1045 "../src/DirectoryMonitor.vala"
	_tmp18_ = _tmp17_;
#line 1045 "../src/DirectoryMonitor.vala"
	_tmp19_ = g_strdup_printf ("Added monitor for %s", _tmp18_);
#line 1045 "../src/DirectoryMonitor.vala"
	_tmp20_ = _tmp19_;
#line 1045 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp20_);
#line 1045 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp20_);
#line 1045 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp18_);
#line 1047 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1047 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1047 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1047 "../src/DirectoryMonitor.vala"
	return result;
#line 4561 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_remove_monitor (DirectoryMonitor* self,
                                  GFile* dir,
                                  GFileInfo* info)
{
	gboolean result = FALSE;
	gchar* id = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GFileMonitor* monitor = NULL;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	GFileMonitor* _tmp6_;
	gboolean removed = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	GFileMonitor* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 1051 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1051 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 1051 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1052 "../src/DirectoryMonitor.vala"
	if (!self->priv->monitoring) {
#line 1053 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1053 "../src/DirectoryMonitor.vala"
		return result;
#line 4599 "DirectoryMonitor.c"
	}
#line 1055 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1055 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_id (_tmp0_, dir, info);
#line 1055 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 1056 "../src/DirectoryMonitor.vala"
	_tmp2_ = id;
#line 1056 "../src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 1057 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1057 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1057 "../src/DirectoryMonitor.vala"
		return result;
#line 4617 "DirectoryMonitor.c"
	}
#line 1059 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->monitors;
#line 1059 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 1059 "../src/DirectoryMonitor.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 1059 "../src/DirectoryMonitor.vala"
	monitor = (GFileMonitor*) _tmp5_;
#line 1060 "../src/DirectoryMonitor.vala"
	_tmp6_ = monitor;
#line 1060 "../src/DirectoryMonitor.vala"
	if (_tmp6_ == NULL) {
#line 1061 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 1061 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1061 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1061 "../src/DirectoryMonitor.vala"
		return result;
#line 4639 "DirectoryMonitor.c"
	}
#line 1063 "../src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->monitors;
#line 1063 "../src/DirectoryMonitor.vala"
	_tmp8_ = id;
#line 1063 "../src/DirectoryMonitor.vala"
	removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
#line 1064 "../src/DirectoryMonitor.vala"
	_vala_assert (removed, "removed");
#line 1066 "../src/DirectoryMonitor.vala"
	_tmp9_ = monitor;
#line 1066 "../src/DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, _tmp9_);
#line 1068 "../src/DirectoryMonitor.vala"
	_tmp10_ = g_file_get_path (dir);
#line 1068 "../src/DirectoryMonitor.vala"
	_tmp11_ = _tmp10_;
#line 1068 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup_printf ("Removed monitor for %s", _tmp11_);
#line 1068 "../src/DirectoryMonitor.vala"
	_tmp13_ = _tmp12_;
#line 1068 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp13_);
#line 1068 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp13_);
#line 1068 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp11_);
#line 1070 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 1070 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1070 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1070 "../src/DirectoryMonitor.vala"
	return result;
#line 4675 "DirectoryMonitor.c"
}

static void
directory_monitor_cancel_monitor (DirectoryMonitor* self,
                                  GFileMonitor* monitor)
{
	guint _tmp0_;
#line 1073 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1073 "../src/DirectoryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 1074 "../src/DirectoryMonitor.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp0_, NULL, FALSE);
#line 1074 "../src/DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1075 "../src/DirectoryMonitor.vala"
	g_file_monitor_cancel (monitor);
#line 4693 "DirectoryMonitor.c"
}

static void
_directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object,
                                                                                GAsyncResult* res,
                                                                                gpointer self)
{
#line 1095 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_on_completed ((DirectoryMonitorQueryInfoQueueElement*) self, source_object, res);
#line 1095 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_unref (self);
#line 4705 "DirectoryMonitor.c"
}

static gboolean
_directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self)
{
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events ((DirectoryMonitor*) self);
#line 1104 "../src/DirectoryMonitor.vala"
	return result;
#line 4715 "DirectoryMonitor.c"
}

static void
directory_monitor_on_monitor_notification (DirectoryMonitor* self,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	DirectoryMonitorQueryInfoQueueElement* query_info = NULL;
	DirectoryMonitorQueryInfoQueueElement* _tmp8_;
	GeeQueue* _tmp9_;
	DirectoryMonitorQueryInfoQueueElement* _tmp10_;
#line 1078 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1078 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1080 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 4740 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1080 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1080 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1080 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 4748 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1080 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(none)");
#line 1080 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1080 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 4757 "DirectoryMonitor.c"
	}
#line 1079 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1079 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1079 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1079 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1079 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1079 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1079 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1079 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1089 "../src/DirectoryMonitor.vala"
	_tmp8_ = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
#line 1089 "../src/DirectoryMonitor.vala"
	query_info = _tmp8_;
#line 1090 "../src/DirectoryMonitor.vala"
	_tmp9_ = self->priv->query_info_queue;
#line 1090 "../src/DirectoryMonitor.vala"
	_tmp10_ = query_info;
#line 1090 "../src/DirectoryMonitor.vala"
	gee_queue_offer (_tmp9_, _tmp10_);
#line 1092 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1092 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1092 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 4791 "DirectoryMonitor.c"
		{
			GCancellable* _tmp11_;
			DirectoryMonitorQueryInfoQueueElement* _tmp12_;
#line 1095 "../src/DirectoryMonitor.vala"
			_tmp11_ = self->priv->cancellable;
#line 1095 "../src/DirectoryMonitor.vala"
			_tmp12_ = query_info;
#line 1095 "../src/DirectoryMonitor.vala"
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp11_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp12_));
#line 1097 "../src/DirectoryMonitor.vala"
			break;
#line 4803 "DirectoryMonitor.c"
		}
#line 1092 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 4807 "DirectoryMonitor.c"
		{
#line 1103 "../src/DirectoryMonitor.vala"
			if (self->priv->delete_timer_id == ((guint) 0)) {
#line 1104 "../src/DirectoryMonitor.vala"
				self->priv->delete_timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 4813 "DirectoryMonitor.c"
			}
#line 1105 "../src/DirectoryMonitor.vala"
			break;
#line 4817 "DirectoryMonitor.c"
		}
#line 1092 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 4821 "DirectoryMonitor.c"
		{
#line 1110 "../src/DirectoryMonitor.vala"
			if (other_file != NULL) {
#line 4825 "DirectoryMonitor.c"
				GCancellable* _tmp13_;
				DirectoryMonitorQueryInfoQueueElement* _tmp14_;
#line 1111 "../src/DirectoryMonitor.vala"
				_tmp13_ = self->priv->cancellable;
#line 1111 "../src/DirectoryMonitor.vala"
				_tmp14_ = query_info;
#line 1111 "../src/DirectoryMonitor.vala"
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp13_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp14_));
#line 4834 "DirectoryMonitor.c"
			} else {
				GeeQueue* _tmp15_;
				DirectoryMonitorQueryInfoQueueElement* _tmp16_;
#line 1114 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1114: Unable to process MOVED event: no other_fi" \
"le");
#line 1115 "../src/DirectoryMonitor.vala"
				_tmp15_ = self->priv->query_info_queue;
#line 1115 "../src/DirectoryMonitor.vala"
				_tmp16_ = query_info;
#line 1115 "../src/DirectoryMonitor.vala"
				gee_collection_remove ((GeeCollection*) _tmp15_, _tmp16_);
#line 4846 "DirectoryMonitor.c"
			}
#line 1117 "../src/DirectoryMonitor.vala"
			break;
#line 4850 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorQueryInfoQueueElement* _tmp17_;
			DirectoryMonitorQueryInfoQueueElement* _tmp18_;
#line 1121 "../src/DirectoryMonitor.vala"
			_tmp17_ = query_info;
#line 1121 "../src/DirectoryMonitor.vala"
			_tmp17_->completed = TRUE;
#line 1122 "../src/DirectoryMonitor.vala"
			_tmp18_ = query_info;
#line 1122 "../src/DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, _tmp18_);
#line 1123 "../src/DirectoryMonitor.vala"
			break;
#line 4866 "DirectoryMonitor.c"
		}
	}
#line 1078 "../src/DirectoryMonitor.vala"
	_directory_monitor_query_info_queue_element_unref0 (query_info);
#line 1078 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 4873 "DirectoryMonitor.c"
}

static void
directory_monitor_process_query_queue (DirectoryMonitor* self,
                                       DirectoryMonitorQueryInfoQueueElement* query_info)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 1127 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1130 "../src/DirectoryMonitor.vala"
	if (query_info != NULL) {
#line 4886 "DirectoryMonitor.c"
		GFileInfo* _tmp2_;
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp2_ = query_info->info;
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_ != NULL;
#line 4892 "DirectoryMonitor.c"
	} else {
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 4896 "DirectoryMonitor.c"
	}
#line 1130 "../src/DirectoryMonitor.vala"
	if (_tmp1_) {
#line 4900 "DirectoryMonitor.c"
		GFileMonitorEvent _tmp3_;
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp3_ = query_info->event;
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp3_ == G_FILE_MONITOR_EVENT_CREATED;
#line 4906 "DirectoryMonitor.c"
	} else {
#line 1130 "../src/DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 4910 "DirectoryMonitor.c"
	}
#line 1130 "../src/DirectoryMonitor.vala"
	if (_tmp0_) {
#line 4914 "DirectoryMonitor.c"
		GFile* match = NULL;
		DirectoryMonitorFileInfoMap* _tmp4_;
		GFileInfo* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 1133 "../src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->files;
#line 1133 "../src/DirectoryMonitor.vala"
		_tmp5_ = query_info->info;
#line 1133 "../src/DirectoryMonitor.vala"
		_tmp6_ = directory_monitor_file_info_map_find_match (_tmp4_, _tmp5_);
#line 1133 "../src/DirectoryMonitor.vala"
		match = _tmp6_;
#line 1134 "../src/DirectoryMonitor.vala"
		_tmp7_ = match;
#line 1134 "../src/DirectoryMonitor.vala"
		if (_tmp7_ != NULL) {
#line 4932 "DirectoryMonitor.c"
			gboolean matched = FALSE;
#line 1135 "../src/DirectoryMonitor.vala"
			matched = FALSE;
#line 4936 "DirectoryMonitor.c"
			{
				GeeIterator* _enqueued_it = NULL;
				GeeQueue* _tmp8_;
				GeeIterator* _tmp9_;
#line 1136 "../src/DirectoryMonitor.vala"
				_tmp8_ = self->priv->query_info_queue;
#line 1136 "../src/DirectoryMonitor.vala"
				_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 1136 "../src/DirectoryMonitor.vala"
				_enqueued_it = _tmp9_;
#line 1136 "../src/DirectoryMonitor.vala"
				while (TRUE) {
#line 4949 "DirectoryMonitor.c"
					GeeIterator* _tmp10_;
					DirectoryMonitorQueryInfoQueueElement* enqueued = NULL;
					GeeIterator* _tmp11_;
					gpointer _tmp12_;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
					DirectoryMonitorQueryInfoQueueElement* _tmp15_;
					GFileMonitorEvent _tmp16_;
					GFile* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					DirectoryMonitorQueryInfoQueueElement* _tmp24_;
					GFile* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
					DirectoryMonitorQueryInfoQueueElement* _tmp30_;
					DirectoryMonitorQueryInfoQueueElement* _tmp31_;
					GFile* _tmp32_;
					GFile* _tmp33_;
					DirectoryMonitorQueryInfoQueueElement* _tmp34_;
					GFileInfo* _tmp35_;
					GFileInfo* _tmp36_;
					DirectoryMonitorQueryInfoQueueElement* _tmp37_;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp10_ = _enqueued_it;
#line 1136 "../src/DirectoryMonitor.vala"
					if (!gee_iterator_next (_tmp10_)) {
#line 1136 "../src/DirectoryMonitor.vala"
						break;
#line 4981 "DirectoryMonitor.c"
					}
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp11_ = _enqueued_it;
#line 1136 "../src/DirectoryMonitor.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 1136 "../src/DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp12_;
#line 1137 "../src/DirectoryMonitor.vala"
					_tmp15_ = enqueued;
#line 1137 "../src/DirectoryMonitor.vala"
					_tmp16_ = _tmp15_->event;
#line 1137 "../src/DirectoryMonitor.vala"
					if (_tmp16_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1137 "../src/DirectoryMonitor.vala"
						_tmp14_ = TRUE;
#line 4997 "DirectoryMonitor.c"
					} else {
						DirectoryMonitorQueryInfoQueueElement* _tmp17_;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp17_ = enqueued;
#line 1138 "../src/DirectoryMonitor.vala"
						_tmp14_ = _tmp17_->completed;
#line 5004 "DirectoryMonitor.c"
					}
#line 1137 "../src/DirectoryMonitor.vala"
					if (_tmp14_) {
#line 1137 "../src/DirectoryMonitor.vala"
						_tmp13_ = TRUE;
#line 5010 "DirectoryMonitor.c"
					} else {
						GFile* _tmp18_;
						DirectoryMonitorQueryInfoQueueElement* _tmp19_;
						GFile* _tmp20_;
#line 1139 "../src/DirectoryMonitor.vala"
						_tmp18_ = match;
#line 1139 "../src/DirectoryMonitor.vala"
						_tmp19_ = enqueued;
#line 1139 "../src/DirectoryMonitor.vala"
						_tmp20_ = _tmp19_->file;
#line 1139 "../src/DirectoryMonitor.vala"
						_tmp13_ = !g_file_equal (_tmp18_, _tmp20_);
#line 5023 "DirectoryMonitor.c"
					}
#line 1137 "../src/DirectoryMonitor.vala"
					if (_tmp13_) {
#line 1140 "../src/DirectoryMonitor.vala"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1140 "../src/DirectoryMonitor.vala"
						continue;
#line 5031 "DirectoryMonitor.c"
					}
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp21_ = query_info->file;
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp22_ = g_file_get_path (_tmp21_);
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp23_ = _tmp22_;
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp24_ = enqueued;
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp25_ = _tmp24_->file;
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp26_ = g_file_get_path (_tmp25_);
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp27_ = _tmp26_;
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp28_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp23_, _tmp27_);
#line 1143 "../src/DirectoryMonitor.vala"
					_tmp29_ = _tmp28_;
#line 1143 "../src/DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp29_);
#line 1143 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp29_);
#line 1143 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp27_);
#line 1143 "../src/DirectoryMonitor.vala"
					_g_free0 (_tmp23_);
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp30_ = enqueued;
#line 1146 "../src/DirectoryMonitor.vala"
					_tmp30_->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp31_ = enqueued;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp32_ = query_info->file;
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1147 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp31_->other_file);
#line 1147 "../src/DirectoryMonitor.vala"
					_tmp31_->other_file = _tmp33_;
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp34_ = enqueued;
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp35_ = query_info->info;
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp36_ = _g_object_ref0 (_tmp35_);
#line 1148 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp34_->info);
#line 1148 "../src/DirectoryMonitor.vala"
					_tmp34_->info = _tmp36_;
#line 1149 "../src/DirectoryMonitor.vala"
					_tmp37_ = enqueued;
#line 1149 "../src/DirectoryMonitor.vala"
					_tmp37_->completed = TRUE;
#line 1151 "../src/DirectoryMonitor.vala"
					matched = TRUE;
#line 1153 "../src/DirectoryMonitor.vala"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1153 "../src/DirectoryMonitor.vala"
					break;
#line 5093 "DirectoryMonitor.c"
				}
#line 1136 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_enqueued_it);
#line 5097 "DirectoryMonitor.c"
			}
#line 1156 "../src/DirectoryMonitor.vala"
			if (matched) {
#line 5101 "DirectoryMonitor.c"
				GeeQueue* _tmp38_;
#line 1157 "../src/DirectoryMonitor.vala"
				_tmp38_ = self->priv->query_info_queue;
#line 1157 "../src/DirectoryMonitor.vala"
				gee_collection_remove ((GeeCollection*) _tmp38_, query_info);
#line 5107 "DirectoryMonitor.c"
			}
		}
#line 1130 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 5112 "DirectoryMonitor.c"
	}
	{
		gboolean _tmp39_ = FALSE;
#line 1162 "../src/DirectoryMonitor.vala"
		_tmp39_ = TRUE;
#line 1162 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5120 "DirectoryMonitor.c"
			DirectoryMonitorQueryInfoQueueElement* next = NULL;
			GeeQueue* _tmp40_;
			gpointer _tmp41_;
			gboolean _tmp42_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp43_;
			DirectoryMonitorQueryInfoQueueElement* n = NULL;
			GeeQueue* _tmp45_;
			gpointer _tmp46_;
			DirectoryMonitorQueryInfoQueueElement* _tmp47_;
			DirectoryMonitorQueryInfoQueueElement* _tmp48_;
			DirectoryMonitorQueryInfoQueueElement* _tmp49_;
			DirectoryMonitorQueryInfoQueueElement* _tmp50_;
			GFileMonitorEvent _tmp51_;
			GEnumValue* _tmp52_;
			DirectoryMonitorQueryInfoQueueElement* _tmp53_;
			GFile* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			DirectoryMonitorQueryInfoQueueElement* _tmp59_;
			GError* _tmp60_;
			gboolean _tmp73_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp74_;
			GFileInfo* _tmp75_;
			gboolean _tmp89_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp90_;
			GFileInfo* _tmp91_;
			DirectoryMonitorQueryInfoQueueElement* _tmp103_;
			GFile* _tmp104_;
			DirectoryMonitorQueryInfoQueueElement* _tmp105_;
			GFile* _tmp106_;
			DirectoryMonitorQueryInfoQueueElement* _tmp107_;
			GFileInfo* _tmp108_;
			DirectoryMonitorQueryInfoQueueElement* _tmp109_;
			GFileMonitorEvent _tmp110_;
#line 1162 "../src/DirectoryMonitor.vala"
			if (!_tmp39_) {
#line 5159 "DirectoryMonitor.c"
			}
#line 1162 "../src/DirectoryMonitor.vala"
			_tmp39_ = FALSE;
#line 1164 "../src/DirectoryMonitor.vala"
			_tmp40_ = self->priv->query_info_queue;
#line 1164 "../src/DirectoryMonitor.vala"
			_tmp41_ = gee_queue_peek (_tmp40_);
#line 1164 "../src/DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp41_;
#line 1165 "../src/DirectoryMonitor.vala"
			_tmp43_ = next;
#line 1165 "../src/DirectoryMonitor.vala"
			if (_tmp43_ == NULL) {
#line 1165 "../src/DirectoryMonitor.vala"
				_tmp42_ = TRUE;
#line 5175 "DirectoryMonitor.c"
			} else {
				DirectoryMonitorQueryInfoQueueElement* _tmp44_;
#line 1165 "../src/DirectoryMonitor.vala"
				_tmp44_ = next;
#line 1165 "../src/DirectoryMonitor.vala"
				_tmp42_ = !_tmp44_->completed;
#line 5182 "DirectoryMonitor.c"
			}
#line 1165 "../src/DirectoryMonitor.vala"
			if (_tmp42_) {
#line 1166 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1166 "../src/DirectoryMonitor.vala"
				break;
#line 5190 "DirectoryMonitor.c"
			}
#line 1169 "../src/DirectoryMonitor.vala"
			_tmp45_ = self->priv->query_info_queue;
#line 1169 "../src/DirectoryMonitor.vala"
			_tmp46_ = gee_queue_poll (_tmp45_);
#line 1169 "../src/DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp46_;
#line 1170 "../src/DirectoryMonitor.vala"
			_tmp47_ = next;
#line 1170 "../src/DirectoryMonitor.vala"
			_tmp48_ = n;
#line 1170 "../src/DirectoryMonitor.vala"
			_vala_assert (_tmp47_ == _tmp48_, "next == n");
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp49_ = next;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp50_ = next;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp51_ = _tmp50_->event;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp52_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp51_);
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp53_ = next;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp54_ = _tmp53_->file;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp55_ = g_file_get_path (_tmp54_);
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp56_ = _tmp55_;
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp57_ = g_strdup_printf ("Completed info query %u for %s on %s", _tmp49_->position, (_tmp52_ != NULL) ? _tmp52_->value_name : NULL, _tmp56_);
#line 1172 "../src/DirectoryMonitor.vala"
			_tmp58_ = _tmp57_;
#line 1172 "../src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp58_);
#line 1172 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp58_);
#line 1172 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp56_);
#line 1175 "../src/DirectoryMonitor.vala"
			_tmp59_ = next;
#line 1175 "../src/DirectoryMonitor.vala"
			_tmp60_ = _tmp59_->err;
#line 1175 "../src/DirectoryMonitor.vala"
			if (_tmp60_ != NULL) {
#line 5236 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp61_;
				GFile* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				DirectoryMonitorQueryInfoQueueElement* _tmp65_;
				GFileMonitorEvent _tmp66_;
				GEnumValue* _tmp67_;
				DirectoryMonitorQueryInfoQueueElement* _tmp68_;
				GError* _tmp69_;
				const gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp61_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp62_ = _tmp61_->file;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp63_ = g_file_get_path (_tmp62_);
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp64_ = _tmp63_;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp65_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp66_ = _tmp65_->event;
#line 1177 "../src/DirectoryMonitor.vala"
				_tmp67_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp66_);
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp68_ = next;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp69_ = _tmp68_->err;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp70_ = _tmp69_->message;
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp71_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp64_, (_tmp67_ != NULL) ? _tmp67_->value_name : NULL, _tmp70_);
#line 1176 "../src/DirectoryMonitor.vala"
				_tmp72_ = _tmp71_;
#line 1176 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp72_);
#line 1176 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp72_);
#line 1176 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp64_);
#line 1179 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1179 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1179 "../src/DirectoryMonitor.vala"
				continue;
#line 5285 "DirectoryMonitor.c"
			}
#line 1183 "../src/DirectoryMonitor.vala"
			_tmp74_ = next;
#line 1183 "../src/DirectoryMonitor.vala"
			_tmp75_ = _tmp74_->info;
#line 1183 "../src/DirectoryMonitor.vala"
			if (_tmp75_ != NULL) {
#line 5293 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp76_;
				GFileInfo* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp76_ = next;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp77_ = _tmp76_->info;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp78_ = get_file_info_id (_tmp77_);
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp79_ = _tmp78_;
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp73_ = _tmp79_ == NULL;
#line 1183 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp79_);
#line 5310 "DirectoryMonitor.c"
			} else {
#line 1183 "../src/DirectoryMonitor.vala"
				_tmp73_ = FALSE;
#line 5314 "DirectoryMonitor.c"
			}
#line 1183 "../src/DirectoryMonitor.vala"
			if (_tmp73_) {
#line 5318 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp80_;
				GFile* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				DirectoryMonitorQueryInfoQueueElement* _tmp84_;
				GFileMonitorEvent _tmp85_;
				GEnumValue* _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp80_ = next;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp81_ = _tmp80_->file;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp82_ = g_file_get_path (_tmp81_);
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp83_ = _tmp82_;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp84_ = next;
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp85_ = _tmp84_->event;
#line 1185 "../src/DirectoryMonitor.vala"
				_tmp86_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp85_);
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp87_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp83_, (_tmp86_ != NULL) ? _tmp86_->value_name : NULL);
#line 1184 "../src/DirectoryMonitor.vala"
				_tmp88_ = _tmp87_;
#line 1184 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp88_);
#line 1184 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp88_);
#line 1184 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp83_);
#line 1187 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1187 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1187 "../src/DirectoryMonitor.vala"
				continue;
#line 5358 "DirectoryMonitor.c"
			}
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp90_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
			_tmp91_ = _tmp90_->info;
#line 1191 "../src/DirectoryMonitor.vala"
			if (_tmp91_ != NULL) {
#line 5366 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp92_;
				GFileInfo* _tmp93_;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp92_ = next;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp93_ = _tmp92_->info;
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp89_ = !directory_monitor_is_file_symlink_supported (_tmp93_);
#line 5375 "DirectoryMonitor.c"
			} else {
#line 1191 "../src/DirectoryMonitor.vala"
				_tmp89_ = FALSE;
#line 5379 "DirectoryMonitor.c"
			}
#line 1191 "../src/DirectoryMonitor.vala"
			if (_tmp89_) {
#line 5383 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp94_;
				GFile* _tmp95_;
				gchar* _tmp96_;
				gchar* _tmp97_;
				DirectoryMonitorQueryInfoQueueElement* _tmp98_;
				GFileMonitorEvent _tmp99_;
				GEnumValue* _tmp100_;
				gchar* _tmp101_;
				gchar* _tmp102_;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp94_ = next;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp95_ = _tmp94_->file;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp96_ = g_file_get_path (_tmp95_);
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp97_ = _tmp96_;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp98_ = next;
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp99_ = _tmp98_->event;
#line 1193 "../src/DirectoryMonitor.vala"
				_tmp100_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp99_);
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp101_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp97_, (_tmp100_ != NULL) ? _tmp100_->value_name : NULL);
#line 1192 "../src/DirectoryMonitor.vala"
				_tmp102_ = _tmp101_;
#line 1192 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp102_);
#line 1192 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp102_);
#line 1192 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp97_);
#line 1195 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1195 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1195 "../src/DirectoryMonitor.vala"
				continue;
#line 5423 "DirectoryMonitor.c"
			}
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp103_ = next;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp104_ = _tmp103_->file;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp105_ = next;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp106_ = _tmp105_->other_file;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp107_ = next;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp108_ = _tmp107_->info;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp109_ = next;
#line 1198 "../src/DirectoryMonitor.vala"
			_tmp110_ = _tmp109_->event;
#line 1198 "../src/DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, _tmp104_, _tmp106_, _tmp108_, _tmp110_);
#line 1162 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (n);
#line 1162 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (next);
#line 5447 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self,
                                                 GFile* file,
                                                 GFile* other_file,
                                                 GFileInfo* info,
                                                 GFileMonitorEvent event)
{
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1202 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 1202 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1205 "../src/DirectoryMonitor.vala"
	if (other_file != NULL) {
#line 5471 "DirectoryMonitor.c"
		gchar* _tmp1_;
#line 1205 "../src/DirectoryMonitor.vala"
		_tmp1_ = g_file_get_path (other_file);
#line 1205 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1205 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp1_;
#line 5479 "DirectoryMonitor.c"
	} else {
		gchar* _tmp2_;
#line 1205 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_strdup ("(null)");
#line 1205 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1205 "../src/DirectoryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 5488 "DirectoryMonitor.c"
	}
#line 1204 "../src/DirectoryMonitor.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1204 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (file);
#line 1204 "../src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 1204 "../src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
#line 1204 "../src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 1204 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 1204 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 1204 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 1209 "../src/DirectoryMonitor.vala"
	switch (event) {
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 5510 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
			DirectoryMonitorFType _tmp8_;
#line 1211 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1213 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1214 "../src/DirectoryMonitor.vala"
			_tmp8_ = ftype;
#line 1214 "../src/DirectoryMonitor.vala"
			switch (_tmp8_) {
#line 1214 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5524 "DirectoryMonitor.c"
				{
#line 1216 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, file, info);
#line 1217 "../src/DirectoryMonitor.vala"
					break;
#line 5530 "DirectoryMonitor.c"
				}
#line 1214 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5534 "DirectoryMonitor.c"
				{
					gint _tmp9_;
#line 1224 "../src/DirectoryMonitor.vala"
					_tmp9_ = self->priv->outstanding_exploration_dirs;
#line 1224 "../src/DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs = _tmp9_ + 1;
#line 1225 "../src/DirectoryMonitor.vala"
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
#line 1226 "../src/DirectoryMonitor.vala"
					break;
#line 5545 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp10_;
#line 1229 "../src/DirectoryMonitor.vala"
					_tmp10_ = ftype;
#line 1229 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp10_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1230 "../src/DirectoryMonitor.vala"
					break;
#line 5556 "DirectoryMonitor.c"
				}
			}
#line 1232 "../src/DirectoryMonitor.vala"
			break;
#line 5561 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 5565 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp11_;
			GFileInfo* _tmp12_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp17_;
			DirectoryMonitorFType _tmp18_;
#line 1236 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1238 "../src/DirectoryMonitor.vala"
			_tmp11_ = directory_monitor_get_file_info (self, file);
#line 1238 "../src/DirectoryMonitor.vala"
			local_info = _tmp11_;
#line 1239 "../src/DirectoryMonitor.vala"
			_tmp12_ = local_info;
#line 1239 "../src/DirectoryMonitor.vala"
			if (_tmp12_ == NULL) {
#line 5583 "DirectoryMonitor.c"
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 1240 "../src/DirectoryMonitor.vala"
				_tmp13_ = g_file_get_path (file);
#line 1240 "../src/DirectoryMonitor.vala"
				_tmp14_ = _tmp13_;
#line 1240 "../src/DirectoryMonitor.vala"
				_tmp15_ = g_strdup_printf ("Changed event for unknown file %s", _tmp14_);
#line 1240 "../src/DirectoryMonitor.vala"
				_tmp16_ = _tmp15_;
#line 1240 "../src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp16_);
#line 1240 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp16_);
#line 1240 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp14_);
#line 1242 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1242 "../src/DirectoryMonitor.vala"
				break;
#line 5606 "DirectoryMonitor.c"
			}
#line 1245 "../src/DirectoryMonitor.vala"
			_tmp17_ = local_info;
#line 1245 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp17_);
#line 1246 "../src/DirectoryMonitor.vala"
			_tmp18_ = ftype;
#line 1246 "../src/DirectoryMonitor.vala"
			switch (_tmp18_) {
#line 1246 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5618 "DirectoryMonitor.c"
				{
#line 1248 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, file);
#line 1249 "../src/DirectoryMonitor.vala"
					break;
#line 5624 "DirectoryMonitor.c"
				}
#line 1246 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5628 "DirectoryMonitor.c"
				{
#line 1252 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, file);
#line 1253 "../src/DirectoryMonitor.vala"
					break;
#line 5634 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp19_;
#line 1256 "../src/DirectoryMonitor.vala"
					_tmp19_ = ftype;
#line 1256 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp19_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1257 "../src/DirectoryMonitor.vala"
					break;
#line 5645 "DirectoryMonitor.c"
				}
			}
#line 1259 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1259 "../src/DirectoryMonitor.vala"
			break;
#line 5652 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 5656 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
			DirectoryMonitorFType _tmp20_;
#line 1262 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1264 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1265 "../src/DirectoryMonitor.vala"
			_tmp20_ = ftype;
#line 1265 "../src/DirectoryMonitor.vala"
			switch (_tmp20_) {
#line 1265 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5670 "DirectoryMonitor.c"
				{
#line 1267 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
#line 1268 "../src/DirectoryMonitor.vala"
					break;
#line 5676 "DirectoryMonitor.c"
				}
#line 1265 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5680 "DirectoryMonitor.c"
				{
#line 1271 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
#line 1272 "../src/DirectoryMonitor.vala"
					break;
#line 5686 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp21_;
#line 1275 "../src/DirectoryMonitor.vala"
					_tmp21_ = ftype;
#line 1275 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp21_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1276 "../src/DirectoryMonitor.vala"
					break;
#line 5697 "DirectoryMonitor.c"
				}
			}
#line 1278 "../src/DirectoryMonitor.vala"
			break;
#line 5702 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 5706 "DirectoryMonitor.c"
		{
			DirectoryMonitorFType ftype = 0;
			DirectoryMonitorFType _tmp22_;
#line 1281 "../src/DirectoryMonitor.vala"
			_vala_assert (info != NULL, "info != null");
#line 1282 "../src/DirectoryMonitor.vala"
			_vala_assert (other_file != NULL, "other_file != null");
#line 1286 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (info);
#line 1287 "../src/DirectoryMonitor.vala"
			_tmp22_ = ftype;
#line 1287 "../src/DirectoryMonitor.vala"
			switch (_tmp22_) {
#line 1287 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5722 "DirectoryMonitor.c"
				{
#line 1289 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
#line 1290 "../src/DirectoryMonitor.vala"
					break;
#line 5728 "DirectoryMonitor.c"
				}
#line 1287 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5732 "DirectoryMonitor.c"
				{
					GFileInfo* old_dir_info = NULL;
					DirectoryMonitorFileInfoMap* _tmp23_;
					GFileInfo* _tmp24_;
					GFileInfo* _tmp25_;
					GFileInfo* _tmp28_;
#line 1294 "../src/DirectoryMonitor.vala"
					_tmp23_ = self->priv->files;
#line 1294 "../src/DirectoryMonitor.vala"
					_tmp24_ = directory_monitor_file_info_map_get_info (_tmp23_, file);
#line 1294 "../src/DirectoryMonitor.vala"
					old_dir_info = _tmp24_;
#line 1295 "../src/DirectoryMonitor.vala"
					_tmp25_ = old_dir_info;
#line 1295 "../src/DirectoryMonitor.vala"
					if (_tmp25_ == NULL) {
#line 5749 "DirectoryMonitor.c"
						gchar* _tmp26_;
						gchar* _tmp27_;
#line 1296 "../src/DirectoryMonitor.vala"
						_tmp26_ = g_file_get_path (file);
#line 1296 "../src/DirectoryMonitor.vala"
						_tmp27_ = _tmp26_;
#line 1296 "../src/DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1296: Directory moved event for unknown file %s", _tmp27_);
#line 1296 "../src/DirectoryMonitor.vala"
						_g_free0 (_tmp27_);
#line 1298 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (old_dir_info);
#line 1298 "../src/DirectoryMonitor.vala"
						break;
#line 5764 "DirectoryMonitor.c"
					}
#line 1301 "../src/DirectoryMonitor.vala"
					_tmp28_ = old_dir_info;
#line 1301 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, file, _tmp28_, other_file, info);
#line 1302 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (old_dir_info);
#line 1302 "../src/DirectoryMonitor.vala"
					break;
#line 5774 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp29_;
#line 1305 "../src/DirectoryMonitor.vala"
					_tmp29_ = ftype;
#line 1305 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp29_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1306 "../src/DirectoryMonitor.vala"
					break;
#line 5785 "DirectoryMonitor.c"
				}
			}
#line 1308 "../src/DirectoryMonitor.vala"
			break;
#line 5790 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 5794 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp30_;
			GFileInfo* _tmp31_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp34_;
			DirectoryMonitorFType _tmp35_;
#line 1311 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1313 "../src/DirectoryMonitor.vala"
			_tmp30_ = directory_monitor_get_file_info (self, file);
#line 1313 "../src/DirectoryMonitor.vala"
			local_info = _tmp30_;
#line 1314 "../src/DirectoryMonitor.vala"
			_tmp31_ = local_info;
#line 1314 "../src/DirectoryMonitor.vala"
			if (_tmp31_ == NULL) {
#line 5812 "DirectoryMonitor.c"
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 1315 "../src/DirectoryMonitor.vala"
				_tmp32_ = g_file_get_path (file);
#line 1315 "../src/DirectoryMonitor.vala"
				_tmp33_ = _tmp32_;
#line 1315 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1315: Deleted event for unknown file %s", _tmp33_);
#line 1315 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp33_);
#line 1317 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1317 "../src/DirectoryMonitor.vala"
				break;
#line 5827 "DirectoryMonitor.c"
			}
#line 1320 "../src/DirectoryMonitor.vala"
			_tmp34_ = local_info;
#line 1320 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp34_);
#line 1321 "../src/DirectoryMonitor.vala"
			_tmp35_ = ftype;
#line 1321 "../src/DirectoryMonitor.vala"
			switch (_tmp35_) {
#line 1321 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5839 "DirectoryMonitor.c"
				{
#line 1323 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, file);
#line 1324 "../src/DirectoryMonitor.vala"
					break;
#line 5845 "DirectoryMonitor.c"
				}
#line 1321 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5849 "DirectoryMonitor.c"
				{
#line 1327 "../src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, file);
#line 1328 "../src/DirectoryMonitor.vala"
					break;
#line 5855 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp36_;
#line 1331 "../src/DirectoryMonitor.vala"
					_tmp36_ = ftype;
#line 1331 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp36_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1332 "../src/DirectoryMonitor.vala"
					break;
#line 5866 "DirectoryMonitor.c"
				}
			}
#line 1334 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1334 "../src/DirectoryMonitor.vala"
			break;
#line 5873 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 5877 "DirectoryMonitor.c"
		{
			GFileInfo* local_info = NULL;
			GFileInfo* _tmp37_;
			GFileInfo* _tmp38_;
			DirectoryMonitorFType ftype = 0;
			GFileInfo* _tmp41_;
			DirectoryMonitorFType _tmp42_;
#line 1338 "../src/DirectoryMonitor.vala"
			_vala_assert (info == NULL, "info == null");
#line 1340 "../src/DirectoryMonitor.vala"
			_tmp37_ = directory_monitor_get_file_info (self, file);
#line 1340 "../src/DirectoryMonitor.vala"
			local_info = _tmp37_;
#line 1341 "../src/DirectoryMonitor.vala"
			_tmp38_ = local_info;
#line 1341 "../src/DirectoryMonitor.vala"
			if (_tmp38_ == NULL) {
#line 5895 "DirectoryMonitor.c"
				gchar* _tmp39_;
				gchar* _tmp40_;
#line 1342 "../src/DirectoryMonitor.vala"
				_tmp39_ = g_file_get_path (file);
#line 1342 "../src/DirectoryMonitor.vala"
				_tmp40_ = _tmp39_;
#line 1342 "../src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1342: Attribute changed event for unknown file %" \
"s", _tmp40_);
#line 1342 "../src/DirectoryMonitor.vala"
				_g_free0 (_tmp40_);
#line 1344 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1344 "../src/DirectoryMonitor.vala"
				break;
#line 5910 "DirectoryMonitor.c"
			}
#line 1347 "../src/DirectoryMonitor.vala"
			_tmp41_ = local_info;
#line 1347 "../src/DirectoryMonitor.vala"
			ftype = directory_monitor_get_ftype (_tmp41_);
#line 1348 "../src/DirectoryMonitor.vala"
			_tmp42_ = ftype;
#line 1348 "../src/DirectoryMonitor.vala"
			switch (_tmp42_) {
#line 1348 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5922 "DirectoryMonitor.c"
				{
#line 1350 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, file);
#line 1351 "../src/DirectoryMonitor.vala"
					break;
#line 5928 "DirectoryMonitor.c"
				}
#line 1348 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5932 "DirectoryMonitor.c"
				{
#line 1354 "../src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, file);
#line 1355 "../src/DirectoryMonitor.vala"
					break;
#line 5938 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp43_;
#line 1358 "../src/DirectoryMonitor.vala"
					_tmp43_ = ftype;
#line 1358 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp43_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1359 "../src/DirectoryMonitor.vala"
					break;
#line 5949 "DirectoryMonitor.c"
				}
			}
#line 1361 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1361 "../src/DirectoryMonitor.vala"
			break;
#line 5956 "DirectoryMonitor.c"
		}
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
#line 1209 "../src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
#line 5962 "DirectoryMonitor.c"
		{
#line 1366 "../src/DirectoryMonitor.vala"
			break;
#line 5966 "DirectoryMonitor.c"
		}
		default:
		{
			GEnumValue* _tmp44_;
#line 1369 "../src/DirectoryMonitor.vala"
			_tmp44_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 1369 "../src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1369: Unknown directory monitor event %s", (_tmp44_ != NULL) ? _tmp44_->value_name : NULL);
#line 1370 "../src/DirectoryMonitor.vala"
			break;
#line 5977 "DirectoryMonitor.c"
		}
	}
#line 1202 "../src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 5982 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_is_file_create_move (DirectoryMonitor* self,
                                       GFile* file,
                                       GFileInfo* info,
                                       GFile* * old_file,
                                       GFileInfo* * old_file_info)
{
	GFile* _vala_old_file = NULL;
	GFileInfo* _vala_old_file_info = NULL;
	gboolean result = FALSE;
	GFile* match = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 1376 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1376 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1376 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1379 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->parent_moved;
#line 1379 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_find_match (_tmp0_, info);
#line 1379 "../src/DirectoryMonitor.vala"
	match = _tmp1_;
#line 1380 "../src/DirectoryMonitor.vala"
	_tmp2_ = match;
#line 1380 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 6015 "DirectoryMonitor.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
		DirectoryMonitorFileInfoMap* _tmp8_;
		GFile* _tmp9_;
#line 1381 "../src/DirectoryMonitor.vala"
		_tmp3_ = match;
#line 1381 "../src/DirectoryMonitor.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1381 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 1381 "../src/DirectoryMonitor.vala"
		_vala_old_file = _tmp4_;
#line 1382 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->parent_moved;
#line 1382 "../src/DirectoryMonitor.vala"
		_tmp6_ = match;
#line 1382 "../src/DirectoryMonitor.vala"
		_tmp7_ = directory_monitor_file_info_map_get_info (_tmp5_, _tmp6_);
#line 1382 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 1382 "../src/DirectoryMonitor.vala"
		_vala_old_file_info = _tmp7_;
#line 1384 "../src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->parent_moved;
#line 1384 "../src/DirectoryMonitor.vala"
		_tmp9_ = match;
#line 1384 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_tmp8_, _tmp9_, info);
#line 1386 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1386 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 1386 "../src/DirectoryMonitor.vala"
		if (old_file) {
#line 1386 "../src/DirectoryMonitor.vala"
			*old_file = _vala_old_file;
#line 6055 "DirectoryMonitor.c"
		} else {
#line 1386 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file);
#line 6059 "DirectoryMonitor.c"
		}
#line 1386 "../src/DirectoryMonitor.vala"
		if (old_file_info) {
#line 1386 "../src/DirectoryMonitor.vala"
			*old_file_info = _vala_old_file_info;
#line 6065 "DirectoryMonitor.c"
		} else {
#line 1386 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file_info);
#line 6069 "DirectoryMonitor.c"
		}
#line 1386 "../src/DirectoryMonitor.vala"
		return result;
#line 6073 "DirectoryMonitor.c"
	}
#line 1389 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file);
#line 1389 "../src/DirectoryMonitor.vala"
	_vala_old_file = NULL;
#line 1390 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_old_file_info);
#line 1390 "../src/DirectoryMonitor.vala"
	_vala_old_file_info = NULL;
#line 1392 "../src/DirectoryMonitor.vala"
	result = FALSE;
#line 1392 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (match);
#line 1392 "../src/DirectoryMonitor.vala"
	if (old_file) {
#line 1392 "../src/DirectoryMonitor.vala"
		*old_file = _vala_old_file;
#line 6091 "DirectoryMonitor.c"
	} else {
#line 1392 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 6095 "DirectoryMonitor.c"
	}
#line 1392 "../src/DirectoryMonitor.vala"
	if (old_file_info) {
#line 1392 "../src/DirectoryMonitor.vala"
		*old_file_info = _vala_old_file_info;
#line 6101 "DirectoryMonitor.c"
	} else {
#line 1392 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 6105 "DirectoryMonitor.c"
	}
#line 1392 "../src/DirectoryMonitor.vala"
	return result;
#line 6109 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self)
{
	gboolean result = FALSE;
	gulong expiration = 0UL;
	gboolean any_deleted = FALSE;
	gboolean any_expired = FALSE;
#line 1395 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1396 "../src/DirectoryMonitor.vala"
	expiration = now_ms () - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1398 "../src/DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1399 "../src/DirectoryMonitor.vala"
	any_expired = FALSE;
#line 6127 "DirectoryMonitor.c"
	{
		GeeIterator* _element_it = NULL;
		GeeQueue* _tmp0_;
		GeeIterator* _tmp1_;
#line 1400 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->query_info_queue;
#line 1400 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 1400 "../src/DirectoryMonitor.vala"
		_element_it = _tmp1_;
#line 1400 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 6140 "DirectoryMonitor.c"
			GeeIterator* _tmp2_;
			DirectoryMonitorQueryInfoQueueElement* element = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DirectoryMonitorQueryInfoQueueElement* _tmp5_;
			GFileMonitorEvent _tmp6_;
			DirectoryMonitorQueryInfoQueueElement* _tmp7_;
			DirectoryMonitorQueryInfoQueueElement* _tmp8_;
#line 1400 "../src/DirectoryMonitor.vala"
			_tmp2_ = _element_it;
#line 1400 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1400 "../src/DirectoryMonitor.vala"
				break;
#line 6155 "DirectoryMonitor.c"
			}
#line 1400 "../src/DirectoryMonitor.vala"
			_tmp3_ = _element_it;
#line 1400 "../src/DirectoryMonitor.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1400 "../src/DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp4_;
#line 1401 "../src/DirectoryMonitor.vala"
			_tmp5_ = element;
#line 1401 "../src/DirectoryMonitor.vala"
			_tmp6_ = _tmp5_->event;
#line 1401 "../src/DirectoryMonitor.vala"
			if (_tmp6_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1402 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1402 "../src/DirectoryMonitor.vala"
				continue;
#line 6173 "DirectoryMonitor.c"
			}
#line 1404 "../src/DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1406 "../src/DirectoryMonitor.vala"
			_tmp7_ = element;
#line 1406 "../src/DirectoryMonitor.vala"
			if (_tmp7_->time_created_msec > expiration) {
#line 1407 "../src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1407 "../src/DirectoryMonitor.vala"
				continue;
#line 6185 "DirectoryMonitor.c"
			}
#line 1410 "../src/DirectoryMonitor.vala"
			_tmp8_ = element;
#line 1410 "../src/DirectoryMonitor.vala"
			_tmp8_->completed = TRUE;
#line 1411 "../src/DirectoryMonitor.vala"
			any_expired = TRUE;
#line 1400 "../src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (element);
#line 6195 "DirectoryMonitor.c"
		}
#line 1400 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_element_it);
#line 6199 "DirectoryMonitor.c"
	}
#line 1414 "../src/DirectoryMonitor.vala"
	if (any_expired) {
#line 1415 "../src/DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 6205 "DirectoryMonitor.c"
	}
#line 1417 "../src/DirectoryMonitor.vala"
	if (!any_deleted) {
#line 1418 "../src/DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 6211 "DirectoryMonitor.c"
	}
#line 1420 "../src/DirectoryMonitor.vala"
	result = any_deleted;
#line 1420 "../src/DirectoryMonitor.vala"
	return result;
#line 6217 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_get_file_info (DirectoryMonitor* self,
                                 GFile* file)
{
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
#line 1424 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1424 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1425 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1425 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (_tmp0_, file);
#line 1425 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1425 "../src/DirectoryMonitor.vala"
	return result;
#line 6239 "DirectoryMonitor.c"
}

GeeCollection*
directory_monitor_get_files (DirectoryMonitor* self)
{
	GeeCollection* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GeeCollection* _tmp1_;
#line 1430 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1431 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1431 "../src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_all (_tmp0_);
#line 1431 "../src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1431 "../src/DirectoryMonitor.vala"
	return result;
#line 6258 "DirectoryMonitor.c"
}

GFileInfo*
directory_monitor_query_file_info (DirectoryMonitor* self,
                                   GFile* file)
{
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GCancellable* _tmp1_;
	GFileInfo* _tmp2_;
#line 1437 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1437 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1438 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1438 "../src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->cancellable;
#line 1438 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_query_info (_tmp0_, file, _tmp1_);
#line 1438 "../src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 1438 "../src/DirectoryMonitor.vala"
	return result;
#line 6283 "DirectoryMonitor.c"
}

gboolean
directory_monitor_is_file_symlink_supported (GFileInfo* info)
{
	gboolean result = FALSE;
	DirectoryMonitorFType ftype = 0;
	DirectoryMonitorFType _tmp0_;
#line 1448 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 1449 "../src/DirectoryMonitor.vala"
	if (!g_file_info_get_is_symlink (info)) {
#line 1450 "../src/DirectoryMonitor.vala"
		result = TRUE;
#line 1450 "../src/DirectoryMonitor.vala"
		return result;
#line 6300 "DirectoryMonitor.c"
	}
#line 1452 "../src/DirectoryMonitor.vala"
	ftype = directory_monitor_get_ftype (info);
#line 1453 "../src/DirectoryMonitor.vala"
	_tmp0_ = ftype;
#line 1453 "../src/DirectoryMonitor.vala"
	switch (_tmp0_) {
#line 1453 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6310 "DirectoryMonitor.c"
		{
#line 1455 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1455 "../src/DirectoryMonitor.vala"
			return result;
#line 6316 "DirectoryMonitor.c"
		}
#line 1453 "../src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6320 "DirectoryMonitor.c"
		{
#line 1458 "../src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1458 "../src/DirectoryMonitor.vala"
			return result;
#line 6326 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorFType _tmp1_;
#line 1461 "../src/DirectoryMonitor.vala"
			_tmp1_ = ftype;
#line 1461 "../src/DirectoryMonitor.vala"
			_vala_assert (_tmp1_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 1463 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 1463 "../src/DirectoryMonitor.vala"
			return result;
#line 6339 "DirectoryMonitor.c"
		}
	}
}

static void
directory_monitor_real_root_moved (DirectoryMonitor* self,
                                   GFile* old_root,
                                   GFile* new_root,
                                   GFileInfo* new_root_info)
{
#line 393 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_root != NULL);
#line 393 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root != NULL);
#line 393 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_root_info != NULL);
#line 6356 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 73 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6381 "DirectoryMonitor.c"
	} else {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6387 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 73 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 6393 "DirectoryMonitor.c"
}

static void
directory_monitor_real_root_deleted (DirectoryMonitor* self,
                                     GFile* root)
{
#line 401 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 6402 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_started (DirectoryMonitor* self)
{
}

static void
directory_monitor_real_file_discovered (DirectoryMonitor* self,
                                        GFile* file,
                                        GFileInfo* info)
{
#line 407 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 407 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6419 "DirectoryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 73 "../src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 73 "../src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6444 "DirectoryMonitor.c"
	} else {
#line 73 "../src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 73 "../src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6450 "DirectoryMonitor.c"
	}
#line 73 "../src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 73 "../src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6456 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_discovered (DirectoryMonitor* self,
                                             GFile* file,
                                             GFileInfo* info)
{
#line 410 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 410 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6468 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_failed (DirectoryMonitor* self,
                                         const gchar* reason)
{
#line 415 "../src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 6477 "DirectoryMonitor.c"
}

static void
directory_monitor_real_discovery_completed (DirectoryMonitor* self)
{
#line 419 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 420 "../src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 6487 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_created (DirectoryMonitor* self,
                                     GFile* file,
                                     GFileInfo* info)
{
#line 423 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 423 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6499 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_moved (DirectoryMonitor* self,
                                   GFile* old_file,
                                   GFile* new_file,
                                   GFileInfo* new_file_info)
{
#line 426 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 426 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 426 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_file_info != NULL);
#line 6514 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_altered (DirectoryMonitor* self,
                                     GFile* file)
{
#line 430 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6523 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_alteration_completed (DirectoryMonitor* self,
                                                  GFile* file,
                                                  GFileInfo* info)
{
#line 435 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 435 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6535 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_attributes_altered (DirectoryMonitor* self,
                                                GFile* file)
{
#line 438 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6544 "DirectoryMonitor.c"
}

static void
directory_monitor_real_file_deleted (DirectoryMonitor* self,
                                     GFile* file)
{
#line 441 "../src/DirectoryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 6553 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_created (DirectoryMonitor* self,
                                          GFile* dir,
                                          GFileInfo* info)
{
#line 445 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 445 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6565 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_moved (DirectoryMonitor* self,
                                        GFile* old_dir,
                                        GFile* new_dir,
                                        GFileInfo* new_dir_info)
{
#line 449 "../src/DirectoryMonitor.vala"
	g_return_if_fail (old_dir != NULL);
#line 449 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir != NULL);
#line 449 "../src/DirectoryMonitor.vala"
	g_return_if_fail (new_dir_info != NULL);
#line 6580 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_altered (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 453 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6589 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self,
                                                       GFile* dir,
                                                       GFileInfo* info)
{
#line 458 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 458 "../src/DirectoryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 6601 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self,
                                                     GFile* dir)
{
#line 461 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6610 "DirectoryMonitor.c"
}

static void
directory_monitor_real_directory_deleted (DirectoryMonitor* self,
                                          GFile* dir)
{
#line 465 "../src/DirectoryMonitor.vala"
	g_return_if_fail (dir != NULL);
#line 6619 "DirectoryMonitor.c"
}

static void
directory_monitor_real_closed (DirectoryMonitor* self)
{
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_construct (GType object_type,
                                                      DirectoryMonitor* owner,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileMonitorEvent event)
{
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	guint _tmp3_;
#line 109 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 109 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 109 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 111 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (owner);
#line 111 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 111 "../src/DirectoryMonitor.vala"
	self->owner = _tmp0_;
#line 112 "../src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 112 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 112 "../src/DirectoryMonitor.vala"
	self->file = _tmp1_;
#line 113 "../src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (other_file);
#line 113 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 113 "../src/DirectoryMonitor.vala"
	self->other_file = _tmp2_;
#line 114 "../src/DirectoryMonitor.vala"
	self->event = event;
#line 115 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_query_info_queue_element_current;
#line 115 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_current = _tmp3_ + 1;
#line 115 "../src/DirectoryMonitor.vala"
	self->position = _tmp3_;
#line 116 "../src/DirectoryMonitor.vala"
	self->time_created_msec = now_ms ();
#line 109 "../src/DirectoryMonitor.vala"
	return self;
#line 6675 "DirectoryMonitor.c"
}

static DirectoryMonitorQueryInfoQueueElement*
directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner,
                                                GFile* file,
                                                GFile* other_file,
                                                GFileMonitorEvent event)
{
#line 109 "../src/DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 6686 "DirectoryMonitor.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 126 "../src/DirectoryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 6694 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self,
                                                         GObject* source,
                                                         GAsyncResult* aresult)
{
	GFile* source_file = NULL;
	GFile* _tmp0_;
	DirectoryMonitor* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 119 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/DirectoryMonitor.vala"
	g_return_if_fail (aresult != NULL);
#line 120 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, g_file_get_type (), GFile));
#line 120 "../src/DirectoryMonitor.vala"
	source_file = _tmp0_;
#line 6714 "DirectoryMonitor.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 124 "../src/DirectoryMonitor.vala"
		_tmp2_ = g_file_query_info_finish (source_file, aresult, &_inner_error0_);
#line 124 "../src/DirectoryMonitor.vala"
		_tmp1_ = _tmp2_;
#line 124 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6725 "DirectoryMonitor.c"
			goto __catch34_g_error;
		}
#line 124 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp1_;
#line 124 "../src/DirectoryMonitor.vala"
		_tmp1_ = NULL;
#line 124 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (self->info);
#line 124 "../src/DirectoryMonitor.vala"
		self->info = _tmp3_;
#line 123 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 6738 "DirectoryMonitor.c"
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		GError* _tmp5_;
#line 123 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 123 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 126 "../src/DirectoryMonitor.vala"
		_tmp4_ = err;
#line 126 "../src/DirectoryMonitor.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 126 "../src/DirectoryMonitor.vala"
		_g_error_free0 (self->err);
#line 126 "../src/DirectoryMonitor.vala"
		self->err = _tmp5_;
#line 123 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 6760 "DirectoryMonitor.c"
	}
	__finally34:
#line 123 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (source_file);
#line 123 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/DirectoryMonitor.vala"
		return;
#line 6773 "DirectoryMonitor.c"
	}
#line 130 "../src/DirectoryMonitor.vala"
	self->completed = TRUE;
#line 133 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->owner;
#line 133 "../src/DirectoryMonitor.vala"
	directory_monitor_process_query_queue (_tmp6_, self);
#line 119 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (source_file);
#line 6783 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_init (GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 6791 "DirectoryMonitor.c"
}

static void
directory_monitor_value_query_info_queue_element_free_value (GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
#line 6801 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
#line 6813 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6817 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6826 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 96 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 6837 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement * object;
		object = collect_values[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 96 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6844 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 96 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6848 "DirectoryMonitor.c"
		}
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
#line 6852 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6856 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6860 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	DirectoryMonitorQueryInfoQueueElement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 96 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6875 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 6881 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 6885 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6889 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	return NULL;
#line 6893 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_query_info_queue_element (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 96 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 96 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 6912 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_query_info_queue_element (const GValue* value)
{
#line 96 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 96 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 6922 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_query_info_queue_element (GValue* value,
                                                      gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 6944 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6948 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (old) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 6954 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_query_info_queue_element (GValue* value,
                                                       gpointer v_object)
{
	DirectoryMonitorQueryInfoQueueElement * old;
#line 96 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 96 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 96 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 6975 "DirectoryMonitor.c"
	} else {
#line 96 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 6979 "DirectoryMonitor.c"
	}
#line 96 "../src/DirectoryMonitor.vala"
	if (old) {
#line 96 "../src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 6985 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass,
                                                       gpointer klass_data)
{
#line 96 "../src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 96 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorQueryInfoQueueElementClass *) klass)->finalize = directory_monitor_query_info_queue_element_finalize;
#line 6997 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self,
                                                          gpointer klass)
{
#line 105 "../src/DirectoryMonitor.vala"
	self->info = NULL;
#line 106 "../src/DirectoryMonitor.vala"
	self->err = NULL;
#line 107 "../src/DirectoryMonitor.vala"
	self->completed = FALSE;
#line 96 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 7012 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement * obj)
{
	DirectoryMonitorQueryInfoQueueElement * self;
#line 96 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement);
#line 96 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 99 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 100 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 101 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 105 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->info);
#line 106 "../src/DirectoryMonitor.vala"
	_g_error_free0 (self->err);
#line 7033 "DirectoryMonitor.c"
}

static GType
directory_monitor_query_info_queue_element_get_type (void)
{
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}

static gpointer
directory_monitor_query_info_queue_element_ref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 96 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 96 "../src/DirectoryMonitor.vala"
	return instance;
#line 7060 "DirectoryMonitor.c"
}

static void
directory_monitor_query_info_queue_element_unref (gpointer instance)
{
	DirectoryMonitorQueryInfoQueueElement * self;
	self = instance;
#line 96 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 96 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 96 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7074 "DirectoryMonitor.c"
	}
}

static inline gpointer
directory_monitor_file_info_map_get_instance_private (DirectoryMonitorFileInfoMap* self)
{
	return G_STRUCT_MEMBER_P (self, DirectoryMonitorFileInfoMap_private_offset);
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_construct (GType object_type)
{
	DirectoryMonitorFileInfoMap* self = NULL;
#line 147 "../src/DirectoryMonitor.vala"
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
#line 147 "../src/DirectoryMonitor.vala"
	return self;
#line 7092 "DirectoryMonitor.c"
}

static DirectoryMonitorFileInfoMap*
directory_monitor_file_info_map_new (void)
{
#line 147 "../src/DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 7100 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self,
                                                GFile* file,
                                                GFileInfo* info,
                                                GFile* * normalized,
                                                gchar* * id)
{
	GFile* _vala_normalized = NULL;
	gchar* _vala_id = NULL;
	gboolean result = FALSE;
	GFileInfo* local_info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	gchar* file_id = NULL;
	GFileInfo* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	GFile* known_file = NULL;
	GeeHashMap* _tmp8_;
	const gchar* _tmp9_;
	gpointer _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp13_ = NULL;
	GFile* _tmp14_;
	GFile* _tmp16_;
#line 150 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 150 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 153 "../src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (info);
#line 153 "../src/DirectoryMonitor.vala"
	local_info = _tmp0_;
#line 154 "../src/DirectoryMonitor.vala"
	_tmp1_ = local_info;
#line 154 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 7141 "DirectoryMonitor.c"
		GeeHashMap* _tmp2_;
		gpointer _tmp3_;
		GFileInfo* _tmp4_;
#line 155 "../src/DirectoryMonitor.vala"
		_tmp2_ = self->priv->map;
#line 155 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, file);
#line 155 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 155 "../src/DirectoryMonitor.vala"
		local_info = (GFileInfo*) _tmp3_;
#line 156 "../src/DirectoryMonitor.vala"
		_tmp4_ = local_info;
#line 156 "../src/DirectoryMonitor.vala"
		if (_tmp4_ == NULL) {
#line 157 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 157 "../src/DirectoryMonitor.vala"
			_vala_normalized = NULL;
#line 158 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 158 "../src/DirectoryMonitor.vala"
			_vala_id = NULL;
#line 160 "../src/DirectoryMonitor.vala"
			result = FALSE;
#line 160 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 160 "../src/DirectoryMonitor.vala"
			if (normalized) {
#line 160 "../src/DirectoryMonitor.vala"
				*normalized = _vala_normalized;
#line 7173 "DirectoryMonitor.c"
			} else {
#line 160 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_vala_normalized);
#line 7177 "DirectoryMonitor.c"
			}
#line 160 "../src/DirectoryMonitor.vala"
			if (id) {
#line 160 "../src/DirectoryMonitor.vala"
				*id = _vala_id;
#line 7183 "DirectoryMonitor.c"
			} else {
#line 160 "../src/DirectoryMonitor.vala"
				_g_free0 (_vala_id);
#line 7187 "DirectoryMonitor.c"
			}
#line 160 "../src/DirectoryMonitor.vala"
			return result;
#line 7191 "DirectoryMonitor.c"
		}
	}
#line 164 "../src/DirectoryMonitor.vala"
	_tmp5_ = local_info;
#line 164 "../src/DirectoryMonitor.vala"
	_tmp6_ = get_file_info_id (_tmp5_);
#line 164 "../src/DirectoryMonitor.vala"
	file_id = _tmp6_;
#line 165 "../src/DirectoryMonitor.vala"
	_tmp7_ = file_id;
#line 165 "../src/DirectoryMonitor.vala"
	if (_tmp7_ == NULL) {
#line 166 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 166 "../src/DirectoryMonitor.vala"
		_vala_normalized = NULL;
#line 167 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 167 "../src/DirectoryMonitor.vala"
		_vala_id = NULL;
#line 169 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 169 "../src/DirectoryMonitor.vala"
		_g_free0 (file_id);
#line 169 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 169 "../src/DirectoryMonitor.vala"
		if (normalized) {
#line 169 "../src/DirectoryMonitor.vala"
			*normalized = _vala_normalized;
#line 7222 "DirectoryMonitor.c"
		} else {
#line 169 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 7226 "DirectoryMonitor.c"
		}
#line 169 "../src/DirectoryMonitor.vala"
		if (id) {
#line 169 "../src/DirectoryMonitor.vala"
			*id = _vala_id;
#line 7232 "DirectoryMonitor.c"
		} else {
#line 169 "../src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 7236 "DirectoryMonitor.c"
		}
#line 169 "../src/DirectoryMonitor.vala"
		return result;
#line 7240 "DirectoryMonitor.c"
	}
#line 172 "../src/DirectoryMonitor.vala"
	_tmp8_ = self->priv->id_map;
#line 172 "../src/DirectoryMonitor.vala"
	_tmp9_ = file_id;
#line 172 "../src/DirectoryMonitor.vala"
	_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp9_);
#line 172 "../src/DirectoryMonitor.vala"
	known_file = (GFile*) _tmp10_;
#line 174 "../src/DirectoryMonitor.vala"
	_tmp11_ = file_id;
#line 174 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup ((const gchar*) _tmp11_);
#line 174 "../src/DirectoryMonitor.vala"
	_g_free0 (_vala_id);
#line 174 "../src/DirectoryMonitor.vala"
	_vala_id = _tmp12_;
#line 175 "../src/DirectoryMonitor.vala"
	_tmp14_ = known_file;
#line 175 "../src/DirectoryMonitor.vala"
	if (_tmp14_ != NULL) {
#line 7262 "DirectoryMonitor.c"
		GFile* _tmp15_;
#line 175 "../src/DirectoryMonitor.vala"
		_tmp15_ = known_file;
#line 175 "../src/DirectoryMonitor.vala"
		_tmp13_ = _tmp15_;
#line 7268 "DirectoryMonitor.c"
	} else {
#line 175 "../src/DirectoryMonitor.vala"
		_tmp13_ = file;
#line 7272 "DirectoryMonitor.c"
	}
#line 175 "../src/DirectoryMonitor.vala"
	_tmp16_ = _g_object_ref0 (_tmp13_);
#line 175 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_normalized);
#line 175 "../src/DirectoryMonitor.vala"
	_vala_normalized = _tmp16_;
#line 177 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 177 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (known_file);
#line 177 "../src/DirectoryMonitor.vala"
	_g_free0 (file_id);
#line 177 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (local_info);
#line 177 "../src/DirectoryMonitor.vala"
	if (normalized) {
#line 177 "../src/DirectoryMonitor.vala"
		*normalized = _vala_normalized;
#line 7292 "DirectoryMonitor.c"
	} else {
#line 177 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 7296 "DirectoryMonitor.c"
	}
#line 177 "../src/DirectoryMonitor.vala"
	if (id) {
#line 177 "../src/DirectoryMonitor.vala"
		*id = _vala_id;
#line 7302 "DirectoryMonitor.c"
	} else {
#line 177 "../src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 7306 "DirectoryMonitor.c"
	}
#line 177 "../src/DirectoryMonitor.vala"
	return result;
#line 7310 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	gchar* existing_id = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_;
	GeeHashMap* _tmp12_;
	GFile* _tmp13_;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	GFile* _tmp16_;
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 180 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 182 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 182 "../src/DirectoryMonitor.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, file)) {
#line 7344 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp1_;
#line 183 "../src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->map;
#line 183 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, file, NULL);
#line 184 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7353 "DirectoryMonitor.c"
	}
#line 188 "../src/DirectoryMonitor.vala"
	_tmp2_ = get_file_info_id (info);
#line 188 "../src/DirectoryMonitor.vala"
	existing_id = _tmp2_;
#line 189 "../src/DirectoryMonitor.vala"
	_tmp4_ = existing_id;
#line 189 "../src/DirectoryMonitor.vala"
	if (_tmp4_ != NULL) {
#line 7363 "DirectoryMonitor.c"
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->id_map;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp6_ = existing_id;
#line 189 "../src/DirectoryMonitor.vala"
		_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 7372 "DirectoryMonitor.c"
	} else {
#line 189 "../src/DirectoryMonitor.vala"
		_tmp3_ = FALSE;
#line 7376 "DirectoryMonitor.c"
	}
#line 189 "../src/DirectoryMonitor.vala"
	if (_tmp3_) {
#line 7380 "DirectoryMonitor.c"
		gboolean removed = FALSE;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
#line 190 "../src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->id_map;
#line 190 "../src/DirectoryMonitor.vala"
		_tmp8_ = existing_id;
#line 190 "../src/DirectoryMonitor.vala"
		removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
#line 191 "../src/DirectoryMonitor.vala"
		_vala_assert (removed, "removed");
#line 7392 "DirectoryMonitor.c"
	}
#line 196 "../src/DirectoryMonitor.vala"
	_tmp11_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp9_, &_tmp10_);
#line 196 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 196 "../src/DirectoryMonitor.vala"
	normalized = _tmp9_;
#line 196 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 196 "../src/DirectoryMonitor.vala"
	id = _tmp10_;
#line 196 "../src/DirectoryMonitor.vala"
	if (!_tmp11_) {
#line 197 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 197 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 197 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 197 "../src/DirectoryMonitor.vala"
		_g_free0 (existing_id);
#line 197 "../src/DirectoryMonitor.vala"
		return result;
#line 7416 "DirectoryMonitor.c"
	}
#line 199 "../src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->map;
#line 199 "../src/DirectoryMonitor.vala"
	_tmp13_ = normalized;
#line 199 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, info);
#line 200 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->priv->id_map;
#line 200 "../src/DirectoryMonitor.vala"
	_tmp15_ = id;
#line 200 "../src/DirectoryMonitor.vala"
	_tmp16_ = normalized;
#line 200 "../src/DirectoryMonitor.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, _tmp15_, _tmp16_);
#line 202 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 202 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 202 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 202 "../src/DirectoryMonitor.vala"
	_g_free0 (existing_id);
#line 202 "../src/DirectoryMonitor.vala"
	return result;
#line 7442 "DirectoryMonitor.c"
}

static gboolean
directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
#line 205 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 208 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 208 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 208 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 208 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 208 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 208 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 209 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 209 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 209 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 209 "../src/DirectoryMonitor.vala"
		return result;
#line 7484 "DirectoryMonitor.c"
	}
#line 211 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->map;
#line 211 "../src/DirectoryMonitor.vala"
	_tmp4_ = normalized;
#line 211 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, _tmp4_, NULL);
#line 212 "../src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->id_map;
#line 212 "../src/DirectoryMonitor.vala"
	_tmp6_ = id;
#line 212 "../src/DirectoryMonitor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, _tmp6_, NULL);
#line 214 "../src/DirectoryMonitor.vala"
	result = TRUE;
#line 214 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 214 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 214 "../src/DirectoryMonitor.vala"
	return result;
#line 7506 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self,
                                            GeeCollection* files)
{
#line 219 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/DirectoryMonitor.vala"
	g_return_if_fail (files != NULL);
#line 7517 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp0_;
#line 220 "../src/DirectoryMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) files);
#line 220 "../src/DirectoryMonitor.vala"
		_file_it = _tmp0_;
#line 220 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7527 "DirectoryMonitor.c"
			GeeIterator* _tmp1_;
			GFile* file = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GFile* _tmp4_;
#line 220 "../src/DirectoryMonitor.vala"
			_tmp1_ = _file_it;
#line 220 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 220 "../src/DirectoryMonitor.vala"
				break;
#line 7539 "DirectoryMonitor.c"
			}
#line 220 "../src/DirectoryMonitor.vala"
			_tmp2_ = _file_it;
#line 220 "../src/DirectoryMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 220 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp3_;
#line 221 "../src/DirectoryMonitor.vala"
			_tmp4_ = file;
#line 221 "../src/DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, _tmp4_, NULL);
#line 220 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 7553 "DirectoryMonitor.c"
		}
#line 220 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7557 "DirectoryMonitor.c"
	}
}

static gboolean
directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self,
                                          GFile* file,
                                          GFileInfo* info)
{
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 227 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
#line 227 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 227 "../src/DirectoryMonitor.vala"
	normalized = _tmp0_;
#line 227 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 227 "../src/DirectoryMonitor.vala"
	id = _tmp1_;
#line 227 "../src/DirectoryMonitor.vala"
	if (!_tmp2_) {
#line 228 "../src/DirectoryMonitor.vala"
		result = FALSE;
#line 228 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 228 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 228 "../src/DirectoryMonitor.vala"
		return result;
#line 7598 "DirectoryMonitor.c"
	}
#line 230 "../src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->id_map;
#line 230 "../src/DirectoryMonitor.vala"
	_tmp4_ = id;
#line 230 "../src/DirectoryMonitor.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 230 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 230 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 230 "../src/DirectoryMonitor.vala"
	return result;
#line 7612 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self,
                                        GFile* file,
                                        GFileInfo* info)
{
	gchar* result = NULL;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
#line 233 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 235 "../src/DirectoryMonitor.vala"
	if (info != NULL) {
#line 7632 "DirectoryMonitor.c"
		gchar* _tmp0_;
#line 236 "../src/DirectoryMonitor.vala"
		_tmp0_ = get_file_info_id (info);
#line 236 "../src/DirectoryMonitor.vala"
		result = _tmp0_;
#line 236 "../src/DirectoryMonitor.vala"
		return result;
#line 7640 "DirectoryMonitor.c"
	}
#line 240 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp1_, &_tmp2_);
#line 240 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 240 "../src/DirectoryMonitor.vala"
	normalized = _tmp1_;
#line 240 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 240 "../src/DirectoryMonitor.vala"
	id = _tmp2_;
#line 240 "../src/DirectoryMonitor.vala"
	if (!_tmp3_) {
#line 241 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 241 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 241 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 241 "../src/DirectoryMonitor.vala"
		return result;
#line 7662 "DirectoryMonitor.c"
	}
#line 243 "../src/DirectoryMonitor.vala"
	result = id;
#line 243 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 243 "../src/DirectoryMonitor.vala"
	return result;
#line 7670 "DirectoryMonitor.c"
}

static GeeCollection*
directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self)
{
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 246 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 247 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 247 "../src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 247 "../src/DirectoryMonitor.vala"
	result = (GeeCollection*) _tmp2_;
#line 247 "../src/DirectoryMonitor.vala"
	return result;
#line 7692 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self,
                                          GFile* file)
{
	GFileInfo* result = NULL;
	GFileInfo* info = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GFileInfo* _tmp2_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean _tmp5_;
	GeeHashMap* _tmp6_;
	GFile* _tmp7_;
	gpointer _tmp8_;
#line 250 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 250 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 252 "../src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 252 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 252 "../src/DirectoryMonitor.vala"
	info = (GFileInfo*) _tmp1_;
#line 253 "../src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 253 "../src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 254 "../src/DirectoryMonitor.vala"
		result = info;
#line 254 "../src/DirectoryMonitor.vala"
		return result;
#line 7730 "DirectoryMonitor.c"
	}
#line 258 "../src/DirectoryMonitor.vala"
	_tmp5_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp3_, &_tmp4_);
#line 258 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 258 "../src/DirectoryMonitor.vala"
	normalized = _tmp3_;
#line 258 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 258 "../src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 258 "../src/DirectoryMonitor.vala"
	if (!_tmp5_) {
#line 259 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 259 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 259 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 259 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 259 "../src/DirectoryMonitor.vala"
		return result;
#line 7754 "DirectoryMonitor.c"
	}
#line 261 "../src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->map;
#line 261 "../src/DirectoryMonitor.vala"
	_tmp7_ = normalized;
#line 261 "../src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 261 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp8_;
#line 261 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 261 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 261 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 261 "../src/DirectoryMonitor.vala"
	return result;
#line 7772 "DirectoryMonitor.c"
}

static GFileInfo*
directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self,
                                            GFile* file,
                                            GCancellable* cancellable)
{
	GFileInfo* result = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp9_;
	gchar* id = NULL;
	GFileInfo* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* normalized = NULL;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	gpointer _tmp16_;
	GFile* _tmp17_;
	GeeHashMap* _tmp18_;
	gpointer _tmp19_;
	GError* _inner_error0_ = NULL;
#line 264 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 265 "../src/DirectoryMonitor.vala"
	_tmp0_ = directory_monitor_file_info_map_get_info (self, file);
#line 265 "../src/DirectoryMonitor.vala"
	info = _tmp0_;
#line 266 "../src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 266 "../src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 267 "../src/DirectoryMonitor.vala"
		result = info;
#line 267 "../src/DirectoryMonitor.vala"
		return result;
#line 7814 "DirectoryMonitor.c"
	}
	{
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
#line 272 "../src/DirectoryMonitor.vala"
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, cancellable, &_inner_error0_);
#line 272 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp3_;
#line 272 "../src/DirectoryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7826 "DirectoryMonitor.c"
			goto __catch35_g_error;
		}
#line 272 "../src/DirectoryMonitor.vala"
		_tmp4_ = _tmp2_;
#line 272 "../src/DirectoryMonitor.vala"
		_tmp2_ = NULL;
#line 272 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 272 "../src/DirectoryMonitor.vala"
		info = _tmp4_;
#line 271 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp2_);
#line 7839 "DirectoryMonitor.c"
	}
	goto __finally35;
	__catch35_g_error:
	{
		GError* err = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 271 "../src/DirectoryMonitor.vala"
		err = _inner_error0_;
#line 271 "../src/DirectoryMonitor.vala"
		_inner_error0_ = NULL;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp5_ = g_file_get_path (file);
#line 274 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp7_ = err;
#line 274 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_->message;
#line 274 "../src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:274: Unable to query file ID of %s: %s", _tmp6_, _tmp8_);
#line 274 "../src/DirectoryMonitor.vala"
		_g_free0 (_tmp6_);
#line 276 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 276 "../src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 276 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 276 "../src/DirectoryMonitor.vala"
		return result;
#line 7873 "DirectoryMonitor.c"
	}
	__finally35:
#line 271 "../src/DirectoryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 271 "../src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 271 "../src/DirectoryMonitor.vala"
		return NULL;
#line 7886 "DirectoryMonitor.c"
	}
#line 279 "../src/DirectoryMonitor.vala"
	_tmp9_ = info;
#line 279 "../src/DirectoryMonitor.vala"
	if (!directory_monitor_is_file_symlink_supported (_tmp9_)) {
#line 280 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 280 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 280 "../src/DirectoryMonitor.vala"
		return result;
#line 7898 "DirectoryMonitor.c"
	}
#line 282 "../src/DirectoryMonitor.vala"
	_tmp10_ = info;
#line 282 "../src/DirectoryMonitor.vala"
	_tmp11_ = g_file_info_get_attribute_string (_tmp10_, G_FILE_ATTRIBUTE_ID_FILE);
#line 282 "../src/DirectoryMonitor.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 282 "../src/DirectoryMonitor.vala"
	id = _tmp12_;
#line 283 "../src/DirectoryMonitor.vala"
	_tmp13_ = id;
#line 283 "../src/DirectoryMonitor.vala"
	if (_tmp13_ == NULL) {
#line 284 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 284 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 284 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 284 "../src/DirectoryMonitor.vala"
		return result;
#line 7920 "DirectoryMonitor.c"
	}
#line 286 "../src/DirectoryMonitor.vala"
	_tmp14_ = self->priv->id_map;
#line 286 "../src/DirectoryMonitor.vala"
	_tmp15_ = id;
#line 286 "../src/DirectoryMonitor.vala"
	_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 286 "../src/DirectoryMonitor.vala"
	normalized = (GFile*) _tmp16_;
#line 287 "../src/DirectoryMonitor.vala"
	_tmp17_ = normalized;
#line 287 "../src/DirectoryMonitor.vala"
	if (_tmp17_ == NULL) {
#line 288 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 288 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 288 "../src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 288 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 288 "../src/DirectoryMonitor.vala"
		return result;
#line 7944 "DirectoryMonitor.c"
	}
#line 290 "../src/DirectoryMonitor.vala"
	_tmp18_ = self->priv->map;
#line 290 "../src/DirectoryMonitor.vala"
	_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, file);
#line 290 "../src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp19_;
#line 290 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 290 "../src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 290 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 290 "../src/DirectoryMonitor.vala"
	return result;
#line 7960 "DirectoryMonitor.c"
}

static GFile*
directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self,
                                            GFileInfo* match)
{
	GFile* result = NULL;
	gchar* match_id = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint64 match_size = 0LL;
	GTimeVal match_time = {0};
	GTimeVal _tmp2_ = {0};
#line 293 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 293 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (match != NULL, NULL);
#line 294 "../src/DirectoryMonitor.vala"
	_tmp0_ = get_file_info_id (match);
#line 294 "../src/DirectoryMonitor.vala"
	match_id = _tmp0_;
#line 295 "../src/DirectoryMonitor.vala"
	_tmp1_ = match_id;
#line 295 "../src/DirectoryMonitor.vala"
	if (_tmp1_ == NULL) {
#line 296 "../src/DirectoryMonitor.vala"
		result = NULL;
#line 296 "../src/DirectoryMonitor.vala"
		_g_free0 (match_id);
#line 296 "../src/DirectoryMonitor.vala"
		return result;
#line 7992 "DirectoryMonitor.c"
	}
#line 299 "../src/DirectoryMonitor.vala"
	match_size = g_file_info_get_size (match);
#line 300 "../src/DirectoryMonitor.vala"
	g_file_info_get_modification_time (match, &_tmp2_);
#line 300 "../src/DirectoryMonitor.vala"
	match_time = _tmp2_;
#line 8000 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp3_);
#line 302 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 302 "../src/DirectoryMonitor.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 302 "../src/DirectoryMonitor.vala"
		_tmp8_ = _tmp7_;
#line 302 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp6_);
#line 302 "../src/DirectoryMonitor.vala"
		_file_it = _tmp8_;
#line 302 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8027 "DirectoryMonitor.c"
			GeeIterator* _tmp9_;
			GFile* file = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			GFileInfo* info = NULL;
			GeeHashMap* _tmp12_;
			GFile* _tmp13_;
			gpointer _tmp14_;
			GFileInfo* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gboolean _tmp19_;
			GFileInfo* _tmp20_;
			GTimeVal time = {0};
			GFileInfo* _tmp21_;
			GTimeVal _tmp22_ = {0};
			GTimeVal _tmp23_;
			GTimeVal _tmp24_;
#line 302 "../src/DirectoryMonitor.vala"
			_tmp9_ = _file_it;
#line 302 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 302 "../src/DirectoryMonitor.vala"
				break;
#line 8053 "DirectoryMonitor.c"
			}
#line 302 "../src/DirectoryMonitor.vala"
			_tmp10_ = _file_it;
#line 302 "../src/DirectoryMonitor.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 302 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp11_;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp12_ = self->priv->map;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp13_ = file;
#line 303 "../src/DirectoryMonitor.vala"
			_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 303 "../src/DirectoryMonitor.vala"
			info = (GFileInfo*) _tmp14_;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp15_ = info;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp16_ = get_file_info_id (_tmp15_);
#line 306 "../src/DirectoryMonitor.vala"
			_tmp17_ = _tmp16_;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp18_ = match_id;
#line 306 "../src/DirectoryMonitor.vala"
			_tmp19_ = g_strcmp0 (_tmp17_, _tmp18_) == 0;
#line 306 "../src/DirectoryMonitor.vala"
			_g_free0 (_tmp17_);
#line 306 "../src/DirectoryMonitor.vala"
			if (_tmp19_) {
#line 307 "../src/DirectoryMonitor.vala"
				result = file;
#line 307 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 307 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (_file_it);
#line 307 "../src/DirectoryMonitor.vala"
				_g_free0 (match_id);
#line 307 "../src/DirectoryMonitor.vala"
				return result;
#line 8093 "DirectoryMonitor.c"
			}
#line 310 "../src/DirectoryMonitor.vala"
			_tmp20_ = info;
#line 310 "../src/DirectoryMonitor.vala"
			if (match_size != g_file_info_get_size (_tmp20_)) {
#line 311 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 311 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 311 "../src/DirectoryMonitor.vala"
				continue;
#line 8105 "DirectoryMonitor.c"
			}
#line 313 "../src/DirectoryMonitor.vala"
			_tmp21_ = info;
#line 313 "../src/DirectoryMonitor.vala"
			g_file_info_get_modification_time (_tmp21_, &_tmp22_);
#line 313 "../src/DirectoryMonitor.vala"
			time = _tmp22_;
#line 315 "../src/DirectoryMonitor.vala"
			_tmp23_ = time;
#line 315 "../src/DirectoryMonitor.vala"
			_tmp24_ = match_time;
#line 315 "../src/DirectoryMonitor.vala"
			if (_tmp23_.tv_sec != _tmp24_.tv_sec) {
#line 316 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 316 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 316 "../src/DirectoryMonitor.vala"
				continue;
#line 8125 "DirectoryMonitor.c"
			}
#line 318 "../src/DirectoryMonitor.vala"
			result = file;
#line 318 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (info);
#line 318 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_file_it);
#line 318 "../src/DirectoryMonitor.vala"
			_g_free0 (match_id);
#line 318 "../src/DirectoryMonitor.vala"
			return result;
#line 8137 "DirectoryMonitor.c"
		}
#line 302 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8141 "DirectoryMonitor.c"
	}
#line 321 "../src/DirectoryMonitor.vala"
	result = NULL;
#line 321 "../src/DirectoryMonitor.vala"
	_g_free0 (match_id);
#line 321 "../src/DirectoryMonitor.vala"
	return result;
#line 8149 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self,
                                                    GFile* root,
                                                    DirectoryMonitorFileInfoMap* descendents)
{
	GeeArrayList* pruned = NULL;
	GeeArrayList* _tmp24_;
#line 324 "../src/DirectoryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/DirectoryMonitor.vala"
	g_return_if_fail (root != NULL);
#line 324 "../src/DirectoryMonitor.vala"
	g_return_if_fail (descendents != NULL);
#line 325 "../src/DirectoryMonitor.vala"
	pruned = NULL;
#line 8167 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 326 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 326 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 326 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 326 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 326 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 326 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 326 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 326 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 326 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8194 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
#line 326 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 326 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 326 "../src/DirectoryMonitor.vala"
				break;
#line 8208 "DirectoryMonitor.c"
			}
#line 326 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 326 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 326 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 327 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 327 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 327 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 328 "../src/DirectoryMonitor.vala"
			while (TRUE) {
#line 8224 "DirectoryMonitor.c"
				GFile* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp22_;
				GFile* _tmp23_;
#line 328 "../src/DirectoryMonitor.vala"
				_tmp11_ = parent;
#line 328 "../src/DirectoryMonitor.vala"
				if (!(_tmp11_ != NULL)) {
#line 328 "../src/DirectoryMonitor.vala"
					break;
#line 8235 "DirectoryMonitor.c"
				}
#line 329 "../src/DirectoryMonitor.vala"
				_tmp12_ = parent;
#line 329 "../src/DirectoryMonitor.vala"
				if (g_file_equal (_tmp12_, root)) {
#line 8241 "DirectoryMonitor.c"
					GeeArrayList* _tmp13_;
					GeeArrayList* _tmp15_;
					GFile* _tmp16_;
					GFile* _tmp17_;
					GeeHashMap* _tmp18_;
					GFile* _tmp19_;
					gpointer _tmp20_;
					GFileInfo* _tmp21_;
#line 330 "../src/DirectoryMonitor.vala"
					_tmp13_ = pruned;
#line 330 "../src/DirectoryMonitor.vala"
					if (_tmp13_ == NULL) {
#line 8254 "DirectoryMonitor.c"
						GeeArrayList* _tmp14_;
#line 331 "../src/DirectoryMonitor.vala"
						_tmp14_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 331 "../src/DirectoryMonitor.vala"
						_g_object_unref0 (pruned);
#line 331 "../src/DirectoryMonitor.vala"
						pruned = _tmp14_;
#line 8262 "DirectoryMonitor.c"
					}
#line 333 "../src/DirectoryMonitor.vala"
					_tmp15_ = pruned;
#line 333 "../src/DirectoryMonitor.vala"
					_tmp16_ = file;
#line 333 "../src/DirectoryMonitor.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 334 "../src/DirectoryMonitor.vala"
					_tmp17_ = file;
#line 334 "../src/DirectoryMonitor.vala"
					_tmp18_ = self->priv->map;
#line 334 "../src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 334 "../src/DirectoryMonitor.vala"
					_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, _tmp19_);
#line 334 "../src/DirectoryMonitor.vala"
					_tmp21_ = (GFileInfo*) _tmp20_;
#line 334 "../src/DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (descendents, _tmp17_, _tmp21_);
#line 334 "../src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp21_);
#line 336 "../src/DirectoryMonitor.vala"
					break;
#line 8286 "DirectoryMonitor.c"
				}
#line 339 "../src/DirectoryMonitor.vala"
				_tmp22_ = parent;
#line 339 "../src/DirectoryMonitor.vala"
				_tmp23_ = g_file_get_parent (_tmp22_);
#line 339 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 339 "../src/DirectoryMonitor.vala"
				parent = _tmp23_;
#line 8296 "DirectoryMonitor.c"
			}
#line 326 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 326 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8302 "DirectoryMonitor.c"
		}
#line 326 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8306 "DirectoryMonitor.c"
	}
#line 343 "../src/DirectoryMonitor.vala"
	_tmp24_ = pruned;
#line 343 "../src/DirectoryMonitor.vala"
	if (_tmp24_ != NULL) {
#line 8312 "DirectoryMonitor.c"
		GeeArrayList* _tmp25_;
#line 344 "../src/DirectoryMonitor.vala"
		_tmp25_ = pruned;
#line 344 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, (GeeCollection*) _tmp25_);
#line 8318 "DirectoryMonitor.c"
	}
#line 324 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (pruned);
#line 8322 "DirectoryMonitor.c"
}

static gint
directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self,
                                              GFile* root,
                                              GeeCollection* files,
                                              GeeCollection* dirs)
{
	gint result = 0;
	gint count = 0;
#line 349 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 349 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (root != NULL, 0);
#line 349 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (files != NULL, 0);
#line 349 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (dirs != NULL, 0);
#line 350 "../src/DirectoryMonitor.vala"
	count = 0;
#line 8343 "DirectoryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 351 "../src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 351 "../src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 351 "../src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 351 "../src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 351 "../src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 351 "../src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 351 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 351 "../src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 351 "../src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8370 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			GFile* file = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GFile* parent = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFile* _tmp12_;
			DirectoryMonitorFType ftype = 0;
			GeeHashMap* _tmp14_;
			GFile* _tmp15_;
			gpointer _tmp16_;
			GFileInfo* _tmp17_;
			DirectoryMonitorFType _tmp18_;
			DirectoryMonitorFType _tmp19_;
#line 351 "../src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 351 "../src/DirectoryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 351 "../src/DirectoryMonitor.vala"
				break;
#line 8393 "DirectoryMonitor.c"
			}
#line 351 "../src/DirectoryMonitor.vala"
			_tmp7_ = _file_it;
#line 351 "../src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 351 "../src/DirectoryMonitor.vala"
			file = (GFile*) _tmp8_;
#line 352 "../src/DirectoryMonitor.vala"
			_tmp9_ = file;
#line 352 "../src/DirectoryMonitor.vala"
			_tmp10_ = g_file_get_parent (_tmp9_);
#line 352 "../src/DirectoryMonitor.vala"
			parent = _tmp10_;
#line 353 "../src/DirectoryMonitor.vala"
			_tmp12_ = parent;
#line 353 "../src/DirectoryMonitor.vala"
			if (_tmp12_ == NULL) {
#line 353 "../src/DirectoryMonitor.vala"
				_tmp11_ = TRUE;
#line 8413 "DirectoryMonitor.c"
			} else {
				GFile* _tmp13_;
#line 353 "../src/DirectoryMonitor.vala"
				_tmp13_ = parent;
#line 353 "../src/DirectoryMonitor.vala"
				_tmp11_ = !g_file_equal (_tmp13_, root);
#line 8420 "DirectoryMonitor.c"
			}
#line 353 "../src/DirectoryMonitor.vala"
			if (_tmp11_) {
#line 354 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 354 "../src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 354 "../src/DirectoryMonitor.vala"
				continue;
#line 8430 "DirectoryMonitor.c"
			}
#line 356 "../src/DirectoryMonitor.vala"
			_tmp14_ = self->priv->map;
#line 356 "../src/DirectoryMonitor.vala"
			_tmp15_ = file;
#line 356 "../src/DirectoryMonitor.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 356 "../src/DirectoryMonitor.vala"
			_tmp17_ = (GFileInfo*) _tmp16_;
#line 356 "../src/DirectoryMonitor.vala"
			_tmp18_ = directory_monitor_get_ftype (_tmp17_);
#line 356 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (_tmp17_);
#line 356 "../src/DirectoryMonitor.vala"
			ftype = _tmp18_;
#line 357 "../src/DirectoryMonitor.vala"
			_tmp19_ = ftype;
#line 357 "../src/DirectoryMonitor.vala"
			switch (_tmp19_) {
#line 357 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 8452 "DirectoryMonitor.c"
				{
					GFile* _tmp20_;
					gint _tmp21_;
#line 359 "../src/DirectoryMonitor.vala"
					_tmp20_ = file;
#line 359 "../src/DirectoryMonitor.vala"
					gee_collection_add (files, _tmp20_);
#line 360 "../src/DirectoryMonitor.vala"
					_tmp21_ = count;
#line 360 "../src/DirectoryMonitor.vala"
					count = _tmp21_ + 1;
#line 361 "../src/DirectoryMonitor.vala"
					break;
#line 8466 "DirectoryMonitor.c"
				}
#line 357 "../src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 8470 "DirectoryMonitor.c"
				{
					GFile* _tmp22_;
					gint _tmp23_;
#line 364 "../src/DirectoryMonitor.vala"
					_tmp22_ = file;
#line 364 "../src/DirectoryMonitor.vala"
					gee_collection_add (dirs, _tmp22_);
#line 365 "../src/DirectoryMonitor.vala"
					_tmp23_ = count;
#line 365 "../src/DirectoryMonitor.vala"
					count = _tmp23_ + 1;
#line 366 "../src/DirectoryMonitor.vala"
					break;
#line 8484 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp24_;
#line 369 "../src/DirectoryMonitor.vala"
					_tmp24_ = ftype;
#line 369 "../src/DirectoryMonitor.vala"
					_vala_assert (_tmp24_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "ftype == FType.UNSUPPORTED");
#line 370 "../src/DirectoryMonitor.vala"
					break;
#line 8495 "DirectoryMonitor.c"
				}
			}
#line 351 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 351 "../src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8502 "DirectoryMonitor.c"
		}
#line 351 "../src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8506 "DirectoryMonitor.c"
	}
#line 374 "../src/DirectoryMonitor.vala"
	result = count;
#line 374 "../src/DirectoryMonitor.vala"
	return result;
#line 8512 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_init (GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 8520 "DirectoryMonitor.c"
}

static void
directory_monitor_value_file_info_map_free_value (GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
#line 8530 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_file_info_map_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
#line 8542 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8546 "DirectoryMonitor.c"
	}
}

static gpointer
directory_monitor_value_file_info_map_peek_pointer (const GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8555 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 141 "../src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 8566 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap * object;
		object = collect_values[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 141 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8573 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 141 "../src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8577 "DirectoryMonitor.c"
		}
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
#line 8581 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8585 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8589 "DirectoryMonitor.c"
}

static gchar*
directory_monitor_value_file_info_map_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	DirectoryMonitorFileInfoMap ** object_p;
	object_p = collect_values[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (!object_p) {
#line 141 "../src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8604 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 8610 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 8614 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8618 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	return NULL;
#line 8622 "DirectoryMonitor.c"
}

static GParamSpec*
directory_monitor_param_spec_file_info_map (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	DirectoryMonitorParamSpecFileInfoMap* spec;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 141 "../src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 141 "../src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 141 "../src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 8641 "DirectoryMonitor.c"
}

static gpointer
directory_monitor_value_get_file_info_map (const GValue* value)
{
#line 141 "../src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 141 "../src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 8651 "DirectoryMonitor.c"
}

static void
directory_monitor_value_set_file_info_map (GValue* value,
                                           gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 8673 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8677 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (old) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8683 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_value_take_file_info_map (GValue* value,
                                            gpointer v_object)
{
	DirectoryMonitorFileInfoMap * old;
#line 141 "../src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 141 "../src/DirectoryMonitor.vala"
	if (v_object) {
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 141 "../src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 8704 "DirectoryMonitor.c"
	} else {
#line 141 "../src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8708 "DirectoryMonitor.c"
	}
#line 141 "../src/DirectoryMonitor.vala"
	if (old) {
#line 141 "../src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 8714 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass,
                                            gpointer klass_data)
{
#line 141 "../src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
#line 141 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorFileInfoMapClass *) klass)->finalize = directory_monitor_file_info_map_finalize;
#line 141 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitorFileInfoMap_private_offset);
#line 8728 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 141 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_file_info_map_get_instance_private (self);
#line 142 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 142 "../src/DirectoryMonitor.vala"
	self->priv->map = _tmp0_;
#line 144 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 144 "../src/DirectoryMonitor.vala"
	self->priv->id_map = _tmp1_;
#line 141 "../src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 8749 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap * obj)
{
	DirectoryMonitorFileInfoMap * self;
#line 141 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap);
#line 141 "../src/DirectoryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 142 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->map);
#line 144 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->id_map);
#line 8764 "DirectoryMonitor.c"
}

static GType
directory_monitor_file_info_map_get_type (void)
{
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		DirectoryMonitorFileInfoMap_private_offset = g_type_add_instance_private (directory_monitor_file_info_map_type_id, sizeof (DirectoryMonitorFileInfoMapPrivate));
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}

static gpointer
directory_monitor_file_info_map_ref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 141 "../src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 141 "../src/DirectoryMonitor.vala"
	return instance;
#line 8792 "DirectoryMonitor.c"
}

static void
directory_monitor_file_info_map_unref (gpointer instance)
{
	DirectoryMonitorFileInfoMap * self;
	self = instance;
#line 141 "../src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 141 "../src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
#line 141 "../src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8806 "DirectoryMonitor.c"
	}
}

static void
directory_monitor_class_init (DirectoryMonitorClass * klass,
                              gpointer klass_data)
{
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 73 "../src/DirectoryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DirectoryMonitor_private_offset);
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_root_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_root_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_root_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_started = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_started;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->internal_notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_internal_notify_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_failed = (void (*) (DirectoryMonitor*, const gchar*)) directory_monitor_real_notify_discovery_failed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_discovery_completed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_discovery_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_file_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_file_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) directory_monitor_real_notify_directory_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_directory_deleted = (void (*) (DirectoryMonitor*, GFile*)) directory_monitor_real_notify_directory_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_closed = (void (*) (DirectoryMonitor*)) directory_monitor_real_notify_closed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->close = (void (*) (DirectoryMonitor*)) directory_monitor_real_close;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_moved = directory_monitor_real_root_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->root_deleted = directory_monitor_real_root_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_started = directory_monitor_real_discovery_started;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_discovered = directory_monitor_real_file_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_discovered = directory_monitor_real_directory_discovered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_failed = directory_monitor_real_discovery_failed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_completed = directory_monitor_real_discovery_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_created = directory_monitor_real_file_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_moved = directory_monitor_real_file_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_altered = directory_monitor_real_file_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_deleted = directory_monitor_real_file_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_created = directory_monitor_real_directory_created;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_moved = directory_monitor_real_directory_moved;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_altered = directory_monitor_real_directory_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->directory_deleted = directory_monitor_real_directory_deleted;
#line 73 "../src/DirectoryMonitor.vala"
	((DirectoryMonitorClass *) klass)->closed = directory_monitor_real_closed;
#line 73 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_MOVED_SIGNAL] = g_signal_new ("root-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_ROOT_DELETED_SIGNAL] = g_signal_new ("root-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_STARTED_SIGNAL] = g_signal_new ("discovery-started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DISCOVERED_SIGNAL] = g_signal_new ("file-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DISCOVERED_SIGNAL] = g_signal_new ("directory-discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_FAILED_SIGNAL] = g_signal_new ("discovery-failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DISCOVERY_COMPLETED_SIGNAL] = g_signal_new ("discovery-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_CREATED_SIGNAL] = g_signal_new ("file-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_MOVED_SIGNAL] = g_signal_new ("file-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERED_SIGNAL] = g_signal_new ("file-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("file-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("file-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_FILE_DELETED_SIGNAL] = g_signal_new ("file-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_CREATED_SIGNAL] = g_signal_new ("directory-created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_MOVED_SIGNAL] = g_signal_new ("directory-moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERED_SIGNAL] = g_signal_new ("directory-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ALTERATION_COMPLETED_SIGNAL] = g_signal_new ("directory-alteration-completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_info_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_ATTRIBUTES_ALTERED_SIGNAL] = g_signal_new ("directory-attributes-altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_DIRECTORY_DELETED_SIGNAL] = g_signal_new ("directory-deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_file_get_type ());
#line 73 "../src/DirectoryMonitor.vala"
	directory_monitor_signals[DIRECTORY_MONITOR_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8946 "DirectoryMonitor.c"
}

static void
directory_monitor_instance_init (DirectoryMonitor * self,
                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GCancellable* _tmp4_;
#line 73 "../src/DirectoryMonitor.vala"
	self->priv = directory_monitor_get_instance_private (self);
#line 381 "../src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_monitor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 381 "../src/DirectoryMonitor.vala"
	self->priv->monitors = _tmp0_;
#line 382 "../src/DirectoryMonitor.vala"
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, (GDestroyNotify) directory_monitor_query_info_queue_element_unref, NULL, NULL, NULL);
#line 382 "../src/DirectoryMonitor.vala"
	self->priv->query_info_queue = (GeeQueue*) _tmp1_;
#line 384 "../src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_new ();
#line 384 "../src/DirectoryMonitor.vala"
	self->priv->files = _tmp2_;
#line 385 "../src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_new ();
#line 385 "../src/DirectoryMonitor.vala"
	self->priv->parent_moved = _tmp3_;
#line 386 "../src/DirectoryMonitor.vala"
	_tmp4_ = g_cancellable_new ();
#line 386 "../src/DirectoryMonitor.vala"
	self->priv->cancellable = _tmp4_;
#line 387 "../src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 0;
#line 388 "../src/DirectoryMonitor.vala"
	self->priv->started = FALSE;
#line 389 "../src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 390 "../src/DirectoryMonitor.vala"
	self->priv->delete_timer_id = (guint) 0;
#line 8988 "DirectoryMonitor.c"
}

static void
directory_monitor_finalize (GObject * obj)
{
	DirectoryMonitor * self;
#line 73 "../src/DirectoryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRECTORY_MONITOR, DirectoryMonitor);
#line 378 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 381 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 382 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->query_info_queue);
#line 384 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->files);
#line 385 "../src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
#line 386 "../src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 73 "../src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
#line 9011 "DirectoryMonitor.c"
}

GType
directory_monitor_get_type (void)
{
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		DirectoryMonitor_private_offset = g_type_add_instance_private (directory_monitor_type_id, sizeof (DirectoryMonitorPrivate));
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}

