/* LibraryMonitor.c generated by valac 0.44.3, the Vala compiler
 * generated from LibraryMonitor.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* LibraryMonitor uses DirectoryMonitor to track assets in the user's library directory and make*/
/* sure they're reflected in the application.*/
/**/
/* NOTE: There appears to be a bug where prior versions of Photos (<= 0.6.x) were not*/
/* properly loading the file modification timestamp during import.  This was no issue*/
/* before but becomes imperative now with file monitoring.  A "proper" algorithm is*/
/* to reimport an entire photo if the modification time in the database is different*/
/* than the file's, but that's Real Bad when the user first turns on monitoring, as it*/
/* will cause a lot of reimports (think of a 10,000 photo database) and will blow away*/
/* ALL transformations, as they are now suspect.*/
/**/
/* So: If the modification time is zero and filesize is the same, simply update the*/
/* timestamp in the database and move on.*/
/**/
/* TODO: Although it seems highly unlikely that a file's timestamp could change but the file size*/
/* has not and the file really be "changed", it *is* possible, even in the case of complex little*/
/* animals like photo files.  We could be more liberal and treat this case as a metadata-changed*/
/* situation (since that's a likely case).*/
/**/

#include <glib-object.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <time.h>

#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;
typedef struct _LibraryMonitorPoolPrivate LibraryMonitorPoolPrivate;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
typedef struct _ParamSpecLibraryMonitorPool ParamSpecLibraryMonitorPool;
enum  {
	LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL,
	LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL,
	LIBRARY_MONITOR_POOL_NUM_SIGNALS
};
static guint library_monitor_pool_signals[LIBRARY_MONITOR_POOL_NUM_SIGNALS] = {0};
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;
typedef struct _LibraryMonitorPrivate LibraryMonitorPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_BATCH_IMPORT (batch_import_get_type ())
#define BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT, BatchImport))
#define BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT, BatchImportClass))
#define IS_BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT))
#define IS_BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT))
#define BATCH_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT, BatchImportClass))

typedef struct _BatchImport BatchImport;
typedef struct _BatchImportClass BatchImportClass;

#define TYPE_BATCH_IMPORT_ROLL (batch_import_roll_get_type ())
#define BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRoll))
#define BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))
#define IS_BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_ROLL))
#define IS_BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_ROLL))
#define BATCH_IMPORT_ROLL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))

typedef struct _BatchImportRoll BatchImportRoll;
typedef struct _BatchImportRollClass BatchImportRollClass;

#define LIBRARY_MONITOR_TYPE_VERIFY_JOB (library_monitor_verify_job_get_type ())
#define LIBRARY_MONITOR_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob))
#define LIBRARY_MONITOR_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))
#define LIBRARY_MONITOR_IS_VERIFY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_IS_VERIFY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_VERIFY_JOB))
#define LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJobClass))

typedef struct _LibraryMonitorVerifyJob LibraryMonitorVerifyJob;
typedef struct _LibraryMonitorVerifyJobClass LibraryMonitorVerifyJobClass;
enum  {
	LIBRARY_MONITOR_0_PROPERTY,
	LIBRARY_MONITOR_NUM_PROPERTIES
};
static GParamSpec* library_monitor_properties[LIBRARY_MONITOR_NUM_PROPERTIES];

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;
typedef void (*DequeuedCallback) (gconstpointer item, gpointer user_data);
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _batch_import_roll_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_roll_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))
typedef enum  {
	MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED,
	MEDIA_MONITOR_DISCOVERED_FILE_IGNORE,
	MEDIA_MONITOR_DISCOVERED_FILE_UNKNOWN
} MediaMonitorDiscoveredFile;

#define MEDIA_MONITOR_TYPE_DISCOVERED_FILE (media_monitor_discovered_file_get_type ())

#define TYPE_TOMBSTONE_SOURCE_COLLECTION (tombstone_source_collection_get_type ())
#define TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollection))
#define TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))
#define IS_TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define IS_TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define TOMBSTONE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))

typedef struct _TombstoneSourceCollection TombstoneSourceCollection;
typedef struct _TombstoneSourceCollectionClass TombstoneSourceCollectionClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB (library_monitor_find_move_job_get_type ())
#define LIBRARY_MONITOR_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJobClass))

typedef struct _LibraryMonitorFindMoveJob LibraryMonitorFindMoveJob;
typedef struct _LibraryMonitorFindMoveJobClass LibraryMonitorFindMoveJobClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _LibraryMonitorAsyncDiscoveryCompletedData LibraryMonitorAsyncDiscoveryCompletedData;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _LibraryMonitorFindMoveJobPrivate LibraryMonitorFindMoveJobPrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _library_monitor_verify_job_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_verify_job_unref (var), NULL)))
typedef struct _LibraryMonitorVerifyJobPrivate LibraryMonitorVerifyJobPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LibraryMonitorVerifyMonitorableData LibraryMonitorVerifyMonitorableData;

#define TYPE_BATCH_IMPORT_JOB (batch_import_job_get_type ())
#define BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJob))
#define BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))
#define IS_BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_JOB))
#define IS_BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_JOB))
#define BATCH_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))

typedef struct _BatchImportJob BatchImportJob;
typedef struct _BatchImportJobClass BatchImportJobClass;

#define TYPE_FILE_IMPORT_JOB (file_import_job_get_type ())
#define FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_IMPORT_JOB, FileImportJob))
#define FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_IMPORT_JOB, FileImportJobClass))
#define IS_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_IMPORT_JOB))
#define IS_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_IMPORT_JOB))
#define FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_IMPORT_JOB, FileImportJobClass))

typedef struct _FileImportJob FileImportJob;
typedef struct _FileImportJobClass FileImportJobClass;
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))

#define TYPE_IMPORT_MANIFEST (import_manifest_get_type ())
#define IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_MANIFEST, ImportManifest))
#define IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_MANIFEST, ImportManifestClass))
#define IS_IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_MANIFEST))
#define IS_IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_MANIFEST))
#define IMPORT_MANIFEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_MANIFEST, ImportManifestClass))

typedef struct _ImportManifest ImportManifest;
typedef struct _ImportManifestClass ImportManifestClass;
typedef void (*BatchImportImportReporter) (ImportManifest* manifest, BatchImportRoll* import_roll, gpointer user_data);
typedef struct _ImportManifestPrivate ImportManifestPrivate;

#define TYPE_BATCH_IMPORT_RESULT (batch_import_result_get_type ())
#define BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResult))
#define BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))
#define IS_BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_RESULT))
#define IS_BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_RESULT))
#define BATCH_IMPORT_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))

typedef struct _BatchImportResult BatchImportResult;
typedef struct _BatchImportResultClass BatchImportResultClass;
typedef struct _BatchImportResultPrivate BatchImportResultPrivate;
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_DUPLICATED_FILE (duplicated_file_get_type ())
#define DUPLICATED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICATED_FILE, DuplicatedFile))
#define DUPLICATED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICATED_FILE, DuplicatedFileClass))
#define IS_DUPLICATED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICATED_FILE))
#define IS_DUPLICATED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICATED_FILE))
#define DUPLICATED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICATED_FILE, DuplicatedFileClass))

typedef struct _DuplicatedFile DuplicatedFile;
typedef struct _DuplicatedFileClass DuplicatedFileClass;
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))

#define TYPE_TOMBSTONED_FILE (tombstoned_file_get_type ())
#define TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONED_FILE, TombstonedFile))
#define TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONED_FILE, TombstonedFileClass))
#define IS_TOMBSTONED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONED_FILE))
#define IS_TOMBSTONED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONED_FILE))
#define TOMBSTONED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONED_FILE, TombstonedFileClass))

typedef struct _TombstonedFile TombstonedFile;
typedef struct _TombstonedFileClass TombstonedFileClass;
#define _tombstoned_file_unref0(var) ((var == NULL) ? NULL : (var = (tombstoned_file_unref (var), NULL)))
typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())

#define LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB (library_monitor_runtime_find_move_job_get_type ())
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_IS_RUNTIME_FIND_MOVE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB))
#define LIBRARY_MONITOR_RUNTIME_FIND_MOVE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJobClass))

typedef struct _LibraryMonitorRuntimeFindMoveJob LibraryMonitorRuntimeFindMoveJob;
typedef struct _LibraryMonitorRuntimeFindMoveJobClass LibraryMonitorRuntimeFindMoveJobClass;
typedef struct _LibraryMonitorRuntimeFindMoveJobPrivate LibraryMonitorRuntimeFindMoveJobPrivate;

#define TYPE_TOMBSTONE (tombstone_get_type ())
#define TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE, Tombstone))
#define TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE, TombstoneClass))
#define IS_TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE))
#define IS_TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE))
#define TOMBSTONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE, TombstoneClass))

typedef struct _Tombstone Tombstone;
typedef struct _TombstoneClass TombstoneClass;
typedef void (*CompletionCallback) (BackgroundJob* job, gpointer user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, gpointer user_data);

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;
typedef struct _LibraryMonitorParamSpecVerifyJob LibraryMonitorParamSpecVerifyJob;
enum  {
	LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL,
	LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL,
	LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL,
	LIBRARY_MONITOR_NUM_SIGNALS
};
static guint library_monitor_signals[LIBRARY_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _LibraryMonitorPool {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorPoolPrivate * priv;
};

struct _LibraryMonitorPoolClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorPool *self);
};

struct _LibraryMonitorPoolPrivate {
	LibraryMonitor* monitor;
	guint timer_id;
};

struct _ParamSpecLibraryMonitorPool {
	GParamSpec parent_instance;
};

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _LibraryMonitor {
	DirectoryMonitor parent_instance;
	LibraryMonitorPrivate * priv;
};

struct _LibraryMonitorClass {
	DirectoryMonitorClass parent_class;
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryMonitorPrivate {
	Workers* workers;
	GCancellable* cancellable;
	gboolean auto_import;
	GeeHashSet* unknown_files;
	GeeList* monitors;
	GeeHashMap* discovered;
	GeeHashSet* import_queue;
	GeeHashSet* pending_imports;
	GeeArrayList* batch_import_queue;
	BatchImportRoll* current_import_roll;
	time_t last_import_roll_use;
	BatchImport* current_batch_import;
	gint checksums_completed;
	gint checksums_total;
	guint import_queue_timer_id;
	GeeQueue* verify_queue;
	gint outstanding_verify_jobs;
	gint completed_monitorable_verifies;
	gint total_monitorable_verifies;
	GSettings* file_settings;
};

struct _LibraryMonitorAsyncDiscoveryCompletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LibraryMonitor* self;
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeArrayList* all_candidates;
	GeeArrayList* _tmp3_;
	GeeArrayList* adopted;
	GeeArrayList* _tmp4_;
	GeeIterator* _file_it;
	GeeHashSet* _tmp5_;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	GFile* file;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	GFileInfo* info;
	GFile* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeCollection* candidates;
	gboolean associated;
	GeeList* _monitor_list;
	GeeList* _tmp14_;
	GeeList* _tmp15_;
	gint _monitor_size;
	GeeList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _monitor_index;
	MediaMonitor* monitor;
	GeeList* _tmp19_;
	gpointer _tmp20_;
	MediaMonitorDiscoveredFile _result_;
	MediaMonitor* _tmp21_;
	GFile* _tmp22_;
	GFileInfo* _tmp23_;
	MediaMonitorDiscoveredFile _tmp24_;
	GeeCollection* _tmp25_;
	gboolean _tmp26_;
	MediaMonitorDiscoveredFile _tmp27_;
	MediaMonitorDiscoveredFile _tmp28_;
	GeeCollection* _tmp29_;
	GeeArrayList* _tmp30_;
	GeeCollection* _tmp31_;
	GeeArrayList* _tmp32_;
	GFile* _tmp33_;
	GeeArrayList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	GeeArrayList* job_candidates;
	GeeArrayList* _tmp37_;
	GeeArrayList* _tmp38_;
	GeeArrayList* _tmp39_;
	gint _tmp40_;
	Workers* _tmp41_;
	GFile* _tmp42_;
	GeeArrayList* _tmp43_;
	LibraryMonitorFindMoveJob* _tmp44_;
	LibraryMonitorFindMoveJob* _tmp45_;
	GeeHashSet* _tmp46_;
	GeeArrayList* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
};

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _LibraryMonitorFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GeeArrayList* losers;
	GError* err;
};

struct _LibraryMonitorFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorVerifyJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	LibraryMonitorVerifyJobPrivate * priv;
	Monitorable* monitorable;
	MediaMonitor* monitor;
};

struct _LibraryMonitorVerifyJobClass {
	GTypeClass parent_class;
	void (*finalize) (LibraryMonitorVerifyJob *self);
};

struct _LibraryMonitorVerifyMonitorableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	LibraryMonitor* self;
	Monitorable* monitorable;
	MediaMonitor* monitor;
	GFile** files;
	GFile** _tmp0_;
	gint files_length1;
	gint _files_size_;
	GFile** _tmp1_;
	gint _tmp1__length1;
	GFile* _tmp2_;
	GFile** aux_files;
	gint _tmp3_;
	GFile** _tmp4_;
	gint aux_files_length1;
	gint _aux_files_size_;
	GFile** _tmp5_;
	gint _tmp5__length1;
	GFile** _tmp6_;
	gint _tmp6__length1;
	GFile** aux_file_collection;
	gint aux_file_collection_length1;
	gint _aux_file_collection_size_;
	gint aux_file_it;
	GFile* _tmp7_;
	GFile* aux_file;
	GFile** _tmp8_;
	gint _tmp8__length1;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gint ctr;
	gboolean _tmp11_;
	gint _tmp12_;
	GFile** _tmp13_;
	gint _tmp13__length1;
	GFile* file;
	GFile** _tmp14_;
	gint _tmp14__length1;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFileInfo* info;
	GFile* _tmp17_;
	GFileInfo* _tmp18_;
	GFileInfo* _tmp19_;
	GFileInfo* _tmp20_;
	GFile* _tmp21_;
	GCancellable* _tmp22_;
	GFileInfo* _tmp23_;
	GFileInfo* _tmp24_;
	GError* err;
	gboolean _tmp25_;
	GFileInfo* _tmp26_;
	gboolean _tmp27_;
	GFileInfo* _tmp28_;
	GFile* _tmp29_;
	GFileInfo* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GError* _inner_error0_;
};

struct _ImportManifest {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImportManifestPrivate * priv;
	GeeList* imported;
	GeeList* success;
	GeeList* camera_failed;
	GeeList* failed;
	GeeList* write_failed;
	GeeList* skipped_photos;
	GeeList* skipped_files;
	GeeList* aborted;
	GeeList* already_imported;
	GeeList* corrupt_files;
	GeeList* all;
};

struct _ImportManifestClass {
	GTypeClass parent_class;
	void (*finalize) (ImportManifest *self);
};

struct _BatchImportResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportResultPrivate * priv;
	BatchImportJob* job;
	GFile* file;
	gchar* src_identifier;
	gchar* dest_identifier;
	ImportResult result;
	gchar* errmsg;
	DuplicatedFile* duplicate_of;
};

struct _BatchImportResultClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportResult *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _LibraryMonitorRuntimeFindMoveJob {
	BackgroundJob parent_instance;
	LibraryMonitorRuntimeFindMoveJobPrivate * priv;
	GFile* file;
	GeeCollection* candidates;
	Monitorable* match;
	GError* err;
};

struct _LibraryMonitorRuntimeFindMoveJobClass {
	BackgroundJobClass parent_class;
};

struct _LibraryMonitorParamSpecVerifyJob {
	GParamSpec parent_instance;
};

static gint LibraryMonitorPool_private_offset;
static gpointer library_monitor_pool_parent_class = NULL;
static LibraryMonitorPool* library_monitor_pool_instance;
static LibraryMonitorPool* library_monitor_pool_instance = NULL;
static gint LibraryMonitor_private_offset;
static gpointer library_monitor_parent_class = NULL;
static GeeHashSet* library_monitor_blacklist;
static GRecMutex __lock_library_monitor_library_monitor_blacklist = {0};
static GeeHashSet* library_monitor_blacklist = NULL;
static HashTimedQueue* library_monitor_to_unblacklist;
static HashTimedQueue* library_monitor_to_unblacklist = NULL;
extern TombstoneSourceCollection* tombstone_global;
extern gboolean commandline_options_no_runtime_monitoring;
static gpointer library_monitor_find_move_job_parent_class = NULL;
static gpointer library_monitor_runtime_find_move_job_parent_class = NULL;
static gpointer library_monitor_verify_job_parent_class = NULL;

gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void value_set_library_monitor_pool (GValue* value,
                                     gpointer v_object);
void value_take_library_monitor_pool (GValue* value,
                                      gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
static LibraryMonitorPool* library_monitor_pool_new (void);
static LibraryMonitorPool* library_monitor_pool_construct (GType object_type);
void library_monitor_pool_init (void);
void library_monitor_pool_terminate (void);
static void library_monitor_pool_close (LibraryMonitorPool* self);
LibraryMonitorPool* library_monitor_pool_get_instance (void);
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self);
void library_monitor_pool_replace (LibraryMonitorPool* self,
                                   LibraryMonitor* replacement,
                                   gint start_msec_delay);
static gboolean library_monitor_pool_on_start_monitor (LibraryMonitorPool* self);
static gboolean _library_monitor_pool_on_start_monitor_gsource_func (gpointer self);
void directory_monitor_close (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void library_monitor_pool_finalize (LibraryMonitorPool * obj);
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
GType batch_import_get_type (void) G_GNUC_CONST;
gpointer batch_import_roll_ref (gpointer instance);
void batch_import_roll_unref (gpointer instance);
GParamSpec* param_spec_batch_import_roll (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_batch_import_roll (GValue* value,
                                  gpointer v_object);
void value_take_batch_import_roll (GValue* value,
                                   gpointer v_object);
gpointer value_get_batch_import_roll (const GValue* value);
GType batch_import_roll_get_type (void) G_GNUC_CONST;
static gpointer library_monitor_verify_job_ref (gpointer instance);
static void library_monitor_verify_job_unref (gpointer instance);
static GParamSpec* library_monitor_param_spec_verify_job (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags) G_GNUC_UNUSED;
static void library_monitor_value_set_verify_job (GValue* value,
                                           gpointer v_object) G_GNUC_UNUSED;
static void library_monitor_value_take_verify_job (GValue* value,
                                            gpointer v_object) G_GNUC_UNUSED;
static gpointer library_monitor_value_get_verify_job (const GValue* value) G_GNUC_UNUSED;
static GType library_monitor_verify_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_timed_queue (GValue* value,
                            gpointer v_object);
void value_take_timed_queue (GValue* value,
                             gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
#define LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC (5 * 1000)
static void library_monitor_on_unblacklist_file (GFile* file);
static void _library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item,
                                                             gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type,
                                      GBoxedCopyFunc g_dup_func,
                                      GDestroyNotify g_destroy_func,
                                      guint hold_msec,
                                      DequeuedCallback callback,
                                      gpointer callback_target,
                                      GeeHashDataFunc hash_func,
                                      gpointer hash_func_target,
                                      GDestroyNotify hash_func_target_destroy_notify,
                                      GeeEqualDataFunc equal_func,
                                      gpointer equal_func_target,
                                      GDestroyNotify equal_func_target_destroy_notify,
                                      gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type,
                                            GType g_type,
                                            GBoxedCopyFunc g_dup_func,
                                            GDestroyNotify g_destroy_func,
                                            guint hold_msec,
                                            DequeuedCallback callback,
                                            gpointer callback_target,
                                            GeeHashDataFunc hash_func,
                                            gpointer hash_func_target,
                                            GDestroyNotify hash_func_target_destroy_notify,
                                            GeeEqualDataFunc equal_func,
                                            gpointer equal_func_target,
                                            GDestroyNotify equal_func_target_destroy_notify,
                                            gint priority);
gint workers_thread_per_cpu_minus_one (void);
Workers* workers_new (gint max_threads,
                      gboolean exclusive);
Workers* workers_construct (GType object_type,
                            gint max_threads,
                            gboolean exclusive);
#define LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC 3
#define LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC (5 * 60)
#define LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS 5
LibraryMonitor* library_monitor_new (GFile* root,
                                     gboolean recurse,
                                     gboolean monitoring);
LibraryMonitor* library_monitor_construct (GType object_type,
                                           GFile* root,
                                           gboolean recurse,
                                           gboolean monitoring);
DirectoryMonitor* directory_monitor_new (GFile* root,
                                         gboolean recurse,
                                         gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type,
                                               GFile* root,
                                               gboolean recurse,
                                               gboolean monitoring);
static void library_monitor_on_config_changed (LibraryMonitor* self,
                                        const gchar* key);
static void _library_monitor_on_config_changed_g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self);
static gboolean library_monitor_on_flush_import_queue (LibraryMonitor* self);
static gboolean _library_monitor_on_flush_import_queue_gsource_func (gpointer self);
static void library_monitor_real_close (DirectoryMonitor* base);
void media_monitor_close (MediaMonitor* self);
static void library_monitor_add_to_discovered_list (LibraryMonitor* self,
                                             MediaMonitor* monitor,
                                             Monitorable* monitorable);
static MediaMonitor* library_monitor_get_monitor_for_monitorable (LibraryMonitor* self,
                                                           Monitorable* monitorable);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
MediaSourceCollection* media_monitor_get_media_source_collection (MediaMonitor* self);
gboolean source_collection_holds_type_of_source (SourceCollection* self,
                                                 DataSource* source);
gchar* data_object_to_string (DataObject* self);
static void library_monitor_real_discovery_started (DirectoryMonitor* base);
gpointer media_collection_registry_ref (gpointer instance);
void media_collection_registry_unref (gpointer instance);
GParamSpec* param_spec_media_collection_registry (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void value_set_media_collection_registry (GValue* value,
                                          gpointer v_object);
void value_take_media_collection_registry (GValue* value,
                                           gpointer v_object);
gpointer value_get_media_collection_registry (const GValue* value);
GType media_collection_registry_get_type (void) G_GNUC_CONST;
MediaCollectionRegistry* media_collection_registry_get_instance (void);
GeeCollection* media_collection_registry_get_all (MediaCollectionRegistry* self);
MediaMonitor* media_source_collection_create_media_monitor (MediaSourceCollection* self,
                                                            Workers* workers,
                                                            GCancellable* cancellable);
void media_monitor_notify_discovery_started (MediaMonitor* self);
static void library_monitor_real_file_discovered (DirectoryMonitor* base,
                                           GFile* file,
                                           GFileInfo* info);
GType media_monitor_discovered_file_get_type (void) G_GNUC_CONST;
MediaMonitorDiscoveredFile media_monitor_notify_file_discovered (MediaMonitor* self,
                                                                 GFile* file,
                                                                 GFileInfo* info,
                                                                 Monitorable* * monitorable);
GType tombstone_source_collection_get_type (void) G_GNUC_CONST;
gboolean tombstone_source_collection_matches (TombstoneSourceCollection* self,
                                              GFile* file);
static gboolean library_monitor_is_supported_filetype (LibraryMonitor* self,
                                                GFile* file);
static void library_monitor_real_discovery_completed (DirectoryMonitor* base);
static void library_monitor_async_discovery_completed (LibraryMonitor* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void library_monitor_async_discovery_completed_finish (LibraryMonitor* self,
                                                       GAsyncResult* _res_);
static void library_monitor_async_discovery_completed_data_free (gpointer _data);
static void library_monitor_async_discovery_completed_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data);
static gboolean library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* _data_);
static void library_monitor_discovery_stage_completed (LibraryMonitor* self);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self,
                                            GFile* file);
GeeCollection* media_monitor_candidates_for_unknown_file (MediaMonitor* self,
                                                          GFile* file,
                                                          GFileInfo* info,
                                                          MediaMonitorDiscoveredFile* _result_);
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_background_job (GValue* value,
                               gpointer v_object);
void value_take_background_job (GValue* value,
                                gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
void workers_enqueue (Workers* self,
                      BackgroundJob* job);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_new (LibraryMonitor* owner,
                                                              GFile* file,
                                                              GeeCollection* candidates);
static LibraryMonitorFindMoveJob* library_monitor_find_move_job_construct (GType object_type,
                                                                    LibraryMonitor* owner,
                                                                    GFile* file,
                                                                    GeeCollection* candidates);
static GType library_monitor_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean _library_monitor_async_discovery_completed_co_gsource_func (gpointer self);
void directory_monitor_mdbg (const gchar* msg);
static void library_monitor_report_checksum_job_completed (LibraryMonitor* self);
static void library_monitor_on_find_move_completed (LibraryMonitor* self,
                                             BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
void media_monitor_update_master_file (MediaMonitor* self,
                                       Monitorable* monitorable,
                                       GFile* file);
static void library_monitor_on_find_move_cancelled (LibraryMonitor* self,
                                             BackgroundJob* j);
static void library_monitor_enqueue_verify_monitorable (LibraryMonitor* self,
                                                 Monitorable* monitorable,
                                                 MediaMonitor* monitor);
GeeCollection* data_collection_get_all (DataCollection* self);
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
static void library_monitor_enqueue_import_many (LibraryMonitor* self,
                                          GeeCollection* files);
void tombstone_source_collection_launch_scan (TombstoneSourceCollection* self,
                                              DirectoryMonitor* monitor,
                                              GCancellable* cancellable);
static LibraryMonitorVerifyJob* library_monitor_verify_job_new (Monitorable* monitorable,
                                                         MediaMonitor* monitor);
static LibraryMonitorVerifyJob* library_monitor_verify_job_construct (GType object_type,
                                                               Monitorable* monitorable,
                                                               MediaMonitor* monitor);
static void library_monitor_execute_next_verify_job (LibraryMonitor* self);
static void library_monitor_verify_monitorable (LibraryMonitor* self,
                                         Monitorable* monitorable,
                                         MediaMonitor* monitor,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void library_monitor_verify_monitorable_finish (LibraryMonitor* self,
                                                GAsyncResult* _res_);
static void library_monitor_verify_monitorable_data_free (gpointer _data);
static void library_monitor_verify_monitorable_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
static gboolean library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* _data_);
GFile* media_monitor_get_master_file (MediaMonitor* self,
                                      Monitorable* monitorable);
GFile** media_monitor_get_auxilliary_backing_files (MediaMonitor* self,
                                                    Monitorable* monitorable,
                                                    gint* result_length1);
static void _vala_array_add3 (GFile** * array,
                       int* length,
                       int* size,
                       GFile* value);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
static void library_monitor_verify_monitorable_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
gboolean media_monitor_is_offline (MediaMonitor* self,
                                   Monitorable* monitorable);
void media_monitor_update_online (MediaMonitor* self,
                                  Monitorable* monitorable);
void media_monitor_update_offline (MediaMonitor* self,
                                   Monitorable* monitorable);
void media_monitor_update_backing_file_info (MediaMonitor* self,
                                             Monitorable* monitorable,
                                             GFile* file,
                                             GFileInfo* info);
static gboolean _library_monitor_verify_monitorable_co_gsource_func (gpointer self);
static void library_monitor_import_unrepresented_files (LibraryMonitor* self);
static void library_monitor_cancel_batch_imports (LibraryMonitor* self);
static void library_monitor_enqueue_import (LibraryMonitor* self,
                                     GFile* file);
gboolean library_monitor_is_blacklisted (GFile* file);
static void library_monitor_remove_queued_import (LibraryMonitor* self,
                                           GFile* file);
gulong now_sec (void);
BatchImportRoll* batch_import_roll_new (void);
BatchImportRoll* batch_import_roll_construct (GType object_type);
gpointer batch_import_job_ref (gpointer instance);
void batch_import_job_unref (gpointer instance);
GParamSpec* param_spec_batch_import_job (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void value_set_batch_import_job (GValue* value,
                                 gpointer v_object);
void value_take_batch_import_job (GValue* value,
                                  gpointer v_object);
gpointer value_get_batch_import_job (const GValue* value);
GType batch_import_job_get_type (void) G_GNUC_CONST;
FileImportJob* file_import_job_new (GFile* file_or_dir,
                                    gboolean copy_to_library);
FileImportJob* file_import_job_construct (GType object_type,
                                          GFile* file_or_dir,
                                          gboolean copy_to_library);
GType file_import_job_get_type (void) G_GNUC_CONST;
gpointer import_manifest_ref (gpointer instance);
void import_manifest_unref (gpointer instance);
GParamSpec* param_spec_import_manifest (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_import_manifest (GValue* value,
                                gpointer v_object);
void value_take_import_manifest (GValue* value,
                                 gpointer v_object);
gpointer value_get_import_manifest (const GValue* value);
GType import_manifest_get_type (void) G_GNUC_CONST;
BatchImport* batch_import_new (GeeIterable* jobs,
                               const gchar* name,
                               BatchImportImportReporter reporter,
                               gpointer reporter_target,
                               GeeArrayList* prefailed,
                               GeeArrayList* pre_already_imported,
                               GCancellable* cancellable,
                               BatchImportRoll* import_roll,
                               ImportManifest* skip_manifest);
BatchImport* batch_import_construct (GType object_type,
                                     GeeIterable* jobs,
                                     const gchar* name,
                                     BatchImportImportReporter reporter,
                                     gpointer reporter_target,
                                     GeeArrayList* prefailed,
                                     GeeArrayList* pre_already_imported,
                                     GCancellable* cancellable,
                                     BatchImportRoll* import_roll,
                                     ImportManifest* skip_manifest);
void batch_import_set_untrash_duplicates (BatchImport* self,
                                          gboolean untrash_duplicates);
void batch_import_set_mark_duplicates_online (BatchImport* self,
                                              gboolean mark_duplicates_online);
static void library_monitor_schedule_next_batch_import (LibraryMonitor* self);
static void library_monitor_on_import_preparing (LibraryMonitor* self);
static void _library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender,
                                                                  gpointer self);
static void library_monitor_on_import_progress (LibraryMonitor* self,
                                         guint64 completed_bytes,
                                         guint64 total_bytes);
static void _library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender,
                                                                guint64 completed_bytes,
                                                                guint64 total_bytes,
                                                                gpointer self);
static void library_monitor_on_import_complete (LibraryMonitor* self,
                                         BatchImport* batch_import,
                                         ImportManifest* manifest,
                                         BatchImportRoll* import_roll);
static void _library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender,
                                                                       ImportManifest* manifest,
                                                                       BatchImportRoll* import_roll,
                                                                       gpointer self);
void batch_import_schedule (BatchImport* self);
static void library_monitor_discard_current_batch_import (LibraryMonitor* self);
void batch_import_user_halt (BatchImport* self);
gpointer batch_import_result_ref (gpointer instance);
void batch_import_result_unref (gpointer instance);
GParamSpec* param_spec_batch_import_result (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_batch_import_result (GValue* value,
                                    gpointer v_object);
void value_take_batch_import_result (GValue* value,
                                     gpointer v_object);
gpointer value_get_batch_import_result (const GValue* value);
GType batch_import_result_get_type (void) G_GNUC_CONST;
GType import_result_get_type (void) G_GNUC_CONST;
GType duplicated_file_get_type (void) G_GNUC_CONST;
gpointer tombstoned_file_ref (gpointer instance);
void tombstoned_file_unref (gpointer instance);
GParamSpec* param_spec_tombstoned_file (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_tombstoned_file (GValue* value,
                                gpointer v_object);
void value_take_tombstoned_file (GValue* value,
                                 gpointer v_object);
gpointer value_get_tombstoned_file (const GValue* value);
GType tombstoned_file_get_type (void) G_GNUC_CONST;
TombstonedFile* tombstoned_file_new (GFile* file,
                                     gint64 filesize,
                                     const gchar* md5);
TombstonedFile* tombstoned_file_construct (GType object_type,
                                           GFile* file,
                                           gint64 filesize,
                                           const gchar* md5);
GType tombstone_reason_get_type (void) G_GNUC_CONST;
GQuark database_error_quark (void);
void tombstone_entomb_many_files (GeeCollection* files,
                                  TombstoneReason reason,
                                  GError** error);
void app_window_database_error (GError* err);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
gboolean timed_queue_contains (TimedQueue* self,
                               gconstpointer item);
gboolean timed_queue_enqueue (TimedQueue* self,
                              gconstpointer item);
MediaSourceCollection* media_collection_registry_get_collection_for_file (MediaCollectionRegistry* self,
                                                                          GFile* file);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
gboolean media_monitor_is_file_represented (MediaMonitor* self,
                                            GFile* file);
static void library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self,
                                                      GFile* file);
static void library_monitor_real_notify_file_created (DirectoryMonitor* base,
                                               GFile* file,
                                               GFileInfo* info);
void directory_monitor_notify_file_created (DirectoryMonitor* self,
                                            GFile* file,
                                            GFileInfo* info);
gboolean media_monitor_notify_file_created (MediaMonitor* self,
                                            GFile* file,
                                            GFileInfo* info);
gchar* media_monitor_to_string (MediaMonitor* self);
const gchar* media_monitor_discovered_file_to_string (MediaMonitorDiscoveredFile self);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_new (LibraryMonitor* owner,
                                                                             GFile* file,
                                                                             GeeCollection* candidates);
static LibraryMonitorRuntimeFindMoveJob* library_monitor_runtime_find_move_job_construct (GType object_type,
                                                                                   LibraryMonitor* owner,
                                                                                   GFile* file,
                                                                                   GeeCollection* candidates);
static GType library_monitor_runtime_find_move_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void library_monitor_on_runtime_find_move_completed (LibraryMonitor* self,
                                                     BackgroundJob* j);
static void library_monitor_real_notify_file_moved (DirectoryMonitor* base,
                                             GFile* old_file,
                                             GFile* new_file,
                                             GFileInfo* new_info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info);
gboolean media_monitor_notify_file_moved (MediaMonitor* self,
                                          GFile* old_file,
                                          GFile* new_file,
                                          GFileInfo* new_file_info);
static void library_monitor_real_notify_file_altered (DirectoryMonitor* base,
                                               GFile* file);
void directory_monitor_notify_file_altered (DirectoryMonitor* self,
                                            GFile* file);
gboolean media_monitor_notify_file_altered (MediaMonitor* self,
                                            GFile* file);
static void library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base,
                                                          GFile* file);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self,
                                                       GFile* file);
gboolean media_monitor_notify_file_attributes_altered (MediaMonitor* self,
                                                       GFile* file);
static void library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base,
                                                            GFile* file,
                                                            GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info);
gboolean media_monitor_notify_file_alteration_completed (MediaMonitor* self,
                                                         GFile* file,
                                                         GFileInfo* info);
static void library_monitor_real_notify_file_deleted (DirectoryMonitor* base,
                                               GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self,
                                            GFile* file);
gboolean media_monitor_notify_file_deleted (MediaMonitor* self,
                                            GFile* file);
GType tombstone_get_type (void) G_GNUC_CONST;
Tombstone* tombstone_source_collection_locate (TombstoneSourceCollection* self,
                                               GFile* file);
void tombstone_source_collection_resurrect (TombstoneSourceCollection* self,
                                            Tombstone* tombstone);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * library_monitor_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
#define GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME "io.elementary.photos"
#define GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME ".preferences"
#define GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME ".files"
static void _library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job,
                                                                  gpointer self);
static void _library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job,
                                                                    gpointer self);
gpointer abstract_semaphore_ref (gpointer instance);
void abstract_semaphore_unref (gpointer instance);
GParamSpec* param_spec_abstract_semaphore (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_abstract_semaphore (GValue* value,
                                   gpointer v_object);
void value_take_abstract_semaphore (GValue* value,
                                    gpointer v_object);
gpointer value_get_abstract_semaphore (const GValue* value);
GType abstract_semaphore_get_type (void) G_GNUC_CONST;
BackgroundJob* background_job_construct (GType object_type,
                                         GObject* owner,
                                         CompletionCallback callback,
                                         gpointer callback_target,
                                         GCancellable* cancellable,
                                         CancellationCallback cancellation,
                                         gpointer cancellation_target,
                                         AbstractSemaphore* completion_semaphore);
void background_job_set_completion_priority (BackgroundJob* self,
                                             gint priority);
static void library_monitor_find_move_job_real_execute (BackgroundJob* base);
GFile* media_source_get_master_file (MediaSource* self);
gchar* md5_file (GFile* file,
                 GError** error);
gchar* media_source_get_master_md5 (MediaSource* self);
static void library_monitor_find_move_job_finalize (BackgroundJob * obj);
static void _library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job,
                                                                          gpointer self);
static void library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base);
static void library_monitor_runtime_find_move_job_finalize (BackgroundJob * obj);
static void library_monitor_verify_job_finalize (LibraryMonitorVerifyJob * obj);
static void library_monitor_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
library_monitor_pool_get_instance_private (LibraryMonitorPool* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryMonitorPool_private_offset);
}

static LibraryMonitorPool*
library_monitor_pool_construct (GType object_type)
{
	LibraryMonitorPool* self = NULL;
#line 51 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorPool*) g_type_create_instance (object_type);
#line 51 "../src/LibraryMonitor.vala"
	return self;
#line 1497 "LibraryMonitor.c"
}

static LibraryMonitorPool*
library_monitor_pool_new (void)
{
#line 51 "../src/LibraryMonitor.vala"
	return library_monitor_pool_construct (TYPE_LIBRARY_MONITOR_POOL);
#line 1505 "LibraryMonitor.c"
}

void
library_monitor_pool_init (void)
{
}

void
library_monitor_pool_terminate (void)
{
	LibraryMonitorPool* _tmp0_;
#line 58 "../src/LibraryMonitor.vala"
	_tmp0_ = library_monitor_pool_instance;
#line 58 "../src/LibraryMonitor.vala"
	if (_tmp0_ != NULL) {
#line 1521 "LibraryMonitor.c"
		LibraryMonitorPool* _tmp1_;
#line 59 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_pool_instance;
#line 59 "../src/LibraryMonitor.vala"
		library_monitor_pool_close (_tmp1_);
#line 1527 "LibraryMonitor.c"
	}
#line 61 "../src/LibraryMonitor.vala"
	_library_monitor_pool_unref0 (library_monitor_pool_instance);
#line 61 "../src/LibraryMonitor.vala"
	library_monitor_pool_instance = NULL;
#line 1533 "LibraryMonitor.c"
}

static gpointer
_library_monitor_pool_ref0 (gpointer self)
{
#line 68 "../src/LibraryMonitor.vala"
	return self ? library_monitor_pool_ref (self) : NULL;
#line 1541 "LibraryMonitor.c"
}

LibraryMonitorPool*
library_monitor_pool_get_instance (void)
{
	LibraryMonitorPool* result = NULL;
	LibraryMonitorPool* _tmp0_;
	LibraryMonitorPool* _tmp2_;
	LibraryMonitorPool* _tmp3_;
#line 65 "../src/LibraryMonitor.vala"
	_tmp0_ = library_monitor_pool_instance;
#line 65 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 1555 "LibraryMonitor.c"
		LibraryMonitorPool* _tmp1_;
#line 66 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_pool_new ();
#line 66 "../src/LibraryMonitor.vala"
		_library_monitor_pool_unref0 (library_monitor_pool_instance);
#line 66 "../src/LibraryMonitor.vala"
		library_monitor_pool_instance = _tmp1_;
#line 1563 "LibraryMonitor.c"
	}
#line 68 "../src/LibraryMonitor.vala"
	_tmp2_ = library_monitor_pool_instance;
#line 68 "../src/LibraryMonitor.vala"
	_tmp3_ = _library_monitor_pool_ref0 (_tmp2_);
#line 68 "../src/LibraryMonitor.vala"
	result = _tmp3_;
#line 68 "../src/LibraryMonitor.vala"
	return result;
#line 1573 "LibraryMonitor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 72 "../src/LibraryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 1581 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_pool_get_monitor (LibraryMonitorPool* self)
{
	LibraryMonitor* result = NULL;
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
#line 71 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 72 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 72 "../src/LibraryMonitor.vala"
	result = _tmp1_;
#line 72 "../src/LibraryMonitor.vala"
	return result;
#line 1600 "LibraryMonitor.c"
}

static gboolean
_library_monitor_pool_on_start_monitor_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_pool_on_start_monitor ((LibraryMonitorPool*) self);
#line 81 "../src/LibraryMonitor.vala"
	return result;
#line 1610 "LibraryMonitor.c"
}

void
library_monitor_pool_replace (LibraryMonitorPool* self,
                              LibraryMonitor* replacement,
                              gint start_msec_delay)
{
	LibraryMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	LibraryMonitor* _tmp2_;
#line 76 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/LibraryMonitor.vala"
	g_return_if_fail (replacement != NULL);
#line 77 "../src/LibraryMonitor.vala"
	library_monitor_pool_close (self);
#line 79 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (replacement);
#line 79 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 79 "../src/LibraryMonitor.vala"
	self->priv->monitor = _tmp0_;
#line 80 "../src/LibraryMonitor.vala"
	if (start_msec_delay > 0) {
#line 80 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->timer_id == ((guint) 0);
#line 1637 "LibraryMonitor.c"
	} else {
#line 80 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 1641 "LibraryMonitor.c"
	}
#line 80 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 81 "../src/LibraryMonitor.vala"
		self->priv->timer_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) start_msec_delay, _library_monitor_pool_on_start_monitor_gsource_func, library_monitor_pool_ref (self), library_monitor_pool_unref);
#line 1647 "LibraryMonitor.c"
	}
#line 83 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->monitor;
#line 83 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL], 0, _tmp2_);
#line 1653 "LibraryMonitor.c"
}

static void
library_monitor_pool_close (LibraryMonitorPool* self)
{
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
	LibraryMonitor* closed = NULL;
	LibraryMonitor* _tmp2_;
	LibraryMonitor* _tmp3_;
	LibraryMonitor* _tmp4_;
#line 86 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 87 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 88 "../src/LibraryMonitor.vala"
		return;
#line 1673 "LibraryMonitor.c"
	}
#line 90 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->monitor;
#line 90 "../src/LibraryMonitor.vala"
	directory_monitor_close ((DirectoryMonitor*) _tmp1_);
#line 91 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->monitor;
#line 91 "../src/LibraryMonitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 91 "../src/LibraryMonitor.vala"
	closed = _tmp3_;
#line 92 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 92 "../src/LibraryMonitor.vala"
	self->priv->monitor = NULL;
#line 94 "../src/LibraryMonitor.vala"
	_tmp4_ = closed;
#line 94 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL], 0, _tmp4_);
#line 86 "../src/LibraryMonitor.vala"
	_g_object_unref0 (closed);
#line 1695 "LibraryMonitor.c"
}

static gboolean
library_monitor_pool_on_start_monitor (LibraryMonitorPool* self)
{
	gboolean result = FALSE;
	LibraryMonitor* _tmp0_;
	LibraryMonitor* _tmp1_;
#line 97 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../src/LibraryMonitor.vala"
	self->priv->timer_id = (guint) 0;
#line 101 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->monitor;
#line 101 "../src/LibraryMonitor.vala"
	if (_tmp0_ == NULL) {
#line 102 "../src/LibraryMonitor.vala"
		result = FALSE;
#line 102 "../src/LibraryMonitor.vala"
		return result;
#line 1716 "LibraryMonitor.c"
	}
#line 104 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->monitor;
#line 104 "../src/LibraryMonitor.vala"
	directory_monitor_start_discovery ((DirectoryMonitor*) _tmp1_);
#line 106 "../src/LibraryMonitor.vala"
	result = FALSE;
#line 106 "../src/LibraryMonitor.vala"
	return result;
#line 1726 "LibraryMonitor.c"
}

static void
value_library_monitor_pool_init (GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 1734 "LibraryMonitor.c"
}

static void
value_library_monitor_pool_free_value (GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (value->data[0].v_pointer);
#line 1744 "LibraryMonitor.c"
	}
}

static void
value_library_monitor_pool_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 41 "../src/LibraryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = library_monitor_pool_ref (src_value->data[0].v_pointer);
#line 1756 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1760 "LibraryMonitor.c"
	}
}

static gpointer
value_library_monitor_pool_peek_pointer (const GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 1769 "LibraryMonitor.c"
}

static gchar*
value_library_monitor_pool_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 41 "../src/LibraryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 1780 "LibraryMonitor.c"
		LibraryMonitorPool * object;
		object = collect_values[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 41 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1787 "LibraryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 41 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1791 "LibraryMonitor.c"
		}
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = library_monitor_pool_ref (object);
#line 1795 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 1799 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	return NULL;
#line 1803 "LibraryMonitor.c"
}

static gchar*
value_library_monitor_pool_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	LibraryMonitorPool ** object_p;
	object_p = collect_values[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (!object_p) {
#line 41 "../src/LibraryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1818 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = NULL;
#line 1824 "LibraryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 1828 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		*object_p = library_monitor_pool_ref (value->data[0].v_pointer);
#line 1832 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	return NULL;
#line 1836 "LibraryMonitor.c"
}

GParamSpec*
param_spec_library_monitor_pool (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	ParamSpecLibraryMonitorPool* spec;
#line 41 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_LIBRARY_MONITOR_POOL), NULL);
#line 41 "../src/LibraryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 41 "../src/LibraryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 41 "../src/LibraryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 1855 "LibraryMonitor.c"
}

gpointer
value_get_library_monitor_pool (const GValue* value)
{
#line 41 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL), NULL);
#line 41 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 1865 "LibraryMonitor.c"
}

void
value_set_library_monitor_pool (GValue* value,
                                gpointer v_object)
{
	LibraryMonitorPool * old;
#line 41 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_ref (value->data[0].v_pointer);
#line 1887 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 1891 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (old) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (old);
#line 1897 "LibraryMonitor.c"
	}
}

void
value_take_library_monitor_pool (GValue* value,
                                 gpointer v_object)
{
	LibraryMonitorPool * old;
#line 41 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 41 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_LIBRARY_MONITOR_POOL));
#line 41 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 1918 "LibraryMonitor.c"
	} else {
#line 41 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 1922 "LibraryMonitor.c"
	}
#line 41 "../src/LibraryMonitor.vala"
	if (old) {
#line 41 "../src/LibraryMonitor.vala"
		library_monitor_pool_unref (old);
#line 1928 "LibraryMonitor.c"
	}
}

static void
library_monitor_pool_class_init (LibraryMonitorPoolClass * klass,
                                 gpointer klass_data)
{
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/LibraryMonitor.vala"
	((LibraryMonitorPoolClass *) klass)->finalize = library_monitor_pool_finalize;
#line 41 "../src/LibraryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &LibraryMonitorPool_private_offset);
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_INSTALLED_SIGNAL] = g_signal_new ("monitor-installed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
#line 41 "../src/LibraryMonitor.vala"
	library_monitor_pool_signals[LIBRARY_MONITOR_POOL_MONITOR_DESTROYED_SIGNAL] = g_signal_new ("monitor-destroyed", TYPE_LIBRARY_MONITOR_POOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_LIBRARY_MONITOR);
#line 1946 "LibraryMonitor.c"
}

static void
library_monitor_pool_instance_init (LibraryMonitorPool * self,
                                    gpointer klass)
{
#line 41 "../src/LibraryMonitor.vala"
	self->priv = library_monitor_pool_get_instance_private (self);
#line 44 "../src/LibraryMonitor.vala"
	self->priv->monitor = NULL;
#line 45 "../src/LibraryMonitor.vala"
	self->priv->timer_id = (guint) 0;
#line 41 "../src/LibraryMonitor.vala"
	self->ref_count = 1;
#line 1961 "LibraryMonitor.c"
}

static void
library_monitor_pool_finalize (LibraryMonitorPool * obj)
{
	LibraryMonitorPool * self;
#line 41 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool);
#line 41 "../src/LibraryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 44 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 1974 "LibraryMonitor.c"
}

GType
library_monitor_pool_get_type (void)
{
	static volatile gsize library_monitor_pool_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_pool_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_library_monitor_pool_init, value_library_monitor_pool_free_value, value_library_monitor_pool_copy_value, value_library_monitor_pool_peek_pointer, "p", value_library_monitor_pool_collect_value, "p", value_library_monitor_pool_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorPoolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_pool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorPool), 0, (GInstanceInitFunc) library_monitor_pool_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_pool_type_id;
		library_monitor_pool_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorPool", &g_define_type_info, &g_define_type_fundamental_info, 0);
		LibraryMonitorPool_private_offset = g_type_add_instance_private (library_monitor_pool_type_id, sizeof (LibraryMonitorPoolPrivate));
		g_once_init_leave (&library_monitor_pool_type_id__volatile, library_monitor_pool_type_id);
	}
	return library_monitor_pool_type_id__volatile;
}

gpointer
library_monitor_pool_ref (gpointer instance)
{
	LibraryMonitorPool * self;
	self = instance;
#line 41 "../src/LibraryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 41 "../src/LibraryMonitor.vala"
	return instance;
#line 2002 "LibraryMonitor.c"
}

void
library_monitor_pool_unref (gpointer instance)
{
	LibraryMonitorPool * self;
	self = instance;
#line 41 "../src/LibraryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 41 "../src/LibraryMonitor.vala"
		LIBRARY_MONITOR_POOL_GET_CLASS (self)->finalize (self);
#line 41 "../src/LibraryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2016 "LibraryMonitor.c"
	}
}

static inline gpointer
library_monitor_get_instance_private (LibraryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryMonitor_private_offset);
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 219 "../src/LibraryMonitor.vala"
	return result;
#line 2034 "LibraryMonitor.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 219 "../src/LibraryMonitor.vala"
	return result;
#line 2046 "LibraryMonitor.c"
}

static void
_library_monitor_on_unblacklist_file_dequeued_callback (gconstpointer item,
                                                        gpointer self)
{
#line 220 "../src/LibraryMonitor.vala"
	library_monitor_on_unblacklist_file ((GFile*) item);
#line 2055 "LibraryMonitor.c"
}

static void
_library_monitor_on_config_changed_g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self)
{
#line 259 "../src/LibraryMonitor.vala"
	library_monitor_on_config_changed ((LibraryMonitor*) self, key);
#line 2065 "LibraryMonitor.c"
}

static gboolean
_library_monitor_on_flush_import_queue_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_on_flush_import_queue ((LibraryMonitor*) self);
#line 261 "../src/LibraryMonitor.vala"
	return result;
#line 2075 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_construct (GType object_type,
                           GFile* root,
                           gboolean recurse,
                           gboolean monitoring)
{
	LibraryMonitor * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 254 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 255 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) directory_monitor_construct (object_type, root, recurse, monitoring);
#line 258 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->file_settings;
#line 258 "../src/LibraryMonitor.vala"
	self->priv->auto_import = g_settings_get_boolean (_tmp0_, "auto-import");
#line 259 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->file_settings;
#line 259 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _library_monitor_on_config_changed_g_settings_changed, self, 0);
#line 261 "../src/LibraryMonitor.vala"
	self->priv->import_queue_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) LIBRARY_MONITOR_FLUSH_IMPORT_QUEUE_SEC, _library_monitor_on_flush_import_queue_gsource_func, g_object_ref (self), g_object_unref);
#line 254 "../src/LibraryMonitor.vala"
	return self;
#line 2103 "LibraryMonitor.c"
}

LibraryMonitor*
library_monitor_new (GFile* root,
                     gboolean recurse,
                     gboolean monitoring)
{
#line 254 "../src/LibraryMonitor.vala"
	return library_monitor_construct (TYPE_LIBRARY_MONITOR, root, recurse, monitoring);
#line 2113 "LibraryMonitor.c"
}

static void
library_monitor_real_close (DirectoryMonitor* base)
{
	LibraryMonitor * self;
	GCancellable* _tmp0_;
#line 264 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 265 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 265 "../src/LibraryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 2127 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp1_;
		GeeList* _tmp2_;
		gint _monitor_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _monitor_index = 0;
#line 267 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 267 "../src/LibraryMonitor.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 267 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp2_;
#line 267 "../src/LibraryMonitor.vala"
		_tmp3_ = _monitor_list;
#line 267 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 267 "../src/LibraryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 267 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp5_;
#line 267 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 267 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2155 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 267 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 267 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 267 "../src/LibraryMonitor.vala"
				break;
#line 2166 "LibraryMonitor.c"
			}
#line 267 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 267 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 267 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 268 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 268 "../src/LibraryMonitor.vala"
			media_monitor_close (_tmp8_);
#line 267 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 2180 "LibraryMonitor.c"
		}
#line 267 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 2184 "LibraryMonitor.c"
	}
#line 270 "../src/LibraryMonitor.vala"
	if (self->priv->import_queue_timer_id != ((guint) 0)) {
#line 271 "../src/LibraryMonitor.vala"
		g_source_remove (self->priv->import_queue_timer_id);
#line 272 "../src/LibraryMonitor.vala"
		self->priv->import_queue_timer_id = (guint) 0;
#line 2192 "LibraryMonitor.c"
	}
#line 275 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 2196 "LibraryMonitor.c"
}

static void
library_monitor_add_to_discovered_list (LibraryMonitor* self,
                                        MediaMonitor* monitor,
                                        Monitorable* monitorable)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	GeeSet* _tmp6_;
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 278 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 279 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->discovered;
#line 279 "../src/LibraryMonitor.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, monitor)) {
#line 2218 "LibraryMonitor.c"
		GeeHashMap* _tmp1_;
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp3_;
#line 280 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->discovered;
#line 280 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 280 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 280 "../src/LibraryMonitor.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, monitor, (GeeSet*) _tmp3_);
#line 280 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 2232 "LibraryMonitor.c"
	}
#line 282 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->discovered;
#line 282 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, monitor);
#line 282 "../src/LibraryMonitor.vala"
	_tmp6_ = (GeeSet*) _tmp5_;
#line 282 "../src/LibraryMonitor.vala"
	gee_collection_add ((GeeCollection*) _tmp6_, monitorable);
#line 282 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_tmp6_);
#line 2244 "LibraryMonitor.c"
}

static MediaMonitor*
library_monitor_get_monitor_for_monitorable (LibraryMonitor* self,
                                             Monitorable* monitorable)
{
	MediaMonitor* result = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 285 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 2258 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 286 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 286 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 286 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 286 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 286 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 286 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 286 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 286 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 286 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2286 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
			MediaSourceCollection* _tmp8_;
			MediaSourceCollection* _tmp9_;
			gboolean _tmp10_;
#line 286 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 286 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 286 "../src/LibraryMonitor.vala"
				break;
#line 2300 "LibraryMonitor.c"
			}
#line 286 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 286 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 286 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 287 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 287 "../src/LibraryMonitor.vala"
			_tmp8_ = media_monitor_get_media_source_collection (_tmp7_);
#line 287 "../src/LibraryMonitor.vala"
			_tmp9_ = _tmp8_;
#line 287 "../src/LibraryMonitor.vala"
			_tmp10_ = source_collection_holds_type_of_source ((SourceCollection*) _tmp9_, (DataSource*) monitorable);
#line 287 "../src/LibraryMonitor.vala"
			_data_collection_unref0 (_tmp9_);
#line 287 "../src/LibraryMonitor.vala"
			if (_tmp10_) {
#line 288 "../src/LibraryMonitor.vala"
				result = monitor;
#line 288 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_monitor_list);
#line 288 "../src/LibraryMonitor.vala"
				return result;
#line 2326 "LibraryMonitor.c"
			}
#line 286 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 2330 "LibraryMonitor.c"
		}
#line 286 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 2334 "LibraryMonitor.c"
	}
#line 291 "../src/LibraryMonitor.vala"
	_tmp11_ = data_object_to_string ((DataObject*) monitorable);
#line 291 "../src/LibraryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 291 "../src/LibraryMonitor.vala"
	g_error ("LibraryMonitor.vala:291: Unable to locate MediaMonitor for %s", _tmp12_);
#line 291 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp12_);
#line 2344 "LibraryMonitor.c"
}

static void
library_monitor_real_discovery_started (DirectoryMonitor* base)
{
	LibraryMonitor * self;
	GeeHashMap* _tmp23_;
	GeeHashSet* _tmp24_;
#line 294 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 2355 "LibraryMonitor.c"
	{
		GeeIterator* _collection_it = NULL;
		MediaCollectionRegistry* _tmp0_;
		MediaCollectionRegistry* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp0_ = media_collection_registry_get_instance ();
#line 295 "../src/LibraryMonitor.vala"
		_tmp1_ = _tmp0_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp2_ = media_collection_registry_get_all (_tmp1_);
#line 295 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 295 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 295 "../src/LibraryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 295 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 295 "../src/LibraryMonitor.vala"
		_media_collection_registry_unref0 (_tmp1_);
#line 295 "../src/LibraryMonitor.vala"
		_collection_it = _tmp5_;
#line 295 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2384 "LibraryMonitor.c"
			GeeIterator* _tmp6_;
			MediaSourceCollection* collection = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			MediaSourceCollection* _tmp10_;
			Workers* _tmp11_;
			GCancellable* _tmp12_;
			MediaMonitor* _tmp13_;
			MediaMonitor* _tmp14_;
#line 295 "../src/LibraryMonitor.vala"
			_tmp6_ = _collection_it;
#line 295 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 295 "../src/LibraryMonitor.vala"
				break;
#line 2401 "LibraryMonitor.c"
			}
#line 295 "../src/LibraryMonitor.vala"
			_tmp7_ = _collection_it;
#line 295 "../src/LibraryMonitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 295 "../src/LibraryMonitor.vala"
			collection = (MediaSourceCollection*) _tmp8_;
#line 296 "../src/LibraryMonitor.vala"
			_tmp9_ = self->priv->monitors;
#line 296 "../src/LibraryMonitor.vala"
			_tmp10_ = collection;
#line 296 "../src/LibraryMonitor.vala"
			_tmp11_ = self->priv->workers;
#line 296 "../src/LibraryMonitor.vala"
			_tmp12_ = self->priv->cancellable;
#line 296 "../src/LibraryMonitor.vala"
			_tmp13_ = media_source_collection_create_media_monitor (_tmp10_, _tmp11_, _tmp12_);
#line 296 "../src/LibraryMonitor.vala"
			_tmp14_ = _tmp13_;
#line 296 "../src/LibraryMonitor.vala"
			gee_collection_add ((GeeCollection*) _tmp9_, _tmp14_);
#line 296 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_tmp14_);
#line 295 "../src/LibraryMonitor.vala"
			_data_collection_unref0 (collection);
#line 2427 "LibraryMonitor.c"
		}
#line 295 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_collection_it);
#line 2431 "LibraryMonitor.c"
	}
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp15_;
		GeeList* _tmp16_;
		gint _monitor_size = 0;
		GeeList* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _monitor_index = 0;
#line 298 "../src/LibraryMonitor.vala"
		_tmp15_ = self->priv->monitors;
#line 298 "../src/LibraryMonitor.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 298 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp16_;
#line 298 "../src/LibraryMonitor.vala"
		_tmp17_ = _monitor_list;
#line 298 "../src/LibraryMonitor.vala"
		_tmp18_ = gee_collection_get_size ((GeeCollection*) _tmp17_);
#line 298 "../src/LibraryMonitor.vala"
		_tmp19_ = _tmp18_;
#line 298 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp19_;
#line 298 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 298 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2460 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp20_;
			gpointer _tmp21_;
			MediaMonitor* _tmp22_;
#line 298 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 298 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 298 "../src/LibraryMonitor.vala"
				break;
#line 2471 "LibraryMonitor.c"
			}
#line 298 "../src/LibraryMonitor.vala"
			_tmp20_ = _monitor_list;
#line 298 "../src/LibraryMonitor.vala"
			_tmp21_ = gee_list_get (_tmp20_, _monitor_index);
#line 298 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp21_;
#line 299 "../src/LibraryMonitor.vala"
			_tmp22_ = monitor;
#line 299 "../src/LibraryMonitor.vala"
			media_monitor_notify_discovery_started (_tmp22_);
#line 298 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 2485 "LibraryMonitor.c"
		}
#line 298 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 2489 "LibraryMonitor.c"
	}
#line 301 "../src/LibraryMonitor.vala"
	_tmp23_ = gee_hash_map_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 301 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 301 "../src/LibraryMonitor.vala"
	self->priv->discovered = _tmp23_;
#line 302 "../src/LibraryMonitor.vala"
	_tmp24_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 302 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 302 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = _tmp24_;
#line 304 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_started (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 2505 "LibraryMonitor.c"
}

static void
library_monitor_real_file_discovered (DirectoryMonitor* base,
                                      GFile* file,
                                      GFileInfo* info)
{
	LibraryMonitor * self;
	Monitorable* representation = NULL;
	MediaMonitor* representing = NULL;
	gboolean ignore = FALSE;
	MediaMonitor* _tmp14_;
#line 307 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 307 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 307 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 308 "../src/LibraryMonitor.vala"
	representation = NULL;
#line 309 "../src/LibraryMonitor.vala"
	representing = NULL;
#line 310 "../src/LibraryMonitor.vala"
	ignore = FALSE;
#line 2530 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 311 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 311 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 311 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 311 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 311 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 311 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 311 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 311 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 311 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 2558 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitorDiscoveredFile _result_ = 0;
			MediaMonitor* _tmp7_;
			Monitorable* _tmp8_ = NULL;
			MediaMonitorDiscoveredFile _tmp9_;
			MediaMonitorDiscoveredFile _tmp10_;
#line 311 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 311 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 311 "../src/LibraryMonitor.vala"
				break;
#line 2573 "LibraryMonitor.c"
			}
#line 311 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 311 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 311 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 312 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 312 "../src/LibraryMonitor.vala"
			_tmp9_ = media_monitor_notify_file_discovered (_tmp7_, file, info, &_tmp8_);
#line 312 "../src/LibraryMonitor.vala"
			_g_object_unref0 (representation);
#line 312 "../src/LibraryMonitor.vala"
			representation = _tmp8_;
#line 312 "../src/LibraryMonitor.vala"
			_result_ = _tmp9_;
#line 314 "../src/LibraryMonitor.vala"
			_tmp10_ = _result_;
#line 314 "../src/LibraryMonitor.vala"
			if (_tmp10_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 2595 "LibraryMonitor.c"
				MediaMonitor* _tmp11_;
				MediaMonitor* _tmp12_;
#line 315 "../src/LibraryMonitor.vala"
				_tmp11_ = monitor;
#line 315 "../src/LibraryMonitor.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 315 "../src/LibraryMonitor.vala"
				_g_object_unref0 (representing);
#line 315 "../src/LibraryMonitor.vala"
				representing = _tmp12_;
#line 317 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 317 "../src/LibraryMonitor.vala"
				break;
#line 2610 "LibraryMonitor.c"
			} else {
				MediaMonitorDiscoveredFile _tmp13_;
#line 318 "../src/LibraryMonitor.vala"
				_tmp13_ = _result_;
#line 318 "../src/LibraryMonitor.vala"
				if (_tmp13_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE) {
#line 320 "../src/LibraryMonitor.vala"
					ignore = TRUE;
#line 322 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 322 "../src/LibraryMonitor.vala"
					break;
#line 2623 "LibraryMonitor.c"
				}
			}
#line 311 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 2628 "LibraryMonitor.c"
		}
#line 311 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 2632 "LibraryMonitor.c"
	}
#line 326 "../src/LibraryMonitor.vala"
	_tmp14_ = representing;
#line 326 "../src/LibraryMonitor.vala"
	if (_tmp14_ != NULL) {
#line 2638 "LibraryMonitor.c"
		gboolean _tmp15_ = FALSE;
		Monitorable* _tmp16_;
		MediaMonitor* _tmp17_;
		Monitorable* _tmp18_;
#line 327 "../src/LibraryMonitor.vala"
		_tmp16_ = representation;
#line 327 "../src/LibraryMonitor.vala"
		if (_tmp16_ != NULL) {
#line 327 "../src/LibraryMonitor.vala"
			_tmp15_ = !ignore;
#line 2649 "LibraryMonitor.c"
		} else {
#line 327 "../src/LibraryMonitor.vala"
			_tmp15_ = FALSE;
#line 2653 "LibraryMonitor.c"
		}
#line 327 "../src/LibraryMonitor.vala"
		_vala_assert (_tmp15_, "representation != null && !ignore");
#line 328 "../src/LibraryMonitor.vala"
		_tmp17_ = representing;
#line 328 "../src/LibraryMonitor.vala"
		_tmp18_ = representation;
#line 328 "../src/LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, _tmp17_, _tmp18_);
#line 2663 "LibraryMonitor.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 329 "../src/LibraryMonitor.vala"
		if (!ignore) {
#line 2669 "LibraryMonitor.c"
			TombstoneSourceCollection* _tmp21_;
#line 329 "../src/LibraryMonitor.vala"
			_tmp21_ = tombstone_global;
#line 329 "../src/LibraryMonitor.vala"
			_tmp20_ = !tombstone_source_collection_matches (_tmp21_, file);
#line 2675 "LibraryMonitor.c"
		} else {
#line 329 "../src/LibraryMonitor.vala"
			_tmp20_ = FALSE;
#line 2679 "LibraryMonitor.c"
		}
#line 329 "../src/LibraryMonitor.vala"
		if (_tmp20_) {
#line 329 "../src/LibraryMonitor.vala"
			_tmp19_ = library_monitor_is_supported_filetype (self, file);
#line 2685 "LibraryMonitor.c"
		} else {
#line 329 "../src/LibraryMonitor.vala"
			_tmp19_ = FALSE;
#line 2689 "LibraryMonitor.c"
		}
#line 329 "../src/LibraryMonitor.vala"
		if (_tmp19_) {
#line 2693 "LibraryMonitor.c"
			GeeHashSet* _tmp22_;
#line 330 "../src/LibraryMonitor.vala"
			_tmp22_ = self->priv->unknown_files;
#line 330 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, file);
#line 2699 "LibraryMonitor.c"
		}
	}
#line 333 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->file_discovered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 307 "../src/LibraryMonitor.vala"
	_g_object_unref0 (representing);
#line 307 "../src/LibraryMonitor.vala"
	_g_object_unref0 (representation);
#line 2708 "LibraryMonitor.c"
}

static void
library_monitor_real_discovery_completed (DirectoryMonitor* base)
{
	LibraryMonitor * self;
#line 336 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 337 "../src/LibraryMonitor.vala"
	library_monitor_async_discovery_completed (self, NULL, NULL);
#line 2719 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed_data_free (gpointer _data)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	_data_ = _data;
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 110 "../src/LibraryMonitor.vala"
	g_slice_free (LibraryMonitorAsyncDiscoveryCompletedData, _data_);
#line 2731 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _task_data_;
#line 110 "../src/LibraryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 110 "../src/LibraryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 110 "../src/LibraryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2746 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2750 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed (LibraryMonitor* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
	LibraryMonitor* _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_slice_new0 (LibraryMonitorAsyncDiscoveryCompletedData);
#line 110 "../src/LibraryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 110 "../src/LibraryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, library_monitor_async_discovery_completed_async_ready_wrapper, _user_data_);
#line 110 "../src/LibraryMonitor.vala"
	if (_callback_ == NULL) {
#line 110 "../src/LibraryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 2770 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, library_monitor_async_discovery_completed_data_free);
#line 110 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 110 "../src/LibraryMonitor.vala"
	_data_->self = _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_async_discovery_completed_co (_data_);
#line 2780 "LibraryMonitor.c"
}

static void
library_monitor_async_discovery_completed_finish (LibraryMonitor* self,
                                                  GAsyncResult* _res_)
{
	LibraryMonitorAsyncDiscoveryCompletedData* _data_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2790 "LibraryMonitor.c"
}

static gboolean
_library_monitor_async_discovery_completed_co_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_async_discovery_completed_co (self);
#line 392 "../src/LibraryMonitor.vala"
	return result;
#line 2800 "LibraryMonitor.c"
}

static gboolean
library_monitor_async_discovery_completed_co (LibraryMonitorAsyncDiscoveryCompletedData* _data_)
{
#line 340 "../src/LibraryMonitor.vala"
	switch (_data_->_state_) {
#line 340 "../src/LibraryMonitor.vala"
		case 0:
#line 2810 "LibraryMonitor.c"
		goto _state_0;
#line 340 "../src/LibraryMonitor.vala"
		case 1:
#line 2814 "LibraryMonitor.c"
		goto _state_1;
		default:
#line 340 "../src/LibraryMonitor.vala"
		g_assert_not_reached ();
#line 2819 "LibraryMonitor.c"
	}
	_state_0:
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->unknown_files;
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp0_);
#line 345 "../src/LibraryMonitor.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 345 "../src/LibraryMonitor.vala"
	if (_data_->_tmp2_ == 0) {
#line 346 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (_data_->self);
#line 348 "../src/LibraryMonitor.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 348 "../src/LibraryMonitor.vala"
		if (_data_->_state_ != 0) {
#line 348 "../src/LibraryMonitor.vala"
			while (!_data_->_task_complete_) {
#line 348 "../src/LibraryMonitor.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2840 "LibraryMonitor.c"
			}
		}
#line 348 "../src/LibraryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 348 "../src/LibraryMonitor.vala"
		return FALSE;
#line 2847 "LibraryMonitor.c"
	}
#line 351 "../src/LibraryMonitor.vala"
	_data_->_tmp3_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 351 "../src/LibraryMonitor.vala"
	_data_->all_candidates = _data_->_tmp3_;
#line 352 "../src/LibraryMonitor.vala"
	_data_->_tmp4_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 352 "../src/LibraryMonitor.vala"
	_data_->adopted = _data_->_tmp4_;
#line 2857 "LibraryMonitor.c"
	{
#line 353 "../src/LibraryMonitor.vala"
		_data_->_tmp5_ = _data_->self->priv->unknown_files;
#line 353 "../src/LibraryMonitor.vala"
		_data_->_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp5_);
#line 353 "../src/LibraryMonitor.vala"
		_data_->_file_it = _data_->_tmp6_;
#line 353 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp7_ = _data_->_file_it;
#line 353 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_data_->_tmp7_)) {
#line 353 "../src/LibraryMonitor.vala"
				break;
#line 2873 "LibraryMonitor.c"
			}
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp8_ = _data_->_file_it;
#line 353 "../src/LibraryMonitor.vala"
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 353 "../src/LibraryMonitor.vala"
			_data_->file = (GFile*) _data_->_tmp9_;
#line 354 "../src/LibraryMonitor.vala"
			_data_->_tmp10_ = _data_->file;
#line 354 "../src/LibraryMonitor.vala"
			_data_->_tmp11_ = directory_monitor_get_file_info ((DirectoryMonitor*) _data_->self, _data_->_tmp10_);
#line 354 "../src/LibraryMonitor.vala"
			_data_->info = _data_->_tmp11_;
#line 355 "../src/LibraryMonitor.vala"
			_data_->_tmp12_ = _data_->info;
#line 355 "../src/LibraryMonitor.vala"
			if (_data_->_tmp12_ == NULL) {
#line 356 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 356 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 356 "../src/LibraryMonitor.vala"
				continue;
#line 2897 "LibraryMonitor.c"
			}
#line 359 "../src/LibraryMonitor.vala"
			_data_->_tmp13_ = _data_->all_candidates;
#line 359 "../src/LibraryMonitor.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _data_->_tmp13_);
#line 361 "../src/LibraryMonitor.vala"
			_data_->candidates = NULL;
#line 362 "../src/LibraryMonitor.vala"
			_data_->associated = FALSE;
#line 2907 "LibraryMonitor.c"
			{
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp14_ = _data_->self->priv->monitors;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp15_ = _g_object_ref0 (_data_->_tmp14_);
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_list = _data_->_tmp15_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp16_ = _data_->_monitor_list;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp17_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp16_);
#line 363 "../src/LibraryMonitor.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_size = _data_->_tmp18_;
#line 363 "../src/LibraryMonitor.vala"
				_data_->_monitor_index = -1;
#line 363 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 363 "../src/LibraryMonitor.vala"
					_data_->_monitor_index = _data_->_monitor_index + 1;
#line 363 "../src/LibraryMonitor.vala"
					if (!(_data_->_monitor_index < _data_->_monitor_size)) {
#line 363 "../src/LibraryMonitor.vala"
						break;
#line 2933 "LibraryMonitor.c"
					}
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp19_ = _data_->_monitor_list;
#line 363 "../src/LibraryMonitor.vala"
					_data_->_tmp20_ = gee_list_get (_data_->_tmp19_, _data_->_monitor_index);
#line 363 "../src/LibraryMonitor.vala"
					_data_->monitor = (MediaMonitor*) _data_->_tmp20_;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp21_ = _data_->monitor;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp22_ = _data_->file;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp23_ = _data_->info;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp24_ = 0;
#line 365 "../src/LibraryMonitor.vala"
					_data_->_tmp25_ = media_monitor_candidates_for_unknown_file (_data_->_tmp21_, _data_->_tmp22_, _data_->_tmp23_, &_data_->_tmp24_);
#line 365 "../src/LibraryMonitor.vala"
					_data_->_result_ = _data_->_tmp24_;
#line 365 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->candidates);
#line 365 "../src/LibraryMonitor.vala"
					_data_->candidates = _data_->_tmp25_;
#line 366 "../src/LibraryMonitor.vala"
					_data_->_tmp27_ = _data_->_result_;
#line 366 "../src/LibraryMonitor.vala"
					if (_data_->_tmp27_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 366 "../src/LibraryMonitor.vala"
						_data_->_tmp26_ = TRUE;
#line 2963 "LibraryMonitor.c"
					} else {
#line 367 "../src/LibraryMonitor.vala"
						_data_->_tmp28_ = _data_->_result_;
#line 367 "../src/LibraryMonitor.vala"
						_data_->_tmp26_ = _data_->_tmp28_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 2969 "LibraryMonitor.c"
					}
#line 366 "../src/LibraryMonitor.vala"
					if (_data_->_tmp26_) {
#line 368 "../src/LibraryMonitor.vala"
						_data_->associated = TRUE;
#line 370 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->monitor);
#line 370 "../src/LibraryMonitor.vala"
						break;
#line 2979 "LibraryMonitor.c"
					} else {
#line 371 "../src/LibraryMonitor.vala"
						_data_->_tmp29_ = _data_->candidates;
#line 371 "../src/LibraryMonitor.vala"
						if (_data_->_tmp29_ != NULL) {
#line 372 "../src/LibraryMonitor.vala"
							_data_->_tmp30_ = _data_->all_candidates;
#line 372 "../src/LibraryMonitor.vala"
							_data_->_tmp31_ = _data_->candidates;
#line 372 "../src/LibraryMonitor.vala"
							gee_array_list_add_all (_data_->_tmp30_, _data_->_tmp31_);
#line 2991 "LibraryMonitor.c"
						}
					}
#line 363 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->monitor);
#line 2996 "LibraryMonitor.c"
				}
#line 363 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->_monitor_list);
#line 3000 "LibraryMonitor.c"
			}
#line 376 "../src/LibraryMonitor.vala"
			if (_data_->associated) {
#line 377 "../src/LibraryMonitor.vala"
				_data_->_tmp32_ = _data_->adopted;
#line 377 "../src/LibraryMonitor.vala"
				_data_->_tmp33_ = _data_->file;
#line 377 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp32_, _data_->_tmp33_);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->candidates);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 379 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 379 "../src/LibraryMonitor.vala"
				continue;
#line 3018 "LibraryMonitor.c"
			}
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp34_ = _data_->all_candidates;
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp34_);
#line 383 "../src/LibraryMonitor.vala"
			_data_->_tmp36_ = _data_->_tmp35_;
#line 383 "../src/LibraryMonitor.vala"
			if (_data_->_tmp36_ > 0) {
#line 385 "../src/LibraryMonitor.vala"
				_data_->_tmp37_ = _data_->all_candidates;
#line 385 "../src/LibraryMonitor.vala"
				_data_->_tmp38_ = _g_object_ref0 (_data_->_tmp37_);
#line 385 "../src/LibraryMonitor.vala"
				_data_->job_candidates = _data_->_tmp38_;
#line 386 "../src/LibraryMonitor.vala"
				_data_->_tmp39_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 386 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->all_candidates);
#line 386 "../src/LibraryMonitor.vala"
				_data_->all_candidates = _data_->_tmp39_;
#line 388 "../src/LibraryMonitor.vala"
				_data_->_tmp40_ = _data_->self->priv->checksums_total;
#line 388 "../src/LibraryMonitor.vala"
				_data_->self->priv->checksums_total = _data_->_tmp40_ + 1;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp41_ = _data_->self->priv->workers;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp42_ = _data_->file;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp43_ = _data_->job_candidates;
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp44_ = library_monitor_find_move_job_new (_data_->self, _data_->_tmp42_, (GeeCollection*) _data_->_tmp43_);
#line 389 "../src/LibraryMonitor.vala"
				_data_->_tmp45_ = _data_->_tmp44_;
#line 389 "../src/LibraryMonitor.vala"
				workers_enqueue (_data_->_tmp41_, (BackgroundJob*) _data_->_tmp45_);
#line 389 "../src/LibraryMonitor.vala"
				_background_job_unref0 (_data_->_tmp45_);
#line 383 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->job_candidates);
#line 3060 "LibraryMonitor.c"
			}
#line 392 "../src/LibraryMonitor.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _library_monitor_async_discovery_completed_co_gsource_func, _data_, NULL);
#line 393 "../src/LibraryMonitor.vala"
			_data_->_state_ = 1;
#line 393 "../src/LibraryMonitor.vala"
			return FALSE;
#line 3068 "LibraryMonitor.c"
			_state_1:
			;
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->candidates);
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->info);
#line 353 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_data_->file);
#line 3077 "LibraryMonitor.c"
		}
#line 353 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_data_->_file_it);
#line 3081 "LibraryMonitor.c"
	}
#line 397 "../src/LibraryMonitor.vala"
	_data_->_tmp46_ = _data_->self->priv->unknown_files;
#line 397 "../src/LibraryMonitor.vala"
	_data_->_tmp47_ = _data_->adopted;
#line 397 "../src/LibraryMonitor.vala"
	gee_collection_remove_all ((GeeCollection*) _data_->_tmp46_, (GeeCollection*) _data_->_tmp47_);
#line 399 "../src/LibraryMonitor.vala"
	_data_->self->priv->checksums_completed = 0;
#line 401 "../src/LibraryMonitor.vala"
	if (_data_->self->priv->checksums_total == 0) {
#line 402 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (_data_->self);
#line 3095 "LibraryMonitor.c"
	} else {
#line 404 "../src/LibraryMonitor.vala"
		_data_->_tmp48_ = g_strdup_printf ("%d checksum jobs initiated to verify unknown photo files", _data_->self->priv->checksums_total);
#line 404 "../src/LibraryMonitor.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 404 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_data_->_tmp49_);
#line 404 "../src/LibraryMonitor.vala"
		_g_free0 (_data_->_tmp49_);
#line 405 "../src/LibraryMonitor.vala"
		g_signal_emit (_data_->self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, _data_->self->priv->checksums_completed, _data_->self->priv->checksums_total);
#line 3107 "LibraryMonitor.c"
	}
#line 340 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->adopted);
#line 340 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->all_candidates);
#line 340 "../src/LibraryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 340 "../src/LibraryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 340 "../src/LibraryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 340 "../src/LibraryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3121 "LibraryMonitor.c"
		}
	}
#line 340 "../src/LibraryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 340 "../src/LibraryMonitor.vala"
	return FALSE;
#line 3128 "LibraryMonitor.c"
}

static void
library_monitor_report_checksum_job_completed (LibraryMonitor* self)
{
	gint _tmp0_;
#line 409 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/LibraryMonitor.vala"
	_vala_assert (self->priv->checksums_completed < self->priv->checksums_total, "checksums_completed < checksums_total");
#line 411 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->checksums_completed;
#line 411 "../src/LibraryMonitor.vala"
	self->priv->checksums_completed = _tmp0_ + 1;
#line 413 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, self->priv->checksums_completed, self->priv->checksums_total);
#line 415 "../src/LibraryMonitor.vala"
	if (self->priv->checksums_completed == self->priv->checksums_total) {
#line 416 "../src/LibraryMonitor.vala"
		library_monitor_discovery_stage_completed (self);
#line 3149 "LibraryMonitor.c"
	}
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 420 "../src/LibraryMonitor.vala"
	return self ? background_job_ref (self) : NULL;
#line 3158 "LibraryMonitor.c"
}

static void
library_monitor_on_find_move_completed (LibraryMonitor* self,
                                        BackgroundJob* j)
{
	LibraryMonitorFindMoveJob* job = NULL;
	LibraryMonitorFindMoveJob* _tmp0_;
	LibraryMonitorFindMoveJob* _tmp1_;
	Monitorable* _tmp2_;
	LibraryMonitorFindMoveJob* _tmp27_;
	GError* _tmp28_;
#line 419 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 420 "../src/LibraryMonitor.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob));
#line 420 "../src/LibraryMonitor.vala"
	job = _tmp0_;
#line 425 "../src/LibraryMonitor.vala"
	_tmp1_ = job;
#line 425 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_->match;
#line 425 "../src/LibraryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 3185 "LibraryMonitor.c"
		LibraryMonitorFindMoveJob* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		LibraryMonitorFindMoveJob* _tmp7_;
		Monitorable* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		MediaMonitor* monitor = NULL;
		LibraryMonitorFindMoveJob* _tmp13_;
		Monitorable* _tmp14_;
		MediaMonitor* _tmp15_;
		MediaMonitor* _tmp16_;
		LibraryMonitorFindMoveJob* _tmp17_;
		Monitorable* _tmp18_;
		LibraryMonitorFindMoveJob* _tmp19_;
		GFile* _tmp20_;
		GeeHashSet* _tmp21_;
		LibraryMonitorFindMoveJob* _tmp22_;
		GFile* _tmp23_;
		MediaMonitor* _tmp24_;
		LibraryMonitorFindMoveJob* _tmp25_;
		Monitorable* _tmp26_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp3_ = job;
#line 426 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_->file;
#line 426 "../src/LibraryMonitor.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp7_ = job;
#line 426 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_->match;
#line 426 "../src/LibraryMonitor.vala"
		_tmp9_ = data_object_to_string ((DataObject*) _tmp8_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 426 "../src/LibraryMonitor.vala"
		_tmp11_ = g_strdup_printf ("Found moved master file: %s matches %s", _tmp6_, _tmp10_);
#line 426 "../src/LibraryMonitor.vala"
		_tmp12_ = _tmp11_;
#line 426 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp12_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp12_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp10_);
#line 426 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 429 "../src/LibraryMonitor.vala"
		_tmp13_ = job;
#line 429 "../src/LibraryMonitor.vala"
		_tmp14_ = _tmp13_->match;
#line 429 "../src/LibraryMonitor.vala"
		_tmp15_ = library_monitor_get_monitor_for_monitorable (self, _tmp14_);
#line 429 "../src/LibraryMonitor.vala"
		monitor = _tmp15_;
#line 430 "../src/LibraryMonitor.vala"
		_tmp16_ = monitor;
#line 430 "../src/LibraryMonitor.vala"
		_tmp17_ = job;
#line 430 "../src/LibraryMonitor.vala"
		_tmp18_ = _tmp17_->match;
#line 430 "../src/LibraryMonitor.vala"
		_tmp19_ = job;
#line 430 "../src/LibraryMonitor.vala"
		_tmp20_ = _tmp19_->file;
#line 430 "../src/LibraryMonitor.vala"
		media_monitor_update_master_file (_tmp16_, _tmp18_, _tmp20_);
#line 431 "../src/LibraryMonitor.vala"
		_tmp21_ = self->priv->unknown_files;
#line 431 "../src/LibraryMonitor.vala"
		_tmp22_ = job;
#line 431 "../src/LibraryMonitor.vala"
		_tmp23_ = _tmp22_->file;
#line 431 "../src/LibraryMonitor.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp21_, _tmp23_);
#line 432 "../src/LibraryMonitor.vala"
		_tmp24_ = monitor;
#line 432 "../src/LibraryMonitor.vala"
		_tmp25_ = job;
#line 432 "../src/LibraryMonitor.vala"
		_tmp26_ = _tmp25_->match;
#line 432 "../src/LibraryMonitor.vala"
		library_monitor_add_to_discovered_list (self, _tmp24_, _tmp26_);
#line 425 "../src/LibraryMonitor.vala"
		_g_object_unref0 (monitor);
#line 3277 "LibraryMonitor.c"
	}
#line 435 "../src/LibraryMonitor.vala"
	_tmp27_ = job;
#line 435 "../src/LibraryMonitor.vala"
	_tmp28_ = _tmp27_->err;
#line 435 "../src/LibraryMonitor.vala"
	if (_tmp28_ != NULL) {
#line 3285 "LibraryMonitor.c"
		LibraryMonitorFindMoveJob* _tmp29_;
		GFile* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		LibraryMonitorFindMoveJob* _tmp33_;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 436 "../src/LibraryMonitor.vala"
		_tmp29_ = job;
#line 436 "../src/LibraryMonitor.vala"
		_tmp30_ = _tmp29_->file;
#line 436 "../src/LibraryMonitor.vala"
		_tmp31_ = g_file_get_path (_tmp30_);
#line 436 "../src/LibraryMonitor.vala"
		_tmp32_ = _tmp31_;
#line 436 "../src/LibraryMonitor.vala"
		_tmp33_ = job;
#line 436 "../src/LibraryMonitor.vala"
		_tmp34_ = _tmp33_->err;
#line 436 "../src/LibraryMonitor.vala"
		_tmp35_ = _tmp34_->message;
#line 436 "../src/LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:436: Unable to checksum unknown media file %s: %s", _tmp32_, _tmp35_);
#line 436 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp32_);
#line 3311 "LibraryMonitor.c"
	}
#line 438 "../src/LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 419 "../src/LibraryMonitor.vala"
	_background_job_unref0 (job);
#line 3317 "LibraryMonitor.c"
}

static void
library_monitor_on_find_move_cancelled (LibraryMonitor* self,
                                        BackgroundJob* j)
{
#line 441 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 441 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 442 "../src/LibraryMonitor.vala"
	library_monitor_report_checksum_job_completed (self);
#line 3330 "LibraryMonitor.c"
}

static void
library_monitor_discovery_stage_completed (LibraryMonitor* self)
{
	TombstoneSourceCollection* _tmp57_;
	GCancellable* _tmp58_;
#line 445 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 3340 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 446 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 446 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 446 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 446 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 446 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 446 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 446 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 446 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 446 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 3368 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			GeeSet* monitorables = NULL;
			GeeHashMap* _tmp7_;
			MediaMonitor* _tmp8_;
			gpointer _tmp9_;
			GeeSet* _tmp10_;
#line 446 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 446 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 446 "../src/LibraryMonitor.vala"
				break;
#line 3383 "LibraryMonitor.c"
			}
#line 446 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 446 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 446 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 447 "../src/LibraryMonitor.vala"
			_tmp7_ = self->priv->discovered;
#line 447 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 447 "../src/LibraryMonitor.vala"
			_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
#line 447 "../src/LibraryMonitor.vala"
			monitorables = (GeeSet*) _tmp9_;
#line 448 "../src/LibraryMonitor.vala"
			_tmp10_ = monitorables;
#line 448 "../src/LibraryMonitor.vala"
			if (_tmp10_ != NULL) {
#line 3403 "LibraryMonitor.c"
				{
					GeeIterator* _monitorable_it = NULL;
					GeeSet* _tmp11_;
					GeeIterator* _tmp12_;
#line 449 "../src/LibraryMonitor.vala"
					_tmp11_ = monitorables;
#line 449 "../src/LibraryMonitor.vala"
					_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 449 "../src/LibraryMonitor.vala"
					_monitorable_it = _tmp12_;
#line 449 "../src/LibraryMonitor.vala"
					while (TRUE) {
#line 3416 "LibraryMonitor.c"
						GeeIterator* _tmp13_;
						Monitorable* monitorable = NULL;
						GeeIterator* _tmp14_;
						gpointer _tmp15_;
						Monitorable* _tmp16_;
						MediaMonitor* _tmp17_;
#line 449 "../src/LibraryMonitor.vala"
						_tmp13_ = _monitorable_it;
#line 449 "../src/LibraryMonitor.vala"
						if (!gee_iterator_next (_tmp13_)) {
#line 449 "../src/LibraryMonitor.vala"
							break;
#line 3429 "LibraryMonitor.c"
						}
#line 449 "../src/LibraryMonitor.vala"
						_tmp14_ = _monitorable_it;
#line 449 "../src/LibraryMonitor.vala"
						_tmp15_ = gee_iterator_get (_tmp14_);
#line 449 "../src/LibraryMonitor.vala"
						monitorable = (Monitorable*) _tmp15_;
#line 450 "../src/LibraryMonitor.vala"
						_tmp16_ = monitorable;
#line 450 "../src/LibraryMonitor.vala"
						_tmp17_ = monitor;
#line 450 "../src/LibraryMonitor.vala"
						library_monitor_enqueue_verify_monitorable (self, _tmp16_, _tmp17_);
#line 449 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 3445 "LibraryMonitor.c"
					}
#line 449 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_monitorable_it);
#line 3449 "LibraryMonitor.c"
				}
			}
			{
				GeeIterator* _object_it = NULL;
				MediaMonitor* _tmp18_;
				MediaSourceCollection* _tmp19_;
				MediaSourceCollection* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
				GeeIterator* _tmp24_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp18_ = monitor;
#line 453 "../src/LibraryMonitor.vala"
				_tmp19_ = media_monitor_get_media_source_collection (_tmp18_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp20_ = _tmp19_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp21_ = data_collection_get_all ((DataCollection*) _tmp20_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp22_ = _tmp21_;
#line 453 "../src/LibraryMonitor.vala"
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 453 "../src/LibraryMonitor.vala"
				_tmp24_ = _tmp23_;
#line 453 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_tmp22_);
#line 453 "../src/LibraryMonitor.vala"
				_data_collection_unref0 (_tmp20_);
#line 453 "../src/LibraryMonitor.vala"
				_object_it = _tmp24_;
#line 453 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 3483 "LibraryMonitor.c"
					GeeIterator* _tmp25_;
					DataObject* object = NULL;
					GeeIterator* _tmp26_;
					gpointer _tmp27_;
					Monitorable* monitorable = NULL;
					DataObject* _tmp28_;
					Monitorable* _tmp29_;
					gboolean _tmp30_ = FALSE;
					GeeSet* _tmp31_;
					Monitorable* _tmp34_;
					MediaMonitor* _tmp35_;
#line 453 "../src/LibraryMonitor.vala"
					_tmp25_ = _object_it;
#line 453 "../src/LibraryMonitor.vala"
					if (!gee_iterator_next (_tmp25_)) {
#line 453 "../src/LibraryMonitor.vala"
						break;
#line 3501 "LibraryMonitor.c"
					}
#line 453 "../src/LibraryMonitor.vala"
					_tmp26_ = _object_it;
#line 453 "../src/LibraryMonitor.vala"
					_tmp27_ = gee_iterator_get (_tmp26_);
#line 453 "../src/LibraryMonitor.vala"
					object = (DataObject*) _tmp27_;
#line 454 "../src/LibraryMonitor.vala"
					_tmp28_ = object;
#line 454 "../src/LibraryMonitor.vala"
					_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MONITORABLE, Monitorable));
#line 454 "../src/LibraryMonitor.vala"
					monitorable = _tmp29_;
#line 456 "../src/LibraryMonitor.vala"
					_tmp31_ = monitorables;
#line 456 "../src/LibraryMonitor.vala"
					if (_tmp31_ != NULL) {
#line 3519 "LibraryMonitor.c"
						GeeSet* _tmp32_;
						Monitorable* _tmp33_;
#line 456 "../src/LibraryMonitor.vala"
						_tmp32_ = monitorables;
#line 456 "../src/LibraryMonitor.vala"
						_tmp33_ = monitorable;
#line 456 "../src/LibraryMonitor.vala"
						_tmp30_ = gee_collection_contains ((GeeCollection*) _tmp32_, _tmp33_);
#line 3528 "LibraryMonitor.c"
					} else {
#line 456 "../src/LibraryMonitor.vala"
						_tmp30_ = FALSE;
#line 3532 "LibraryMonitor.c"
					}
#line 456 "../src/LibraryMonitor.vala"
					if (_tmp30_) {
#line 457 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 457 "../src/LibraryMonitor.vala"
						_g_object_unref0 (object);
#line 457 "../src/LibraryMonitor.vala"
						continue;
#line 3542 "LibraryMonitor.c"
					}
#line 459 "../src/LibraryMonitor.vala"
					_tmp34_ = monitorable;
#line 459 "../src/LibraryMonitor.vala"
					_tmp35_ = monitor;
#line 459 "../src/LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, _tmp34_, _tmp35_);
#line 453 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitorable);
#line 453 "../src/LibraryMonitor.vala"
					_g_object_unref0 (object);
#line 3554 "LibraryMonitor.c"
				}
#line 453 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_object_it);
#line 3558 "LibraryMonitor.c"
			}
			{
				GeeIterator* _source_it = NULL;
				MediaMonitor* _tmp36_;
				MediaSourceCollection* _tmp37_;
				MediaSourceCollection* _tmp38_;
				MediaSourceHoldingTank* _tmp39_;
				MediaSourceHoldingTank* _tmp40_;
				GeeCollection* _tmp41_;
				GeeCollection* _tmp42_;
				GeeIterator* _tmp43_;
				GeeIterator* _tmp44_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp36_ = monitor;
#line 462 "../src/LibraryMonitor.vala"
				_tmp37_ = media_monitor_get_media_source_collection (_tmp36_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp38_ = _tmp37_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp39_ = media_source_collection_get_offline_bin (_tmp38_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp40_ = _tmp39_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp41_ = source_holding_tank_get_all ((SourceHoldingTank*) _tmp40_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp42_ = _tmp41_;
#line 462 "../src/LibraryMonitor.vala"
				_tmp43_ = gee_iterable_iterator ((GeeIterable*) _tmp42_);
#line 462 "../src/LibraryMonitor.vala"
				_tmp44_ = _tmp43_;
#line 462 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_tmp42_);
#line 462 "../src/LibraryMonitor.vala"
				_source_holding_tank_unref0 (_tmp40_);
#line 462 "../src/LibraryMonitor.vala"
				_data_collection_unref0 (_tmp38_);
#line 462 "../src/LibraryMonitor.vala"
				_source_it = _tmp44_;
#line 462 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 3599 "LibraryMonitor.c"
					GeeIterator* _tmp45_;
					DataSource* source = NULL;
					GeeIterator* _tmp46_;
					gpointer _tmp47_;
					Monitorable* monitorable = NULL;
					DataSource* _tmp48_;
					Monitorable* _tmp49_;
					gboolean _tmp50_ = FALSE;
					GeeSet* _tmp51_;
					Monitorable* _tmp54_;
					MediaMonitor* _tmp55_;
#line 462 "../src/LibraryMonitor.vala"
					_tmp45_ = _source_it;
#line 462 "../src/LibraryMonitor.vala"
					if (!gee_iterator_next (_tmp45_)) {
#line 462 "../src/LibraryMonitor.vala"
						break;
#line 3617 "LibraryMonitor.c"
					}
#line 462 "../src/LibraryMonitor.vala"
					_tmp46_ = _source_it;
#line 462 "../src/LibraryMonitor.vala"
					_tmp47_ = gee_iterator_get (_tmp46_);
#line 462 "../src/LibraryMonitor.vala"
					source = (DataSource*) _tmp47_;
#line 464 "../src/LibraryMonitor.vala"
					_tmp48_ = source;
#line 464 "../src/LibraryMonitor.vala"
					_tmp49_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_MONITORABLE, Monitorable));
#line 464 "../src/LibraryMonitor.vala"
					monitorable = _tmp49_;
#line 466 "../src/LibraryMonitor.vala"
					_tmp51_ = monitorables;
#line 466 "../src/LibraryMonitor.vala"
					if (_tmp51_ != NULL) {
#line 3635 "LibraryMonitor.c"
						GeeSet* _tmp52_;
						Monitorable* _tmp53_;
#line 466 "../src/LibraryMonitor.vala"
						_tmp52_ = monitorables;
#line 466 "../src/LibraryMonitor.vala"
						_tmp53_ = monitorable;
#line 466 "../src/LibraryMonitor.vala"
						_tmp50_ = gee_collection_contains ((GeeCollection*) _tmp52_, _tmp53_);
#line 3644 "LibraryMonitor.c"
					} else {
#line 466 "../src/LibraryMonitor.vala"
						_tmp50_ = FALSE;
#line 3648 "LibraryMonitor.c"
					}
#line 466 "../src/LibraryMonitor.vala"
					if (_tmp50_) {
#line 467 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitorable);
#line 467 "../src/LibraryMonitor.vala"
						_g_object_unref0 (source);
#line 467 "../src/LibraryMonitor.vala"
						continue;
#line 3658 "LibraryMonitor.c"
					}
#line 469 "../src/LibraryMonitor.vala"
					_tmp54_ = monitorable;
#line 469 "../src/LibraryMonitor.vala"
					_tmp55_ = monitor;
#line 469 "../src/LibraryMonitor.vala"
					library_monitor_enqueue_verify_monitorable (self, _tmp54_, _tmp55_);
#line 462 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitorable);
#line 462 "../src/LibraryMonitor.vala"
					_g_object_unref0 (source);
#line 3670 "LibraryMonitor.c"
				}
#line 462 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_source_it);
#line 3674 "LibraryMonitor.c"
			}
#line 446 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitorables);
#line 446 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3680 "LibraryMonitor.c"
		}
#line 446 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 3684 "LibraryMonitor.c"
	}
#line 474 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 3688 "LibraryMonitor.c"
		GeeHashSet* _tmp56_;
#line 475 "../src/LibraryMonitor.vala"
		_tmp56_ = self->priv->unknown_files;
#line 475 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, (GeeCollection*) _tmp56_);
#line 3694 "LibraryMonitor.c"
	}
#line 478 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 478 "../src/LibraryMonitor.vala"
	self->priv->discovered = NULL;
#line 479 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 479 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = NULL;
#line 483 "../src/LibraryMonitor.vala"
	_tmp57_ = tombstone_global;
#line 483 "../src/LibraryMonitor.vala"
	_tmp58_ = self->priv->cancellable;
#line 483 "../src/LibraryMonitor.vala"
	tombstone_source_collection_launch_scan (_tmp57_, (DirectoryMonitor*) self, _tmp58_);
#line 486 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->discovery_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor));
#line 3712 "LibraryMonitor.c"
}

static void
library_monitor_enqueue_verify_monitorable (LibraryMonitor* self,
                                            Monitorable* monitorable,
                                            MediaMonitor* monitor)
{
	gboolean offered = FALSE;
	GeeQueue* _tmp0_;
	LibraryMonitorVerifyJob* _tmp1_;
	LibraryMonitorVerifyJob* _tmp2_;
	gboolean _tmp3_;
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitorable != NULL);
#line 489 "../src/LibraryMonitor.vala"
	g_return_if_fail (monitor != NULL);
#line 490 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->verify_queue;
#line 490 "../src/LibraryMonitor.vala"
	_tmp1_ = library_monitor_verify_job_new (monitorable, monitor);
#line 490 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/LibraryMonitor.vala"
	_tmp3_ = gee_queue_offer (_tmp0_, _tmp2_);
#line 490 "../src/LibraryMonitor.vala"
	_library_monitor_verify_job_unref0 (_tmp2_);
#line 490 "../src/LibraryMonitor.vala"
	offered = _tmp3_;
#line 491 "../src/LibraryMonitor.vala"
	_vala_assert (offered, "offered");
#line 493 "../src/LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (self);
#line 3747 "LibraryMonitor.c"
}

static void
library_monitor_execute_next_verify_job (LibraryMonitor* self)
{
	gboolean _tmp0_ = FALSE;
	LibraryMonitorVerifyJob* job = NULL;
	GeeQueue* _tmp4_;
	gpointer _tmp5_;
	LibraryMonitorVerifyJob* _tmp6_;
	gint _tmp7_;
	LibraryMonitorVerifyJob* _tmp8_;
	Monitorable* _tmp9_;
	LibraryMonitorVerifyJob* _tmp10_;
	MediaMonitor* _tmp11_;
#line 496 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 497 "../src/LibraryMonitor.vala"
	if (self->priv->outstanding_verify_jobs >= LIBRARY_MONITOR_MAX_VERIFY_EXISTING_MEDIA_JOBS) {
#line 497 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 3769 "LibraryMonitor.c"
	} else {
		GeeQueue* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 497 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->verify_queue;
#line 497 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 497 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 497 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp3_ == 0;
#line 3782 "LibraryMonitor.c"
	}
#line 497 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 498 "../src/LibraryMonitor.vala"
		return;
#line 3788 "LibraryMonitor.c"
	}
#line 500 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->verify_queue;
#line 500 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_queue_poll (_tmp4_);
#line 500 "../src/LibraryMonitor.vala"
	job = (LibraryMonitorVerifyJob*) _tmp5_;
#line 501 "../src/LibraryMonitor.vala"
	_tmp6_ = job;
#line 501 "../src/LibraryMonitor.vala"
	_vala_assert (_tmp6_ != NULL, "job != null");
#line 503 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->outstanding_verify_jobs;
#line 503 "../src/LibraryMonitor.vala"
	self->priv->outstanding_verify_jobs = _tmp7_ + 1;
#line 504 "../src/LibraryMonitor.vala"
	_tmp8_ = job;
#line 504 "../src/LibraryMonitor.vala"
	_tmp9_ = _tmp8_->monitorable;
#line 504 "../src/LibraryMonitor.vala"
	_tmp10_ = job;
#line 504 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_->monitor;
#line 504 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable (self, _tmp9_, _tmp11_, NULL, NULL);
#line 496 "../src/LibraryMonitor.vala"
	_library_monitor_verify_job_unref0 (job);
#line 3816 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_data_free (gpointer _data)
{
	LibraryMonitorVerifyMonitorableData* _data_;
	_data_ = _data;
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitor);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 110 "../src/LibraryMonitor.vala"
	g_slice_free (LibraryMonitorVerifyMonitorableData, _data_);
#line 3832 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	LibraryMonitorVerifyMonitorableData* _task_data_;
#line 110 "../src/LibraryMonitor.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 110 "../src/LibraryMonitor.vala"
	if (_task_data_->_callback_ != NULL) {
#line 110 "../src/LibraryMonitor.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3847 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3851 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable (LibraryMonitor* self,
                                    Monitorable* monitorable,
                                    MediaMonitor* monitor,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
	LibraryMonitor* _tmp0_;
	Monitorable* _tmp1_;
	MediaMonitor* _tmp2_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_slice_new0 (LibraryMonitorVerifyMonitorableData);
#line 110 "../src/LibraryMonitor.vala"
	_data_->_callback_ = _callback_;
#line 110 "../src/LibraryMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, library_monitor_verify_monitorable_async_ready_wrapper, _user_data_);
#line 110 "../src/LibraryMonitor.vala"
	if (_callback_ == NULL) {
#line 110 "../src/LibraryMonitor.vala"
		_data_->_task_complete_ = TRUE;
#line 3875 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, library_monitor_verify_monitorable_data_free);
#line 110 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 110 "../src/LibraryMonitor.vala"
	_data_->self = _tmp0_;
#line 110 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitorable);
#line 110 "../src/LibraryMonitor.vala"
	_data_->monitorable = _tmp1_;
#line 110 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (monitor);
#line 110 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->monitor);
#line 110 "../src/LibraryMonitor.vala"
	_data_->monitor = _tmp2_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable_co (_data_);
#line 3897 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_finish (LibraryMonitor* self,
                                           GAsyncResult* _res_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
#line 110 "../src/LibraryMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3907 "LibraryMonitor.c"
}

static void
_vala_array_add3 (GFile** * array,
                  int* length,
                  int* size,
                  GFile* value)
{
#line 514 "../src/LibraryMonitor.vala"
	if ((*length) == (*size)) {
#line 514 "../src/LibraryMonitor.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 514 "../src/LibraryMonitor.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 3922 "LibraryMonitor.c"
	}
#line 514 "../src/LibraryMonitor.vala"
	(*array)[(*length)++] = value;
#line 514 "../src/LibraryMonitor.vala"
	(*array)[*length] = NULL;
#line 3928 "LibraryMonitor.c"
}

static void
library_monitor_verify_monitorable_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	LibraryMonitorVerifyMonitorableData* _data_;
#line 523 "../src/LibraryMonitor.vala"
	_data_ = _user_data_;
#line 523 "../src/LibraryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 523 "../src/LibraryMonitor.vala"
	_data_->_res_ = _res_;
#line 523 "../src/LibraryMonitor.vala"
	_data_->_task_complete_ = TRUE;
#line 523 "../src/LibraryMonitor.vala"
	library_monitor_verify_monitorable_co (_data_);
#line 3947 "LibraryMonitor.c"
}

static gboolean
_library_monitor_verify_monitorable_co_gsource_func (gpointer self)
{
	gboolean result;
	result = library_monitor_verify_monitorable_co (self);
#line 544 "../src/LibraryMonitor.vala"
	return result;
#line 3957 "LibraryMonitor.c"
}

static gboolean
library_monitor_verify_monitorable_co (LibraryMonitorVerifyMonitorableData* _data_)
{
#line 507 "../src/LibraryMonitor.vala"
	switch (_data_->_state_) {
#line 507 "../src/LibraryMonitor.vala"
		case 0:
#line 3967 "LibraryMonitor.c"
		goto _state_0;
#line 507 "../src/LibraryMonitor.vala"
		case 1:
#line 3971 "LibraryMonitor.c"
		goto _state_1;
#line 507 "../src/LibraryMonitor.vala"
		case 2:
#line 3975 "LibraryMonitor.c"
		goto _state_2;
		default:
#line 507 "../src/LibraryMonitor.vala"
		g_assert_not_reached ();
#line 3980 "LibraryMonitor.c"
	}
	_state_0:
#line 508 "../src/LibraryMonitor.vala"
	_data_->_tmp0_ = g_new0 (GFile*, 1 + 1);
#line 508 "../src/LibraryMonitor.vala"
	_data_->files = _data_->_tmp0_;
#line 508 "../src/LibraryMonitor.vala"
	_data_->files_length1 = 1;
#line 508 "../src/LibraryMonitor.vala"
	_data_->_files_size_ = _data_->files_length1;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1_ = _data_->files;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1__length1 = _data_->files_length1;
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp2_ = media_monitor_get_master_file (_data_->monitor, _data_->monitorable);
#line 509 "../src/LibraryMonitor.vala"
	_g_object_unref0 (_data_->_tmp1_[0]);
#line 509 "../src/LibraryMonitor.vala"
	_data_->_tmp1_[0] = _data_->_tmp2_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_tmp3_ = 0;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_tmp4_ = media_monitor_get_auxilliary_backing_files (_data_->monitor, _data_->monitorable, &_data_->_tmp3_);
#line 511 "../src/LibraryMonitor.vala"
	_data_->aux_files = _data_->_tmp4_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->aux_files_length1 = _data_->_tmp3_;
#line 511 "../src/LibraryMonitor.vala"
	_data_->_aux_files_size_ = _data_->aux_files_length1;
#line 512 "../src/LibraryMonitor.vala"
	_data_->_tmp5_ = _data_->aux_files;
#line 512 "../src/LibraryMonitor.vala"
	_data_->_tmp5__length1 = _data_->aux_files_length1;
#line 512 "../src/LibraryMonitor.vala"
	if (_data_->_tmp5_ != NULL) {
#line 513 "../src/LibraryMonitor.vala"
		_data_->_tmp6_ = _data_->aux_files;
#line 513 "../src/LibraryMonitor.vala"
		_data_->_tmp6__length1 = _data_->aux_files_length1;
#line 4021 "LibraryMonitor.c"
		{
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection_length1 = 0;
#line 513 "../src/LibraryMonitor.vala"
			_data_->_aux_file_collection_size_ = 0;
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection = _data_->_tmp6_;
#line 513 "../src/LibraryMonitor.vala"
			_data_->aux_file_collection_length1 = _data_->_tmp6__length1;
#line 513 "../src/LibraryMonitor.vala"
			for (_data_->aux_file_it = 0; _data_->aux_file_it < _data_->_tmp6__length1; _data_->aux_file_it = _data_->aux_file_it + 1) {
#line 513 "../src/LibraryMonitor.vala"
				_data_->_tmp7_ = _g_object_ref0 (_data_->aux_file_collection[_data_->aux_file_it]);
#line 513 "../src/LibraryMonitor.vala"
				_data_->aux_file = _data_->_tmp7_;
#line 4037 "LibraryMonitor.c"
				{
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp8_ = _data_->files;
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp8__length1 = _data_->files_length1;
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp9_ = _data_->aux_file;
#line 514 "../src/LibraryMonitor.vala"
					_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp9_);
#line 514 "../src/LibraryMonitor.vala"
					_vala_array_add3 (&_data_->files, &_data_->files_length1, &_data_->_files_size_, _data_->_tmp10_);
#line 513 "../src/LibraryMonitor.vala"
					_g_object_unref0 (_data_->aux_file);
#line 4051 "LibraryMonitor.c"
				}
			}
		}
	}
	{
#line 517 "../src/LibraryMonitor.vala"
		_data_->ctr = 0;
#line 4059 "LibraryMonitor.c"
		{
#line 517 "../src/LibraryMonitor.vala"
			_data_->_tmp11_ = TRUE;
#line 517 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 517 "../src/LibraryMonitor.vala"
				if (!_data_->_tmp11_) {
#line 517 "../src/LibraryMonitor.vala"
					_data_->_tmp12_ = _data_->ctr;
#line 517 "../src/LibraryMonitor.vala"
					_data_->ctr = _data_->_tmp12_ + 1;
#line 4071 "LibraryMonitor.c"
				}
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp11_ = FALSE;
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp13_ = _data_->files;
#line 517 "../src/LibraryMonitor.vala"
				_data_->_tmp13__length1 = _data_->files_length1;
#line 517 "../src/LibraryMonitor.vala"
				if (!(_data_->ctr < _data_->_tmp13__length1)) {
#line 517 "../src/LibraryMonitor.vala"
					break;
#line 4083 "LibraryMonitor.c"
				}
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp14_ = _data_->files;
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp14__length1 = _data_->files_length1;
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp15_ = _data_->_tmp14_[_data_->ctr];
#line 518 "../src/LibraryMonitor.vala"
				_data_->_tmp16_ = _g_object_ref0 (_data_->_tmp15_);
#line 518 "../src/LibraryMonitor.vala"
				_data_->file = _data_->_tmp16_;
#line 520 "../src/LibraryMonitor.vala"
				_data_->_tmp17_ = _data_->file;
#line 520 "../src/LibraryMonitor.vala"
				_data_->_tmp18_ = directory_monitor_get_file_info ((DirectoryMonitor*) _data_->self, _data_->_tmp17_);
#line 520 "../src/LibraryMonitor.vala"
				_data_->info = _data_->_tmp18_;
#line 521 "../src/LibraryMonitor.vala"
				_data_->_tmp19_ = _data_->info;
#line 521 "../src/LibraryMonitor.vala"
				if (_data_->_tmp19_ == NULL) {
#line 4105 "LibraryMonitor.c"
					{
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp21_ = _data_->file;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp22_ = _data_->self->priv->cancellable;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_state_ = 1;
#line 523 "../src/LibraryMonitor.vala"
						g_file_query_info_async (_data_->_tmp21_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_FILE_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp22_, library_monitor_verify_monitorable_ready, _data_);
#line 523 "../src/LibraryMonitor.vala"
						return FALSE;
#line 4117 "LibraryMonitor.c"
						_state_1:
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp23_ = g_file_query_info_finish (_data_->_tmp21_, _data_->_res_, &_data_->_inner_error0_);
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp20_ = _data_->_tmp23_;
#line 523 "../src/LibraryMonitor.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4125 "LibraryMonitor.c"
							goto __catch52_g_error;
						}
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp24_ = _data_->_tmp20_;
#line 523 "../src/LibraryMonitor.vala"
						_data_->_tmp20_ = NULL;
#line 523 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->info);
#line 523 "../src/LibraryMonitor.vala"
						_data_->info = _data_->_tmp24_;
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->_tmp20_);
#line 4138 "LibraryMonitor.c"
					}
					goto __finally52;
					__catch52_g_error:
					{
#line 522 "../src/LibraryMonitor.vala"
						_data_->err = _data_->_inner_error0_;
#line 522 "../src/LibraryMonitor.vala"
						_data_->_inner_error0_ = NULL;
#line 522 "../src/LibraryMonitor.vala"
						_g_error_free0 (_data_->err);
#line 4149 "LibraryMonitor.c"
					}
					__finally52:
#line 522 "../src/LibraryMonitor.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->info);
#line 522 "../src/LibraryMonitor.vala"
						_g_object_unref0 (_data_->file);
#line 522 "../src/LibraryMonitor.vala"
						_data_->aux_files = (_vala_array_free (_data_->aux_files, _data_->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 522 "../src/LibraryMonitor.vala"
						_data_->files = (_vala_array_free (_data_->files, _data_->files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 522 "../src/LibraryMonitor.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 522 "../src/LibraryMonitor.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 522 "../src/LibraryMonitor.vala"
						g_object_unref (_data_->_async_result);
#line 522 "../src/LibraryMonitor.vala"
						return FALSE;
#line 4170 "LibraryMonitor.c"
					}
				}
#line 531 "../src/LibraryMonitor.vala"
				if (_data_->ctr == 0) {
#line 532 "../src/LibraryMonitor.vala"
					_data_->_tmp26_ = _data_->info;
#line 532 "../src/LibraryMonitor.vala"
					if (_data_->_tmp26_ != NULL) {
#line 532 "../src/LibraryMonitor.vala"
						_data_->_tmp25_ = media_monitor_is_offline (_data_->monitor, _data_->monitorable);
#line 4181 "LibraryMonitor.c"
					} else {
#line 532 "../src/LibraryMonitor.vala"
						_data_->_tmp25_ = FALSE;
#line 4185 "LibraryMonitor.c"
					}
#line 532 "../src/LibraryMonitor.vala"
					if (_data_->_tmp25_) {
#line 533 "../src/LibraryMonitor.vala"
						media_monitor_update_online (_data_->monitor, _data_->monitorable);
#line 4191 "LibraryMonitor.c"
					} else {
#line 534 "../src/LibraryMonitor.vala"
						_data_->_tmp28_ = _data_->info;
#line 534 "../src/LibraryMonitor.vala"
						if (_data_->_tmp28_ == NULL) {
#line 534 "../src/LibraryMonitor.vala"
							_data_->_tmp27_ = !media_monitor_is_offline (_data_->monitor, _data_->monitorable);
#line 4199 "LibraryMonitor.c"
						} else {
#line 534 "../src/LibraryMonitor.vala"
							_data_->_tmp27_ = FALSE;
#line 4203 "LibraryMonitor.c"
						}
#line 534 "../src/LibraryMonitor.vala"
						if (_data_->_tmp27_) {
#line 535 "../src/LibraryMonitor.vala"
							media_monitor_update_offline (_data_->monitor, _data_->monitorable);
#line 4209 "LibraryMonitor.c"
						}
					}
				}
#line 538 "../src/LibraryMonitor.vala"
				_data_->_tmp29_ = _data_->file;
#line 538 "../src/LibraryMonitor.vala"
				_data_->_tmp30_ = _data_->info;
#line 538 "../src/LibraryMonitor.vala"
				media_monitor_update_backing_file_info (_data_->monitor, _data_->monitorable, _data_->_tmp29_, _data_->_tmp30_);
#line 517 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->info);
#line 517 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_data_->file);
#line 4223 "LibraryMonitor.c"
			}
		}
	}
#line 541 "../src/LibraryMonitor.vala"
	_data_->_tmp31_ = _data_->self->priv->completed_monitorable_verifies;
#line 541 "../src/LibraryMonitor.vala"
	_data_->self->priv->completed_monitorable_verifies = _data_->_tmp31_ + 1;
#line 542 "../src/LibraryMonitor.vala"
	g_signal_emit (_data_->self, library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL], 0, _data_->self->priv->completed_monitorable_verifies, _data_->self->priv->total_monitorable_verifies);
#line 544 "../src/LibraryMonitor.vala"
	g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _library_monitor_verify_monitorable_co_gsource_func, _data_, NULL);
#line 545 "../src/LibraryMonitor.vala"
	_data_->_state_ = 2;
#line 545 "../src/LibraryMonitor.vala"
	return FALSE;
#line 4239 "LibraryMonitor.c"
	_state_2:
	;
#line 548 "../src/LibraryMonitor.vala"
	_vala_assert (_data_->self->priv->outstanding_verify_jobs > 0, "outstanding_verify_jobs > 0");
#line 549 "../src/LibraryMonitor.vala"
	_data_->_tmp32_ = _data_->self->priv->outstanding_verify_jobs;
#line 549 "../src/LibraryMonitor.vala"
	_data_->self->priv->outstanding_verify_jobs = _data_->_tmp32_ - 1;
#line 551 "../src/LibraryMonitor.vala"
	library_monitor_execute_next_verify_job (_data_->self);
#line 507 "../src/LibraryMonitor.vala"
	_data_->aux_files = (_vala_array_free (_data_->aux_files, _data_->aux_files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 507 "../src/LibraryMonitor.vala"
	_data_->files = (_vala_array_free (_data_->files, _data_->files_length1, (GDestroyNotify) g_object_unref), NULL);
#line 507 "../src/LibraryMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 507 "../src/LibraryMonitor.vala"
	if (_data_->_state_ != 0) {
#line 507 "../src/LibraryMonitor.vala"
		while (!_data_->_task_complete_) {
#line 507 "../src/LibraryMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4262 "LibraryMonitor.c"
		}
	}
#line 507 "../src/LibraryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 507 "../src/LibraryMonitor.vala"
	return FALSE;
#line 4269 "LibraryMonitor.c"
}

static void
library_monitor_on_config_changed (LibraryMonitor* self,
                                   const gchar* key)
{
	gboolean value = FALSE;
	GSettings* _tmp0_;
#line 554 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/LibraryMonitor.vala"
	g_return_if_fail (key != NULL);
#line 555 "../src/LibraryMonitor.vala"
	if (g_strcmp0 (key, "auto-import") != 0) {
#line 556 "../src/LibraryMonitor.vala"
		return;
#line 4286 "LibraryMonitor.c"
	}
#line 559 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->file_settings;
#line 559 "../src/LibraryMonitor.vala"
	value = g_settings_get_boolean (_tmp0_, "auto-import");
#line 561 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import == value) {
#line 562 "../src/LibraryMonitor.vala"
		return;
#line 4296 "LibraryMonitor.c"
	}
#line 564 "../src/LibraryMonitor.vala"
	self->priv->auto_import = value;
#line 565 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 566 "../src/LibraryMonitor.vala"
		if (!commandline_options_no_runtime_monitoring) {
#line 567 "../src/LibraryMonitor.vala"
			library_monitor_import_unrepresented_files (self);
#line 4306 "LibraryMonitor.c"
		}
	} else {
#line 569 "../src/LibraryMonitor.vala"
		library_monitor_cancel_batch_imports (self);
#line 4311 "LibraryMonitor.c"
	}
}

static void
library_monitor_enqueue_import (LibraryMonitor* self,
                                GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GeeHashSet* _tmp2_;
#line 573 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 574 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->pending_imports;
#line 574 "../src/LibraryMonitor.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, file)) {
#line 574 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 4332 "LibraryMonitor.c"
	} else {
#line 574 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 4336 "LibraryMonitor.c"
	}
#line 574 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 574 "../src/LibraryMonitor.vala"
		_tmp0_ = !library_monitor_is_blacklisted (file);
#line 4342 "LibraryMonitor.c"
	} else {
#line 574 "../src/LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 4346 "LibraryMonitor.c"
	}
#line 574 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 4350 "LibraryMonitor.c"
		GeeHashSet* _tmp3_;
#line 575 "../src/LibraryMonitor.vala"
		_tmp3_ = self->priv->import_queue;
#line 575 "../src/LibraryMonitor.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, file);
#line 4356 "LibraryMonitor.c"
	}
}

static void
library_monitor_enqueue_import_many (LibraryMonitor* self,
                                     GeeCollection* files)
{
#line 578 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/LibraryMonitor.vala"
	g_return_if_fail (files != NULL);
#line 4368 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp0_;
#line 579 "../src/LibraryMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) files);
#line 579 "../src/LibraryMonitor.vala"
		_file_it = _tmp0_;
#line 579 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 4378 "LibraryMonitor.c"
			GeeIterator* _tmp1_;
			GFile* file = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GFile* _tmp4_;
#line 579 "../src/LibraryMonitor.vala"
			_tmp1_ = _file_it;
#line 579 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 579 "../src/LibraryMonitor.vala"
				break;
#line 4390 "LibraryMonitor.c"
			}
#line 579 "../src/LibraryMonitor.vala"
			_tmp2_ = _file_it;
#line 579 "../src/LibraryMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 579 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp3_;
#line 580 "../src/LibraryMonitor.vala"
			_tmp4_ = file;
#line 580 "../src/LibraryMonitor.vala"
			library_monitor_enqueue_import (self, _tmp4_);
#line 579 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 4404 "LibraryMonitor.c"
		}
#line 579 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 4408 "LibraryMonitor.c"
	}
}

static void
library_monitor_remove_queued_import (LibraryMonitor* self,
                                      GFile* file)
{
	GeeHashSet* _tmp0_;
#line 583 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 584 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->import_queue;
#line 584 "../src/LibraryMonitor.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, file);
#line 4425 "LibraryMonitor.c"
}

static gboolean
library_monitor_on_flush_import_queue (LibraryMonitor* self)
{
	gboolean result = FALSE;
	GCancellable* _tmp0_;
	GeeHashSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	BatchImport* _tmp4_;
	GeeHashSet* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	time_t now = 0;
	gboolean _tmp10_ = FALSE;
	BatchImportRoll* _tmp11_;
	GeeArrayList* jobs = NULL;
	GeeArrayList* _tmp13_;
	GeeHashSet* _tmp26_;
	BatchImport* importer = NULL;
	GeeArrayList* _tmp27_;
	BatchImportRoll* _tmp28_;
	BatchImport* _tmp29_;
	BatchImport* _tmp30_;
	BatchImport* _tmp31_;
	GeeArrayList* _tmp32_;
	BatchImport* _tmp33_;
#line 587 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 588 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 588 "../src/LibraryMonitor.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 589 "../src/LibraryMonitor.vala"
		result = FALSE;
#line 589 "../src/LibraryMonitor.vala"
		return result;
#line 4466 "LibraryMonitor.c"
	}
#line 591 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->import_queue;
#line 591 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 591 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 591 "../src/LibraryMonitor.vala"
	if (_tmp3_ == 0) {
#line 592 "../src/LibraryMonitor.vala"
		result = TRUE;
#line 592 "../src/LibraryMonitor.vala"
		return result;
#line 4480 "LibraryMonitor.c"
	}
#line 596 "../src/LibraryMonitor.vala"
	_tmp4_ = self->priv->current_batch_import;
#line 596 "../src/LibraryMonitor.vala"
	if (_tmp4_ != NULL) {
#line 597 "../src/LibraryMonitor.vala"
		result = TRUE;
#line 597 "../src/LibraryMonitor.vala"
		return result;
#line 4490 "LibraryMonitor.c"
	}
#line 599 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->import_queue;
#line 599 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 599 "../src/LibraryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 599 "../src/LibraryMonitor.vala"
	_tmp8_ = g_strdup_printf ("Auto-importing %d files", _tmp7_);
#line 599 "../src/LibraryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 599 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp9_);
#line 599 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp9_);
#line 604 "../src/LibraryMonitor.vala"
	now = (time_t) now_sec ();
#line 605 "../src/LibraryMonitor.vala"
	_tmp11_ = self->priv->current_import_roll;
#line 605 "../src/LibraryMonitor.vala"
	if (_tmp11_ == NULL) {
#line 605 "../src/LibraryMonitor.vala"
		_tmp10_ = TRUE;
#line 4514 "LibraryMonitor.c"
	} else {
#line 605 "../src/LibraryMonitor.vala"
		_tmp10_ = (now - self->priv->last_import_roll_use) >= ((time_t) LIBRARY_MONITOR_IMPORT_ROLL_QUIET_SEC);
#line 4518 "LibraryMonitor.c"
	}
#line 605 "../src/LibraryMonitor.vala"
	if (_tmp10_) {
#line 4522 "LibraryMonitor.c"
		BatchImportRoll* _tmp12_;
#line 606 "../src/LibraryMonitor.vala"
		_tmp12_ = batch_import_roll_new ();
#line 606 "../src/LibraryMonitor.vala"
		_batch_import_roll_unref0 (self->priv->current_import_roll);
#line 606 "../src/LibraryMonitor.vala"
		self->priv->current_import_roll = _tmp12_;
#line 4530 "LibraryMonitor.c"
	}
#line 607 "../src/LibraryMonitor.vala"
	self->priv->last_import_roll_use = now;
#line 609 "../src/LibraryMonitor.vala"
	_tmp13_ = gee_array_list_new (TYPE_BATCH_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, (GDestroyNotify) batch_import_job_unref, NULL, NULL, NULL);
#line 609 "../src/LibraryMonitor.vala"
	jobs = _tmp13_;
#line 4538 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeHashSet* _tmp14_;
		GeeIterator* _tmp15_;
#line 610 "../src/LibraryMonitor.vala"
		_tmp14_ = self->priv->import_queue;
#line 610 "../src/LibraryMonitor.vala"
		_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 610 "../src/LibraryMonitor.vala"
		_file_it = _tmp15_;
#line 610 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 4551 "LibraryMonitor.c"
			GeeIterator* _tmp16_;
			GFile* file = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			GFile* _tmp19_;
			GeeArrayList* _tmp20_;
			GFile* _tmp21_;
			FileImportJob* _tmp22_;
			FileImportJob* _tmp23_;
			GeeHashSet* _tmp24_;
			GFile* _tmp25_;
#line 610 "../src/LibraryMonitor.vala"
			_tmp16_ = _file_it;
#line 610 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp16_)) {
#line 610 "../src/LibraryMonitor.vala"
				break;
#line 4569 "LibraryMonitor.c"
			}
#line 610 "../src/LibraryMonitor.vala"
			_tmp17_ = _file_it;
#line 610 "../src/LibraryMonitor.vala"
			_tmp18_ = gee_iterator_get (_tmp17_);
#line 610 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp18_;
#line 611 "../src/LibraryMonitor.vala"
			_tmp19_ = file;
#line 611 "../src/LibraryMonitor.vala"
			if (library_monitor_is_blacklisted (_tmp19_)) {
#line 612 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 612 "../src/LibraryMonitor.vala"
				continue;
#line 4585 "LibraryMonitor.c"
			}
#line 614 "../src/LibraryMonitor.vala"
			_tmp20_ = jobs;
#line 614 "../src/LibraryMonitor.vala"
			_tmp21_ = file;
#line 614 "../src/LibraryMonitor.vala"
			_tmp22_ = file_import_job_new (_tmp21_, FALSE);
#line 614 "../src/LibraryMonitor.vala"
			_tmp23_ = _tmp22_;
#line 614 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, (BatchImportJob*) _tmp23_);
#line 614 "../src/LibraryMonitor.vala"
			_batch_import_job_unref0 (_tmp23_);
#line 615 "../src/LibraryMonitor.vala"
			_tmp24_ = self->priv->pending_imports;
#line 615 "../src/LibraryMonitor.vala"
			_tmp25_ = file;
#line 615 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 610 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 4607 "LibraryMonitor.c"
		}
#line 610 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 4611 "LibraryMonitor.c"
	}
#line 618 "../src/LibraryMonitor.vala"
	_tmp26_ = self->priv->import_queue;
#line 618 "../src/LibraryMonitor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp26_);
#line 620 "../src/LibraryMonitor.vala"
	_tmp27_ = jobs;
#line 620 "../src/LibraryMonitor.vala"
	_tmp28_ = self->priv->current_import_roll;
#line 620 "../src/LibraryMonitor.vala"
	_tmp29_ = batch_import_new ((GeeIterable*) _tmp27_, "LibraryMonitor autoimport", NULL, NULL, NULL, NULL, NULL, _tmp28_, NULL);
#line 620 "../src/LibraryMonitor.vala"
	importer = _tmp29_;
#line 622 "../src/LibraryMonitor.vala"
	_tmp30_ = importer;
#line 622 "../src/LibraryMonitor.vala"
	batch_import_set_untrash_duplicates (_tmp30_, FALSE);
#line 623 "../src/LibraryMonitor.vala"
	_tmp31_ = importer;
#line 623 "../src/LibraryMonitor.vala"
	batch_import_set_mark_duplicates_online (_tmp31_, FALSE);
#line 624 "../src/LibraryMonitor.vala"
	_tmp32_ = self->priv->batch_import_queue;
#line 624 "../src/LibraryMonitor.vala"
	_tmp33_ = importer;
#line 624 "../src/LibraryMonitor.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 626 "../src/LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 628 "../src/LibraryMonitor.vala"
	result = TRUE;
#line 628 "../src/LibraryMonitor.vala"
	_g_object_unref0 (importer);
#line 628 "../src/LibraryMonitor.vala"
	_g_object_unref0 (jobs);
#line 628 "../src/LibraryMonitor.vala"
	return result;
#line 4649 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_preparing_batch_import_preparing (BatchImport* _sender,
                                                             gpointer self)
{
#line 636 "../src/LibraryMonitor.vala"
	library_monitor_on_import_preparing ((LibraryMonitor*) self);
#line 4658 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_progress_batch_import_progress (BatchImport* _sender,
                                                           guint64 completed_bytes,
                                                           guint64 total_bytes,
                                                           gpointer self)
{
#line 637 "../src/LibraryMonitor.vala"
	library_monitor_on_import_progress ((LibraryMonitor*) self, completed_bytes, total_bytes);
#line 4669 "LibraryMonitor.c"
}

static void
_library_monitor_on_import_complete_batch_import_import_complete (BatchImport* _sender,
                                                                  ImportManifest* manifest,
                                                                  BatchImportRoll* import_roll,
                                                                  gpointer self)
{
#line 638 "../src/LibraryMonitor.vala"
	library_monitor_on_import_complete ((LibraryMonitor*) self, _sender, manifest, import_roll);
#line 4680 "LibraryMonitor.c"
}

static void
library_monitor_schedule_next_batch_import (LibraryMonitor* self)
{
	gboolean _tmp0_ = FALSE;
	BatchImport* _tmp1_;
	GeeArrayList* _tmp5_;
	gpointer _tmp6_;
	BatchImport* _tmp7_;
	BatchImport* _tmp8_;
	BatchImport* _tmp9_;
	BatchImport* _tmp10_;
#line 631 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 632 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->current_batch_import;
#line 632 "../src/LibraryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 632 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 4702 "LibraryMonitor.c"
	} else {
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 632 "../src/LibraryMonitor.vala"
		_tmp2_ = self->priv->batch_import_queue;
#line 632 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 632 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 632 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp4_ == 0;
#line 4715 "LibraryMonitor.c"
	}
#line 632 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 633 "../src/LibraryMonitor.vala"
		return;
#line 4721 "LibraryMonitor.c"
	}
#line 635 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->batch_import_queue;
#line 635 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, 0);
#line 635 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 635 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = (BatchImport*) _tmp6_;
#line 636 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->current_batch_import;
#line 636 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp7_, "preparing", (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self, 0);
#line 637 "../src/LibraryMonitor.vala"
	_tmp8_ = self->priv->current_batch_import;
#line 637 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp8_, "progress", (GCallback) _library_monitor_on_import_progress_batch_import_progress, self, 0);
#line 638 "../src/LibraryMonitor.vala"
	_tmp9_ = self->priv->current_batch_import;
#line 638 "../src/LibraryMonitor.vala"
	g_signal_connect_object (_tmp9_, "import-complete", (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self, 0);
#line 639 "../src/LibraryMonitor.vala"
	_tmp10_ = self->priv->current_batch_import;
#line 639 "../src/LibraryMonitor.vala"
	batch_import_schedule (_tmp10_);
#line 4747 "LibraryMonitor.c"
}

static void
library_monitor_discard_current_batch_import (LibraryMonitor* self)
{
	BatchImport* _tmp0_;
	gboolean removed = FALSE;
	GeeArrayList* _tmp1_;
	BatchImport* _tmp2_;
	BatchImport* _tmp3_;
	guint _tmp4_;
	BatchImport* _tmp5_;
	guint _tmp6_;
	BatchImport* _tmp7_;
	guint _tmp8_;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 642 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 643 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->current_batch_import;
#line 643 "../src/LibraryMonitor.vala"
	_vala_assert (_tmp0_ != NULL, "current_batch_import != null");
#line 645 "../src/LibraryMonitor.vala"
	_tmp1_ = self->priv->batch_import_queue;
#line 645 "../src/LibraryMonitor.vala"
	_tmp2_ = self->priv->current_batch_import;
#line 645 "../src/LibraryMonitor.vala"
	removed = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _tmp2_);
#line 646 "../src/LibraryMonitor.vala"
	_vala_assert (removed, "removed");
#line 647 "../src/LibraryMonitor.vala"
	_tmp3_ = self->priv->current_batch_import;
#line 647 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("preparing", TYPE_BATCH_IMPORT, &_tmp4_, NULL, FALSE);
#line 647 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _library_monitor_on_import_preparing_batch_import_preparing, self);
#line 648 "../src/LibraryMonitor.vala"
	_tmp5_ = self->priv->current_batch_import;
#line 648 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("progress", TYPE_BATCH_IMPORT, &_tmp6_, NULL, FALSE);
#line 648 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _library_monitor_on_import_progress_batch_import_progress, self);
#line 649 "../src/LibraryMonitor.vala"
	_tmp7_ = self->priv->current_batch_import;
#line 649 "../src/LibraryMonitor.vala"
	g_signal_parse_name ("import-complete", TYPE_BATCH_IMPORT, &_tmp8_, NULL, FALSE);
#line 649 "../src/LibraryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _library_monitor_on_import_complete_batch_import_import_complete, self);
#line 650 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 650 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = NULL;
#line 657 "../src/LibraryMonitor.vala"
	_tmp9_ = self->priv->batch_import_queue;
#line 657 "../src/LibraryMonitor.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 657 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_;
#line 657 "../src/LibraryMonitor.vala"
	if (_tmp11_ == 0) {
#line 4810 "LibraryMonitor.c"
		GeeHashSet* _tmp12_;
#line 658 "../src/LibraryMonitor.vala"
		_tmp12_ = self->priv->pending_imports;
#line 658 "../src/LibraryMonitor.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp12_);
#line 4816 "LibraryMonitor.c"
	}
}

static void
library_monitor_cancel_batch_imports (LibraryMonitor* self)
{
	gint ctr = 0;
	BatchImport* _tmp13_;
	GeeHashSet* _tmp15_;
#line 661 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 663 "../src/LibraryMonitor.vala"
	ctr = 0;
#line 664 "../src/LibraryMonitor.vala"
	while (TRUE) {
#line 4832 "LibraryMonitor.c"
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		GeeArrayList* _tmp3_;
		gpointer _tmp4_;
		BatchImport* _tmp5_;
		BatchImport* _tmp6_;
		gboolean _tmp7_;
		GeeArrayList* _tmp9_;
		GeeArrayList* _tmp10_;
		gpointer _tmp11_;
		BatchImport* _tmp12_;
#line 664 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->batch_import_queue;
#line 664 "../src/LibraryMonitor.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 664 "../src/LibraryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 664 "../src/LibraryMonitor.vala"
		if (!(ctr < _tmp2_)) {
#line 664 "../src/LibraryMonitor.vala"
			break;
#line 4855 "LibraryMonitor.c"
		}
#line 665 "../src/LibraryMonitor.vala"
		_tmp3_ = self->priv->batch_import_queue;
#line 665 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, ctr);
#line 665 "../src/LibraryMonitor.vala"
		_tmp5_ = (BatchImport*) _tmp4_;
#line 665 "../src/LibraryMonitor.vala"
		_tmp6_ = self->priv->current_batch_import;
#line 665 "../src/LibraryMonitor.vala"
		_tmp7_ = _tmp5_ == _tmp6_;
#line 665 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 665 "../src/LibraryMonitor.vala"
		if (_tmp7_) {
#line 4871 "LibraryMonitor.c"
			gint _tmp8_;
#line 666 "../src/LibraryMonitor.vala"
			_tmp8_ = ctr;
#line 666 "../src/LibraryMonitor.vala"
			ctr = _tmp8_ + 1;
#line 668 "../src/LibraryMonitor.vala"
			continue;
#line 4879 "LibraryMonitor.c"
		}
#line 671 "../src/LibraryMonitor.vala"
		_tmp9_ = self->priv->batch_import_queue;
#line 671 "../src/LibraryMonitor.vala"
		_tmp10_ = self->priv->batch_import_queue;
#line 671 "../src/LibraryMonitor.vala"
		_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, ctr);
#line 671 "../src/LibraryMonitor.vala"
		_tmp12_ = (BatchImport*) _tmp11_;
#line 671 "../src/LibraryMonitor.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp12_);
#line 671 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp12_);
#line 4893 "LibraryMonitor.c"
	}
#line 675 "../src/LibraryMonitor.vala"
	_tmp13_ = self->priv->current_batch_import;
#line 675 "../src/LibraryMonitor.vala"
	if (_tmp13_ != NULL) {
#line 4899 "LibraryMonitor.c"
		BatchImport* _tmp14_;
#line 676 "../src/LibraryMonitor.vala"
		_tmp14_ = self->priv->current_batch_import;
#line 676 "../src/LibraryMonitor.vala"
		batch_import_user_halt (_tmp14_);
#line 4905 "LibraryMonitor.c"
	}
#line 679 "../src/LibraryMonitor.vala"
	_tmp15_ = self->priv->pending_imports;
#line 679 "../src/LibraryMonitor.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp15_);
#line 4911 "LibraryMonitor.c"
}

static void
library_monitor_on_import_preparing (LibraryMonitor* self)
{
#line 682 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 683 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL], 0);
#line 4921 "LibraryMonitor.c"
}

static void
library_monitor_on_import_progress (LibraryMonitor* self,
                                    guint64 completed_bytes,
                                    guint64 total_bytes)
{
#line 686 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL], 0, completed_bytes, total_bytes);
#line 4933 "LibraryMonitor.c"
}

static void
library_monitor_on_import_complete (LibraryMonitor* self,
                                    BatchImport* batch_import,
                                    ImportManifest* manifest,
                                    BatchImportRoll* import_roll)
{
	BatchImport* _tmp0_;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GeeList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GeeHashSet* _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GError* _inner_error0_ = NULL;
#line 690 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 690 "../src/LibraryMonitor.vala"
	g_return_if_fail (batch_import != NULL);
#line 690 "../src/LibraryMonitor.vala"
	g_return_if_fail (manifest != NULL);
#line 690 "../src/LibraryMonitor.vala"
	g_return_if_fail (import_roll != NULL);
#line 692 "../src/LibraryMonitor.vala"
	_tmp0_ = self->priv->current_batch_import;
#line 692 "../src/LibraryMonitor.vala"
	_vala_assert (batch_import == _tmp0_, "batch_import == current_batch_import");
#line 694 "../src/LibraryMonitor.vala"
	_tmp1_ = manifest->all;
#line 694 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 694 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 694 "../src/LibraryMonitor.vala"
	_tmp4_ = g_strdup_printf ("auto-import batch completed %d", _tmp3_);
#line 694 "../src/LibraryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 694 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp5_);
#line 694 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp5_);
#line 695 "../src/LibraryMonitor.vala"
	g_signal_emit (self, library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL], 0, (guint64) 0, (guint64) 0);
#line 4985 "LibraryMonitor.c"
	{
		GeeList* _result_list = NULL;
		GeeList* _tmp6_;
		GeeList* _tmp7_;
		gint _result_size = 0;
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _result_index = 0;
#line 697 "../src/LibraryMonitor.vala"
		_tmp6_ = manifest->all;
#line 697 "../src/LibraryMonitor.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 697 "../src/LibraryMonitor.vala"
		_result_list = _tmp7_;
#line 697 "../src/LibraryMonitor.vala"
		_tmp8_ = _result_list;
#line 697 "../src/LibraryMonitor.vala"
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 697 "../src/LibraryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 697 "../src/LibraryMonitor.vala"
		_result_size = _tmp10_;
#line 697 "../src/LibraryMonitor.vala"
		_result_index = -1;
#line 697 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5013 "LibraryMonitor.c"
			BatchImportResult* _result_ = NULL;
			GeeList* _tmp11_;
			gpointer _tmp12_;
			BatchImportResult* _tmp13_;
			GFile* _tmp14_;
#line 697 "../src/LibraryMonitor.vala"
			_result_index = _result_index + 1;
#line 697 "../src/LibraryMonitor.vala"
			if (!(_result_index < _result_size)) {
#line 697 "../src/LibraryMonitor.vala"
				break;
#line 5025 "LibraryMonitor.c"
			}
#line 697 "../src/LibraryMonitor.vala"
			_tmp11_ = _result_list;
#line 697 "../src/LibraryMonitor.vala"
			_tmp12_ = gee_list_get (_tmp11_, _result_index);
#line 697 "../src/LibraryMonitor.vala"
			_result_ = (BatchImportResult*) _tmp12_;
#line 700 "../src/LibraryMonitor.vala"
			_tmp13_ = _result_;
#line 700 "../src/LibraryMonitor.vala"
			_tmp14_ = _tmp13_->file;
#line 700 "../src/LibraryMonitor.vala"
			if (_tmp14_ != NULL) {
#line 5039 "LibraryMonitor.c"
				GeeHashSet* _tmp15_;
				BatchImportResult* _tmp16_;
				GFile* _tmp17_;
#line 701 "../src/LibraryMonitor.vala"
				_tmp15_ = self->priv->pending_imports;
#line 701 "../src/LibraryMonitor.vala"
				_tmp16_ = _result_;
#line 701 "../src/LibraryMonitor.vala"
				_tmp17_ = _tmp16_->file;
#line 701 "../src/LibraryMonitor.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp15_, _tmp17_);
#line 5051 "LibraryMonitor.c"
			}
#line 697 "../src/LibraryMonitor.vala"
			_batch_import_result_unref0 (_result_);
#line 5055 "LibraryMonitor.c"
		}
#line 697 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_result_list);
#line 5059 "LibraryMonitor.c"
	}
#line 704 "../src/LibraryMonitor.vala"
	_tmp18_ = manifest->already_imported;
#line 704 "../src/LibraryMonitor.vala"
	_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 704 "../src/LibraryMonitor.vala"
	_tmp20_ = _tmp19_;
#line 704 "../src/LibraryMonitor.vala"
	if (_tmp20_ > 0) {
#line 5069 "LibraryMonitor.c"
		GeeArrayList* to_tombstone = NULL;
		GeeArrayList* _tmp21_;
#line 705 "../src/LibraryMonitor.vala"
		_tmp21_ = gee_array_list_new (TYPE_TOMBSTONED_FILE, (GBoxedCopyFunc) tombstoned_file_ref, (GDestroyNotify) tombstoned_file_unref, NULL, NULL, NULL);
#line 705 "../src/LibraryMonitor.vala"
		to_tombstone = _tmp21_;
#line 5076 "LibraryMonitor.c"
		{
			GeeList* _result_list = NULL;
			GeeList* _tmp22_;
			GeeList* _tmp23_;
			gint _result_size = 0;
			GeeList* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gint _result_index = 0;
#line 706 "../src/LibraryMonitor.vala"
			_tmp22_ = manifest->already_imported;
#line 706 "../src/LibraryMonitor.vala"
			_tmp23_ = _g_object_ref0 (_tmp22_);
#line 706 "../src/LibraryMonitor.vala"
			_result_list = _tmp23_;
#line 706 "../src/LibraryMonitor.vala"
			_tmp24_ = _result_list;
#line 706 "../src/LibraryMonitor.vala"
			_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 706 "../src/LibraryMonitor.vala"
			_tmp26_ = _tmp25_;
#line 706 "../src/LibraryMonitor.vala"
			_result_size = _tmp26_;
#line 706 "../src/LibraryMonitor.vala"
			_result_index = -1;
#line 706 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 5104 "LibraryMonitor.c"
				BatchImportResult* _result_ = NULL;
				GeeList* _tmp27_;
				gpointer _tmp28_;
				GFileInfo* info = NULL;
				BatchImportResult* _tmp29_;
				GFile* _tmp30_;
				GFileInfo* _tmp31_;
				GFileInfo* _tmp32_;
				GeeArrayList* _tmp37_;
				BatchImportResult* _tmp38_;
				GFile* _tmp39_;
				GFileInfo* _tmp40_;
				TombstonedFile* _tmp41_;
				TombstonedFile* _tmp42_;
#line 706 "../src/LibraryMonitor.vala"
				_result_index = _result_index + 1;
#line 706 "../src/LibraryMonitor.vala"
				if (!(_result_index < _result_size)) {
#line 706 "../src/LibraryMonitor.vala"
					break;
#line 5125 "LibraryMonitor.c"
				}
#line 706 "../src/LibraryMonitor.vala"
				_tmp27_ = _result_list;
#line 706 "../src/LibraryMonitor.vala"
				_tmp28_ = gee_list_get (_tmp27_, _result_index);
#line 706 "../src/LibraryMonitor.vala"
				_result_ = (BatchImportResult*) _tmp28_;
#line 707 "../src/LibraryMonitor.vala"
				_tmp29_ = _result_;
#line 707 "../src/LibraryMonitor.vala"
				_tmp30_ = _tmp29_->file;
#line 707 "../src/LibraryMonitor.vala"
				_tmp31_ = directory_monitor_get_file_info ((DirectoryMonitor*) self, _tmp30_);
#line 707 "../src/LibraryMonitor.vala"
				info = _tmp31_;
#line 708 "../src/LibraryMonitor.vala"
				_tmp32_ = info;
#line 708 "../src/LibraryMonitor.vala"
				if (_tmp32_ == NULL) {
#line 5145 "LibraryMonitor.c"
					BatchImportResult* _tmp33_;
					GFile* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 709 "../src/LibraryMonitor.vala"
					_tmp33_ = _result_;
#line 709 "../src/LibraryMonitor.vala"
					_tmp34_ = _tmp33_->file;
#line 709 "../src/LibraryMonitor.vala"
					_tmp35_ = g_file_get_path (_tmp34_);
#line 709 "../src/LibraryMonitor.vala"
					_tmp36_ = _tmp35_;
#line 709 "../src/LibraryMonitor.vala"
					g_warning ("LibraryMonitor.vala:709: Unable to get info for duplicate file %s", _tmp36_);
#line 709 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp36_);
#line 711 "../src/LibraryMonitor.vala"
					_g_object_unref0 (info);
#line 711 "../src/LibraryMonitor.vala"
					_batch_import_result_unref0 (_result_);
#line 711 "../src/LibraryMonitor.vala"
					continue;
#line 5168 "LibraryMonitor.c"
				}
#line 714 "../src/LibraryMonitor.vala"
				_tmp37_ = to_tombstone;
#line 714 "../src/LibraryMonitor.vala"
				_tmp38_ = _result_;
#line 714 "../src/LibraryMonitor.vala"
				_tmp39_ = _tmp38_->file;
#line 714 "../src/LibraryMonitor.vala"
				_tmp40_ = info;
#line 714 "../src/LibraryMonitor.vala"
				_tmp41_ = tombstoned_file_new (_tmp39_, g_file_info_get_size (_tmp40_), NULL);
#line 714 "../src/LibraryMonitor.vala"
				_tmp42_ = _tmp41_;
#line 714 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, _tmp42_);
#line 714 "../src/LibraryMonitor.vala"
				_tombstoned_file_unref0 (_tmp42_);
#line 706 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 706 "../src/LibraryMonitor.vala"
				_batch_import_result_unref0 (_result_);
#line 5190 "LibraryMonitor.c"
			}
#line 706 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_result_list);
#line 5194 "LibraryMonitor.c"
		}
		{
			GeeArrayList* _tmp43_;
#line 718 "../src/LibraryMonitor.vala"
			_tmp43_ = to_tombstone;
#line 718 "../src/LibraryMonitor.vala"
			tombstone_entomb_many_files ((GeeCollection*) _tmp43_, TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE, &_inner_error0_);
#line 718 "../src/LibraryMonitor.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 718 "../src/LibraryMonitor.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5206 "LibraryMonitor.c"
					goto __catch53_database_error;
				}
#line 718 "../src/LibraryMonitor.vala"
				_g_object_unref0 (to_tombstone);
#line 718 "../src/LibraryMonitor.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 718 "../src/LibraryMonitor.vala"
				g_clear_error (&_inner_error0_);
#line 718 "../src/LibraryMonitor.vala"
				return;
#line 5217 "LibraryMonitor.c"
			}
		}
		goto __finally53;
		__catch53_database_error:
		{
			GError* err = NULL;
			GError* _tmp44_;
#line 717 "../src/LibraryMonitor.vala"
			err = _inner_error0_;
#line 717 "../src/LibraryMonitor.vala"
			_inner_error0_ = NULL;
#line 720 "../src/LibraryMonitor.vala"
			_tmp44_ = err;
#line 720 "../src/LibraryMonitor.vala"
			app_window_database_error (_tmp44_);
#line 717 "../src/LibraryMonitor.vala"
			_g_error_free0 (err);
#line 5235 "LibraryMonitor.c"
		}
		__finally53:
#line 717 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 717 "../src/LibraryMonitor.vala"
			_g_object_unref0 (to_tombstone);
#line 717 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 717 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 717 "../src/LibraryMonitor.vala"
			return;
#line 5248 "LibraryMonitor.c"
		}
#line 704 "../src/LibraryMonitor.vala"
		_g_object_unref0 (to_tombstone);
#line 5252 "LibraryMonitor.c"
	}
#line 724 "../src/LibraryMonitor.vala"
	_tmp45_ = self->priv->pending_imports;
#line 724 "../src/LibraryMonitor.vala"
	_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
#line 724 "../src/LibraryMonitor.vala"
	_tmp47_ = _tmp46_;
#line 724 "../src/LibraryMonitor.vala"
	_tmp48_ = g_strdup_printf ("%d files remain pending for auto-import", _tmp47_);
#line 724 "../src/LibraryMonitor.vala"
	_tmp49_ = _tmp48_;
#line 724 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp49_);
#line 724 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp49_);
#line 726 "../src/LibraryMonitor.vala"
	library_monitor_discard_current_batch_import (self);
#line 727 "../src/LibraryMonitor.vala"
	library_monitor_schedule_next_batch_import (self);
#line 5272 "LibraryMonitor.c"
}

void
library_monitor_blacklist_file (GFile* file,
                                const gchar* reason)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 743 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 743 "../src/LibraryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 744 "../src/LibraryMonitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 744 "../src/LibraryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 744 "../src/LibraryMonitor.vala"
	_tmp2_ = g_strdup_printf ("[%s] Blacklisting %s", reason, _tmp1_);
#line 744 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 744 "../src/LibraryMonitor.vala"
	directory_monitor_mdbg (_tmp3_);
#line 744 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp3_);
#line 744 "../src/LibraryMonitor.vala"
	_g_free0 (_tmp1_);
#line 5302 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp4_;
#line 745 "../src/LibraryMonitor.vala"
		_tmp4_ = library_monitor_blacklist;
#line 745 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 5309 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp5_;
#line 746 "../src/LibraryMonitor.vala"
			_tmp5_ = library_monitor_blacklist;
#line 746 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, file);
#line 5316 "LibraryMonitor.c"
		}
		__finally54:
		{
			GeeHashSet* _tmp6_;
#line 745 "../src/LibraryMonitor.vala"
			_tmp6_ = library_monitor_blacklist;
#line 745 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 5325 "LibraryMonitor.c"
		}
#line 745 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 745 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 745 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 745 "../src/LibraryMonitor.vala"
			return;
#line 5335 "LibraryMonitor.c"
		}
	}
}

void
library_monitor_unblacklist_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 750 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 5346 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
#line 753 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 753 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 5353 "LibraryMonitor.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashSet* _tmp2_;
#line 754 "../src/LibraryMonitor.vala"
			_tmp2_ = library_monitor_blacklist;
#line 754 "../src/LibraryMonitor.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, file)) {
#line 5361 "LibraryMonitor.c"
				HashTimedQueue* _tmp3_;
#line 754 "../src/LibraryMonitor.vala"
				_tmp3_ = library_monitor_to_unblacklist;
#line 754 "../src/LibraryMonitor.vala"
				_tmp1_ = !timed_queue_contains ((TimedQueue*) _tmp3_, file);
#line 5367 "LibraryMonitor.c"
			} else {
#line 754 "../src/LibraryMonitor.vala"
				_tmp1_ = FALSE;
#line 5371 "LibraryMonitor.c"
			}
#line 754 "../src/LibraryMonitor.vala"
			if (_tmp1_) {
#line 5375 "LibraryMonitor.c"
				HashTimedQueue* _tmp4_;
#line 755 "../src/LibraryMonitor.vala"
				_tmp4_ = library_monitor_to_unblacklist;
#line 755 "../src/LibraryMonitor.vala"
				timed_queue_enqueue ((TimedQueue*) _tmp4_, file);
#line 5381 "LibraryMonitor.c"
			}
		}
		__finally55:
		{
			GeeHashSet* _tmp5_;
#line 753 "../src/LibraryMonitor.vala"
			_tmp5_ = library_monitor_blacklist;
#line 753 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 5391 "LibraryMonitor.c"
		}
#line 753 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 753 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 753 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 753 "../src/LibraryMonitor.vala"
			return;
#line 5401 "LibraryMonitor.c"
		}
	}
}

static void
library_monitor_on_unblacklist_file (GFile* file)
{
	gboolean removed = FALSE;
	GError* _inner_error0_ = NULL;
#line 759 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 5413 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
#line 761 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 761 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 5420 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp1_;
#line 762 "../src/LibraryMonitor.vala"
			_tmp1_ = library_monitor_blacklist;
#line 762 "../src/LibraryMonitor.vala"
			removed = gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, file);
#line 5427 "LibraryMonitor.c"
		}
		__finally56:
		{
			GeeHashSet* _tmp2_;
#line 761 "../src/LibraryMonitor.vala"
			_tmp2_ = library_monitor_blacklist;
#line 761 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 5436 "LibraryMonitor.c"
		}
#line 761 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 761 "../src/LibraryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 761 "../src/LibraryMonitor.vala"
			g_clear_error (&_inner_error0_);
#line 761 "../src/LibraryMonitor.vala"
			return;
#line 5446 "LibraryMonitor.c"
		}
	}
#line 765 "../src/LibraryMonitor.vala"
	if (removed) {
#line 5451 "LibraryMonitor.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 766 "../src/LibraryMonitor.vala"
		_tmp3_ = g_file_get_path (file);
#line 766 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 766 "../src/LibraryMonitor.vala"
		_tmp5_ = g_strdup_printf ("Blacklist for %s removed", _tmp4_);
#line 766 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 766 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp6_);
#line 766 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 766 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp4_);
#line 5470 "LibraryMonitor.c"
	} else {
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 768 "../src/LibraryMonitor.vala"
		_tmp7_ = g_file_get_path (file);
#line 768 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_;
#line 768 "../src/LibraryMonitor.vala"
		g_warning ("LibraryMonitor.vala:768: File %s was not blacklisted but unblacklisted", _tmp8_);
#line 768 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp8_);
#line 5482 "LibraryMonitor.c"
	}
}

gboolean
library_monitor_is_blacklisted (GFile* file)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 771 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 5493 "LibraryMonitor.c"
	{
		GeeHashSet* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 772 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_blacklist;
#line 772 "../src/LibraryMonitor.vala"
		g_rec_mutex_lock (&__lock_library_monitor_library_monitor_blacklist);
#line 5501 "LibraryMonitor.c"
		{
			GeeHashSet* _tmp1_;
#line 773 "../src/LibraryMonitor.vala"
			_tmp1_ = library_monitor_blacklist;
#line 773 "../src/LibraryMonitor.vala"
			result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp1_, file);
#line 5508 "LibraryMonitor.c"
			{
				GeeHashSet* _tmp2_;
#line 772 "../src/LibraryMonitor.vala"
				_tmp2_ = library_monitor_blacklist;
#line 772 "../src/LibraryMonitor.vala"
				g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 5515 "LibraryMonitor.c"
			}
#line 773 "../src/LibraryMonitor.vala"
			return result;
#line 5519 "LibraryMonitor.c"
		}
		__finally57:
		{
			GeeHashSet* _tmp3_;
#line 772 "../src/LibraryMonitor.vala"
			_tmp3_ = library_monitor_blacklist;
#line 772 "../src/LibraryMonitor.vala"
			g_rec_mutex_unlock (&__lock_library_monitor_library_monitor_blacklist);
#line 5528 "LibraryMonitor.c"
		}
#line 772 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 772 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 772 "../src/LibraryMonitor.vala"
		return _tmp4_;
#line 5536 "LibraryMonitor.c"
	}
}

static gboolean
library_monitor_is_supported_filetype (LibraryMonitor* self,
                                       GFile* file)
{
	gboolean result = FALSE;
	MediaCollectionRegistry* _tmp0_;
	MediaCollectionRegistry* _tmp1_;
	MediaSourceCollection* _tmp2_;
	MediaSourceCollection* _tmp3_;
	gboolean _tmp4_;
#line 777 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 777 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 778 "../src/LibraryMonitor.vala"
	_tmp0_ = media_collection_registry_get_instance ();
#line 778 "../src/LibraryMonitor.vala"
	_tmp1_ = _tmp0_;
#line 778 "../src/LibraryMonitor.vala"
	_tmp2_ = media_collection_registry_get_collection_for_file (_tmp1_, file);
#line 778 "../src/LibraryMonitor.vala"
	_tmp3_ = _tmp2_;
#line 778 "../src/LibraryMonitor.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 778 "../src/LibraryMonitor.vala"
	_data_collection_unref0 (_tmp3_);
#line 778 "../src/LibraryMonitor.vala"
	_media_collection_registry_unref0 (_tmp1_);
#line 778 "../src/LibraryMonitor.vala"
	result = _tmp4_;
#line 778 "../src/LibraryMonitor.vala"
	return result;
#line 5572 "LibraryMonitor.c"
}

static void
library_monitor_import_unrepresented_files (LibraryMonitor* self)
{
	GeeArrayList* to_import = NULL;
	GeeArrayList* _tmp30_;
#line 783 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 784 "../src/LibraryMonitor.vala"
	if (!self->priv->auto_import) {
#line 785 "../src/LibraryMonitor.vala"
		return;
#line 5586 "LibraryMonitor.c"
	}
#line 787 "../src/LibraryMonitor.vala"
	to_import = NULL;
#line 5590 "LibraryMonitor.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 788 "../src/LibraryMonitor.vala"
		_tmp0_ = directory_monitor_get_files ((DirectoryMonitor*) self);
#line 788 "../src/LibraryMonitor.vala"
		_tmp1_ = _tmp0_;
#line 788 "../src/LibraryMonitor.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 788 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 788 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp1_);
#line 788 "../src/LibraryMonitor.vala"
		_file_it = _tmp3_;
#line 788 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5611 "LibraryMonitor.c"
			GeeIterator* _tmp4_;
			GFile* file = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GFileInfo* info = NULL;
			GFile* _tmp7_;
			GFileInfo* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
			GeeHashSet* _tmp12_;
			GFile* _tmp13_;
			TombstoneSourceCollection* _tmp14_;
			GFile* _tmp15_;
			gboolean represented = FALSE;
			GFile* _tmp25_;
			GeeArrayList* _tmp26_;
			GeeArrayList* _tmp28_;
			GFile* _tmp29_;
#line 788 "../src/LibraryMonitor.vala"
			_tmp4_ = _file_it;
#line 788 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 788 "../src/LibraryMonitor.vala"
				break;
#line 5636 "LibraryMonitor.c"
			}
#line 788 "../src/LibraryMonitor.vala"
			_tmp5_ = _file_it;
#line 788 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 788 "../src/LibraryMonitor.vala"
			file = (GFile*) _tmp6_;
#line 789 "../src/LibraryMonitor.vala"
			_tmp7_ = file;
#line 789 "../src/LibraryMonitor.vala"
			_tmp8_ = directory_monitor_get_file_info ((DirectoryMonitor*) self, _tmp7_);
#line 789 "../src/LibraryMonitor.vala"
			info = _tmp8_;
#line 790 "../src/LibraryMonitor.vala"
			_tmp10_ = info;
#line 790 "../src/LibraryMonitor.vala"
			if (_tmp10_ == NULL) {
#line 790 "../src/LibraryMonitor.vala"
				_tmp9_ = TRUE;
#line 5656 "LibraryMonitor.c"
			} else {
				GFileInfo* _tmp11_;
#line 790 "../src/LibraryMonitor.vala"
				_tmp11_ = info;
#line 790 "../src/LibraryMonitor.vala"
				_tmp9_ = g_file_info_get_file_type (_tmp11_) != G_FILE_TYPE_REGULAR;
#line 5663 "LibraryMonitor.c"
			}
#line 790 "../src/LibraryMonitor.vala"
			if (_tmp9_) {
#line 791 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 791 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 791 "../src/LibraryMonitor.vala"
				continue;
#line 5673 "LibraryMonitor.c"
			}
#line 793 "../src/LibraryMonitor.vala"
			_tmp12_ = self->priv->pending_imports;
#line 793 "../src/LibraryMonitor.vala"
			_tmp13_ = file;
#line 793 "../src/LibraryMonitor.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp12_, _tmp13_)) {
#line 794 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 794 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 794 "../src/LibraryMonitor.vala"
				continue;
#line 5687 "LibraryMonitor.c"
			}
#line 796 "../src/LibraryMonitor.vala"
			_tmp14_ = tombstone_global;
#line 796 "../src/LibraryMonitor.vala"
			_tmp15_ = file;
#line 796 "../src/LibraryMonitor.vala"
			if (tombstone_source_collection_matches (_tmp14_, _tmp15_)) {
#line 797 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 797 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 797 "../src/LibraryMonitor.vala"
				continue;
#line 5701 "LibraryMonitor.c"
			}
#line 799 "../src/LibraryMonitor.vala"
			represented = FALSE;
#line 5705 "LibraryMonitor.c"
			{
				GeeList* _monitor_list = NULL;
				GeeList* _tmp16_;
				GeeList* _tmp17_;
				gint _monitor_size = 0;
				GeeList* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _monitor_index = 0;
#line 800 "../src/LibraryMonitor.vala"
				_tmp16_ = self->priv->monitors;
#line 800 "../src/LibraryMonitor.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 800 "../src/LibraryMonitor.vala"
				_monitor_list = _tmp17_;
#line 800 "../src/LibraryMonitor.vala"
				_tmp18_ = _monitor_list;
#line 800 "../src/LibraryMonitor.vala"
				_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 800 "../src/LibraryMonitor.vala"
				_tmp20_ = _tmp19_;
#line 800 "../src/LibraryMonitor.vala"
				_monitor_size = _tmp20_;
#line 800 "../src/LibraryMonitor.vala"
				_monitor_index = -1;
#line 800 "../src/LibraryMonitor.vala"
				while (TRUE) {
#line 5733 "LibraryMonitor.c"
					MediaMonitor* monitor = NULL;
					GeeList* _tmp21_;
					gpointer _tmp22_;
					MediaMonitor* _tmp23_;
					GFile* _tmp24_;
#line 800 "../src/LibraryMonitor.vala"
					_monitor_index = _monitor_index + 1;
#line 800 "../src/LibraryMonitor.vala"
					if (!(_monitor_index < _monitor_size)) {
#line 800 "../src/LibraryMonitor.vala"
						break;
#line 5745 "LibraryMonitor.c"
					}
#line 800 "../src/LibraryMonitor.vala"
					_tmp21_ = _monitor_list;
#line 800 "../src/LibraryMonitor.vala"
					_tmp22_ = gee_list_get (_tmp21_, _monitor_index);
#line 800 "../src/LibraryMonitor.vala"
					monitor = (MediaMonitor*) _tmp22_;
#line 801 "../src/LibraryMonitor.vala"
					_tmp23_ = monitor;
#line 801 "../src/LibraryMonitor.vala"
					_tmp24_ = file;
#line 801 "../src/LibraryMonitor.vala"
					if (media_monitor_is_file_represented (_tmp23_, _tmp24_)) {
#line 802 "../src/LibraryMonitor.vala"
						represented = TRUE;
#line 804 "../src/LibraryMonitor.vala"
						_g_object_unref0 (monitor);
#line 804 "../src/LibraryMonitor.vala"
						break;
#line 5765 "LibraryMonitor.c"
					}
#line 800 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 5769 "LibraryMonitor.c"
				}
#line 800 "../src/LibraryMonitor.vala"
				_g_object_unref0 (_monitor_list);
#line 5773 "LibraryMonitor.c"
			}
#line 808 "../src/LibraryMonitor.vala"
			if (represented) {
#line 809 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 809 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 809 "../src/LibraryMonitor.vala"
				continue;
#line 5783 "LibraryMonitor.c"
			}
#line 811 "../src/LibraryMonitor.vala"
			_tmp25_ = file;
#line 811 "../src/LibraryMonitor.vala"
			if (!library_monitor_is_supported_filetype (self, _tmp25_)) {
#line 812 "../src/LibraryMonitor.vala"
				_g_object_unref0 (info);
#line 812 "../src/LibraryMonitor.vala"
				_g_object_unref0 (file);
#line 812 "../src/LibraryMonitor.vala"
				continue;
#line 5795 "LibraryMonitor.c"
			}
#line 814 "../src/LibraryMonitor.vala"
			_tmp26_ = to_import;
#line 814 "../src/LibraryMonitor.vala"
			if (_tmp26_ == NULL) {
#line 5801 "LibraryMonitor.c"
				GeeArrayList* _tmp27_;
#line 815 "../src/LibraryMonitor.vala"
				_tmp27_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_equal_gee_equal_data_func, NULL, NULL);
#line 815 "../src/LibraryMonitor.vala"
				_g_object_unref0 (to_import);
#line 815 "../src/LibraryMonitor.vala"
				to_import = _tmp27_;
#line 5809 "LibraryMonitor.c"
			}
#line 817 "../src/LibraryMonitor.vala"
			_tmp28_ = to_import;
#line 817 "../src/LibraryMonitor.vala"
			_tmp29_ = file;
#line 817 "../src/LibraryMonitor.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 788 "../src/LibraryMonitor.vala"
			_g_object_unref0 (info);
#line 788 "../src/LibraryMonitor.vala"
			_g_object_unref0 (file);
#line 5821 "LibraryMonitor.c"
		}
#line 788 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 5825 "LibraryMonitor.c"
	}
#line 820 "../src/LibraryMonitor.vala"
	_tmp30_ = to_import;
#line 820 "../src/LibraryMonitor.vala"
	if (_tmp30_ != NULL) {
#line 5831 "LibraryMonitor.c"
		GeeArrayList* _tmp31_;
#line 821 "../src/LibraryMonitor.vala"
		_tmp31_ = to_import;
#line 821 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import_many (self, (GeeCollection*) _tmp31_);
#line 5837 "LibraryMonitor.c"
	}
#line 783 "../src/LibraryMonitor.vala"
	_g_object_unref0 (to_import);
#line 5841 "LibraryMonitor.c"
}

static void
library_monitor_runtime_unknown_file_discovered (LibraryMonitor* self,
                                                 GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 826 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 826 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 827 "../src/LibraryMonitor.vala"
	if (self->priv->auto_import) {
#line 827 "../src/LibraryMonitor.vala"
		_tmp1_ = library_monitor_is_supported_filetype (self, file);
#line 5858 "LibraryMonitor.c"
	} else {
#line 827 "../src/LibraryMonitor.vala"
		_tmp1_ = FALSE;
#line 5862 "LibraryMonitor.c"
	}
#line 827 "../src/LibraryMonitor.vala"
	if (_tmp1_) {
#line 5866 "LibraryMonitor.c"
		TombstoneSourceCollection* _tmp2_;
#line 827 "../src/LibraryMonitor.vala"
		_tmp2_ = tombstone_global;
#line 827 "../src/LibraryMonitor.vala"
		_tmp0_ = !tombstone_source_collection_matches (_tmp2_, file);
#line 5872 "LibraryMonitor.c"
	} else {
#line 827 "../src/LibraryMonitor.vala"
		_tmp0_ = FALSE;
#line 5876 "LibraryMonitor.c"
	}
#line 827 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 5880 "LibraryMonitor.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 828 "../src/LibraryMonitor.vala"
		_tmp3_ = g_file_get_path (file);
#line 828 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 828 "../src/LibraryMonitor.vala"
		_tmp5_ = g_strdup_printf ("Unknown file %s discovered, enqueuing for import", _tmp4_);
#line 828 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 828 "../src/LibraryMonitor.vala"
		directory_monitor_mdbg (_tmp6_);
#line 828 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 828 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp4_);
#line 829 "../src/LibraryMonitor.vala"
		library_monitor_enqueue_import (self, file);
#line 5901 "LibraryMonitor.c"
	}
}

static void
library_monitor_real_notify_file_created (DirectoryMonitor* base,
                                          GFile* file,
                                          GFileInfo* info)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 833 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 833 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 833 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 834 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 835 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 837 "../src/LibraryMonitor.vala"
		return;
#line 5924 "LibraryMonitor.c"
	}
#line 840 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 5928 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 841 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 841 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 841 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 841 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 841 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 841 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 841 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 841 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 841 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 5956 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
#line 841 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 841 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 841 "../src/LibraryMonitor.vala"
				break;
#line 5967 "LibraryMonitor.c"
			}
#line 841 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 841 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 841 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 842 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 842 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_created (_tmp7_, file, info)) {
#line 843 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 845 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 845 "../src/LibraryMonitor.vala"
				break;
#line 5985 "LibraryMonitor.c"
			}
#line 841 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 5989 "LibraryMonitor.c"
		}
#line 841 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 5993 "LibraryMonitor.c"
	}
#line 849 "../src/LibraryMonitor.vala"
	if (!known) {
#line 5997 "LibraryMonitor.c"
		GeeHashSet* all_candidates = NULL;
		gboolean _tmp56_ = FALSE;
		gboolean _tmp57_ = FALSE;
#line 851 "../src/LibraryMonitor.vala"
		all_candidates = NULL;
#line 6003 "LibraryMonitor.c"
		{
			GeeList* _monitor_list = NULL;
			GeeList* _tmp8_;
			GeeList* _tmp9_;
			gint _monitor_size = 0;
			GeeList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _monitor_index = 0;
#line 852 "../src/LibraryMonitor.vala"
			_tmp8_ = self->priv->monitors;
#line 852 "../src/LibraryMonitor.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 852 "../src/LibraryMonitor.vala"
			_monitor_list = _tmp9_;
#line 852 "../src/LibraryMonitor.vala"
			_tmp10_ = _monitor_list;
#line 852 "../src/LibraryMonitor.vala"
			_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 852 "../src/LibraryMonitor.vala"
			_tmp12_ = _tmp11_;
#line 852 "../src/LibraryMonitor.vala"
			_monitor_size = _tmp12_;
#line 852 "../src/LibraryMonitor.vala"
			_monitor_index = -1;
#line 852 "../src/LibraryMonitor.vala"
			while (TRUE) {
#line 6031 "LibraryMonitor.c"
				MediaMonitor* monitor = NULL;
				GeeList* _tmp13_;
				gpointer _tmp14_;
				MediaMonitorDiscoveredFile _result_ = 0;
				GeeCollection* candidates = NULL;
				MediaMonitor* _tmp15_;
				MediaMonitorDiscoveredFile _tmp16_ = 0;
				GeeCollection* _tmp17_;
				gboolean _tmp18_ = FALSE;
				MediaMonitorDiscoveredFile _tmp19_;
#line 852 "../src/LibraryMonitor.vala"
				_monitor_index = _monitor_index + 1;
#line 852 "../src/LibraryMonitor.vala"
				if (!(_monitor_index < _monitor_size)) {
#line 852 "../src/LibraryMonitor.vala"
					break;
#line 6048 "LibraryMonitor.c"
				}
#line 852 "../src/LibraryMonitor.vala"
				_tmp13_ = _monitor_list;
#line 852 "../src/LibraryMonitor.vala"
				_tmp14_ = gee_list_get (_tmp13_, _monitor_index);
#line 852 "../src/LibraryMonitor.vala"
				monitor = (MediaMonitor*) _tmp14_;
#line 854 "../src/LibraryMonitor.vala"
				_tmp15_ = monitor;
#line 854 "../src/LibraryMonitor.vala"
				_tmp17_ = media_monitor_candidates_for_unknown_file (_tmp15_, file, info, &_tmp16_);
#line 854 "../src/LibraryMonitor.vala"
				_result_ = _tmp16_;
#line 854 "../src/LibraryMonitor.vala"
				candidates = _tmp17_;
#line 856 "../src/LibraryMonitor.vala"
				_tmp19_ = _result_;
#line 856 "../src/LibraryMonitor.vala"
				if (_tmp19_ == MEDIA_MONITOR_DISCOVERED_FILE_REPRESENTED) {
#line 856 "../src/LibraryMonitor.vala"
					_tmp18_ = TRUE;
#line 6070 "LibraryMonitor.c"
				} else {
					MediaMonitorDiscoveredFile _tmp20_;
#line 857 "../src/LibraryMonitor.vala"
					_tmp20_ = _result_;
#line 857 "../src/LibraryMonitor.vala"
					_tmp18_ = _tmp20_ == MEDIA_MONITOR_DISCOVERED_FILE_IGNORE;
#line 6077 "LibraryMonitor.c"
				}
#line 856 "../src/LibraryMonitor.vala"
				if (_tmp18_) {
#line 6081 "LibraryMonitor.c"
					MediaMonitor* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					MediaMonitorDiscoveredFile _tmp24_;
					GEnumValue* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar* _tmp29_;
#line 858 "../src/LibraryMonitor.vala"
					_tmp21_ = monitor;
#line 858 "../src/LibraryMonitor.vala"
					_tmp22_ = media_monitor_to_string (_tmp21_);
#line 858 "../src/LibraryMonitor.vala"
					_tmp23_ = _tmp22_;
#line 858 "../src/LibraryMonitor.vala"
					_tmp24_ = _result_;
#line 858 "../src/LibraryMonitor.vala"
					_tmp25_ = g_enum_get_value (g_type_class_ref (MEDIA_MONITOR_TYPE_DISCOVERED_FILE), _tmp24_);
#line 858 "../src/LibraryMonitor.vala"
					_tmp26_ = g_file_get_path (file);
#line 858 "../src/LibraryMonitor.vala"
					_tmp27_ = _tmp26_;
#line 858 "../src/LibraryMonitor.vala"
					_tmp28_ = g_strdup_printf ("%s %s created file %s", _tmp23_, (_tmp25_ != NULL) ? _tmp25_->value_name : NULL, _tmp27_);
#line 858 "../src/LibraryMonitor.vala"
					_tmp29_ = _tmp28_;
#line 858 "../src/LibraryMonitor.vala"
					directory_monitor_mdbg (_tmp29_);
#line 858 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp29_);
#line 858 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp27_);
#line 858 "../src/LibraryMonitor.vala"
					_g_free0 (_tmp23_);
#line 861 "../src/LibraryMonitor.vala"
					known = TRUE;
#line 863 "../src/LibraryMonitor.vala"
					_g_object_unref0 (candidates);
#line 863 "../src/LibraryMonitor.vala"
					_g_object_unref0 (monitor);
#line 863 "../src/LibraryMonitor.vala"
					break;
#line 6125 "LibraryMonitor.c"
				} else {
					gboolean _tmp30_ = FALSE;
					GeeCollection* _tmp31_;
#line 864 "../src/LibraryMonitor.vala"
					_tmp31_ = candidates;
#line 864 "../src/LibraryMonitor.vala"
					if (_tmp31_ != NULL) {
#line 6133 "LibraryMonitor.c"
						GeeCollection* _tmp32_;
						gint _tmp33_;
						gint _tmp34_;
#line 864 "../src/LibraryMonitor.vala"
						_tmp32_ = candidates;
#line 864 "../src/LibraryMonitor.vala"
						_tmp33_ = gee_collection_get_size (_tmp32_);
#line 864 "../src/LibraryMonitor.vala"
						_tmp34_ = _tmp33_;
#line 864 "../src/LibraryMonitor.vala"
						_tmp30_ = _tmp34_ > 0;
#line 6145 "LibraryMonitor.c"
					} else {
#line 864 "../src/LibraryMonitor.vala"
						_tmp30_ = FALSE;
#line 6149 "LibraryMonitor.c"
					}
#line 864 "../src/LibraryMonitor.vala"
					if (_tmp30_) {
#line 6153 "LibraryMonitor.c"
						MediaMonitor* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						GeeCollection* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						GeeHashSet* _tmp45_;
#line 865 "../src/LibraryMonitor.vala"
						_tmp35_ = monitor;
#line 865 "../src/LibraryMonitor.vala"
						_tmp36_ = media_monitor_to_string (_tmp35_);
#line 865 "../src/LibraryMonitor.vala"
						_tmp37_ = _tmp36_;
#line 865 "../src/LibraryMonitor.vala"
						_tmp38_ = candidates;
#line 865 "../src/LibraryMonitor.vala"
						_tmp39_ = gee_collection_get_size (_tmp38_);
#line 865 "../src/LibraryMonitor.vala"
						_tmp40_ = _tmp39_;
#line 865 "../src/LibraryMonitor.vala"
						_tmp41_ = g_file_get_path (file);
#line 865 "../src/LibraryMonitor.vala"
						_tmp42_ = _tmp41_;
#line 865 "../src/LibraryMonitor.vala"
						_tmp43_ = g_strdup_printf ("%s suggests %d candidates for created file %s", _tmp37_, _tmp40_, _tmp42_);
#line 865 "../src/LibraryMonitor.vala"
						_tmp44_ = _tmp43_;
#line 865 "../src/LibraryMonitor.vala"
						directory_monitor_mdbg (_tmp44_);
#line 865 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp44_);
#line 865 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp42_);
#line 865 "../src/LibraryMonitor.vala"
						_g_free0 (_tmp37_);
#line 868 "../src/LibraryMonitor.vala"
						_tmp45_ = all_candidates;
#line 868 "../src/LibraryMonitor.vala"
						if (_tmp45_ == NULL) {
#line 6197 "LibraryMonitor.c"
							GeeHashSet* _tmp46_;
#line 869 "../src/LibraryMonitor.vala"
							_tmp46_ = gee_hash_set_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 869 "../src/LibraryMonitor.vala"
							_g_object_unref0 (all_candidates);
#line 869 "../src/LibraryMonitor.vala"
							all_candidates = _tmp46_;
#line 6205 "LibraryMonitor.c"
						}
						{
							GeeIterator* _candidate_it = NULL;
							GeeCollection* _tmp47_;
							GeeIterator* _tmp48_;
#line 871 "../src/LibraryMonitor.vala"
							_tmp47_ = candidates;
#line 871 "../src/LibraryMonitor.vala"
							_tmp48_ = gee_iterable_iterator ((GeeIterable*) _tmp47_);
#line 871 "../src/LibraryMonitor.vala"
							_candidate_it = _tmp48_;
#line 871 "../src/LibraryMonitor.vala"
							while (TRUE) {
#line 6219 "LibraryMonitor.c"
								GeeIterator* _tmp49_;
								Monitorable* candidate = NULL;
								GeeIterator* _tmp50_;
								gpointer _tmp51_;
								MediaMonitor* _tmp52_;
								Monitorable* _tmp53_;
#line 871 "../src/LibraryMonitor.vala"
								_tmp49_ = _candidate_it;
#line 871 "../src/LibraryMonitor.vala"
								if (!gee_iterator_next (_tmp49_)) {
#line 871 "../src/LibraryMonitor.vala"
									break;
#line 6232 "LibraryMonitor.c"
								}
#line 871 "../src/LibraryMonitor.vala"
								_tmp50_ = _candidate_it;
#line 871 "../src/LibraryMonitor.vala"
								_tmp51_ = gee_iterator_get (_tmp50_);
#line 871 "../src/LibraryMonitor.vala"
								candidate = (Monitorable*) _tmp51_;
#line 872 "../src/LibraryMonitor.vala"
								_tmp52_ = monitor;
#line 872 "../src/LibraryMonitor.vala"
								_tmp53_ = candidate;
#line 872 "../src/LibraryMonitor.vala"
								if (media_monitor_is_offline (_tmp52_, _tmp53_)) {
#line 6246 "LibraryMonitor.c"
									GeeHashSet* _tmp54_;
									Monitorable* _tmp55_;
#line 873 "../src/LibraryMonitor.vala"
									_tmp54_ = all_candidates;
#line 873 "../src/LibraryMonitor.vala"
									_tmp55_ = candidate;
#line 873 "../src/LibraryMonitor.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp54_, _tmp55_);
#line 6255 "LibraryMonitor.c"
								}
#line 871 "../src/LibraryMonitor.vala"
								_g_object_unref0 (candidate);
#line 6259 "LibraryMonitor.c"
							}
#line 871 "../src/LibraryMonitor.vala"
							_g_object_unref0 (_candidate_it);
#line 6263 "LibraryMonitor.c"
						}
					}
				}
#line 852 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidates);
#line 852 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 6271 "LibraryMonitor.c"
			}
#line 852 "../src/LibraryMonitor.vala"
			_g_object_unref0 (_monitor_list);
#line 6275 "LibraryMonitor.c"
		}
#line 878 "../src/LibraryMonitor.vala"
		if (!known) {
#line 6279 "LibraryMonitor.c"
			GeeHashSet* _tmp58_;
#line 878 "../src/LibraryMonitor.vala"
			_tmp58_ = all_candidates;
#line 878 "../src/LibraryMonitor.vala"
			_tmp57_ = _tmp58_ != NULL;
#line 6285 "LibraryMonitor.c"
		} else {
#line 878 "../src/LibraryMonitor.vala"
			_tmp57_ = FALSE;
#line 6289 "LibraryMonitor.c"
		}
#line 878 "../src/LibraryMonitor.vala"
		if (_tmp57_) {
#line 6293 "LibraryMonitor.c"
			GeeHashSet* _tmp59_;
			gint _tmp60_;
			gint _tmp61_;
#line 878 "../src/LibraryMonitor.vala"
			_tmp59_ = all_candidates;
#line 878 "../src/LibraryMonitor.vala"
			_tmp60_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp59_);
#line 878 "../src/LibraryMonitor.vala"
			_tmp61_ = _tmp60_;
#line 878 "../src/LibraryMonitor.vala"
			_tmp56_ = _tmp61_ > 0;
#line 6305 "LibraryMonitor.c"
		} else {
#line 878 "../src/LibraryMonitor.vala"
			_tmp56_ = FALSE;
#line 6309 "LibraryMonitor.c"
		}
#line 878 "../src/LibraryMonitor.vala"
		if (_tmp56_) {
#line 6313 "LibraryMonitor.c"
			GeeHashSet* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			Workers* _tmp69_;
			GeeHashSet* _tmp70_;
			LibraryMonitorRuntimeFindMoveJob* _tmp71_;
			LibraryMonitorRuntimeFindMoveJob* _tmp72_;
#line 879 "../src/LibraryMonitor.vala"
			_tmp62_ = all_candidates;
#line 879 "../src/LibraryMonitor.vala"
			_tmp63_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp62_);
#line 879 "../src/LibraryMonitor.vala"
			_tmp64_ = _tmp63_;
#line 879 "../src/LibraryMonitor.vala"
			_tmp65_ = g_file_get_path (file);
#line 879 "../src/LibraryMonitor.vala"
			_tmp66_ = _tmp65_;
#line 879 "../src/LibraryMonitor.vala"
			_tmp67_ = g_strdup_printf ("%d candidates for created file %s being checksummed", _tmp64_, _tmp66_);
#line 879 "../src/LibraryMonitor.vala"
			_tmp68_ = _tmp67_;
#line 879 "../src/LibraryMonitor.vala"
			directory_monitor_mdbg (_tmp68_);
#line 879 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp68_);
#line 879 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp66_);
#line 882 "../src/LibraryMonitor.vala"
			_tmp69_ = self->priv->workers;
#line 882 "../src/LibraryMonitor.vala"
			_tmp70_ = all_candidates;
#line 882 "../src/LibraryMonitor.vala"
			_tmp71_ = library_monitor_runtime_find_move_job_new (self, file, (GeeCollection*) _tmp70_);
#line 882 "../src/LibraryMonitor.vala"
			_tmp72_ = _tmp71_;
#line 882 "../src/LibraryMonitor.vala"
			workers_enqueue (_tmp69_, (BackgroundJob*) _tmp72_);
#line 882 "../src/LibraryMonitor.vala"
			_background_job_unref0 (_tmp72_);
#line 884 "../src/LibraryMonitor.vala"
			known = TRUE;
#line 6359 "LibraryMonitor.c"
		}
#line 849 "../src/LibraryMonitor.vala"
		_g_object_unref0 (all_candidates);
#line 6363 "LibraryMonitor.c"
	}
#line 888 "../src/LibraryMonitor.vala"
	if (!known) {
#line 889 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 6369 "LibraryMonitor.c"
	}
#line 891 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_created (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 6373 "LibraryMonitor.c"
}

static void
library_monitor_on_runtime_find_move_completed (LibraryMonitor* self,
                                                BackgroundJob* j)
{
	LibraryMonitorRuntimeFindMoveJob* job = NULL;
	LibraryMonitorRuntimeFindMoveJob* _tmp0_;
	LibraryMonitorRuntimeFindMoveJob* _tmp1_;
	GError* _tmp2_;
	LibraryMonitorRuntimeFindMoveJob* _tmp10_;
	Monitorable* _tmp11_;
#line 894 "../src/LibraryMonitor.vala"
	g_return_if_fail (self != NULL);
#line 894 "../src/LibraryMonitor.vala"
	g_return_if_fail (j != NULL);
#line 895 "../src/LibraryMonitor.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob));
#line 895 "../src/LibraryMonitor.vala"
	job = _tmp0_;
#line 897 "../src/LibraryMonitor.vala"
	_tmp1_ = job;
#line 897 "../src/LibraryMonitor.vala"
	_tmp2_ = _tmp1_->err;
#line 897 "../src/LibraryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 6400 "LibraryMonitor.c"
		LibraryMonitorRuntimeFindMoveJob* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		LibraryMonitorRuntimeFindMoveJob* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 898 "../src/LibraryMonitor.vala"
		_tmp3_ = job;
#line 898 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_->file;
#line 898 "../src/LibraryMonitor.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 898 "../src/LibraryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 898 "../src/LibraryMonitor.vala"
		_tmp7_ = job;
#line 898 "../src/LibraryMonitor.vala"
		_tmp8_ = _tmp7_->err;
#line 898 "../src/LibraryMonitor.vala"
		_tmp9_ = _tmp8_->message;
#line 898 "../src/LibraryMonitor.vala"
		g_critical ("LibraryMonitor.vala:898: Error attempting to find a match at runtime f" \
"or %s: %s", _tmp6_, _tmp9_);
#line 898 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp6_);
#line 6426 "LibraryMonitor.c"
	}
#line 902 "../src/LibraryMonitor.vala"
	_tmp10_ = job;
#line 902 "../src/LibraryMonitor.vala"
	_tmp11_ = _tmp10_->match;
#line 902 "../src/LibraryMonitor.vala"
	if (_tmp11_ != NULL) {
#line 6434 "LibraryMonitor.c"
		MediaMonitor* monitor = NULL;
		LibraryMonitorRuntimeFindMoveJob* _tmp12_;
		Monitorable* _tmp13_;
		MediaMonitor* _tmp14_;
		MediaMonitor* _tmp15_;
		LibraryMonitorRuntimeFindMoveJob* _tmp16_;
		Monitorable* _tmp17_;
		LibraryMonitorRuntimeFindMoveJob* _tmp18_;
		GFile* _tmp19_;
		MediaMonitor* _tmp20_;
		LibraryMonitorRuntimeFindMoveJob* _tmp21_;
		Monitorable* _tmp22_;
#line 903 "../src/LibraryMonitor.vala"
		_tmp12_ = job;
#line 903 "../src/LibraryMonitor.vala"
		_tmp13_ = _tmp12_->match;
#line 903 "../src/LibraryMonitor.vala"
		_tmp14_ = library_monitor_get_monitor_for_monitorable (self, _tmp13_);
#line 903 "../src/LibraryMonitor.vala"
		monitor = _tmp14_;
#line 904 "../src/LibraryMonitor.vala"
		_tmp15_ = monitor;
#line 904 "../src/LibraryMonitor.vala"
		_tmp16_ = job;
#line 904 "../src/LibraryMonitor.vala"
		_tmp17_ = _tmp16_->match;
#line 904 "../src/LibraryMonitor.vala"
		_tmp18_ = job;
#line 904 "../src/LibraryMonitor.vala"
		_tmp19_ = _tmp18_->file;
#line 904 "../src/LibraryMonitor.vala"
		media_monitor_update_master_file (_tmp15_, _tmp17_, _tmp19_);
#line 905 "../src/LibraryMonitor.vala"
		_tmp20_ = monitor;
#line 905 "../src/LibraryMonitor.vala"
		_tmp21_ = job;
#line 905 "../src/LibraryMonitor.vala"
		_tmp22_ = _tmp21_->match;
#line 905 "../src/LibraryMonitor.vala"
		media_monitor_update_online (_tmp20_, _tmp22_);
#line 902 "../src/LibraryMonitor.vala"
		_g_object_unref0 (monitor);
#line 6477 "LibraryMonitor.c"
	} else {
		LibraryMonitorRuntimeFindMoveJob* _tmp23_;
		GFile* _tmp24_;
#line 908 "../src/LibraryMonitor.vala"
		_tmp23_ = job;
#line 908 "../src/LibraryMonitor.vala"
		_tmp24_ = _tmp23_->file;
#line 908 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, _tmp24_);
#line 6487 "LibraryMonitor.c"
	}
#line 894 "../src/LibraryMonitor.vala"
	_background_job_unref0 (job);
#line 6491 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_moved (DirectoryMonitor* base,
                                        GFile* old_file,
                                        GFile* new_file,
                                        GFileInfo* new_info)
{
	LibraryMonitor * self;
	gboolean _tmp0_ = FALSE;
	gboolean known = FALSE;
#line 912 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 912 "../src/LibraryMonitor.vala"
	g_return_if_fail (old_file != NULL);
#line 912 "../src/LibraryMonitor.vala"
	g_return_if_fail (new_file != NULL);
#line 912 "../src/LibraryMonitor.vala"
	g_return_if_fail (new_info != NULL);
#line 913 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (old_file)) {
#line 913 "../src/LibraryMonitor.vala"
		_tmp0_ = TRUE;
#line 6515 "LibraryMonitor.c"
	} else {
#line 913 "../src/LibraryMonitor.vala"
		_tmp0_ = library_monitor_is_blacklisted (new_file);
#line 6519 "LibraryMonitor.c"
	}
#line 913 "../src/LibraryMonitor.vala"
	if (_tmp0_) {
#line 914 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), old_file, new_file, new_info);
#line 916 "../src/LibraryMonitor.vala"
		return;
#line 6527 "LibraryMonitor.c"
	}
#line 919 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 6531 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp1_;
		GeeList* _tmp2_;
		gint _monitor_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _monitor_index = 0;
#line 920 "../src/LibraryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 920 "../src/LibraryMonitor.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 920 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp2_;
#line 920 "../src/LibraryMonitor.vala"
		_tmp3_ = _monitor_list;
#line 920 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 920 "../src/LibraryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 920 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp5_;
#line 920 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 920 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6559 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			MediaMonitor* _tmp8_;
#line 920 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 920 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 920 "../src/LibraryMonitor.vala"
				break;
#line 6570 "LibraryMonitor.c"
			}
#line 920 "../src/LibraryMonitor.vala"
			_tmp6_ = _monitor_list;
#line 920 "../src/LibraryMonitor.vala"
			_tmp7_ = gee_list_get (_tmp6_, _monitor_index);
#line 920 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp7_;
#line 921 "../src/LibraryMonitor.vala"
			_tmp8_ = monitor;
#line 921 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_moved (_tmp8_, old_file, new_file, new_info)) {
#line 922 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 924 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 924 "../src/LibraryMonitor.vala"
				break;
#line 6588 "LibraryMonitor.c"
			}
#line 920 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 6592 "LibraryMonitor.c"
		}
#line 920 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 6596 "LibraryMonitor.c"
	}
#line 928 "../src/LibraryMonitor.vala"
	if (!known) {
#line 929 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, new_file);
#line 6602 "LibraryMonitor.c"
	}
#line 931 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_moved (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), old_file, new_file, new_info);
#line 6606 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_altered (DirectoryMonitor* base,
                                          GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 934 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 934 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 935 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 936 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 938 "../src/LibraryMonitor.vala"
		return;
#line 6625 "LibraryMonitor.c"
	}
#line 941 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 6629 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 942 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 942 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 942 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 942 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 942 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 942 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 942 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 942 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 942 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6657 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
#line 942 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 942 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 942 "../src/LibraryMonitor.vala"
				break;
#line 6668 "LibraryMonitor.c"
			}
#line 942 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 942 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 942 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 943 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 943 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_altered (_tmp7_, file)) {
#line 944 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 946 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 946 "../src/LibraryMonitor.vala"
				break;
#line 6686 "LibraryMonitor.c"
			}
#line 942 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 6690 "LibraryMonitor.c"
		}
#line 942 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 6694 "LibraryMonitor.c"
	}
#line 950 "../src/LibraryMonitor.vala"
	if (!known) {
#line 951 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 6700 "LibraryMonitor.c"
	}
#line 953 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 6704 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_attributes_altered (DirectoryMonitor* base,
                                                     GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 956 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 956 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 957 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 958 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 960 "../src/LibraryMonitor.vala"
		return;
#line 6723 "LibraryMonitor.c"
	}
#line 963 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 6727 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 964 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 964 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 964 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 964 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 964 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 964 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 964 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 964 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 964 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6755 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
#line 964 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 964 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 964 "../src/LibraryMonitor.vala"
				break;
#line 6766 "LibraryMonitor.c"
			}
#line 964 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 964 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 964 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 965 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 965 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_attributes_altered (_tmp7_, file)) {
#line 966 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 968 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 968 "../src/LibraryMonitor.vala"
				break;
#line 6784 "LibraryMonitor.c"
			}
#line 964 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 6788 "LibraryMonitor.c"
		}
#line 964 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 6792 "LibraryMonitor.c"
	}
#line 972 "../src/LibraryMonitor.vala"
	if (!known) {
#line 973 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 6798 "LibraryMonitor.c"
	}
#line 975 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_attributes_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 6802 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_alteration_completed (DirectoryMonitor* base,
                                                       GFile* file,
                                                       GFileInfo* info)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 978 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 978 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 978 "../src/LibraryMonitor.vala"
	g_return_if_fail (info != NULL);
#line 979 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 980 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 982 "../src/LibraryMonitor.vala"
		return;
#line 6824 "LibraryMonitor.c"
	}
#line 985 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 6828 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 986 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 986 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 986 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 986 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 986 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 986 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 986 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 986 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 986 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6856 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
#line 986 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 986 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 986 "../src/LibraryMonitor.vala"
				break;
#line 6867 "LibraryMonitor.c"
			}
#line 986 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 986 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 986 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 987 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 987 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_alteration_completed (_tmp7_, file, info)) {
#line 988 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 990 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 990 "../src/LibraryMonitor.vala"
				break;
#line 6885 "LibraryMonitor.c"
			}
#line 986 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 6889 "LibraryMonitor.c"
		}
#line 986 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 6893 "LibraryMonitor.c"
	}
#line 994 "../src/LibraryMonitor.vala"
	if (!known) {
#line 995 "../src/LibraryMonitor.vala"
		library_monitor_runtime_unknown_file_discovered (self, file);
#line 6899 "LibraryMonitor.c"
	}
#line 997 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_alteration_completed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file, info);
#line 6903 "LibraryMonitor.c"
}

static void
library_monitor_real_notify_file_deleted (DirectoryMonitor* base,
                                          GFile* file)
{
	LibraryMonitor * self;
	gboolean known = FALSE;
#line 1000 "../src/LibraryMonitor.vala"
	self = (LibraryMonitor*) base;
#line 1000 "../src/LibraryMonitor.vala"
	g_return_if_fail (file != NULL);
#line 1001 "../src/LibraryMonitor.vala"
	if (library_monitor_is_blacklisted (file)) {
#line 1002 "../src/LibraryMonitor.vala"
		DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 1004 "../src/LibraryMonitor.vala"
		return;
#line 6922 "LibraryMonitor.c"
	}
#line 1007 "../src/LibraryMonitor.vala"
	known = FALSE;
#line 6926 "LibraryMonitor.c"
	{
		GeeList* _monitor_list = NULL;
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		gint _monitor_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 1008 "../src/LibraryMonitor.vala"
		_tmp0_ = self->priv->monitors;
#line 1008 "../src/LibraryMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1008 "../src/LibraryMonitor.vala"
		_monitor_list = _tmp1_;
#line 1008 "../src/LibraryMonitor.vala"
		_tmp2_ = _monitor_list;
#line 1008 "../src/LibraryMonitor.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 1008 "../src/LibraryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 1008 "../src/LibraryMonitor.vala"
		_monitor_size = _tmp4_;
#line 1008 "../src/LibraryMonitor.vala"
		_monitor_index = -1;
#line 1008 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 6954 "LibraryMonitor.c"
			MediaMonitor* monitor = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			MediaMonitor* _tmp7_;
#line 1008 "../src/LibraryMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 1008 "../src/LibraryMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 1008 "../src/LibraryMonitor.vala"
				break;
#line 6965 "LibraryMonitor.c"
			}
#line 1008 "../src/LibraryMonitor.vala"
			_tmp5_ = _monitor_list;
#line 1008 "../src/LibraryMonitor.vala"
			_tmp6_ = gee_list_get (_tmp5_, _monitor_index);
#line 1008 "../src/LibraryMonitor.vala"
			monitor = (MediaMonitor*) _tmp6_;
#line 1009 "../src/LibraryMonitor.vala"
			_tmp7_ = monitor;
#line 1009 "../src/LibraryMonitor.vala"
			if (media_monitor_notify_file_deleted (_tmp7_, file)) {
#line 1010 "../src/LibraryMonitor.vala"
				known = TRUE;
#line 1012 "../src/LibraryMonitor.vala"
				_g_object_unref0 (monitor);
#line 1012 "../src/LibraryMonitor.vala"
				break;
#line 6983 "LibraryMonitor.c"
			}
#line 1008 "../src/LibraryMonitor.vala"
			_g_object_unref0 (monitor);
#line 6987 "LibraryMonitor.c"
		}
#line 1008 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 6991 "LibraryMonitor.c"
	}
#line 1016 "../src/LibraryMonitor.vala"
	if (!known) {
#line 6995 "LibraryMonitor.c"
		Tombstone* tombstone = NULL;
		TombstoneSourceCollection* _tmp8_;
		Tombstone* _tmp9_;
		Tombstone* _tmp10_;
#line 1018 "../src/LibraryMonitor.vala"
		_tmp8_ = tombstone_global;
#line 1018 "../src/LibraryMonitor.vala"
		_tmp9_ = tombstone_source_collection_locate (_tmp8_, file);
#line 1018 "../src/LibraryMonitor.vala"
		tombstone = _tmp9_;
#line 1019 "../src/LibraryMonitor.vala"
		_tmp10_ = tombstone;
#line 1019 "../src/LibraryMonitor.vala"
		if (_tmp10_ != NULL) {
#line 7010 "LibraryMonitor.c"
			gchar* _tmp11_;
			gchar* _tmp12_;
			TombstoneSourceCollection* _tmp13_;
			Tombstone* _tmp14_;
#line 1020 "../src/LibraryMonitor.vala"
			_tmp11_ = g_file_get_path (file);
#line 1020 "../src/LibraryMonitor.vala"
			_tmp12_ = _tmp11_;
#line 1020 "../src/LibraryMonitor.vala"
			g_debug ("LibraryMonitor.vala:1020: Resurrecting tombstoned file %s", _tmp12_);
#line 1020 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp12_);
#line 1021 "../src/LibraryMonitor.vala"
			_tmp13_ = tombstone_global;
#line 1021 "../src/LibraryMonitor.vala"
			_tmp14_ = tombstone;
#line 1021 "../src/LibraryMonitor.vala"
			tombstone_source_collection_resurrect (_tmp13_, _tmp14_);
#line 7029 "LibraryMonitor.c"
		}
#line 1025 "../src/LibraryMonitor.vala"
		library_monitor_remove_queued_import (self, file);
#line 1016 "../src/LibraryMonitor.vala"
		_g_object_unref0 (tombstone);
#line 7035 "LibraryMonitor.c"
	}
#line 1028 "../src/LibraryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (library_monitor_parent_class)->notify_file_deleted (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DIRECTORY_MONITOR, DirectoryMonitor), file);
#line 7039 "LibraryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 110 "../src/LibraryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 110 "../src/LibraryMonitor.vala"
		data1 = closure->data;
#line 110 "../src/LibraryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 7064 "LibraryMonitor.c"
	} else {
#line 110 "../src/LibraryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 110 "../src/LibraryMonitor.vala"
		data2 = closure->data;
#line 7070 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 110 "../src/LibraryMonitor.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 7076 "LibraryMonitor.c"
}

static void
g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT64_UINT64) (gpointer data1, guint64 arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT64_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 110 "../src/LibraryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 110 "../src/LibraryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 110 "../src/LibraryMonitor.vala"
		data1 = closure->data;
#line 110 "../src/LibraryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 7101 "LibraryMonitor.c"
	} else {
#line 110 "../src/LibraryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 110 "../src/LibraryMonitor.vala"
		data2 = closure->data;
#line 7107 "LibraryMonitor.c"
	}
#line 110 "../src/LibraryMonitor.vala"
	callback = (GMarshalFunc_VOID__UINT64_UINT64) (marshal_data ? marshal_data : cc->callback);
#line 110 "../src/LibraryMonitor.vala"
	callback (data1, g_value_get_uint64 (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
#line 7113 "LibraryMonitor.c"
}

static GObject *
library_monitor_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	LibraryMonitor * self;
	GSettings* _tmp0_;
#line 250 "../src/LibraryMonitor.vala"
	parent_class = G_OBJECT_CLASS (library_monitor_parent_class);
#line 250 "../src/LibraryMonitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 250 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR, LibraryMonitor);
#line 251 "../src/LibraryMonitor.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_FILES_PREFS_SCHEMA_NAME);
#line 251 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 251 "../src/LibraryMonitor.vala"
	self->priv->file_settings = _tmp0_;
#line 250 "../src/LibraryMonitor.vala"
	return obj;
#line 7139 "LibraryMonitor.c"
}

static void
_library_monitor_on_find_move_completed_completion_callback (BackgroundJob* job,
                                                             gpointer self)
{
#line 124 "../src/LibraryMonitor.vala"
	library_monitor_on_find_move_completed ((LibraryMonitor*) self, job);
#line 7148 "LibraryMonitor.c"
}

static void
_library_monitor_on_find_move_cancelled_cancellation_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 124 "../src/LibraryMonitor.vala"
	library_monitor_on_find_move_cancelled ((LibraryMonitor*) self, job);
#line 7157 "LibraryMonitor.c"
}

static LibraryMonitorFindMoveJob*
library_monitor_find_move_job_construct (GType object_type,
                                         LibraryMonitor* owner,
                                         GFile* file,
                                         GeeCollection* candidates)
{
	LibraryMonitorFindMoveJob* self = NULL;
	GCancellable* _tmp0_;
	GFile* _tmp1_;
	GeeCollection* _tmp2_;
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 123 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (candidates != NULL, NULL);
#line 124 "../src/LibraryMonitor.vala"
	_tmp0_ = owner->priv->cancellable;
#line 124 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorFindMoveJob*) background_job_construct (object_type, (GObject*) owner, _library_monitor_on_find_move_completed_completion_callback, owner, _tmp0_, _library_monitor_on_find_move_cancelled_cancellation_callback, owner, NULL);
#line 126 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 126 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 126 "../src/LibraryMonitor.vala"
	self->file = _tmp1_;
#line 127 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (candidates);
#line 127 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 127 "../src/LibraryMonitor.vala"
	self->candidates = _tmp2_;
#line 129 "../src/LibraryMonitor.vala"
	background_job_set_completion_priority ((BackgroundJob*) self, G_PRIORITY_LOW);
#line 123 "../src/LibraryMonitor.vala"
	return self;
#line 7196 "LibraryMonitor.c"
}

static LibraryMonitorFindMoveJob*
library_monitor_find_move_job_new (LibraryMonitor* owner,
                                   GFile* file,
                                   GeeCollection* candidates)
{
#line 123 "../src/LibraryMonitor.vala"
	return library_monitor_find_move_job_construct (LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, owner, file, candidates);
#line 7206 "LibraryMonitor.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 148 "../src/LibraryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 7214 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_real_execute (BackgroundJob* base)
{
	LibraryMonitorFindMoveJob * self;
	GeeIterator* iter = NULL;
	GeeCollection* _tmp0_;
	GeeIterator* _tmp1_;
	GeeCollection* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* md5 = NULL;
	GError* _inner_error0_ = NULL;
#line 132 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorFindMoveJob*) base;
#line 134 "../src/LibraryMonitor.vala"
	_tmp0_ = self->candidates;
#line 134 "../src/LibraryMonitor.vala"
	_tmp1_ = gee_iterable_iterator ((GeeIterable*) _tmp0_);
#line 134 "../src/LibraryMonitor.vala"
	iter = _tmp1_;
#line 135 "../src/LibraryMonitor.vala"
	while (TRUE) {
#line 7239 "LibraryMonitor.c"
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		gpointer _tmp4_;
		Monitorable* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		gboolean _tmp8_;
#line 135 "../src/LibraryMonitor.vala"
		_tmp2_ = iter;
#line 135 "../src/LibraryMonitor.vala"
		if (!gee_iterator_next (_tmp2_)) {
#line 135 "../src/LibraryMonitor.vala"
			break;
#line 7253 "LibraryMonitor.c"
		}
#line 136 "../src/LibraryMonitor.vala"
		_tmp3_ = iter;
#line 136 "../src/LibraryMonitor.vala"
		_tmp4_ = gee_iterator_get (_tmp3_);
#line 136 "../src/LibraryMonitor.vala"
		_tmp5_ = (Monitorable*) _tmp4_;
#line 136 "../src/LibraryMonitor.vala"
		_tmp6_ = media_source_get_master_file ((MediaSource*) _tmp5_);
#line 136 "../src/LibraryMonitor.vala"
		_tmp7_ = _tmp6_;
#line 136 "../src/LibraryMonitor.vala"
		_tmp8_ = g_file_query_exists (_tmp7_, NULL);
#line 136 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp7_);
#line 136 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_tmp5_);
#line 136 "../src/LibraryMonitor.vala"
		if (_tmp8_) {
#line 7273 "LibraryMonitor.c"
			GeeIterator* _tmp9_;
#line 137 "../src/LibraryMonitor.vala"
			_tmp9_ = iter;
#line 137 "../src/LibraryMonitor.vala"
			gee_iterator_remove (_tmp9_);
#line 7279 "LibraryMonitor.c"
		}
	}
#line 141 "../src/LibraryMonitor.vala"
	_tmp10_ = self->candidates;
#line 141 "../src/LibraryMonitor.vala"
	_tmp11_ = gee_collection_get_size (_tmp10_);
#line 141 "../src/LibraryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 141 "../src/LibraryMonitor.vala"
	if (_tmp12_ == 0) {
#line 142 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 142 "../src/LibraryMonitor.vala"
		return;
#line 7294 "LibraryMonitor.c"
	}
#line 144 "../src/LibraryMonitor.vala"
	md5 = NULL;
#line 7298 "LibraryMonitor.c"
	{
		gchar* _tmp13_ = NULL;
		GFile* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 146 "../src/LibraryMonitor.vala"
		_tmp14_ = self->file;
#line 146 "../src/LibraryMonitor.vala"
		_tmp15_ = md5_file (_tmp14_, &_inner_error0_);
#line 146 "../src/LibraryMonitor.vala"
		_tmp13_ = _tmp15_;
#line 146 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7312 "LibraryMonitor.c"
			goto __catch58_g_error;
		}
#line 146 "../src/LibraryMonitor.vala"
		_tmp16_ = _tmp13_;
#line 146 "../src/LibraryMonitor.vala"
		_tmp13_ = NULL;
#line 146 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 146 "../src/LibraryMonitor.vala"
		md5 = _tmp16_;
#line 145 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp13_);
#line 7325 "LibraryMonitor.c"
	}
	goto __finally58;
	__catch58_g_error:
	{
		GError* err = NULL;
		GError* _tmp17_;
		GError* _tmp18_;
#line 145 "../src/LibraryMonitor.vala"
		err = _inner_error0_;
#line 145 "../src/LibraryMonitor.vala"
		_inner_error0_ = NULL;
#line 148 "../src/LibraryMonitor.vala"
		_tmp17_ = err;
#line 148 "../src/LibraryMonitor.vala"
		_tmp18_ = _g_error_copy0 (_tmp17_);
#line 148 "../src/LibraryMonitor.vala"
		_g_error_free0 (self->err);
#line 148 "../src/LibraryMonitor.vala"
		self->err = _tmp18_;
#line 150 "../src/LibraryMonitor.vala"
		_g_error_free0 (err);
#line 150 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 150 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 150 "../src/LibraryMonitor.vala"
		return;
#line 7353 "LibraryMonitor.c"
	}
	__finally58:
#line 145 "../src/LibraryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 145 "../src/LibraryMonitor.vala"
		_g_object_unref0 (iter);
#line 145 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 145 "../src/LibraryMonitor.vala"
		return;
#line 7368 "LibraryMonitor.c"
	}
	{
		GeeIterator* _candidate_it = NULL;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
#line 153 "../src/LibraryMonitor.vala"
		_tmp19_ = self->candidates;
#line 153 "../src/LibraryMonitor.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 153 "../src/LibraryMonitor.vala"
		_candidate_it = _tmp20_;
#line 153 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 7382 "LibraryMonitor.c"
			GeeIterator* _tmp21_;
			Monitorable* candidate = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			Monitorable* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			const gchar* _tmp27_;
			gboolean _tmp28_;
			Monitorable* _tmp29_;
			Monitorable* _tmp43_;
			Monitorable* _tmp44_;
#line 153 "../src/LibraryMonitor.vala"
			_tmp21_ = _candidate_it;
#line 153 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 153 "../src/LibraryMonitor.vala"
				break;
#line 7401 "LibraryMonitor.c"
			}
#line 153 "../src/LibraryMonitor.vala"
			_tmp22_ = _candidate_it;
#line 153 "../src/LibraryMonitor.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 153 "../src/LibraryMonitor.vala"
			candidate = (Monitorable*) _tmp23_;
#line 154 "../src/LibraryMonitor.vala"
			_tmp24_ = candidate;
#line 154 "../src/LibraryMonitor.vala"
			_tmp25_ = media_source_get_master_md5 ((MediaSource*) _tmp24_);
#line 154 "../src/LibraryMonitor.vala"
			_tmp26_ = _tmp25_;
#line 154 "../src/LibraryMonitor.vala"
			_tmp27_ = md5;
#line 154 "../src/LibraryMonitor.vala"
			_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) != 0;
#line 154 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp26_);
#line 154 "../src/LibraryMonitor.vala"
			if (_tmp28_) {
#line 155 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 155 "../src/LibraryMonitor.vala"
				continue;
#line 7427 "LibraryMonitor.c"
			}
#line 157 "../src/LibraryMonitor.vala"
			_tmp29_ = self->match;
#line 157 "../src/LibraryMonitor.vala"
			if (_tmp29_ != NULL) {
#line 7433 "LibraryMonitor.c"
				GFile* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				Monitorable* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				Monitorable* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GeeArrayList* _tmp39_;
				GeeArrayList* _tmp41_;
				Monitorable* _tmp42_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp30_ = self->file;
#line 158 "../src/LibraryMonitor.vala"
				_tmp31_ = g_file_get_path (_tmp30_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp32_ = _tmp31_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp33_ = self->match;
#line 158 "../src/LibraryMonitor.vala"
				_tmp34_ = data_object_to_string ((DataObject*) _tmp33_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp35_ = _tmp34_;
#line 158 "../src/LibraryMonitor.vala"
				_tmp36_ = candidate;
#line 158 "../src/LibraryMonitor.vala"
				_tmp37_ = data_object_to_string ((DataObject*) _tmp36_);
#line 158 "../src/LibraryMonitor.vala"
				_tmp38_ = _tmp37_;
#line 158 "../src/LibraryMonitor.vala"
				g_warning ("LibraryMonitor.vala:158: Found more than one media match for %s: %s an" \
"d %s", _tmp32_, _tmp35_, _tmp38_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp38_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp35_);
#line 158 "../src/LibraryMonitor.vala"
				_g_free0 (_tmp32_);
#line 161 "../src/LibraryMonitor.vala"
				_tmp39_ = self->losers;
#line 161 "../src/LibraryMonitor.vala"
				if (_tmp39_ == NULL) {
#line 7476 "LibraryMonitor.c"
					GeeArrayList* _tmp40_;
#line 162 "../src/LibraryMonitor.vala"
					_tmp40_ = gee_array_list_new (TYPE_MONITORABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 162 "../src/LibraryMonitor.vala"
					_g_object_unref0 (self->losers);
#line 162 "../src/LibraryMonitor.vala"
					self->losers = _tmp40_;
#line 7484 "LibraryMonitor.c"
				}
#line 164 "../src/LibraryMonitor.vala"
				_tmp41_ = self->losers;
#line 164 "../src/LibraryMonitor.vala"
				_tmp42_ = candidate;
#line 164 "../src/LibraryMonitor.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp42_);
#line 166 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 166 "../src/LibraryMonitor.vala"
				continue;
#line 7496 "LibraryMonitor.c"
			}
#line 169 "../src/LibraryMonitor.vala"
			_tmp43_ = candidate;
#line 169 "../src/LibraryMonitor.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 169 "../src/LibraryMonitor.vala"
			_g_object_unref0 (self->match);
#line 169 "../src/LibraryMonitor.vala"
			self->match = _tmp44_;
#line 153 "../src/LibraryMonitor.vala"
			_g_object_unref0 (candidate);
#line 7508 "LibraryMonitor.c"
		}
#line 153 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_candidate_it);
#line 7512 "LibraryMonitor.c"
	}
#line 132 "../src/LibraryMonitor.vala"
	_g_free0 (md5);
#line 132 "../src/LibraryMonitor.vala"
	_g_object_unref0 (iter);
#line 7518 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_class_init (LibraryMonitorFindMoveJobClass * klass,
                                          gpointer klass_data)
{
#line 116 "../src/LibraryMonitor.vala"
	library_monitor_find_move_job_parent_class = g_type_class_peek_parent (klass);
#line 116 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->finalize = library_monitor_find_move_job_finalize;
#line 116 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) library_monitor_find_move_job_real_execute;
#line 7531 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_instance_init (LibraryMonitorFindMoveJob * self,
                                             gpointer klass)
{
#line 119 "../src/LibraryMonitor.vala"
	self->match = NULL;
#line 120 "../src/LibraryMonitor.vala"
	self->losers = NULL;
#line 121 "../src/LibraryMonitor.vala"
	self->err = NULL;
#line 7544 "LibraryMonitor.c"
}

static void
library_monitor_find_move_job_finalize (BackgroundJob * obj)
{
	LibraryMonitorFindMoveJob * self;
#line 116 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_FIND_MOVE_JOB, LibraryMonitorFindMoveJob);
#line 117 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 118 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 119 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->match);
#line 120 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->losers);
#line 121 "../src/LibraryMonitor.vala"
	_g_error_free0 (self->err);
#line 116 "../src/LibraryMonitor.vala"
	BACKGROUND_JOB_CLASS (library_monitor_find_move_job_parent_class)->finalize (obj);
#line 7565 "LibraryMonitor.c"
}

static GType
library_monitor_find_move_job_get_type (void)
{
	static volatile gsize library_monitor_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorFindMoveJob), 0, (GInstanceInitFunc) library_monitor_find_move_job_instance_init, NULL };
		GType library_monitor_find_move_job_type_id;
		library_monitor_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_find_move_job_type_id__volatile, library_monitor_find_move_job_type_id);
	}
	return library_monitor_find_move_job_type_id__volatile;
}

static void
_library_monitor_on_runtime_find_move_completed_completion_callback (BackgroundJob* job,
                                                                     gpointer self)
{
#line 181 "../src/LibraryMonitor.vala"
	library_monitor_on_runtime_find_move_completed ((LibraryMonitor*) self, job);
#line 7587 "LibraryMonitor.c"
}

static LibraryMonitorRuntimeFindMoveJob*
library_monitor_runtime_find_move_job_construct (GType object_type,
                                                 LibraryMonitor* owner,
                                                 GFile* file,
                                                 GeeCollection* candidates)
{
	LibraryMonitorRuntimeFindMoveJob* self = NULL;
	GCancellable* _tmp0_;
	GFile* _tmp1_;
	GeeCollection* _tmp2_;
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 180 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (candidates != NULL, NULL);
#line 181 "../src/LibraryMonitor.vala"
	_tmp0_ = owner->priv->cancellable;
#line 181 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorRuntimeFindMoveJob*) background_job_construct (object_type, (GObject*) owner, _library_monitor_on_runtime_find_move_completed_completion_callback, owner, _tmp0_, NULL, NULL, NULL);
#line 183 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 183 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 183 "../src/LibraryMonitor.vala"
	self->file = _tmp1_;
#line 184 "../src/LibraryMonitor.vala"
	_tmp2_ = _g_object_ref0 (candidates);
#line 184 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 184 "../src/LibraryMonitor.vala"
	self->candidates = _tmp2_;
#line 186 "../src/LibraryMonitor.vala"
	background_job_set_completion_priority ((BackgroundJob*) self, G_PRIORITY_LOW);
#line 180 "../src/LibraryMonitor.vala"
	return self;
#line 7626 "LibraryMonitor.c"
}

static LibraryMonitorRuntimeFindMoveJob*
library_monitor_runtime_find_move_job_new (LibraryMonitor* owner,
                                           GFile* file,
                                           GeeCollection* candidates)
{
#line 180 "../src/LibraryMonitor.vala"
	return library_monitor_runtime_find_move_job_construct (LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, owner, file, candidates);
#line 7636 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_real_execute (BackgroundJob* base)
{
	LibraryMonitorRuntimeFindMoveJob * self;
	gchar* md5 = NULL;
	GError* _inner_error0_ = NULL;
#line 189 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorRuntimeFindMoveJob*) base;
#line 190 "../src/LibraryMonitor.vala"
	md5 = NULL;
#line 7649 "LibraryMonitor.c"
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 192 "../src/LibraryMonitor.vala"
		_tmp1_ = self->file;
#line 192 "../src/LibraryMonitor.vala"
		_tmp2_ = md5_file (_tmp1_, &_inner_error0_);
#line 192 "../src/LibraryMonitor.vala"
		_tmp0_ = _tmp2_;
#line 192 "../src/LibraryMonitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7663 "LibraryMonitor.c"
			goto __catch59_g_error;
		}
#line 192 "../src/LibraryMonitor.vala"
		_tmp3_ = _tmp0_;
#line 192 "../src/LibraryMonitor.vala"
		_tmp0_ = NULL;
#line 192 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 192 "../src/LibraryMonitor.vala"
		md5 = _tmp3_;
#line 191 "../src/LibraryMonitor.vala"
		_g_free0 (_tmp0_);
#line 7676 "LibraryMonitor.c"
	}
	goto __finally59;
	__catch59_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
		GError* _tmp5_;
#line 191 "../src/LibraryMonitor.vala"
		err = _inner_error0_;
#line 191 "../src/LibraryMonitor.vala"
		_inner_error0_ = NULL;
#line 194 "../src/LibraryMonitor.vala"
		_tmp4_ = err;
#line 194 "../src/LibraryMonitor.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 194 "../src/LibraryMonitor.vala"
		_g_error_free0 (self->err);
#line 194 "../src/LibraryMonitor.vala"
		self->err = _tmp5_;
#line 196 "../src/LibraryMonitor.vala"
		_g_error_free0 (err);
#line 196 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 196 "../src/LibraryMonitor.vala"
		return;
#line 7702 "LibraryMonitor.c"
	}
	__finally59:
#line 191 "../src/LibraryMonitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/LibraryMonitor.vala"
		_g_free0 (md5);
#line 191 "../src/LibraryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/LibraryMonitor.vala"
		g_clear_error (&_inner_error0_);
#line 191 "../src/LibraryMonitor.vala"
		return;
#line 7715 "LibraryMonitor.c"
	}
	{
		GeeIterator* _candidate_it = NULL;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
#line 199 "../src/LibraryMonitor.vala"
		_tmp6_ = self->candidates;
#line 199 "../src/LibraryMonitor.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 199 "../src/LibraryMonitor.vala"
		_candidate_it = _tmp7_;
#line 199 "../src/LibraryMonitor.vala"
		while (TRUE) {
#line 7729 "LibraryMonitor.c"
			GeeIterator* _tmp8_;
			Monitorable* candidate = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			Monitorable* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			const gchar* _tmp14_;
			gboolean _tmp15_;
#line 199 "../src/LibraryMonitor.vala"
			_tmp8_ = _candidate_it;
#line 199 "../src/LibraryMonitor.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 199 "../src/LibraryMonitor.vala"
				break;
#line 7745 "LibraryMonitor.c"
			}
#line 199 "../src/LibraryMonitor.vala"
			_tmp9_ = _candidate_it;
#line 199 "../src/LibraryMonitor.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 199 "../src/LibraryMonitor.vala"
			candidate = (Monitorable*) _tmp10_;
#line 200 "../src/LibraryMonitor.vala"
			_tmp11_ = candidate;
#line 200 "../src/LibraryMonitor.vala"
			_tmp12_ = media_source_get_master_md5 ((MediaSource*) _tmp11_);
#line 200 "../src/LibraryMonitor.vala"
			_tmp13_ = _tmp12_;
#line 200 "../src/LibraryMonitor.vala"
			_tmp14_ = md5;
#line 200 "../src/LibraryMonitor.vala"
			_tmp15_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 200 "../src/LibraryMonitor.vala"
			_g_free0 (_tmp13_);
#line 200 "../src/LibraryMonitor.vala"
			if (_tmp15_) {
#line 7767 "LibraryMonitor.c"
				Monitorable* _tmp16_;
				Monitorable* _tmp17_;
#line 201 "../src/LibraryMonitor.vala"
				_tmp16_ = candidate;
#line 201 "../src/LibraryMonitor.vala"
				_tmp17_ = _g_object_ref0 (_tmp16_);
#line 201 "../src/LibraryMonitor.vala"
				_g_object_unref0 (self->match);
#line 201 "../src/LibraryMonitor.vala"
				self->match = _tmp17_;
#line 203 "../src/LibraryMonitor.vala"
				_g_object_unref0 (candidate);
#line 203 "../src/LibraryMonitor.vala"
				break;
#line 7782 "LibraryMonitor.c"
			}
#line 199 "../src/LibraryMonitor.vala"
			_g_object_unref0 (candidate);
#line 7786 "LibraryMonitor.c"
		}
#line 199 "../src/LibraryMonitor.vala"
		_g_object_unref0 (_candidate_it);
#line 7790 "LibraryMonitor.c"
	}
#line 189 "../src/LibraryMonitor.vala"
	_g_free0 (md5);
#line 7794 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_class_init (LibraryMonitorRuntimeFindMoveJobClass * klass,
                                                  gpointer klass_data)
{
#line 174 "../src/LibraryMonitor.vala"
	library_monitor_runtime_find_move_job_parent_class = g_type_class_peek_parent (klass);
#line 174 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->finalize = library_monitor_runtime_find_move_job_finalize;
#line 174 "../src/LibraryMonitor.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) library_monitor_runtime_find_move_job_real_execute;
#line 7807 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_instance_init (LibraryMonitorRuntimeFindMoveJob * self,
                                                     gpointer klass)
{
#line 177 "../src/LibraryMonitor.vala"
	self->match = NULL;
#line 178 "../src/LibraryMonitor.vala"
	self->err = NULL;
#line 7818 "LibraryMonitor.c"
}

static void
library_monitor_runtime_find_move_job_finalize (BackgroundJob * obj)
{
	LibraryMonitorRuntimeFindMoveJob * self;
#line 174 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_RUNTIME_FIND_MOVE_JOB, LibraryMonitorRuntimeFindMoveJob);
#line 175 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->file);
#line 176 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->candidates);
#line 177 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->match);
#line 178 "../src/LibraryMonitor.vala"
	_g_error_free0 (self->err);
#line 174 "../src/LibraryMonitor.vala"
	BACKGROUND_JOB_CLASS (library_monitor_runtime_find_move_job_parent_class)->finalize (obj);
#line 7837 "LibraryMonitor.c"
}

static GType
library_monitor_runtime_find_move_job_get_type (void)
{
	static volatile gsize library_monitor_runtime_find_move_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_runtime_find_move_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorRuntimeFindMoveJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_runtime_find_move_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorRuntimeFindMoveJob), 0, (GInstanceInitFunc) library_monitor_runtime_find_move_job_instance_init, NULL };
		GType library_monitor_runtime_find_move_job_type_id;
		library_monitor_runtime_find_move_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "LibraryMonitorRuntimeFindMoveJob", &g_define_type_info, 0);
		g_once_init_leave (&library_monitor_runtime_find_move_job_type_id__volatile, library_monitor_runtime_find_move_job_type_id);
	}
	return library_monitor_runtime_find_move_job_type_id__volatile;
}

static LibraryMonitorVerifyJob*
library_monitor_verify_job_construct (GType object_type,
                                      Monitorable* monitorable,
                                      MediaMonitor* monitor)
{
	LibraryMonitorVerifyJob* self = NULL;
	Monitorable* _tmp0_;
	MediaMonitor* _tmp1_;
#line 213 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitorable != NULL, NULL);
#line 213 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (monitor != NULL, NULL);
#line 213 "../src/LibraryMonitor.vala"
	self = (LibraryMonitorVerifyJob*) g_type_create_instance (object_type);
#line 214 "../src/LibraryMonitor.vala"
	_tmp0_ = _g_object_ref0 (monitorable);
#line 214 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 214 "../src/LibraryMonitor.vala"
	self->monitorable = _tmp0_;
#line 215 "../src/LibraryMonitor.vala"
	_tmp1_ = _g_object_ref0 (monitor);
#line 215 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitor);
#line 215 "../src/LibraryMonitor.vala"
	self->monitor = _tmp1_;
#line 213 "../src/LibraryMonitor.vala"
	return self;
#line 7881 "LibraryMonitor.c"
}

static LibraryMonitorVerifyJob*
library_monitor_verify_job_new (Monitorable* monitorable,
                                MediaMonitor* monitor)
{
#line 213 "../src/LibraryMonitor.vala"
	return library_monitor_verify_job_construct (LIBRARY_MONITOR_TYPE_VERIFY_JOB, monitorable, monitor);
#line 7890 "LibraryMonitor.c"
}

static void
library_monitor_value_verify_job_init (GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 7898 "LibraryMonitor.c"
}

static void
library_monitor_value_verify_job_free_value (GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (value->data[0].v_pointer);
#line 7908 "LibraryMonitor.c"
	}
}

static void
library_monitor_value_verify_job_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 209 "../src/LibraryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = library_monitor_verify_job_ref (src_value->data[0].v_pointer);
#line 7920 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7924 "LibraryMonitor.c"
	}
}

static gpointer
library_monitor_value_verify_job_peek_pointer (const GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 7933 "LibraryMonitor.c"
}

static gchar*
library_monitor_value_verify_job_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 209 "../src/LibraryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 7944 "LibraryMonitor.c"
		LibraryMonitorVerifyJob * object;
		object = collect_values[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 209 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7951 "LibraryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 209 "../src/LibraryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7955 "LibraryMonitor.c"
		}
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = library_monitor_verify_job_ref (object);
#line 7959 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7963 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	return NULL;
#line 7967 "LibraryMonitor.c"
}

static gchar*
library_monitor_value_verify_job_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	LibraryMonitorVerifyJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (!object_p) {
#line 209 "../src/LibraryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7982 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = NULL;
#line 7988 "LibraryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 7992 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		*object_p = library_monitor_verify_job_ref (value->data[0].v_pointer);
#line 7996 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	return NULL;
#line 8000 "LibraryMonitor.c"
}

static GParamSpec*
library_monitor_param_spec_verify_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	LibraryMonitorParamSpecVerifyJob* spec;
#line 209 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
#line 209 "../src/LibraryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 209 "../src/LibraryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 209 "../src/LibraryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 8019 "LibraryMonitor.c"
}

static gpointer
library_monitor_value_get_verify_job (const GValue* value)
{
#line 209 "../src/LibraryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB), NULL);
#line 209 "../src/LibraryMonitor.vala"
	return value->data[0].v_pointer;
#line 8029 "LibraryMonitor.c"
}

static void
library_monitor_value_set_verify_job (GValue* value,
                                      gpointer v_object)
{
	LibraryMonitorVerifyJob * old;
#line 209 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_ref (value->data[0].v_pointer);
#line 8051 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8055 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (old) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (old);
#line 8061 "LibraryMonitor.c"
	}
}

static void
library_monitor_value_take_verify_job (GValue* value,
                                       gpointer v_object)
{
	LibraryMonitorVerifyJob * old;
#line 209 "../src/LibraryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
	old = value->data[0].v_pointer;
#line 209 "../src/LibraryMonitor.vala"
	if (v_object) {
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, LIBRARY_MONITOR_TYPE_VERIFY_JOB));
#line 209 "../src/LibraryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 8082 "LibraryMonitor.c"
	} else {
#line 209 "../src/LibraryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 8086 "LibraryMonitor.c"
	}
#line 209 "../src/LibraryMonitor.vala"
	if (old) {
#line 209 "../src/LibraryMonitor.vala"
		library_monitor_verify_job_unref (old);
#line 8092 "LibraryMonitor.c"
	}
}

static void
library_monitor_verify_job_class_init (LibraryMonitorVerifyJobClass * klass,
                                       gpointer klass_data)
{
#line 209 "../src/LibraryMonitor.vala"
	library_monitor_verify_job_parent_class = g_type_class_peek_parent (klass);
#line 209 "../src/LibraryMonitor.vala"
	((LibraryMonitorVerifyJobClass *) klass)->finalize = library_monitor_verify_job_finalize;
#line 8104 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_instance_init (LibraryMonitorVerifyJob * self,
                                          gpointer klass)
{
#line 209 "../src/LibraryMonitor.vala"
	self->ref_count = 1;
#line 8113 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_finalize (LibraryMonitorVerifyJob * obj)
{
	LibraryMonitorVerifyJob * self;
#line 209 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LIBRARY_MONITOR_TYPE_VERIFY_JOB, LibraryMonitorVerifyJob);
#line 209 "../src/LibraryMonitor.vala"
	g_signal_handlers_destroy (self);
#line 210 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitorable);
#line 211 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->monitor);
#line 8128 "LibraryMonitor.c"
}

static GType
library_monitor_verify_job_get_type (void)
{
	static volatile gsize library_monitor_verify_job_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_verify_job_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { library_monitor_value_verify_job_init, library_monitor_value_verify_job_free_value, library_monitor_value_verify_job_copy_value, library_monitor_value_verify_job_peek_pointer, "p", library_monitor_value_verify_job_collect_value, "p", library_monitor_value_verify_job_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorVerifyJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_verify_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitorVerifyJob), 0, (GInstanceInitFunc) library_monitor_verify_job_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType library_monitor_verify_job_type_id;
		library_monitor_verify_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "LibraryMonitorVerifyJob", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&library_monitor_verify_job_type_id__volatile, library_monitor_verify_job_type_id);
	}
	return library_monitor_verify_job_type_id__volatile;
}

static gpointer
library_monitor_verify_job_ref (gpointer instance)
{
	LibraryMonitorVerifyJob * self;
	self = instance;
#line 209 "../src/LibraryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 209 "../src/LibraryMonitor.vala"
	return instance;
#line 8155 "LibraryMonitor.c"
}

static void
library_monitor_verify_job_unref (gpointer instance)
{
	LibraryMonitorVerifyJob * self;
	self = instance;
#line 209 "../src/LibraryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 209 "../src/LibraryMonitor.vala"
		LIBRARY_MONITOR_VERIFY_JOB_GET_CLASS (self)->finalize (self);
#line 209 "../src/LibraryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8169 "LibraryMonitor.c"
	}
}

static void
library_monitor_class_init (LibraryMonitorClass * klass,
                            gpointer klass_data)
{
	GeeHashSet* _tmp0_;
	HashTimedQueue* _tmp1_;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_parent_class = g_type_class_peek_parent (klass);
#line 110 "../src/LibraryMonitor.vala"
	g_type_class_adjust_private_offset (klass, &LibraryMonitor_private_offset);
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->close = (void (*) (DirectoryMonitor*)) library_monitor_real_close;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_started = (void (*) (DirectoryMonitor*)) library_monitor_real_discovery_started;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->file_discovered = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_file_discovered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->discovery_completed = (void (*) (DirectoryMonitor*)) library_monitor_real_discovery_completed;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_created = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_notify_file_created;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_moved = (void (*) (DirectoryMonitor*, GFile*, GFile*, GFileInfo*)) library_monitor_real_notify_file_moved;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_altered = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_altered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_attributes_altered = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_attributes_altered;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_alteration_completed = (void (*) (DirectoryMonitor*, GFile*, GFileInfo*)) library_monitor_real_notify_file_alteration_completed;
#line 110 "../src/LibraryMonitor.vala"
	((DirectoryMonitorClass *) klass)->notify_file_deleted = (void (*) (DirectoryMonitor*, GFile*)) library_monitor_real_notify_file_deleted;
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (klass)->constructor = library_monitor_constructor;
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = library_monitor_finalize;
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_UPDATE_PROGRESS_SIGNAL] = g_signal_new ("auto-update-progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PREPARING_SIGNAL] = g_signal_new ("auto-import-preparing", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 110 "../src/LibraryMonitor.vala"
	library_monitor_signals[LIBRARY_MONITOR_AUTO_IMPORT_PROGRESS_SIGNAL] = g_signal_new ("auto-import-progress", TYPE_LIBRARY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT64_UINT64, G_TYPE_NONE, 2, G_TYPE_UINT64, G_TYPE_UINT64);
#line 219 "../src/LibraryMonitor.vala"
	g_rec_mutex_init (&__lock_library_monitor_library_monitor_blacklist);
#line 219 "../src/LibraryMonitor.vala"
	_tmp0_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 219 "../src/LibraryMonitor.vala"
	library_monitor_blacklist = _tmp0_;
#line 220 "../src/LibraryMonitor.vala"
	_tmp1_ = hash_timed_queue_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (guint) LIBRARY_MONITOR_MIN_BLACKLIST_DURATION_MSEC, _library_monitor_on_unblacklist_file_dequeued_callback, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, G_PRIORITY_LOW);
#line 220 "../src/LibraryMonitor.vala"
	library_monitor_to_unblacklist = _tmp1_;
#line 8223 "LibraryMonitor.c"
}

static void
library_monitor_instance_init (LibraryMonitor * self,
                               gpointer klass)
{
	Workers* _tmp0_;
	GCancellable* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeLinkedList* _tmp6_;
#line 110 "../src/LibraryMonitor.vala"
	self->priv = library_monitor_get_instance_private (self);
#line 223 "../src/LibraryMonitor.vala"
	_tmp0_ = workers_new (workers_thread_per_cpu_minus_one (), FALSE);
#line 223 "../src/LibraryMonitor.vala"
	self->priv->workers = _tmp0_;
#line 224 "../src/LibraryMonitor.vala"
	_tmp1_ = g_cancellable_new ();
#line 224 "../src/LibraryMonitor.vala"
	self->priv->cancellable = _tmp1_;
#line 225 "../src/LibraryMonitor.vala"
	self->priv->auto_import = FALSE;
#line 226 "../src/LibraryMonitor.vala"
	self->priv->unknown_files = NULL;
#line 227 "../src/LibraryMonitor.vala"
	_tmp2_ = gee_array_list_new (TYPE_MEDIA_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 227 "../src/LibraryMonitor.vala"
	self->priv->monitors = (GeeList*) _tmp2_;
#line 228 "../src/LibraryMonitor.vala"
	self->priv->discovered = NULL;
#line 229 "../src/LibraryMonitor.vala"
	_tmp3_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 229 "../src/LibraryMonitor.vala"
	self->priv->import_queue = _tmp3_;
#line 230 "../src/LibraryMonitor.vala"
	_tmp4_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 230 "../src/LibraryMonitor.vala"
	self->priv->pending_imports = _tmp4_;
#line 231 "../src/LibraryMonitor.vala"
	_tmp5_ = gee_array_list_new (TYPE_BATCH_IMPORT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 231 "../src/LibraryMonitor.vala"
	self->priv->batch_import_queue = _tmp5_;
#line 232 "../src/LibraryMonitor.vala"
	self->priv->current_import_roll = NULL;
#line 233 "../src/LibraryMonitor.vala"
	self->priv->last_import_roll_use = (time_t) 0;
#line 234 "../src/LibraryMonitor.vala"
	self->priv->current_batch_import = NULL;
#line 235 "../src/LibraryMonitor.vala"
	self->priv->checksums_completed = 0;
#line 236 "../src/LibraryMonitor.vala"
	self->priv->checksums_total = 0;
#line 237 "../src/LibraryMonitor.vala"
	self->priv->import_queue_timer_id = (guint) 0;
#line 238 "../src/LibraryMonitor.vala"
	_tmp6_ = gee_linked_list_new (LIBRARY_MONITOR_TYPE_VERIFY_JOB, (GBoxedCopyFunc) library_monitor_verify_job_ref, (GDestroyNotify) library_monitor_verify_job_unref, NULL, NULL, NULL);
#line 238 "../src/LibraryMonitor.vala"
	self->priv->verify_queue = (GeeQueue*) _tmp6_;
#line 239 "../src/LibraryMonitor.vala"
	self->priv->outstanding_verify_jobs = 0;
#line 240 "../src/LibraryMonitor.vala"
	self->priv->completed_monitorable_verifies = 0;
#line 241 "../src/LibraryMonitor.vala"
	self->priv->total_monitorable_verifies = 0;
#line 8291 "LibraryMonitor.c"
}

static void
library_monitor_finalize (GObject * obj)
{
	LibraryMonitor * self;
#line 110 "../src/LibraryMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_MONITOR, LibraryMonitor);
#line 223 "../src/LibraryMonitor.vala"
	_workers_unref0 (self->priv->workers);
#line 224 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 226 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->unknown_files);
#line 227 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 228 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->discovered);
#line 229 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->import_queue);
#line 230 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->pending_imports);
#line 231 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->batch_import_queue);
#line 232 "../src/LibraryMonitor.vala"
	_batch_import_roll_unref0 (self->priv->current_import_roll);
#line 234 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->current_batch_import);
#line 238 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->verify_queue);
#line 242 "../src/LibraryMonitor.vala"
	_g_object_unref0 (self->priv->file_settings);
#line 110 "../src/LibraryMonitor.vala"
	G_OBJECT_CLASS (library_monitor_parent_class)->finalize (obj);
#line 8326 "LibraryMonitor.c"
}

GType
library_monitor_get_type (void)
{
	static volatile gsize library_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&library_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryMonitor), 0, (GInstanceInitFunc) library_monitor_instance_init, NULL };
		GType library_monitor_type_id;
		library_monitor_type_id = g_type_register_static (TYPE_DIRECTORY_MONITOR, "LibraryMonitor", &g_define_type_info, 0);
		LibraryMonitor_private_offset = g_type_add_instance_private (library_monitor_type_id, sizeof (LibraryMonitorPrivate));
		g_once_init_leave (&library_monitor_type_id__volatile, library_monitor_type_id);
	}
	return library_monitor_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

