/* Photo.c generated by valac 0.44.3, the Vala compiler
 * generated from Photo.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <cairo.h>

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;
enum  {
	PHOTO_TRANSFORMATION_STATE_0_PROPERTY,
	PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES
};
static GParamSpec* photo_transformation_state_properties[PHOTO_TRANSFORMATION_STATE_NUM_PROPERTIES];
enum  {
	PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL,
	PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS
};
static guint photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_NUM_SIGNALS] = {0};

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;
typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
enum  {
	PHOTO_0_PROPERTY,
	PHOTO_NUM_PROPERTIES
};
static GParamSpec* photo_properties[PHOTO_NUM_PROPERTIES];
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))
typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
typedef void (*OneShotCallback) (gpointer user_data);
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_0_PROPERTY,
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES
};
static GParamSpec* photo_photo_transformation_state_impl_properties[PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_NUM_PROPERTIES];
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
enum  {
	PHOTO_EDITABLE_REPLACED_SIGNAL,
	PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL,
	PHOTO_BASELINE_REPLACED_SIGNAL,
	PHOTO_MASTER_REIMPORTED_SIGNAL,
	PHOTO_EDITABLE_REIMPORTED_SIGNAL,
	PHOTO_BASELINE_REIMPORTED_SIGNAL,
	PHOTO_SOURCE_REIMPORTED_SIGNAL,
	PHOTO_NUM_SIGNALS
};
static guint photo_signals[PHOTO_NUM_SIGNALS] = {0};
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL,
	LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS
};
static guint library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_NUM_SIGNALS] = {0};

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
enum  {
	LIBRARY_PHOTO_0_PROPERTY,
	LIBRARY_PHOTO_NUM_PROPERTIES
};
static GParamSpec* library_photo_properties[LIBRARY_PHOTO_NUM_PROPERTIES];
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ImportID {
	gint64 id;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, gint* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	gboolean enhanced;
	GeeHashMap* original_transforms;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	GeeHashMap* original_transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gboolean enhanced;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};

static gpointer photo_import_params_parent_class = NULL;
static gint PhotoTransformationState_private_offset;
static gpointer photo_transformation_state_parent_class = NULL;
static gint Photo_private_offset;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gint PhotoPhotoTransformationStateImpl_private_offset;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface * photo_dateable_parent_iface = NULL;
static gint LibraryPhotoSourceCollection_private_offset;
static gpointer library_photo_source_collection_parent_class = NULL;
static gint LibraryPhoto_private_offset;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface * library_photo_flaggable_parent_iface = NULL;
static MonitorableIface * library_photo_monitorable_parent_iface = NULL;
static gint LibraryPhotoSourceHoldingTank_private_offset;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_photo_row (GValue* value,
                          gpointer v_object);
void value_take_photo_row (GValue* value,
                           gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file,
                                                               ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type,
                                                                     GFile* file,
                                                                     ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams * obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject * obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void value_set_pixel_transformer (GValue* value,
                                  gpointer v_object);
void value_take_pixel_transformer (GValue* value,
                                   gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value,
                                            gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value,
                                             gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
gboolean photo_exception_prohibits (PhotoException self,
                                    PhotoException exception);
gboolean photo_exception_allows (PhotoException self,
                                 PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type,
                        PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type,
                                     gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_key_value_map (GValue* value,
                              gpointer v_object);
void value_take_key_value_map (GValue* value,
                               gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self,
                                        BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  GError** error);
static void photo_internal_remove_all_transformations (Photo* self,
                                                gboolean notify);
RawDeveloper* raw_developer_as_array (gint* result_length1);
void photo_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self,
                                          GFile* old_file,
                                          GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self,
                                            PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self,
                                          PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self,
                                            PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base,
                                             GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self,
                            gboolean delete_editable,
                            gboolean remove_transformations,
                            gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self,
                                       RawDeveloper d);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self,
                                 BackingPhotoID* backing_id,
                                 GError** error);
gboolean photo_is_raw_developer_complete (Photo* self,
                                          RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self,
                                          GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              GError** error);
void photo_import_developed_backing_photo (PhotoRow* row,
                                           RawDeveloper d,
                                           BackingPhotoRow* bpr,
                                           GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value,
                                        gpointer v_object);
void value_take_photo_file_interrogator (GValue* value,
                                         gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file,
                                                    PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type,
                                                          GFile* file,
                                                          PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self,
                                          GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_detected_photo_information (GValue* value,
                                           gpointer v_object);
void value_take_detected_photo_information (GValue* value,
                                            gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self,
                              BackingPhotoRow* state,
                              GError** error);
void photo_table_update_raw_development (PhotoTable* self,
                                         PhotoRow* row,
                                         RawDeveloper rd,
                                         BackingPhotoID* backing_photo_id,
                                         GError** error);
static void photo_develop_photo (Photo* self,
                          RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self,
                                                                   const gchar* raw_filepath,
                                                                   const gchar* camera_development_filename,
                                                                   GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self,
                                    Scaling* scaling,
                                    gboolean rotate,
                                    GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self,
                                                  const gchar* filepath,
                                                  GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self,
                              GdkPixbuf* pixbuf,
                              JpegQuality quality,
                              GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self,
                                                                   const gchar* filepath,
                                                                   GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self,
                                                PhotoMetadata* metadata,
                                                GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
void photo_set_raw_developer (Photo* self,
                              RawDeveloper d);
void photo_populate_prefetched (Photo* self,
                                GError** error);
void photo_revert_to_master (Photo* self,
                             gboolean notify);
gboolean photo_set_orientation (Photo* self,
                                Orientation orientation);
gboolean photo_discard_prefetched (Photo* self,
                                   gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self,
                                     PhotoRow* row,
                                     RawDeveloper rd,
                                     GError** error);
void photo_redevelop_raw (Photo* self,
                          RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base,
                                                       gint* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row,
                                                         const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type,
                                                               BackingPhotoRow* photo_row,
                                                               const gchar* md5);
static void _vala_array_add7 (BackingFileState** * array,
                       int* length,
                       int* size,
                       BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add8 (BackingFileState** * array,
                       int* length,
                       int* size,
                       BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add9 (BackingFileState** * array,
                       int* length,
                       int* size,
                       BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self,
                                           BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self,
                                                      RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self,
                                                        ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self,
                                                 ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self,
                                  PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails,
                                         PhotoFileReader* reader,
                                         Orientation orientation,
                                         Dimensions* original_dim,
                                         GError** error);
ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self,
                                                GFile* file,
                                                PhotoFileSnifferOptions options,
                                                DetectedPhotoInformation* * detected,
                                                GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value,
                                            gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value,
                                             gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self,
                                            PhotoReimportMasterState* * reimport_state,
                                            GError** error);
static void _vala_array_add10 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add12 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row,
                                                                    PhotoMetadata* metadata,
                                                                    gchar** alterations,
                                                                    gint alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type,
                                                                          PhotoRow* row,
                                                                          PhotoMetadata* metadata,
                                                                          gchar** alterations,
                                                                          gint alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self,
                                                  PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self,
                                   PhotoReimportMasterState* state,
                                   GError** error);
void photo_table_reimport (PhotoTable* self,
                           PhotoRow* row,
                           GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self,
                                  BackingPhotoRow* from);
static void _vala_array_add15 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
Alteration* alteration_new_from_array (gchar** array,
                                       gint array_length1);
Alteration* alteration_construct_from_array (GType object_type,
                                             gchar** array,
                                             gint array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self,
                                         GFile* file,
                                         BackingPhotoRow* * backing,
                                         DetectedPhotoInformation* * detected,
                                         GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value,
                                              gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value,
                                               gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self,
                                              PhotoReimportEditableState* * state,
                                              GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                                                        PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type,
                                                                              BackingPhotoRow* backing_state,
                                                                              PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* state,
                                     GError** error);
void photo_get_editable_id (Photo* self,
                            BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self,
                                 BackingPhotoRow* row,
                                 GError** error);
void media_source_set_title (MediaSource* self,
                             const gchar* title);
gboolean media_source_set_comment (MediaSource* self,
                                   const gchar* comment);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value,
                                                     gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value,
                                                      gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self,
                                                     PhotoReimportRawDevelopmentState* * state,
                                                     GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                                    BackingPhotoRow* backing,
                                                    PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* state,
                                            GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self,
                         PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self,
                                 GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self,
                                   PhotoID* photo_id,
                                   time_t timestamp,
                                   GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self,
                                              GFileInfo* info,
                                              GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self,
                                           BackingPhotoID* id,
                                           time_t timestamp,
                                           GError** error);
void photo_update_many_editable_timestamps (GeeMap* map,
                                            GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
void scaling_for_best_fit (gint pixels,
                           gboolean scale_up,
                           Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename,
                                   gchar** extensions,
                                   gint extensions_length1);
gboolean photo_can_write_file (Photo* self);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self,
                                    GFile* file,
                                    const gchar* thumbnail_md5,
                                    const gchar* md5,
                                    PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file,
                                  const gchar* thumbnail_md5,
                                  const gchar* full_md5,
                                  PhotoFileFormat file_format,
                                  gint* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self,
                            GFile* file);
void photo_table_set_filepath (PhotoTable* self,
                               PhotoID* photo_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
static void _vala_array_add17 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add19 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add20 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void photo_set_editable_file (Photo* self,
                              GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self,
                                       BackingPhotoID* id,
                                       const gchar* filepath,
                                       GError** error);
static void _vala_array_add21 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add22 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void photo_set_many_editable_file (GeeMap* map,
                                   GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base,
                              EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base,
                               ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 photo_replace_flags (Photo* self,
                             guint64 flags,
                             Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self,
                                    PhotoID* photo_id,
                                    guint64 flags);
gboolean photo_is_flag_set (Photo* self,
                            guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
guint64 photo_add_flags (Photo* self,
                         guint64 mask,
                         Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
guint64 photo_remove_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
guint64 photo_add_remove_flags (Photo* self,
                                guint64 add,
                                guint64 remove,
                                Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add,
                                  guint64 add_mask,
                                  Alteration* additional_add_alteration,
                                  GeeCollection* remove,
                                  guint64 remove_mask,
                                  Alteration* additional_remove_alteration,
                                  GError** error);
guint64 photo_toggle_flags (Photo* self,
                            guint64 mask,
                            Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self,
                                      gboolean dirty,
                                      GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self,
                                     PhotoID* photo_id,
                                     gboolean dirty,
                                     GError** error);
gboolean photo_is_enhanced (Photo* self);
void photo_set_enhanced (Photo* self,
                         gboolean enhanced);
gboolean photo_table_set_enhanced (PhotoTable* self,
                                   PhotoID* photo_id,
                                   gboolean enhanced);
static void photo_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self,
                                   PhotoID* photo_id,
                                   const gchar* backlinks,
                                   GError** error);
static gboolean photo_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self,
                                PhotoID* photo_id,
                                EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base,
                            DataSource* source);
gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self,
                                          PhotoID* photoID,
                                          gint64 filesize,
                                          glong timestamp,
                                          const gchar* md5,
                                          const gchar* exif_md5,
                                          const gchar* thumbnail_md5,
                                          PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base,
                           const gchar* title);
gboolean photo_table_set_title (PhotoTable* self,
                                PhotoID* photo_id,
                                const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base,
                                 const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self,
                                  PhotoID* photo_id,
                                  const gchar* new_comment);
void photo_set_import_id (Photo* self,
                          ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self,
                                PhotoID* photo_id,
                                ImportID* import_id,
                                GError** error);
void photo_set_title_persistent (Photo* self,
                                 const gchar* title,
                                 GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self,
                                                                   GError** error);
void library_monitor_blacklist_file (GFile* file,
                                     const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self,
                                   const gchar* comment,
                                   GError** error);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base,
                                   time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self,
                                        PhotoID* photo_id,
                                        time_t time);
void photo_set_exposure_time_persistent (Photo* self,
                                         time_t time,
                                         GError** error);
void dateable_set_exposure_time (Dateable* self,
                                 time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
void photo_get_raw_dimensions (Photo* self,
                               Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
void compute_arb_rotated_size (gdouble src_width,
                               gdouble src_height,
                               gdouble angle,
                               gdouble* dest_width,
                               gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
void box_get_dimensions (Box *self,
                         Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self,
                                       const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self,
                                       KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type,
                                      const gchar* group);
static KeyValueMap* photo_get_color_adjustments_map (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self,
                                   const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void value_set_pixel_transformation (GValue* value,
                                     gpointer v_object);
void value_take_pixel_transformation (GValue* value,
                                      gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self,
                                                 PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self,
                                                                     PixelTransformationType type);
void photo_set_color_adjustments (Photo* self,
                                  PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self,
                                      const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self,
                                               const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self,
                                               PixelTransformation* old_trans,
                                               PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self,
                                   KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self,
                                            GError** error);
gboolean photo_persist_master_metadata (Photo* self,
                                        PhotoMetadata* metadata,
                                        PhotoReimportMasterState* * state,
                                        GError** error);
void photo_finish_update_master_metadata (Photo* self,
                                          PhotoReimportMasterState* state,
                                          GError** error);
gboolean photo_persist_editable_metadata (Photo* self,
                                          PhotoMetadata* metadata,
                                          PhotoReimportEditableState* * state,
                                          GError** error);
void photo_finish_update_editable_metadata (Photo* self,
                                            PhotoReimportEditableState* state,
                                            GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo,
                                                                              Orientation orientation,
                                                                              GeeHashMap* transformations,
                                                                              PixelTransformer* transformer,
                                                                              PixelTransformationBundle* adjustments,
                                                                              GeeHashMap* original_transformations,
                                                                              gboolean enhanced);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type,
                                                                                    Photo* photo,
                                                                                    Orientation orientation,
                                                                                    GeeHashMap* transformations,
                                                                                    PixelTransformer* transformer,
                                                                                    PixelTransformationBundle* adjustments,
                                                                                    GeeHashMap* original_transformations,
                                                                                    gboolean enhanced);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self,
                                          PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self,
                                               PhotoID* photo_id,
                                               Orientation orientation,
                                               GeeHashMap* transformations,
                                               GeeHashMap* original_transforms,
                                               gboolean enhanced);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self,
                                                 PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self,
                                      PhotoID* photo_id,
                                      Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self,
                   Rotation rotation);
static void photo_real_rotate (Photo* self,
                        Rotation rotation);
Orientation orientation_perform (Orientation self,
                                 Rotation rotation);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self,
                                         PhotoID* photo_id,
                                         KeyValueMap* map);
static gboolean photo_set_original_transforms (Photo* self,
                                        KeyValueMap* trans);
gboolean photo_table_set_original_transforms (PhotoTable* self,
                                              PhotoID* photo_id,
                                              KeyValueMap* map);
static gboolean photo_clear_original_transforms (Photo* self);
gboolean photo_table_remove_transformation (PhotoTable* self,
                                            PhotoID* photo_id,
                                            const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self,
                             Box* crop);
void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
gint key_value_map_get_int (KeyValueMap* self,
                            const gchar* key,
                            gint def);
static void photo_set_raw_crop (Photo* self,
                         Box* crop);
void key_value_map_set_int (KeyValueMap* self,
                            const gchar* key,
                            gint value);
static gboolean photo_get_raw_straighten (Photo* self,
                                   gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self,
                                  const gchar* key,
                                  gdouble def);
static void photo_set_raw_straighten (Photo* self,
                               gdouble theta);
void key_value_map_set_double (KeyValueMap* self,
                               const gchar* key,
                               gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self,
                                                            gint* result_length1);
void key_value_map_get_point (KeyValueMap* self,
                              const gchar* key,
                              GdkPoint* def,
                              GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self,
                                EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self,
                              const gchar* key,
                              GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self,
                                            Scaling* scaling,
                                            PhotoException exceptions,
                                            Dimensions* scaled_image,
                                            Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                                   Scaling* scaling,
                                                   PhotoException exceptions,
                                                   Dimensions* scaled_image,
                                                   Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self,
                             Dimensions* space,
                             Box* box,
                             Box* result);
void orientation_rotate_dimensions (Orientation self,
                                    Dimensions* dim,
                                    Dimensions* result);
void box_get_scaled (Box *self,
                     Dimensions* scaled,
                     Box* result);
void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self,
                                    Dimensions* original,
                                    Dimensions* scaled,
                                    Dimensions* result);
void orientation_derotate_dimensions (Orientation self,
                                      Dimensions* dim,
                                      Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self,
                                  Scaling* scaling,
                                  PhotoException exceptions,
                                  BackingFetchMode fetch_mode,
                                  GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self,
                                            GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self,
                                          Dimensions* full,
                                          Dimensions* scaled,
                                          GError** error);
gboolean dimensions_approx_equals (Dimensions *self,
                                   Dimensions* dim,
                                   gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self,
                                           Scaling* scaling,
                                           gboolean rotate,
                                           BackingFetchMode fetch_mode,
                                           GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self,
                                        Scaling* scaling,
                                        gboolean rotate,
                                        GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self,
                                      GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base,
                                  Scaling* scaling,
                                  GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
gboolean dimensions_equals (Dimensions *self,
                            Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self,
                            GdkPixbuf* pixbuf,
                            EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf,
                       gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self,
                                         GdkPixbuf* pixbuf,
                                         GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self,
                                              PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self,
                                                            GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self,
                                         GFile* file,
                                         gboolean export_metadata,
                                         GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
#define RESOURCES_APP_TITLE N_ ("Photos")
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self,
                                   Scaling* scaling,
                                   PhotoFileFormat export_format);
void photo_export (Photo* self,
                   GFile* dest_file,
                   Scaling* scaling,
                   JpegQuality quality,
                   PhotoFileFormat export_format,
                   gboolean direct_copy_unmodified,
                   gboolean export_metadata,
                   GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self,
                                         PhotoFileFormat* file_format,
                                         GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GError** error);
static gboolean photo_launch_editor (GFile* file,
                              PhotoFileFormat file_format,
                              const gchar* commandline,
                              GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self,
                                          const gchar* external_editor,
                                          GError** error);
void photo_open_with_external_editor (Photo* self,
                                      const gchar* external_editor,
                                      GError** error);
GFile* photo_get_modified_file (Photo* self,
                                GError** error);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self,
                            PhotoFileFormat file_format,
                            GFile* file,
                            GError** error);
static void photo_start_monitoring_editable (Photo* self,
                                      GFile* file,
                                      GError** error);
static void photo_on_editable_file_changed (Photo* self,
                                     GFile* file,
                                     GFile* other_file,
                                     GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                             GFile* file,
                                                             GFile* other_file,
                                                             GFileMonitorEvent event_type,
                                                             gpointer self);
static void photo_update_editable (Photo* self,
                            gboolean only_attributes,
                            PhotoFileReader* new_reader,
                            GError** error);
static void photo_update_editable_attributes (Photo* self,
                                       GError** error);
void photo_reimport_editable (Photo* self,
                              GError** error);
void photo_table_attach_editable (PhotoTable* self,
                                  PhotoRow* row,
                                  BackingPhotoID* editable_id,
                                  GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self,
                                            BackingPhotoID* id,
                                            time_t timestamp,
                                            gint64 filesize,
                                            GError** error);
static void _vala_array_add24 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add25 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add26 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add27 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add28 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add29 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void backing_photo_id_init (BackingPhotoID *self,
                            gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
void photo_get_master_dimensions (Photo* self,
                                  Dimensions* result);
void photo_set_crop (Photo* self,
                     Box* crop);
void orientation_derotate_box (Orientation self,
                               Dimensions* space,
                               Box* box,
                               Box* result);
void photo_set_straighten (Photo* self,
                           gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
void photo_unscaled_to_raw_point (Photo* self,
                                  GdkPoint* unscaled_point,
                                  GdkPoint* result);
void orientation_derotate_point (Orientation self,
                                 Dimensions* space,
                                 GdkPoint* point,
                                 GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
gboolean photo_unenhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self,
                                   GFile* old_file,
                                   GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self,
                                     PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self,
                                   PhotoMetadata* metadata);
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                                gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject * obj);
static void photo_backing_readers_finalize (PhotoBackingReaders * obj);
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState * obj);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj);
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj);
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj);
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                                                                                  PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                                                                        BackingPhotoRow* backing,
                                                                                                                        PhotoMetadata* metadata);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj);
static void photo_finalize (GObject * obj);
static void _vala_photo_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
gint int64_compare (gint64* a,
                    gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a,
                      gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a,
                                           gconstpointer b,
                                           gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source,
                                                     gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                                   GeeCollection* added,
                                                                   GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                         GeeCollection* added,
                                                                                                         GeeCollection* removed,
                                                                                                         gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                                  GeeCollection* added,
                                                                  GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                        GeeCollection* added,
                                                                                                        GeeCollection* removed,
                                                                                                        gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                                                      SourceHoldingTankCheckToKeep check_to_keep,
                                                                      gpointer check_to_keep_target,
                                                                      GetSourceDatabaseKey get_key,
                                                                      gpointer get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type,
                                                                            LibraryPhotoSourceCollection* sources,
                                                                            SourceHoldingTankCheckToKeep check_to_keep,
                                                                            gpointer check_to_keep_target,
                                                                            GetSourceDatabaseKey get_key,
                                                                            gpointer get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                                 DataSource* source,
                                                                 Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                                    Alteration* alteration,
                                                                                                    gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                         Workers* workers,
                                                                         GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers,
                                 GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type,
                                       Workers* workers,
                                       GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                                    DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                                  GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                                   GeeIterable* added,
                                                                   GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                           Photo* photo,
                                                           GFile* old_file,
                                                           GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                    GFile* old_file,
                                                                                    GFile* new_file,
                                                                                    gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                                  Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                  gpointer self);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base,
                                                         GeeMap* items);
gboolean alteration_has_detail (Alteration* self,
                                const gchar* subject,
                                const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                      GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self,
                                                 const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self,
                                                 const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self,
                      GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self,
                                                         GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                                    LibraryPhoto* photo,
                                                                    PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                      LibraryPhoto* photo,
                                                                      PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                                       gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                                      const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self,
                                                          gint64 numeric_id);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                          EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self,
                                                EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                                      GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                                             GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                      LibraryPhoto* photo,
                                                      GFileInfo* info,
                                                      GeeCollection* matches_master,
                                                      GeeCollection* matches_editable,
                                                      GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self,
                                              GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                                GFileInfo* info,
                                                                GeeCollection* matches_master,
                                                                GeeCollection* matches_editable,
                                                                GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                      const gchar* basename,
                                                                      gint64 filesize,
                                                                      PhotoID* result);
gint utf8_ci_compare (void* a,
                      void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                          const gchar* basename,
                                                                          gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                                       GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                            SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self,
                                         SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self,
                                           SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                           SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self,
                                          SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self,
                                        SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                          GValue * return_value,
                                                          guint n_param_values,
                                                          const GValue * param_values,
                                                          gpointer invocation_hint,
                                                          gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                             LibraryPhoto* photo,
                                                             PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection * obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type,
                                       PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type,
                                                          PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor,
                         gpointer monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto* * photo);
void photo_table_add (PhotoTable* self,
                      PhotoRow* photo_row,
                      PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self,
                         PhotoID* photo_id,
                         GError** error);
static void library_photo_real_notify_master_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base,
                                                  PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base,
                                                    PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source,
                                         gboolean force,
                                         GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base,
                                        Alteration* alteration);
gboolean alteration_has_subject (Alteration* self,
                                 const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self,
                                          gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base,
                                                  Scaling* scaling,
                                                  GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static void library_photo_real_rotate (Photo* base,
                                Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source,
                             Rotation rotation,
                             GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base,
                                             gint scale,
                                             GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                            BackingPhotoRow* backing,
                                            BackingPhotoID* result,
                                            GError** error);
GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self,
                                          gint64 current,
                                          gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                                   gint64 total_num_bytes,
                                                                   gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self,
                                       GError** error);
void photo_table_duplicate (PhotoTable* self,
                            PhotoID* photo_id,
                            const gchar* new_filename,
                            BackingPhotoID* editable_id,
                            BackingPhotoID* develop_shotwell,
                            BackingPhotoID* develop_camera_id,
                            BackingPhotoID* develop_embedded_id,
                            PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self,
                               PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source,
                                ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self,
                   MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self,
                                                 MediaSource* source);
void tag_attach (Tag* self,
                 MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base,
                                                     GError** error);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file,
                                               const gchar* thumbnail_md5,
                                               const gchar* full_md5,
                                               PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file,
                                           const gchar* thumbnail_md5,
                                           const gchar* full_md5,
                                           PhotoFileFormat file_format,
                                           PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base,
                                                      PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                          PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self,
                                       const gchar* name,
                                       gboolean treat_htags_as_root);
static void library_photo_finalize (GObject * obj);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                     GeeCollection* added,
                                                                     GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                             Photo* _photo,
                                                             GFile* old_file,
                                                             GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                      GFile* old_file,
                                                                                      GFile* new_file,
                                                                                      gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                                    Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                                    gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self,
                                                  GeeCollection* added,
                                                  GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType
backing_fetch_mode_get_type (void)
{
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 3833 "Photo.c"
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 61 "../src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 3841 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct (GType object_type,
                               GFile* file,
                               GFile* final_associated_file,
                               ImportID* import_id,
                               PhotoFileSnifferOptions sniffer_options,
                               const gchar* exif_md5,
                               const gchar* thumbnail_md5,
                               const gchar* full_md5,
                               Thumbnails* thumbnails)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	Thumbnails* _tmp6_;
#line 51 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 51 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 54 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 54 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 54 "../src/Photo.vala"
	self->file = _tmp0_;
#line 55 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (final_associated_file);
#line 55 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 55 "../src/Photo.vala"
	self->final_associated_file = _tmp1_;
#line 56 "../src/Photo.vala"
	_tmp2_ = *import_id;
#line 56 "../src/Photo.vala"
	self->import_id = _tmp2_;
#line 57 "../src/Photo.vala"
	self->sniffer_options = sniffer_options;
#line 58 "../src/Photo.vala"
	_tmp3_ = g_strdup (exif_md5);
#line 58 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 58 "../src/Photo.vala"
	self->exif_md5 = _tmp3_;
#line 59 "../src/Photo.vala"
	_tmp4_ = g_strdup (thumbnail_md5);
#line 59 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 59 "../src/Photo.vala"
	self->thumbnail_md5 = _tmp4_;
#line 60 "../src/Photo.vala"
	_tmp5_ = g_strdup (full_md5);
#line 60 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 60 "../src/Photo.vala"
	self->full_md5 = _tmp5_;
#line 61 "../src/Photo.vala"
	_tmp6_ = _thumbnails_ref0 (thumbnails);
#line 61 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 61 "../src/Photo.vala"
	self->thumbnails = _tmp6_;
#line 51 "../src/Photo.vala"
	return self;
#line 3913 "Photo.c"
}

PhotoImportParams*
photo_import_params_new (GFile* file,
                         GFile* final_associated_file,
                         ImportID* import_id,
                         PhotoFileSnifferOptions sniffer_options,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         Thumbnails* thumbnails)
{
#line 51 "../src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 3928 "Photo.c"
}

PhotoImportParams*
photo_import_params_construct_create_placeholder (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id)
{
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
#line 65 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "../src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 65 "../src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 66 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 66 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 66 "../src/Photo.vala"
	self->file = _tmp0_;
#line 67 "../src/Photo.vala"
	_tmp1_ = *import_id;
#line 67 "../src/Photo.vala"
	self->import_id = _tmp1_;
#line 68 "../src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 69 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 69 "../src/Photo.vala"
	self->exif_md5 = NULL;
#line 70 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 70 "../src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 71 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 71 "../src/Photo.vala"
	self->full_md5 = NULL;
#line 72 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 72 "../src/Photo.vala"
	self->thumbnails = NULL;
#line 65 "../src/Photo.vala"
	return self;
#line 3975 "Photo.c"
}

PhotoImportParams*
photo_import_params_new_create_placeholder (GFile* file,
                                            ImportID* import_id)
{
#line 65 "../src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 3984 "Photo.c"
}

static void
value_photo_import_params_init (GValue* value)
{
#line 34 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 3992 "Photo.c"
}

static void
value_photo_import_params_free_value (GValue* value)
{
#line 34 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 4002 "Photo.c"
	}
}

static void
value_photo_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 34 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 4014 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4018 "Photo.c"
	}
}

static gpointer
value_photo_import_params_peek_pointer (const GValue* value)
{
#line 34 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4027 "Photo.c"
}

static gchar*
value_photo_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 34 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 4038 "Photo.c"
		PhotoImportParams * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4045 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4049 "Photo.c"
		}
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 4053 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4057 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	return NULL;
#line 4061 "Photo.c"
}

static gchar*
value_photo_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	PhotoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (!object_p) {
#line 34 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4076 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/Photo.vala"
		*object_p = NULL;
#line 4082 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 4086 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 4090 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	return NULL;
#line 4094 "Photo.c"
}

GParamSpec*
param_spec_photo_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecPhotoImportParams* spec;
#line 34 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 4113 "Photo.c"
}

gpointer
value_get_photo_import_params (const GValue* value)
{
#line 34 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 4123 "Photo.c"
}

void
value_set_photo_import_params (GValue* value,
                               gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (v_object) {
#line 34 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 4145 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4149 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (old) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4155 "Photo.c"
	}
}

void
value_take_photo_import_params (GValue* value,
                                gpointer v_object)
{
	PhotoImportParams * old;
#line 34 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/Photo.vala"
	if (v_object) {
#line 34 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 4176 "Photo.c"
	} else {
#line 34 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 4180 "Photo.c"
	}
#line 34 "../src/Photo.vala"
	if (old) {
#line 34 "../src/Photo.vala"
		photo_import_params_unref (old);
#line 4186 "Photo.c"
	}
}

static void
photo_import_params_class_init (PhotoImportParamsClass * klass,
                                gpointer klass_data)
{
#line 34 "../src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 4198 "Photo.c"
}

static void
photo_import_params_instance_init (PhotoImportParams * self,
                                   gpointer klass)
{
	PhotoRow* _tmp0_;
#line 37 "../src/Photo.vala"
	self->final_associated_file = NULL;
#line 48 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 48 "../src/Photo.vala"
	self->row = _tmp0_;
#line 49 "../src/Photo.vala"
	self->keywords = NULL;
#line 34 "../src/Photo.vala"
	self->ref_count = 1;
#line 4216 "Photo.c"
}

static void
photo_import_params_finalize (PhotoImportParams * obj)
{
	PhotoImportParams * self;
#line 34 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 34 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 36 "../src/Photo.vala"
	_g_object_unref0 (self->file);
#line 37 "../src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 40 "../src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "../src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "../src/Photo.vala"
	_g_free0 (self->full_md5);
#line 45 "../src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 49 "../src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 4243 "Photo.c"
}

GType
photo_import_params_get_type (void)
{
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}

gpointer
photo_import_params_ref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/Photo.vala"
	return instance;
#line 4270 "Photo.c"
}

void
photo_import_params_unref (gpointer instance)
{
	PhotoImportParams * self;
	self = instance;
#line 34 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 34 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4284 "Photo.c"
	}
}

static inline gpointer
photo_transformation_state_get_instance_private (PhotoTransformationState* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoTransformationState_private_offset);
}

PhotoTransformationState*
photo_transformation_state_construct (GType object_type)
{
	PhotoTransformationState * self = NULL;
#line 85 "../src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 85 "../src/Photo.vala"
	return self;
#line 4302 "Photo.c"
}

gboolean
photo_transformation_state_is_broken (PhotoTransformationState* self)
{
	gboolean result = FALSE;
#line 88 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/Photo.vala"
	result = self->priv->is_broke;
#line 89 "../src/Photo.vala"
	return result;
#line 4315 "Photo.c"
}

static void
photo_transformation_state_real_broken (PhotoTransformationState* self)
{
#line 82 "../src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 4323 "Photo.c"
}

static void
photo_transformation_state_class_init (PhotoTransformationStateClass * klass,
                                       gpointer klass_data)
{
#line 76 "../src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 76 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoTransformationState_private_offset);
#line 76 "../src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 76 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 76 "../src/Photo.vala"
	photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL] = g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4340 "Photo.c"
}

static void
photo_transformation_state_instance_init (PhotoTransformationState * self,
                                          gpointer klass)
{
#line 76 "../src/Photo.vala"
	self->priv = photo_transformation_state_get_instance_private (self);
#line 77 "../src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 4351 "Photo.c"
}

static void
photo_transformation_state_finalize (GObject * obj)
{
	PhotoTransformationState * self;
#line 76 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 76 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 4362 "Photo.c"
}

GType
photo_transformation_state_get_type (void)
{
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		PhotoTransformationState_private_offset = g_type_add_instance_private (photo_transformation_state_type_id, sizeof (PhotoTransformationStatePrivate));
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}

static inline gpointer
photo_get_instance_private (Photo* self)
{
	return G_STRUCT_MEMBER_P (self, Photo_private_offset);
}

gboolean
photo_exception_prohibits (PhotoException self,
                           PhotoException exception)
{
	gboolean result = FALSE;
#line 160 "../src/Photo.vala"
	result = (self & exception) != 0;
#line 160 "../src/Photo.vala"
	return result;
#line 4394 "Photo.c"
}

gboolean
photo_exception_allows (PhotoException self,
                        PhotoException exception)
{
	gboolean result = FALSE;
#line 164 "../src/Photo.vala"
	result = (self & exception) == 0;
#line 164 "../src/Photo.vala"
	return result;
#line 4406 "Photo.c"
}

GType
photo_exception_get_type (void)
{
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}

static gpointer
_photo_row_ref0 (gpointer self)
{
#line 335 "../src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 4427 "Photo.c"
}

static gpointer
_backing_photo_row_ref0 (gpointer self)
{
#line 356 "../src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 4435 "Photo.c"
}

Photo*
photo_construct (GType object_type,
                 PhotoRow* row)
{
	Photo * self = NULL;
	PhotoRow* _tmp0_;
	PhotoRow* _tmp1_;
	PhotoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PhotoRow* _tmp5_;
	PhotoRow* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	PhotoBackingReaders* _tmp9_;
	BackingPhotoRow* _tmp10_;
	PhotoFileFormat _tmp11_;
	BackingPhotoRow* _tmp12_;
	const gchar* _tmp13_;
	PhotoFileReader* _tmp14_;
	gchar* basename = NULL;
	BackingPhotoRow* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp21_;
	BackingPhotoID _tmp25_;
	BackingPhotoRow* _tmp40_;
	PhotoFileFormat _tmp41_;
	gboolean _tmp55_ = FALSE;
	BackingPhotoRow* _tmp56_;
	PhotoFileFormat _tmp57_;
	PhotoBackingReaders* _tmp69_;
	PhotoFileReader* _tmp70_;
	PhotoRow* _tmp86_;
	GError* _inner_error0_ = NULL;
#line 334 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "../src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 335 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 335 "../src/Photo.vala"
	self->row = _tmp0_;
#line 338 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 338 "../src/Photo.vala"
	_tmp2_ = self->row;
#line 338 "../src/Photo.vala"
	_tmp3_ = _tmp2_->title;
#line 338 "../src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 338 "../src/Photo.vala"
	_g_free0 (_tmp1_->title);
#line 338 "../src/Photo.vala"
	_tmp1_->title = _tmp4_;
#line 339 "../src/Photo.vala"
	_tmp5_ = self->row;
#line 339 "../src/Photo.vala"
	_tmp6_ = self->row;
#line 339 "../src/Photo.vala"
	_tmp7_ = _tmp6_->comment;
#line 339 "../src/Photo.vala"
	_tmp8_ = media_source_prep_comment (_tmp7_);
#line 339 "../src/Photo.vala"
	_g_free0 (_tmp5_->comment);
#line 339 "../src/Photo.vala"
	_tmp5_->comment = _tmp8_;
#line 343 "../src/Photo.vala"
	_tmp9_ = self->priv->readers;
#line 343 "../src/Photo.vala"
	_tmp10_ = row->master;
#line 343 "../src/Photo.vala"
	_tmp11_ = _tmp10_->file_format;
#line 343 "../src/Photo.vala"
	_tmp12_ = row->master;
#line 343 "../src/Photo.vala"
	_tmp13_ = _tmp12_->filepath;
#line 343 "../src/Photo.vala"
	_tmp14_ = photo_file_format_create_reader (_tmp11_, _tmp13_);
#line 343 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_->master);
#line 343 "../src/Photo.vala"
	_tmp9_->master = _tmp14_;
#line 346 "../src/Photo.vala"
	_tmp15_ = row->master;
#line 346 "../src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 346 "../src/Photo.vala"
	_tmp17_ = string_sliced_at_last_char (_tmp16_, (gunichar) G_DIR_SEPARATOR, 0);
#line 346 "../src/Photo.vala"
	basename = _tmp17_;
#line 347 "../src/Photo.vala"
	_tmp18_ = basename;
#line 347 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 4536 "Photo.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 348 "../src/Photo.vala"
		_tmp19_ = basename;
#line 348 "../src/Photo.vala"
		_tmp20_ = string_sliced_at (_tmp19_, 1);
#line 348 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 348 "../src/Photo.vala"
		self->priv->file_title = _tmp20_;
#line 4547 "Photo.c"
	}
#line 350 "../src/Photo.vala"
	_tmp21_ = self->priv->file_title;
#line 350 "../src/Photo.vala"
	if (is_string_empty (_tmp21_)) {
#line 4553 "Photo.c"
		BackingPhotoRow* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 351 "../src/Photo.vala"
		_tmp22_ = row->master;
#line 351 "../src/Photo.vala"
		_tmp23_ = _tmp22_->filepath;
#line 351 "../src/Photo.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 351 "../src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 351 "../src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 4567 "Photo.c"
	}
#line 353 "../src/Photo.vala"
	_tmp25_ = row->editable_id;
#line 353 "../src/Photo.vala"
	if (_tmp25_.id != BACKING_PHOTO_ID_INVALID) {
#line 4573 "Photo.c"
		BackingPhotoRow* e = NULL;
		BackingPhotoID _tmp26_;
		BackingPhotoRow* _tmp27_;
		BackingPhotoRow* _tmp28_;
#line 354 "../src/Photo.vala"
		_tmp26_ = row->editable_id;
#line 354 "../src/Photo.vala"
		_tmp27_ = photo_get_backing_row (self, &_tmp26_);
#line 354 "../src/Photo.vala"
		e = _tmp27_;
#line 355 "../src/Photo.vala"
		_tmp28_ = e;
#line 355 "../src/Photo.vala"
		if (_tmp28_ != NULL) {
#line 4588 "Photo.c"
			BackingPhotoRow* _tmp29_;
			BackingPhotoRow* _tmp30_;
			PhotoBackingReaders* _tmp31_;
			BackingPhotoRow* _tmp32_;
			PhotoFileFormat _tmp33_;
			BackingPhotoRow* _tmp34_;
			const gchar* _tmp35_;
			PhotoFileReader* _tmp36_;
#line 356 "../src/Photo.vala"
			_tmp29_ = e;
#line 356 "../src/Photo.vala"
			_tmp30_ = _backing_photo_row_ref0 (_tmp29_);
#line 356 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 356 "../src/Photo.vala"
			self->priv->editable = _tmp30_;
#line 357 "../src/Photo.vala"
			_tmp31_ = self->priv->readers;
#line 357 "../src/Photo.vala"
			_tmp32_ = self->priv->editable;
#line 357 "../src/Photo.vala"
			_tmp33_ = _tmp32_->file_format;
#line 357 "../src/Photo.vala"
			_tmp34_ = self->priv->editable;
#line 357 "../src/Photo.vala"
			_tmp35_ = _tmp34_->filepath;
#line 357 "../src/Photo.vala"
			_tmp36_ = photo_file_format_create_reader (_tmp33_, _tmp35_);
#line 357 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp31_->editable);
#line 357 "../src/Photo.vala"
			_tmp31_->editable = _tmp36_;
#line 4621 "Photo.c"
		} else {
			{
				PhotoTable* _tmp37_;
				PhotoTable* _tmp38_;
				PhotoRow* _tmp39_;
#line 360 "../src/Photo.vala"
				_tmp37_ = photo_table_get_instance ();
#line 360 "../src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 360 "../src/Photo.vala"
				_tmp39_ = self->row;
#line 360 "../src/Photo.vala"
				photo_table_detach_editable (_tmp38_, _tmp39_, &_inner_error0_);
#line 360 "../src/Photo.vala"
				_database_table_unref0 (_tmp38_);
#line 360 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 360 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 4641 "Photo.c"
						goto __catch88_database_error;
					}
#line 360 "../src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 360 "../src/Photo.vala"
					_g_free0 (basename);
#line 360 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 360 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 360 "../src/Photo.vala"
					return NULL;
#line 4654 "Photo.c"
				}
			}
			goto __finally88;
			__catch88_database_error:
			{
				GError* err = NULL;
#line 359 "../src/Photo.vala"
				err = _inner_error0_;
#line 359 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 359 "../src/Photo.vala"
				_g_error_free0 (err);
#line 4667 "Photo.c"
			}
			__finally88:
#line 359 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 359 "../src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 359 "../src/Photo.vala"
				_g_free0 (basename);
#line 359 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 359 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 359 "../src/Photo.vala"
				return NULL;
#line 4682 "Photo.c"
			}
#line 367 "../src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 4686 "Photo.c"
		}
#line 353 "../src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 4690 "Photo.c"
	}
#line 371 "../src/Photo.vala"
	_tmp40_ = row->master;
#line 371 "../src/Photo.vala"
	_tmp41_ = _tmp40_->file_format;
#line 371 "../src/Photo.vala"
	if (_tmp41_ == PHOTO_FILE_FORMAT_RAW) {
#line 4698 "Photo.c"
		GeeHashMap* _tmp42_;
		gint _tmp43_ = 0;
		RawDeveloper* _tmp44_;
#line 373 "../src/Photo.vala"
		_tmp42_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "../src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 373 "../src/Photo.vala"
		self->priv->developments = _tmp42_;
#line 374 "../src/Photo.vala"
		_tmp44_ = raw_developer_as_array (&_tmp43_);
#line 4710 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 374 "../src/Photo.vala"
			d_collection = _tmp44_;
#line 374 "../src/Photo.vala"
			d_collection_length1 = _tmp43_;
#line 374 "../src/Photo.vala"
			for (d_it = 0; d_it < _tmp43_; d_it = d_it + 1) {
#line 4722 "Photo.c"
				RawDeveloper d = 0;
#line 374 "../src/Photo.vala"
				d = d_collection[d_it];
#line 4726 "Photo.c"
				{
					BackingPhotoID id = {0};
					BackingPhotoID* _tmp45_;
					gint _tmp45__length1;
					RawDeveloper _tmp46_;
					BackingPhotoID _tmp47_;
					BackingPhotoID _tmp48_;
#line 375 "../src/Photo.vala"
					_tmp45_ = row->development_ids;
#line 375 "../src/Photo.vala"
					_tmp45__length1 = row->development_ids_length1;
#line 375 "../src/Photo.vala"
					_tmp46_ = d;
#line 375 "../src/Photo.vala"
					_tmp47_ = _tmp45_[_tmp46_];
#line 375 "../src/Photo.vala"
					id = _tmp47_;
#line 376 "../src/Photo.vala"
					_tmp48_ = id;
#line 376 "../src/Photo.vala"
					if (_tmp48_.id != BACKING_PHOTO_ID_INVALID) {
#line 4748 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp49_;
						BackingPhotoRow* _tmp50_;
						BackingPhotoRow* _tmp51_;
#line 377 "../src/Photo.vala"
						_tmp49_ = id;
#line 377 "../src/Photo.vala"
						_tmp50_ = photo_get_backing_row (self, &_tmp49_);
#line 377 "../src/Photo.vala"
						bpr = _tmp50_;
#line 378 "../src/Photo.vala"
						_tmp51_ = bpr;
#line 378 "../src/Photo.vala"
						if (_tmp51_ != NULL) {
#line 4763 "Photo.c"
							GeeHashMap* _tmp52_;
							RawDeveloper _tmp53_;
							BackingPhotoRow* _tmp54_;
#line 379 "../src/Photo.vala"
							_tmp52_ = self->priv->developments;
#line 379 "../src/Photo.vala"
							_tmp53_ = d;
#line 379 "../src/Photo.vala"
							_tmp54_ = bpr;
#line 379 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp52_, (gpointer) ((gintptr) _tmp53_), _tmp54_);
#line 4775 "Photo.c"
						}
#line 376 "../src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 4779 "Photo.c"
					}
				}
			}
#line 374 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4785 "Photo.c"
		}
	}
#line 385 "../src/Photo.vala"
	_tmp56_ = row->master;
#line 385 "../src/Photo.vala"
	_tmp57_ = _tmp56_->file_format;
#line 385 "../src/Photo.vala"
	if (_tmp57_ == PHOTO_FILE_FORMAT_RAW) {
#line 4794 "Photo.c"
		GeeHashMap* _tmp58_;
		RawDeveloper _tmp59_;
#line 385 "../src/Photo.vala"
		_tmp58_ = self->priv->developments;
#line 385 "../src/Photo.vala"
		_tmp59_ = row->developer;
#line 385 "../src/Photo.vala"
		_tmp55_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp58_, (gpointer) ((gintptr) _tmp59_));
#line 4803 "Photo.c"
	} else {
#line 385 "../src/Photo.vala"
		_tmp55_ = FALSE;
#line 4807 "Photo.c"
	}
#line 385 "../src/Photo.vala"
	if (_tmp55_) {
#line 4811 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp60_;
		RawDeveloper _tmp61_;
		gpointer _tmp62_;
		PhotoBackingReaders* _tmp63_;
		BackingPhotoRow* _tmp64_;
		PhotoFileFormat _tmp65_;
		BackingPhotoRow* _tmp66_;
		const gchar* _tmp67_;
		PhotoFileReader* _tmp68_;
#line 386 "../src/Photo.vala"
		_tmp60_ = self->priv->developments;
#line 386 "../src/Photo.vala"
		_tmp61_ = row->developer;
#line 386 "../src/Photo.vala"
		_tmp62_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp60_, (gpointer) ((gintptr) _tmp61_));
#line 386 "../src/Photo.vala"
		r = (BackingPhotoRow*) _tmp62_;
#line 387 "../src/Photo.vala"
		_tmp63_ = self->priv->readers;
#line 387 "../src/Photo.vala"
		_tmp64_ = r;
#line 387 "../src/Photo.vala"
		_tmp65_ = _tmp64_->file_format;
#line 387 "../src/Photo.vala"
		_tmp66_ = r;
#line 387 "../src/Photo.vala"
		_tmp67_ = _tmp66_->filepath;
#line 387 "../src/Photo.vala"
		_tmp68_ = photo_file_format_create_reader (_tmp65_, _tmp67_);
#line 387 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp63_->developer);
#line 387 "../src/Photo.vala"
		_tmp63_->developer = _tmp68_;
#line 385 "../src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 4848 "Photo.c"
	}
#line 391 "../src/Photo.vala"
	_tmp69_ = self->priv->readers;
#line 391 "../src/Photo.vala"
	_tmp70_ = _tmp69_->editable;
#line 391 "../src/Photo.vala"
	if (_tmp70_ != NULL) {
#line 4856 "Photo.c"
		BackingPhotoRow* _tmp71_;
		BackingPhotoRow* _tmp72_;
#line 392 "../src/Photo.vala"
		_tmp71_ = self->priv->editable;
#line 392 "../src/Photo.vala"
		_tmp72_ = _backing_photo_row_ref0 (_tmp71_);
#line 392 "../src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 392 "../src/Photo.vala"
		self->backing_photo_row = _tmp72_;
#line 4867 "Photo.c"
	} else {
		BackingPhotoRow* _tmp73_;
		PhotoFileFormat _tmp74_;
#line 393 "../src/Photo.vala"
		_tmp73_ = row->master;
#line 393 "../src/Photo.vala"
		_tmp74_ = _tmp73_->file_format;
#line 393 "../src/Photo.vala"
		if (_tmp74_ != PHOTO_FILE_FORMAT_RAW) {
#line 4877 "Photo.c"
			PhotoRow* _tmp75_;
			BackingPhotoRow* _tmp76_;
			BackingPhotoRow* _tmp77_;
#line 394 "../src/Photo.vala"
			_tmp75_ = self->row;
#line 394 "../src/Photo.vala"
			_tmp76_ = _tmp75_->master;
#line 394 "../src/Photo.vala"
			_tmp77_ = _backing_photo_row_ref0 (_tmp76_);
#line 394 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 394 "../src/Photo.vala"
			self->backing_photo_row = _tmp77_;
#line 4891 "Photo.c"
		} else {
			GeeHashMap* _tmp78_;
			RawDeveloper _tmp79_;
#line 398 "../src/Photo.vala"
			_tmp78_ = self->priv->developments;
#line 398 "../src/Photo.vala"
			_tmp79_ = row->developer;
#line 398 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp78_, (gpointer) ((gintptr) _tmp79_))) {
#line 4901 "Photo.c"
				GeeHashMap* _tmp80_;
				RawDeveloper _tmp81_;
				gpointer _tmp82_;
#line 399 "../src/Photo.vala"
				_tmp80_ = self->priv->developments;
#line 399 "../src/Photo.vala"
				_tmp81_ = row->developer;
#line 399 "../src/Photo.vala"
				_tmp82_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp80_, (gpointer) ((gintptr) _tmp81_));
#line 399 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 399 "../src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp82_;
#line 4915 "Photo.c"
			} else {
				PhotoRow* _tmp83_;
				BackingPhotoRow* _tmp84_;
				BackingPhotoRow* _tmp85_;
#line 402 "../src/Photo.vala"
				_tmp83_ = self->row;
#line 402 "../src/Photo.vala"
				_tmp84_ = _tmp83_->master;
#line 402 "../src/Photo.vala"
				_tmp85_ = _backing_photo_row_ref0 (_tmp84_);
#line 402 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 402 "../src/Photo.vala"
				self->backing_photo_row = _tmp85_;
#line 4930 "Photo.c"
			}
		}
	}
#line 406 "../src/Photo.vala"
	_tmp86_ = self->row;
#line 406 "../src/Photo.vala"
	self->priv->cached_exposure_time = _tmp86_->exposure_time;
#line 334 "../src/Photo.vala"
	_g_free0 (basename);
#line 334 "../src/Photo.vala"
	return self;
#line 4942 "Photo.c"
}

static void
photo_real_notify_editable_replaced (Photo* self,
                                     GFile* old_file,
                                     GFile* new_file)
{
#line 410 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL], 0, old_file, new_file);
#line 4952 "Photo.c"
}

void
photo_notify_editable_replaced (Photo* self,
                                GFile* old_file,
                                GFile* new_file)
{
#line 409 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 409 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 4964 "Photo.c"
}

static void
photo_real_notify_raw_development_modified (Photo* self)
{
#line 414 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL], 0);
#line 4972 "Photo.c"
}

void
photo_notify_raw_development_modified (Photo* self)
{
#line 413 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 4982 "Photo.c"
}

static void
photo_real_notify_baseline_replaced (Photo* self)
{
#line 418 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL], 0);
#line 4990 "Photo.c"
}

void
photo_notify_baseline_replaced (Photo* self)
{
#line 417 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 5000 "Photo.c"
}

static void
photo_real_notify_master_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 422 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL], 0, metadata);
#line 5009 "Photo.c"
}

void
photo_notify_master_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 421 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 421 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 5020 "Photo.c"
}

static void
photo_real_notify_editable_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 426 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL], 0, metadata);
#line 5029 "Photo.c"
}

void
photo_notify_editable_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 425 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 5040 "Photo.c"
}

static void
photo_real_notify_source_reimported (Photo* self,
                                     PhotoMetadata* metadata)
{
#line 430 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL], 0, metadata);
#line 5049 "Photo.c"
}

void
photo_notify_source_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
#line 429 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 5060 "Photo.c"
}

static void
photo_real_notify_baseline_reimported (Photo* self,
                                       PhotoMetadata* metadata)
{
#line 434 "../src/Photo.vala"
	g_signal_emit (self, photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL], 0, metadata);
#line 5069 "Photo.c"
}

void
photo_notify_baseline_reimported (Photo* self,
                                  PhotoMetadata* metadata)
{
#line 433 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 5080 "Photo.c"
}

static gboolean
photo_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 437 "../src/Photo.vala"
	self = (Photo*) base;
#line 438 "../src/Photo.vala"
	ret = TRUE;
#line 439 "../src/Photo.vala"
	file = NULL;
#line 5100 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 440 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 440 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5107 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 441 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 441 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 441 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 5117 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 442 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 442 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 442 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 442 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 442 "../src/Photo.vala"
				file = _tmp5_;
#line 5131 "Photo.c"
			}
		}
		__finally89:
		{
			PhotoBackingReaders* _tmp6_;
#line 440 "../src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 440 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5141 "Photo.c"
		}
#line 440 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5145 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 440 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 440 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 440 "../src/Photo.vala"
			return _tmp7_;
#line 5153 "Photo.c"
		}
	}
#line 445 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 447 "../src/Photo.vala"
	if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 5160 "Photo.c"
		gint _tmp8_ = 0;
		RawDeveloper* _tmp9_;
#line 448 "../src/Photo.vala"
		_tmp9_ = raw_developer_as_array (&_tmp8_);
#line 5165 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 448 "../src/Photo.vala"
			d_collection = _tmp9_;
#line 448 "../src/Photo.vala"
			d_collection_length1 = _tmp8_;
#line 448 "../src/Photo.vala"
			for (d_it = 0; d_it < _tmp8_; d_it = d_it + 1) {
#line 5177 "Photo.c"
				RawDeveloper d = 0;
#line 448 "../src/Photo.vala"
				d = d_collection[d_it];
#line 5181 "Photo.c"
				{
					RawDeveloper _tmp10_;
#line 449 "../src/Photo.vala"
					_tmp10_ = d;
#line 449 "../src/Photo.vala"
					photo_delete_raw_development (self, _tmp10_);
#line 5188 "Photo.c"
				}
			}
#line 448 "../src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 5193 "Photo.c"
		}
	}
#line 453 "../src/Photo.vala"
	media_source_delete_original_file ((MediaSource*) self);
#line 456 "../src/Photo.vala"
	_tmp12_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_inner_error0_);
#line 456 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5202 "Photo.c"
		gboolean _tmp13_ = FALSE;
#line 456 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 456 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 456 "../src/Photo.vala"
		return _tmp13_;
#line 5210 "Photo.c"
	}
#line 456 "../src/Photo.vala"
	if (_tmp12_) {
#line 456 "../src/Photo.vala"
		_tmp11_ = ret;
#line 5216 "Photo.c"
	} else {
#line 456 "../src/Photo.vala"
		_tmp11_ = FALSE;
#line 5220 "Photo.c"
	}
#line 456 "../src/Photo.vala"
	result = _tmp11_;
#line 456 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 456 "../src/Photo.vala"
	return result;
#line 5228 "Photo.c"
}

static BackingPhotoRow*
photo_get_backing_row (Photo* self,
                       BackingPhotoID* id)
{
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 461 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 462 "../src/Photo.vala"
	_tmp0_ = *id;
#line 462 "../src/Photo.vala"
	if (_tmp0_.id == BACKING_PHOTO_ID_INVALID) {
#line 463 "../src/Photo.vala"
		result = NULL;
#line 463 "../src/Photo.vala"
		return result;
#line 5252 "Photo.c"
	}
#line 466 "../src/Photo.vala"
	backing_row = NULL;
#line 5256 "Photo.c"
	{
		BackingPhotoRow* _tmp1_ = NULL;
		BackingPhotoTable* _tmp2_;
		BackingPhotoTable* _tmp3_;
		BackingPhotoID _tmp4_;
		BackingPhotoRow* _tmp5_;
		BackingPhotoRow* _tmp6_;
		BackingPhotoRow* _tmp7_;
#line 468 "../src/Photo.vala"
		_tmp2_ = backing_photo_table_get_instance ();
#line 468 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 468 "../src/Photo.vala"
		_tmp4_ = *id;
#line 468 "../src/Photo.vala"
		_tmp5_ = backing_photo_table_fetch (_tmp3_, &_tmp4_, &_inner_error0_);
#line 468 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 468 "../src/Photo.vala"
		_database_table_unref0 (_tmp3_);
#line 468 "../src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 468 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 468 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5283 "Photo.c"
				goto __catch90_database_error;
			}
#line 468 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 468 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 468 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 468 "../src/Photo.vala"
			return NULL;
#line 5294 "Photo.c"
		}
#line 468 "../src/Photo.vala"
		_tmp7_ = _tmp1_;
#line 468 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 468 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 468 "../src/Photo.vala"
		backing_row = _tmp7_;
#line 467 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp1_);
#line 5306 "Photo.c"
	}
	goto __finally90;
	__catch90_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 467 "../src/Photo.vala"
		err = _inner_error0_;
#line 467 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 470 "../src/Photo.vala"
		_tmp8_ = data_object_to_string ((DataObject*) self);
#line 470 "../src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 470 "../src/Photo.vala"
		_tmp10_ = err;
#line 470 "../src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 470 "../src/Photo.vala"
		g_warning ("Photo.vala:470: Unable to fetch backing state for %s: %s", _tmp9_, _tmp11_);
#line 470 "../src/Photo.vala"
		_g_free0 (_tmp9_);
#line 467 "../src/Photo.vala"
		_g_error_free0 (err);
#line 5334 "Photo.c"
	}
	__finally90:
#line 467 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 467 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 467 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 467 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 467 "../src/Photo.vala"
		return NULL;
#line 5347 "Photo.c"
	}
#line 473 "../src/Photo.vala"
	_tmp12_ = backing_row;
#line 473 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 5353 "Photo.c"
		{
			BackingPhotoTable* _tmp13_;
			BackingPhotoTable* _tmp14_;
			BackingPhotoID _tmp15_;
#line 475 "../src/Photo.vala"
			_tmp13_ = backing_photo_table_get_instance ();
#line 475 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 475 "../src/Photo.vala"
			_tmp15_ = *id;
#line 475 "../src/Photo.vala"
			backing_photo_table_remove (_tmp14_, &_tmp15_, &_inner_error0_);
#line 475 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 475 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 5372 "Photo.c"
					goto __catch91_database_error;
				}
#line 475 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 475 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 475 "../src/Photo.vala"
				return NULL;
#line 5383 "Photo.c"
			}
		}
		goto __finally91;
		__catch91_database_error:
		{
			GError* err = NULL;
#line 474 "../src/Photo.vala"
			err = _inner_error0_;
#line 474 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 474 "../src/Photo.vala"
			_g_error_free0 (err);
#line 5396 "Photo.c"
		}
		__finally91:
#line 474 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 474 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 474 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 474 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 474 "../src/Photo.vala"
			return NULL;
#line 5409 "Photo.c"
		}
#line 479 "../src/Photo.vala"
		result = NULL;
#line 479 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 479 "../src/Photo.vala"
		return result;
#line 5417 "Photo.c"
	}
#line 482 "../src/Photo.vala"
	result = backing_row;
#line 482 "../src/Photo.vala"
	return result;
#line 5423 "Photo.c"
}

gboolean
photo_is_raw_developer_complete (Photo* self,
                                 RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 487 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5434 "Photo.c"
	{
		GeeHashMap* _tmp0_;
		gboolean _tmp9_ = FALSE;
#line 488 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 488 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5442 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_;
#line 489 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 489 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d))) {
#line 5450 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
				BackingPhotoRow* _tmp5_;
				const gchar* _tmp6_;
#line 490 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 490 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 490 "../src/Photo.vala"
				_tmp5_ = (BackingPhotoRow*) _tmp4_;
#line 490 "../src/Photo.vala"
				_tmp6_ = _tmp5_->filepath;
#line 490 "../src/Photo.vala"
				_tmp1_ = g_file_test (_tmp6_, G_FILE_TEST_EXISTS);
#line 490 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp5_);
#line 5467 "Photo.c"
			} else {
#line 489 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 5471 "Photo.c"
			}
#line 489 "../src/Photo.vala"
			result = _tmp1_;
#line 5475 "Photo.c"
			{
				GeeHashMap* _tmp7_;
#line 488 "../src/Photo.vala"
				_tmp7_ = self->priv->developments;
#line 488 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5482 "Photo.c"
			}
#line 489 "../src/Photo.vala"
			return result;
#line 5486 "Photo.c"
		}
		__finally92:
		{
			GeeHashMap* _tmp8_;
#line 488 "../src/Photo.vala"
			_tmp8_ = self->priv->developments;
#line 488 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5495 "Photo.c"
		}
#line 488 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 488 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 488 "../src/Photo.vala"
		return _tmp9_;
#line 5503 "Photo.c"
	}
}

gboolean
photo_is_raw_developer_available (Photo* self,
                                  RawDeveloper d)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 495 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5515 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 496 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 496 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5522 "Photo.c"
		{
			GeeHashMap* _tmp1_;
#line 497 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 497 "../src/Photo.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 498 "../src/Photo.vala"
				result = TRUE;
#line 5531 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 496 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 496 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5538 "Photo.c"
				}
#line 498 "../src/Photo.vala"
				return result;
#line 5542 "Photo.c"
			}
		}
		__finally93:
		{
			GeeHashMap* _tmp3_;
#line 496 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 496 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5552 "Photo.c"
		}
#line 496 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5556 "Photo.c"
			gboolean _tmp4_ = FALSE;
#line 496 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 496 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 496 "../src/Photo.vala"
			return _tmp4_;
#line 5564 "Photo.c"
		}
	}
#line 502 "../src/Photo.vala"
	switch (d) {
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5571 "Photo.c"
		{
#line 504 "../src/Photo.vala"
			result = TRUE;
#line 504 "../src/Photo.vala"
			return result;
#line 5577 "Photo.c"
		}
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5581 "Photo.c"
		{
#line 507 "../src/Photo.vala"
			result = FALSE;
#line 507 "../src/Photo.vala"
			return result;
#line 5587 "Photo.c"
		}
#line 502 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5591 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp5_;
				guint num_previews = 0U;
				PhotoMetadata* _tmp6_;
#line 511 "../src/Photo.vala"
				_tmp5_ = photo_get_master_metadata (self, &_inner_error0_);
#line 511 "../src/Photo.vala"
				meta = _tmp5_;
#line 511 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5604 "Photo.c"
					goto __catch94_g_error;
				}
#line 512 "../src/Photo.vala"
				_tmp6_ = meta;
#line 512 "../src/Photo.vala"
				num_previews = photo_metadata_get_preview_count (_tmp6_);
#line 514 "../src/Photo.vala"
				if (num_previews > ((guint) 0)) {
#line 5613 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp7_;
					PhotoPreview* _tmp8_;
					PhotoPreview* _tmp9_;
					Dimensions dims = {0};
					PhotoPreview* _tmp10_;
					Dimensions _tmp11_ = {0};
					gint _tmp12_ = 0;
					Dimensions _tmp13_;
					Dimensions _tmp14_;
					gint preview_major_axis = 0;
#line 515 "../src/Photo.vala"
					_tmp7_ = meta;
#line 515 "../src/Photo.vala"
					_tmp8_ = photo_metadata_get_preview (_tmp7_, num_previews - 1);
#line 515 "../src/Photo.vala"
					prev = _tmp8_;
#line 518 "../src/Photo.vala"
					_tmp9_ = prev;
#line 518 "../src/Photo.vala"
					if (_tmp9_ == NULL) {
#line 519 "../src/Photo.vala"
						result = FALSE;
#line 519 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 519 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 519 "../src/Photo.vala"
						return result;
#line 5643 "Photo.c"
					}
#line 522 "../src/Photo.vala"
					_tmp10_ = prev;
#line 522 "../src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp10_, &_tmp11_);
#line 522 "../src/Photo.vala"
					dims = _tmp11_;
#line 525 "../src/Photo.vala"
					_tmp13_ = dims;
#line 525 "../src/Photo.vala"
					_tmp14_ = dims;
#line 525 "../src/Photo.vala"
					if (_tmp13_.width > _tmp14_.height) {
#line 5657 "Photo.c"
						Dimensions _tmp15_;
#line 525 "../src/Photo.vala"
						_tmp15_ = dims;
#line 525 "../src/Photo.vala"
						_tmp12_ = _tmp15_.width;
#line 5663 "Photo.c"
					} else {
						Dimensions _tmp16_;
#line 525 "../src/Photo.vala"
						_tmp16_ = dims;
#line 525 "../src/Photo.vala"
						_tmp12_ = _tmp16_.height;
#line 5670 "Photo.c"
					}
#line 525 "../src/Photo.vala"
					preview_major_axis = _tmp12_;
#line 526 "../src/Photo.vala"
					if (preview_major_axis < PHOTO_MIN_EMBEDDED_SIZE) {
#line 527 "../src/Photo.vala"
						result = FALSE;
#line 527 "../src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 527 "../src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 527 "../src/Photo.vala"
						return result;
#line 5684 "Photo.c"
					}
#line 531 "../src/Photo.vala"
					result = TRUE;
#line 531 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 531 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 531 "../src/Photo.vala"
					return result;
#line 5694 "Photo.c"
				}
#line 535 "../src/Photo.vala"
				result = FALSE;
#line 535 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 535 "../src/Photo.vala"
				return result;
#line 5702 "Photo.c"
			}
			goto __finally94;
			__catch94_g_error:
			{
				GError* e = NULL;
				GError* _tmp17_;
				const gchar* _tmp18_;
#line 510 "../src/Photo.vala"
				e = _inner_error0_;
#line 510 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 537 "../src/Photo.vala"
				_tmp17_ = e;
#line 537 "../src/Photo.vala"
				_tmp18_ = _tmp17_->message;
#line 537 "../src/Photo.vala"
				g_debug ("Photo.vala:537: Error accessing embedded preview. Message: %s", _tmp18_);
#line 510 "../src/Photo.vala"
				_g_error_free0 (e);
#line 5722 "Photo.c"
			}
			__finally94:
#line 510 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5727 "Photo.c"
				gboolean _tmp19_ = FALSE;
#line 510 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 510 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 510 "../src/Photo.vala"
				return _tmp19_;
#line 5735 "Photo.c"
			}
#line 539 "../src/Photo.vala"
			result = FALSE;
#line 539 "../src/Photo.vala"
			return result;
#line 5741 "Photo.c"
		}
		default:
		{
#line 542 "../src/Photo.vala"
			g_assert_not_reached ();
#line 5747 "Photo.c"
		}
	}
}

void
photo_add_backing_photo_for_development (Photo* self,
                                         RawDeveloper d,
                                         BackingPhotoRow* bpr,
                                         GError** error)
{
	PhotoRow* _tmp0_;
	Alteration* _tmp4_;
	Alteration* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 549 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 549 "../src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 550 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 550 "../src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, d, bpr, &_inner_error0_);
#line 550 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 550 "../src/Photo.vala"
		return;
#line 5776 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 551 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 551 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 5784 "Photo.c"
		{
			GeeHashMap* _tmp2_;
#line 552 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 552 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) d), bpr);
#line 5791 "Photo.c"
		}
		__finally95:
		{
			GeeHashMap* _tmp3_;
#line 551 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 551 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 5800 "Photo.c"
		}
#line 551 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 551 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 551 "../src/Photo.vala"
			return;
#line 5808 "Photo.c"
		}
	}
#line 554 "../src/Photo.vala"
	_tmp4_ = alteration_new ("image", "developer");
#line 554 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 554 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp5_);
#line 554 "../src/Photo.vala"
	_alteration_unref0 (_tmp5_);
#line 5819 "Photo.c"
}

void
photo_import_developed_backing_photo (PhotoRow* row,
                                      RawDeveloper d,
                                      BackingPhotoRow* bpr,
                                      GError** error)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp4_;
	GTimeVal _tmp5_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp6_;
	PhotoFileInterrogator* _tmp7_;
	PhotoFileInterrogator* _tmp8_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	Dimensions _tmp12_;
	GFileInfo* _tmp13_;
	GTimeVal _tmp14_;
	Orientation _tmp15_ = 0;
	DetectedPhotoInformation* _tmp16_;
	PhotoMetadata* _tmp17_;
	BackingPhotoTable* _tmp20_;
	BackingPhotoTable* _tmp21_;
	PhotoTable* _tmp22_;
	PhotoTable* _tmp23_;
	BackingPhotoID _tmp24_;
	GError* _inner_error0_ = NULL;
#line 557 "../src/Photo.vala"
	g_return_if_fail (row != NULL);
#line 557 "../src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 559 "../src/Photo.vala"
	_tmp0_ = bpr->filepath;
#line 559 "../src/Photo.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 559 "../src/Photo.vala"
	file = _tmp1_;
#line 560 "../src/Photo.vala"
	_tmp2_ = file;
#line 560 "../src/Photo.vala"
	_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 560 "../src/Photo.vala"
	info = _tmp3_;
#line 560 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 560 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 560 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 560 "../src/Photo.vala"
		return;
#line 5881 "Photo.c"
	}
#line 562 "../src/Photo.vala"
	_tmp4_ = info;
#line 562 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp4_, &_tmp5_);
#line 562 "../src/Photo.vala"
	timestamp = _tmp5_;
#line 564 "../src/Photo.vala"
	_tmp6_ = file;
#line 564 "../src/Photo.vala"
	_tmp7_ = photo_file_interrogator_new (_tmp6_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 564 "../src/Photo.vala"
	interrogator = _tmp7_;
#line 566 "../src/Photo.vala"
	_tmp8_ = interrogator;
#line 566 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp8_, &_inner_error0_);
#line 566 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 566 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 566 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 566 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 566 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 566 "../src/Photo.vala"
		return;
#line 5911 "Photo.c"
	}
#line 568 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 568 "../src/Photo.vala"
	_tmp10_ = photo_file_interrogator_get_detected_photo_information (_tmp9_);
#line 568 "../src/Photo.vala"
	detected = _tmp10_;
#line 569 "../src/Photo.vala"
	_tmp11_ = detected;
#line 569 "../src/Photo.vala"
	_tmp12_ = _tmp11_->image_dim;
#line 569 "../src/Photo.vala"
	bpr->dim = _tmp12_;
#line 570 "../src/Photo.vala"
	_tmp13_ = info;
#line 570 "../src/Photo.vala"
	bpr->filesize = g_file_info_get_size (_tmp13_);
#line 571 "../src/Photo.vala"
	_tmp14_ = timestamp;
#line 571 "../src/Photo.vala"
	bpr->timestamp = (time_t) _tmp14_.tv_sec;
#line 572 "../src/Photo.vala"
	_tmp16_ = detected;
#line 572 "../src/Photo.vala"
	_tmp17_ = _tmp16_->metadata;
#line 572 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 5939 "Photo.c"
		DetectedPhotoInformation* _tmp18_;
		PhotoMetadata* _tmp19_;
#line 572 "../src/Photo.vala"
		_tmp18_ = detected;
#line 572 "../src/Photo.vala"
		_tmp19_ = _tmp18_->metadata;
#line 572 "../src/Photo.vala"
		_tmp15_ = photo_metadata_get_orientation (_tmp19_);
#line 5948 "Photo.c"
	} else {
#line 573 "../src/Photo.vala"
		_tmp15_ = ORIENTATION_TOP_LEFT;
#line 5952 "Photo.c"
	}
#line 572 "../src/Photo.vala"
	bpr->original_orientation = _tmp15_;
#line 576 "../src/Photo.vala"
	_tmp20_ = backing_photo_table_get_instance ();
#line 576 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 576 "../src/Photo.vala"
	backing_photo_table_add (_tmp21_, bpr, &_inner_error0_);
#line 576 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 576 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 576 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 576 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 576 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 576 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 576 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 576 "../src/Photo.vala"
		return;
#line 5978 "Photo.c"
	}
#line 577 "../src/Photo.vala"
	_tmp22_ = photo_table_get_instance ();
#line 577 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 577 "../src/Photo.vala"
	_tmp24_ = bpr->id;
#line 577 "../src/Photo.vala"
	photo_table_update_raw_development (_tmp23_, row, d, &_tmp24_, &_inner_error0_);
#line 577 "../src/Photo.vala"
	_database_table_unref0 (_tmp23_);
#line 577 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 577 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 577 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 577 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 577 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 577 "../src/Photo.vala"
		return;
#line 6004 "Photo.c"
	}
#line 557 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 557 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 557 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 557 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 6014 "Photo.c"
}

static void
photo_develop_photo (Photo* self,
                     RawDeveloper d)
{
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	GError* _inner_error0_ = NULL;
#line 582 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 584 "../src/Photo.vala"
	bps = NULL;
#line 586 "../src/Photo.vala"
	switch (d) {
#line 586 "../src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 6034 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp0_ = NULL;
				PhotoRow* _tmp1_;
				BackingPhotoRow* _tmp2_;
				const gchar* _tmp3_;
				BackingPhotoRow* _tmp4_;
				BackingPhotoRow* _tmp5_;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp12_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp16_;
				const gchar* _tmp17_;
				PhotoFileWriter* _tmp18_;
				PhotoFileWriter* _tmp19_;
				GdkPixbuf* _tmp20_;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp21_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp22_;
				const gchar* _tmp23_;
				PhotoFileMetadataWriter* _tmp24_;
				PhotoFileMetadataWriter* _tmp25_;
				PhotoMetadata* _tmp26_;
#line 590 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 590 "../src/Photo.vala"
				_tmp2_ = _tmp1_->master;
#line 590 "../src/Photo.vala"
				_tmp3_ = _tmp2_->filepath;
#line 590 "../src/Photo.vala"
				_tmp4_ = raw_developer_create_backing_row_for_development (d, _tmp3_, NULL, &_inner_error0_);
#line 590 "../src/Photo.vala"
				_tmp0_ = _tmp4_;
#line 590 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6071 "Photo.c"
					goto __catch96_g_error;
				}
#line 590 "../src/Photo.vala"
				_tmp5_ = _tmp0_;
#line 590 "../src/Photo.vala"
				_tmp0_ = NULL;
#line 590 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 590 "../src/Photo.vala"
				bps = _tmp5_;
#line 591 "../src/Photo.vala"
				pix = NULL;
#line 6084 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 592 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 592 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 6091 "Photo.c"
					{
						GdkPixbuf* _tmp7_ = NULL;
						Scaling _tmp8_ = {0};
						GdkPixbuf* _tmp9_;
						GdkPixbuf* _tmp10_;
#line 597 "../src/Photo.vala"
						scaling_for_original (&_tmp8_);
#line 597 "../src/Photo.vala"
						_tmp9_ = photo_get_master_pixbuf (self, &_tmp8_, FALSE, &_inner_error0_);
#line 597 "../src/Photo.vala"
						_tmp7_ = _tmp9_;
#line 597 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6105 "Photo.c"
							goto __finally97;
						}
#line 597 "../src/Photo.vala"
						_tmp10_ = _tmp7_;
#line 597 "../src/Photo.vala"
						_tmp7_ = NULL;
#line 597 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 597 "../src/Photo.vala"
						pix = _tmp10_;
#line 592 "../src/Photo.vala"
						_g_object_unref0 (_tmp7_);
#line 6118 "Photo.c"
					}
					__finally97:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp11_;
#line 592 "../src/Photo.vala"
						_tmp11_ = self->priv->readers;
#line 592 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 6128 "Photo.c"
					}
#line 592 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 592 "../src/Photo.vala"
						_g_object_unref0 (pix);
#line 592 "../src/Photo.vala"
						_backing_photo_row_unref0 (_tmp0_);
#line 6136 "Photo.c"
						goto __catch96_g_error;
					}
				}
#line 600 "../src/Photo.vala"
				_tmp12_ = pix;
#line 600 "../src/Photo.vala"
				if (_tmp12_ == NULL) {
#line 601 "../src/Photo.vala"
					g_debug ("Photo.vala:601: Could not get preview pixbuf");
#line 602 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 602 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6150 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 626 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6155 "Photo.c"
							{
								BackingPhotoRow* _tmp13_;
#line 629 "../src/Photo.vala"
								_tmp13_ = bps;
#line 629 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp13_, &_inner_error0_);
#line 629 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6164 "Photo.c"
									goto __catch98_g_error;
								}
#line 631 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6169 "Photo.c"
							}
							goto __finally98;
							__catch98_g_error:
							{
								GError* e = NULL;
								GError* _tmp14_;
								const gchar* _tmp15_;
#line 627 "../src/Photo.vala"
								e = _inner_error0_;
#line 627 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 633 "../src/Photo.vala"
								_tmp14_ = e;
#line 633 "../src/Photo.vala"
								_tmp15_ = _tmp14_->message;
#line 633 "../src/Photo.vala"
								g_debug ("Photo.vala:633: Error adding backing photo as development. Message: %s", _tmp15_);
#line 627 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6189 "Photo.c"
							}
							__finally98:
#line 627 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6194 "Photo.c"
								goto __catch96_g_error;
							}
						}
					}
#line 602 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 602 "../src/Photo.vala"
					return;
#line 6203 "Photo.c"
				}
#line 606 "../src/Photo.vala"
				_tmp16_ = bps;
#line 606 "../src/Photo.vala"
				_tmp17_ = _tmp16_->filepath;
#line 606 "../src/Photo.vala"
				_tmp18_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp17_, &_inner_error0_);
#line 606 "../src/Photo.vala"
				writer = _tmp18_;
#line 606 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 606 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 606 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6219 "Photo.c"
					goto __catch96_g_error;
				}
#line 607 "../src/Photo.vala"
				_tmp19_ = writer;
#line 607 "../src/Photo.vala"
				_tmp20_ = pix;
#line 607 "../src/Photo.vala"
				photo_file_writer_write (_tmp19_, _tmp20_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 607 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 607 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 607 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6236 "Photo.c"
					goto __catch96_g_error;
				}
#line 615 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 620 "../src/Photo.vala"
				_tmp21_ = photo_get_master_metadata (self, &_inner_error0_);
#line 620 "../src/Photo.vala"
				meta = _tmp21_;
#line 620 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 620 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 620 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 620 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6253 "Photo.c"
					goto __catch96_g_error;
				}
#line 621 "../src/Photo.vala"
				_tmp22_ = bps;
#line 621 "../src/Photo.vala"
				_tmp23_ = _tmp22_->filepath;
#line 621 "../src/Photo.vala"
				_tmp24_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp23_, &_inner_error0_);
#line 621 "../src/Photo.vala"
				mwriter = _tmp24_;
#line 621 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 621 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 621 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 621 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6274 "Photo.c"
					goto __catch96_g_error;
				}
#line 622 "../src/Photo.vala"
				_tmp25_ = mwriter;
#line 622 "../src/Photo.vala"
				_tmp26_ = meta;
#line 622 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp25_, _tmp26_, &_inner_error0_);
#line 622 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 622 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 622 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 622 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 622 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 622 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp0_);
#line 6295 "Photo.c"
					goto __catch96_g_error;
				}
#line 588 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 588 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 588 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 588 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 588 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp0_);
#line 6308 "Photo.c"
			}
			goto __finally96;
			__catch96_g_error:
			{
				GError* err = NULL;
				GError* _tmp27_;
				const gchar* _tmp28_;
#line 588 "../src/Photo.vala"
				err = _inner_error0_;
#line 588 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 624 "../src/Photo.vala"
				_tmp27_ = err;
#line 624 "../src/Photo.vala"
				_tmp28_ = _tmp27_->message;
#line 624 "../src/Photo.vala"
				g_debug ("Photo.vala:624: Error developing photo: %s", _tmp28_);
#line 588 "../src/Photo.vala"
				_g_error_free0 (err);
#line 6328 "Photo.c"
			}
			__finally96:
			{
				GError* _inner_error1_ = NULL;
#line 626 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 6335 "Photo.c"
					{
						BackingPhotoRow* _tmp29_;
#line 629 "../src/Photo.vala"
						_tmp29_ = bps;
#line 629 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp29_, &_inner_error1_);
#line 629 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 6344 "Photo.c"
							goto __catch99_g_error;
						}
#line 631 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6349 "Photo.c"
					}
					goto __finally99;
					__catch99_g_error:
					{
						GError* e = NULL;
						GError* _tmp30_;
						const gchar* _tmp31_;
#line 627 "../src/Photo.vala"
						e = _inner_error1_;
#line 627 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 633 "../src/Photo.vala"
						_tmp30_ = e;
#line 633 "../src/Photo.vala"
						_tmp31_ = _tmp30_->message;
#line 633 "../src/Photo.vala"
						g_debug ("Photo.vala:633: Error adding backing photo as development. Message: %s", _tmp31_);
#line 627 "../src/Photo.vala"
						_g_error_free0 (e);
#line 6369 "Photo.c"
					}
					__finally99:
#line 627 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 627 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 627 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 627 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 627 "../src/Photo.vala"
						return;
#line 6382 "Photo.c"
					}
				}
			}
#line 588 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 588 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 588 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 588 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 588 "../src/Photo.vala"
				return;
#line 6396 "Photo.c"
			}
#line 639 "../src/Photo.vala"
			break;
#line 6400 "Photo.c"
		}
#line 586 "../src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 6404 "Photo.c"
		{
#line 643 "../src/Photo.vala"
			break;
#line 6408 "Photo.c"
		}
#line 586 "../src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 6412 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp32_;
				guint c = 0U;
				PhotoMetadata* _tmp33_;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp37_;
				PhotoPreview* _tmp38_;
				PhotoPreview* _tmp39_;
				GdkPixbuf* pix = NULL;
				PhotoPreview* _tmp43_;
				GdkPixbuf* _tmp44_;
				GdkPixbuf* _tmp45_;
				BackingPhotoRow* _tmp49_ = NULL;
				PhotoRow* _tmp50_;
				BackingPhotoRow* _tmp51_;
				const gchar* _tmp52_;
				BackingPhotoRow* _tmp53_;
				BackingPhotoRow* _tmp54_;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp55_;
				const gchar* _tmp56_;
				PhotoFileWriter* _tmp57_;
				PhotoFileWriter* _tmp58_;
				GdkPixbuf* _tmp59_;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp60_;
				const gchar* _tmp61_;
				PhotoFileMetadataWriter* _tmp62_;
				PhotoFileMetadataWriter* _tmp63_;
				PhotoMetadata* _tmp64_;
#line 648 "../src/Photo.vala"
				_tmp32_ = photo_get_master_metadata (self, &_inner_error0_);
#line 648 "../src/Photo.vala"
				meta = _tmp32_;
#line 648 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6451 "Photo.c"
					goto __catch100_g_error;
				}
#line 649 "../src/Photo.vala"
				_tmp33_ = meta;
#line 649 "../src/Photo.vala"
				c = photo_metadata_get_preview_count (_tmp33_);
#line 650 "../src/Photo.vala"
				if (c <= ((guint) 0)) {
#line 651 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6462 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 681 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6467 "Photo.c"
							{
								BackingPhotoRow* _tmp34_;
#line 684 "../src/Photo.vala"
								_tmp34_ = bps;
#line 684 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp34_, &_inner_error0_);
#line 684 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6476 "Photo.c"
									goto __catch101_g_error;
								}
#line 686 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6481 "Photo.c"
							}
							goto __finally101;
							__catch101_g_error:
							{
								GError* e = NULL;
								GError* _tmp35_;
								const gchar* _tmp36_;
#line 682 "../src/Photo.vala"
								e = _inner_error0_;
#line 682 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 688 "../src/Photo.vala"
								_tmp35_ = e;
#line 688 "../src/Photo.vala"
								_tmp36_ = _tmp35_->message;
#line 688 "../src/Photo.vala"
								g_debug ("Photo.vala:688: Error adding backing photo as development. Message: %s", _tmp36_);
#line 682 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6501 "Photo.c"
							}
							__finally101:
#line 682 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6506 "Photo.c"
								goto __catch100_g_error;
							}
						}
					}
#line 651 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 651 "../src/Photo.vala"
					return;
#line 6515 "Photo.c"
				}
#line 653 "../src/Photo.vala"
				_tmp37_ = meta;
#line 653 "../src/Photo.vala"
				_tmp38_ = photo_metadata_get_preview (_tmp37_, c - 1);
#line 653 "../src/Photo.vala"
				prev = _tmp38_;
#line 654 "../src/Photo.vala"
				_tmp39_ = prev;
#line 654 "../src/Photo.vala"
				if (_tmp39_ == NULL) {
#line 655 "../src/Photo.vala"
					g_debug ("Photo.vala:655: Could not get preview from metadata");
#line 656 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 656 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6533 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 681 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6538 "Photo.c"
							{
								BackingPhotoRow* _tmp40_;
#line 684 "../src/Photo.vala"
								_tmp40_ = bps;
#line 684 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp40_, &_inner_error0_);
#line 684 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6547 "Photo.c"
									goto __catch102_g_error;
								}
#line 686 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6552 "Photo.c"
							}
							goto __finally102;
							__catch102_g_error:
							{
								GError* e = NULL;
								GError* _tmp41_;
								const gchar* _tmp42_;
#line 682 "../src/Photo.vala"
								e = _inner_error0_;
#line 682 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 688 "../src/Photo.vala"
								_tmp41_ = e;
#line 688 "../src/Photo.vala"
								_tmp42_ = _tmp41_->message;
#line 688 "../src/Photo.vala"
								g_debug ("Photo.vala:688: Error adding backing photo as development. Message: %s", _tmp42_);
#line 682 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6572 "Photo.c"
							}
							__finally102:
#line 682 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6577 "Photo.c"
								goto __catch100_g_error;
							}
						}
					}
#line 656 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 656 "../src/Photo.vala"
					return;
#line 6586 "Photo.c"
				}
#line 659 "../src/Photo.vala"
				_tmp43_ = prev;
#line 659 "../src/Photo.vala"
				_tmp44_ = photo_preview_get_pixbuf (_tmp43_, &_inner_error0_);
#line 659 "../src/Photo.vala"
				pix = _tmp44_;
#line 659 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 659 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 659 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6600 "Photo.c"
					goto __catch100_g_error;
				}
#line 660 "../src/Photo.vala"
				_tmp45_ = pix;
#line 660 "../src/Photo.vala"
				if (_tmp45_ == NULL) {
#line 661 "../src/Photo.vala"
					g_debug ("Photo.vala:661: Could not get preview pixbuf");
#line 662 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 662 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 662 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6615 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
#line 681 "../src/Photo.vala"
						if (wrote_img_to_disk) {
#line 6620 "Photo.c"
							{
								BackingPhotoRow* _tmp46_;
#line 684 "../src/Photo.vala"
								_tmp46_ = bps;
#line 684 "../src/Photo.vala"
								photo_add_backing_photo_for_development (self, d, _tmp46_, &_inner_error0_);
#line 684 "../src/Photo.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6629 "Photo.c"
									goto __catch103_g_error;
								}
#line 686 "../src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 6634 "Photo.c"
							}
							goto __finally103;
							__catch103_g_error:
							{
								GError* e = NULL;
								GError* _tmp47_;
								const gchar* _tmp48_;
#line 682 "../src/Photo.vala"
								e = _inner_error0_;
#line 682 "../src/Photo.vala"
								_inner_error0_ = NULL;
#line 688 "../src/Photo.vala"
								_tmp47_ = e;
#line 688 "../src/Photo.vala"
								_tmp48_ = _tmp47_->message;
#line 688 "../src/Photo.vala"
								g_debug ("Photo.vala:688: Error adding backing photo as development. Message: %s", _tmp48_);
#line 682 "../src/Photo.vala"
								_g_error_free0 (e);
#line 6654 "Photo.c"
							}
							__finally103:
#line 682 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6659 "Photo.c"
								goto __catch100_g_error;
							}
						}
					}
#line 662 "../src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 662 "../src/Photo.vala"
					return;
#line 6668 "Photo.c"
				}
#line 666 "../src/Photo.vala"
				_tmp50_ = self->row;
#line 666 "../src/Photo.vala"
				_tmp51_ = _tmp50_->master;
#line 666 "../src/Photo.vala"
				_tmp52_ = _tmp51_->filepath;
#line 666 "../src/Photo.vala"
				_tmp53_ = raw_developer_create_backing_row_for_development (d, _tmp52_, NULL, &_inner_error0_);
#line 666 "../src/Photo.vala"
				_tmp49_ = _tmp53_;
#line 666 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 666 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 666 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6688 "Photo.c"
					goto __catch100_g_error;
				}
#line 666 "../src/Photo.vala"
				_tmp54_ = _tmp49_;
#line 666 "../src/Photo.vala"
				_tmp49_ = NULL;
#line 666 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 666 "../src/Photo.vala"
				bps = _tmp54_;
#line 667 "../src/Photo.vala"
				_tmp55_ = bps;
#line 667 "../src/Photo.vala"
				_tmp56_ = _tmp55_->filepath;
#line 667 "../src/Photo.vala"
				_tmp57_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp56_, &_inner_error0_);
#line 667 "../src/Photo.vala"
				writer = _tmp57_;
#line 667 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 667 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 667 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 667 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 667 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6717 "Photo.c"
					goto __catch100_g_error;
				}
#line 668 "../src/Photo.vala"
				_tmp58_ = writer;
#line 668 "../src/Photo.vala"
				_tmp59_ = pix;
#line 668 "../src/Photo.vala"
				photo_file_writer_write (_tmp58_, _tmp59_, JPEG_QUALITY_HIGH, &_inner_error0_);
#line 668 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 668 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 668 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 668 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 668 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 668 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6738 "Photo.c"
					goto __catch100_g_error;
				}
#line 672 "../src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 675 "../src/Photo.vala"
				_tmp60_ = bps;
#line 675 "../src/Photo.vala"
				_tmp61_ = _tmp60_->filepath;
#line 675 "../src/Photo.vala"
				_tmp62_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp61_, &_inner_error0_);
#line 675 "../src/Photo.vala"
				mwriter = _tmp62_;
#line 675 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 675 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 675 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 675 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 675 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 675 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6763 "Photo.c"
					goto __catch100_g_error;
				}
#line 676 "../src/Photo.vala"
				_tmp63_ = mwriter;
#line 676 "../src/Photo.vala"
				_tmp64_ = meta;
#line 676 "../src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp63_, _tmp64_, &_inner_error0_);
#line 676 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 676 "../src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 676 "../src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 676 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp49_);
#line 676 "../src/Photo.vala"
					_g_object_unref0 (pix);
#line 676 "../src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 676 "../src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 6786 "Photo.c"
					goto __catch100_g_error;
				}
#line 646 "../src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 646 "../src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 646 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp49_);
#line 646 "../src/Photo.vala"
				_g_object_unref0 (pix);
#line 646 "../src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 646 "../src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 6801 "Photo.c"
			}
			goto __finally100;
			__catch100_g_error:
			{
				GError* e = NULL;
				GError* _tmp65_;
				const gchar* _tmp66_;
#line 646 "../src/Photo.vala"
				e = _inner_error0_;
#line 646 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 678 "../src/Photo.vala"
				_tmp65_ = e;
#line 678 "../src/Photo.vala"
				_tmp66_ = _tmp65_->message;
#line 678 "../src/Photo.vala"
				g_debug ("Photo.vala:678: Error accessing embedded preview. Message: %s", _tmp66_);
#line 679 "../src/Photo.vala"
				_g_error_free0 (e);
#line 6821 "Photo.c"
				{
					GError* _inner_error0_ = NULL;
#line 681 "../src/Photo.vala"
					if (wrote_img_to_disk) {
#line 6826 "Photo.c"
						{
							BackingPhotoRow* _tmp67_;
#line 684 "../src/Photo.vala"
							_tmp67_ = bps;
#line 684 "../src/Photo.vala"
							photo_add_backing_photo_for_development (self, d, _tmp67_, &_inner_error0_);
#line 684 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6835 "Photo.c"
								goto __catch104_g_error;
							}
#line 686 "../src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 6840 "Photo.c"
						}
						goto __finally104;
						__catch104_g_error:
						{
							GError* e = NULL;
							GError* _tmp68_;
							const gchar* _tmp69_;
#line 682 "../src/Photo.vala"
							e = _inner_error0_;
#line 682 "../src/Photo.vala"
							_inner_error0_ = NULL;
#line 688 "../src/Photo.vala"
							_tmp68_ = e;
#line 688 "../src/Photo.vala"
							_tmp69_ = _tmp68_->message;
#line 688 "../src/Photo.vala"
							g_debug ("Photo.vala:688: Error adding backing photo as development. Message: %s", _tmp69_);
#line 682 "../src/Photo.vala"
							_g_error_free0 (e);
#line 6860 "Photo.c"
						}
						__finally104:
#line 682 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 682 "../src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 6867 "Photo.c"
						}
					}
				}
#line 679 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 679 "../src/Photo.vala"
				return;
#line 6875 "Photo.c"
			}
			__finally100:
			{
				GError* _inner_error1_ = NULL;
#line 681 "../src/Photo.vala"
				if (wrote_img_to_disk) {
#line 6882 "Photo.c"
					{
						BackingPhotoRow* _tmp70_;
#line 684 "../src/Photo.vala"
						_tmp70_ = bps;
#line 684 "../src/Photo.vala"
						photo_add_backing_photo_for_development (self, d, _tmp70_, &_inner_error1_);
#line 684 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 6891 "Photo.c"
							goto __catch105_g_error;
						}
#line 686 "../src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6896 "Photo.c"
					}
					goto __finally105;
					__catch105_g_error:
					{
						GError* e = NULL;
						GError* _tmp71_;
						const gchar* _tmp72_;
#line 682 "../src/Photo.vala"
						e = _inner_error1_;
#line 682 "../src/Photo.vala"
						_inner_error1_ = NULL;
#line 688 "../src/Photo.vala"
						_tmp71_ = e;
#line 688 "../src/Photo.vala"
						_tmp72_ = _tmp71_->message;
#line 688 "../src/Photo.vala"
						g_debug ("Photo.vala:688: Error adding backing photo as development. Message: %s", _tmp72_);
#line 682 "../src/Photo.vala"
						_g_error_free0 (e);
#line 6916 "Photo.c"
					}
					__finally105:
#line 682 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error1_ != NULL)) {
#line 682 "../src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 682 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error1_->message, g_quark_to_string (_inner_error1_->domain), _inner_error1_->code);
#line 682 "../src/Photo.vala"
						g_clear_error (&_inner_error1_);
#line 682 "../src/Photo.vala"
						return;
#line 6929 "Photo.c"
					}
				}
			}
#line 646 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 646 "../src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 646 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 646 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 646 "../src/Photo.vala"
				return;
#line 6943 "Photo.c"
			}
#line 693 "../src/Photo.vala"
			break;
#line 6947 "Photo.c"
		}
		default:
		{
#line 696 "../src/Photo.vala"
			g_assert_not_reached ();
#line 6953 "Photo.c"
		}
	}
#line 582 "../src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 6958 "Photo.c"
}

void
photo_set_default_raw_developer (Photo* self,
                                 RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 701 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 6968 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 702 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 702 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6975 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 703 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 703 "../src/Photo.vala"
			_tmp1_->developer = d;
#line 6982 "Photo.c"
		}
		__finally106:
		{
			PhotoRow* _tmp2_;
#line 702 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 702 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6991 "Photo.c"
		}
#line 702 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 702 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 702 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 702 "../src/Photo.vala"
			return;
#line 7001 "Photo.c"
		}
	}
}

void
photo_set_raw_developer (Photo* self,
                         RawDeveloper d)
{
	gboolean _tmp0_ = FALSE;
	Alteration* _tmp34_;
	Alteration* _tmp35_;
	GError* _inner_error0_ = NULL;
#line 708 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 709 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 710 "../src/Photo.vala"
		return;
#line 7020 "Photo.c"
	}
#line 716 "../src/Photo.vala"
	if (photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA)) {
#line 716 "../src/Photo.vala"
		_tmp0_ = d == RAW_DEVELOPER_EMBEDDED;
#line 7026 "Photo.c"
	} else {
#line 716 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 7030 "Photo.c"
	}
#line 716 "../src/Photo.vala"
	if (_tmp0_) {
#line 717 "../src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 7036 "Photo.c"
	}
#line 722 "../src/Photo.vala"
	if (!photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED)) {
#line 723 "../src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 7042 "Photo.c"
	}
	{
		GeeHashMap* _tmp1_;
#line 726 "../src/Photo.vala"
		_tmp1_ = self->priv->developments;
#line 726 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7050 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp2_;
			RawDeveloper _tmp3_;
			GeeHashMap* _tmp6_;
			PhotoRow* _tmp8_;
			GeeHashMap* _tmp9_;
			gpointer _tmp10_;
			PhotoBackingReaders* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoFileFormat _tmp13_;
			BackingPhotoRow* _tmp14_;
			const gchar* _tmp15_;
			PhotoFileReader* _tmp16_;
			BackingPhotoRow* _tmp17_;
			Orientation _tmp18_;
			gboolean _tmp27_ = FALSE;
			RawDeveloper _tmp28_;
#line 727 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 727 "../src/Photo.vala"
			_tmp3_ = _tmp2_->developer;
#line 727 "../src/Photo.vala"
			stale_raw_developer = _tmp3_;
#line 730 "../src/Photo.vala"
			if (!photo_is_raw_developer_complete (self, d)) {
#line 731 "../src/Photo.vala"
				photo_develop_photo (self, d);
#line 7079 "Photo.c"
				{
#line 733 "../src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error0_);
#line 733 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7085 "Photo.c"
						goto __catch108_g_error;
					}
				}
				goto __finally108;
				__catch108_g_error:
				{
					GError* e = NULL;
#line 732 "../src/Photo.vala"
					e = _inner_error0_;
#line 732 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 736 "../src/Photo.vala"
					_g_error_free0 (e);
#line 7099 "Photo.c"
					{
						GeeHashMap* _tmp4_;
#line 726 "../src/Photo.vala"
						_tmp4_ = self->priv->developments;
#line 726 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7106 "Photo.c"
					}
#line 736 "../src/Photo.vala"
					return;
#line 7110 "Photo.c"
				}
				__finally108:
#line 732 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7115 "Photo.c"
					{
						GeeHashMap* _tmp5_;
#line 726 "../src/Photo.vala"
						_tmp5_ = self->priv->developments;
#line 726 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7122 "Photo.c"
					}
#line 732 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 732 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 732 "../src/Photo.vala"
					return;
#line 7130 "Photo.c"
				}
			}
#line 739 "../src/Photo.vala"
			_tmp6_ = self->priv->developments;
#line 739 "../src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) d))) {
#line 7137 "Photo.c"
				{
					GeeHashMap* _tmp7_;
#line 726 "../src/Photo.vala"
					_tmp7_ = self->priv->developments;
#line 726 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7144 "Photo.c"
				}
#line 740 "../src/Photo.vala"
				return;
#line 7148 "Photo.c"
			}
#line 744 "../src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 747 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 747 "../src/Photo.vala"
			_tmp8_->developer = d;
#line 748 "../src/Photo.vala"
			_tmp9_ = self->priv->developments;
#line 748 "../src/Photo.vala"
			_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) d));
#line 748 "../src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 748 "../src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp10_;
#line 749 "../src/Photo.vala"
			_tmp11_ = self->priv->readers;
#line 749 "../src/Photo.vala"
			_tmp12_ = self->backing_photo_row;
#line 749 "../src/Photo.vala"
			_tmp13_ = _tmp12_->file_format;
#line 749 "../src/Photo.vala"
			_tmp14_ = self->backing_photo_row;
#line 749 "../src/Photo.vala"
			_tmp15_ = _tmp14_->filepath;
#line 749 "../src/Photo.vala"
			_tmp16_ = photo_file_format_create_reader (_tmp13_, _tmp15_);
#line 749 "../src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp11_->developer);
#line 749 "../src/Photo.vala"
			_tmp11_->developer = _tmp16_;
#line 751 "../src/Photo.vala"
			_tmp17_ = self->backing_photo_row;
#line 751 "../src/Photo.vala"
			_tmp18_ = _tmp17_->original_orientation;
#line 751 "../src/Photo.vala"
			photo_set_orientation (self, _tmp18_);
#line 7186 "Photo.c"
			{
				PhotoTable* _tmp19_;
				PhotoTable* _tmp20_;
				PhotoRow* _tmp21_;
				BackingPhotoRow* _tmp22_;
				BackingPhotoID _tmp23_;
#line 754 "../src/Photo.vala"
				_tmp19_ = photo_table_get_instance ();
#line 754 "../src/Photo.vala"
				_tmp20_ = _tmp19_;
#line 754 "../src/Photo.vala"
				_tmp21_ = self->row;
#line 754 "../src/Photo.vala"
				_tmp22_ = self->backing_photo_row;
#line 754 "../src/Photo.vala"
				_tmp23_ = _tmp22_->id;
#line 754 "../src/Photo.vala"
				photo_table_update_raw_development (_tmp20_, _tmp21_, d, &_tmp23_, &_inner_error0_);
#line 754 "../src/Photo.vala"
				_database_table_unref0 (_tmp20_);
#line 754 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7209 "Photo.c"
					goto __catch109_g_error;
				}
			}
			goto __finally109;
			__catch109_g_error:
			{
				GError* e = NULL;
				GError* _tmp24_;
				const gchar* _tmp25_;
#line 753 "../src/Photo.vala"
				e = _inner_error0_;
#line 753 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 756 "../src/Photo.vala"
				_tmp24_ = e;
#line 756 "../src/Photo.vala"
				_tmp25_ = _tmp24_->message;
#line 756 "../src/Photo.vala"
				g_warning ("Photo.vala:756: Error updating database: %s", _tmp25_);
#line 753 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7231 "Photo.c"
			}
			__finally109:
#line 753 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7236 "Photo.c"
				{
					GeeHashMap* _tmp26_;
#line 726 "../src/Photo.vala"
					_tmp26_ = self->priv->developments;
#line 726 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7243 "Photo.c"
				}
#line 753 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 753 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 753 "../src/Photo.vala"
				return;
#line 7251 "Photo.c"
			}
#line 763 "../src/Photo.vala"
			_tmp28_ = stale_raw_developer;
#line 763 "../src/Photo.vala"
			if (_tmp28_ != RAW_DEVELOPER_CAMERA) {
#line 7257 "Photo.c"
				RawDeveloper _tmp29_;
				PhotoRow* _tmp30_;
				RawDeveloper _tmp31_;
#line 764 "../src/Photo.vala"
				_tmp29_ = stale_raw_developer;
#line 764 "../src/Photo.vala"
				_tmp30_ = self->row;
#line 764 "../src/Photo.vala"
				_tmp31_ = _tmp30_->developer;
#line 764 "../src/Photo.vala"
				_tmp27_ = _tmp29_ != _tmp31_;
#line 7269 "Photo.c"
			} else {
#line 763 "../src/Photo.vala"
				_tmp27_ = FALSE;
#line 7273 "Photo.c"
			}
#line 763 "../src/Photo.vala"
			if (_tmp27_) {
#line 7277 "Photo.c"
				RawDeveloper _tmp32_;
#line 767 "../src/Photo.vala"
				_tmp32_ = stale_raw_developer;
#line 767 "../src/Photo.vala"
				photo_delete_raw_development (self, _tmp32_);
#line 7283 "Photo.c"
			}
		}
		__finally107:
		{
			GeeHashMap* _tmp33_;
#line 726 "../src/Photo.vala"
			_tmp33_ = self->priv->developments;
#line 726 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7293 "Photo.c"
		}
#line 726 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 726 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 726 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 726 "../src/Photo.vala"
			return;
#line 7303 "Photo.c"
		}
	}
#line 774 "../src/Photo.vala"
	_tmp34_ = alteration_new ("image", "developer");
#line 774 "../src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 774 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp35_);
#line 774 "../src/Photo.vala"
	_alteration_unref0 (_tmp35_);
#line 775 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 7316 "Photo.c"
}

RawDeveloper
photo_get_raw_developer (Photo* self)
{
	RawDeveloper result = 0;
	PhotoRow* _tmp0_;
	RawDeveloper _tmp1_;
#line 778 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 779 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 779 "../src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 779 "../src/Photo.vala"
	result = _tmp1_;
#line 779 "../src/Photo.vala"
	return result;
#line 7335 "Photo.c"
}

static gboolean
photo_delete_raw_development (Photo* self,
                              RawDeveloper d)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError* _inner_error0_ = NULL;
#line 784 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 785 "../src/Photo.vala"
	ret = FALSE;
#line 7349 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 787 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 787 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7356 "Photo.c"
		{
			GeeHashMap* _tmp1_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp7_;
			gpointer _tmp8_;
			BackingPhotoRow* _tmp9_;
			const gchar* _tmp10_;
			GeeHashMap* _tmp33_;
#line 788 "../src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 788 "../src/Photo.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) d))) {
#line 789 "../src/Photo.vala"
				result = FALSE;
#line 7375 "Photo.c"
				{
					GeeHashMap* _tmp2_;
#line 787 "../src/Photo.vala"
					_tmp2_ = self->priv->developments;
#line 787 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7382 "Photo.c"
				}
#line 789 "../src/Photo.vala"
				return result;
#line 7386 "Photo.c"
			}
#line 793 "../src/Photo.vala"
			_tmp3_ = data_object_to_string ((DataObject*) self);
#line 793 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 793 "../src/Photo.vala"
			_tmp5_ = raw_developer_to_string (d);
#line 793 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 793 "../src/Photo.vala"
			g_debug ("Photo.vala:793: Delete raw development: %s %s", _tmp4_, _tmp6_);
#line 793 "../src/Photo.vala"
			_g_free0 (_tmp6_);
#line 793 "../src/Photo.vala"
			_g_free0 (_tmp4_);
#line 794 "../src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 794 "../src/Photo.vala"
			_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) d));
#line 794 "../src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp8_;
#line 795 "../src/Photo.vala"
			_tmp9_ = bpr;
#line 795 "../src/Photo.vala"
			_tmp10_ = _tmp9_->filepath;
#line 795 "../src/Photo.vala"
			if (_tmp10_ != NULL) {
#line 7414 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
#line 796 "../src/Photo.vala"
				_tmp11_ = bpr;
#line 796 "../src/Photo.vala"
				_tmp12_ = _tmp11_->filepath;
#line 796 "../src/Photo.vala"
				_tmp13_ = g_file_new_for_path (_tmp12_);
#line 796 "../src/Photo.vala"
				f = _tmp13_;
#line 7427 "Photo.c"
				{
#line 798 "../src/Photo.vala"
					if (d == RAW_DEVELOPER_CAMERA) {
#line 7431 "Photo.c"
						GFile* _tmp14_;
#line 799 "../src/Photo.vala"
						_tmp14_ = f;
#line 799 "../src/Photo.vala"
						g_file_trash (_tmp14_, NULL, &_inner_error0_);
#line 799 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7439 "Photo.c"
							goto __catch111_g_error;
						}
					} else {
						GFile* _tmp15_;
#line 801 "../src/Photo.vala"
						_tmp15_ = f;
#line 801 "../src/Photo.vala"
						g_file_delete (_tmp15_, NULL, &_inner_error0_);
#line 801 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7450 "Photo.c"
							goto __catch111_g_error;
						}
					}
				}
				goto __finally111;
				__catch111_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp16_;
					const gchar* _tmp17_;
					GError* _tmp18_;
					const gchar* _tmp19_;
#line 797 "../src/Photo.vala"
					e = _inner_error0_;
#line 797 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 804 "../src/Photo.vala"
					_tmp16_ = bpr;
#line 804 "../src/Photo.vala"
					_tmp17_ = _tmp16_->filepath;
#line 804 "../src/Photo.vala"
					_tmp18_ = e;
#line 804 "../src/Photo.vala"
					_tmp19_ = _tmp18_->message;
#line 804 "../src/Photo.vala"
					g_warning ("Photo.vala:804: Unable to delete RAW development: %s error: %s", _tmp17_, _tmp19_);
#line 797 "../src/Photo.vala"
					_g_error_free0 (e);
#line 7479 "Photo.c"
				}
				__finally111:
#line 797 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7484 "Photo.c"
					gboolean _tmp21_ = FALSE;
#line 797 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 797 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 797 "../src/Photo.vala"
					_g_object_unref0 (f);
#line 797 "../src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 7494 "Photo.c"
					{
						GeeHashMap* _tmp20_;
#line 787 "../src/Photo.vala"
						_tmp20_ = self->priv->developments;
#line 787 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7501 "Photo.c"
					}
#line 797 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 797 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 797 "../src/Photo.vala"
					return _tmp21_;
#line 7509 "Photo.c"
				}
#line 795 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 7513 "Photo.c"
			}
			{
				PhotoTable* _tmp22_;
				PhotoTable* _tmp23_;
				PhotoRow* _tmp24_;
				BackingPhotoTable* _tmp25_;
				BackingPhotoTable* _tmp26_;
				BackingPhotoRow* _tmp27_;
				BackingPhotoID _tmp28_;
#line 810 "../src/Photo.vala"
				_tmp22_ = photo_table_get_instance ();
#line 810 "../src/Photo.vala"
				_tmp23_ = _tmp22_;
#line 810 "../src/Photo.vala"
				_tmp24_ = self->row;
#line 810 "../src/Photo.vala"
				photo_table_remove_development (_tmp23_, _tmp24_, d, &_inner_error0_);
#line 810 "../src/Photo.vala"
				_database_table_unref0 (_tmp23_);
#line 810 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7535 "Photo.c"
					goto __catch112_g_error;
				}
#line 811 "../src/Photo.vala"
				_tmp25_ = backing_photo_table_get_instance ();
#line 811 "../src/Photo.vala"
				_tmp26_ = _tmp25_;
#line 811 "../src/Photo.vala"
				_tmp27_ = bpr;
#line 811 "../src/Photo.vala"
				_tmp28_ = _tmp27_->id;
#line 811 "../src/Photo.vala"
				backing_photo_table_remove (_tmp26_, &_tmp28_, &_inner_error0_);
#line 811 "../src/Photo.vala"
				_database_table_unref0 (_tmp26_);
#line 811 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7552 "Photo.c"
					goto __catch112_g_error;
				}
			}
			goto __finally112;
			__catch112_g_error:
			{
				GError* e = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 809 "../src/Photo.vala"
				e = _inner_error0_;
#line 809 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 813 "../src/Photo.vala"
				_tmp29_ = e;
#line 813 "../src/Photo.vala"
				_tmp30_ = _tmp29_->message;
#line 813 "../src/Photo.vala"
				g_warning ("Photo.vala:813: Database error while deleting RAW development: %s", _tmp30_);
#line 809 "../src/Photo.vala"
				_g_error_free0 (e);
#line 7574 "Photo.c"
			}
			__finally112:
#line 809 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7579 "Photo.c"
				gboolean _tmp32_ = FALSE;
#line 809 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 809 "../src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 7585 "Photo.c"
				{
					GeeHashMap* _tmp31_;
#line 787 "../src/Photo.vala"
					_tmp31_ = self->priv->developments;
#line 787 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7592 "Photo.c"
				}
#line 809 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 809 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 809 "../src/Photo.vala"
				return _tmp32_;
#line 7600 "Photo.c"
			}
#line 816 "../src/Photo.vala"
			_tmp33_ = self->priv->developments;
#line 816 "../src/Photo.vala"
			ret = gee_abstract_map_unset ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) d), NULL);
#line 787 "../src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 7608 "Photo.c"
		}
		__finally110:
		{
			GeeHashMap* _tmp34_;
#line 787 "../src/Photo.vala"
			_tmp34_ = self->priv->developments;
#line 787 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7617 "Photo.c"
		}
#line 787 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7621 "Photo.c"
			gboolean _tmp35_ = FALSE;
#line 787 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 787 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 787 "../src/Photo.vala"
			return _tmp35_;
#line 7629 "Photo.c"
		}
	}
#line 819 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 820 "../src/Photo.vala"
	result = ret;
#line 820 "../src/Photo.vala"
	return result;
#line 7638 "Photo.c"
}

void
photo_redevelop_raw (Photo* self,
                     RawDeveloper d)
{
	GError* _inner_error0_ = NULL;
#line 824 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 7648 "Photo.c"
	{
		GeeHashMap* _tmp0_;
#line 825 "../src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 825 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 7655 "Photo.c"
		{
			RawDeveloper dev = 0;
			RawDeveloper _tmp1_;
			RawDeveloper _tmp2_;
#line 826 "../src/Photo.vala"
			photo_delete_raw_development (self, d);
#line 827 "../src/Photo.vala"
			dev = d;
#line 828 "../src/Photo.vala"
			_tmp1_ = dev;
#line 828 "../src/Photo.vala"
			if (_tmp1_ == RAW_DEVELOPER_CAMERA) {
#line 829 "../src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 7670 "Photo.c"
			}
#line 832 "../src/Photo.vala"
			_tmp2_ = dev;
#line 832 "../src/Photo.vala"
			photo_set_raw_developer (self, _tmp2_);
#line 7676 "Photo.c"
		}
		__finally113:
		{
			GeeHashMap* _tmp3_;
#line 825 "../src/Photo.vala"
			_tmp3_ = self->priv->developments;
#line 825 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 7685 "Photo.c"
		}
#line 825 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 825 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 825 "../src/Photo.vala"
			return;
#line 7695 "Photo.c"
		}
	}
}

static void
_vala_array_add7 (BackingFileState** * array,
                  int* length,
                  int* size,
                  BackingFileState* value)
{
#line 839 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 839 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 839 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7712 "Photo.c"
	}
#line 839 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 839 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 7718 "Photo.c"
}

static void
_vala_array_add8 (BackingFileState** * array,
                  int* length,
                  int* size,
                  BackingFileState* value)
{
#line 841 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 841 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 841 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7733 "Photo.c"
	}
#line 841 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 841 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 7739 "Photo.c"
}

static void
_vala_array_add9 (BackingFileState** * array,
                  int* length,
                  int* size,
                  BackingFileState* value)
{
#line 849 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 849 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 849 "../src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 7754 "Photo.c"
	}
#line 849 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 849 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 7760 "Photo.c"
}

static BackingFileState**
photo_real_get_backing_files_state (MediaSource* base,
                                    gint* result_length1)
{
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp24_;
	gint _tmp24__length1;
	GError* _inner_error0_ = NULL;
#line 836 "../src/Photo.vala"
	self = (Photo*) base;
#line 837 "../src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 837 "../src/Photo.vala"
	backing = _tmp0_;
#line 837 "../src/Photo.vala"
	backing_length1 = 0;
#line 837 "../src/Photo.vala"
	_backing_size_ = backing_length1;
#line 7786 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 838 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 838 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 7793 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow* _tmp3_;
			BackingPhotoRow* _tmp4_;
			PhotoRow* _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
#line 839 "../src/Photo.vala"
			_tmp2_ = backing;
#line 839 "../src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 839 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 839 "../src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 839 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 839 "../src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 839 "../src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 839 "../src/Photo.vala"
			_vala_array_add7 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 840 "../src/Photo.vala"
			if (photo_has_editable (self)) {
#line 7820 "Photo.c"
				BackingFileState** _tmp8_;
				gint _tmp8__length1;
				BackingPhotoRow* _tmp9_;
				BackingFileState* _tmp10_;
#line 841 "../src/Photo.vala"
				_tmp8_ = backing;
#line 841 "../src/Photo.vala"
				_tmp8__length1 = backing_length1;
#line 841 "../src/Photo.vala"
				_tmp9_ = self->priv->editable;
#line 841 "../src/Photo.vala"
				_tmp10_ = backing_file_state_new_from_photo_row (_tmp9_, NULL);
#line 841 "../src/Photo.vala"
				_vala_array_add8 (&backing, &backing_length1, &_backing_size_, _tmp10_);
#line 7835 "Photo.c"
			}
#line 844 "../src/Photo.vala"
			if (photo_is_developed (self)) {
#line 7839 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
#line 845 "../src/Photo.vala"
				_tmp11_ = photo_get_raw_development_photo_rows (self);
#line 845 "../src/Photo.vala"
				dev_rows = _tmp11_;
#line 846 "../src/Photo.vala"
				_tmp12_ = dev_rows;
#line 846 "../src/Photo.vala"
				if (_tmp12_ != NULL) {
#line 7851 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp13_;
						GeeIterator* _tmp14_;
#line 847 "../src/Photo.vala"
						_tmp13_ = dev_rows;
#line 847 "../src/Photo.vala"
						_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 847 "../src/Photo.vala"
						_r_it = _tmp14_;
#line 847 "../src/Photo.vala"
						while (TRUE) {
#line 7864 "Photo.c"
							GeeIterator* _tmp15_;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp16_;
							gpointer _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							BackingFileState** _tmp20_;
							gint _tmp20__length1;
							BackingPhotoRow* _tmp21_;
							BackingFileState* _tmp22_;
#line 847 "../src/Photo.vala"
							_tmp15_ = _r_it;
#line 847 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp15_)) {
#line 847 "../src/Photo.vala"
								break;
#line 7881 "Photo.c"
							}
#line 847 "../src/Photo.vala"
							_tmp16_ = _r_it;
#line 847 "../src/Photo.vala"
							_tmp17_ = gee_iterator_get (_tmp16_);
#line 847 "../src/Photo.vala"
							r = (BackingPhotoRow*) _tmp17_;
#line 848 "../src/Photo.vala"
							_tmp18_ = r;
#line 848 "../src/Photo.vala"
							_tmp19_ = _tmp18_->filepath;
#line 848 "../src/Photo.vala"
							g_debug ("Photo.vala:848: adding: %s", _tmp19_);
#line 849 "../src/Photo.vala"
							_tmp20_ = backing;
#line 849 "../src/Photo.vala"
							_tmp20__length1 = backing_length1;
#line 849 "../src/Photo.vala"
							_tmp21_ = r;
#line 849 "../src/Photo.vala"
							_tmp22_ = backing_file_state_new_from_photo_row (_tmp21_, NULL);
#line 849 "../src/Photo.vala"
							_vala_array_add9 (&backing, &backing_length1, &_backing_size_, _tmp22_);
#line 847 "../src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 7907 "Photo.c"
						}
#line 847 "../src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 7911 "Photo.c"
					}
				}
#line 844 "../src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 7916 "Photo.c"
			}
		}
		__finally114:
		{
			PhotoRow* _tmp23_;
#line 838 "../src/Photo.vala"
			_tmp23_ = self->row;
#line 838 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7926 "Photo.c"
		}
#line 838 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 838 "../src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 838 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 838 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 838 "../src/Photo.vala"
			return NULL;
#line 7938 "Photo.c"
		}
	}
#line 855 "../src/Photo.vala"
	_tmp24_ = backing;
#line 855 "../src/Photo.vala"
	_tmp24__length1 = backing_length1;
#line 855 "../src/Photo.vala"
	if (result_length1) {
#line 855 "../src/Photo.vala"
		*result_length1 = _tmp24__length1;
#line 7949 "Photo.c"
	}
#line 855 "../src/Photo.vala"
	result = _tmp24_;
#line 855 "../src/Photo.vala"
	return result;
#line 7955 "Photo.c"
}

static PhotoFileReader*
photo_get_backing_reader (Photo* self,
                          BackingFetchMode mode)
{
	PhotoFileReader* result = NULL;
#line 858 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 859 "../src/Photo.vala"
	switch (mode) {
#line 859 "../src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 7969 "Photo.c"
		{
			PhotoFileReader* _tmp0_;
#line 861 "../src/Photo.vala"
			_tmp0_ = photo_get_master_reader (self);
#line 861 "../src/Photo.vala"
			result = _tmp0_;
#line 861 "../src/Photo.vala"
			return result;
#line 7978 "Photo.c"
		}
#line 859 "../src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 7982 "Photo.c"
		{
			PhotoFileReader* _tmp1_;
#line 864 "../src/Photo.vala"
			_tmp1_ = photo_get_baseline_reader (self);
#line 864 "../src/Photo.vala"
			result = _tmp1_;
#line 864 "../src/Photo.vala"
			return result;
#line 7991 "Photo.c"
		}
#line 859 "../src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 7995 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
#line 867 "../src/Photo.vala"
			_tmp2_ = photo_get_source_reader (self);
#line 867 "../src/Photo.vala"
			result = _tmp2_;
#line 867 "../src/Photo.vala"
			return result;
#line 8004 "Photo.c"
		}
#line 859 "../src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 8008 "Photo.c"
		{
#line 870 "../src/Photo.vala"
			if (photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW) {
#line 8012 "Photo.c"
				PhotoFileReader* _tmp3_;
#line 871 "../src/Photo.vala"
				_tmp3_ = photo_get_raw_developer_reader (self);
#line 871 "../src/Photo.vala"
				result = _tmp3_;
#line 871 "../src/Photo.vala"
				return result;
#line 8020 "Photo.c"
			} else {
				PhotoFileReader* _tmp4_;
#line 873 "../src/Photo.vala"
				_tmp4_ = photo_get_master_reader (self);
#line 873 "../src/Photo.vala"
				result = _tmp4_;
#line 873 "../src/Photo.vala"
				return result;
#line 8029 "Photo.c"
			}
		}
		default:
		{
			GEnumValue* _tmp5_;
#line 877 "../src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), mode);
#line 877 "../src/Photo.vala"
			g_error ("Photo.vala:877: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 8039 "Photo.c"
		}
	}
}

static gpointer
_photo_file_adapter_ref0 (gpointer self)
{
#line 883 "../src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 8049 "Photo.c"
}

static PhotoFileReader*
photo_get_master_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 881 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8059 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 882 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 882 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8066 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 883 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 883 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 883 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 883 "../src/Photo.vala"
			result = _tmp3_;
#line 8079 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 882 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 882 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8086 "Photo.c"
			}
#line 883 "../src/Photo.vala"
			return result;
#line 8090 "Photo.c"
		}
		__finally115:
		{
			PhotoBackingReaders* _tmp5_;
#line 882 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 882 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8099 "Photo.c"
		}
#line 882 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 882 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 882 "../src/Photo.vala"
		return NULL;
#line 8107 "Photo.c"
	}
}

PhotoFileReader*
photo_get_editable_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 887 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8118 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 888 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 888 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8125 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 889 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 889 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 889 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 889 "../src/Photo.vala"
			result = _tmp3_;
#line 8138 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 888 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 888 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8145 "Photo.c"
			}
#line 889 "../src/Photo.vala"
			return result;
#line 8149 "Photo.c"
		}
		__finally116:
		{
			PhotoBackingReaders* _tmp5_;
#line 888 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 888 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8158 "Photo.c"
		}
#line 888 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 888 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 888 "../src/Photo.vala"
		return NULL;
#line 8166 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_baseline_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 894 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8177 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 895 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 895 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8184 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 896 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 896 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 896 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8199 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 897 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 897 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 897 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 897 "../src/Photo.vala"
				result = _tmp5_;
#line 8211 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 895 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 895 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8218 "Photo.c"
				}
#line 897 "../src/Photo.vala"
				return result;
#line 8222 "Photo.c"
			}
#line 900 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 900 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 900 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8230 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 901 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 901 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 901 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 901 "../src/Photo.vala"
				result = _tmp11_;
#line 8242 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 895 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 895 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8249 "Photo.c"
				}
#line 901 "../src/Photo.vala"
				return result;
#line 8253 "Photo.c"
			}
#line 904 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 904 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 904 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 904 "../src/Photo.vala"
			result = _tmp15_;
#line 8263 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 895 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 895 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8270 "Photo.c"
			}
#line 904 "../src/Photo.vala"
			return result;
#line 8274 "Photo.c"
		}
		__finally117:
		{
			PhotoBackingReaders* _tmp17_;
#line 895 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 895 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8283 "Photo.c"
		}
#line 895 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 895 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 895 "../src/Photo.vala"
		return NULL;
#line 8291 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_source_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 909 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8302 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 910 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 910 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8309 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders* _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders* _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 911 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 911 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 911 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8324 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 912 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 912 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 912 "../src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 912 "../src/Photo.vala"
				result = _tmp5_;
#line 8336 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_;
#line 910 "../src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 910 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8343 "Photo.c"
				}
#line 912 "../src/Photo.vala"
				return result;
#line 8347 "Photo.c"
			}
#line 915 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 915 "../src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 915 "../src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 8355 "Photo.c"
				PhotoBackingReaders* _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 916 "../src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 916 "../src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 916 "../src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 916 "../src/Photo.vala"
				result = _tmp11_;
#line 8367 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_;
#line 910 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 910 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8374 "Photo.c"
				}
#line 916 "../src/Photo.vala"
				return result;
#line 8378 "Photo.c"
			}
#line 919 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 919 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 919 "../src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 919 "../src/Photo.vala"
			result = _tmp15_;
#line 8388 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_;
#line 910 "../src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 910 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8395 "Photo.c"
			}
#line 919 "../src/Photo.vala"
			return result;
#line 8399 "Photo.c"
		}
		__finally118:
		{
			PhotoBackingReaders* _tmp17_;
#line 910 "../src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 910 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8408 "Photo.c"
		}
#line 910 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 910 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 910 "../src/Photo.vala"
		return NULL;
#line 8416 "Photo.c"
	}
}

static PhotoFileReader*
photo_get_raw_developer_reader (Photo* self)
{
	PhotoFileReader* result = NULL;
	GError* _inner_error0_ = NULL;
#line 924 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8427 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 925 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 925 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8434 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 926 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 926 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 926 "../src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 926 "../src/Photo.vala"
			result = _tmp3_;
#line 8447 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_;
#line 925 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 925 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8454 "Photo.c"
			}
#line 926 "../src/Photo.vala"
			return result;
#line 8458 "Photo.c"
		}
		__finally119:
		{
			PhotoBackingReaders* _tmp5_;
#line 925 "../src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 925 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8467 "Photo.c"
		}
#line 925 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 925 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 925 "../src/Photo.vala"
		return NULL;
#line 8475 "Photo.c"
	}
}

gboolean
photo_is_developed (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 930 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8486 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 931 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 931 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8494 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 932 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 932 "../src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 932 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8504 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 931 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 931 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8511 "Photo.c"
			}
#line 932 "../src/Photo.vala"
			return result;
#line 8515 "Photo.c"
		}
		__finally120:
		{
			PhotoBackingReaders* _tmp4_;
#line 931 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 931 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8524 "Photo.c"
		}
#line 931 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 931 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 931 "../src/Photo.vala"
		return _tmp5_;
#line 8532 "Photo.c"
	}
}

gboolean
photo_has_editable (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 936 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8543 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 937 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 937 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8551 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 938 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 938 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 938 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8561 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 937 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 937 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8568 "Photo.c"
			}
#line 938 "../src/Photo.vala"
			return result;
#line 8572 "Photo.c"
		}
		__finally121:
		{
			PhotoBackingReaders* _tmp4_;
#line 937 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 937 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8581 "Photo.c"
		}
#line 937 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 937 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 937 "../src/Photo.vala"
		return _tmp5_;
#line 8589 "Photo.c"
	}
}

gboolean
photo_does_master_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 942 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8600 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 943 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 943 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8608 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 944 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 944 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 944 "../src/Photo.vala"
			result = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp2_);
#line 8618 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 943 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 943 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8625 "Photo.c"
			}
#line 944 "../src/Photo.vala"
			return result;
#line 8629 "Photo.c"
		}
		__finally122:
		{
			PhotoBackingReaders* _tmp4_;
#line 943 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 943 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8638 "Photo.c"
		}
#line 943 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 943 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 943 "../src/Photo.vala"
		return _tmp5_;
#line 8646 "Photo.c"
	}
}

gboolean
photo_does_editable_exist (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 949 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8657 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 950 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 950 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8665 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 951 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 951 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 951 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 8676 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 951 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 951 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 951 "../src/Photo.vala"
				_tmp1_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp5_);
#line 8685 "Photo.c"
			} else {
#line 951 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 8689 "Photo.c"
			}
#line 951 "../src/Photo.vala"
			result = _tmp1_;
#line 8693 "Photo.c"
			{
				PhotoBackingReaders* _tmp6_;
#line 950 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 950 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8700 "Photo.c"
			}
#line 951 "../src/Photo.vala"
			return result;
#line 8704 "Photo.c"
		}
		__finally123:
		{
			PhotoBackingReaders* _tmp7_;
#line 950 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 950 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8713 "Photo.c"
		}
#line 950 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 950 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 950 "../src/Photo.vala"
		return _tmp8_;
#line 8721 "Photo.c"
	}
}

gboolean
photo_is_master_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 955 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8732 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 956 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 956 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8740 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 957 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 957 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 957 "../src/Photo.vala"
			result = _tmp2_ == NULL;
#line 8750 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 956 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 956 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8757 "Photo.c"
			}
#line 957 "../src/Photo.vala"
			return result;
#line 8761 "Photo.c"
		}
		__finally124:
		{
			PhotoBackingReaders* _tmp4_;
#line 956 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 956 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8770 "Photo.c"
		}
#line 956 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 956 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 956 "../src/Photo.vala"
		return _tmp5_;
#line 8778 "Photo.c"
	}
}

gboolean
photo_is_master_source (Photo* self)
{
	gboolean result = FALSE;
#line 961 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 962 "../src/Photo.vala"
	result = !photo_has_editable (self);
#line 962 "../src/Photo.vala"
	return result;
#line 8792 "Photo.c"
}

gboolean
photo_is_editable_baseline (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 965 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8802 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
		gboolean _tmp5_ = FALSE;
#line 966 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 966 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8810 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 967 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 967 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 967 "../src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8820 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_;
#line 966 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 966 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8827 "Photo.c"
			}
#line 967 "../src/Photo.vala"
			return result;
#line 8831 "Photo.c"
		}
		__finally125:
		{
			PhotoBackingReaders* _tmp4_;
#line 966 "../src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 966 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8840 "Photo.c"
		}
#line 966 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 966 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 966 "../src/Photo.vala"
		return _tmp5_;
#line 8848 "Photo.c"
	}
}

gboolean
photo_is_editable_source (Photo* self)
{
	gboolean result = FALSE;
#line 971 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 972 "../src/Photo.vala"
	result = photo_has_editable (self);
#line 972 "../src/Photo.vala"
	return result;
#line 8862 "Photo.c"
}

BackingPhotoRow*
photo_get_master_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 975 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8872 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 976 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 976 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8879 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
			BackingPhotoRow* _tmp3_;
#line 977 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 977 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 977 "../src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 977 "../src/Photo.vala"
			result = _tmp3_;
#line 8892 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 976 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 976 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8899 "Photo.c"
			}
#line 977 "../src/Photo.vala"
			return result;
#line 8903 "Photo.c"
		}
		__finally126:
		{
			PhotoRow* _tmp5_;
#line 976 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 976 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8912 "Photo.c"
		}
#line 976 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 976 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 976 "../src/Photo.vala"
		return NULL;
#line 8920 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_editable_photo_row (Photo* self)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 981 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8931 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 982 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 982 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8938 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 984 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 984 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp1_->editable_id)) {
#line 8945 "Photo.c"
				BackingPhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
#line 985 "../src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 985 "../src/Photo.vala"
				_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 985 "../src/Photo.vala"
				result = _tmp3_;
#line 8954 "Photo.c"
				{
					PhotoRow* _tmp4_;
#line 982 "../src/Photo.vala"
					_tmp4_ = self->row;
#line 982 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8961 "Photo.c"
				}
#line 985 "../src/Photo.vala"
				return result;
#line 8965 "Photo.c"
			} else {
#line 987 "../src/Photo.vala"
				result = NULL;
#line 8969 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 982 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 982 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8976 "Photo.c"
				}
#line 987 "../src/Photo.vala"
				return result;
#line 8980 "Photo.c"
			}
		}
		__finally127:
		{
			PhotoRow* _tmp6_;
#line 982 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 982 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8990 "Photo.c"
		}
#line 982 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 982 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 982 "../src/Photo.vala"
		return NULL;
#line 8998 "Photo.c"
	}
}

GeeCollection*
photo_get_raw_development_photo_rows (Photo* self)
{
	GeeCollection* result = NULL;
	GError* _inner_error0_ = NULL;
#line 992 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9009 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 993 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 993 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9016 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 994 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 994 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9024 "Photo.c"
				GeeHashMap* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
#line 994 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 994 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 994 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 994 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 994 "../src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 9038 "Photo.c"
			} else {
#line 994 "../src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 994 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9044 "Photo.c"
			}
#line 994 "../src/Photo.vala"
			result = _tmp1_;
#line 9048 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 993 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 993 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9055 "Photo.c"
			}
#line 994 "../src/Photo.vala"
			return result;
#line 9059 "Photo.c"
		}
		__finally128:
		{
			PhotoRow* _tmp7_;
#line 993 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 993 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9068 "Photo.c"
		}
#line 993 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 993 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 993 "../src/Photo.vala"
		return NULL;
#line 9076 "Photo.c"
	}
}

BackingPhotoRow*
photo_get_raw_development_photo_row (Photo* self,
                                     RawDeveloper d)
{
	BackingPhotoRow* result = NULL;
	GError* _inner_error0_ = NULL;
#line 998 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9088 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 999 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 999 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 9095 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_;
#line 1000 "../src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 1000 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 9103 "Photo.c"
				GeeHashMap* _tmp3_;
				gpointer _tmp4_;
#line 1000 "../src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1000 "../src/Photo.vala"
				_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) d));
#line 1000 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1000 "../src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp4_;
#line 9114 "Photo.c"
			} else {
#line 1000 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 1000 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 9120 "Photo.c"
			}
#line 1000 "../src/Photo.vala"
			result = _tmp1_;
#line 9124 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 999 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 999 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9131 "Photo.c"
			}
#line 1000 "../src/Photo.vala"
			return result;
#line 9135 "Photo.c"
		}
		__finally129:
		{
			PhotoRow* _tmp6_;
#line 999 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 999 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 9144 "Photo.c"
		}
#line 999 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 999 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 999 "../src/Photo.vala"
		return NULL;
#line 9152 "Photo.c"
	}
}

static PhotoFileFormat*
_photo_file_format_dup (PhotoFileFormat* self)
{
	PhotoFileFormat* dup;
#line 1011 "../src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 1011 "../src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 1011 "../src/Photo.vala"
	return dup;
#line 9166 "Photo.c"
}

static gpointer
__photo_file_format_dup0 (gpointer self)
{
#line 1011 "../src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 9174 "Photo.c"
}

PhotoFileFormat*
photo_get_editable_file_format (Photo* self)
{
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_;
	PhotoFileFormat* _tmp4_;
#line 1004 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1005 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1005 "../src/Photo.vala"
	reader = _tmp0_;
#line 1006 "../src/Photo.vala"
	_tmp1_ = reader;
#line 1006 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1007 "../src/Photo.vala"
		result = NULL;
#line 1007 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 1007 "../src/Photo.vala"
		return result;
#line 9203 "Photo.c"
	}
#line 1011 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1011 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 1011 "../src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 1011 "../src/Photo.vala"
	result = _tmp4_;
#line 1011 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1011 "../src/Photo.vala"
	return result;
#line 9217 "Photo.c"
}

PhotoFileFormat
photo_get_export_format_for_parameters (Photo* self,
                                        ExportFormatParameters* params)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
#line 1014 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1014 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1015 "../src/Photo.vala"
	_result_ = photo_file_format_get_system_default_format ();
#line 1017 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1017 "../src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1017 "../src/Photo.vala"
	switch (_tmp1_) {
#line 1017 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 9242 "Photo.c"
		{
#line 1019 "../src/Photo.vala"
			_result_ = photo_get_master_file_format (self);
#line 1020 "../src/Photo.vala"
			break;
#line 9248 "Photo.c"
		}
#line 1017 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 9252 "Photo.c"
		{
#line 1023 "../src/Photo.vala"
			_result_ = photo_get_best_export_file_format (self);
#line 1024 "../src/Photo.vala"
			break;
#line 9258 "Photo.c"
		}
#line 1017 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 9262 "Photo.c"
		{
			ExportFormatParameters _tmp2_;
			PhotoFileFormat _tmp3_;
#line 1027 "../src/Photo.vala"
			_tmp2_ = *params;
#line 1027 "../src/Photo.vala"
			_tmp3_ = _tmp2_.specified_format;
#line 1027 "../src/Photo.vala"
			_result_ = _tmp3_;
#line 1028 "../src/Photo.vala"
			break;
#line 9274 "Photo.c"
		}
		default:
		{
#line 1031 "../src/Photo.vala"
			g_error ("Photo.vala:1031: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 9280 "Photo.c"
		}
	}
#line 1034 "../src/Photo.vala"
	result = _result_;
#line 1034 "../src/Photo.vala"
	return result;
#line 9287 "Photo.c"
}

gchar*
photo_get_export_basename_for_parameters (Photo* self,
                                          ExportFormatParameters* params)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 1037 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1037 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1038 "../src/Photo.vala"
	_result_ = NULL;
#line 1040 "../src/Photo.vala"
	_tmp0_ = *params;
#line 1040 "../src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1040 "../src/Photo.vala"
	switch (_tmp1_) {
#line 1040 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 9313 "Photo.c"
		{
			GFile* _tmp2_;
			GFile* _tmp3_;
			gchar* _tmp4_;
#line 1042 "../src/Photo.vala"
			_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 1042 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1042 "../src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1042 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1042 "../src/Photo.vala"
			_result_ = _tmp4_;
#line 1042 "../src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1043 "../src/Photo.vala"
			break;
#line 9332 "Photo.c"
		}
#line 1040 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1040 "../src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 9338 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
			gchar* _tmp7_;
#line 1047 "../src/Photo.vala"
			_tmp5_ = *params;
#line 1047 "../src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1047 "../src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1047 "../src/Photo.vala"
			result = _tmp7_;
#line 1047 "../src/Photo.vala"
			_g_free0 (_result_);
#line 1047 "../src/Photo.vala"
			return result;
#line 9355 "Photo.c"
		}
		default:
		{
#line 1050 "../src/Photo.vala"
			g_error ("Photo.vala:1050: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 9361 "Photo.c"
		}
	}
#line 1053 "../src/Photo.vala"
	_tmp8_ = _result_;
#line 1053 "../src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1054 "../src/Photo.vala"
	result = _result_;
#line 1054 "../src/Photo.vala"
	return result;
#line 9372 "Photo.c"
}

ImportResult
photo_prepare_for_import (PhotoImportParams* params)
{
	ImportResult result = 0;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp11_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp23_;
	PhotoFileSnifferOptions _tmp24_;
	PhotoFileInterrogator* _tmp25_;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp32_;
	DetectedPhotoInformation* _tmp33_;
	DetectedPhotoInformation* _tmp34_;
	PhotoFileSnifferOptions _tmp35_;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp45_;
	gchar* comment = NULL;
	gchar* _tmp46_;
	DetectedPhotoInformation* _tmp47_;
	PhotoMetadata* _tmp48_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	DetectedPhotoInformation* _tmp67_;
	GdkColorspace _tmp68_;
	PhotoRow* _tmp74_;
	PhotoRow* _tmp75_;
	BackingPhotoRow* _tmp76_;
	GFile* _tmp77_;
	gchar* _tmp78_;
	PhotoRow* _tmp79_;
	BackingPhotoRow* _tmp80_;
	DetectedPhotoInformation* _tmp81_;
	Dimensions _tmp82_;
	PhotoRow* _tmp83_;
	BackingPhotoRow* _tmp84_;
	GFileInfo* _tmp85_;
	PhotoRow* _tmp86_;
	BackingPhotoRow* _tmp87_;
	GTimeVal _tmp88_;
	PhotoRow* _tmp89_;
	PhotoRow* _tmp90_;
	Orientation _tmp91_;
	PhotoRow* _tmp92_;
	BackingPhotoRow* _tmp93_;
	Orientation _tmp94_;
	PhotoRow* _tmp95_;
	ImportID _tmp96_;
	PhotoRow* _tmp97_;
	PhotoRow* _tmp98_;
	PhotoRow* _tmp99_;
	DetectedPhotoInformation* _tmp100_;
	const gchar* _tmp101_;
	gchar* _tmp102_;
	PhotoRow* _tmp103_;
	DetectedPhotoInformation* _tmp104_;
	const gchar* _tmp105_;
	gchar* _tmp106_;
	PhotoRow* _tmp107_;
	DetectedPhotoInformation* _tmp108_;
	const gchar* _tmp109_;
	gchar* _tmp110_;
	PhotoRow* _tmp111_;
	PhotoRow* _tmp112_;
	PhotoRow* _tmp113_;
	BackingPhotoRow* _tmp114_;
	DetectedPhotoInformation* _tmp115_;
	PhotoFileFormat _tmp116_;
	PhotoRow* _tmp117_;
	const gchar* _tmp118_;
	gchar* _tmp119_;
	PhotoRow* _tmp120_;
	const gchar* _tmp121_;
	gchar* _tmp122_;
	Thumbnails* _tmp123_;
	GError* _inner_error0_ = NULL;
#line 1069 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1073 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1073 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1073 "../src/Photo.vala"
	file = _tmp1_;
#line 1075 "../src/Photo.vala"
	info = NULL;
#line 9474 "Photo.c"
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 1077 "../src/Photo.vala"
		_tmp3_ = file;
#line 1077 "../src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1077 "../src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 1077 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9488 "Photo.c"
			goto __catch130_g_error;
		}
#line 1077 "../src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 1077 "../src/Photo.vala"
		_tmp2_ = NULL;
#line 1077 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1077 "../src/Photo.vala"
		info = _tmp5_;
#line 1076 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 9501 "Photo.c"
	}
	goto __finally130;
	__catch130_g_error:
	{
		GError* err = NULL;
#line 1076 "../src/Photo.vala"
		err = _inner_error0_;
#line 1076 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1080 "../src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1080 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1080 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1080 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1080 "../src/Photo.vala"
		return result;
#line 9521 "Photo.c"
	}
	__finally130:
#line 1076 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1076 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1076 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1076 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1076 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1076 "../src/Photo.vala"
		return 0;
#line 9536 "Photo.c"
	}
#line 1083 "../src/Photo.vala"
	_tmp6_ = info;
#line 1083 "../src/Photo.vala"
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
#line 1084 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1084 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1084 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1084 "../src/Photo.vala"
		return result;
#line 9550 "Photo.c"
	}
#line 1087 "../src/Photo.vala"
	_tmp7_ = file;
#line 1087 "../src/Photo.vala"
	if (!photo_is_file_image (_tmp7_)) {
#line 9556 "Photo.c"
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1088 "../src/Photo.vala"
		_tmp8_ = file;
#line 1088 "../src/Photo.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 1088 "../src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1088 "../src/Photo.vala"
		g_message ("Photo.vala:1088: Not importing %s: Not an image file", _tmp10_);
#line 1088 "../src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1090 "../src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1090 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1090 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1090 "../src/Photo.vala"
		return result;
#line 9578 "Photo.c"
	}
#line 1093 "../src/Photo.vala"
	_tmp11_ = file;
#line 1093 "../src/Photo.vala"
	if (!photo_file_format_is_file_supported (_tmp11_)) {
#line 9584 "Photo.c"
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1094 "../src/Photo.vala"
		_tmp12_ = file;
#line 1094 "../src/Photo.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1094 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1094 "../src/Photo.vala"
		g_message ("Photo.vala:1094: Not importing %s: Unsupported extension", _tmp14_);
#line 1094 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1096 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1096 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1096 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1096 "../src/Photo.vala"
		return result;
#line 9606 "Photo.c"
	}
#line 1099 "../src/Photo.vala"
	_tmp15_ = info;
#line 1099 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1099 "../src/Photo.vala"
	timestamp = _tmp16_;
#line 1102 "../src/Photo.vala"
	_tmp19_ = params->exif_md5;
#line 1102 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 9618 "Photo.c"
		const gchar* _tmp20_;
#line 1102 "../src/Photo.vala"
		_tmp20_ = params->thumbnail_md5;
#line 1102 "../src/Photo.vala"
		_tmp18_ = _tmp20_ != NULL;
#line 9624 "Photo.c"
	} else {
#line 1102 "../src/Photo.vala"
		_tmp18_ = FALSE;
#line 9628 "Photo.c"
	}
#line 1102 "../src/Photo.vala"
	if (_tmp18_) {
#line 9632 "Photo.c"
		const gchar* _tmp21_;
#line 1102 "../src/Photo.vala"
		_tmp21_ = params->full_md5;
#line 1102 "../src/Photo.vala"
		_tmp17_ = _tmp21_ != NULL;
#line 9638 "Photo.c"
	} else {
#line 1102 "../src/Photo.vala"
		_tmp17_ = FALSE;
#line 9642 "Photo.c"
	}
#line 1102 "../src/Photo.vala"
	if (_tmp17_) {
#line 9646 "Photo.c"
		PhotoFileSnifferOptions _tmp22_;
#line 1103 "../src/Photo.vala"
		_tmp22_ = params->sniffer_options;
#line 1103 "../src/Photo.vala"
		params->sniffer_options = _tmp22_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 9652 "Photo.c"
	}
#line 1107 "../src/Photo.vala"
	_tmp23_ = file;
#line 1107 "../src/Photo.vala"
	_tmp24_ = params->sniffer_options;
#line 1107 "../src/Photo.vala"
	_tmp25_ = photo_file_interrogator_new (_tmp23_, _tmp24_);
#line 1107 "../src/Photo.vala"
	interrogator = _tmp25_;
#line 9662 "Photo.c"
	{
		PhotoFileInterrogator* _tmp26_;
#line 1109 "../src/Photo.vala"
		_tmp26_ = interrogator;
#line 1109 "../src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp26_, &_inner_error0_);
#line 1109 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9671 "Photo.c"
			goto __catch131_g_error;
		}
	}
	goto __finally131;
	__catch131_g_error:
	{
		GError* err = NULL;
		GFile* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1108 "../src/Photo.vala"
		err = _inner_error0_;
#line 1108 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1111 "../src/Photo.vala"
		_tmp27_ = file;
#line 1111 "../src/Photo.vala"
		_tmp28_ = g_file_get_path (_tmp27_);
#line 1111 "../src/Photo.vala"
		_tmp29_ = _tmp28_;
#line 1111 "../src/Photo.vala"
		_tmp30_ = err;
#line 1111 "../src/Photo.vala"
		_tmp31_ = _tmp30_->message;
#line 1111 "../src/Photo.vala"
		g_warning ("Photo.vala:1111: Unable to interrogate photo file %s: %s", _tmp29_, _tmp31_);
#line 1111 "../src/Photo.vala"
		_g_free0 (_tmp29_);
#line 1113 "../src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1113 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1113 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1113 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1113 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1113 "../src/Photo.vala"
		return result;
#line 9714 "Photo.c"
	}
	__finally131:
#line 1108 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1108 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1108 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1108 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1108 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1108 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1108 "../src/Photo.vala"
		return 0;
#line 9731 "Photo.c"
	}
#line 1117 "../src/Photo.vala"
	_tmp32_ = interrogator;
#line 1117 "../src/Photo.vala"
	_tmp33_ = photo_file_interrogator_get_detected_photo_information (_tmp32_);
#line 1117 "../src/Photo.vala"
	detected = _tmp33_;
#line 1118 "../src/Photo.vala"
	_tmp34_ = detected;
#line 1118 "../src/Photo.vala"
	if (_tmp34_ == NULL) {
#line 1119 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1119 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1119 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1119 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1119 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1119 "../src/Photo.vala"
		return result;
#line 9755 "Photo.c"
	}
#line 1123 "../src/Photo.vala"
	_tmp35_ = params->sniffer_options;
#line 1123 "../src/Photo.vala"
	if ((_tmp35_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 9761 "Photo.c"
		DetectedPhotoInformation* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		DetectedPhotoInformation* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		DetectedPhotoInformation* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
#line 1124 "../src/Photo.vala"
		_tmp36_ = detected;
#line 1124 "../src/Photo.vala"
		_tmp37_ = params->exif_md5;
#line 1124 "../src/Photo.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 1124 "../src/Photo.vala"
		_g_free0 (_tmp36_->exif_md5);
#line 1124 "../src/Photo.vala"
		_tmp36_->exif_md5 = _tmp38_;
#line 1125 "../src/Photo.vala"
		_tmp39_ = detected;
#line 1125 "../src/Photo.vala"
		_tmp40_ = params->thumbnail_md5;
#line 1125 "../src/Photo.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 1125 "../src/Photo.vala"
		_g_free0 (_tmp39_->thumbnail_md5);
#line 1125 "../src/Photo.vala"
		_tmp39_->thumbnail_md5 = _tmp41_;
#line 1126 "../src/Photo.vala"
		_tmp42_ = detected;
#line 1126 "../src/Photo.vala"
		_tmp43_ = params->full_md5;
#line 1126 "../src/Photo.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 1126 "../src/Photo.vala"
		_g_free0 (_tmp42_->md5);
#line 1126 "../src/Photo.vala"
		_tmp42_->md5 = _tmp44_;
#line 9801 "Photo.c"
	}
#line 1129 "../src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1130 "../src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1131 "../src/Photo.vala"
	_tmp45_ = g_strdup ("");
#line 1131 "../src/Photo.vala"
	title = _tmp45_;
#line 1132 "../src/Photo.vala"
	_tmp46_ = g_strdup ("");
#line 1132 "../src/Photo.vala"
	comment = _tmp46_;
#line 1139 "../src/Photo.vala"
	_tmp47_ = detected;
#line 1139 "../src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1139 "../src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 9821 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_;
		PhotoMetadata* _tmp50_;
		MetadataDateTime* _tmp51_;
		MetadataDateTime* _tmp52_;
		DetectedPhotoInformation* _tmp54_;
		PhotoMetadata* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoMetadata* _tmp57_;
		gchar* _tmp58_;
		DetectedPhotoInformation* _tmp59_;
		PhotoMetadata* _tmp60_;
		gchar* _tmp61_;
		DetectedPhotoInformation* _tmp62_;
		PhotoMetadata* _tmp63_;
		GeeSet* _tmp64_;
#line 1140 "../src/Photo.vala"
		_tmp49_ = detected;
#line 1140 "../src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1140 "../src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1140 "../src/Photo.vala"
		date_time = _tmp51_;
#line 1141 "../src/Photo.vala"
		_tmp52_ = date_time;
#line 1141 "../src/Photo.vala"
		if (_tmp52_ != NULL) {
#line 9850 "Photo.c"
			MetadataDateTime* _tmp53_;
#line 1142 "../src/Photo.vala"
			_tmp53_ = date_time;
#line 1142 "../src/Photo.vala"
			exposure_time = metadata_date_time_get_timestamp (_tmp53_);
#line 9856 "Photo.c"
		}
#line 1145 "../src/Photo.vala"
		_tmp54_ = detected;
#line 1145 "../src/Photo.vala"
		_tmp55_ = _tmp54_->metadata;
#line 1145 "../src/Photo.vala"
		orientation = photo_metadata_get_orientation (_tmp55_);
#line 1146 "../src/Photo.vala"
		_tmp56_ = detected;
#line 1146 "../src/Photo.vala"
		_tmp57_ = _tmp56_->metadata;
#line 1146 "../src/Photo.vala"
		_tmp58_ = media_metadata_get_title ((MediaMetadata*) _tmp57_);
#line 1146 "../src/Photo.vala"
		_g_free0 (title);
#line 1146 "../src/Photo.vala"
		title = _tmp58_;
#line 1147 "../src/Photo.vala"
		_tmp59_ = detected;
#line 1147 "../src/Photo.vala"
		_tmp60_ = _tmp59_->metadata;
#line 1147 "../src/Photo.vala"
		_tmp61_ = media_metadata_get_comment ((MediaMetadata*) _tmp60_);
#line 1147 "../src/Photo.vala"
		_g_free0 (comment);
#line 1147 "../src/Photo.vala"
		comment = _tmp61_;
#line 1148 "../src/Photo.vala"
		_tmp62_ = detected;
#line 1148 "../src/Photo.vala"
		_tmp63_ = _tmp62_->metadata;
#line 1148 "../src/Photo.vala"
		_tmp64_ = photo_metadata_get_keywords (_tmp63_, NULL, NULL, NULL);
#line 1148 "../src/Photo.vala"
		_g_object_unref0 (params->keywords);
#line 1148 "../src/Photo.vala"
		params->keywords = (GeeCollection*) _tmp64_;
#line 1139 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 9896 "Photo.c"
	}
#line 1152 "../src/Photo.vala"
	_tmp67_ = detected;
#line 1152 "../src/Photo.vala"
	_tmp68_ = _tmp67_->colorspace;
#line 1152 "../src/Photo.vala"
	if (_tmp68_ != GDK_COLORSPACE_RGB) {
#line 1152 "../src/Photo.vala"
		_tmp66_ = TRUE;
#line 9906 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp69_;
#line 1153 "../src/Photo.vala"
		_tmp69_ = detected;
#line 1153 "../src/Photo.vala"
		_tmp66_ = _tmp69_->channels < 3;
#line 9913 "Photo.c"
	}
#line 1152 "../src/Photo.vala"
	if (_tmp66_) {
#line 1152 "../src/Photo.vala"
		_tmp65_ = TRUE;
#line 9919 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp70_;
#line 1154 "../src/Photo.vala"
		_tmp70_ = detected;
#line 1154 "../src/Photo.vala"
		_tmp65_ = _tmp70_->bits_per_channel != 8;
#line 9926 "Photo.c"
	}
#line 1152 "../src/Photo.vala"
	if (_tmp65_) {
#line 9930 "Photo.c"
		GFile* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
#line 1155 "../src/Photo.vala"
		_tmp71_ = file;
#line 1155 "../src/Photo.vala"
		_tmp72_ = g_file_get_path (_tmp71_);
#line 1155 "../src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 1155 "../src/Photo.vala"
		g_message ("Photo.vala:1155: Not importing %s: Unsupported color format", _tmp73_);
#line 1155 "../src/Photo.vala"
		_g_free0 (_tmp73_);
#line 1157 "../src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1157 "../src/Photo.vala"
		_g_free0 (comment);
#line 1157 "../src/Photo.vala"
		_g_free0 (title);
#line 1157 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1157 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1157 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1157 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1157 "../src/Photo.vala"
		return result;
#line 9960 "Photo.c"
	}
#line 1163 "../src/Photo.vala"
	_tmp74_ = params->row;
#line 1163 "../src/Photo.vala"
	photo_id_init (&_tmp74_->photo_id, PHOTO_ID_INVALID);
#line 1164 "../src/Photo.vala"
	_tmp75_ = params->row;
#line 1164 "../src/Photo.vala"
	_tmp76_ = _tmp75_->master;
#line 1164 "../src/Photo.vala"
	_tmp77_ = file;
#line 1164 "../src/Photo.vala"
	_tmp78_ = g_file_get_path (_tmp77_);
#line 1164 "../src/Photo.vala"
	_g_free0 (_tmp76_->filepath);
#line 1164 "../src/Photo.vala"
	_tmp76_->filepath = _tmp78_;
#line 1165 "../src/Photo.vala"
	_tmp79_ = params->row;
#line 1165 "../src/Photo.vala"
	_tmp80_ = _tmp79_->master;
#line 1165 "../src/Photo.vala"
	_tmp81_ = detected;
#line 1165 "../src/Photo.vala"
	_tmp82_ = _tmp81_->image_dim;
#line 1165 "../src/Photo.vala"
	_tmp80_->dim = _tmp82_;
#line 1166 "../src/Photo.vala"
	_tmp83_ = params->row;
#line 1166 "../src/Photo.vala"
	_tmp84_ = _tmp83_->master;
#line 1166 "../src/Photo.vala"
	_tmp85_ = info;
#line 1166 "../src/Photo.vala"
	_tmp84_->filesize = g_file_info_get_size (_tmp85_);
#line 1167 "../src/Photo.vala"
	_tmp86_ = params->row;
#line 1167 "../src/Photo.vala"
	_tmp87_ = _tmp86_->master;
#line 1167 "../src/Photo.vala"
	_tmp88_ = timestamp;
#line 1167 "../src/Photo.vala"
	_tmp87_->timestamp = (time_t) _tmp88_.tv_sec;
#line 1168 "../src/Photo.vala"
	_tmp89_ = params->row;
#line 1168 "../src/Photo.vala"
	_tmp89_->exposure_time = exposure_time;
#line 1169 "../src/Photo.vala"
	_tmp90_ = params->row;
#line 1169 "../src/Photo.vala"
	_tmp91_ = orientation;
#line 1169 "../src/Photo.vala"
	_tmp90_->orientation = _tmp91_;
#line 1170 "../src/Photo.vala"
	_tmp92_ = params->row;
#line 1170 "../src/Photo.vala"
	_tmp93_ = _tmp92_->master;
#line 1170 "../src/Photo.vala"
	_tmp94_ = orientation;
#line 1170 "../src/Photo.vala"
	_tmp93_->original_orientation = _tmp94_;
#line 1171 "../src/Photo.vala"
	_tmp95_ = params->row;
#line 1171 "../src/Photo.vala"
	_tmp96_ = params->import_id;
#line 1171 "../src/Photo.vala"
	_tmp95_->import_id = _tmp96_;
#line 1172 "../src/Photo.vala"
	_tmp97_ = params->row;
#line 1172 "../src/Photo.vala"
	event_id_init (&_tmp97_->event_id, EVENT_ID_INVALID);
#line 1173 "../src/Photo.vala"
	_tmp98_ = params->row;
#line 1173 "../src/Photo.vala"
	_g_object_unref0 (_tmp98_->transformations);
#line 1173 "../src/Photo.vala"
	_tmp98_->transformations = NULL;
#line 1174 "../src/Photo.vala"
	_tmp99_ = params->row;
#line 1174 "../src/Photo.vala"
	_tmp100_ = detected;
#line 1174 "../src/Photo.vala"
	_tmp101_ = _tmp100_->md5;
#line 1174 "../src/Photo.vala"
	_tmp102_ = g_strdup (_tmp101_);
#line 1174 "../src/Photo.vala"
	_g_free0 (_tmp99_->md5);
#line 1174 "../src/Photo.vala"
	_tmp99_->md5 = _tmp102_;
#line 1175 "../src/Photo.vala"
	_tmp103_ = params->row;
#line 1175 "../src/Photo.vala"
	_tmp104_ = detected;
#line 1175 "../src/Photo.vala"
	_tmp105_ = _tmp104_->thumbnail_md5;
#line 1175 "../src/Photo.vala"
	_tmp106_ = g_strdup (_tmp105_);
#line 1175 "../src/Photo.vala"
	_g_free0 (_tmp103_->thumbnail_md5);
#line 1175 "../src/Photo.vala"
	_tmp103_->thumbnail_md5 = _tmp106_;
#line 1176 "../src/Photo.vala"
	_tmp107_ = params->row;
#line 1176 "../src/Photo.vala"
	_tmp108_ = detected;
#line 1176 "../src/Photo.vala"
	_tmp109_ = _tmp108_->exif_md5;
#line 1176 "../src/Photo.vala"
	_tmp110_ = g_strdup (_tmp109_);
#line 1176 "../src/Photo.vala"
	_g_free0 (_tmp107_->exif_md5);
#line 1176 "../src/Photo.vala"
	_tmp107_->exif_md5 = _tmp110_;
#line 1177 "../src/Photo.vala"
	_tmp111_ = params->row;
#line 1177 "../src/Photo.vala"
	_tmp111_->time_created = (time_t) 0;
#line 1178 "../src/Photo.vala"
	_tmp112_ = params->row;
#line 1178 "../src/Photo.vala"
	_tmp112_->flags = (guint64) 0;
#line 1179 "../src/Photo.vala"
	_tmp113_ = params->row;
#line 1179 "../src/Photo.vala"
	_tmp114_ = _tmp113_->master;
#line 1179 "../src/Photo.vala"
	_tmp115_ = detected;
#line 1179 "../src/Photo.vala"
	_tmp116_ = _tmp115_->file_format;
#line 1179 "../src/Photo.vala"
	_tmp114_->file_format = _tmp116_;
#line 1180 "../src/Photo.vala"
	_tmp117_ = params->row;
#line 1180 "../src/Photo.vala"
	_tmp118_ = title;
#line 1180 "../src/Photo.vala"
	_tmp119_ = g_strdup (_tmp118_);
#line 1180 "../src/Photo.vala"
	_g_free0 (_tmp117_->title);
#line 1180 "../src/Photo.vala"
	_tmp117_->title = _tmp119_;
#line 1181 "../src/Photo.vala"
	_tmp120_ = params->row;
#line 1181 "../src/Photo.vala"
	_tmp121_ = comment;
#line 1181 "../src/Photo.vala"
	_tmp122_ = g_strdup (_tmp121_);
#line 1181 "../src/Photo.vala"
	_g_free0 (_tmp120_->comment);
#line 1181 "../src/Photo.vala"
	_tmp120_->comment = _tmp122_;
#line 1183 "../src/Photo.vala"
	_tmp123_ = params->thumbnails;
#line 1183 "../src/Photo.vala"
	if (_tmp123_ != NULL) {
#line 10116 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoRow* _tmp124_;
		BackingPhotoRow* _tmp125_;
		PhotoFileFormat _tmp126_;
		PhotoRow* _tmp127_;
		BackingPhotoRow* _tmp128_;
		const gchar* _tmp129_;
		PhotoFileReader* _tmp130_;
#line 1184 "../src/Photo.vala"
		_tmp124_ = params->row;
#line 1184 "../src/Photo.vala"
		_tmp125_ = _tmp124_->master;
#line 1184 "../src/Photo.vala"
		_tmp126_ = _tmp125_->file_format;
#line 1184 "../src/Photo.vala"
		_tmp127_ = params->row;
#line 1184 "../src/Photo.vala"
		_tmp128_ = _tmp127_->master;
#line 1184 "../src/Photo.vala"
		_tmp129_ = _tmp128_->filepath;
#line 1184 "../src/Photo.vala"
		_tmp130_ = photo_file_format_create_reader (_tmp126_, _tmp129_);
#line 1184 "../src/Photo.vala"
		reader = _tmp130_;
#line 10141 "Photo.c"
		{
			Thumbnails* _tmp131_;
			PhotoFileReader* _tmp132_;
			PhotoRow* _tmp133_;
			Orientation _tmp134_;
			PhotoRow* _tmp135_;
			BackingPhotoRow* _tmp136_;
			Dimensions _tmp137_;
#line 1187 "../src/Photo.vala"
			_tmp131_ = params->thumbnails;
#line 1187 "../src/Photo.vala"
			_tmp132_ = reader;
#line 1187 "../src/Photo.vala"
			_tmp133_ = params->row;
#line 1187 "../src/Photo.vala"
			_tmp134_ = _tmp133_->orientation;
#line 1187 "../src/Photo.vala"
			_tmp135_ = params->row;
#line 1187 "../src/Photo.vala"
			_tmp136_ = _tmp135_->master;
#line 1187 "../src/Photo.vala"
			_tmp137_ = _tmp136_->dim;
#line 1187 "../src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp131_, _tmp132_, _tmp134_, &_tmp137_, &_inner_error0_);
#line 1187 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10168 "Photo.c"
				goto __catch132_g_error;
			}
		}
		goto __finally132;
		__catch132_g_error:
		{
			GError* err = NULL;
			GError* _tmp138_;
#line 1186 "../src/Photo.vala"
			err = _inner_error0_;
#line 1186 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 1190 "../src/Photo.vala"
			_tmp138_ = err;
#line 1190 "../src/Photo.vala"
			result = import_result_convert_error (_tmp138_, IMPORT_RESULT_FILE_ERROR);
#line 1190 "../src/Photo.vala"
			_g_error_free0 (err);
#line 1190 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1190 "../src/Photo.vala"
			_g_free0 (comment);
#line 1190 "../src/Photo.vala"
			_g_free0 (title);
#line 1190 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1190 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1190 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1190 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1190 "../src/Photo.vala"
			return result;
#line 10203 "Photo.c"
		}
		__finally132:
#line 1186 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1186 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1186 "../src/Photo.vala"
			_g_free0 (comment);
#line 1186 "../src/Photo.vala"
			_g_free0 (title);
#line 1186 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1186 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1186 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 1186 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1186 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1186 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1186 "../src/Photo.vala"
			return 0;
#line 10228 "Photo.c"
		}
#line 1183 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 10232 "Photo.c"
	}
#line 1197 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1197 "../src/Photo.vala"
	_g_free0 (comment);
#line 1197 "../src/Photo.vala"
	_g_free0 (title);
#line 1197 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1197 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1197 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1197 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1197 "../src/Photo.vala"
	return result;
#line 10250 "Photo.c"
}

void
photo_create_pre_import (PhotoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoRow* _tmp3_;
	BackingPhotoRow* _tmp4_;
	gchar* _tmp5_;
	PhotoRow* _tmp6_;
	BackingPhotoRow* _tmp7_;
	PhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	PhotoRow* _tmp10_;
	BackingPhotoRow* _tmp11_;
	PhotoRow* _tmp12_;
	PhotoRow* _tmp13_;
	PhotoRow* _tmp14_;
	BackingPhotoRow* _tmp15_;
	PhotoRow* _tmp16_;
	ImportID _tmp17_;
	PhotoRow* _tmp18_;
	PhotoRow* _tmp19_;
	PhotoRow* _tmp20_;
	PhotoRow* _tmp21_;
	PhotoRow* _tmp22_;
	PhotoRow* _tmp23_;
	PhotoRow* _tmp24_;
	PhotoRow* _tmp25_;
	BackingPhotoRow* _tmp26_;
	PhotoRow* _tmp27_;
	PhotoRow* _tmp28_;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp29_;
	PhotoFileSnifferOptions _tmp30_;
	PhotoFileInterrogator* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1200 "../src/Photo.vala"
	g_return_if_fail (params != NULL);
#line 1201 "../src/Photo.vala"
	_tmp0_ = params->file;
#line 1201 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1201 "../src/Photo.vala"
	file = _tmp1_;
#line 1202 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 1202 "../src/Photo.vala"
	photo_id_init (&_tmp2_->photo_id, PHOTO_ID_INVALID);
#line 1203 "../src/Photo.vala"
	_tmp3_ = params->row;
#line 1203 "../src/Photo.vala"
	_tmp4_ = _tmp3_->master;
#line 1203 "../src/Photo.vala"
	_tmp5_ = g_file_get_path (file);
#line 1203 "../src/Photo.vala"
	_g_free0 (_tmp4_->filepath);
#line 1203 "../src/Photo.vala"
	_tmp4_->filepath = _tmp5_;
#line 1204 "../src/Photo.vala"
	_tmp6_ = params->row;
#line 1204 "../src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1204 "../src/Photo.vala"
	dimensions_init (&_tmp7_->dim, 0, 0);
#line 1205 "../src/Photo.vala"
	_tmp8_ = params->row;
#line 1205 "../src/Photo.vala"
	_tmp9_ = _tmp8_->master;
#line 1205 "../src/Photo.vala"
	_tmp9_->filesize = (gint64) 0;
#line 1206 "../src/Photo.vala"
	_tmp10_ = params->row;
#line 1206 "../src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1206 "../src/Photo.vala"
	_tmp11_->timestamp = (time_t) 0;
#line 1207 "../src/Photo.vala"
	_tmp12_ = params->row;
#line 1207 "../src/Photo.vala"
	_tmp12_->exposure_time = (time_t) 0;
#line 1208 "../src/Photo.vala"
	_tmp13_ = params->row;
#line 1208 "../src/Photo.vala"
	_tmp13_->orientation = ORIENTATION_TOP_LEFT;
#line 1209 "../src/Photo.vala"
	_tmp14_ = params->row;
#line 1209 "../src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 1209 "../src/Photo.vala"
	_tmp15_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1210 "../src/Photo.vala"
	_tmp16_ = params->row;
#line 1210 "../src/Photo.vala"
	_tmp17_ = params->import_id;
#line 1210 "../src/Photo.vala"
	_tmp16_->import_id = _tmp17_;
#line 1211 "../src/Photo.vala"
	_tmp18_ = params->row;
#line 1211 "../src/Photo.vala"
	event_id_init (&_tmp18_->event_id, EVENT_ID_INVALID);
#line 1212 "../src/Photo.vala"
	_tmp19_ = params->row;
#line 1212 "../src/Photo.vala"
	_g_object_unref0 (_tmp19_->transformations);
#line 1212 "../src/Photo.vala"
	_tmp19_->transformations = NULL;
#line 1213 "../src/Photo.vala"
	_tmp20_ = params->row;
#line 1213 "../src/Photo.vala"
	_g_free0 (_tmp20_->md5);
#line 1213 "../src/Photo.vala"
	_tmp20_->md5 = NULL;
#line 1214 "../src/Photo.vala"
	_tmp21_ = params->row;
#line 1214 "../src/Photo.vala"
	_g_free0 (_tmp21_->thumbnail_md5);
#line 1214 "../src/Photo.vala"
	_tmp21_->thumbnail_md5 = NULL;
#line 1215 "../src/Photo.vala"
	_tmp22_ = params->row;
#line 1215 "../src/Photo.vala"
	_g_free0 (_tmp22_->exif_md5);
#line 1215 "../src/Photo.vala"
	_tmp22_->exif_md5 = NULL;
#line 1216 "../src/Photo.vala"
	_tmp23_ = params->row;
#line 1216 "../src/Photo.vala"
	_tmp23_->time_created = (time_t) 0;
#line 1217 "../src/Photo.vala"
	_tmp24_ = params->row;
#line 1217 "../src/Photo.vala"
	_tmp24_->flags = (guint64) 0;
#line 1218 "../src/Photo.vala"
	_tmp25_ = params->row;
#line 1218 "../src/Photo.vala"
	_tmp26_ = _tmp25_->master;
#line 1218 "../src/Photo.vala"
	_tmp26_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1219 "../src/Photo.vala"
	_tmp27_ = params->row;
#line 1219 "../src/Photo.vala"
	_g_free0 (_tmp27_->title);
#line 1219 "../src/Photo.vala"
	_tmp27_->title = NULL;
#line 1220 "../src/Photo.vala"
	_tmp28_ = params->row;
#line 1220 "../src/Photo.vala"
	_g_free0 (_tmp28_->comment);
#line 1220 "../src/Photo.vala"
	_tmp28_->comment = NULL;
#line 1222 "../src/Photo.vala"
	_tmp29_ = params->file;
#line 1222 "../src/Photo.vala"
	_tmp30_ = params->sniffer_options;
#line 1222 "../src/Photo.vala"
	_tmp31_ = photo_file_interrogator_new (_tmp29_, _tmp30_);
#line 1222 "../src/Photo.vala"
	interrogator = _tmp31_;
#line 10413 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp32_;
		DetectedPhotoInformation* _tmp33_;
#line 1224 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 1224 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10422 "Photo.c"
			goto __catch133_g_error;
		}
#line 1225 "../src/Photo.vala"
		_tmp32_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1225 "../src/Photo.vala"
		detected = _tmp32_;
#line 1226 "../src/Photo.vala"
		_tmp33_ = detected;
#line 1226 "../src/Photo.vala"
		if (_tmp33_ != NULL) {
#line 10433 "Photo.c"
			PhotoRow* _tmp34_;
			BackingPhotoRow* _tmp35_;
			DetectedPhotoInformation* _tmp36_;
			PhotoFileFormat _tmp37_;
			MetadataDateTime* date_time = NULL;
			DetectedPhotoInformation* _tmp38_;
			PhotoMetadata* _tmp39_;
			MetadataDateTime* _tmp40_;
			MetadataDateTime* _tmp41_;
#line 1227 "../src/Photo.vala"
			_tmp34_ = params->row;
#line 1227 "../src/Photo.vala"
			_tmp35_ = _tmp34_->master;
#line 1227 "../src/Photo.vala"
			_tmp36_ = detected;
#line 1227 "../src/Photo.vala"
			_tmp37_ = _tmp36_->file_format;
#line 1227 "../src/Photo.vala"
			_tmp35_->file_format = _tmp37_;
#line 1228 "../src/Photo.vala"
			_tmp38_ = detected;
#line 1228 "../src/Photo.vala"
			_tmp39_ = _tmp38_->metadata;
#line 1228 "../src/Photo.vala"
			_tmp40_ = photo_metadata_get_exposure_date_time (_tmp39_);
#line 1228 "../src/Photo.vala"
			date_time = _tmp40_;
#line 1229 "../src/Photo.vala"
			_tmp41_ = date_time;
#line 1229 "../src/Photo.vala"
			if (_tmp41_ != NULL) {
#line 10465 "Photo.c"
				PhotoRow* _tmp42_;
				MetadataDateTime* _tmp43_;
#line 1230 "../src/Photo.vala"
				_tmp42_ = params->row;
#line 1230 "../src/Photo.vala"
				_tmp43_ = date_time;
#line 1230 "../src/Photo.vala"
				_tmp42_->exposure_time = metadata_date_time_get_timestamp (_tmp43_);
#line 10474 "Photo.c"
			}
#line 1226 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 10478 "Photo.c"
		}
#line 1223 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 10482 "Photo.c"
	}
	goto __finally133;
	__catch133_g_error:
	{
		GError* err = NULL;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
#line 1223 "../src/Photo.vala"
		err = _inner_error0_;
#line 1223 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1234 "../src/Photo.vala"
		_tmp44_ = g_file_get_path (file);
#line 1234 "../src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 1234 "../src/Photo.vala"
		_tmp46_ = err;
#line 1234 "../src/Photo.vala"
		_tmp47_ = _tmp46_->message;
#line 1234 "../src/Photo.vala"
		g_debug ("Photo.vala:1234: Unable to interrogate photo file %s: %s", _tmp45_, _tmp47_);
#line 1234 "../src/Photo.vala"
		_g_free0 (_tmp45_);
#line 1223 "../src/Photo.vala"
		_g_error_free0 (err);
#line 10510 "Photo.c"
	}
	__finally133:
#line 1223 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1223 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1223 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1223 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1223 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1223 "../src/Photo.vala"
		return;
#line 10525 "Photo.c"
	}
#line 1200 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1200 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 10531 "Photo.c"
}

BackingPhotoRow*
photo_query_backing_photo_row (Photo* self,
                               GFile* file,
                               PhotoFileSnifferOptions options,
                               DetectedPhotoInformation* * detected,
                               GError** error)
{
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	DetectedPhotoInformation* _tmp11_;
	DetectedPhotoInformation* _tmp12_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp15_;
	GTimeVal _tmp16_ = {0};
	BackingPhotoRow* _tmp17_;
	gchar* _tmp18_;
	BackingPhotoRow* _tmp19_;
	GTimeVal _tmp20_;
	BackingPhotoRow* _tmp21_;
	GFileInfo* _tmp22_;
	BackingPhotoRow* _tmp23_;
	DetectedPhotoInformation* _tmp24_;
	PhotoFileFormat _tmp25_;
	BackingPhotoRow* _tmp26_;
	DetectedPhotoInformation* _tmp27_;
	Dimensions _tmp28_;
	Orientation _tmp29_ = 0;
	DetectedPhotoInformation* _tmp30_;
	PhotoMetadata* _tmp31_;
	BackingPhotoRow* _tmp34_;
	GError* _inner_error0_ = NULL;
#line 1238 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1238 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1240 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1240 "../src/Photo.vala"
	_vala_detected = NULL;
#line 1242 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1242 "../src/Photo.vala"
	backing = _tmp0_;
#line 1244 "../src/Photo.vala"
	info = NULL;
#line 10586 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 1246 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1246 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 1246 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10597 "Photo.c"
			goto __catch134_g_error;
		}
#line 1246 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 1246 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 1246 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1246 "../src/Photo.vala"
		info = _tmp3_;
#line 1245 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 10610 "Photo.c"
	}
	goto __finally134;
	__catch134_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 1245 "../src/Photo.vala"
		err = _inner_error0_;
#line 1245 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1249 "../src/Photo.vala"
		_tmp4_ = g_file_get_path (file);
#line 1249 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1249 "../src/Photo.vala"
		_tmp6_ = err;
#line 1249 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 1249 "../src/Photo.vala"
		g_critical ("Photo.vala:1249: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 1249 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1251 "../src/Photo.vala"
		result = NULL;
#line 1251 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1251 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1251 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1251 "../src/Photo.vala"
		if (detected) {
#line 1251 "../src/Photo.vala"
			*detected = _vala_detected;
#line 10648 "Photo.c"
		} else {
#line 1251 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10652 "Photo.c"
		}
#line 1251 "../src/Photo.vala"
		return result;
#line 10656 "Photo.c"
	}
	__finally134:
#line 1245 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1245 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1245 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1245 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1245 "../src/Photo.vala"
		return NULL;
#line 10669 "Photo.c"
	}
#line 1255 "../src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, options);
#line 1255 "../src/Photo.vala"
	interrogator = _tmp8_;
#line 1256 "../src/Photo.vala"
	_tmp9_ = interrogator;
#line 1256 "../src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error0_);
#line 1256 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1256 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1256 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1256 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1256 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1256 "../src/Photo.vala"
		return NULL;
#line 10691 "Photo.c"
	}
#line 1257 "../src/Photo.vala"
	_tmp10_ = interrogator;
#line 1257 "../src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 1257 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1257 "../src/Photo.vala"
	_vala_detected = _tmp11_;
#line 1258 "../src/Photo.vala"
	_tmp12_ = _vala_detected;
#line 1258 "../src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 10705 "Photo.c"
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 1259 "../src/Photo.vala"
		_tmp13_ = data_object_to_string ((DataObject*) self);
#line 1259 "../src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1259 "../src/Photo.vala"
		g_critical ("Photo.vala:1259: Photo update: %s no longer a recognized image", _tmp14_);
#line 1259 "../src/Photo.vala"
		_g_free0 (_tmp14_);
#line 1261 "../src/Photo.vala"
		result = NULL;
#line 1261 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1261 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 1261 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1261 "../src/Photo.vala"
		if (detected) {
#line 1261 "../src/Photo.vala"
			*detected = _vala_detected;
#line 10728 "Photo.c"
		} else {
#line 1261 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10732 "Photo.c"
		}
#line 1261 "../src/Photo.vala"
		return result;
#line 10736 "Photo.c"
	}
#line 1264 "../src/Photo.vala"
	_tmp15_ = info;
#line 1264 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp15_, &_tmp16_);
#line 1264 "../src/Photo.vala"
	modification_time = _tmp16_;
#line 1266 "../src/Photo.vala"
	_tmp17_ = backing;
#line 1266 "../src/Photo.vala"
	_tmp18_ = g_file_get_path (file);
#line 1266 "../src/Photo.vala"
	_g_free0 (_tmp17_->filepath);
#line 1266 "../src/Photo.vala"
	_tmp17_->filepath = _tmp18_;
#line 1267 "../src/Photo.vala"
	_tmp19_ = backing;
#line 1267 "../src/Photo.vala"
	_tmp20_ = modification_time;
#line 1267 "../src/Photo.vala"
	_tmp19_->timestamp = (time_t) _tmp20_.tv_sec;
#line 1268 "../src/Photo.vala"
	_tmp21_ = backing;
#line 1268 "../src/Photo.vala"
	_tmp22_ = info;
#line 1268 "../src/Photo.vala"
	_tmp21_->filesize = g_file_info_get_size (_tmp22_);
#line 1269 "../src/Photo.vala"
	_tmp23_ = backing;
#line 1269 "../src/Photo.vala"
	_tmp24_ = _vala_detected;
#line 1269 "../src/Photo.vala"
	_tmp25_ = _tmp24_->file_format;
#line 1269 "../src/Photo.vala"
	_tmp23_->file_format = _tmp25_;
#line 1270 "../src/Photo.vala"
	_tmp26_ = backing;
#line 1270 "../src/Photo.vala"
	_tmp27_ = _vala_detected;
#line 1270 "../src/Photo.vala"
	_tmp28_ = _tmp27_->image_dim;
#line 1270 "../src/Photo.vala"
	_tmp26_->dim = _tmp28_;
#line 1271 "../src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 1271 "../src/Photo.vala"
	_tmp31_ = _tmp30_->metadata;
#line 1271 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 10786 "Photo.c"
		DetectedPhotoInformation* _tmp32_;
		PhotoMetadata* _tmp33_;
#line 1272 "../src/Photo.vala"
		_tmp32_ = _vala_detected;
#line 1272 "../src/Photo.vala"
		_tmp33_ = _tmp32_->metadata;
#line 1272 "../src/Photo.vala"
		_tmp29_ = photo_metadata_get_orientation (_tmp33_);
#line 10795 "Photo.c"
	} else {
#line 1272 "../src/Photo.vala"
		_tmp29_ = ORIENTATION_TOP_LEFT;
#line 10799 "Photo.c"
	}
#line 1271 "../src/Photo.vala"
	_tmp34_ = backing;
#line 1271 "../src/Photo.vala"
	_tmp34_->original_orientation = _tmp29_;
#line 1274 "../src/Photo.vala"
	result = backing;
#line 1274 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1274 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 1274 "../src/Photo.vala"
	if (detected) {
#line 1274 "../src/Photo.vala"
		*detected = _vala_detected;
#line 10815 "Photo.c"
	} else {
#line 1274 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 10819 "Photo.c"
	}
#line 1274 "../src/Photo.vala"
	return result;
#line 10823 "Photo.c"
}

static void
_vala_array_add10 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1370 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1370 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1370 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10838 "Photo.c"
	}
#line 1370 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1370 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 10844 "Photo.c"
}

static void
_vala_array_add11 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1374 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1374 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1374 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10859 "Photo.c"
	}
#line 1374 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1374 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 10865 "Photo.c"
}

static void
_vala_array_add12 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1381 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1381 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1381 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10880 "Photo.c"
	}
#line 1381 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1381 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 10886 "Photo.c"
}

static void
_vala_array_add13 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1385 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1385 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1385 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10901 "Photo.c"
	}
#line 1385 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1385 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 10907 "Photo.c"
}

static void
_vala_array_add14 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1389 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1389 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1389 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10922 "Photo.c"
	}
#line 1389 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1389 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 10928 "Photo.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 1400 "../src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 10936 "Photo.c"
}

gboolean
photo_prepare_for_reimport_master (Photo* self,
                                   PhotoReimportMasterState* * reimport_state,
                                   GError** error)
{
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_;
	BackingPhotoRow* _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	GdkColorspace _tmp15_;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp21_;
	gchar** list = NULL;
	gchar** _tmp27_;
	gint list_length1;
	gint _list_size_;
	PhotoRow* _tmp28_;
	const gchar* _tmp29_;
	DetectedPhotoInformation* _tmp30_;
	const gchar* _tmp31_;
	PhotoRow* _tmp34_;
	BackingPhotoRow* _tmp35_;
	Orientation _tmp36_;
	BackingPhotoRow* _tmp37_;
	Orientation _tmp38_;
	DetectedPhotoInformation* _tmp45_;
	PhotoMetadata* _tmp46_;
	PhotoRow* _tmp74_;
	BackingPhotoRow* _tmp75_;
	BackingPhotoRow* _tmp76_;
	PhotoRow* _tmp77_;
	DetectedPhotoInformation* _tmp78_;
	const gchar* _tmp79_;
	gchar* _tmp80_;
	PhotoRow* _tmp81_;
	DetectedPhotoInformation* _tmp82_;
	const gchar* _tmp83_;
	gchar* _tmp84_;
	PhotoRow* _tmp85_;
	DetectedPhotoInformation* _tmp86_;
	const gchar* _tmp87_;
	gchar* _tmp88_;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp89_;
	PhotoMetadata* _tmp90_;
	PhotoRow* _tmp112_;
	PhotoMetadata* _tmp113_;
	gchar** _tmp114_;
	gint _tmp114__length1;
	PhotoReimportMasterStateImpl* _tmp115_;
	GError* _inner_error0_ = NULL;
#line 1338 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1339 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1339 "../src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1341 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1341 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1341 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1341 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1341 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1341 "../src/Photo.vala"
	file = _tmp3_;
#line 1344 "../src/Photo.vala"
	_tmp4_ = file;
#line 1344 "../src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error0_);
#line 1344 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1344 "../src/Photo.vala"
	detected = _tmp5_;
#line 1344 "../src/Photo.vala"
	backing = _tmp6_;
#line 1344 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11032 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1344 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1344 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1344 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1344 "../src/Photo.vala"
		return _tmp7_;
#line 11042 "Photo.c"
	}
#line 1346 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1346 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 11048 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1347 "../src/Photo.vala"
		_tmp9_ = file;
#line 1347 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1347 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1347 "../src/Photo.vala"
		g_warning ("Photo.vala:1347: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1347 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1348 "../src/Photo.vala"
		result = FALSE;
#line 1348 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1348 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1348 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1348 "../src/Photo.vala"
		if (reimport_state) {
#line 1348 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11074 "Photo.c"
		} else {
#line 1348 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11078 "Photo.c"
		}
#line 1348 "../src/Photo.vala"
		return result;
#line 11082 "Photo.c"
	}
#line 1352 "../src/Photo.vala"
	_tmp14_ = detected;
#line 1352 "../src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 1352 "../src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 1352 "../src/Photo.vala"
		_tmp13_ = TRUE;
#line 11092 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
#line 1353 "../src/Photo.vala"
		_tmp16_ = detected;
#line 1353 "../src/Photo.vala"
		_tmp13_ = _tmp16_->channels < 3;
#line 11099 "Photo.c"
	}
#line 1352 "../src/Photo.vala"
	if (_tmp13_) {
#line 1352 "../src/Photo.vala"
		_tmp12_ = TRUE;
#line 11105 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp17_;
#line 1354 "../src/Photo.vala"
		_tmp17_ = detected;
#line 1354 "../src/Photo.vala"
		_tmp12_ = _tmp17_->bits_per_channel != 8;
#line 11112 "Photo.c"
	}
#line 1352 "../src/Photo.vala"
	if (_tmp12_) {
#line 11116 "Photo.c"
		GFile* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 1355 "../src/Photo.vala"
		_tmp18_ = file;
#line 1355 "../src/Photo.vala"
		_tmp19_ = g_file_get_path (_tmp18_);
#line 1355 "../src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 1355 "../src/Photo.vala"
		g_warning ("Photo.vala:1355: Not re-importing %s: Unsupported color format", _tmp20_);
#line 1355 "../src/Photo.vala"
		_g_free0 (_tmp20_);
#line 1357 "../src/Photo.vala"
		result = FALSE;
#line 1357 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1357 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1357 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1357 "../src/Photo.vala"
		if (reimport_state) {
#line 1357 "../src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 11142 "Photo.c"
		} else {
#line 1357 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11146 "Photo.c"
		}
#line 1357 "../src/Photo.vala"
		return result;
#line 11150 "Photo.c"
	}
#line 1361 "../src/Photo.vala"
	_tmp21_ = photo_row_new ();
#line 1361 "../src/Photo.vala"
	updated_row = _tmp21_;
#line 11156 "Photo.c"
	{
		PhotoRow* _tmp22_;
#line 1362 "../src/Photo.vala"
		_tmp22_ = self->row;
#line 1362 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11163 "Photo.c"
		{
			PhotoRow* _tmp23_;
			PhotoRow* _tmp24_;
#line 1363 "../src/Photo.vala"
			_tmp23_ = self->row;
#line 1363 "../src/Photo.vala"
			_tmp24_ = _photo_row_ref0 (_tmp23_);
#line 1363 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1363 "../src/Photo.vala"
			updated_row = _tmp24_;
#line 11175 "Photo.c"
		}
		__finally135:
		{
			PhotoRow* _tmp25_;
#line 1362 "../src/Photo.vala"
			_tmp25_ = self->row;
#line 1362 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11184 "Photo.c"
		}
#line 1362 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11188 "Photo.c"
			gboolean _tmp26_ = FALSE;
#line 1362 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1362 "../src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1362 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1362 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1362 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 1362 "../src/Photo.vala"
			return _tmp26_;
#line 11202 "Photo.c"
		}
	}
#line 1367 "../src/Photo.vala"
	_tmp27_ = g_new0 (gchar*, 0 + 1);
#line 1367 "../src/Photo.vala"
	list = _tmp27_;
#line 1367 "../src/Photo.vala"
	list_length1 = 0;
#line 1367 "../src/Photo.vala"
	_list_size_ = list_length1;
#line 1369 "../src/Photo.vala"
	_tmp28_ = updated_row;
#line 1369 "../src/Photo.vala"
	_tmp29_ = _tmp28_->md5;
#line 1369 "../src/Photo.vala"
	_tmp30_ = detected;
#line 1369 "../src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1369 "../src/Photo.vala"
	if (g_strcmp0 (_tmp29_, _tmp31_) != 0) {
#line 11223 "Photo.c"
		gchar** _tmp32_;
		gint _tmp32__length1;
		gchar* _tmp33_;
#line 1370 "../src/Photo.vala"
		_tmp32_ = list;
#line 1370 "../src/Photo.vala"
		_tmp32__length1 = list_length1;
#line 1370 "../src/Photo.vala"
		_tmp33_ = g_strdup ("metadata:md5");
#line 1370 "../src/Photo.vala"
		_vala_array_add10 (&list, &list_length1, &_list_size_, _tmp33_);
#line 11235 "Photo.c"
	}
#line 1373 "../src/Photo.vala"
	_tmp34_ = updated_row;
#line 1373 "../src/Photo.vala"
	_tmp35_ = _tmp34_->master;
#line 1373 "../src/Photo.vala"
	_tmp36_ = _tmp35_->original_orientation;
#line 1373 "../src/Photo.vala"
	_tmp37_ = backing;
#line 1373 "../src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1373 "../src/Photo.vala"
	if (_tmp36_ != _tmp38_) {
#line 11249 "Photo.c"
		gchar** _tmp39_;
		gint _tmp39__length1;
		gchar* _tmp40_;
		PhotoRow* _tmp41_;
		BackingPhotoRow* _tmp42_;
		BackingPhotoRow* _tmp43_;
		Orientation _tmp44_;
#line 1374 "../src/Photo.vala"
		_tmp39_ = list;
#line 1374 "../src/Photo.vala"
		_tmp39__length1 = list_length1;
#line 1374 "../src/Photo.vala"
		_tmp40_ = g_strdup ("image:orientation");
#line 1374 "../src/Photo.vala"
		_vala_array_add11 (&list, &list_length1, &_list_size_, _tmp40_);
#line 1375 "../src/Photo.vala"
		_tmp41_ = updated_row;
#line 1375 "../src/Photo.vala"
		_tmp42_ = _tmp41_->master;
#line 1375 "../src/Photo.vala"
		_tmp43_ = backing;
#line 1375 "../src/Photo.vala"
		_tmp44_ = _tmp43_->original_orientation;
#line 1375 "../src/Photo.vala"
		_tmp42_->original_orientation = _tmp44_;
#line 11275 "Photo.c"
	}
#line 1378 "../src/Photo.vala"
	_tmp45_ = detected;
#line 1378 "../src/Photo.vala"
	_tmp46_ = _tmp45_->metadata;
#line 1378 "../src/Photo.vala"
	if (_tmp46_ != NULL) {
#line 11283 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp47_;
		PhotoMetadata* _tmp48_;
		MetadataDateTime* _tmp49_;
		gboolean _tmp50_ = FALSE;
		MetadataDateTime* _tmp51_;
		PhotoRow* _tmp56_;
		const gchar* _tmp57_;
		DetectedPhotoInformation* _tmp58_;
		PhotoMetadata* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gboolean _tmp62_;
		PhotoRow* _tmp65_;
		const gchar* _tmp66_;
		DetectedPhotoInformation* _tmp67_;
		PhotoMetadata* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gboolean _tmp71_;
#line 1379 "../src/Photo.vala"
		_tmp47_ = detected;
#line 1379 "../src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1379 "../src/Photo.vala"
		_tmp49_ = photo_metadata_get_exposure_date_time (_tmp48_);
#line 1379 "../src/Photo.vala"
		date_time = _tmp49_;
#line 1380 "../src/Photo.vala"
		_tmp51_ = date_time;
#line 1380 "../src/Photo.vala"
		if (_tmp51_ != NULL) {
#line 11316 "Photo.c"
			PhotoRow* _tmp52_;
			MetadataDateTime* _tmp53_;
#line 1380 "../src/Photo.vala"
			_tmp52_ = updated_row;
#line 1380 "../src/Photo.vala"
			_tmp53_ = date_time;
#line 1380 "../src/Photo.vala"
			_tmp50_ = _tmp52_->exposure_time != metadata_date_time_get_timestamp (_tmp53_);
#line 11325 "Photo.c"
		} else {
#line 1380 "../src/Photo.vala"
			_tmp50_ = FALSE;
#line 11329 "Photo.c"
		}
#line 1380 "../src/Photo.vala"
		if (_tmp50_) {
#line 11333 "Photo.c"
			gchar** _tmp54_;
			gint _tmp54__length1;
			gchar* _tmp55_;
#line 1381 "../src/Photo.vala"
			_tmp54_ = list;
#line 1381 "../src/Photo.vala"
			_tmp54__length1 = list_length1;
#line 1381 "../src/Photo.vala"
			_tmp55_ = g_strdup ("metadata:exposure-time");
#line 1381 "../src/Photo.vala"
			_vala_array_add12 (&list, &list_length1, &_list_size_, _tmp55_);
#line 11345 "Photo.c"
		}
#line 1384 "../src/Photo.vala"
		_tmp56_ = updated_row;
#line 1384 "../src/Photo.vala"
		_tmp57_ = _tmp56_->title;
#line 1384 "../src/Photo.vala"
		_tmp58_ = detected;
#line 1384 "../src/Photo.vala"
		_tmp59_ = _tmp58_->metadata;
#line 1384 "../src/Photo.vala"
		_tmp60_ = media_metadata_get_title ((MediaMetadata*) _tmp59_);
#line 1384 "../src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 1384 "../src/Photo.vala"
		_tmp62_ = g_strcmp0 (_tmp57_, _tmp61_) != 0;
#line 1384 "../src/Photo.vala"
		_g_free0 (_tmp61_);
#line 1384 "../src/Photo.vala"
		if (_tmp62_) {
#line 11365 "Photo.c"
			gchar** _tmp63_;
			gint _tmp63__length1;
			gchar* _tmp64_;
#line 1385 "../src/Photo.vala"
			_tmp63_ = list;
#line 1385 "../src/Photo.vala"
			_tmp63__length1 = list_length1;
#line 1385 "../src/Photo.vala"
			_tmp64_ = g_strdup ("metadata:name");
#line 1385 "../src/Photo.vala"
			_vala_array_add13 (&list, &list_length1, &_list_size_, _tmp64_);
#line 11377 "Photo.c"
		}
#line 1388 "../src/Photo.vala"
		_tmp65_ = updated_row;
#line 1388 "../src/Photo.vala"
		_tmp66_ = _tmp65_->comment;
#line 1388 "../src/Photo.vala"
		_tmp67_ = detected;
#line 1388 "../src/Photo.vala"
		_tmp68_ = _tmp67_->metadata;
#line 1388 "../src/Photo.vala"
		_tmp69_ = media_metadata_get_comment ((MediaMetadata*) _tmp68_);
#line 1388 "../src/Photo.vala"
		_tmp70_ = _tmp69_;
#line 1388 "../src/Photo.vala"
		_tmp71_ = g_strcmp0 (_tmp66_, _tmp70_) != 0;
#line 1388 "../src/Photo.vala"
		_g_free0 (_tmp70_);
#line 1388 "../src/Photo.vala"
		if (_tmp71_) {
#line 11397 "Photo.c"
			gchar** _tmp72_;
			gint _tmp72__length1;
			gchar* _tmp73_;
#line 1389 "../src/Photo.vala"
			_tmp72_ = list;
#line 1389 "../src/Photo.vala"
			_tmp72__length1 = list_length1;
#line 1389 "../src/Photo.vala"
			_tmp73_ = g_strdup ("metadata:comment");
#line 1389 "../src/Photo.vala"
			_vala_array_add14 (&list, &list_length1, &_list_size_, _tmp73_);
#line 11409 "Photo.c"
		}
#line 1378 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11413 "Photo.c"
	}
#line 1393 "../src/Photo.vala"
	_tmp74_ = updated_row;
#line 1393 "../src/Photo.vala"
	_tmp75_ = backing;
#line 1393 "../src/Photo.vala"
	_tmp76_ = _backing_photo_row_ref0 (_tmp75_);
#line 1393 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp74_->master);
#line 1393 "../src/Photo.vala"
	_tmp74_->master = _tmp76_;
#line 1394 "../src/Photo.vala"
	_tmp77_ = updated_row;
#line 1394 "../src/Photo.vala"
	_tmp78_ = detected;
#line 1394 "../src/Photo.vala"
	_tmp79_ = _tmp78_->md5;
#line 1394 "../src/Photo.vala"
	_tmp80_ = g_strdup (_tmp79_);
#line 1394 "../src/Photo.vala"
	_g_free0 (_tmp77_->md5);
#line 1394 "../src/Photo.vala"
	_tmp77_->md5 = _tmp80_;
#line 1395 "../src/Photo.vala"
	_tmp81_ = updated_row;
#line 1395 "../src/Photo.vala"
	_tmp82_ = detected;
#line 1395 "../src/Photo.vala"
	_tmp83_ = _tmp82_->exif_md5;
#line 1395 "../src/Photo.vala"
	_tmp84_ = g_strdup (_tmp83_);
#line 1395 "../src/Photo.vala"
	_g_free0 (_tmp81_->exif_md5);
#line 1395 "../src/Photo.vala"
	_tmp81_->exif_md5 = _tmp84_;
#line 1396 "../src/Photo.vala"
	_tmp85_ = updated_row;
#line 1396 "../src/Photo.vala"
	_tmp86_ = detected;
#line 1396 "../src/Photo.vala"
	_tmp87_ = _tmp86_->thumbnail_md5;
#line 1396 "../src/Photo.vala"
	_tmp88_ = g_strdup (_tmp87_);
#line 1396 "../src/Photo.vala"
	_g_free0 (_tmp85_->thumbnail_md5);
#line 1396 "../src/Photo.vala"
	_tmp85_->thumbnail_md5 = _tmp88_;
#line 1398 "../src/Photo.vala"
	metadata = NULL;
#line 1399 "../src/Photo.vala"
	_tmp89_ = detected;
#line 1399 "../src/Photo.vala"
	_tmp90_ = _tmp89_->metadata;
#line 1399 "../src/Photo.vala"
	if (_tmp90_ != NULL) {
#line 11469 "Photo.c"
		DetectedPhotoInformation* _tmp91_;
		PhotoMetadata* _tmp92_;
		PhotoMetadata* _tmp93_;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp94_;
		PhotoMetadata* _tmp95_;
		MetadataDateTime* _tmp96_;
		MetadataDateTime* _tmp97_;
		PhotoRow* _tmp100_;
		DetectedPhotoInformation* _tmp101_;
		PhotoMetadata* _tmp102_;
		gchar* _tmp103_;
		PhotoRow* _tmp104_;
		DetectedPhotoInformation* _tmp105_;
		PhotoMetadata* _tmp106_;
		gchar* _tmp107_;
		PhotoRow* _tmp108_;
		DetectedPhotoInformation* _tmp109_;
		PhotoMetadata* _tmp110_;
		gchar* _tmp111_;
#line 1400 "../src/Photo.vala"
		_tmp91_ = detected;
#line 1400 "../src/Photo.vala"
		_tmp92_ = _tmp91_->metadata;
#line 1400 "../src/Photo.vala"
		_tmp93_ = _media_metadata_ref0 (_tmp92_);
#line 1400 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1400 "../src/Photo.vala"
		metadata = _tmp93_;
#line 1402 "../src/Photo.vala"
		_tmp94_ = detected;
#line 1402 "../src/Photo.vala"
		_tmp95_ = _tmp94_->metadata;
#line 1402 "../src/Photo.vala"
		_tmp96_ = photo_metadata_get_exposure_date_time (_tmp95_);
#line 1402 "../src/Photo.vala"
		date_time = _tmp96_;
#line 1403 "../src/Photo.vala"
		_tmp97_ = date_time;
#line 1403 "../src/Photo.vala"
		if (_tmp97_ != NULL) {
#line 11512 "Photo.c"
			PhotoRow* _tmp98_;
			MetadataDateTime* _tmp99_;
#line 1404 "../src/Photo.vala"
			_tmp98_ = updated_row;
#line 1404 "../src/Photo.vala"
			_tmp99_ = date_time;
#line 1404 "../src/Photo.vala"
			_tmp98_->exposure_time = metadata_date_time_get_timestamp (_tmp99_);
#line 11521 "Photo.c"
		}
#line 1407 "../src/Photo.vala"
		_tmp100_ = updated_row;
#line 1407 "../src/Photo.vala"
		_tmp101_ = detected;
#line 1407 "../src/Photo.vala"
		_tmp102_ = _tmp101_->metadata;
#line 1407 "../src/Photo.vala"
		_tmp103_ = media_metadata_get_title ((MediaMetadata*) _tmp102_);
#line 1407 "../src/Photo.vala"
		_g_free0 (_tmp100_->title);
#line 1407 "../src/Photo.vala"
		_tmp100_->title = _tmp103_;
#line 1408 "../src/Photo.vala"
		_tmp104_ = updated_row;
#line 1408 "../src/Photo.vala"
		_tmp105_ = detected;
#line 1408 "../src/Photo.vala"
		_tmp106_ = _tmp105_->metadata;
#line 1408 "../src/Photo.vala"
		_tmp107_ = media_metadata_get_comment ((MediaMetadata*) _tmp106_);
#line 1408 "../src/Photo.vala"
		_g_free0 (_tmp104_->comment);
#line 1408 "../src/Photo.vala"
		_tmp104_->comment = _tmp107_;
#line 1409 "../src/Photo.vala"
		_tmp108_ = updated_row;
#line 1409 "../src/Photo.vala"
		_tmp109_ = detected;
#line 1409 "../src/Photo.vala"
		_tmp110_ = _tmp109_->metadata;
#line 1409 "../src/Photo.vala"
		_tmp111_ = media_metadata_get_comment ((MediaMetadata*) _tmp110_);
#line 1409 "../src/Photo.vala"
		_g_free0 (_tmp108_->comment);
#line 1409 "../src/Photo.vala"
		_tmp108_->comment = _tmp111_;
#line 1399 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 11561 "Photo.c"
	}
#line 1412 "../src/Photo.vala"
	_tmp112_ = updated_row;
#line 1412 "../src/Photo.vala"
	_tmp113_ = metadata;
#line 1412 "../src/Photo.vala"
	_tmp114_ = list;
#line 1412 "../src/Photo.vala"
	_tmp114__length1 = list_length1;
#line 1412 "../src/Photo.vala"
	_tmp115_ = photo_reimport_master_state_impl_new (_tmp112_, _tmp113_, _tmp114_, _tmp114__length1);
#line 1412 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1412 "../src/Photo.vala"
	_vala_reimport_state = (PhotoReimportMasterState*) _tmp115_;
#line 1414 "../src/Photo.vala"
	result = TRUE;
#line 1414 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1414 "../src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1414 "../src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1414 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1414 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1414 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1414 "../src/Photo.vala"
	if (reimport_state) {
#line 1414 "../src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 11595 "Photo.c"
	} else {
#line 1414 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11599 "Photo.c"
	}
#line 1414 "../src/Photo.vala"
	return result;
#line 11603 "Photo.c"
}

static void
photo_real_apply_user_metadata_for_reimport (Photo* self,
                                             PhotoMetadata* metadata)
{
#line 1417 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1417 "../src/Photo.vala"
	return;
#line 11614 "Photo.c"
}

void
photo_apply_user_metadata_for_reimport (Photo* self,
                                        PhotoMetadata* metadata)
{
#line 1417 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1417 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 11625 "Photo.c"
}

static gpointer
_photo_reimport_master_state_ref0 (gpointer self)
{
#line 1421 "../src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 11633 "Photo.c"
}

static void
_vala_array_add15 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1441 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1441 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1441 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11648 "Photo.c"
	}
#line 1441 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1441 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11654 "Photo.c"
}

static void
_vala_array_add16 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1443 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1443 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1443 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11669 "Photo.c"
	}
#line 1443 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1443 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 11675 "Photo.c"
}

void
photo_finish_reimport_master (Photo* self,
                              PhotoReimportMasterState* state,
                              GError** error)
{
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterStateImpl* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	PhotoRow* _tmp3_;
	PhotoMetadata* _tmp18_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	PhotoMetadata* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 1420 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1420 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1421 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1421 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 1423 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 1423 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1423 "../src/Photo.vala"
	_tmp3_ = reimport_state->row;
#line 1423 "../src/Photo.vala"
	photo_table_reimport (_tmp2_, _tmp3_, &_inner_error0_);
#line 1423 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 1423 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1423 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1423 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1423 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1423 "../src/Photo.vala"
			return;
#line 11721 "Photo.c"
		} else {
#line 1423 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1423 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1423 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1423 "../src/Photo.vala"
			return;
#line 11731 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp4_;
#line 1425 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 1425 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11740 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp5_;
			BackingPhotoRow* _tmp6_;
			BackingPhotoRow* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoRow* _tmp9_;
			PhotoRow* _tmp10_;
			BackingPhotoRow* _tmp11_;
			BackingPhotoRow* _tmp12_;
			PhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			PhotoRow* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 1427 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1427 "../src/Photo.vala"
			_tmp6_ = _tmp5_->master;
#line 1427 "../src/Photo.vala"
			_tmp7_ = _backing_photo_row_ref0 (_tmp6_);
#line 1427 "../src/Photo.vala"
			original_master = _tmp7_;
#line 1428 "../src/Photo.vala"
			_tmp8_ = reimport_state->row;
#line 1428 "../src/Photo.vala"
			_tmp9_ = _photo_row_ref0 (_tmp8_);
#line 1428 "../src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1428 "../src/Photo.vala"
			self->row = _tmp9_;
#line 1429 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 1429 "../src/Photo.vala"
			_tmp11_ = original_master;
#line 1429 "../src/Photo.vala"
			_tmp12_ = _backing_photo_row_ref0 (_tmp11_);
#line 1429 "../src/Photo.vala"
			_backing_photo_row_unref0 (_tmp10_->master);
#line 1429 "../src/Photo.vala"
			_tmp10_->master = _tmp12_;
#line 1430 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1430 "../src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 1430 "../src/Photo.vala"
			_tmp15_ = reimport_state->row;
#line 1430 "../src/Photo.vala"
			_tmp16_ = _tmp15_->master;
#line 1430 "../src/Photo.vala"
			backing_photo_row_copy_from (_tmp14_, _tmp16_);
#line 1431 "../src/Photo.vala"
			if (!reimport_state->metadata_only) {
#line 1432 "../src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11795 "Photo.c"
			}
#line 1425 "../src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 11799 "Photo.c"
		}
		__finally136:
		{
			PhotoRow* _tmp17_;
#line 1425 "../src/Photo.vala"
			_tmp17_ = self->row;
#line 1425 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11808 "Photo.c"
		}
#line 1425 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1425 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1425 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1425 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1425 "../src/Photo.vala"
				return;
#line 11820 "Photo.c"
			} else {
#line 1425 "../src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1425 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1425 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1425 "../src/Photo.vala"
				return;
#line 11830 "Photo.c"
			}
		}
	}
#line 1436 "../src/Photo.vala"
	_tmp18_ = reimport_state->metadata;
#line 1436 "../src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 11838 "Photo.c"
		PhotoMetadata* _tmp19_;
#line 1437 "../src/Photo.vala"
		_tmp19_ = reimport_state->metadata;
#line 1437 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp19_);
#line 11844 "Photo.c"
	}
#line 1440 "../src/Photo.vala"
	if (!reimport_state->metadata_only) {
#line 11848 "Photo.c"
		gchar** _tmp20_;
		gint _tmp20__length1;
		gchar* _tmp21_;
#line 1441 "../src/Photo.vala"
		_tmp20_ = reimport_state->alterations;
#line 1441 "../src/Photo.vala"
		_tmp20__length1 = reimport_state->alterations_length1;
#line 1441 "../src/Photo.vala"
		_tmp21_ = g_strdup ("image:master");
#line 1441 "../src/Photo.vala"
		_vala_array_add15 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp21_);
#line 1442 "../src/Photo.vala"
		if (photo_is_master_baseline (self)) {
#line 11862 "Photo.c"
			gchar** _tmp22_;
			gint _tmp22__length1;
			gchar* _tmp23_;
#line 1443 "../src/Photo.vala"
			_tmp22_ = reimport_state->alterations;
#line 1443 "../src/Photo.vala"
			_tmp22__length1 = reimport_state->alterations_length1;
#line 1443 "../src/Photo.vala"
			_tmp23_ = g_strdup ("image:baseline");
#line 1443 "../src/Photo.vala"
			_vala_array_add16 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp23_);
#line 11874 "Photo.c"
		}
	}
#line 1447 "../src/Photo.vala"
	_tmp24_ = reimport_state->alterations;
#line 1447 "../src/Photo.vala"
	_tmp24__length1 = reimport_state->alterations_length1;
#line 1447 "../src/Photo.vala"
	if (_tmp24__length1 > 0) {
#line 11883 "Photo.c"
		gchar** _tmp25_;
		gint _tmp25__length1;
		Alteration* _tmp26_;
		Alteration* _tmp27_;
#line 1448 "../src/Photo.vala"
		_tmp25_ = reimport_state->alterations;
#line 1448 "../src/Photo.vala"
		_tmp25__length1 = reimport_state->alterations_length1;
#line 1448 "../src/Photo.vala"
		_tmp26_ = alteration_new_from_array (_tmp25_, _tmp25__length1);
#line 1448 "../src/Photo.vala"
		_tmp27_ = _tmp26_;
#line 1448 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp27_);
#line 1448 "../src/Photo.vala"
		_alteration_unref0 (_tmp27_);
#line 11900 "Photo.c"
	}
#line 1451 "../src/Photo.vala"
	_tmp28_ = reimport_state->metadata;
#line 1451 "../src/Photo.vala"
	photo_notify_master_reimported (self, _tmp28_);
#line 1453 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 11908 "Photo.c"
		PhotoMetadata* _tmp29_;
#line 1454 "../src/Photo.vala"
		_tmp29_ = reimport_state->metadata;
#line 1454 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp29_);
#line 11914 "Photo.c"
	}
#line 1457 "../src/Photo.vala"
	if (photo_is_master_source (self)) {
#line 11918 "Photo.c"
		PhotoMetadata* _tmp30_;
#line 1458 "../src/Photo.vala"
		_tmp30_ = reimport_state->metadata;
#line 1458 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp30_);
#line 11924 "Photo.c"
	}
#line 1420 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 11928 "Photo.c"
}

static gboolean
photo_verify_file_for_reimport (Photo* self,
                                GFile* file,
                                BackingPhotoRow* * backing,
                                DetectedPhotoInformation* * detected,
                                GError** error)
{
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	DetectedPhotoInformation* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_;
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	DetectedPhotoInformation* _tmp8_;
	GdkColorspace _tmp9_;
	GError* _inner_error0_ = NULL;
#line 1463 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1463 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1465 "../src/Photo.vala"
	_tmp2_ = photo_query_backing_photo_row (self, file, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp1_, &_inner_error0_);
#line 1465 "../src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1465 "../src/Photo.vala"
	_vala_detected = _tmp1_;
#line 1465 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1465 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11965 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 1465 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1465 "../src/Photo.vala"
		return _tmp3_;
#line 11971 "Photo.c"
	}
#line 1465 "../src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1465 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1465 "../src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1465 "../src/Photo.vala"
	_vala_backing = _tmp4_;
#line 1467 "../src/Photo.vala"
	_tmp5_ = _vala_backing;
#line 1467 "../src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 1468 "../src/Photo.vala"
		result = FALSE;
#line 1468 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1468 "../src/Photo.vala"
		if (backing) {
#line 1468 "../src/Photo.vala"
			*backing = _vala_backing;
#line 11993 "Photo.c"
		} else {
#line 1468 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11997 "Photo.c"
		}
#line 1468 "../src/Photo.vala"
		if (detected) {
#line 1468 "../src/Photo.vala"
			*detected = _vala_detected;
#line 12003 "Photo.c"
		} else {
#line 1468 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12007 "Photo.c"
		}
#line 1468 "../src/Photo.vala"
		return result;
#line 12011 "Photo.c"
	}
#line 1472 "../src/Photo.vala"
	_tmp8_ = _vala_detected;
#line 1472 "../src/Photo.vala"
	_tmp9_ = _tmp8_->colorspace;
#line 1472 "../src/Photo.vala"
	if (_tmp9_ != GDK_COLORSPACE_RGB) {
#line 1472 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 12021 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp10_;
#line 1473 "../src/Photo.vala"
		_tmp10_ = _vala_detected;
#line 1473 "../src/Photo.vala"
		_tmp7_ = _tmp10_->channels < 3;
#line 12028 "Photo.c"
	}
#line 1472 "../src/Photo.vala"
	if (_tmp7_) {
#line 1472 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 12034 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp11_;
#line 1474 "../src/Photo.vala"
		_tmp11_ = _vala_detected;
#line 1474 "../src/Photo.vala"
		_tmp6_ = _tmp11_->bits_per_channel != 8;
#line 12041 "Photo.c"
	}
#line 1472 "../src/Photo.vala"
	if (_tmp6_) {
#line 12045 "Photo.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 1475 "../src/Photo.vala"
		_tmp12_ = g_file_get_path (file);
#line 1475 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 1475 "../src/Photo.vala"
		g_warning ("Photo.vala:1475: Not re-importing %s: Unsupported color format", _tmp13_);
#line 1475 "../src/Photo.vala"
		_g_free0 (_tmp13_);
#line 1477 "../src/Photo.vala"
		result = FALSE;
#line 1477 "../src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1477 "../src/Photo.vala"
		if (backing) {
#line 1477 "../src/Photo.vala"
			*backing = _vala_backing;
#line 12064 "Photo.c"
		} else {
#line 1477 "../src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 12068 "Photo.c"
		}
#line 1477 "../src/Photo.vala"
		if (detected) {
#line 1477 "../src/Photo.vala"
			*detected = _vala_detected;
#line 12074 "Photo.c"
		} else {
#line 1477 "../src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 12078 "Photo.c"
		}
#line 1477 "../src/Photo.vala"
		return result;
#line 12082 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	result = TRUE;
#line 1480 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1480 "../src/Photo.vala"
	if (backing) {
#line 1480 "../src/Photo.vala"
		*backing = _vala_backing;
#line 12092 "Photo.c"
	} else {
#line 1480 "../src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 12096 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	if (detected) {
#line 1480 "../src/Photo.vala"
		*detected = _vala_detected;
#line 12102 "Photo.c"
	} else {
#line 1480 "../src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 12106 "Photo.c"
	}
#line 1480 "../src/Photo.vala"
	return result;
#line 12110 "Photo.c"
}

gboolean
photo_prepare_for_reimport_editable (Photo* self,
                                     PhotoReimportEditableState* * state,
                                     GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_;
	BackingPhotoRow* _tmp8_;
	DetectedPhotoInformation* _tmp9_;
	PhotoMetadata* _tmp10_;
	PhotoReimportEditableStateImpl* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1484 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1485 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1485 "../src/Photo.vala"
	_vala_state = NULL;
#line 1487 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1487 "../src/Photo.vala"
	file = _tmp0_;
#line 1488 "../src/Photo.vala"
	_tmp1_ = file;
#line 1488 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1489 "../src/Photo.vala"
		result = FALSE;
#line 1489 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1489 "../src/Photo.vala"
		if (state) {
#line 1489 "../src/Photo.vala"
			*state = _vala_state;
#line 12157 "Photo.c"
		} else {
#line 1489 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 12161 "Photo.c"
		}
#line 1489 "../src/Photo.vala"
		return result;
#line 12165 "Photo.c"
	}
#line 1494 "../src/Photo.vala"
	_tmp3_ = file;
#line 1494 "../src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1494 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1494 "../src/Photo.vala"
	backing = _tmp4_;
#line 1494 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1494 "../src/Photo.vala"
	detected = _tmp5_;
#line 1494 "../src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1494 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12183 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1494 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1494 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1494 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1494 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1494 "../src/Photo.vala"
		return _tmp7_;
#line 12195 "Photo.c"
	}
#line 1494 "../src/Photo.vala"
	if (!_tmp2_) {
#line 1495 "../src/Photo.vala"
		result = FALSE;
#line 1495 "../src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1495 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1495 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1495 "../src/Photo.vala"
		if (state) {
#line 1495 "../src/Photo.vala"
			*state = _vala_state;
#line 12211 "Photo.c"
		} else {
#line 1495 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 12215 "Photo.c"
		}
#line 1495 "../src/Photo.vala"
		return result;
#line 12219 "Photo.c"
	}
#line 1498 "../src/Photo.vala"
	_tmp8_ = backing;
#line 1498 "../src/Photo.vala"
	_tmp9_ = detected;
#line 1498 "../src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1498 "../src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1498 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1498 "../src/Photo.vala"
	_vala_state = (PhotoReimportEditableState*) _tmp11_;
#line 1500 "../src/Photo.vala"
	result = TRUE;
#line 1500 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1500 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1500 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1500 "../src/Photo.vala"
	if (state) {
#line 1500 "../src/Photo.vala"
		*state = _vala_state;
#line 12245 "Photo.c"
	} else {
#line 1500 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 12249 "Photo.c"
	}
#line 1500 "../src/Photo.vala"
	return result;
#line 12253 "Photo.c"
}

static gpointer
_photo_reimport_editable_state_ref0 (gpointer self)
{
#line 1510 "../src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 12261 "Photo.c"
}

void
photo_finish_reimport_editable (Photo* self,
                                PhotoReimportEditableState* state,
                                GError** error)
{
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableStateImpl* _tmp1_;
	PhotoReimportEditableStateImpl* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp18_;
	PhotoMetadata* _tmp19_;
	gchar* list = NULL;
	gchar* _tmp30_;
	PhotoReimportEditableStateImpl* _tmp31_;
	const gchar* _tmp34_;
	Alteration* _tmp35_;
	Alteration* _tmp36_;
	PhotoReimportEditableStateImpl* _tmp37_;
	PhotoMetadata* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 1504 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1504 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1505 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1505 "../src/Photo.vala"
	editable_id = _tmp0_;
#line 1506 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 1507 "../src/Photo.vala"
		return;
#line 12297 "Photo.c"
	}
#line 1510 "../src/Photo.vala"
	_tmp1_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1510 "../src/Photo.vala"
	reimport_state = _tmp1_;
#line 1512 "../src/Photo.vala"
	_tmp2_ = reimport_state;
#line 1512 "../src/Photo.vala"
	if (!_tmp2_->metadata_only) {
#line 12307 "Photo.c"
		BackingPhotoTable* _tmp3_;
		BackingPhotoTable* _tmp4_;
		PhotoReimportEditableStateImpl* _tmp5_;
		BackingPhotoRow* _tmp6_;
#line 1513 "../src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 1513 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1513 "../src/Photo.vala"
		_tmp5_ = reimport_state;
#line 1513 "../src/Photo.vala"
		_tmp6_ = _tmp5_->backing_state;
#line 1513 "../src/Photo.vala"
		backing_photo_table_update (_tmp4_, _tmp6_, &_inner_error0_);
#line 1513 "../src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 1513 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1513 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1513 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1513 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1513 "../src/Photo.vala"
				return;
#line 12334 "Photo.c"
			} else {
#line 1513 "../src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1513 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1513 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1513 "../src/Photo.vala"
				return;
#line 12344 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp7_;
#line 1515 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 1515 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 12353 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp8_;
				BackingPhotoRow* _tmp9_;
				BackingPhotoRow* _tmp10_;
				PhotoReimportEditableStateImpl* _tmp11_;
				BackingPhotoRow* _tmp12_;
				Orientation _tmp13_;
#line 1516 "../src/Photo.vala"
				_tmp8_ = reimport_state;
#line 1516 "../src/Photo.vala"
				_tmp9_ = _tmp8_->backing_state;
#line 1516 "../src/Photo.vala"
				_tmp10_ = _backing_photo_row_ref0 (_tmp9_);
#line 1516 "../src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1516 "../src/Photo.vala"
				self->priv->editable = _tmp10_;
#line 1517 "../src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1517 "../src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1517 "../src/Photo.vala"
				_tmp13_ = _tmp12_->original_orientation;
#line 1517 "../src/Photo.vala"
				photo_set_orientation (self, _tmp13_);
#line 1518 "../src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 12381 "Photo.c"
			}
			__finally137:
			{
				PhotoRow* _tmp14_;
#line 1515 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 1515 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12390 "Photo.c"
			}
#line 1515 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1515 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1515 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1515 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1515 "../src/Photo.vala"
					return;
#line 12402 "Photo.c"
				} else {
#line 1515 "../src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1515 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1515 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1515 "../src/Photo.vala"
					return;
#line 12412 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp15_;
		BackingPhotoRow* _tmp16_;
		Orientation _tmp17_;
#line 1521 "../src/Photo.vala"
		_tmp15_ = reimport_state;
#line 1521 "../src/Photo.vala"
		_tmp16_ = _tmp15_->backing_state;
#line 1521 "../src/Photo.vala"
		_tmp17_ = _tmp16_->original_orientation;
#line 1521 "../src/Photo.vala"
		photo_set_orientation (self, _tmp17_);
#line 12428 "Photo.c"
	}
#line 1524 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1524 "../src/Photo.vala"
	_tmp19_ = _tmp18_->metadata;
#line 1524 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 12436 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp20_;
		PhotoMetadata* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		PhotoReimportEditableStateImpl* _tmp24_;
		PhotoMetadata* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		PhotoReimportEditableStateImpl* _tmp28_;
		PhotoMetadata* _tmp29_;
#line 1525 "../src/Photo.vala"
		_tmp20_ = reimport_state;
#line 1525 "../src/Photo.vala"
		_tmp21_ = _tmp20_->metadata;
#line 1525 "../src/Photo.vala"
		_tmp22_ = media_metadata_get_title ((MediaMetadata*) _tmp21_);
#line 1525 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1525 "../src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp23_);
#line 1525 "../src/Photo.vala"
		_g_free0 (_tmp23_);
#line 1526 "../src/Photo.vala"
		_tmp24_ = reimport_state;
#line 1526 "../src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 1526 "../src/Photo.vala"
		_tmp26_ = media_metadata_get_comment ((MediaMetadata*) _tmp25_);
#line 1526 "../src/Photo.vala"
		_tmp27_ = _tmp26_;
#line 1526 "../src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp27_);
#line 1526 "../src/Photo.vala"
		_g_free0 (_tmp27_);
#line 1527 "../src/Photo.vala"
		_tmp28_ = reimport_state;
#line 1527 "../src/Photo.vala"
		_tmp29_ = _tmp28_->metadata;
#line 1527 "../src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp29_);
#line 12477 "Photo.c"
	}
#line 1530 "../src/Photo.vala"
	_tmp30_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1530 "../src/Photo.vala"
	list = _tmp30_;
#line 1531 "../src/Photo.vala"
	_tmp31_ = reimport_state;
#line 1531 "../src/Photo.vala"
	if (!_tmp31_->metadata_only) {
#line 12487 "Photo.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1532 "../src/Photo.vala"
		_tmp32_ = list;
#line 1532 "../src/Photo.vala"
		_tmp33_ = g_strconcat (_tmp32_, "image:editable,image:baseline", NULL);
#line 1532 "../src/Photo.vala"
		_g_free0 (list);
#line 1532 "../src/Photo.vala"
		list = _tmp33_;
#line 12498 "Photo.c"
	}
#line 1535 "../src/Photo.vala"
	_tmp34_ = list;
#line 1535 "../src/Photo.vala"
	_tmp35_ = alteration_new_from_list (_tmp34_);
#line 1535 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 1535 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp36_);
#line 1535 "../src/Photo.vala"
	_alteration_unref0 (_tmp36_);
#line 1537 "../src/Photo.vala"
	_tmp37_ = reimport_state;
#line 1537 "../src/Photo.vala"
	_tmp38_ = _tmp37_->metadata;
#line 1537 "../src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp38_);
#line 1539 "../src/Photo.vala"
	if (photo_is_editable_baseline (self)) {
#line 12518 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp39_;
		PhotoMetadata* _tmp40_;
#line 1540 "../src/Photo.vala"
		_tmp39_ = reimport_state;
#line 1540 "../src/Photo.vala"
		_tmp40_ = _tmp39_->metadata;
#line 1540 "../src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp40_);
#line 12527 "Photo.c"
	}
#line 1543 "../src/Photo.vala"
	if (photo_is_editable_source (self)) {
#line 12531 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp41_;
		PhotoMetadata* _tmp42_;
#line 1544 "../src/Photo.vala"
		_tmp41_ = reimport_state;
#line 1544 "../src/Photo.vala"
		_tmp42_ = _tmp41_->metadata;
#line 1544 "../src/Photo.vala"
		photo_notify_source_reimported (self, _tmp42_);
#line 12540 "Photo.c"
	}
#line 1504 "../src/Photo.vala"
	_g_free0 (list);
#line 1504 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 12546 "Photo.c"
}

static gpointer
_photo_reimport_raw_development_state_ref0 (gpointer self)
{
#line 1569 "../src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 12554 "Photo.c"
}

gboolean
photo_prepare_for_reimport_raw_development (Photo* self,
                                            PhotoReimportRawDevelopmentState* * state,
                                            GError** error)
{
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_;
	PhotoReimportRawDevelopmentStateImpl* _tmp18_;
	PhotoReimportRawDevelopmentState* _tmp19_;
	PhotoReimportRawDevelopmentStateImpl* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 1549 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1550 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1550 "../src/Photo.vala"
	_vala_state = NULL;
#line 1552 "../src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1552 "../src/Photo.vala"
	files = _tmp0_;
#line 1553 "../src/Photo.vala"
	_tmp1_ = files;
#line 1553 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1554 "../src/Photo.vala"
		result = FALSE;
#line 1554 "../src/Photo.vala"
		_g_object_unref0 (files);
#line 1554 "../src/Photo.vala"
		if (state) {
#line 1554 "../src/Photo.vala"
			*state = _vala_state;
#line 12595 "Photo.c"
		} else {
#line 1554 "../src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12599 "Photo.c"
		}
#line 1554 "../src/Photo.vala"
		return result;
#line 12603 "Photo.c"
	}
#line 1557 "../src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1557 "../src/Photo.vala"
	reimport_state = _tmp2_;
#line 12609 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 1559 "../src/Photo.vala"
		_tmp3_ = files;
#line 1559 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1559 "../src/Photo.vala"
		_file_it = _tmp4_;
#line 1559 "../src/Photo.vala"
		while (TRUE) {
#line 12622 "Photo.c"
			GeeIterator* _tmp5_;
			GFile* file = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp8_ = FALSE;
			GFile* _tmp9_;
			BackingPhotoRow* _tmp10_ = NULL;
			DetectedPhotoInformation* _tmp11_ = NULL;
			gboolean _tmp12_;
			PhotoReimportRawDevelopmentStateImpl* _tmp14_;
			BackingPhotoRow* _tmp15_;
			DetectedPhotoInformation* _tmp16_;
			PhotoMetadata* _tmp17_;
#line 1559 "../src/Photo.vala"
			_tmp5_ = _file_it;
#line 1559 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1559 "../src/Photo.vala"
				break;
#line 12644 "Photo.c"
			}
#line 1559 "../src/Photo.vala"
			_tmp6_ = _file_it;
#line 1559 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1559 "../src/Photo.vala"
			file = (GFile*) _tmp7_;
#line 1562 "../src/Photo.vala"
			_tmp9_ = file;
#line 1562 "../src/Photo.vala"
			_tmp12_ = photo_verify_file_for_reimport (self, _tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 1562 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1562 "../src/Photo.vala"
			backing = _tmp10_;
#line 1562 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1562 "../src/Photo.vala"
			detected = _tmp11_;
#line 1562 "../src/Photo.vala"
			_tmp8_ = _tmp12_;
#line 1562 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12668 "Photo.c"
				gboolean _tmp13_ = FALSE;
#line 1562 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1562 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1562 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1562 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1562 "../src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1562 "../src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1562 "../src/Photo.vala"
				_g_object_unref0 (files);
#line 1562 "../src/Photo.vala"
				return _tmp13_;
#line 12686 "Photo.c"
			}
#line 1562 "../src/Photo.vala"
			if (!_tmp8_) {
#line 1563 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1563 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1563 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 1563 "../src/Photo.vala"
				continue;
#line 12698 "Photo.c"
			}
#line 1566 "../src/Photo.vala"
			_tmp14_ = reimport_state;
#line 1566 "../src/Photo.vala"
			_tmp15_ = backing;
#line 1566 "../src/Photo.vala"
			_tmp16_ = detected;
#line 1566 "../src/Photo.vala"
			_tmp17_ = _tmp16_->metadata;
#line 1566 "../src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp14_, _tmp15_, _tmp17_);
#line 1559 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1559 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1559 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 12716 "Photo.c"
		}
#line 1559 "../src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 12720 "Photo.c"
	}
#line 1569 "../src/Photo.vala"
	_tmp18_ = reimport_state;
#line 1569 "../src/Photo.vala"
	_tmp19_ = _photo_reimport_raw_development_state_ref0 ((PhotoReimportRawDevelopmentState*) _tmp18_);
#line 1569 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1569 "../src/Photo.vala"
	_vala_state = _tmp19_;
#line 1570 "../src/Photo.vala"
	_tmp20_ = reimport_state;
#line 1570 "../src/Photo.vala"
	result = photo_reimport_raw_development_state_impl_get_size (_tmp20_) > 0;
#line 1570 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1570 "../src/Photo.vala"
	_g_object_unref0 (files);
#line 1570 "../src/Photo.vala"
	if (state) {
#line 1570 "../src/Photo.vala"
		*state = _vala_state;
#line 12742 "Photo.c"
	} else {
#line 1570 "../src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12746 "Photo.c"
	}
#line 1570 "../src/Photo.vala"
	return result;
#line 12750 "Photo.c"
}

void
photo_finish_reimport_raw_development (Photo* self,
                                       PhotoReimportRawDevelopmentState* state,
                                       GError** error)
{
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp0_;
	gchar* list = NULL;
	gchar* _tmp27_;
	PhotoReimportRawDevelopmentStateImpl* _tmp28_;
	const gchar* _tmp31_;
	Alteration* _tmp32_;
	Alteration* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 1574 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1574 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1575 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1576 "../src/Photo.vala"
		return;
#line 12775 "Photo.c"
	}
#line 1579 "../src/Photo.vala"
	_tmp0_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (state, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1579 "../src/Photo.vala"
	reimport_state = _tmp0_;
#line 12781 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 1581 "../src/Photo.vala"
		_tmp1_ = reimport_state;
#line 1581 "../src/Photo.vala"
		_tmp2_ = _tmp1_->list;
#line 1581 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1581 "../src/Photo.vala"
		_dev_it = _tmp3_;
#line 1581 "../src/Photo.vala"
		while (TRUE) {
#line 12797 "Photo.c"
			GeeIterator* _tmp4_;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PhotoReimportRawDevelopmentStateImpl* _tmp7_;
#line 1581 "../src/Photo.vala"
			_tmp4_ = _dev_it;
#line 1581 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1581 "../src/Photo.vala"
				break;
#line 12809 "Photo.c"
			}
#line 1581 "../src/Photo.vala"
			_tmp5_ = _dev_it;
#line 1581 "../src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1581 "../src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp6_;
#line 1582 "../src/Photo.vala"
			_tmp7_ = reimport_state;
#line 1582 "../src/Photo.vala"
			if (!_tmp7_->metadata_only) {
#line 12821 "Photo.c"
				BackingPhotoTable* _tmp8_;
				BackingPhotoTable* _tmp9_;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp10_;
				BackingPhotoRow* _tmp11_;
#line 1583 "../src/Photo.vala"
				_tmp8_ = backing_photo_table_get_instance ();
#line 1583 "../src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1583 "../src/Photo.vala"
				_tmp10_ = dev;
#line 1583 "../src/Photo.vala"
				_tmp11_ = _tmp10_->backing;
#line 1583 "../src/Photo.vala"
				backing_photo_table_update (_tmp9_, _tmp11_, &_inner_error0_);
#line 1583 "../src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1583 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1583 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1583 "../src/Photo.vala"
						g_propagate_error (error, _inner_error0_);
#line 1583 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1583 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1583 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1583 "../src/Photo.vala"
						return;
#line 12852 "Photo.c"
					} else {
#line 1583 "../src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1583 "../src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1583 "../src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1583 "../src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1583 "../src/Photo.vala"
						g_clear_error (&_inner_error0_);
#line 1583 "../src/Photo.vala"
						return;
#line 12866 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp12_;
#line 1585 "../src/Photo.vala"
					_tmp12_ = self->row;
#line 1585 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 12875 "Photo.c"
					{
						gint _tmp13_ = 0;
						RawDeveloper* _tmp14_;
#line 1587 "../src/Photo.vala"
						_tmp14_ = raw_developer_as_array (&_tmp13_);
#line 12881 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1587 "../src/Photo.vala"
							d_collection = _tmp14_;
#line 1587 "../src/Photo.vala"
							d_collection_length1 = _tmp13_;
#line 1587 "../src/Photo.vala"
							for (d_it = 0; d_it < _tmp13_; d_it = d_it + 1) {
#line 12893 "Photo.c"
								RawDeveloper d = 0;
#line 1587 "../src/Photo.vala"
								d = d_collection[d_it];
#line 12897 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp15_;
									BackingPhotoID* _tmp16_;
									gint _tmp16__length1;
									RawDeveloper _tmp17_;
									BackingPhotoID _tmp18_;
									BackingPhotoID _tmp19_;
#line 1588 "../src/Photo.vala"
									_tmp15_ = self->row;
#line 1588 "../src/Photo.vala"
									_tmp16_ = _tmp15_->development_ids;
#line 1588 "../src/Photo.vala"
									_tmp16__length1 = _tmp15_->development_ids_length1;
#line 1588 "../src/Photo.vala"
									_tmp17_ = d;
#line 1588 "../src/Photo.vala"
									_tmp18_ = _tmp16_[_tmp17_];
#line 1588 "../src/Photo.vala"
									id = _tmp18_;
#line 1589 "../src/Photo.vala"
									_tmp19_ = id;
#line 1589 "../src/Photo.vala"
									if (_tmp19_.id != BACKING_PHOTO_ID_INVALID) {
#line 12922 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp20_;
										BackingPhotoRow* _tmp21_;
										BackingPhotoRow* _tmp22_;
#line 1590 "../src/Photo.vala"
										_tmp20_ = id;
#line 1590 "../src/Photo.vala"
										_tmp21_ = photo_get_backing_row (self, &_tmp20_);
#line 1590 "../src/Photo.vala"
										bpr = _tmp21_;
#line 1591 "../src/Photo.vala"
										_tmp22_ = bpr;
#line 1591 "../src/Photo.vala"
										if (_tmp22_ != NULL) {
#line 12937 "Photo.c"
											GeeHashMap* _tmp23_;
											RawDeveloper _tmp24_;
											BackingPhotoRow* _tmp25_;
#line 1592 "../src/Photo.vala"
											_tmp23_ = self->priv->developments;
#line 1592 "../src/Photo.vala"
											_tmp24_ = d;
#line 1592 "../src/Photo.vala"
											_tmp25_ = bpr;
#line 1592 "../src/Photo.vala"
											gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) _tmp24_), _tmp25_);
#line 12949 "Photo.c"
										}
#line 1589 "../src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 12953 "Photo.c"
									}
								}
							}
#line 1587 "../src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 12959 "Photo.c"
						}
					}
					__finally138:
					{
						PhotoRow* _tmp26_;
#line 1585 "../src/Photo.vala"
						_tmp26_ = self->row;
#line 1585 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12969 "Photo.c"
					}
#line 1585 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1585 "../src/Photo.vala"
						if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1585 "../src/Photo.vala"
							g_propagate_error (error, _inner_error0_);
#line 1585 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1585 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1585 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1585 "../src/Photo.vala"
							return;
#line 12985 "Photo.c"
						} else {
#line 1585 "../src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1585 "../src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1585 "../src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1585 "../src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1585 "../src/Photo.vala"
							g_clear_error (&_inner_error0_);
#line 1585 "../src/Photo.vala"
							return;
#line 12999 "Photo.c"
						}
					}
				}
			}
#line 1581 "../src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 13006 "Photo.c"
		}
#line 1581 "../src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 13010 "Photo.c"
	}
#line 1600 "../src/Photo.vala"
	_tmp27_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1600 "../src/Photo.vala"
	list = _tmp27_;
#line 1601 "../src/Photo.vala"
	_tmp28_ = reimport_state;
#line 1601 "../src/Photo.vala"
	if (!_tmp28_->metadata_only) {
#line 13020 "Photo.c"
		const gchar* _tmp29_;
		gchar* _tmp30_;
#line 1602 "../src/Photo.vala"
		_tmp29_ = list;
#line 1602 "../src/Photo.vala"
		_tmp30_ = g_strconcat (_tmp29_, "image:editable,image:baseline", NULL);
#line 1602 "../src/Photo.vala"
		_g_free0 (list);
#line 1602 "../src/Photo.vala"
		list = _tmp30_;
#line 13031 "Photo.c"
	}
#line 1605 "../src/Photo.vala"
	_tmp31_ = list;
#line 1605 "../src/Photo.vala"
	_tmp32_ = alteration_new_from_list (_tmp31_);
#line 1605 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 1605 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp33_);
#line 1605 "../src/Photo.vala"
	_alteration_unref0 (_tmp33_);
#line 1607 "../src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1574 "../src/Photo.vala"
	_g_free0 (list);
#line 1574 "../src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 13049 "Photo.c"
}

static gchar*
photo_real_get_typename (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1610 "../src/Photo.vala"
	self = (Photo*) base;
#line 1611 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1611 "../src/Photo.vala"
	result = _tmp0_;
#line 1611 "../src/Photo.vala"
	return result;
#line 13066 "Photo.c"
}

static gint64
photo_real_get_instance_id (DataSource* base)
{
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
#line 1614 "../src/Photo.vala"
	self = (Photo*) base;
#line 1615 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1615 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1615 "../src/Photo.vala"
	return result;
#line 13083 "Photo.c"
}

static gchar*
photo_real_get_source_id (DataSource* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1618 "../src/Photo.vala"
	self = (Photo*) base;
#line 1622 "../src/Photo.vala"
	_tmp0_ = data_source_get_typename ((DataSource*) self);
#line 1622 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1622 "../src/Photo.vala"
	_tmp2_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, data_source_get_instance_id ((DataSource*) self));
#line 1622 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1622 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1622 "../src/Photo.vala"
	result = _tmp3_;
#line 1622 "../src/Photo.vala"
	return result;
#line 13111 "Photo.c"
}

void
photo_set_master_timestamp (Photo* self,
                            GFileInfo* info)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 1626 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1626 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1627 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1627 "../src/Photo.vala"
	modification = _tmp0_;
#line 13129 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1630 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1630 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13137 "Photo.c"
			{
				PhotoRow* _tmp2_;
				BackingPhotoRow* _tmp3_;
				GTimeVal _tmp4_;
				PhotoTable* _tmp6_;
				PhotoTable* _tmp7_;
				PhotoRow* _tmp8_;
				PhotoID _tmp9_;
				GTimeVal _tmp10_;
				PhotoRow* _tmp11_;
				BackingPhotoRow* _tmp12_;
				GTimeVal _tmp13_;
#line 1631 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1631 "../src/Photo.vala"
				_tmp3_ = _tmp2_->master;
#line 1631 "../src/Photo.vala"
				_tmp4_ = modification;
#line 1631 "../src/Photo.vala"
				if (_tmp3_->timestamp == ((time_t) _tmp4_.tv_sec)) {
#line 13158 "Photo.c"
					{
						GError* _inner_error0_ = NULL;
						PhotoRow* _tmp5_;
#line 1630 "../src/Photo.vala"
						_tmp5_ = self->row;
#line 1630 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13166 "Photo.c"
					}
#line 1632 "../src/Photo.vala"
					return;
#line 13170 "Photo.c"
				}
#line 1635 "../src/Photo.vala"
				_tmp6_ = photo_table_get_instance ();
#line 1635 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1635 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 1635 "../src/Photo.vala"
				_tmp9_ = _tmp8_->photo_id;
#line 1635 "../src/Photo.vala"
				_tmp10_ = modification;
#line 1635 "../src/Photo.vala"
				photo_table_update_timestamp (_tmp7_, &_tmp9_, (time_t) _tmp10_.tv_sec, &_inner_error0_);
#line 1635 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1635 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13188 "Photo.c"
					goto __finally140;
				}
#line 1636 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 1636 "../src/Photo.vala"
				_tmp12_ = _tmp11_->master;
#line 1636 "../src/Photo.vala"
				_tmp13_ = modification;
#line 1636 "../src/Photo.vala"
				_tmp12_->timestamp = (time_t) _tmp13_.tv_sec;
#line 13199 "Photo.c"
			}
			__finally140:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp14_;
#line 1630 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 1630 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13209 "Photo.c"
			}
#line 1630 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1630 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 13215 "Photo.c"
					goto __catch139_database_error;
				}
#line 1630 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1630 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1630 "../src/Photo.vala"
				return;
#line 13224 "Photo.c"
			}
		}
	}
	goto __finally139;
	__catch139_database_error:
	{
		GError* err = NULL;
		GError* _tmp15_;
#line 1629 "../src/Photo.vala"
		err = _inner_error0_;
#line 1629 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1639 "../src/Photo.vala"
		_tmp15_ = err;
#line 1639 "../src/Photo.vala"
		app_window_database_error (_tmp15_);
#line 1641 "../src/Photo.vala"
		_g_error_free0 (err);
#line 1641 "../src/Photo.vala"
		return;
#line 13245 "Photo.c"
	}
	__finally139:
#line 1629 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1629 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1629 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1629 "../src/Photo.vala"
		return;
#line 13256 "Photo.c"
	}
#line 1644 "../src/Photo.vala"
	if (photo_is_master_baseline (self)) {
#line 13260 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 1645 "../src/Photo.vala"
		_tmp16_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1645 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1645 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp17_);
#line 1645 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 13271 "Photo.c"
	} else {
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 1647 "../src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "master-timestamp");
#line 1647 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1647 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp19_);
#line 1647 "../src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 13283 "Photo.c"
	}
}

void
photo_update_editable_modification_time (Photo* self,
                                         GFileInfo* info,
                                         GError** error)
{
	GTimeVal modification = {0};
	GTimeVal _tmp0_ = {0};
	gboolean altered = FALSE;
	GError* _inner_error0_ = NULL;
#line 1652 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1652 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1653 "../src/Photo.vala"
	g_file_info_get_modification_time (info, &_tmp0_);
#line 1653 "../src/Photo.vala"
	modification = _tmp0_;
#line 1655 "../src/Photo.vala"
	altered = FALSE;
#line 13306 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1656 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1656 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 13313 "Photo.c"
		{
			gboolean _tmp2_ = FALSE;
			PhotoRow* _tmp3_;
#line 1657 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1657 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&_tmp3_->editable_id)) {
#line 13321 "Photo.c"
				BackingPhotoRow* _tmp4_;
				GTimeVal _tmp5_;
#line 1657 "../src/Photo.vala"
				_tmp4_ = self->priv->editable;
#line 1657 "../src/Photo.vala"
				_tmp5_ = modification;
#line 1657 "../src/Photo.vala"
				_tmp2_ = _tmp4_->timestamp != ((time_t) _tmp5_.tv_sec);
#line 13330 "Photo.c"
			} else {
#line 1657 "../src/Photo.vala"
				_tmp2_ = FALSE;
#line 13334 "Photo.c"
			}
#line 1657 "../src/Photo.vala"
			if (_tmp2_) {
#line 13338 "Photo.c"
				BackingPhotoTable* _tmp6_;
				BackingPhotoTable* _tmp7_;
				PhotoRow* _tmp8_;
				BackingPhotoID _tmp9_;
				GTimeVal _tmp10_;
				BackingPhotoRow* _tmp11_;
				GTimeVal _tmp12_;
#line 1658 "../src/Photo.vala"
				_tmp6_ = backing_photo_table_get_instance ();
#line 1658 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1658 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 1658 "../src/Photo.vala"
				_tmp9_ = _tmp8_->editable_id;
#line 1658 "../src/Photo.vala"
				_tmp10_ = modification;
#line 1658 "../src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp7_, &_tmp9_, (time_t) _tmp10_.tv_sec, &_inner_error0_);
#line 1658 "../src/Photo.vala"
				_database_table_unref0 (_tmp7_);
#line 1658 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13362 "Photo.c"
					goto __finally141;
				}
#line 1660 "../src/Photo.vala"
				_tmp11_ = self->priv->editable;
#line 1660 "../src/Photo.vala"
				_tmp12_ = modification;
#line 1660 "../src/Photo.vala"
				_tmp11_->timestamp = (time_t) _tmp12_.tv_sec;
#line 1661 "../src/Photo.vala"
				altered = TRUE;
#line 13373 "Photo.c"
			}
		}
		__finally141:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp13_;
#line 1656 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 1656 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13384 "Photo.c"
		}
#line 1656 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1656 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1656 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 1656 "../src/Photo.vala"
				return;
#line 13394 "Photo.c"
			} else {
#line 1656 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1656 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1656 "../src/Photo.vala"
				return;
#line 13402 "Photo.c"
			}
		}
	}
#line 1665 "../src/Photo.vala"
	if (altered) {
#line 13408 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 1666 "../src/Photo.vala"
		_tmp14_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1666 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 1666 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 1666 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 13419 "Photo.c"
	}
}

void
photo_update_many_editable_timestamps (GeeMap* map,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 1671 "../src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1673 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 13432 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 1674 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (map);
#line 1674 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1674 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1674 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 1674 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1674 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 1674 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 1674 "../src/Photo.vala"
		while (TRUE) {
#line 13456 "Photo.c"
			GeeIterator* _tmp5_;
			Photo* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Photo* _tmp8_;
			Photo* _tmp9_;
			gpointer _tmp10_;
			GFileInfo* _tmp11_;
#line 1674 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 1674 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 1674 "../src/Photo.vala"
				break;
#line 13471 "Photo.c"
			}
#line 1674 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1674 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 1674 "../src/Photo.vala"
			photo = (Photo*) _tmp7_;
#line 1675 "../src/Photo.vala"
			_tmp8_ = photo;
#line 1675 "../src/Photo.vala"
			_tmp9_ = photo;
#line 1675 "../src/Photo.vala"
			_tmp10_ = gee_map_get (map, _tmp9_);
#line 1675 "../src/Photo.vala"
			_tmp11_ = (GFileInfo*) _tmp10_;
#line 1675 "../src/Photo.vala"
			photo_update_editable_modification_time (_tmp8_, _tmp11_, &_inner_error0_);
#line 1675 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 1675 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1675 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1675 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1675 "../src/Photo.vala"
					return;
#line 13503 "Photo.c"
				} else {
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 1675 "../src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1675 "../src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1675 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 1675 "../src/Photo.vala"
					return;
#line 13515 "Photo.c"
				}
			}
#line 1674 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 13520 "Photo.c"
		}
#line 1674 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 13524 "Photo.c"
	}
#line 1677 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1677 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1677 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1677 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1677 "../src/Photo.vala"
			return;
#line 13536 "Photo.c"
		} else {
#line 1677 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1677 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1677 "../src/Photo.vala"
			return;
#line 13544 "Photo.c"
		}
	}
}

static PhotoFileFormat
photo_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
#line 1680 "../src/Photo.vala"
	self = (Photo*) base;
#line 1681 "../src/Photo.vala"
	if (photo_file_format_can_write_image (photo_get_file_format (self))) {
#line 1681 "../src/Photo.vala"
		_tmp0_ = photo_get_file_format (self);
#line 13561 "Photo.c"
	} else {
#line 1682 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_system_default_format ();
#line 13565 "Photo.c"
	}
#line 1681 "../src/Photo.vala"
	result = _tmp0_;
#line 1681 "../src/Photo.vala"
	return result;
#line 13571 "Photo.c"
}

static GdkPixbuf*
photo_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1685 "../src/Photo.vala"
	self = (Photo*) base;
#line 1686 "../src/Photo.vala"
	scaling_for_best_fit (scale, TRUE, &_tmp1_);
#line 1686 "../src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf ((PhotoSource*) self, &_tmp1_, &_inner_error0_);
#line 1686 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 1686 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1686 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 1686 "../src/Photo.vala"
		return NULL;
#line 13600 "Photo.c"
	}
#line 1686 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 1686 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 1686 "../src/Photo.vala"
	result = _tmp3_;
#line 1686 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1686 "../src/Photo.vala"
	return result;
#line 13612 "Photo.c"
}

gboolean
photo_is_file_image (GFile* file)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1689 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1693 "../src/Photo.vala"
	if (photo_file_format_is_file_supported (file)) {
#line 1694 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 13626 "Photo.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 1694 "../src/Photo.vala"
		_tmp1_ = g_file_get_basename (file);
#line 1694 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1694 "../src/Photo.vala"
		_tmp0_ = photo_is_extension_found (_tmp2_, PHOTO_IMAGE_EXTENSIONS, (gint) G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1694 "../src/Photo.vala"
		_g_free0 (_tmp2_);
#line 13638 "Photo.c"
	}
#line 1693 "../src/Photo.vala"
	result = _tmp0_;
#line 1693 "../src/Photo.vala"
	return result;
#line 13644 "Photo.c"
}

gboolean
photo_can_write_file (Photo* self)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* file_info = NULL;
	GFileInfo* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1697 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1698 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1698 "../src/Photo.vala"
	_tmp1_ = _tmp0_->master;
#line 1698 "../src/Photo.vala"
	_tmp2_ = _tmp1_->filepath;
#line 1698 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 1698 "../src/Photo.vala"
	file = _tmp3_;
#line 13671 "Photo.c"
	{
		GFileInfo* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
#line 1701 "../src/Photo.vala"
		_tmp5_ = file;
#line 1701 "../src/Photo.vala"
		_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 1701 "../src/Photo.vala"
		_tmp4_ = _tmp6_;
#line 1701 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13685 "Photo.c"
			goto __catch142_g_error;
		}
#line 1701 "../src/Photo.vala"
		_tmp7_ = _tmp4_;
#line 1701 "../src/Photo.vala"
		_tmp4_ = NULL;
#line 1701 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1701 "../src/Photo.vala"
		file_info = _tmp7_;
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 13698 "Photo.c"
	}
	goto __finally142;
	__catch142_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 1700 "../src/Photo.vala"
		e = _inner_error0_;
#line 1700 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1703 "../src/Photo.vala"
		_tmp8_ = e;
#line 1703 "../src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1703 "../src/Photo.vala"
		g_warning ("Photo.vala:1703: Error while testing if file is writeable: %s\n", _tmp9_);
#line 1704 "../src/Photo.vala"
		result = FALSE;
#line 1704 "../src/Photo.vala"
		_g_error_free0 (e);
#line 1704 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1704 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1704 "../src/Photo.vala"
		return result;
#line 13726 "Photo.c"
	}
	__finally142:
#line 1700 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13731 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1700 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 1700 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1700 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1700 "../src/Photo.vala"
		return _tmp10_;
#line 13743 "Photo.c"
	}
#line 1707 "../src/Photo.vala"
	_tmp11_ = file_info;
#line 1707 "../src/Photo.vala"
	result = g_file_info_get_attribute_boolean (_tmp11_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 1707 "../src/Photo.vala"
	_g_object_unref0 (file_info);
#line 1707 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 1707 "../src/Photo.vala"
	return result;
#line 13755 "Photo.c"
}

static gboolean
photo_is_extension_found (const gchar* basename,
                          gchar** extensions,
                          gint extensions_length1)
{
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
#line 1710 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1712 "../src/Photo.vala"
	disassemble_filename (basename, &_tmp0_, &_tmp1_);
#line 1712 "../src/Photo.vala"
	_g_free0 (name);
#line 1712 "../src/Photo.vala"
	name = _tmp0_;
#line 1712 "../src/Photo.vala"
	_g_free0 (ext);
#line 1712 "../src/Photo.vala"
	ext = _tmp1_;
#line 1713 "../src/Photo.vala"
	_tmp2_ = ext;
#line 1713 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 1714 "../src/Photo.vala"
		result = FALSE;
#line 1714 "../src/Photo.vala"
		_g_free0 (ext);
#line 1714 "../src/Photo.vala"
		_g_free0 (name);
#line 1714 "../src/Photo.vala"
		return result;
#line 13795 "Photo.c"
	}
#line 1718 "../src/Photo.vala"
	_tmp3_ = ext;
#line 1718 "../src/Photo.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 1718 "../src/Photo.vala"
	_g_free0 (ext);
#line 1718 "../src/Photo.vala"
	ext = _tmp4_;
#line 13805 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1721 "../src/Photo.vala"
		extension_collection = extensions;
#line 1721 "../src/Photo.vala"
		extension_collection_length1 = extensions_length1;
#line 1721 "../src/Photo.vala"
		for (extension_it = 0; extension_it < extensions_length1; extension_it = extension_it + 1) {
#line 13817 "Photo.c"
			gchar* _tmp5_;
			gchar* extension = NULL;
#line 1721 "../src/Photo.vala"
			_tmp5_ = g_strdup (extension_collection[extension_it]);
#line 1721 "../src/Photo.vala"
			extension = _tmp5_;
#line 13824 "Photo.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1722 "../src/Photo.vala"
				_tmp6_ = ext;
#line 1722 "../src/Photo.vala"
				_tmp7_ = extension;
#line 1722 "../src/Photo.vala"
				if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
#line 1723 "../src/Photo.vala"
					result = TRUE;
#line 1723 "../src/Photo.vala"
					_g_free0 (extension);
#line 1723 "../src/Photo.vala"
					_g_free0 (ext);
#line 1723 "../src/Photo.vala"
					_g_free0 (name);
#line 1723 "../src/Photo.vala"
					return result;
#line 13844 "Photo.c"
				}
#line 1721 "../src/Photo.vala"
				_g_free0 (extension);
#line 13848 "Photo.c"
			}
		}
	}
#line 1727 "../src/Photo.vala"
	result = FALSE;
#line 1727 "../src/Photo.vala"
	_g_free0 (ext);
#line 1727 "../src/Photo.vala"
	_g_free0 (name);
#line 1727 "../src/Photo.vala"
	return result;
#line 13860 "Photo.c"
}

gboolean
photo_is_duplicate (GFile* file,
                    const gchar* thumbnail_md5,
                    const gchar* full_md5,
                    PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gboolean _tmp2_;
#line 1736 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1736 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1736 "../src/Photo.vala"
	_tmp2_ = photo_table_has_duplicate (_tmp1_, file, thumbnail_md5, full_md5, file_format);
#line 1736 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1736 "../src/Photo.vala"
	result = _tmp2_;
#line 1736 "../src/Photo.vala"
	return result;
#line 13885 "Photo.c"
}

PhotoID*
photo_get_duplicate_ids (GFile* file,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         gint* result_length1)
{
	PhotoID* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	gint _tmp2_ = 0;
	PhotoID* _tmp3_;
	PhotoID* _tmp4_;
	gint _tmp4__length1;
	PhotoID* _tmp5_;
	gint _tmp5__length1;
#line 1745 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1745 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1745 "../src/Photo.vala"
	_tmp3_ = photo_table_get_duplicate_ids (_tmp1_, file, thumbnail_md5, full_md5, file_format, &_tmp2_);
#line 1745 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1745 "../src/Photo.vala"
	_tmp4__length1 = _tmp2_;
#line 1745 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1745 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 1745 "../src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1745 "../src/Photo.vala"
	if (result_length1) {
#line 1745 "../src/Photo.vala"
		*result_length1 = _tmp5__length1;
#line 13924 "Photo.c"
	}
#line 1745 "../src/Photo.vala"
	result = _tmp5_;
#line 1745 "../src/Photo.vala"
	return result;
#line 13930 "Photo.c"
}

gint64
photo_get_photo_key (DataSource* source)
{
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
#line 1752 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, 0LL);
#line 1753 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto), &_tmp0_);
#line 1753 "../src/Photo.vala"
	result = _tmp0_.id;
#line 1753 "../src/Photo.vala"
	return result;
#line 13946 "Photo.c"
}

static GFile*
photo_real_get_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1771 "../src/Photo.vala"
	self = (Photo*) base;
#line 1772 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1772 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1772 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1772 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1772 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1772 "../src/Photo.vala"
	result = _tmp3_;
#line 1772 "../src/Photo.vala"
	return result;
#line 13974 "Photo.c"
}

static void
_vala_array_add17 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1816 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1816 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1816 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13989 "Photo.c"
	}
#line 1816 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1816 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 13995 "Photo.c"
}

static void
_vala_array_add18 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1821 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1821 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1821 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14010 "Photo.c"
	}
#line 1821 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1821 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14016 "Photo.c"
}

static void
_vala_array_add19 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1825 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1825 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1825 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14031 "Photo.c"
	}
#line 1825 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1825 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14037 "Photo.c"
}

static void
_vala_array_add20 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1829 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1829 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1829 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14052 "Photo.c"
	}
#line 1829 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1829 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14058 "Photo.c"
}

void
photo_set_master_file (Photo* self,
                       GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1777 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1777 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1778 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1778 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1780 "../src/Photo.vala"
	altered = FALSE;
#line 1781 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1782 "../src/Photo.vala"
	is_source = FALSE;
#line 1783 "../src/Photo.vala"
	name_changed = FALSE;
#line 1784 "../src/Photo.vala"
	old_file = NULL;
#line 14091 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1786 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1786 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14099 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1787 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1787 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14107 "Photo.c"
					{
						PhotoBackingReaders* _tmp3_;
						PhotoFileReader* _tmp4_;
						GFile* _tmp5_;
						GFile* _tmp6_;
#line 1788 "../src/Photo.vala"
						_tmp3_ = self->priv->readers;
#line 1788 "../src/Photo.vala"
						_tmp4_ = _tmp3_->master;
#line 1788 "../src/Photo.vala"
						_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 1788 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1788 "../src/Photo.vala"
						old_file = _tmp5_;
#line 1789 "../src/Photo.vala"
						_tmp6_ = old_file;
#line 1789 "../src/Photo.vala"
						if (!g_file_equal (file, _tmp6_)) {
#line 14127 "Photo.c"
							PhotoTable* _tmp7_;
							PhotoTable* _tmp8_;
							PhotoID _tmp9_ = {0};
							const gchar* _tmp10_;
							PhotoRow* _tmp11_;
							BackingPhotoRow* _tmp12_;
							const gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							PhotoBackingReaders* _tmp16_;
							PhotoRow* _tmp17_;
							BackingPhotoRow* _tmp18_;
							PhotoFileFormat _tmp19_;
							const gchar* _tmp20_;
							PhotoFileReader* _tmp21_;
							gboolean _tmp22_ = FALSE;
							PhotoRow* _tmp23_;
							const gchar* _tmp24_;
#line 1790 "../src/Photo.vala"
							_tmp7_ = photo_table_get_instance ();
#line 1790 "../src/Photo.vala"
							_tmp8_ = _tmp7_;
#line 1790 "../src/Photo.vala"
							photo_get_photo_id (self, &_tmp9_);
#line 1790 "../src/Photo.vala"
							_tmp10_ = filepath;
#line 1790 "../src/Photo.vala"
							photo_table_set_filepath (_tmp8_, &_tmp9_, _tmp10_, &_inner_error0_);
#line 1790 "../src/Photo.vala"
							_database_table_unref0 (_tmp8_);
#line 1790 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14160 "Photo.c"
								goto __finally145;
							}
#line 1792 "../src/Photo.vala"
							_tmp11_ = self->row;
#line 1792 "../src/Photo.vala"
							_tmp12_ = _tmp11_->master;
#line 1792 "../src/Photo.vala"
							_tmp13_ = filepath;
#line 1792 "../src/Photo.vala"
							_tmp14_ = g_strdup (_tmp13_);
#line 1792 "../src/Photo.vala"
							_g_free0 (_tmp12_->filepath);
#line 1792 "../src/Photo.vala"
							_tmp12_->filepath = _tmp14_;
#line 1793 "../src/Photo.vala"
							_tmp15_ = g_file_get_basename (file);
#line 1793 "../src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1793 "../src/Photo.vala"
							self->priv->file_title = _tmp15_;
#line 1794 "../src/Photo.vala"
							_tmp16_ = self->priv->readers;
#line 1794 "../src/Photo.vala"
							_tmp17_ = self->row;
#line 1794 "../src/Photo.vala"
							_tmp18_ = _tmp17_->master;
#line 1794 "../src/Photo.vala"
							_tmp19_ = _tmp18_->file_format;
#line 1794 "../src/Photo.vala"
							_tmp20_ = filepath;
#line 1794 "../src/Photo.vala"
							_tmp21_ = photo_file_format_create_reader (_tmp19_, _tmp20_);
#line 1794 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp16_->master);
#line 1794 "../src/Photo.vala"
							_tmp16_->master = _tmp21_;
#line 1796 "../src/Photo.vala"
							altered = TRUE;
#line 1797 "../src/Photo.vala"
							is_baseline = photo_is_master_baseline (self);
#line 1798 "../src/Photo.vala"
							is_source = photo_is_master_source (self);
#line 1799 "../src/Photo.vala"
							_tmp23_ = self->row;
#line 1799 "../src/Photo.vala"
							_tmp24_ = _tmp23_->title;
#line 1799 "../src/Photo.vala"
							if (is_string_empty (_tmp24_)) {
#line 14209 "Photo.c"
								GFile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
#line 1800 "../src/Photo.vala"
								_tmp25_ = old_file;
#line 1800 "../src/Photo.vala"
								_tmp26_ = g_file_get_basename (_tmp25_);
#line 1800 "../src/Photo.vala"
								_tmp27_ = _tmp26_;
#line 1800 "../src/Photo.vala"
								_tmp28_ = g_file_get_basename (file);
#line 1800 "../src/Photo.vala"
								_tmp29_ = _tmp28_;
#line 1800 "../src/Photo.vala"
								_tmp22_ = g_strcmp0 (_tmp27_, _tmp29_) != 0;
#line 1800 "../src/Photo.vala"
								_g_free0 (_tmp29_);
#line 1800 "../src/Photo.vala"
								_g_free0 (_tmp27_);
#line 14231 "Photo.c"
							} else {
#line 1799 "../src/Photo.vala"
								_tmp22_ = FALSE;
#line 14235 "Photo.c"
							}
#line 1799 "../src/Photo.vala"
							name_changed = _tmp22_;
#line 14239 "Photo.c"
						}
					}
					__finally145:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp30_;
#line 1787 "../src/Photo.vala"
						_tmp30_ = self->priv->readers;
#line 1787 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14250 "Photo.c"
					}
#line 1787 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14254 "Photo.c"
						goto __finally144;
					}
				}
			}
			__finally144:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp31_;
#line 1786 "../src/Photo.vala"
				_tmp31_ = self->row;
#line 1786 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14267 "Photo.c"
			}
#line 1786 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1786 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 14273 "Photo.c"
					goto __catch143_database_error;
				}
#line 1786 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1786 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1786 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1786 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1786 "../src/Photo.vala"
				return;
#line 14286 "Photo.c"
			}
		}
	}
	goto __finally143;
	__catch143_database_error:
	{
		GError* err = NULL;
		GError* _tmp32_;
#line 1785 "../src/Photo.vala"
		err = _inner_error0_;
#line 1785 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1805 "../src/Photo.vala"
		_tmp32_ = err;
#line 1805 "../src/Photo.vala"
		app_window_database_error (_tmp32_);
#line 1785 "../src/Photo.vala"
		_g_error_free0 (err);
#line 14305 "Photo.c"
	}
	__finally143:
#line 1785 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1785 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1785 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1785 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1785 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1785 "../src/Photo.vala"
		return;
#line 14320 "Photo.c"
	}
#line 1808 "../src/Photo.vala"
	if (altered) {
#line 14324 "Photo.c"
		GFile* _tmp33_;
		gchar** alteration_list = NULL;
		gchar** _tmp34_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		gchar* _tmp36_;
		gchar** _tmp43_;
		gint _tmp43__length1;
		Alteration* _tmp44_;
		Alteration* _tmp45_;
#line 1809 "../src/Photo.vala"
		_tmp33_ = old_file;
#line 1809 "../src/Photo.vala"
		media_source_notify_master_replaced ((MediaSource*) self, _tmp33_, file);
#line 1811 "../src/Photo.vala"
		if (is_baseline) {
#line 1812 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14345 "Photo.c"
		}
#line 1815 "../src/Photo.vala"
		_tmp34_ = g_new0 (gchar*, 0 + 1);
#line 1815 "../src/Photo.vala"
		alteration_list = _tmp34_;
#line 1815 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1815 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1816 "../src/Photo.vala"
		_tmp35_ = alteration_list;
#line 1816 "../src/Photo.vala"
		_tmp35__length1 = alteration_list_length1;
#line 1816 "../src/Photo.vala"
		_tmp36_ = g_strdup ("backing:master");
#line 1816 "../src/Photo.vala"
		_vala_array_add17 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp36_);
#line 1820 "../src/Photo.vala"
		if (name_changed) {
#line 14365 "Photo.c"
			gchar** _tmp37_;
			gint _tmp37__length1;
			gchar* _tmp38_;
#line 1821 "../src/Photo.vala"
			_tmp37_ = alteration_list;
#line 1821 "../src/Photo.vala"
			_tmp37__length1 = alteration_list_length1;
#line 1821 "../src/Photo.vala"
			_tmp38_ = g_strdup ("metadata:name");
#line 1821 "../src/Photo.vala"
			_vala_array_add18 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp38_);
#line 14377 "Photo.c"
		}
#line 1824 "../src/Photo.vala"
		if (is_source) {
#line 14381 "Photo.c"
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar* _tmp40_;
#line 1825 "../src/Photo.vala"
			_tmp39_ = alteration_list;
#line 1825 "../src/Photo.vala"
			_tmp39__length1 = alteration_list_length1;
#line 1825 "../src/Photo.vala"
			_tmp40_ = g_strdup ("backing:source");
#line 1825 "../src/Photo.vala"
			_vala_array_add19 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 14393 "Photo.c"
		}
#line 1828 "../src/Photo.vala"
		if (is_baseline) {
#line 14397 "Photo.c"
			gchar** _tmp41_;
			gint _tmp41__length1;
			gchar* _tmp42_;
#line 1829 "../src/Photo.vala"
			_tmp41_ = alteration_list;
#line 1829 "../src/Photo.vala"
			_tmp41__length1 = alteration_list_length1;
#line 1829 "../src/Photo.vala"
			_tmp42_ = g_strdup ("backing:baseline");
#line 1829 "../src/Photo.vala"
			_vala_array_add20 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp42_);
#line 14409 "Photo.c"
		}
#line 1832 "../src/Photo.vala"
		_tmp43_ = alteration_list;
#line 1832 "../src/Photo.vala"
		_tmp43__length1 = alteration_list_length1;
#line 1832 "../src/Photo.vala"
		_tmp44_ = alteration_new_from_array (_tmp43_, _tmp43__length1);
#line 1832 "../src/Photo.vala"
		_tmp45_ = _tmp44_;
#line 1832 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp45_);
#line 1832 "../src/Photo.vala"
		_alteration_unref0 (_tmp45_);
#line 1808 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14425 "Photo.c"
	}
#line 1777 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1777 "../src/Photo.vala"
	_g_free0 (filepath);
#line 14431 "Photo.c"
}

static void
_vala_array_add21 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1873 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1873 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1873 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14446 "Photo.c"
	}
#line 1873 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1873 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14452 "Photo.c"
}

static void
_vala_array_add22 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1876 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1876 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1876 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14467 "Photo.c"
	}
#line 1876 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1876 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14473 "Photo.c"
}

static void
_vala_array_add23 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 1880 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 1880 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1880 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14488 "Photo.c"
	}
#line 1880 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1880 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 14494 "Photo.c"
}

void
photo_set_editable_file (Photo* self,
                         GFile* file)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	GError* _inner_error0_ = NULL;
#line 1838 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1838 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1839 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 1839 "../src/Photo.vala"
	filepath = _tmp0_;
#line 1841 "../src/Photo.vala"
	altered = FALSE;
#line 1842 "../src/Photo.vala"
	is_baseline = FALSE;
#line 1843 "../src/Photo.vala"
	is_source = FALSE;
#line 1844 "../src/Photo.vala"
	old_file = NULL;
#line 14524 "Photo.c"
	{
		{
			PhotoRow* _tmp1_;
#line 1846 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1846 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14532 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp2_;
#line 1847 "../src/Photo.vala"
					_tmp2_ = self->priv->readers;
#line 1847 "../src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14540 "Photo.c"
					{
						GFile* _tmp3_ = NULL;
						PhotoBackingReaders* _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp9_;
						gboolean _tmp10_ = FALSE;
						GFile* _tmp11_;
#line 1848 "../src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1848 "../src/Photo.vala"
						_tmp5_ = _tmp4_->editable;
#line 1848 "../src/Photo.vala"
						if (_tmp5_ != NULL) {
#line 14554 "Photo.c"
							PhotoBackingReaders* _tmp6_;
							PhotoFileReader* _tmp7_;
							GFile* _tmp8_;
#line 1848 "../src/Photo.vala"
							_tmp6_ = self->priv->readers;
#line 1848 "../src/Photo.vala"
							_tmp7_ = _tmp6_->editable;
#line 1848 "../src/Photo.vala"
							_tmp8_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp7_);
#line 1848 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
							_tmp3_ = _tmp8_;
#line 14568 "Photo.c"
						} else {
#line 1848 "../src/Photo.vala"
							_g_object_unref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
							_tmp3_ = NULL;
#line 14574 "Photo.c"
						}
#line 1848 "../src/Photo.vala"
						_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1848 "../src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1848 "../src/Photo.vala"
						old_file = _tmp9_;
#line 1849 "../src/Photo.vala"
						_tmp11_ = old_file;
#line 1849 "../src/Photo.vala"
						if (_tmp11_ != NULL) {
#line 14586 "Photo.c"
							GFile* _tmp12_;
#line 1849 "../src/Photo.vala"
							_tmp12_ = old_file;
#line 1849 "../src/Photo.vala"
							_tmp10_ = !g_file_equal (_tmp12_, file);
#line 14592 "Photo.c"
						} else {
#line 1849 "../src/Photo.vala"
							_tmp10_ = FALSE;
#line 14596 "Photo.c"
						}
#line 1849 "../src/Photo.vala"
						if (_tmp10_) {
#line 14600 "Photo.c"
							BackingPhotoTable* _tmp13_;
							BackingPhotoTable* _tmp14_;
							PhotoRow* _tmp15_;
							BackingPhotoID _tmp16_;
							const gchar* _tmp17_;
							BackingPhotoRow* _tmp18_;
							const gchar* _tmp19_;
							gchar* _tmp20_;
							PhotoBackingReaders* _tmp21_;
							BackingPhotoRow* _tmp22_;
							PhotoFileFormat _tmp23_;
							const gchar* _tmp24_;
							PhotoFileReader* _tmp25_;
#line 1850 "../src/Photo.vala"
							_tmp13_ = backing_photo_table_get_instance ();
#line 1850 "../src/Photo.vala"
							_tmp14_ = _tmp13_;
#line 1850 "../src/Photo.vala"
							_tmp15_ = self->row;
#line 1850 "../src/Photo.vala"
							_tmp16_ = _tmp15_->editable_id;
#line 1850 "../src/Photo.vala"
							_tmp17_ = filepath;
#line 1850 "../src/Photo.vala"
							backing_photo_table_set_filepath (_tmp14_, &_tmp16_, _tmp17_, &_inner_error0_);
#line 1850 "../src/Photo.vala"
							_database_table_unref0 (_tmp14_);
#line 1850 "../src/Photo.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1850 "../src/Photo.vala"
								_g_object_unref0 (_tmp3_);
#line 14632 "Photo.c"
								goto __finally148;
							}
#line 1852 "../src/Photo.vala"
							_tmp18_ = self->priv->editable;
#line 1852 "../src/Photo.vala"
							_tmp19_ = filepath;
#line 1852 "../src/Photo.vala"
							_tmp20_ = g_strdup (_tmp19_);
#line 1852 "../src/Photo.vala"
							_g_free0 (_tmp18_->filepath);
#line 1852 "../src/Photo.vala"
							_tmp18_->filepath = _tmp20_;
#line 1853 "../src/Photo.vala"
							_tmp21_ = self->priv->readers;
#line 1853 "../src/Photo.vala"
							_tmp22_ = self->priv->editable;
#line 1853 "../src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1853 "../src/Photo.vala"
							_tmp24_ = filepath;
#line 1853 "../src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1853 "../src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp21_->editable);
#line 1853 "../src/Photo.vala"
							_tmp21_->editable = _tmp25_;
#line 1855 "../src/Photo.vala"
							altered = TRUE;
#line 1856 "../src/Photo.vala"
							is_baseline = photo_is_editable_baseline (self);
#line 1857 "../src/Photo.vala"
							is_source = photo_is_editable_source (self);
#line 14665 "Photo.c"
						}
#line 1847 "../src/Photo.vala"
						_g_object_unref0 (_tmp3_);
#line 14669 "Photo.c"
					}
					__finally148:
					{
						GError* _inner_error1_ = NULL;
						PhotoBackingReaders* _tmp26_;
#line 1847 "../src/Photo.vala"
						_tmp26_ = self->priv->readers;
#line 1847 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14679 "Photo.c"
					}
#line 1847 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14683 "Photo.c"
						goto __finally147;
					}
				}
			}
			__finally147:
			{
				GError* _inner_error1_ = NULL;
				PhotoRow* _tmp27_;
#line 1846 "../src/Photo.vala"
				_tmp27_ = self->row;
#line 1846 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14696 "Photo.c"
			}
#line 1846 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1846 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 14702 "Photo.c"
					goto __catch146_database_error;
				}
#line 1846 "../src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1846 "../src/Photo.vala"
				_g_free0 (filepath);
#line 1846 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1846 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 1846 "../src/Photo.vala"
				return;
#line 14715 "Photo.c"
			}
		}
	}
	goto __finally146;
	__catch146_database_error:
	{
		GError* err = NULL;
		GError* _tmp28_;
#line 1845 "../src/Photo.vala"
		err = _inner_error0_;
#line 1845 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 1862 "../src/Photo.vala"
		_tmp28_ = err;
#line 1862 "../src/Photo.vala"
		app_window_database_error (_tmp28_);
#line 1845 "../src/Photo.vala"
		_g_error_free0 (err);
#line 14734 "Photo.c"
	}
	__finally146:
#line 1845 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1845 "../src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1845 "../src/Photo.vala"
		_g_free0 (filepath);
#line 1845 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1845 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1845 "../src/Photo.vala"
		return;
#line 14749 "Photo.c"
	}
#line 1865 "../src/Photo.vala"
	if (altered) {
#line 14753 "Photo.c"
		GFile* _tmp29_;
		gchar** alteration_list = NULL;
		gchar** _tmp30_;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		gchar* _tmp32_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		Alteration* _tmp38_;
		Alteration* _tmp39_;
#line 1866 "../src/Photo.vala"
		_tmp29_ = old_file;
#line 1866 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp29_, file);
#line 1868 "../src/Photo.vala"
		if (is_baseline) {
#line 1869 "../src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14774 "Photo.c"
		}
#line 1872 "../src/Photo.vala"
		_tmp30_ = g_new0 (gchar*, 0 + 1);
#line 1872 "../src/Photo.vala"
		alteration_list = _tmp30_;
#line 1872 "../src/Photo.vala"
		alteration_list_length1 = 0;
#line 1872 "../src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1873 "../src/Photo.vala"
		_tmp31_ = alteration_list;
#line 1873 "../src/Photo.vala"
		_tmp31__length1 = alteration_list_length1;
#line 1873 "../src/Photo.vala"
		_tmp32_ = g_strdup ("backing:editable");
#line 1873 "../src/Photo.vala"
		_vala_array_add21 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp32_);
#line 1875 "../src/Photo.vala"
		if (is_baseline) {
#line 14794 "Photo.c"
			gchar** _tmp33_;
			gint _tmp33__length1;
			gchar* _tmp34_;
#line 1876 "../src/Photo.vala"
			_tmp33_ = alteration_list;
#line 1876 "../src/Photo.vala"
			_tmp33__length1 = alteration_list_length1;
#line 1876 "../src/Photo.vala"
			_tmp34_ = g_strdup ("backing:baseline");
#line 1876 "../src/Photo.vala"
			_vala_array_add22 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp34_);
#line 14806 "Photo.c"
		}
#line 1879 "../src/Photo.vala"
		if (is_source) {
#line 14810 "Photo.c"
			gchar** _tmp35_;
			gint _tmp35__length1;
			gchar* _tmp36_;
#line 1880 "../src/Photo.vala"
			_tmp35_ = alteration_list;
#line 1880 "../src/Photo.vala"
			_tmp35__length1 = alteration_list_length1;
#line 1880 "../src/Photo.vala"
			_tmp36_ = g_strdup ("backing:source");
#line 1880 "../src/Photo.vala"
			_vala_array_add23 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp36_);
#line 14822 "Photo.c"
		}
#line 1883 "../src/Photo.vala"
		_tmp37_ = alteration_list;
#line 1883 "../src/Photo.vala"
		_tmp37__length1 = alteration_list_length1;
#line 1883 "../src/Photo.vala"
		_tmp38_ = alteration_new_from_array (_tmp37_, _tmp37__length1);
#line 1883 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 1883 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp39_);
#line 1883 "../src/Photo.vala"
		_alteration_unref0 (_tmp39_);
#line 1865 "../src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14838 "Photo.c"
	}
#line 1838 "../src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1838 "../src/Photo.vala"
	_g_free0 (filepath);
#line 14844 "Photo.c"
}

void
photo_set_many_editable_file (GeeMap* map,
                              GError** error)
{
	GeeMapIterator* map_iter = NULL;
	GeeMapIterator* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1888 "../src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1889 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 1891 "../src/Photo.vala"
	_tmp0_ = gee_map_map_iterator (map);
#line 1891 "../src/Photo.vala"
	map_iter = _tmp0_;
#line 1892 "../src/Photo.vala"
	while (TRUE) {
#line 14864 "Photo.c"
		GeeMapIterator* _tmp1_;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		Photo* _tmp4_;
		GeeMapIterator* _tmp5_;
		gpointer _tmp6_;
		GFile* _tmp7_;
#line 1892 "../src/Photo.vala"
		_tmp1_ = map_iter;
#line 1892 "../src/Photo.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 1892 "../src/Photo.vala"
			break;
#line 14878 "Photo.c"
		}
#line 1893 "../src/Photo.vala"
		_tmp2_ = map_iter;
#line 1893 "../src/Photo.vala"
		_tmp3_ = gee_map_iterator_get_key (_tmp2_);
#line 1893 "../src/Photo.vala"
		_tmp4_ = (Photo*) _tmp3_;
#line 1893 "../src/Photo.vala"
		_tmp5_ = map_iter;
#line 1893 "../src/Photo.vala"
		_tmp6_ = gee_map_iterator_get_value (_tmp5_);
#line 1893 "../src/Photo.vala"
		_tmp7_ = (GFile*) _tmp6_;
#line 1893 "../src/Photo.vala"
		photo_set_editable_file (_tmp4_, _tmp7_);
#line 1893 "../src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 1893 "../src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 14898 "Photo.c"
	}
#line 1896 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 1896 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1896 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 1896 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 1896 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1896 "../src/Photo.vala"
			return;
#line 14912 "Photo.c"
		} else {
#line 1896 "../src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1896 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1896 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1896 "../src/Photo.vala"
			return;
#line 14922 "Photo.c"
		}
	}
#line 1888 "../src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 14927 "Photo.c"
}

GFile*
photo_get_actual_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1901 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1902 "../src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1902 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1902 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1902 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1902 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1902 "../src/Photo.vala"
	result = _tmp3_;
#line 1902 "../src/Photo.vala"
	return result;
#line 14954 "Photo.c"
}

static GFile*
photo_real_get_master_file (MediaSource* base)
{
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1905 "../src/Photo.vala"
	self = (Photo*) base;
#line 1906 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1906 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1906 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1906 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1906 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1906 "../src/Photo.vala"
	result = _tmp3_;
#line 1906 "../src/Photo.vala"
	return result;
#line 14982 "Photo.c"
}

GFile*
photo_get_editable_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1909 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1910 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1910 "../src/Photo.vala"
	reader = _tmp0_;
#line 1912 "../src/Photo.vala"
	_tmp2_ = reader;
#line 1912 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 15003 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_;
#line 1912 "../src/Photo.vala"
		_tmp3_ = reader;
#line 1912 "../src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp3_);
#line 1912 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1912 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 15014 "Photo.c"
	} else {
#line 1912 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1912 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 15020 "Photo.c"
	}
#line 1912 "../src/Photo.vala"
	result = _tmp1_;
#line 1912 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1912 "../src/Photo.vala"
	return result;
#line 15028 "Photo.c"
}

GeeCollection*
photo_get_raw_developer_files (Photo* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1915 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1916 "../src/Photo.vala"
	if (photo_get_master_file_format (self) != PHOTO_FILE_FORMAT_RAW) {
#line 1917 "../src/Photo.vala"
		result = NULL;
#line 1917 "../src/Photo.vala"
		return result;
#line 15046 "Photo.c"
	}
#line 1920 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1920 "../src/Photo.vala"
	ret = _tmp0_;
#line 15052 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 1921 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 1921 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15059 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp2_;
				GeeCollection* _tmp3_;
				GeeCollection* _tmp4_;
				GeeCollection* _tmp5_;
				GeeIterator* _tmp6_;
				GeeIterator* _tmp7_;
#line 1922 "../src/Photo.vala"
				_tmp2_ = self->priv->developments;
#line 1922 "../src/Photo.vala"
				_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 1922 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 1922 "../src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1922 "../src/Photo.vala"
				_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 1922 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 1922 "../src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 1922 "../src/Photo.vala"
				_row_it = _tmp7_;
#line 1922 "../src/Photo.vala"
				while (TRUE) {
#line 15087 "Photo.c"
					GeeIterator* _tmp8_;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp9_;
					gpointer _tmp10_;
					GeeArrayList* _tmp11_;
					BackingPhotoRow* _tmp12_;
					const gchar* _tmp13_;
					GFile* _tmp14_;
					GFile* _tmp15_;
#line 1922 "../src/Photo.vala"
					_tmp8_ = _row_it;
#line 1922 "../src/Photo.vala"
					if (!gee_iterator_next (_tmp8_)) {
#line 1922 "../src/Photo.vala"
						break;
#line 15103 "Photo.c"
					}
#line 1922 "../src/Photo.vala"
					_tmp9_ = _row_it;
#line 1922 "../src/Photo.vala"
					_tmp10_ = gee_iterator_get (_tmp9_);
#line 1922 "../src/Photo.vala"
					row = (BackingPhotoRow*) _tmp10_;
#line 1923 "../src/Photo.vala"
					_tmp11_ = ret;
#line 1923 "../src/Photo.vala"
					_tmp12_ = row;
#line 1923 "../src/Photo.vala"
					_tmp13_ = _tmp12_->filepath;
#line 1923 "../src/Photo.vala"
					_tmp14_ = g_file_new_for_path (_tmp13_);
#line 1923 "../src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 1923 "../src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 1923 "../src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 1922 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 15127 "Photo.c"
				}
#line 1922 "../src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 15131 "Photo.c"
			}
		}
		__finally149:
		{
			PhotoRow* _tmp16_;
#line 1921 "../src/Photo.vala"
			_tmp16_ = self->row;
#line 1921 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15141 "Photo.c"
		}
#line 1921 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1921 "../src/Photo.vala"
			_g_object_unref0 (ret);
#line 1921 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1921 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 1921 "../src/Photo.vala"
			return NULL;
#line 15153 "Photo.c"
		}
	}
#line 1926 "../src/Photo.vala"
	result = (GeeCollection*) ret;
#line 1926 "../src/Photo.vala"
	return result;
#line 15160 "Photo.c"
}

GFile*
photo_get_source_file (Photo* self)
{
	GFile* result = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1929 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1930 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1930 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1930 "../src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1930 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1930 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1930 "../src/Photo.vala"
	result = _tmp3_;
#line 1930 "../src/Photo.vala"
	return result;
#line 15187 "Photo.c"
}

PhotoFileFormat
photo_get_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 1933 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15197 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1934 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1934 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15204 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1935 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1935 "../src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1935 "../src/Photo.vala"
			result = _tmp2_;
#line 15214 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1934 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1934 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15221 "Photo.c"
			}
#line 1935 "../src/Photo.vala"
			return result;
#line 15225 "Photo.c"
		}
		__finally150:
		{
			PhotoRow* _tmp4_;
#line 1934 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1934 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15234 "Photo.c"
		}
#line 1934 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1934 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1934 "../src/Photo.vala"
		return 0;
#line 15242 "Photo.c"
	}
}

PhotoFileFormat
photo_get_best_export_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_;
#line 1939 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1940 "../src/Photo.vala"
	file_format = photo_get_file_format (self);
#line 1941 "../src/Photo.vala"
	_tmp0_ = file_format;
#line 1941 "../src/Photo.vala"
	if (!photo_file_format_can_write (_tmp0_)) {
#line 1942 "../src/Photo.vala"
		file_format = photo_file_format_get_system_default_format ();
#line 15262 "Photo.c"
	}
#line 1945 "../src/Photo.vala"
	result = file_format;
#line 1945 "../src/Photo.vala"
	return result;
#line 15268 "Photo.c"
}

PhotoFileFormat
photo_get_master_file_format (Photo* self)
{
	PhotoFileFormat result = 0;
	GError* _inner_error0_ = NULL;
#line 1948 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15278 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1949 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1949 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15285 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 1950 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1950 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1950 "../src/Photo.vala"
			result = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 15295 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1949 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1949 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15302 "Photo.c"
			}
#line 1950 "../src/Photo.vala"
			return result;
#line 15306 "Photo.c"
		}
		__finally151:
		{
			PhotoRow* _tmp4_;
#line 1949 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1949 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15315 "Photo.c"
		}
#line 1949 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1949 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1949 "../src/Photo.vala"
		return 0;
#line 15323 "Photo.c"
	}
}

static time_t
photo_real_get_timestamp (MediaSource* base)
{
	Photo * self;
	time_t result = 0;
	GError* _inner_error0_ = NULL;
#line 1954 "../src/Photo.vala"
	self = (Photo*) base;
#line 15335 "Photo.c"
	{
		PhotoRow* _tmp0_;
		time_t _tmp4_ = 0;
#line 1955 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1955 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15343 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 1956 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1956 "../src/Photo.vala"
			result = _tmp1_->timestamp;
#line 15350 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1955 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1955 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15357 "Photo.c"
			}
#line 1956 "../src/Photo.vala"
			return result;
#line 15361 "Photo.c"
		}
		__finally152:
		{
			PhotoRow* _tmp3_;
#line 1955 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1955 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15370 "Photo.c"
		}
#line 1955 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1955 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1955 "../src/Photo.vala"
		return _tmp4_;
#line 15378 "Photo.c"
	}
}

void
photo_get_photo_id (Photo* self,
                    PhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 1960 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 15389 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1961 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1961 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15396 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoID _tmp2_;
#line 1962 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1962 "../src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1962 "../src/Photo.vala"
			*result = _tmp2_;
#line 15406 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1961 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1961 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15413 "Photo.c"
			}
#line 1962 "../src/Photo.vala"
			return;
#line 15417 "Photo.c"
		}
		__finally153:
		{
			PhotoRow* _tmp4_;
#line 1961 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1961 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15426 "Photo.c"
		}
#line 1961 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1961 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1961 "../src/Photo.vala"
		return;
#line 15434 "Photo.c"
	}
}

static inline void
photo_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Photo * self;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1967 "../src/Photo.vala"
	self = (Photo*) base;
#line 1968 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1968 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1968 "../src/Photo.vala"
	*result = _tmp1_;
#line 1968 "../src/Photo.vala"
	return;
#line 15455 "Photo.c"
}

inline gint64
photo_get_raw_event_id (Photo* self)
{
	gint64 result = 0LL;
	PhotoRow* _tmp0_;
	EventID _tmp1_;
#line 1972 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1973 "../src/Photo.vala"
	_tmp0_ = self->row;
#line 1973 "../src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1973 "../src/Photo.vala"
	result = _tmp1_.id;
#line 1973 "../src/Photo.vala"
	return result;
#line 15474 "Photo.c"
}

static void
photo_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 1976 "../src/Photo.vala"
	self = (Photo*) base;
#line 15485 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1977 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1977 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15492 "Photo.c"
		{
			PhotoRow* _tmp1_;
			ImportID _tmp2_;
#line 1978 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1978 "../src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1978 "../src/Photo.vala"
			*result = _tmp2_;
#line 15502 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1977 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1977 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15509 "Photo.c"
			}
#line 1978 "../src/Photo.vala"
			return;
#line 15513 "Photo.c"
		}
		__finally154:
		{
			PhotoRow* _tmp4_;
#line 1977 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1977 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15522 "Photo.c"
		}
#line 1977 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1977 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1977 "../src/Photo.vala"
		return;
#line 15530 "Photo.c"
	}
}

void
photo_get_editable_id (Photo* self,
                       BackingPhotoID* result)
{
	GError* _inner_error0_ = NULL;
#line 1982 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 15541 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1983 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1983 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15548 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoID _tmp2_;
#line 1984 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1984 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1984 "../src/Photo.vala"
			*result = _tmp2_;
#line 15558 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 1983 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 1983 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15565 "Photo.c"
			}
#line 1984 "../src/Photo.vala"
			return;
#line 15569 "Photo.c"
		}
		__finally155:
		{
			PhotoRow* _tmp4_;
#line 1983 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 1983 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15578 "Photo.c"
		}
#line 1983 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1983 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1983 "../src/Photo.vala"
		return;
#line 15586 "Photo.c"
	}
}

static gchar*
photo_real_get_master_md5 (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 1988 "../src/Photo.vala"
	self = (Photo*) base;
#line 15598 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 1989 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1989 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15605 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1990 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1990 "../src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1990 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1990 "../src/Photo.vala"
			result = _tmp3_;
#line 15618 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 1989 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 1989 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15625 "Photo.c"
			}
#line 1990 "../src/Photo.vala"
			return result;
#line 15629 "Photo.c"
		}
		__finally156:
		{
			PhotoRow* _tmp5_;
#line 1989 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 1989 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15638 "Photo.c"
		}
#line 1989 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1989 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1989 "../src/Photo.vala"
		return NULL;
#line 15646 "Photo.c"
	}
}

guint64
photo_get_flags (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 1996 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15657 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 1997 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 1997 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15665 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 1998 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 1998 "../src/Photo.vala"
			result = _tmp1_->flags;
#line 15672 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 1997 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 1997 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15679 "Photo.c"
			}
#line 1998 "../src/Photo.vala"
			return result;
#line 15683 "Photo.c"
		}
		__finally157:
		{
			PhotoRow* _tmp3_;
#line 1997 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 1997 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15692 "Photo.c"
		}
#line 1997 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1997 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 1997 "../src/Photo.vala"
		return _tmp4_;
#line 15700 "Photo.c"
	}
}

static void
photo_notify_flags_altered (Photo* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
#line 2002 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2003 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 2003 "../src/Photo.vala"
	alteration = _tmp0_;
#line 2004 "../src/Photo.vala"
	if (additional_alteration != NULL) {
#line 15719 "Photo.c"
		Alteration* _tmp1_;
		Alteration* _tmp2_;
#line 2005 "../src/Photo.vala"
		_tmp1_ = alteration;
#line 2005 "../src/Photo.vala"
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
#line 2005 "../src/Photo.vala"
		_alteration_unref0 (alteration);
#line 2005 "../src/Photo.vala"
		alteration = _tmp2_;
#line 15730 "Photo.c"
	}
#line 2008 "../src/Photo.vala"
	_tmp3_ = alteration;
#line 2008 "../src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp3_);
#line 2002 "../src/Photo.vala"
	_alteration_unref0 (alteration);
#line 15738 "Photo.c"
}

guint64
photo_replace_flags (Photo* self,
                     guint64 flags,
                     Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2011 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15751 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2013 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2013 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15758 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
#line 2014 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2014 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2014 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 2014 "../src/Photo.vala"
			committed = photo_table_replace_flags (_tmp2_, &_tmp3_, flags);
#line 2014 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2015 "../src/Photo.vala"
			if (committed) {
#line 15775 "Photo.c"
				PhotoRow* _tmp4_;
#line 2016 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2016 "../src/Photo.vala"
				_tmp4_->flags = flags;
#line 15781 "Photo.c"
			}
		}
		__finally158:
		{
			PhotoRow* _tmp5_;
#line 2013 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2013 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15791 "Photo.c"
		}
#line 2013 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15795 "Photo.c"
			guint64 _tmp6_ = 0ULL;
#line 2013 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2013 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2013 "../src/Photo.vala"
			return _tmp6_;
#line 15803 "Photo.c"
		}
	}
#line 2020 "../src/Photo.vala"
	if (committed) {
#line 2021 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 15810 "Photo.c"
	}
#line 2024 "../src/Photo.vala"
	result = flags;
#line 2024 "../src/Photo.vala"
	return result;
#line 15816 "Photo.c"
}

gboolean
photo_is_flag_set (Photo* self,
                   guint64 mask)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2027 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 15827 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2028 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2028 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15835 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2029 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2029 "../src/Photo.vala"
			result = media_source_internal_is_flag_set (_tmp1_->flags, mask);
#line 15842 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2028 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2028 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15849 "Photo.c"
			}
#line 2029 "../src/Photo.vala"
			return result;
#line 15853 "Photo.c"
		}
		__finally159:
		{
			PhotoRow* _tmp3_;
#line 2028 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2028 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15862 "Photo.c"
		}
#line 2028 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2028 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2028 "../src/Photo.vala"
		return _tmp4_;
#line 15870 "Photo.c"
	}
}

guint64
photo_add_flags (Photo* self,
                 guint64 mask,
                 Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2033 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2034 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2036 "../src/Photo.vala"
	committed = FALSE;
#line 15889 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2037 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2037 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15896 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2038 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2038 "../src/Photo.vala"
			flags = media_source_internal_add_flags (_tmp1_->flags, mask);
#line 2039 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2039 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 15908 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2040 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2040 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2040 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2040 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2040 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2041 "../src/Photo.vala"
				if (committed) {
#line 15924 "Photo.c"
					PhotoRow* _tmp6_;
#line 2042 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2042 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 15930 "Photo.c"
				}
			}
		}
		__finally160:
		{
			PhotoRow* _tmp7_;
#line 2037 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2037 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15941 "Photo.c"
		}
#line 2037 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15945 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2037 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2037 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2037 "../src/Photo.vala"
			return _tmp8_;
#line 15953 "Photo.c"
		}
	}
#line 2047 "../src/Photo.vala"
	if (committed) {
#line 2048 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 15960 "Photo.c"
	}
#line 2051 "../src/Photo.vala"
	result = flags;
#line 2051 "../src/Photo.vala"
	return result;
#line 15966 "Photo.c"
}

guint64
photo_remove_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2054 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2055 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2057 "../src/Photo.vala"
	committed = FALSE;
#line 15984 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2058 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2058 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15991 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2059 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2059 "../src/Photo.vala"
			flags = media_source_internal_remove_flags (_tmp1_->flags, mask);
#line 2060 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2060 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16003 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2061 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2061 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2061 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2061 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2061 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2062 "../src/Photo.vala"
				if (committed) {
#line 16019 "Photo.c"
					PhotoRow* _tmp6_;
#line 2063 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2063 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16025 "Photo.c"
				}
			}
		}
		__finally161:
		{
			PhotoRow* _tmp7_;
#line 2058 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2058 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16036 "Photo.c"
		}
#line 2058 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16040 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2058 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2058 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2058 "../src/Photo.vala"
			return _tmp8_;
#line 16048 "Photo.c"
		}
	}
#line 2068 "../src/Photo.vala"
	if (committed) {
#line 2069 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16055 "Photo.c"
	}
#line 2072 "../src/Photo.vala"
	result = flags;
#line 2072 "../src/Photo.vala"
	return result;
#line 16061 "Photo.c"
}

guint64
photo_add_remove_flags (Photo* self,
                        guint64 add,
                        guint64 remove,
                        Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2075 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2076 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2078 "../src/Photo.vala"
	committed = FALSE;
#line 16080 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2079 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2079 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16087 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2080 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2080 "../src/Photo.vala"
			flags = (_tmp1_->flags | add) & (~remove);
#line 2081 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2081 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16099 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2082 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2082 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2082 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2082 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2082 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2083 "../src/Photo.vala"
				if (committed) {
#line 16115 "Photo.c"
					PhotoRow* _tmp6_;
#line 2084 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2084 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16121 "Photo.c"
				}
			}
		}
		__finally162:
		{
			PhotoRow* _tmp7_;
#line 2079 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2079 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16132 "Photo.c"
		}
#line 2079 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16136 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2079 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2079 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2079 "../src/Photo.vala"
			return _tmp8_;
#line 16144 "Photo.c"
		}
	}
#line 2089 "../src/Photo.vala"
	if (committed) {
#line 2090 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16151 "Photo.c"
	}
#line 2093 "../src/Photo.vala"
	result = flags;
#line 2093 "../src/Photo.vala"
	return result;
#line 16157 "Photo.c"
}

void
photo_add_remove_many_flags (GeeCollection* add,
                             guint64 add_mask,
                             Alteration* additional_add_alteration,
                             GeeCollection* remove,
                             guint64 remove_mask,
                             Alteration* additional_remove_alteration,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2099 "../src/Photo.vala"
	database_table_begin_transaction ();
#line 2101 "../src/Photo.vala"
	if (add != NULL) {
#line 16174 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp0_;
#line 2102 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) add);
#line 2102 "../src/Photo.vala"
			_photo_it = _tmp0_;
#line 2102 "../src/Photo.vala"
			while (TRUE) {
#line 16184 "Photo.c"
				GeeIterator* _tmp1_;
				Photo* photo = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Photo* _tmp4_;
#line 2102 "../src/Photo.vala"
				_tmp1_ = _photo_it;
#line 2102 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 2102 "../src/Photo.vala"
					break;
#line 16196 "Photo.c"
				}
#line 2102 "../src/Photo.vala"
				_tmp2_ = _photo_it;
#line 2102 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 2102 "../src/Photo.vala"
				photo = (Photo*) _tmp3_;
#line 2103 "../src/Photo.vala"
				_tmp4_ = photo;
#line 2103 "../src/Photo.vala"
				photo_add_flags (_tmp4_, add_mask, additional_add_alteration);
#line 2102 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 16210 "Photo.c"
			}
#line 2102 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16214 "Photo.c"
		}
	}
#line 2107 "../src/Photo.vala"
	if (remove != NULL) {
#line 16219 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeIterator* _tmp5_;
#line 2108 "../src/Photo.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) remove);
#line 2108 "../src/Photo.vala"
			_photo_it = _tmp5_;
#line 2108 "../src/Photo.vala"
			while (TRUE) {
#line 16229 "Photo.c"
				GeeIterator* _tmp6_;
				Photo* photo = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				Photo* _tmp9_;
#line 2108 "../src/Photo.vala"
				_tmp6_ = _photo_it;
#line 2108 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 2108 "../src/Photo.vala"
					break;
#line 16241 "Photo.c"
				}
#line 2108 "../src/Photo.vala"
				_tmp7_ = _photo_it;
#line 2108 "../src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 2108 "../src/Photo.vala"
				photo = (Photo*) _tmp8_;
#line 2109 "../src/Photo.vala"
				_tmp9_ = photo;
#line 2109 "../src/Photo.vala"
				photo_remove_flags (_tmp9_, remove_mask, additional_remove_alteration);
#line 2108 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 16255 "Photo.c"
			}
#line 2108 "../src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16259 "Photo.c"
		}
	}
#line 2113 "../src/Photo.vala"
	database_table_commit_transaction (&_inner_error0_);
#line 2113 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2113 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2113 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2113 "../src/Photo.vala"
			return;
#line 16272 "Photo.c"
		} else {
#line 2113 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2113 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2113 "../src/Photo.vala"
			return;
#line 16280 "Photo.c"
		}
	}
}

guint64
photo_toggle_flags (Photo* self,
                    guint64 mask,
                    Alteration* additional_alteration)
{
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2116 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2117 "../src/Photo.vala"
	flags = (guint64) 0;
#line 2119 "../src/Photo.vala"
	committed = FALSE;
#line 16300 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2120 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2120 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16307 "Photo.c"
		{
			PhotoRow* _tmp1_;
			PhotoRow* _tmp2_;
#line 2121 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2121 "../src/Photo.vala"
			flags = _tmp1_->flags ^ mask;
#line 2122 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2122 "../src/Photo.vala"
			if (_tmp2_->flags != flags) {
#line 16319 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoID _tmp5_ = {0};
#line 2123 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2123 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2123 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp5_);
#line 2123 "../src/Photo.vala"
				committed = photo_table_replace_flags (_tmp4_, &_tmp5_, flags);
#line 2123 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2124 "../src/Photo.vala"
				if (committed) {
#line 16335 "Photo.c"
					PhotoRow* _tmp6_;
#line 2125 "../src/Photo.vala"
					_tmp6_ = self->row;
#line 2125 "../src/Photo.vala"
					_tmp6_->flags = flags;
#line 16341 "Photo.c"
				}
			}
		}
		__finally163:
		{
			PhotoRow* _tmp7_;
#line 2120 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2120 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16352 "Photo.c"
		}
#line 2120 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16356 "Photo.c"
			guint64 _tmp8_ = 0ULL;
#line 2120 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2120 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2120 "../src/Photo.vala"
			return _tmp8_;
#line 16364 "Photo.c"
		}
	}
#line 2130 "../src/Photo.vala"
	if (committed) {
#line 2131 "../src/Photo.vala"
		photo_notify_flags_altered (self, additional_alteration);
#line 16371 "Photo.c"
	}
#line 2134 "../src/Photo.vala"
	result = flags;
#line 2134 "../src/Photo.vala"
	return result;
#line 16377 "Photo.c"
}

gboolean
photo_is_master_metadata_dirty (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2137 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16387 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2138 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2138 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16395 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2139 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2139 "../src/Photo.vala"
			result = _tmp1_->metadata_dirty;
#line 16402 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2138 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2138 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16409 "Photo.c"
			}
#line 2139 "../src/Photo.vala"
			return result;
#line 16413 "Photo.c"
		}
		__finally164:
		{
			PhotoRow* _tmp3_;
#line 2138 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2138 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16422 "Photo.c"
		}
#line 2138 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2138 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2138 "../src/Photo.vala"
		return _tmp4_;
#line 16430 "Photo.c"
	}
}

void
photo_set_master_metadata_dirty (Photo* self,
                                 gboolean dirty,
                                 GError** error)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2143 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2144 "../src/Photo.vala"
	committed = FALSE;
#line 16445 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2145 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2145 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16452 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2146 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2146 "../src/Photo.vala"
			if (_tmp1_->metadata_dirty != dirty) {
#line 16459 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
				PhotoRow* _tmp5_;
#line 2147 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2147 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2147 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2147 "../src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp3_, &_tmp4_, dirty, &_inner_error0_);
#line 2147 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2147 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16476 "Photo.c"
					goto __finally165;
				}
#line 2148 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2148 "../src/Photo.vala"
				_tmp5_->metadata_dirty = dirty;
#line 2149 "../src/Photo.vala"
				committed = TRUE;
#line 16485 "Photo.c"
			}
		}
		__finally165:
		{
			GError* _inner_error1_ = NULL;
			PhotoRow* _tmp6_;
#line 2145 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2145 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16496 "Photo.c"
		}
#line 2145 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2145 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2145 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 2145 "../src/Photo.vala"
				return;
#line 16506 "Photo.c"
			} else {
#line 2145 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2145 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2145 "../src/Photo.vala"
				return;
#line 16514 "Photo.c"
			}
		}
	}
#line 2153 "../src/Photo.vala"
	if (committed) {
#line 16520 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2154 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "master-dirty");
#line 2154 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2154 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp8_);
#line 2154 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 16531 "Photo.c"
	}
}

gboolean
photo_is_enhanced (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2158 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16542 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 2159 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2159 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16550 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2160 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2160 "../src/Photo.vala"
			result = _tmp1_->enhanced;
#line 16557 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2159 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2159 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16564 "Photo.c"
			}
#line 2160 "../src/Photo.vala"
			return result;
#line 16568 "Photo.c"
		}
		__finally166:
		{
			PhotoRow* _tmp3_;
#line 2159 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2159 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16577 "Photo.c"
		}
#line 2159 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2159 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2159 "../src/Photo.vala"
		return _tmp4_;
#line 16585 "Photo.c"
	}
}

void
photo_set_enhanced (Photo* self,
                    gboolean enhanced)
{
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2164 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2165 "../src/Photo.vala"
	committed = FALSE;
#line 16599 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2166 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2166 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16606 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 2167 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2167 "../src/Photo.vala"
			if (_tmp1_->enhanced != enhanced) {
#line 16613 "Photo.c"
				PhotoTable* _tmp2_;
				PhotoTable* _tmp3_;
				PhotoID _tmp4_ = {0};
#line 2168 "../src/Photo.vala"
				_tmp2_ = photo_table_get_instance ();
#line 2168 "../src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 2168 "../src/Photo.vala"
				photo_get_photo_id (self, &_tmp4_);
#line 2168 "../src/Photo.vala"
				committed = photo_table_set_enhanced (_tmp3_, &_tmp4_, enhanced);
#line 2168 "../src/Photo.vala"
				_database_table_unref0 (_tmp3_);
#line 2169 "../src/Photo.vala"
				if (committed) {
#line 16629 "Photo.c"
					PhotoRow* _tmp5_;
#line 2170 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2170 "../src/Photo.vala"
					_tmp5_->enhanced = enhanced;
#line 16635 "Photo.c"
				}
			}
		}
		__finally167:
		{
			PhotoRow* _tmp6_;
#line 2166 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2166 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16646 "Photo.c"
		}
#line 2166 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2166 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2166 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2166 "../src/Photo.vala"
			return;
#line 16656 "Photo.c"
		}
	}
#line 2175 "../src/Photo.vala"
	if (committed) {
#line 16661 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2176 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "enhanced");
#line 2176 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2176 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp8_);
#line 2176 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 16672 "Photo.c"
	}
}

static void
photo_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Photo * self;
	GError* _inner_error0_ = NULL;
#line 2180 "../src/Photo.vala"
	self = (Photo*) base;
#line 16685 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 2185 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2185 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2185 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2185 "../src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
#line 2185 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2185 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2185 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 16704 "Photo.c"
				goto __catch168_database_error;
			}
#line 2185 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2185 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2185 "../src/Photo.vala"
			return;
#line 16713 "Photo.c"
		}
		{
			PhotoRow* _tmp3_;
#line 2186 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2186 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 16721 "Photo.c"
			{
				PhotoRow* _tmp4_;
				gchar* _tmp5_;
#line 2187 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2187 "../src/Photo.vala"
				_tmp5_ = g_strdup (backlinks);
#line 2187 "../src/Photo.vala"
				_g_free0 (_tmp4_->backlinks);
#line 2187 "../src/Photo.vala"
				_tmp4_->backlinks = _tmp5_;
#line 16733 "Photo.c"
			}
			__finally169:
			{
				PhotoRow* _tmp6_;
#line 2186 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2186 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16742 "Photo.c"
			}
#line 2186 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2186 "../src/Photo.vala"
				if (_inner_error0_->domain == DATABASE_ERROR) {
#line 16748 "Photo.c"
					goto __catch168_database_error;
				}
#line 2186 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2186 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2186 "../src/Photo.vala"
				return;
#line 16757 "Photo.c"
			}
		}
	}
	goto __finally168;
	__catch168_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 2184 "../src/Photo.vala"
		err = _inner_error0_;
#line 2184 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2190 "../src/Photo.vala"
		_tmp7_ = data_object_to_string ((DataObject*) self);
#line 2190 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2190 "../src/Photo.vala"
		_tmp9_ = err;
#line 2190 "../src/Photo.vala"
		_tmp10_ = _tmp9_->message;
#line 2190 "../src/Photo.vala"
		g_warning ("Photo.vala:2190: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
#line 2190 "../src/Photo.vala"
		_g_free0 (_tmp8_);
#line 2184 "../src/Photo.vala"
		_g_error_free0 (err);
#line 16787 "Photo.c"
	}
	__finally168:
#line 2184 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2184 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2184 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2184 "../src/Photo.vala"
		return;
#line 16798 "Photo.c"
	}
}

static gboolean
photo_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Photo * self;
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2198 "../src/Photo.vala"
	self = (Photo*) base;
#line 2198 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 16813 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp11_ = FALSE;
#line 2199 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2199 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16821 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
#line 2200 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2200 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2200 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2200 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2200 "../src/Photo.vala"
			_tmp5_ = *event_id;
#line 2200 "../src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2200 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2200 "../src/Photo.vala"
			committed = _tmp6_;
#line 2202 "../src/Photo.vala"
			if (committed) {
#line 16848 "Photo.c"
				PhotoRow* _tmp7_;
				EventID _tmp8_;
#line 2203 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2203 "../src/Photo.vala"
				_tmp8_ = *event_id;
#line 2203 "../src/Photo.vala"
				_tmp7_->event_id = _tmp8_;
#line 16857 "Photo.c"
			}
#line 2206 "../src/Photo.vala"
			result = committed;
#line 16861 "Photo.c"
			{
				PhotoRow* _tmp9_;
#line 2199 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2199 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16868 "Photo.c"
			}
#line 2206 "../src/Photo.vala"
			return result;
#line 16872 "Photo.c"
		}
		__finally170:
		{
			PhotoRow* _tmp10_;
#line 2199 "../src/Photo.vala"
			_tmp10_ = self->row;
#line 2199 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16881 "Photo.c"
		}
#line 2199 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2199 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2199 "../src/Photo.vala"
		return _tmp11_;
#line 16889 "Photo.c"
	}
}

static gchar*
photo_real_to_string (DataObject* base)
{
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	PhotoID _tmp9_ = {0};
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileReader* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
#line 2210 "../src/Photo.vala"
	self = (Photo*) base;
#line 2212 "../src/Photo.vala"
	if (!photo_is_master_baseline (self)) {
#line 16912 "Photo.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 2212 "../src/Photo.vala"
		_tmp1_ = photo_get_actual_file (self);
#line 2212 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2212 "../src/Photo.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 2212 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2212 "../src/Photo.vala"
		_tmp5_ = g_strconcat (" (", _tmp4_, NULL);
#line 2212 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2212 "../src/Photo.vala"
		_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2212 "../src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2212 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 16944 "Photo.c"
	} else {
		gchar* _tmp8_;
#line 2212 "../src/Photo.vala"
		_tmp8_ = g_strdup ("");
#line 2212 "../src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2212 "../src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 16953 "Photo.c"
	}
#line 2211 "../src/Photo.vala"
	photo_get_photo_id (self, &_tmp9_);
#line 2211 "../src/Photo.vala"
	_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp9_.id);
#line 2211 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2211 "../src/Photo.vala"
	_tmp12_ = photo_get_master_reader (self);
#line 2211 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2211 "../src/Photo.vala"
	_tmp14_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp13_);
#line 2211 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2211 "../src/Photo.vala"
	_tmp16_ = g_strdup_printf ("[%s] %s%s", _tmp11_, _tmp15_, _tmp0_);
#line 2211 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 2211 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp13_);
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 2211 "../src/Photo.vala"
	result = _tmp17_;
#line 2211 "../src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2211 "../src/Photo.vala"
	return result;
#line 16985 "Photo.c"
}

static gboolean
photo_real_equals (DataSource* base,
                   DataSource* source)
{
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
#line 2215 "../src/Photo.vala"
	self = (Photo*) base;
#line 2217 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_PHOTO) ? ((Photo*) source) : NULL);
#line 2217 "../src/Photo.vala"
	photo = _tmp0_;
#line 2218 "../src/Photo.vala"
	_tmp1_ = photo;
#line 2218 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 17007 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp2_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp3_;
		PhotoID _tmp4_ = {0};
		gboolean _tmp5_ = FALSE;
		Photo* _tmp6_;
#line 2219 "../src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2219 "../src/Photo.vala"
		photo_id = _tmp2_;
#line 2220 "../src/Photo.vala"
		_tmp3_ = photo;
#line 2220 "../src/Photo.vala"
		photo_get_photo_id (_tmp3_, &_tmp4_);
#line 2220 "../src/Photo.vala"
		other_photo_id = _tmp4_;
#line 2222 "../src/Photo.vala"
		_tmp6_ = photo;
#line 2222 "../src/Photo.vala"
		if (self != _tmp6_) {
#line 17029 "Photo.c"
			PhotoID _tmp7_;
#line 2222 "../src/Photo.vala"
			_tmp7_ = photo_id;
#line 2222 "../src/Photo.vala"
			_tmp5_ = _tmp7_.id != PHOTO_ID_INVALID;
#line 17035 "Photo.c"
		} else {
#line 2222 "../src/Photo.vala"
			_tmp5_ = FALSE;
#line 17039 "Photo.c"
		}
#line 2222 "../src/Photo.vala"
		if (_tmp5_) {
#line 17043 "Photo.c"
			PhotoID _tmp8_;
			PhotoID _tmp9_;
#line 2223 "../src/Photo.vala"
			_tmp8_ = photo_id;
#line 2223 "../src/Photo.vala"
			_tmp9_ = other_photo_id;
#line 2223 "../src/Photo.vala"
			_vala_assert (_tmp8_.id != _tmp9_.id, "photo_id.id != other_photo_id.id");
#line 17052 "Photo.c"
		}
	}
#line 2227 "../src/Photo.vala"
	result = DATA_SOURCE_CLASS (photo_parent_class)->equals ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), source);
#line 2227 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 2227 "../src/Photo.vala"
	return result;
#line 17061 "Photo.c"
}

static void
photo_file_exif_updated (Photo* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_;
	DetectedPhotoInformation* _tmp15_;
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 2231 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2232 "../src/Photo.vala"
	_tmp0_ = media_source_get_file ((MediaSource*) self);
#line 2232 "../src/Photo.vala"
	file = _tmp0_;
#line 2234 "../src/Photo.vala"
	info = NULL;
#line 17088 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
#line 2236 "../src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 2236 "../src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2236 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17099 "Photo.c"
			goto __catch171_g_error;
		}
#line 2236 "../src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2236 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 2236 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2236 "../src/Photo.vala"
		info = _tmp3_;
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 17112 "Photo.c"
	}
	goto __finally171;
	__catch171_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 2235 "../src/Photo.vala"
		err = _inner_error0_;
#line 2235 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2239 "../src/Photo.vala"
		_tmp4_ = data_object_to_string ((DataObject*) self);
#line 2239 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2239 "../src/Photo.vala"
		_tmp6_ = err->message;
#line 2239 "../src/Photo.vala"
		g_error ("Photo.vala:2239: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2239 "../src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2235 "../src/Photo.vala"
		_g_error_free0 (err);
#line 17137 "Photo.c"
	}
	__finally171:
#line 2235 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2235 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2235 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2235 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2235 "../src/Photo.vala"
		return;
#line 17152 "Photo.c"
	}
#line 2242 "../src/Photo.vala"
	_tmp7_ = info;
#line 2242 "../src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2242 "../src/Photo.vala"
	timestamp = _tmp8_;
#line 2245 "../src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2245 "../src/Photo.vala"
	interrogator = _tmp9_;
#line 17164 "Photo.c"
	{
#line 2247 "../src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error0_);
#line 2247 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17170 "Photo.c"
			goto __catch172_g_error;
		}
	}
	goto __finally172;
	__catch172_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 2246 "../src/Photo.vala"
		err = _inner_error0_;
#line 2246 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2249 "../src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2249 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2249 "../src/Photo.vala"
		_tmp12_ = err;
#line 2249 "../src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2249 "../src/Photo.vala"
		g_warning ("Photo.vala:2249: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2249 "../src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2246 "../src/Photo.vala"
		_g_error_free0 (err);
#line 17200 "Photo.c"
	}
	__finally172:
#line 2246 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2246 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2246 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2246 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2246 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2246 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2246 "../src/Photo.vala"
		return;
#line 17217 "Photo.c"
	}
#line 2252 "../src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2252 "../src/Photo.vala"
	detected = _tmp14_;
#line 2253 "../src/Photo.vala"
	_tmp15_ = detected;
#line 2253 "../src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 17227 "Photo.c"
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 2254 "../src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2254 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2254 "../src/Photo.vala"
		g_critical ("Photo.vala:2254: file_exif_updated: %s no longer an image", _tmp17_);
#line 2254 "../src/Photo.vala"
		_g_free0 (_tmp17_);
#line 2256 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2256 "../src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2256 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 2256 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 2256 "../src/Photo.vala"
		return;
#line 17248 "Photo.c"
	}
	{
		PhotoRow* _tmp18_;
#line 2260 "../src/Photo.vala"
		_tmp18_ = self->row;
#line 2260 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17256 "Photo.c"
		{
			PhotoTable* _tmp19_;
			PhotoTable* _tmp20_;
			PhotoID _tmp21_ = {0};
			GFileInfo* _tmp22_;
			GTimeVal _tmp23_;
			DetectedPhotoInformation* _tmp24_;
			const gchar* _tmp25_;
			DetectedPhotoInformation* _tmp26_;
			const gchar* _tmp27_;
			DetectedPhotoInformation* _tmp28_;
			const gchar* _tmp29_;
			PhotoRow* _tmp30_;
#line 2261 "../src/Photo.vala"
			_tmp19_ = photo_table_get_instance ();
#line 2261 "../src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2261 "../src/Photo.vala"
			photo_get_photo_id (self, &_tmp21_);
#line 2261 "../src/Photo.vala"
			_tmp22_ = info;
#line 2261 "../src/Photo.vala"
			_tmp23_ = timestamp;
#line 2261 "../src/Photo.vala"
			_tmp24_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp25_ = _tmp24_->md5;
#line 2261 "../src/Photo.vala"
			_tmp26_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp27_ = _tmp26_->exif_md5;
#line 2261 "../src/Photo.vala"
			_tmp28_ = detected;
#line 2261 "../src/Photo.vala"
			_tmp29_ = _tmp28_->thumbnail_md5;
#line 2261 "../src/Photo.vala"
			_tmp30_ = self->row;
#line 2261 "../src/Photo.vala"
			success = photo_table_master_exif_updated (_tmp20_, &_tmp21_, g_file_info_get_size (_tmp22_), _tmp23_.tv_sec, _tmp25_, _tmp27_, _tmp29_, _tmp30_);
#line 2261 "../src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 17298 "Photo.c"
		}
		__finally173:
		{
			PhotoRow* _tmp31_;
#line 2260 "../src/Photo.vala"
			_tmp31_ = self->row;
#line 2260 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17307 "Photo.c"
		}
#line 2260 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2260 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2260 "../src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2260 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 2260 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 2260 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2260 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2260 "../src/Photo.vala"
			return;
#line 17325 "Photo.c"
		}
	}
#line 2265 "../src/Photo.vala"
	if (success) {
#line 17330 "Photo.c"
		Alteration* _tmp32_;
		Alteration* _tmp33_;
#line 2266 "../src/Photo.vala"
		_tmp32_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2266 "../src/Photo.vala"
		_tmp33_ = _tmp32_;
#line 2266 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp33_);
#line 2266 "../src/Photo.vala"
		_alteration_unref0 (_tmp33_);
#line 17341 "Photo.c"
	}
#line 2231 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2231 "../src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2231 "../src/Photo.vala"
	_g_object_unref0 (info);
#line 2231 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 17351 "Photo.c"
}

static guint64
photo_real_get_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2272 "../src/Photo.vala"
	self = (Photo*) base;
#line 17362 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2273 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2273 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17370 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2274 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2274 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 17377 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2273 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2273 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17384 "Photo.c"
			}
#line 2274 "../src/Photo.vala"
			return result;
#line 17388 "Photo.c"
		}
		__finally174:
		{
			PhotoRow* _tmp3_;
#line 2273 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2273 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17397 "Photo.c"
		}
#line 2273 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2273 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2273 "../src/Photo.vala"
		return _tmp4_;
#line 17405 "Photo.c"
	}
}

static guint64
photo_real_get_master_filesize (MediaSource* base)
{
	Photo * self;
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2278 "../src/Photo.vala"
	self = (Photo*) base;
#line 17417 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp5_ = 0ULL;
#line 2279 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2279 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17425 "Photo.c"
		{
			PhotoRow* _tmp1_;
			BackingPhotoRow* _tmp2_;
#line 2280 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2280 "../src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2280 "../src/Photo.vala"
			result = (guint64) _tmp2_->filesize;
#line 17435 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2279 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2279 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17442 "Photo.c"
			}
#line 2280 "../src/Photo.vala"
			return result;
#line 17446 "Photo.c"
		}
		__finally175:
		{
			PhotoRow* _tmp4_;
#line 2279 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2279 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17455 "Photo.c"
		}
#line 2279 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2279 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2279 "../src/Photo.vala"
		return _tmp5_;
#line 17463 "Photo.c"
	}
}

guint64
photo_get_editable_filesize (Photo* self)
{
	guint64 result = 0ULL;
	GError* _inner_error0_ = NULL;
#line 2284 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 17474 "Photo.c"
	{
		PhotoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
#line 2285 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2285 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17482 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
#line 2286 "../src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2286 "../src/Photo.vala"
			result = (guint64) _tmp1_->filesize;
#line 17489 "Photo.c"
			{
				PhotoRow* _tmp2_;
#line 2285 "../src/Photo.vala"
				_tmp2_ = self->row;
#line 2285 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17496 "Photo.c"
			}
#line 2286 "../src/Photo.vala"
			return result;
#line 17500 "Photo.c"
		}
		__finally176:
		{
			PhotoRow* _tmp3_;
#line 2285 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2285 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17509 "Photo.c"
		}
#line 2285 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2285 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2285 "../src/Photo.vala"
		return _tmp4_;
#line 17517 "Photo.c"
	}
}

static time_t
photo_real_get_exposure_time (Dateable* base)
{
	Photo * self;
	time_t result = 0;
#line 2290 "../src/Photo.vala"
	self = (Photo*) base;
#line 2291 "../src/Photo.vala"
	result = self->priv->cached_exposure_time;
#line 2291 "../src/Photo.vala"
	return result;
#line 17532 "Photo.c"
}

static gchar*
photo_real_get_basename (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2294 "../src/Photo.vala"
	self = (Photo*) base;
#line 17543 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2295 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2295 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17550 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 2296 "../src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2296 "../src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2296 "../src/Photo.vala"
			result = _tmp2_;
#line 17560 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2295 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2295 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17567 "Photo.c"
			}
#line 2296 "../src/Photo.vala"
			return result;
#line 17571 "Photo.c"
		}
		__finally177:
		{
			PhotoRow* _tmp4_;
#line 2295 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2295 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17580 "Photo.c"
		}
#line 2295 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2295 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2295 "../src/Photo.vala"
		return NULL;
#line 17588 "Photo.c"
	}
}

static gchar*
photo_real_get_title (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2300 "../src/Photo.vala"
	self = (Photo*) base;
#line 17600 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2301 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2301 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17607 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2302 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2302 "../src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2302 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2302 "../src/Photo.vala"
			result = _tmp3_;
#line 17620 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2301 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2301 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17627 "Photo.c"
			}
#line 2302 "../src/Photo.vala"
			return result;
#line 17631 "Photo.c"
		}
		__finally178:
		{
			PhotoRow* _tmp5_;
#line 2301 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2301 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17640 "Photo.c"
		}
#line 2301 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2301 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2301 "../src/Photo.vala"
		return NULL;
#line 17648 "Photo.c"
	}
}

static gchar*
photo_real_get_comment (MediaSource* base)
{
	Photo * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2306 "../src/Photo.vala"
	self = (Photo*) base;
#line 17660 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2307 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2307 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17667 "Photo.c"
		{
			PhotoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 2308 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2308 "../src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2308 "../src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2308 "../src/Photo.vala"
			result = _tmp3_;
#line 17680 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2307 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2307 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17687 "Photo.c"
			}
#line 2308 "../src/Photo.vala"
			return result;
#line 17691 "Photo.c"
		}
		__finally179:
		{
			PhotoRow* _tmp5_;
#line 2307 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2307 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17700 "Photo.c"
		}
#line 2307 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2307 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2307 "../src/Photo.vala"
		return NULL;
#line 17708 "Photo.c"
	}
}

static void
photo_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Photo * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2312 "../src/Photo.vala"
	self = (Photo*) base;
#line 2313 "../src/Photo.vala"
	_tmp0_ = media_source_prep_title (title);
#line 2313 "../src/Photo.vala"
	new_title = _tmp0_;
#line 2315 "../src/Photo.vala"
	committed = FALSE;
#line 17729 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2316 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2316 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17736 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2317 "../src/Photo.vala"
			_tmp2_ = new_title;
#line 2317 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2317 "../src/Photo.vala"
			_tmp4_ = _tmp3_->title;
#line 2317 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 17754 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2316 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2316 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17761 "Photo.c"
				}
#line 2318 "../src/Photo.vala"
				_g_free0 (new_title);
#line 2318 "../src/Photo.vala"
				return;
#line 17767 "Photo.c"
			}
#line 2321 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2321 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2321 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2321 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2321 "../src/Photo.vala"
			_tmp10_ = new_title;
#line 2321 "../src/Photo.vala"
			committed = photo_table_set_title (_tmp7_, &_tmp9_, _tmp10_);
#line 2321 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2322 "../src/Photo.vala"
			if (committed) {
#line 17785 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2323 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2323 "../src/Photo.vala"
				_tmp12_ = new_title;
#line 2323 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2323 "../src/Photo.vala"
				_g_free0 (_tmp11_->title);
#line 2323 "../src/Photo.vala"
				_tmp11_->title = _tmp13_;
#line 17799 "Photo.c"
			}
		}
		__finally180:
		{
			PhotoRow* _tmp14_;
#line 2316 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2316 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17809 "Photo.c"
		}
#line 2316 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2316 "../src/Photo.vala"
			_g_free0 (new_title);
#line 2316 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2316 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2316 "../src/Photo.vala"
			return;
#line 17821 "Photo.c"
		}
	}
#line 2327 "../src/Photo.vala"
	if (committed) {
#line 17826 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2328 "../src/Photo.vala"
		_tmp15_ = alteration_new ("metadata", "name");
#line 2328 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2328 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp16_);
#line 2328 "../src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 17837 "Photo.c"
	}
#line 2312 "../src/Photo.vala"
	_g_free0 (new_title);
#line 17841 "Photo.c"
}

static gboolean
photo_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2332 "../src/Photo.vala"
	self = (Photo*) base;
#line 2333 "../src/Photo.vala"
	_tmp0_ = media_source_prep_comment (comment);
#line 2333 "../src/Photo.vala"
	new_comment = _tmp0_;
#line 2335 "../src/Photo.vala"
	committed = FALSE;
#line 17862 "Photo.c"
	{
		PhotoRow* _tmp1_;
#line 2336 "../src/Photo.vala"
		_tmp1_ = self->row;
#line 2336 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17869 "Photo.c"
		{
			const gchar* _tmp2_;
			PhotoRow* _tmp3_;
			const gchar* _tmp4_;
			PhotoTable* _tmp6_;
			PhotoTable* _tmp7_;
			PhotoRow* _tmp8_;
			PhotoID _tmp9_;
			const gchar* _tmp10_;
#line 2337 "../src/Photo.vala"
			_tmp2_ = new_comment;
#line 2337 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2337 "../src/Photo.vala"
			_tmp4_ = _tmp3_->comment;
#line 2337 "../src/Photo.vala"
			if (g_strcmp0 (_tmp2_, _tmp4_) == 0) {
#line 2338 "../src/Photo.vala"
				result = TRUE;
#line 17889 "Photo.c"
				{
					PhotoRow* _tmp5_;
#line 2336 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 2336 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17896 "Photo.c"
				}
#line 2338 "../src/Photo.vala"
				_g_free0 (new_comment);
#line 2338 "../src/Photo.vala"
				return result;
#line 17902 "Photo.c"
			}
#line 2341 "../src/Photo.vala"
			_tmp6_ = photo_table_get_instance ();
#line 2341 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2341 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2341 "../src/Photo.vala"
			_tmp9_ = _tmp8_->photo_id;
#line 2341 "../src/Photo.vala"
			_tmp10_ = new_comment;
#line 2341 "../src/Photo.vala"
			committed = photo_table_set_comment (_tmp7_, &_tmp9_, _tmp10_);
#line 2341 "../src/Photo.vala"
			_database_table_unref0 (_tmp7_);
#line 2342 "../src/Photo.vala"
			if (committed) {
#line 17920 "Photo.c"
				PhotoRow* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 2343 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2343 "../src/Photo.vala"
				_tmp12_ = new_comment;
#line 2343 "../src/Photo.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 2343 "../src/Photo.vala"
				_g_free0 (_tmp11_->comment);
#line 2343 "../src/Photo.vala"
				_tmp11_->comment = _tmp13_;
#line 17934 "Photo.c"
			}
		}
		__finally181:
		{
			PhotoRow* _tmp14_;
#line 2336 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2336 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17944 "Photo.c"
		}
#line 2336 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17948 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2336 "../src/Photo.vala"
			_g_free0 (new_comment);
#line 2336 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2336 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2336 "../src/Photo.vala"
			return _tmp15_;
#line 17958 "Photo.c"
		}
	}
#line 2347 "../src/Photo.vala"
	if (committed) {
#line 17963 "Photo.c"
		Alteration* _tmp16_;
		Alteration* _tmp17_;
#line 2348 "../src/Photo.vala"
		_tmp16_ = alteration_new ("metadata", "comment");
#line 2348 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2348 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp17_);
#line 2348 "../src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 17974 "Photo.c"
	}
#line 2351 "../src/Photo.vala"
	result = committed;
#line 2351 "../src/Photo.vala"
	_g_free0 (new_comment);
#line 2351 "../src/Photo.vala"
	return result;
#line 17982 "Photo.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 2361 "../src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 17990 "Photo.c"
}

void
photo_set_import_id (Photo* self,
                     ImportID* import_id)
{
	GError* dberr = NULL;
	GError* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 2354 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2354 "../src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2355 "../src/Photo.vala"
	dberr = NULL;
#line 18006 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2356 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2356 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18013 "Photo.c"
		{
			{
				PhotoTable* _tmp1_;
				PhotoTable* _tmp2_;
				PhotoRow* _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				PhotoRow* _tmp7_;
				ImportID _tmp8_;
#line 2358 "../src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2358 "../src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2358 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2358 "../src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2358 "../src/Photo.vala"
				_tmp5_ = *import_id;
#line 2358 "../src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 2358 "../src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2358 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2358 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 18041 "Photo.c"
						goto __catch183_database_error;
					}
					{
						PhotoRow* _tmp6_;
#line 2356 "../src/Photo.vala"
						_tmp6_ = self->row;
#line 2356 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18050 "Photo.c"
					}
#line 2358 "../src/Photo.vala"
					_g_error_free0 (dberr);
#line 2358 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2358 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 2358 "../src/Photo.vala"
					return;
#line 18060 "Photo.c"
				}
#line 2359 "../src/Photo.vala"
				_tmp7_ = self->row;
#line 2359 "../src/Photo.vala"
				_tmp8_ = *import_id;
#line 2359 "../src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 18068 "Photo.c"
			}
			goto __finally183;
			__catch183_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_;
				GError* _tmp10_;
#line 2357 "../src/Photo.vala"
				err = _inner_error0_;
#line 2357 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 2361 "../src/Photo.vala"
				_tmp9_ = err;
#line 2361 "../src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2361 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2361 "../src/Photo.vala"
				dberr = _tmp10_;
#line 2357 "../src/Photo.vala"
				_g_error_free0 (err);
#line 18090 "Photo.c"
			}
			__finally183:
#line 2357 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18095 "Photo.c"
				{
					PhotoRow* _tmp11_;
#line 2356 "../src/Photo.vala"
					_tmp11_ = self->row;
#line 2356 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18102 "Photo.c"
				}
#line 2357 "../src/Photo.vala"
				_g_error_free0 (dberr);
#line 2357 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2357 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2357 "../src/Photo.vala"
				return;
#line 18112 "Photo.c"
			}
		}
		__finally182:
		{
			PhotoRow* _tmp12_;
#line 2356 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2356 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18122 "Photo.c"
		}
#line 2356 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2356 "../src/Photo.vala"
			_g_error_free0 (dberr);
#line 2356 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2356 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2356 "../src/Photo.vala"
			return;
#line 18134 "Photo.c"
		}
	}
#line 2365 "../src/Photo.vala"
	_tmp13_ = dberr;
#line 2365 "../src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 18141 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2366 "../src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2366 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2366 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2366 "../src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 18152 "Photo.c"
	} else {
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 2368 "../src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2368 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2368 "../src/Photo.vala"
		_tmp18_ = dberr;
#line 2368 "../src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2368 "../src/Photo.vala"
		g_warning ("Photo.vala:2368: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2368 "../src/Photo.vala"
		_g_free0 (_tmp17_);
#line 18170 "Photo.c"
	}
#line 2354 "../src/Photo.vala"
	_g_error_free0 (dberr);
#line 18174 "Photo.c"
}

void
photo_set_title_persistent (Photo* self,
                            const gchar* title,
                            GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2372 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2373 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2373 "../src/Photo.vala"
	source = _tmp0_;
#line 2376 "../src/Photo.vala"
	_tmp1_ = source;
#line 2376 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 18206 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2377 "../src/Photo.vala"
		_tmp2_ = source;
#line 2377 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2377 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2377 "../src/Photo.vala"
		g_warning ("Photo.vala:2377: No photo file writer available for %s", _tmp4_);
#line 2377 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2379 "../src/Photo.vala"
		media_source_set_title ((MediaSource*) self, title);
#line 2381 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2381 "../src/Photo.vala"
		return;
#line 18226 "Photo.c"
	}
#line 2384 "../src/Photo.vala"
	_tmp5_ = source;
#line 2384 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2384 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2384 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2384 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2384 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2384 "../src/Photo.vala"
		return;
#line 18242 "Photo.c"
	}
#line 2385 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2385 "../src/Photo.vala"
	photo_metadata_set_title (_tmp7_, title, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2387 "../src/Photo.vala"
	_tmp8_ = source;
#line 2387 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2387 "../src/Photo.vala"
	writer = _tmp9_;
#line 2387 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2387 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2387 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2387 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2387 "../src/Photo.vala"
		return;
#line 18264 "Photo.c"
	}
#line 2388 "../src/Photo.vala"
	_tmp10_ = source;
#line 2388 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2388 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2388 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_title");
#line 2388 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 18276 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2390 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2390 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2390 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2390 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18288 "Photo.c"
			goto __finally184;
		}
	}
	__finally184:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2392 "../src/Photo.vala"
		_tmp15_ = source;
#line 2392 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2392 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2392 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2392 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 18308 "Photo.c"
	}
#line 2389 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2389 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2389 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2389 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2389 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2389 "../src/Photo.vala"
		return;
#line 18322 "Photo.c"
	}
#line 2395 "../src/Photo.vala"
	media_source_set_title ((MediaSource*) self, title);
#line 2397 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2372 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2372 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2372 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18334 "Photo.c"
}

void
photo_set_comment_persistent (Photo* self,
                              const gchar* comment,
                              GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp8_;
	PhotoFileMetadataWriter* _tmp9_;
	PhotoFileReader* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2400 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2401 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2401 "../src/Photo.vala"
	source = _tmp0_;
#line 2404 "../src/Photo.vala"
	_tmp1_ = source;
#line 2404 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 18366 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2405 "../src/Photo.vala"
		_tmp2_ = source;
#line 2405 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2405 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2405 "../src/Photo.vala"
		g_warning ("Photo.vala:2405: No photo file writer available for %s", _tmp4_);
#line 2405 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2407 "../src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, comment);
#line 2409 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2409 "../src/Photo.vala"
		return;
#line 18386 "Photo.c"
	}
#line 2412 "../src/Photo.vala"
	_tmp5_ = source;
#line 2412 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2412 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2412 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2412 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2412 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2412 "../src/Photo.vala"
		return;
#line 18402 "Photo.c"
	}
#line 2413 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2413 "../src/Photo.vala"
	photo_metadata_set_comment (_tmp7_, comment);
#line 2415 "../src/Photo.vala"
	_tmp8_ = source;
#line 2415 "../src/Photo.vala"
	_tmp9_ = photo_file_reader_create_metadata_writer (_tmp8_, &_inner_error0_);
#line 2415 "../src/Photo.vala"
	writer = _tmp9_;
#line 2415 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2415 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2415 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2415 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2415 "../src/Photo.vala"
		return;
#line 18424 "Photo.c"
	}
#line 2416 "../src/Photo.vala"
	_tmp10_ = source;
#line 2416 "../src/Photo.vala"
	_tmp11_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp10_);
#line 2416 "../src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 2416 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp12_, "Photo.set_persistent_comment");
#line 2416 "../src/Photo.vala"
	_g_object_unref0 (_tmp12_);
#line 18436 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp13_;
		PhotoMetadata* _tmp14_;
#line 2418 "../src/Photo.vala"
		_tmp13_ = writer;
#line 2418 "../src/Photo.vala"
		_tmp14_ = metadata;
#line 2418 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp13_, _tmp14_, &_inner_error0_);
#line 2418 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18448 "Photo.c"
			goto __finally185;
		}
	}
	__finally185:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 2420 "../src/Photo.vala"
		_tmp15_ = source;
#line 2420 "../src/Photo.vala"
		_tmp16_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp15_);
#line 2420 "../src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2420 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp17_);
#line 2420 "../src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 18468 "Photo.c"
	}
#line 2417 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2417 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2417 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2417 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2417 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2417 "../src/Photo.vala"
		return;
#line 18482 "Photo.c"
	}
#line 2423 "../src/Photo.vala"
	media_source_set_comment ((MediaSource*) self, comment);
#line 2425 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2400 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2400 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2400 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18494 "Photo.c"
}

static void
photo_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Photo * self;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2428 "../src/Photo.vala"
	self = (Photo*) base;
#line 18506 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2430 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2430 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18513 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
#line 2431 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2431 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2431 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2431 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2431 "../src/Photo.vala"
			committed = photo_table_set_exposure_time (_tmp2_, &_tmp4_, time);
#line 2431 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2432 "../src/Photo.vala"
			if (committed) {
#line 18533 "Photo.c"
				PhotoRow* _tmp5_;
#line 2433 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2433 "../src/Photo.vala"
				_tmp5_->exposure_time = time;
#line 2434 "../src/Photo.vala"
				self->priv->cached_exposure_time = time;
#line 18541 "Photo.c"
			}
		}
		__finally186:
		{
			PhotoRow* _tmp6_;
#line 2430 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2430 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18551 "Photo.c"
		}
#line 2430 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2430 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2430 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2430 "../src/Photo.vala"
			return;
#line 18561 "Photo.c"
		}
	}
#line 2438 "../src/Photo.vala"
	if (committed) {
#line 18566 "Photo.c"
		Alteration* _tmp7_;
		Alteration* _tmp8_;
#line 2439 "../src/Photo.vala"
		_tmp7_ = alteration_new ("metadata", "exposure-time");
#line 2439 "../src/Photo.vala"
		_tmp8_ = _tmp7_;
#line 2439 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp8_);
#line 2439 "../src/Photo.vala"
		_alteration_unref0 (_tmp8_);
#line 18577 "Photo.c"
	}
}

void
photo_set_exposure_time_persistent (Photo* self,
                                    time_t time,
                                    GError** error)
{
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp5_;
	PhotoMetadata* _tmp6_;
	PhotoMetadata* _tmp7_;
	MetadataDateTime* _tmp8_;
	MetadataDateTime* _tmp9_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp10_;
	PhotoFileMetadataWriter* _tmp11_;
	PhotoFileReader* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 2443 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2444 "../src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2444 "../src/Photo.vala"
	source = _tmp0_;
#line 2447 "../src/Photo.vala"
	_tmp1_ = source;
#line 2447 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 18612 "Photo.c"
		PhotoFileReader* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 2448 "../src/Photo.vala"
		_tmp2_ = source;
#line 2448 "../src/Photo.vala"
		_tmp3_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp2_);
#line 2448 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2448 "../src/Photo.vala"
		g_warning ("Photo.vala:2448: No photo file writer available for %s", _tmp4_);
#line 2448 "../src/Photo.vala"
		_g_free0 (_tmp4_);
#line 2450 "../src/Photo.vala"
		dateable_set_exposure_time ((Dateable*) self, time);
#line 2452 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2452 "../src/Photo.vala"
		return;
#line 18632 "Photo.c"
	}
#line 2455 "../src/Photo.vala"
	_tmp5_ = source;
#line 2455 "../src/Photo.vala"
	_tmp6_ = photo_file_reader_read_metadata (_tmp5_, &_inner_error0_);
#line 2455 "../src/Photo.vala"
	metadata = _tmp6_;
#line 2455 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2455 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2455 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2455 "../src/Photo.vala"
		return;
#line 18648 "Photo.c"
	}
#line 2456 "../src/Photo.vala"
	_tmp7_ = metadata;
#line 2456 "../src/Photo.vala"
	_tmp8_ = metadata_date_time_new (time);
#line 2456 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2456 "../src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp7_, _tmp9_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2456 "../src/Photo.vala"
	_metadata_date_time_unref0 (_tmp9_);
#line 2458 "../src/Photo.vala"
	_tmp10_ = source;
#line 2458 "../src/Photo.vala"
	_tmp11_ = photo_file_reader_create_metadata_writer (_tmp10_, &_inner_error0_);
#line 2458 "../src/Photo.vala"
	writer = _tmp11_;
#line 2458 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2458 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2458 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2458 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2458 "../src/Photo.vala"
		return;
#line 18676 "Photo.c"
	}
#line 2459 "../src/Photo.vala"
	_tmp12_ = source;
#line 2459 "../src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp12_);
#line 2459 "../src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 2459 "../src/Photo.vala"
	library_monitor_blacklist_file (_tmp14_, "Photo.set_exposure_time_persistent");
#line 2459 "../src/Photo.vala"
	_g_object_unref0 (_tmp14_);
#line 18688 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp15_;
		PhotoMetadata* _tmp16_;
#line 2461 "../src/Photo.vala"
		_tmp15_ = writer;
#line 2461 "../src/Photo.vala"
		_tmp16_ = metadata;
#line 2461 "../src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp15_, _tmp16_, &_inner_error0_);
#line 2461 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 18700 "Photo.c"
			goto __finally187;
		}
	}
	__finally187:
	{
		GError* _inner_error1_ = NULL;
		PhotoFileReader* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 2463 "../src/Photo.vala"
		_tmp17_ = source;
#line 2463 "../src/Photo.vala"
		_tmp18_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp17_);
#line 2463 "../src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 2463 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp19_);
#line 2463 "../src/Photo.vala"
		_g_object_unref0 (_tmp19_);
#line 18720 "Photo.c"
	}
#line 2460 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2460 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2460 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2460 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2460 "../src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2460 "../src/Photo.vala"
		return;
#line 18734 "Photo.c"
	}
#line 2466 "../src/Photo.vala"
	dateable_set_exposure_time ((Dateable*) self, time);
#line 2468 "../src/Photo.vala"
	photo_file_exif_updated (self);
#line 2443 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2443 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2443 "../src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18746 "Photo.c"
}

/**
     * Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options ()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void
photo_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
#line 2484 "../src/Photo.vala"
	self = (Photo*) base;
#line 2486 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2486 "../src/Photo.vala"
	returned_dims = _tmp0_;
#line 2489 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_ORIENTATION)) {
#line 18778 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp1_;
#line 2490 "../src/Photo.vala"
		ori_tmp = photo_get_orientation (self);
#line 2493 "../src/Photo.vala"
		_tmp1_ = ori_tmp;
#line 2493 "../src/Photo.vala"
		switch (_tmp1_) {
#line 2493 "../src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2493 "../src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2493 "../src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2493 "../src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 18795 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp2_;
				Dimensions _tmp3_;
#line 2499 "../src/Photo.vala"
				_tmp2_ = returned_dims;
#line 2499 "../src/Photo.vala"
				width_tmp = _tmp2_.width;
#line 2501 "../src/Photo.vala"
				_tmp3_ = returned_dims;
#line 2501 "../src/Photo.vala"
				returned_dims.width = _tmp3_.height;
#line 2502 "../src/Photo.vala"
				returned_dims.height = width_tmp;
#line 2503 "../src/Photo.vala"
				break;
#line 18812 "Photo.c"
			}
			default:
			{
#line 2507 "../src/Photo.vala"
				break;
#line 18818 "Photo.c"
			}
		}
	}
#line 2512 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 18824 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp4_ = 0.0;
		Dimensions _tmp5_;
		Dimensions _tmp6_;
		gdouble _tmp7_ = 0.0;
		gdouble _tmp8_ = 0.0;
#line 2514 "../src/Photo.vala"
		angle = 0.0;
#line 2516 "../src/Photo.vala"
		photo_get_straighten (self, &_tmp4_);
#line 2516 "../src/Photo.vala"
		angle = _tmp4_;
#line 2518 "../src/Photo.vala"
		_tmp5_ = returned_dims;
#line 2518 "../src/Photo.vala"
		_tmp6_ = returned_dims;
#line 2518 "../src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp5_.width, (gdouble) _tmp6_.height, angle, &_tmp7_, &_tmp8_);
#line 2518 "../src/Photo.vala"
		x_size = _tmp7_;
#line 2518 "../src/Photo.vala"
		y_size = _tmp8_;
#line 2520 "../src/Photo.vala"
		returned_dims.width = (gint) x_size;
#line 2521 "../src/Photo.vala"
		returned_dims.height = (gint) y_size;
#line 18853 "Photo.c"
	}
#line 2525 "../src/Photo.vala"
	if (photo_exception_allows (disallowed_steps, PHOTO_EXCEPTION_CROP)) {
#line 18857 "Photo.c"
		Box crop = {0};
		Box _tmp9_ = {0};
		gboolean _tmp10_;
#line 2527 "../src/Photo.vala"
		_tmp10_ = photo_get_crop (self, &_tmp9_, disallowed_steps);
#line 2527 "../src/Photo.vala"
		crop = _tmp9_;
#line 2527 "../src/Photo.vala"
		if (_tmp10_) {
#line 18867 "Photo.c"
			Dimensions _tmp11_ = {0};
#line 2528 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp11_);
#line 2528 "../src/Photo.vala"
			returned_dims = _tmp11_;
#line 18873 "Photo.c"
		}
	}
#line 2531 "../src/Photo.vala"
	*result = returned_dims;
#line 2531 "../src/Photo.vala"
	return;
#line 18880 "Photo.c"
}

static void
photo_locked_create_adjustments_from_data (Photo* self)
{
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
#line 2535 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2536 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2536 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2536 "../src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2538 "../src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2538 "../src/Photo.vala"
	map = _tmp1_;
#line 2539 "../src/Photo.vala"
	_tmp2_ = map;
#line 2539 "../src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 18908 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 2540 "../src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2540 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 18914 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 2542 "../src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2542 "../src/Photo.vala"
		_tmp5_ = map;
#line 2542 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 18924 "Photo.c"
	}
#line 2545 "../src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2545 "../src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2545 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2545 "../src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2535 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 18936 "Photo.c"
}

PixelTransformationBundle*
photo_get_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2549 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18946 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2550 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2550 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18953 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_;
#line 2551 "../src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2551 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2552 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18964 "Photo.c"
			}
#line 2555 "../src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2555 "../src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2555 "../src/Photo.vala"
			result = _tmp3_;
#line 18972 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2550 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2550 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18979 "Photo.c"
			}
#line 2555 "../src/Photo.vala"
			return result;
#line 18983 "Photo.c"
		}
		__finally188:
		{
			PhotoRow* _tmp5_;
#line 2550 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2550 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18992 "Photo.c"
		}
#line 2550 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2550 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2550 "../src/Photo.vala"
		return NULL;
#line 19000 "Photo.c"
	}
}

static PixelTransformationBundle*
photo_locked_original_color_adjustments (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* original_adjustments = NULL;
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* map = NULL;
	PhotoRow* _tmp1_;
	GeeHashMap* _tmp2_;
	KeyValueMap* _tmp10_;
#line 2560 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2561 "../src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2561 "../src/Photo.vala"
	original_adjustments = _tmp0_;
#line 2564 "../src/Photo.vala"
	_tmp1_ = self->row;
#line 2564 "../src/Photo.vala"
	_tmp2_ = _tmp1_->original_transforms;
#line 2564 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19026 "Photo.c"
		PhotoRow* _tmp3_;
		GeeHashMap* _tmp4_;
		gpointer _tmp5_;
		KeyValueMap* _tmp6_;
#line 2565 "../src/Photo.vala"
		_tmp3_ = self->row;
#line 2565 "../src/Photo.vala"
		_tmp4_ = _tmp3_->original_transforms;
#line 2565 "../src/Photo.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "adjustments");
#line 2565 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2565 "../src/Photo.vala"
		map = (KeyValueMap*) _tmp5_;
#line 2566 "../src/Photo.vala"
		_tmp6_ = map;
#line 2566 "../src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 19045 "Photo.c"
			KeyValueMap* _tmp7_;
			KeyValueMap* _tmp8_;
#line 2567 "../src/Photo.vala"
			_tmp7_ = map;
#line 2567 "../src/Photo.vala"
			_tmp8_ = key_value_map_copy (_tmp7_);
#line 2567 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2567 "../src/Photo.vala"
			map = _tmp8_;
#line 19056 "Photo.c"
		}
	} else {
		KeyValueMap* _tmp9_;
#line 2570 "../src/Photo.vala"
		_tmp9_ = key_value_map_new ("adjustments");
#line 2570 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2570 "../src/Photo.vala"
		map = _tmp9_;
#line 19066 "Photo.c"
	}
#line 2573 "../src/Photo.vala"
	_tmp10_ = map;
#line 2573 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 19072 "Photo.c"
		PixelTransformationBundle* _tmp11_;
#line 2574 "../src/Photo.vala"
		_tmp11_ = original_adjustments;
#line 2574 "../src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp11_);
#line 19078 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp12_;
		KeyValueMap* _tmp13_;
#line 2576 "../src/Photo.vala"
		_tmp12_ = original_adjustments;
#line 2576 "../src/Photo.vala"
		_tmp13_ = map;
#line 2576 "../src/Photo.vala"
		pixel_transformation_bundle_load (_tmp12_, _tmp13_);
#line 19088 "Photo.c"
	}
#line 2579 "../src/Photo.vala"
	result = original_adjustments;
#line 2579 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2579 "../src/Photo.vala"
	return result;
#line 19096 "Photo.c"
}

static KeyValueMap*
photo_get_color_adjustments_map (Photo* self)
{
	KeyValueMap* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2584 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19106 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2585 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2585 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19113 "Photo.c"
		{
			KeyValueMap* map = NULL;
			KeyValueMap* _tmp1_;
			KeyValueMap* _tmp2_;
#line 2586 "../src/Photo.vala"
			_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2586 "../src/Photo.vala"
			map = _tmp1_;
#line 2587 "../src/Photo.vala"
			_tmp2_ = map;
#line 2587 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 19126 "Photo.c"
				KeyValueMap* _tmp3_;
#line 2588 "../src/Photo.vala"
				_tmp3_ = key_value_map_new ("adjustments");
#line 2588 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2588 "../src/Photo.vala"
				map = _tmp3_;
#line 19134 "Photo.c"
			}
#line 2590 "../src/Photo.vala"
			result = map;
#line 19138 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2585 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2585 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19145 "Photo.c"
			}
#line 2590 "../src/Photo.vala"
			return result;
#line 19149 "Photo.c"
		}
		__finally189:
		{
			PhotoRow* _tmp5_;
#line 2585 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2585 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19158 "Photo.c"
		}
#line 2585 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2585 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2585 "../src/Photo.vala"
		return NULL;
#line 19166 "Photo.c"
	}
}

PixelTransformer*
photo_get_pixel_transformer (Photo* self)
{
	PixelTransformer* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2594 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19177 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2595 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2595 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19184 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_;
#line 2596 "../src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2596 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2597 "../src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19195 "Photo.c"
			}
#line 2600 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2600 "../src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2600 "../src/Photo.vala"
			result = _tmp3_;
#line 19203 "Photo.c"
			{
				PhotoRow* _tmp4_;
#line 2595 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2595 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19210 "Photo.c"
			}
#line 2600 "../src/Photo.vala"
			return result;
#line 19214 "Photo.c"
		}
		__finally190:
		{
			PhotoRow* _tmp5_;
#line 2595 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2595 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19223 "Photo.c"
		}
#line 2595 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2595 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2595 "../src/Photo.vala"
		return NULL;
#line 19231 "Photo.c"
	}
}

gboolean
photo_has_color_adjustments (Photo* self)
{
	gboolean result = FALSE;
#line 2604 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2605 "../src/Photo.vala"
	result = photo_has_transformation (self, "adjustments");
#line 2605 "../src/Photo.vala"
	return result;
#line 19245 "Photo.c"
}

PixelTransformation*
photo_get_color_adjustment (Photo* self,
                            PixelTransformationType type)
{
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformation* _tmp2_;
	PixelTransformation* _tmp3_;
#line 2608 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2609 "../src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2609 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2609 "../src/Photo.vala"
	_tmp2_ = pixel_transformation_bundle_get_transformation (_tmp1_, type);
#line 2609 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2609 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2609 "../src/Photo.vala"
	result = _tmp3_;
#line 2609 "../src/Photo.vala"
	return result;
#line 19273 "Photo.c"
}

void
photo_set_color_adjustments (Photo* self,
                             PixelTransformationBundle* new_adjustments)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp4_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2612 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2612 "../src/Photo.vala"
	g_return_if_fail (new_adjustments != NULL);
#line 2615 "../src/Photo.vala"
	photo_set_enhanced (self, FALSE);
#line 2616 "../src/Photo.vala"
	if (pixel_transformation_bundle_is_identity (new_adjustments)) {
#line 19292 "Photo.c"
		gboolean _result_ = FALSE;
		{
			PhotoRow* _tmp0_;
#line 2618 "../src/Photo.vala"
			_tmp0_ = self->row;
#line 2618 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 19300 "Photo.c"
			{
#line 2619 "../src/Photo.vala"
				_result_ = photo_remove_transformation (self, "adjustments");
#line 2620 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2620 "../src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2621 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2621 "../src/Photo.vala"
				self->priv->transformer = NULL;
#line 19312 "Photo.c"
			}
			__finally191:
			{
				PhotoRow* _tmp1_;
#line 2618 "../src/Photo.vala"
				_tmp1_ = self->row;
#line 2618 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19321 "Photo.c"
			}
#line 2618 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2618 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2618 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2618 "../src/Photo.vala"
				return;
#line 19331 "Photo.c"
			}
		}
#line 2624 "../src/Photo.vala"
		if (_result_) {
#line 19336 "Photo.c"
			Alteration* _tmp2_;
			Alteration* _tmp3_;
#line 2625 "../src/Photo.vala"
			_tmp2_ = alteration_new ("image", "color-adjustments");
#line 2625 "../src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 2625 "../src/Photo.vala"
			data_object_notify_altered ((DataObject*) self, _tmp3_);
#line 2625 "../src/Photo.vala"
			_alteration_unref0 (_tmp3_);
#line 19347 "Photo.c"
		}
#line 2628 "../src/Photo.vala"
		return;
#line 19351 "Photo.c"
	}
#line 2632 "../src/Photo.vala"
	_tmp4_ = pixel_transformation_bundle_save (new_adjustments, "adjustments");
#line 2632 "../src/Photo.vala"
	map = _tmp4_;
#line 19357 "Photo.c"
	{
		PhotoRow* _tmp5_;
#line 2635 "../src/Photo.vala"
		_tmp5_ = self->row;
#line 2635 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19364 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
			PixelTransformer* _tmp7_;
			KeyValueMap* _tmp25_;
#line 2636 "../src/Photo.vala"
			_tmp7_ = self->priv->transformer;
#line 2636 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 2636 "../src/Photo.vala"
				_tmp6_ = TRUE;
#line 19375 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp8_;
#line 2636 "../src/Photo.vala"
				_tmp8_ = self->priv->adjustments;
#line 2636 "../src/Photo.vala"
				_tmp6_ = _tmp8_ == NULL;
#line 19382 "Photo.c"
			}
#line 2636 "../src/Photo.vala"
			if (_tmp6_) {
#line 19386 "Photo.c"
				PixelTransformationBundle* _tmp9_;
				PixelTransformer* _tmp10_;
#line 2638 "../src/Photo.vala"
				_tmp9_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2638 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2638 "../src/Photo.vala"
				self->priv->adjustments = _tmp9_;
#line 2639 "../src/Photo.vala"
				_tmp10_ = pixel_transformation_bundle_generate_transformer (new_adjustments);
#line 2639 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2639 "../src/Photo.vala"
				self->priv->transformer = _tmp10_;
#line 19401 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp24_;
				{
					GeeIterator* _transformation_it = NULL;
					GeeIterable* _tmp11_;
					GeeIterable* _tmp12_;
					GeeIterator* _tmp13_;
					GeeIterator* _tmp14_;
#line 2642 "../src/Photo.vala"
					_tmp11_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2642 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 2642 "../src/Photo.vala"
					_tmp13_ = gee_iterable_iterator (_tmp12_);
#line 2642 "../src/Photo.vala"
					_tmp14_ = _tmp13_;
#line 2642 "../src/Photo.vala"
					_g_object_unref0 (_tmp12_);
#line 2642 "../src/Photo.vala"
					_transformation_it = _tmp14_;
#line 2642 "../src/Photo.vala"
					while (TRUE) {
#line 19424 "Photo.c"
						GeeIterator* _tmp15_;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp16_;
						gpointer _tmp17_;
						PixelTransformer* _tmp18_;
						PixelTransformationBundle* _tmp19_;
						PixelTransformation* _tmp20_;
						PixelTransformation* _tmp21_;
						PixelTransformation* _tmp22_;
						PixelTransformation* _tmp23_;
#line 2642 "../src/Photo.vala"
						_tmp15_ = _transformation_it;
#line 2642 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp15_)) {
#line 2642 "../src/Photo.vala"
							break;
#line 19441 "Photo.c"
						}
#line 2642 "../src/Photo.vala"
						_tmp16_ = _transformation_it;
#line 2642 "../src/Photo.vala"
						_tmp17_ = gee_iterator_get (_tmp16_);
#line 2642 "../src/Photo.vala"
						transformation = (PixelTransformation*) _tmp17_;
#line 2643 "../src/Photo.vala"
						_tmp18_ = self->priv->transformer;
#line 2643 "../src/Photo.vala"
						_tmp19_ = self->priv->adjustments;
#line 2643 "../src/Photo.vala"
						_tmp20_ = transformation;
#line 2643 "../src/Photo.vala"
						_tmp21_ = pixel_transformation_bundle_get_transformation (_tmp19_, pixel_transformation_get_transformation_type (_tmp20_));
#line 2643 "../src/Photo.vala"
						_tmp22_ = _tmp21_;
#line 2643 "../src/Photo.vala"
						_tmp23_ = transformation;
#line 2643 "../src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp18_, _tmp22_, _tmp23_);
#line 2643 "../src/Photo.vala"
						_pixel_transformation_unref0 (_tmp22_);
#line 2642 "../src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 19467 "Photo.c"
					}
#line 2642 "../src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 19471 "Photo.c"
				}
#line 2648 "../src/Photo.vala"
				_tmp24_ = pixel_transformation_bundle_copy (new_adjustments);
#line 2648 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2648 "../src/Photo.vala"
				self->priv->adjustments = _tmp24_;
#line 19479 "Photo.c"
			}
#line 2651 "../src/Photo.vala"
			_tmp25_ = map;
#line 2651 "../src/Photo.vala"
			committed = photo_set_transformation (self, _tmp25_);
#line 19485 "Photo.c"
		}
		__finally192:
		{
			PhotoRow* _tmp26_;
#line 2635 "../src/Photo.vala"
			_tmp26_ = self->row;
#line 2635 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19494 "Photo.c"
		}
#line 2635 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2635 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2635 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2635 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2635 "../src/Photo.vala"
			return;
#line 19506 "Photo.c"
		}
	}
#line 2654 "../src/Photo.vala"
	if (committed) {
#line 19511 "Photo.c"
		Alteration* _tmp27_;
		Alteration* _tmp28_;
#line 2655 "../src/Photo.vala"
		_tmp27_ = alteration_new ("image", "color-adjustments");
#line 2655 "../src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 2655 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp28_);
#line 2655 "../src/Photo.vala"
		_alteration_unref0 (_tmp28_);
#line 19522 "Photo.c"
	}
#line 2612 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19526 "Photo.c"
}

static PhotoMetadata*
photo_real_get_metadata (PhotoSource* base)
{
	Photo * self;
	PhotoMetadata* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2660 "../src/Photo.vala"
	self = (Photo*) base;
#line 19537 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoFileReader* _tmp2_;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
		PhotoMetadata* _tmp5_;
#line 2662 "../src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2662 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2662 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2662 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2662 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2662 "../src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2662 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19559 "Photo.c"
			goto __catch193_g_error;
		}
#line 2662 "../src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2662 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 2662 "../src/Photo.vala"
		result = _tmp5_;
#line 2662 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2662 "../src/Photo.vala"
		return result;
#line 19572 "Photo.c"
	}
	goto __finally193;
	__catch193_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 2661 "../src/Photo.vala"
		err = _inner_error0_;
#line 2661 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 2664 "../src/Photo.vala"
		_tmp6_ = err;
#line 2664 "../src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2664 "../src/Photo.vala"
		g_warning ("Photo.vala:2664: Unable to load metadata: %s", _tmp7_);
#line 2666 "../src/Photo.vala"
		result = NULL;
#line 2666 "../src/Photo.vala"
		_g_error_free0 (err);
#line 2666 "../src/Photo.vala"
		return result;
#line 19596 "Photo.c"
	}
	__finally193:
#line 2661 "../src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2661 "../src/Photo.vala"
	g_clear_error (&_inner_error0_);
#line 2661 "../src/Photo.vala"
	return NULL;
#line 19605 "Photo.c"
}

PhotoMetadata*
photo_get_master_metadata (Photo* self,
                           GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	PhotoMetadata* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 2670 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2671 "../src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2671 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2671 "../src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error0_);
#line 2671 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2671 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2671 "../src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2671 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2671 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2671 "../src/Photo.vala"
		return NULL;
#line 19640 "Photo.c"
	}
#line 2671 "../src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2671 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 2671 "../src/Photo.vala"
	result = _tmp5_;
#line 2671 "../src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2671 "../src/Photo.vala"
	return result;
#line 19652 "Photo.c"
}

PhotoMetadata*
photo_get_editable_metadata (Photo* self,
                             GError** error)
{
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 2674 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2675 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2675 "../src/Photo.vala"
	reader = _tmp0_;
#line 2677 "../src/Photo.vala"
	_tmp2_ = reader;
#line 2677 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19675 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 2677 "../src/Photo.vala"
		_tmp3_ = reader;
#line 2677 "../src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error0_);
#line 2677 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2677 "../src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2677 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2677 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2677 "../src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2677 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2677 "../src/Photo.vala"
			return NULL;
#line 19696 "Photo.c"
		}
	} else {
#line 2677 "../src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2677 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 19703 "Photo.c"
	}
#line 2677 "../src/Photo.vala"
	result = _tmp1_;
#line 2677 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2677 "../src/Photo.vala"
	return result;
#line 19711 "Photo.c"
}

gboolean
photo_persist_master_metadata (Photo* self,
                               PhotoMetadata* metadata,
                               PhotoReimportMasterState* * state,
                               GError** error)
{
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileMetadataWriter* _tmp2_ = NULL;
	PhotoFileReader* _tmp3_;
	PhotoFileMetadataWriter* _tmp4_;
	gboolean _tmp7_ = FALSE;
	PhotoReimportMasterState* _tmp8_ = NULL;
	gboolean _tmp9_;
	PhotoReimportMasterState* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 2683 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2683 "../src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2685 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2685 "../src/Photo.vala"
	_vala_state = NULL;
#line 2687 "../src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2687 "../src/Photo.vala"
	master_reader = _tmp0_;
#line 2689 "../src/Photo.vala"
	_tmp1_ = master_reader;
#line 2689 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_))) {
#line 2690 "../src/Photo.vala"
		result = FALSE;
#line 2690 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2690 "../src/Photo.vala"
		if (state) {
#line 2690 "../src/Photo.vala"
			*state = _vala_state;
#line 19757 "Photo.c"
		} else {
#line 2690 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19761 "Photo.c"
		}
#line 2690 "../src/Photo.vala"
		return result;
#line 19765 "Photo.c"
	}
#line 2693 "../src/Photo.vala"
	_tmp3_ = master_reader;
#line 2693 "../src/Photo.vala"
	_tmp4_ = photo_file_reader_create_metadata_writer (_tmp3_, &_inner_error0_);
#line 2693 "../src/Photo.vala"
	_tmp2_ = _tmp4_;
#line 2693 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19775 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 2693 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2693 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2693 "../src/Photo.vala"
		return _tmp5_;
#line 19783 "Photo.c"
	}
#line 2693 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp2_, metadata, &_inner_error0_);
#line 2693 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19789 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2693 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2693 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2693 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2693 "../src/Photo.vala"
		return _tmp6_;
#line 19799 "Photo.c"
	}
#line 2695 "../src/Photo.vala"
	_tmp9_ = photo_prepare_for_reimport_master (self, &_tmp8_, &_inner_error0_);
#line 2695 "../src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2695 "../src/Photo.vala"
	_vala_state = _tmp8_;
#line 2695 "../src/Photo.vala"
	_tmp7_ = _tmp9_;
#line 2695 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19811 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 2695 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2695 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2695 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2695 "../src/Photo.vala"
		return _tmp10_;
#line 19821 "Photo.c"
	}
#line 2695 "../src/Photo.vala"
	if (!_tmp7_) {
#line 2696 "../src/Photo.vala"
		result = FALSE;
#line 2696 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2696 "../src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2696 "../src/Photo.vala"
		if (state) {
#line 2696 "../src/Photo.vala"
			*state = _vala_state;
#line 19835 "Photo.c"
		} else {
#line 2696 "../src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19839 "Photo.c"
		}
#line 2696 "../src/Photo.vala"
		return result;
#line 19843 "Photo.c"
	}
#line 2699 "../src/Photo.vala"
	_tmp11_ = _vala_state;
#line 2699 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2701 "../src/Photo.vala"
	result = TRUE;
#line 2701 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2701 "../src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2701 "../src/Photo.vala"
	if (state) {
#line 2701 "../src/Photo.vala"
		*state = _vala_state;
#line 19859 "Photo.c"
	} else {
#line 2701 "../src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 19863 "Photo.c"
	}
#line 2701 "../src/Photo.vala"
	return result;
#line 19867 "Photo.c"
}

void
photo_finish_update_master_metadata (Photo* self,
                                     PhotoReimportMasterState* state,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2704 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2704 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2705 "../src/Photo.vala"
	photo_finish_reimport_master (self, state, &_inner_error0_);
#line 2705 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2705 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2705 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2705 "../src/Photo.vala"
			return;
#line 19890 "Photo.c"
		} else {
#line 2705 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2705 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2705 "../src/Photo.vala"
			return;
#line 19898 "Photo.c"
		}
	}
}

gboolean
photo_persist_editable_metadata (Photo* self,
                                 PhotoMetadata* metadata,
                                 PhotoReimportEditableState* * state,
                                 GError** error)
{
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	gboolean _tmp8_ = FALSE;
	PhotoReimportEditableState* _tmp9_ = NULL;
	gboolean _tmp10_;
	PhotoReimportEditableState* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 2708 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2708 "../src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2710 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2710 "../src/Photo.vala"
	_vala_state = NULL;
#line 2712 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2712 "../src/Photo.vala"
	editable_reader = _tmp0_;
#line 2713 "../src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2713 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2714 "../src/Photo.vala"
		result = FALSE;
#line 2714 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2714 "../src/Photo.vala"
		if (state) {
#line 2714 "../src/Photo.vala"
			*state = _vala_state;
#line 19947 "Photo.c"
		} else {
#line 2714 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19951 "Photo.c"
		}
#line 2714 "../src/Photo.vala"
		return result;
#line 19955 "Photo.c"
	}
#line 2717 "../src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2717 "../src/Photo.vala"
	if (!photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_))) {
#line 2718 "../src/Photo.vala"
		result = FALSE;
#line 2718 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2718 "../src/Photo.vala"
		if (state) {
#line 2718 "../src/Photo.vala"
			*state = _vala_state;
#line 19969 "Photo.c"
		} else {
#line 2718 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19973 "Photo.c"
		}
#line 2718 "../src/Photo.vala"
		return result;
#line 19977 "Photo.c"
	}
#line 2721 "../src/Photo.vala"
	_tmp4_ = editable_reader;
#line 2721 "../src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error0_);
#line 2721 "../src/Photo.vala"
	_tmp3_ = _tmp5_;
#line 2721 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19987 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 2721 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2721 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2721 "../src/Photo.vala"
		return _tmp6_;
#line 19995 "Photo.c"
	}
#line 2721 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp3_, metadata, &_inner_error0_);
#line 2721 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20001 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2721 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2721 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2721 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2721 "../src/Photo.vala"
		return _tmp7_;
#line 20011 "Photo.c"
	}
#line 2723 "../src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_editable (self, &_tmp9_, &_inner_error0_);
#line 2723 "../src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2723 "../src/Photo.vala"
	_vala_state = _tmp9_;
#line 2723 "../src/Photo.vala"
	_tmp8_ = _tmp10_;
#line 2723 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20023 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2723 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2723 "../src/Photo.vala"
		return _tmp11_;
#line 20033 "Photo.c"
	}
#line 2723 "../src/Photo.vala"
	if (!_tmp8_) {
#line 2724 "../src/Photo.vala"
		result = FALSE;
#line 2724 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp3_);
#line 2724 "../src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2724 "../src/Photo.vala"
		if (state) {
#line 2724 "../src/Photo.vala"
			*state = _vala_state;
#line 20047 "Photo.c"
		} else {
#line 2724 "../src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20051 "Photo.c"
		}
#line 2724 "../src/Photo.vala"
		return result;
#line 20055 "Photo.c"
	}
#line 2727 "../src/Photo.vala"
	_tmp12_ = _vala_state;
#line 2727 "../src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2729 "../src/Photo.vala"
	result = TRUE;
#line 2729 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 2729 "../src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2729 "../src/Photo.vala"
	if (state) {
#line 2729 "../src/Photo.vala"
		*state = _vala_state;
#line 20071 "Photo.c"
	} else {
#line 2729 "../src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 20075 "Photo.c"
	}
#line 2729 "../src/Photo.vala"
	return result;
#line 20079 "Photo.c"
}

void
photo_finish_update_editable_metadata (Photo* self,
                                       PhotoReimportEditableState* state,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
#line 2732 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2732 "../src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2733 "../src/Photo.vala"
	photo_finish_reimport_editable (self, state, &_inner_error0_);
#line 2733 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2733 "../src/Photo.vala"
		if (_inner_error0_->domain == DATABASE_ERROR) {
#line 2733 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 2733 "../src/Photo.vala"
			return;
#line 20102 "Photo.c"
		} else {
#line 2733 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2733 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2733 "../src/Photo.vala"
			return;
#line 20110 "Photo.c"
		}
	}
}

void
photo_get_raw_dimensions (Photo* self,
                          Dimensions* result)
{
	GError* _inner_error0_ = NULL;
#line 2738 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 20122 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2739 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2739 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20129 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Dimensions _tmp2_;
#line 2740 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2740 "../src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2740 "../src/Photo.vala"
			*result = _tmp2_;
#line 20139 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2739 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2739 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20146 "Photo.c"
			}
#line 2740 "../src/Photo.vala"
			return;
#line 20150 "Photo.c"
		}
		__finally194:
		{
			PhotoRow* _tmp4_;
#line 2739 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2739 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20159 "Photo.c"
		}
#line 2739 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2739 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2739 "../src/Photo.vala"
		return;
#line 20167 "Photo.c"
	}
}

gboolean
photo_has_transformations (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2744 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20178 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp10_ = FALSE;
#line 2745 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2745 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20186 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			Orientation _tmp3_;
			BackingPhotoRow* _tmp4_;
			Orientation _tmp5_;
#line 2746 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2746 "../src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2746 "../src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2746 "../src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2746 "../src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2747 "../src/Photo.vala"
				_tmp1_ = TRUE;
#line 20205 "Photo.c"
			} else {
				PhotoRow* _tmp6_;
				GeeHashMap* _tmp7_;
#line 2748 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2748 "../src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2748 "../src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 20215 "Photo.c"
			}
#line 2746 "../src/Photo.vala"
			result = _tmp1_;
#line 20219 "Photo.c"
			{
				PhotoRow* _tmp8_;
#line 2745 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 2745 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20226 "Photo.c"
			}
#line 2746 "../src/Photo.vala"
			return result;
#line 20230 "Photo.c"
		}
		__finally195:
		{
			PhotoRow* _tmp9_;
#line 2745 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2745 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20239 "Photo.c"
		}
#line 2745 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2745 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2745 "../src/Photo.vala"
		return _tmp10_;
#line 20247 "Photo.c"
	}
}

gboolean
photo_only_metadata_changed (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 2752 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2753 "../src/Photo.vala"
	date_time = NULL;
#line 2755 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2755 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2756 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2756 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20272 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
#line 2757 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2757 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2757 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2757 "../src/Photo.vala"
		date_time = _tmp3_;
#line 20283 "Photo.c"
	}
	{
		PhotoRow* _tmp4_;
		gboolean _tmp19_ = FALSE;
#line 2760 "../src/Photo.vala"
		_tmp4_ = self->row;
#line 2760 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20292 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_;
			GeeHashMap* _tmp7_;
#line 2761 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2761 "../src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2761 "../src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 20303 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_;
				Orientation _tmp10_;
				BackingPhotoRow* _tmp11_;
				Orientation _tmp12_;
#line 2762 "../src/Photo.vala"
				_tmp9_ = self->row;
#line 2762 "../src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2762 "../src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2762 "../src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2762 "../src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2762 "../src/Photo.vala"
					_tmp8_ = TRUE;
#line 20321 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
#line 2763 "../src/Photo.vala"
					_tmp14_ = date_time;
#line 2763 "../src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 20329 "Photo.c"
						PhotoRow* _tmp15_;
						MetadataDateTime* _tmp16_;
#line 2763 "../src/Photo.vala"
						_tmp15_ = self->row;
#line 2763 "../src/Photo.vala"
						_tmp16_ = date_time;
#line 2763 "../src/Photo.vala"
						_tmp13_ = _tmp15_->exposure_time != metadata_date_time_get_timestamp (_tmp16_);
#line 20338 "Photo.c"
					} else {
#line 2763 "../src/Photo.vala"
						_tmp13_ = FALSE;
#line 20342 "Photo.c"
					}
#line 2763 "../src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 20346 "Photo.c"
				}
#line 2762 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20350 "Photo.c"
			} else {
#line 2761 "../src/Photo.vala"
				_tmp5_ = FALSE;
#line 20354 "Photo.c"
			}
#line 2761 "../src/Photo.vala"
			result = _tmp5_;
#line 20358 "Photo.c"
			{
				PhotoRow* _tmp17_;
#line 2760 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 2760 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20365 "Photo.c"
			}
#line 2761 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2761 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2761 "../src/Photo.vala"
			return result;
#line 20373 "Photo.c"
		}
		__finally196:
		{
			PhotoRow* _tmp18_;
#line 2760 "../src/Photo.vala"
			_tmp18_ = self->row;
#line 2760 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20382 "Photo.c"
		}
#line 2760 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2760 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2760 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2760 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2760 "../src/Photo.vala"
		return _tmp19_;
#line 20394 "Photo.c"
	}
#line 2752 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2752 "../src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20400 "Photo.c"
}

gboolean
photo_has_alterations (Photo* self)
{
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_;
	PhotoMetadata* _tmp1_;
	MetadataDateTime* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 2767 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2768 "../src/Photo.vala"
	date_time = NULL;
#line 2769 "../src/Photo.vala"
	title = NULL;
#line 2770 "../src/Photo.vala"
	comment = NULL;
#line 2772 "../src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2772 "../src/Photo.vala"
	metadata = _tmp0_;
#line 2773 "../src/Photo.vala"
	_tmp1_ = metadata;
#line 2773 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20431 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_;
		PhotoMetadata* _tmp6_;
		gchar* _tmp7_;
#line 2774 "../src/Photo.vala"
		_tmp2_ = metadata;
#line 2774 "../src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2774 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2774 "../src/Photo.vala"
		date_time = _tmp3_;
#line 2775 "../src/Photo.vala"
		_tmp4_ = metadata;
#line 2775 "../src/Photo.vala"
		_tmp5_ = media_metadata_get_title ((MediaMetadata*) _tmp4_);
#line 2775 "../src/Photo.vala"
		_g_free0 (title);
#line 2775 "../src/Photo.vala"
		title = _tmp5_;
#line 2776 "../src/Photo.vala"
		_tmp6_ = metadata;
#line 2776 "../src/Photo.vala"
		_tmp7_ = media_metadata_get_comment ((MediaMetadata*) _tmp6_);
#line 2776 "../src/Photo.vala"
		_g_free0 (comment);
#line 2776 "../src/Photo.vala"
		comment = _tmp7_;
#line 20462 "Photo.c"
	}
#line 2780 "../src/Photo.vala"
	_tmp8_ = date_time;
#line 2780 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 20468 "Photo.c"
		{
			PhotoRow* _tmp9_;
#line 2782 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2782 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20475 "Photo.c"
			{
				BackingPhotoRow* _tmp10_;
				PhotoRow* _tmp11_;
#line 2784 "../src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2784 "../src/Photo.vala"
				_tmp11_ = self->row;
#line 2784 "../src/Photo.vala"
				if (_tmp10_->timestamp != _tmp11_->exposure_time) {
#line 2786 "../src/Photo.vala"
					result = TRUE;
#line 20487 "Photo.c"
					{
						PhotoRow* _tmp12_;
#line 2782 "../src/Photo.vala"
						_tmp12_ = self->row;
#line 2782 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20494 "Photo.c"
					}
#line 2786 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2786 "../src/Photo.vala"
					_g_free0 (comment);
#line 2786 "../src/Photo.vala"
					_g_free0 (title);
#line 2786 "../src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2786 "../src/Photo.vala"
					return result;
#line 20506 "Photo.c"
				}
			}
			__finally197:
			{
				PhotoRow* _tmp13_;
#line 2782 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2782 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20516 "Photo.c"
			}
#line 2782 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20520 "Photo.c"
				gboolean _tmp14_ = FALSE;
#line 2782 "../src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2782 "../src/Photo.vala"
				_g_free0 (comment);
#line 2782 "../src/Photo.vala"
				_g_free0 (title);
#line 2782 "../src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2782 "../src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2782 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 2782 "../src/Photo.vala"
				return _tmp14_;
#line 20536 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp15_;
		gboolean _tmp38_ = FALSE;
#line 2791 "../src/Photo.vala"
		_tmp15_ = self->row;
#line 2791 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20547 "Photo.c"
		{
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			PhotoRow* _tmp20_;
			GeeHashMap* _tmp21_;
#line 2792 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 2792 "../src/Photo.vala"
			_tmp21_ = _tmp20_->transformations;
#line 2792 "../src/Photo.vala"
			if (_tmp21_ != NULL) {
#line 2792 "../src/Photo.vala"
				_tmp19_ = TRUE;
#line 20563 "Photo.c"
			} else {
				PhotoRow* _tmp22_;
				Orientation _tmp23_;
				BackingPhotoRow* _tmp24_;
				Orientation _tmp25_;
#line 2793 "../src/Photo.vala"
				_tmp22_ = self->row;
#line 2793 "../src/Photo.vala"
				_tmp23_ = _tmp22_->orientation;
#line 2793 "../src/Photo.vala"
				_tmp24_ = self->backing_photo_row;
#line 2793 "../src/Photo.vala"
				_tmp25_ = _tmp24_->original_orientation;
#line 2793 "../src/Photo.vala"
				_tmp19_ = _tmp23_ != _tmp25_;
#line 20579 "Photo.c"
			}
#line 2792 "../src/Photo.vala"
			if (_tmp19_) {
#line 2792 "../src/Photo.vala"
				_tmp18_ = TRUE;
#line 20585 "Photo.c"
			} else {
				gboolean _tmp26_ = FALSE;
				MetadataDateTime* _tmp27_;
#line 2794 "../src/Photo.vala"
				_tmp27_ = date_time;
#line 2794 "../src/Photo.vala"
				if (_tmp27_ != NULL) {
#line 20593 "Photo.c"
					PhotoRow* _tmp28_;
					MetadataDateTime* _tmp29_;
#line 2794 "../src/Photo.vala"
					_tmp28_ = self->row;
#line 2794 "../src/Photo.vala"
					_tmp29_ = date_time;
#line 2794 "../src/Photo.vala"
					_tmp26_ = _tmp28_->exposure_time != metadata_date_time_get_timestamp (_tmp29_);
#line 20602 "Photo.c"
				} else {
#line 2794 "../src/Photo.vala"
					_tmp26_ = FALSE;
#line 20606 "Photo.c"
				}
#line 2794 "../src/Photo.vala"
				_tmp18_ = _tmp26_;
#line 20610 "Photo.c"
			}
#line 2792 "../src/Photo.vala"
			if (_tmp18_) {
#line 2792 "../src/Photo.vala"
				_tmp17_ = TRUE;
#line 20616 "Photo.c"
			} else {
				gchar* _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
#line 2795 "../src/Photo.vala"
				_tmp30_ = media_source_get_comment ((MediaSource*) self);
#line 2795 "../src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 2795 "../src/Photo.vala"
				_tmp32_ = comment;
#line 2795 "../src/Photo.vala"
				_tmp17_ = g_strcmp0 (_tmp31_, _tmp32_) != 0;
#line 2795 "../src/Photo.vala"
				_g_free0 (_tmp31_);
#line 20631 "Photo.c"
			}
#line 2792 "../src/Photo.vala"
			if (_tmp17_) {
#line 2792 "../src/Photo.vala"
				_tmp16_ = TRUE;
#line 20637 "Photo.c"
			} else {
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 2796 "../src/Photo.vala"
				_tmp33_ = media_source_get_title ((MediaSource*) self);
#line 2796 "../src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 2796 "../src/Photo.vala"
				_tmp35_ = title;
#line 2796 "../src/Photo.vala"
				_tmp16_ = g_strcmp0 (_tmp34_, _tmp35_) != 0;
#line 2796 "../src/Photo.vala"
				_g_free0 (_tmp34_);
#line 20652 "Photo.c"
			}
#line 2792 "../src/Photo.vala"
			result = _tmp16_;
#line 20656 "Photo.c"
			{
				PhotoRow* _tmp36_;
#line 2791 "../src/Photo.vala"
				_tmp36_ = self->row;
#line 2791 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20663 "Photo.c"
			}
#line 2792 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2792 "../src/Photo.vala"
			_g_free0 (comment);
#line 2792 "../src/Photo.vala"
			_g_free0 (title);
#line 2792 "../src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2792 "../src/Photo.vala"
			return result;
#line 20675 "Photo.c"
		}
		__finally198:
		{
			PhotoRow* _tmp37_;
#line 2791 "../src/Photo.vala"
			_tmp37_ = self->row;
#line 2791 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20684 "Photo.c"
		}
#line 2791 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2791 "../src/Photo.vala"
		_g_free0 (comment);
#line 2791 "../src/Photo.vala"
		_g_free0 (title);
#line 2791 "../src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2791 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2791 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2791 "../src/Photo.vala"
		return _tmp38_;
#line 20700 "Photo.c"
	}
#line 2767 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2767 "../src/Photo.vala"
	_g_free0 (comment);
#line 2767 "../src/Photo.vala"
	_g_free0 (title);
#line 2767 "../src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20710 "Photo.c"
}

PhotoTransformationState*
photo_save_transformation_state (Photo* self)
{
	PhotoTransformationState* result = NULL;
	GError* _inner_error0_ = NULL;
#line 2801 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20720 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2802 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2802 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20727 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow* _tmp9_;
			Orientation _tmp10_;
			PhotoRow* _tmp11_;
			GeeHashMap* _tmp12_;
			PhotoRow* _tmp13_;
			GeeHashMap* _tmp14_;
			PhotoRow* _tmp15_;
			PhotoPhotoTransformationStateImpl* _tmp16_;
#line 2805 "../src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2805 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20745 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_;
#line 2805 "../src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2805 "../src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2805 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2805 "../src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 20756 "Photo.c"
			} else {
#line 2805 "../src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2805 "../src/Photo.vala"
				_tmp1_ = NULL;
#line 20762 "Photo.c"
			}
#line 2806 "../src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2806 "../src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 20768 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_;
#line 2806 "../src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2806 "../src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2806 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2806 "../src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20779 "Photo.c"
			} else {
#line 2806 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2806 "../src/Photo.vala"
				_tmp5_ = NULL;
#line 20785 "Photo.c"
			}
#line 2803 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2803 "../src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2803 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2803 "../src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2803 "../src/Photo.vala"
			_tmp13_ = self->row;
#line 2803 "../src/Photo.vala"
			_tmp14_ = _tmp13_->original_transforms;
#line 2803 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2803 "../src/Photo.vala"
			_tmp16_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_, _tmp14_, _tmp15_->enhanced);
#line 2803 "../src/Photo.vala"
			result = (PhotoTransformationState*) _tmp16_;
#line 2803 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2803 "../src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 20809 "Photo.c"
			{
				PhotoRow* _tmp17_;
#line 2802 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 2802 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20816 "Photo.c"
			}
#line 2803 "../src/Photo.vala"
			return result;
#line 20820 "Photo.c"
		}
		__finally199:
		{
			PhotoRow* _tmp18_;
#line 2802 "../src/Photo.vala"
			_tmp18_ = self->row;
#line 2802 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20829 "Photo.c"
		}
#line 2802 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2802 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2802 "../src/Photo.vala"
		return NULL;
#line 20837 "Photo.c"
	}
}

static gpointer
_pixel_transformer_ref0 (gpointer self)
{
#line 2833 "../src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 20846 "Photo.c"
}

static gpointer
_pixel_transformation_bundle_ref0 (gpointer self)
{
#line 2834 "../src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 20854 "Photo.c"
}

gboolean
photo_load_transformation_state (Photo* self,
                                 PhotoTransformationState* state)
{
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoPhotoTransformationStateImpl* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	gboolean saved_enhanced = FALSE;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* saved_original_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp6_;
	GeeHashMap* _tmp7_;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp8_;
	PixelTransformer* _tmp9_;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp10_;
	PixelTransformationBundle* _tmp11_;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2811 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2811 "../src/Photo.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 2812 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (state, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) state) : NULL);
#line 2812 "../src/Photo.vala"
	state_impl = _tmp0_;
#line 2813 "../src/Photo.vala"
	_tmp1_ = state_impl;
#line 2813 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2814 "../src/Photo.vala"
		result = FALSE;
#line 2814 "../src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2814 "../src/Photo.vala"
		return result;
#line 20901 "Photo.c"
	}
#line 2817 "../src/Photo.vala"
	_tmp2_ = state_impl;
#line 2817 "../src/Photo.vala"
	saved_orientation = photo_photo_transformation_state_impl_get_orientation (_tmp2_);
#line 2818 "../src/Photo.vala"
	_tmp3_ = state_impl;
#line 2818 "../src/Photo.vala"
	saved_enhanced = photo_photo_transformation_state_impl_get_enhanced (_tmp3_);
#line 2819 "../src/Photo.vala"
	_tmp4_ = state_impl;
#line 2819 "../src/Photo.vala"
	_tmp5_ = photo_photo_transformation_state_impl_get_transformations (_tmp4_);
#line 2819 "../src/Photo.vala"
	saved_transformations = _tmp5_;
#line 2820 "../src/Photo.vala"
	_tmp6_ = state_impl;
#line 2820 "../src/Photo.vala"
	_tmp7_ = photo_photo_transformation_state_impl_get_original_transformations (_tmp6_);
#line 2820 "../src/Photo.vala"
	saved_original_transformations = _tmp7_;
#line 2821 "../src/Photo.vala"
	_tmp8_ = state_impl;
#line 2821 "../src/Photo.vala"
	_tmp9_ = photo_photo_transformation_state_impl_get_transformer (_tmp8_);
#line 2821 "../src/Photo.vala"
	saved_transformer = _tmp9_;
#line 2822 "../src/Photo.vala"
	_tmp10_ = state_impl;
#line 2822 "../src/Photo.vala"
	_tmp11_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp10_);
#line 2822 "../src/Photo.vala"
	saved_adjustments = _tmp11_;
#line 20935 "Photo.c"
	{
		PhotoRow* _tmp12_;
#line 2825 "../src/Photo.vala"
		_tmp12_ = self->row;
#line 2825 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20942 "Photo.c"
		{
			PhotoTable* _tmp13_;
			PhotoTable* _tmp14_;
			PhotoRow* _tmp15_;
			PhotoID _tmp16_;
			Orientation _tmp17_;
			GeeHashMap* _tmp18_;
			GeeHashMap* _tmp19_;
#line 2826 "../src/Photo.vala"
			_tmp13_ = photo_table_get_instance ();
#line 2826 "../src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 2826 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2826 "../src/Photo.vala"
			_tmp16_ = _tmp15_->photo_id;
#line 2826 "../src/Photo.vala"
			_tmp17_ = saved_orientation;
#line 2826 "../src/Photo.vala"
			_tmp18_ = saved_transformations;
#line 2826 "../src/Photo.vala"
			_tmp19_ = saved_transformations;
#line 2826 "../src/Photo.vala"
			committed = photo_table_set_transformation_state (_tmp14_, &_tmp16_, _tmp17_, _tmp18_, _tmp19_, saved_enhanced);
#line 2826 "../src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 2828 "../src/Photo.vala"
			if (committed) {
#line 20971 "Photo.c"
				PhotoRow* _tmp20_;
				Orientation _tmp21_;
				PhotoRow* _tmp22_;
				GeeHashMap* _tmp23_;
				GeeHashMap* _tmp24_;
				PhotoRow* _tmp25_;
				GeeHashMap* _tmp26_;
				GeeHashMap* _tmp27_;
				PhotoRow* _tmp28_;
				PixelTransformer* _tmp29_;
				PixelTransformer* _tmp30_;
				PixelTransformationBundle* _tmp31_;
				PixelTransformationBundle* _tmp32_;
#line 2829 "../src/Photo.vala"
				_tmp20_ = self->row;
#line 2829 "../src/Photo.vala"
				_tmp21_ = saved_orientation;
#line 2829 "../src/Photo.vala"
				_tmp20_->orientation = _tmp21_;
#line 2830 "../src/Photo.vala"
				_tmp22_ = self->row;
#line 2830 "../src/Photo.vala"
				_tmp23_ = saved_transformations;
#line 2830 "../src/Photo.vala"
				_tmp24_ = _g_object_ref0 (_tmp23_);
#line 2830 "../src/Photo.vala"
				_g_object_unref0 (_tmp22_->transformations);
#line 2830 "../src/Photo.vala"
				_tmp22_->transformations = _tmp24_;
#line 2831 "../src/Photo.vala"
				_tmp25_ = self->row;
#line 2831 "../src/Photo.vala"
				_tmp26_ = saved_original_transformations;
#line 2831 "../src/Photo.vala"
				_tmp27_ = _g_object_ref0 (_tmp26_);
#line 2831 "../src/Photo.vala"
				_g_object_unref0 (_tmp25_->original_transforms);
#line 2831 "../src/Photo.vala"
				_tmp25_->original_transforms = _tmp27_;
#line 2832 "../src/Photo.vala"
				_tmp28_ = self->row;
#line 2832 "../src/Photo.vala"
				_tmp28_->enhanced = saved_enhanced;
#line 2833 "../src/Photo.vala"
				_tmp29_ = saved_transformer;
#line 2833 "../src/Photo.vala"
				_tmp30_ = _pixel_transformer_ref0 (_tmp29_);
#line 2833 "../src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2833 "../src/Photo.vala"
				self->priv->transformer = _tmp30_;
#line 2834 "../src/Photo.vala"
				_tmp31_ = saved_adjustments;
#line 2834 "../src/Photo.vala"
				_tmp32_ = _pixel_transformation_bundle_ref0 (_tmp31_);
#line 2834 "../src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2834 "../src/Photo.vala"
				self->priv->adjustments = _tmp32_;
#line 21031 "Photo.c"
			}
		}
		__finally200:
		{
			PhotoRow* _tmp33_;
#line 2825 "../src/Photo.vala"
			_tmp33_ = self->row;
#line 2825 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21041 "Photo.c"
		}
#line 2825 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21045 "Photo.c"
			gboolean _tmp34_ = FALSE;
#line 2825 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2825 "../src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2825 "../src/Photo.vala"
			_g_object_unref0 (saved_original_transformations);
#line 2825 "../src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2825 "../src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2825 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2825 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2825 "../src/Photo.vala"
			return _tmp34_;
#line 21063 "Photo.c"
		}
	}
#line 2838 "../src/Photo.vala"
	if (committed) {
#line 21068 "Photo.c"
		Alteration* _tmp35_;
		Alteration* _tmp36_;
#line 2839 "../src/Photo.vala"
		_tmp35_ = alteration_new ("image", "transformation-state");
#line 2839 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 2839 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp36_);
#line 2839 "../src/Photo.vala"
		_alteration_unref0 (_tmp36_);
#line 21079 "Photo.c"
	}
#line 2842 "../src/Photo.vala"
	result = committed;
#line 2842 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2842 "../src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2842 "../src/Photo.vala"
	_g_object_unref0 (saved_original_transformations);
#line 2842 "../src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2842 "../src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2842 "../src/Photo.vala"
	return result;
#line 21095 "Photo.c"
}

void
photo_remove_all_transformations (Photo* self)
{
#line 2845 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2846 "../src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 21105 "Photo.c"
}

static void
photo_internal_remove_all_transformations (Photo* self,
                                           gboolean notify)
{
	gboolean is_altered = FALSE;
	gboolean _tmp21_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 2849 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2850 "../src/Photo.vala"
	is_altered = FALSE;
#line 21119 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2851 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2851 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21126 "Photo.c"
		{
			PhotoTable* _tmp1_;
			PhotoTable* _tmp2_;
			PhotoRow* _tmp3_;
			PhotoID _tmp4_;
			PhotoRow* _tmp5_;
			PhotoRow* _tmp6_;
			PhotoRow* _tmp7_;
			Orientation _tmp8_;
			BackingPhotoRow* _tmp9_;
			Orientation _tmp10_;
#line 2852 "../src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2852 "../src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2852 "../src/Photo.vala"
			_tmp3_ = self->row;
#line 2852 "../src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2852 "../src/Photo.vala"
			is_altered = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2852 "../src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2853 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2853 "../src/Photo.vala"
			_g_object_unref0 (_tmp5_->transformations);
#line 2853 "../src/Photo.vala"
			_tmp5_->transformations = NULL;
#line 2854 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 2854 "../src/Photo.vala"
			_tmp6_->enhanced = FALSE;
#line 2855 "../src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2855 "../src/Photo.vala"
			self->priv->transformer = NULL;
#line 2856 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2856 "../src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2858 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2858 "../src/Photo.vala"
			_tmp8_ = _tmp7_->orientation;
#line 2858 "../src/Photo.vala"
			_tmp9_ = self->backing_photo_row;
#line 2858 "../src/Photo.vala"
			_tmp10_ = _tmp9_->original_orientation;
#line 2858 "../src/Photo.vala"
			if (_tmp8_ != _tmp10_) {
#line 21178 "Photo.c"
				PhotoTable* _tmp11_;
				PhotoTable* _tmp12_;
				PhotoRow* _tmp13_;
				PhotoID _tmp14_;
				BackingPhotoRow* _tmp15_;
				Orientation _tmp16_;
				PhotoRow* _tmp17_;
				BackingPhotoRow* _tmp18_;
				Orientation _tmp19_;
#line 2859 "../src/Photo.vala"
				_tmp11_ = photo_table_get_instance ();
#line 2859 "../src/Photo.vala"
				_tmp12_ = _tmp11_;
#line 2859 "../src/Photo.vala"
				_tmp13_ = self->row;
#line 2859 "../src/Photo.vala"
				_tmp14_ = _tmp13_->photo_id;
#line 2859 "../src/Photo.vala"
				_tmp15_ = self->backing_photo_row;
#line 2859 "../src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 2859 "../src/Photo.vala"
				photo_table_set_orientation (_tmp12_, &_tmp14_, _tmp16_);
#line 2859 "../src/Photo.vala"
				_database_table_unref0 (_tmp12_);
#line 2861 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 2861 "../src/Photo.vala"
				_tmp18_ = self->backing_photo_row;
#line 2861 "../src/Photo.vala"
				_tmp19_ = _tmp18_->original_orientation;
#line 2861 "../src/Photo.vala"
				_tmp17_->orientation = _tmp19_;
#line 2862 "../src/Photo.vala"
				is_altered = TRUE;
#line 21214 "Photo.c"
			}
		}
		__finally201:
		{
			PhotoRow* _tmp20_;
#line 2851 "../src/Photo.vala"
			_tmp20_ = self->row;
#line 2851 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21224 "Photo.c"
		}
#line 2851 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2851 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2851 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2851 "../src/Photo.vala"
			return;
#line 21234 "Photo.c"
		}
	}
#line 2866 "../src/Photo.vala"
	if (is_altered) {
#line 2866 "../src/Photo.vala"
		_tmp21_ = notify;
#line 21241 "Photo.c"
	} else {
#line 2866 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 21245 "Photo.c"
	}
#line 2866 "../src/Photo.vala"
	if (_tmp21_) {
#line 21249 "Photo.c"
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 2867 "../src/Photo.vala"
		_tmp22_ = alteration_new ("image", "revert");
#line 2867 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2867 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp23_);
#line 2867 "../src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 21260 "Photo.c"
	}
}

Orientation
photo_get_original_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2871 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21271 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2872 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2872 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21278 "Photo.c"
		{
			BackingPhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2873 "../src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2873 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2873 "../src/Photo.vala"
			result = _tmp2_;
#line 21288 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2872 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2872 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21295 "Photo.c"
			}
#line 2873 "../src/Photo.vala"
			return result;
#line 21299 "Photo.c"
		}
		__finally202:
		{
			PhotoRow* _tmp4_;
#line 2872 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2872 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21308 "Photo.c"
		}
#line 2872 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2872 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2872 "../src/Photo.vala"
		return 0;
#line 21316 "Photo.c"
	}
}

Orientation
photo_get_orientation (Photo* self)
{
	Orientation result = 0;
	GError* _inner_error0_ = NULL;
#line 2877 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21327 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2878 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2878 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21334 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2879 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2879 "../src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2879 "../src/Photo.vala"
			result = _tmp2_;
#line 21344 "Photo.c"
			{
				PhotoRow* _tmp3_;
#line 2878 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2878 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21351 "Photo.c"
			}
#line 2879 "../src/Photo.vala"
			return result;
#line 21355 "Photo.c"
		}
		__finally203:
		{
			PhotoRow* _tmp4_;
#line 2878 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 2878 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21364 "Photo.c"
		}
#line 2878 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2878 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2878 "../src/Photo.vala"
		return 0;
#line 21372 "Photo.c"
	}
}

gboolean
photo_set_orientation (Photo* self,
                       Orientation orientation)
{
	gboolean result = FALSE;
	gboolean committed = FALSE;
	GError* _inner_error0_ = NULL;
#line 2883 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2884 "../src/Photo.vala"
	committed = FALSE;
#line 21387 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2885 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2885 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21394 "Photo.c"
		{
			PhotoRow* _tmp1_;
			Orientation _tmp2_;
#line 2886 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2886 "../src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2886 "../src/Photo.vala"
			if (_tmp2_ != orientation) {
#line 21404 "Photo.c"
				PhotoTable* _tmp3_;
				PhotoTable* _tmp4_;
				PhotoRow* _tmp5_;
				PhotoID _tmp6_;
#line 2887 "../src/Photo.vala"
				_tmp3_ = photo_table_get_instance ();
#line 2887 "../src/Photo.vala"
				_tmp4_ = _tmp3_;
#line 2887 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2887 "../src/Photo.vala"
				_tmp6_ = _tmp5_->photo_id;
#line 2887 "../src/Photo.vala"
				committed = photo_table_set_orientation (_tmp4_, &_tmp6_, orientation);
#line 2887 "../src/Photo.vala"
				_database_table_unref0 (_tmp4_);
#line 2888 "../src/Photo.vala"
				if (committed) {
#line 21423 "Photo.c"
					PhotoRow* _tmp7_;
#line 2889 "../src/Photo.vala"
					_tmp7_ = self->row;
#line 2889 "../src/Photo.vala"
					_tmp7_->orientation = orientation;
#line 21429 "Photo.c"
				}
			}
		}
		__finally204:
		{
			PhotoRow* _tmp8_;
#line 2885 "../src/Photo.vala"
			_tmp8_ = self->row;
#line 2885 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21440 "Photo.c"
		}
#line 2885 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 21444 "Photo.c"
			gboolean _tmp9_ = FALSE;
#line 2885 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2885 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2885 "../src/Photo.vala"
			return _tmp9_;
#line 21452 "Photo.c"
		}
	}
#line 2893 "../src/Photo.vala"
	if (committed) {
#line 21457 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 2894 "../src/Photo.vala"
		_tmp10_ = alteration_new ("image", "orientation");
#line 2894 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2894 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp11_);
#line 2894 "../src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 21468 "Photo.c"
	}
#line 2897 "../src/Photo.vala"
	result = committed;
#line 2897 "../src/Photo.vala"
	return result;
#line 21474 "Photo.c"
}

gboolean
photo_check_can_rotate (Photo* self)
{
	gboolean result = FALSE;
#line 2900 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2901 "../src/Photo.vala"
	result = self->can_rotate_now;
#line 2901 "../src/Photo.vala"
	return result;
#line 21487 "Photo.c"
}

static void
photo_real_rotate (Photo* self,
                   Rotation rotation)
{
	GError* _inner_error0_ = NULL;
	{
		PhotoRow* _tmp0_;
#line 2905 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2905 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21501 "Photo.c"
		{
#line 2906 "../src/Photo.vala"
			photo_set_orientation (self, orientation_perform (photo_get_orientation (self), rotation));
#line 21505 "Photo.c"
		}
		__finally205:
		{
			PhotoRow* _tmp1_;
#line 2905 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2905 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21514 "Photo.c"
		}
#line 2905 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2905 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2905 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2905 "../src/Photo.vala"
			return;
#line 21524 "Photo.c"
		}
	}
}

void
photo_rotate (Photo* self,
              Rotation rotation)
{
#line 2904 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2904 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 21537 "Photo.c"
}

static gboolean
photo_has_transformation (Photo* self,
                          const gchar* name)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2910 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2910 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 21550 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp8_ = FALSE;
#line 2911 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2911 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21558 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_;
			GeeHashMap* _tmp3_;
#line 2912 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 2912 "../src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2912 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 21569 "Photo.c"
				PhotoRow* _tmp4_;
				GeeHashMap* _tmp5_;
#line 2912 "../src/Photo.vala"
				_tmp4_ = self->row;
#line 2912 "../src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2912 "../src/Photo.vala"
				_tmp1_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, name);
#line 21578 "Photo.c"
			} else {
#line 2912 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 21582 "Photo.c"
			}
#line 2912 "../src/Photo.vala"
			result = _tmp1_;
#line 21586 "Photo.c"
			{
				PhotoRow* _tmp6_;
#line 2911 "../src/Photo.vala"
				_tmp6_ = self->row;
#line 2911 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21593 "Photo.c"
			}
#line 2912 "../src/Photo.vala"
			return result;
#line 21597 "Photo.c"
		}
		__finally206:
		{
			PhotoRow* _tmp7_;
#line 2911 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2911 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21606 "Photo.c"
		}
#line 2911 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2911 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2911 "../src/Photo.vala"
		return _tmp8_;
#line 21614 "Photo.c"
	}
}

static KeyValueMap*
photo_get_transformation (Photo* self,
                          const gchar* name)
{
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError* _inner_error0_ = NULL;
#line 2919 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2919 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2920 "../src/Photo.vala"
	map = NULL;
#line 21631 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2921 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2921 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21638 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
#line 2922 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2922 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2922 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21648 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				gpointer _tmp5_;
				KeyValueMap* _tmp6_;
#line 2923 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2923 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2923 "../src/Photo.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, name);
#line 2923 "../src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2923 "../src/Photo.vala"
				map = (KeyValueMap*) _tmp5_;
#line 2924 "../src/Photo.vala"
				_tmp6_ = map;
#line 2924 "../src/Photo.vala"
				if (_tmp6_ != NULL) {
#line 21667 "Photo.c"
					KeyValueMap* _tmp7_;
					KeyValueMap* _tmp8_;
#line 2925 "../src/Photo.vala"
					_tmp7_ = map;
#line 2925 "../src/Photo.vala"
					_tmp8_ = key_value_map_copy (_tmp7_);
#line 2925 "../src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2925 "../src/Photo.vala"
					map = _tmp8_;
#line 21678 "Photo.c"
				}
			}
		}
		__finally207:
		{
			PhotoRow* _tmp9_;
#line 2921 "../src/Photo.vala"
			_tmp9_ = self->row;
#line 2921 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21689 "Photo.c"
		}
#line 2921 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2921 "../src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2921 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2921 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2921 "../src/Photo.vala"
			return NULL;
#line 21701 "Photo.c"
		}
	}
#line 2930 "../src/Photo.vala"
	result = map;
#line 2930 "../src/Photo.vala"
	return result;
#line 21708 "Photo.c"
}

static gboolean
photo_set_transformation (Photo* self,
                          KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2933 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2933 "../src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21721 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2934 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2934 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21729 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2935 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2935 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2935 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21748 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2936 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2936 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2936 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2936 "../src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 21759 "Photo.c"
			}
#line 2939 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2939 "../src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2939 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2939 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2939 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2939 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2941 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2941 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2941 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2941 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2941 "../src/Photo.vala"
			_tmp13_ = photo_table_set_transformation (_tmp10_, &_tmp12_, trans);
#line 2941 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2941 "../src/Photo.vala"
			result = _tmp13_;
#line 21787 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2934 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2934 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21794 "Photo.c"
			}
#line 2941 "../src/Photo.vala"
			return result;
#line 21798 "Photo.c"
		}
		__finally208:
		{
			PhotoRow* _tmp15_;
#line 2934 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2934 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21807 "Photo.c"
		}
#line 2934 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2934 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2934 "../src/Photo.vala"
		return _tmp16_;
#line 21815 "Photo.c"
	}
}

static gboolean
photo_set_original_transforms (Photo* self,
                               KeyValueMap* trans)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2945 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2945 "../src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21829 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp16_ = FALSE;
#line 2946 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2946 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21837 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow* _tmp5_;
			GeeHashMap* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			PhotoTable* _tmp9_;
			PhotoTable* _tmp10_;
			PhotoRow* _tmp11_;
			PhotoID _tmp12_;
			gboolean _tmp13_;
#line 2947 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2947 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2947 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21856 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2948 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2948 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2948 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2948 "../src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 21867 "Photo.c"
			}
#line 2951 "../src/Photo.vala"
			_tmp5_ = self->row;
#line 2951 "../src/Photo.vala"
			_tmp6_ = _tmp5_->original_transforms;
#line 2951 "../src/Photo.vala"
			_tmp7_ = key_value_map_get_group (trans);
#line 2951 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2951 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, trans);
#line 2951 "../src/Photo.vala"
			_g_free0 (_tmp8_);
#line 2953 "../src/Photo.vala"
			_tmp9_ = photo_table_get_instance ();
#line 2953 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2953 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2953 "../src/Photo.vala"
			_tmp12_ = _tmp11_->photo_id;
#line 2953 "../src/Photo.vala"
			_tmp13_ = photo_table_set_original_transforms (_tmp10_, &_tmp12_, trans);
#line 2953 "../src/Photo.vala"
			_database_table_unref0 (_tmp10_);
#line 2953 "../src/Photo.vala"
			result = _tmp13_;
#line 21895 "Photo.c"
			{
				PhotoRow* _tmp14_;
#line 2946 "../src/Photo.vala"
				_tmp14_ = self->row;
#line 2946 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21902 "Photo.c"
			}
#line 2953 "../src/Photo.vala"
			return result;
#line 21906 "Photo.c"
		}
		__finally209:
		{
			PhotoRow* _tmp15_;
#line 2946 "../src/Photo.vala"
			_tmp15_ = self->row;
#line 2946 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21915 "Photo.c"
		}
#line 2946 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2946 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2946 "../src/Photo.vala"
		return _tmp16_;
#line 21923 "Photo.c"
	}
}

static gboolean
photo_clear_original_transforms (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 2957 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21934 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 2958 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2958 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21942 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp5_;
			PhotoTable* _tmp6_;
			PhotoRow* _tmp7_;
			PhotoID _tmp8_;
			gboolean _tmp9_;
#line 2959 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2959 "../src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2959 "../src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21957 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 2960 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2960 "../src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2960 "../src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2960 "../src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 21968 "Photo.c"
			}
#line 2962 "../src/Photo.vala"
			_tmp5_ = photo_table_get_instance ();
#line 2962 "../src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 2962 "../src/Photo.vala"
			_tmp7_ = self->row;
#line 2962 "../src/Photo.vala"
			_tmp8_ = _tmp7_->photo_id;
#line 2962 "../src/Photo.vala"
			_tmp9_ = photo_table_set_original_transforms (_tmp6_, &_tmp8_, NULL);
#line 2962 "../src/Photo.vala"
			_database_table_unref0 (_tmp6_);
#line 2962 "../src/Photo.vala"
			result = _tmp9_;
#line 21984 "Photo.c"
			{
				PhotoRow* _tmp10_;
#line 2958 "../src/Photo.vala"
				_tmp10_ = self->row;
#line 2958 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21991 "Photo.c"
			}
#line 2962 "../src/Photo.vala"
			return result;
#line 21995 "Photo.c"
		}
		__finally210:
		{
			PhotoRow* _tmp11_;
#line 2958 "../src/Photo.vala"
			_tmp11_ = self->row;
#line 2958 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22004 "Photo.c"
		}
#line 2958 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2958 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 2958 "../src/Photo.vala"
		return _tmp12_;
#line 22012 "Photo.c"
	}
}

static gboolean
photo_remove_transformation (Photo* self,
                             const gchar* name)
{
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 2966 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2966 "../src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22029 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 2968 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 2968 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22036 "Photo.c"
		{
			PhotoRow* _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp10_;
			PhotoTable* _tmp11_;
			PhotoRow* _tmp12_;
			PhotoID _tmp13_;
#line 2969 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 2969 "../src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2969 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22050 "Photo.c"
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
				PhotoRow* _tmp5_;
				GeeHashMap* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 2970 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 2970 "../src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2970 "../src/Photo.vala"
				altered_cache = gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, name, NULL);
#line 2971 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 2971 "../src/Photo.vala"
				_tmp6_ = _tmp5_->transformations;
#line 2971 "../src/Photo.vala"
				_tmp7_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp6_);
#line 2971 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2971 "../src/Photo.vala"
				if (_tmp8_ == 0) {
#line 22073 "Photo.c"
					PhotoRow* _tmp9_;
#line 2972 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 2972 "../src/Photo.vala"
					_g_object_unref0 (_tmp9_->transformations);
#line 2972 "../src/Photo.vala"
					_tmp9_->transformations = NULL;
#line 22081 "Photo.c"
				}
			} else {
#line 2975 "../src/Photo.vala"
				altered_cache = FALSE;
#line 22086 "Photo.c"
			}
#line 2978 "../src/Photo.vala"
			_tmp10_ = photo_table_get_instance ();
#line 2978 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2978 "../src/Photo.vala"
			_tmp12_ = self->row;
#line 2978 "../src/Photo.vala"
			_tmp13_ = _tmp12_->photo_id;
#line 2978 "../src/Photo.vala"
			altered_persistent = photo_table_remove_transformation (_tmp11_, &_tmp13_, name);
#line 2978 "../src/Photo.vala"
			_database_table_unref0 (_tmp11_);
#line 22100 "Photo.c"
		}
		__finally211:
		{
			PhotoRow* _tmp14_;
#line 2968 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 2968 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22109 "Photo.c"
		}
#line 2968 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22113 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 2968 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2968 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 2968 "../src/Photo.vala"
			return _tmp15_;
#line 22121 "Photo.c"
		}
	}
#line 2982 "../src/Photo.vala"
	if (altered_cache) {
#line 2982 "../src/Photo.vala"
		_tmp16_ = TRUE;
#line 22128 "Photo.c"
	} else {
#line 2982 "../src/Photo.vala"
		_tmp16_ = altered_persistent;
#line 22132 "Photo.c"
	}
#line 2982 "../src/Photo.vala"
	result = _tmp16_;
#line 2982 "../src/Photo.vala"
	return result;
#line 22138 "Photo.c"
}

gboolean
photo_has_crop (Photo* self)
{
	gboolean result = FALSE;
#line 2985 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2986 "../src/Photo.vala"
	result = photo_has_transformation (self, "crop");
#line 2986 "../src/Photo.vala"
	return result;
#line 22151 "Photo.c"
}

gboolean
photo_get_raw_crop (Photo* self,
                    Box* crop)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint left = 0;
	KeyValueMap* _tmp2_;
	gint top = 0;
	KeyValueMap* _tmp3_;
	gint right = 0;
	KeyValueMap* _tmp4_;
	gint bottom = 0;
	KeyValueMap* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
#line 2990 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2991 "../src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2993 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2993 "../src/Photo.vala"
	map = _tmp0_;
#line 2994 "../src/Photo.vala"
	_tmp1_ = map;
#line 2994 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2995 "../src/Photo.vala"
		result = FALSE;
#line 2995 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2995 "../src/Photo.vala"
		if (crop) {
#line 2995 "../src/Photo.vala"
			*crop = _vala_crop;
#line 22194 "Photo.c"
		}
#line 2995 "../src/Photo.vala"
		return result;
#line 22198 "Photo.c"
	}
#line 2998 "../src/Photo.vala"
	_tmp2_ = map;
#line 2998 "../src/Photo.vala"
	left = key_value_map_get_int (_tmp2_, "left", -1);
#line 2999 "../src/Photo.vala"
	_tmp3_ = map;
#line 2999 "../src/Photo.vala"
	top = key_value_map_get_int (_tmp3_, "top", -1);
#line 3000 "../src/Photo.vala"
	_tmp4_ = map;
#line 3000 "../src/Photo.vala"
	right = key_value_map_get_int (_tmp4_, "right", -1);
#line 3001 "../src/Photo.vala"
	_tmp5_ = map;
#line 3001 "../src/Photo.vala"
	bottom = key_value_map_get_int (_tmp5_, "bottom", -1);
#line 3003 "../src/Photo.vala"
	if (left == -1) {
#line 3003 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 22220 "Photo.c"
	} else {
#line 3003 "../src/Photo.vala"
		_tmp8_ = top == -1;
#line 22224 "Photo.c"
	}
#line 3003 "../src/Photo.vala"
	if (_tmp8_) {
#line 3003 "../src/Photo.vala"
		_tmp7_ = TRUE;
#line 22230 "Photo.c"
	} else {
#line 3003 "../src/Photo.vala"
		_tmp7_ = right == -1;
#line 22234 "Photo.c"
	}
#line 3003 "../src/Photo.vala"
	if (_tmp7_) {
#line 3003 "../src/Photo.vala"
		_tmp6_ = TRUE;
#line 22240 "Photo.c"
	} else {
#line 3003 "../src/Photo.vala"
		_tmp6_ = bottom == -1;
#line 22244 "Photo.c"
	}
#line 3003 "../src/Photo.vala"
	if (_tmp6_) {
#line 3004 "../src/Photo.vala"
		result = FALSE;
#line 3004 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3004 "../src/Photo.vala"
		if (crop) {
#line 3004 "../src/Photo.vala"
			*crop = _vala_crop;
#line 22256 "Photo.c"
		}
#line 3004 "../src/Photo.vala"
		return result;
#line 22260 "Photo.c"
	}
#line 3007 "../src/Photo.vala"
	box_init (&_vala_crop, left, top, right, bottom);
#line 3009 "../src/Photo.vala"
	result = TRUE;
#line 3009 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3009 "../src/Photo.vala"
	if (crop) {
#line 3009 "../src/Photo.vala"
		*crop = _vala_crop;
#line 22272 "Photo.c"
	}
#line 3009 "../src/Photo.vala"
	return result;
#line 22276 "Photo.c"
}

static void
photo_set_raw_crop (Photo* self,
                    Box* crop)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	KeyValueMap* _tmp3_;
	Box _tmp4_;
	KeyValueMap* _tmp5_;
	Box _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	KeyValueMap* _tmp9_;
#line 3013 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3013 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 3014 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 3014 "../src/Photo.vala"
	map = _tmp0_;
#line 3015 "../src/Photo.vala"
	_tmp1_ = map;
#line 3015 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 3015 "../src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp2_.left);
#line 3016 "../src/Photo.vala"
	_tmp3_ = map;
#line 3016 "../src/Photo.vala"
	_tmp4_ = *crop;
#line 3016 "../src/Photo.vala"
	key_value_map_set_int (_tmp3_, "top", _tmp4_.top);
#line 3017 "../src/Photo.vala"
	_tmp5_ = map;
#line 3017 "../src/Photo.vala"
	_tmp6_ = *crop;
#line 3017 "../src/Photo.vala"
	key_value_map_set_int (_tmp5_, "right", _tmp6_.right);
#line 3018 "../src/Photo.vala"
	_tmp7_ = map;
#line 3018 "../src/Photo.vala"
	_tmp8_ = *crop;
#line 3018 "../src/Photo.vala"
	key_value_map_set_int (_tmp7_, "bottom", _tmp8_.bottom);
#line 3020 "../src/Photo.vala"
	_tmp9_ = map;
#line 3020 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp9_)) {
#line 22330 "Photo.c"
		Alteration* _tmp10_;
		Alteration* _tmp11_;
#line 3021 "../src/Photo.vala"
		_tmp10_ = alteration_new ("image", "crop");
#line 3021 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 3021 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp11_);
#line 3021 "../src/Photo.vala"
		_alteration_unref0 (_tmp11_);
#line 22341 "Photo.c"
	}
#line 3013 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22345 "Photo.c"
}

static gboolean
photo_get_raw_straighten (Photo* self,
                          gdouble* angle)
{
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3025 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3026 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 3026 "../src/Photo.vala"
	map = _tmp0_;
#line 3027 "../src/Photo.vala"
	_tmp1_ = map;
#line 3027 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3028 "../src/Photo.vala"
		_vala_angle = 0.0;
#line 3030 "../src/Photo.vala"
		result = FALSE;
#line 3030 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3030 "../src/Photo.vala"
		if (angle) {
#line 3030 "../src/Photo.vala"
			*angle = _vala_angle;
#line 22378 "Photo.c"
		}
#line 3030 "../src/Photo.vala"
		return result;
#line 22382 "Photo.c"
	}
#line 3033 "../src/Photo.vala"
	_tmp2_ = map;
#line 3033 "../src/Photo.vala"
	_vala_angle = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 3035 "../src/Photo.vala"
	result = TRUE;
#line 3035 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3035 "../src/Photo.vala"
	if (angle) {
#line 3035 "../src/Photo.vala"
		*angle = _vala_angle;
#line 22396 "Photo.c"
	}
#line 3035 "../src/Photo.vala"
	return result;
#line 22400 "Photo.c"
}

static void
photo_set_raw_straighten (Photo* self,
                          gdouble theta)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
#line 3038 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3039 "../src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 3039 "../src/Photo.vala"
	map = _tmp0_;
#line 3040 "../src/Photo.vala"
	_tmp1_ = map;
#line 3040 "../src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", theta);
#line 3042 "../src/Photo.vala"
	_tmp2_ = map;
#line 3042 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp2_)) {
#line 22425 "Photo.c"
		Alteration* _tmp3_;
		Alteration* _tmp4_;
#line 3043 "../src/Photo.vala"
		_tmp3_ = alteration_new ("image", "straighten");
#line 3043 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3043 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp4_);
#line 3043 "../src/Photo.vala"
		_alteration_unref0 (_tmp4_);
#line 22436 "Photo.c"
	}
#line 3038 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22440 "Photo.c"
}

static EditingToolsRedeyeInstance*
photo_get_raw_redeye_instances (Photo* self,
                                gint* result_length1)
{
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	EditingToolsRedeyeInstance* res = NULL;
	EditingToolsRedeyeInstance* _tmp5_;
	gint res_length1;
	gint _res_size_;
	GdkPoint default_point = {0};
	GdkPoint _tmp6_ = {0};
	EditingToolsRedeyeInstance* _tmp29_;
	gint _tmp29__length1;
#line 3048 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3049 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3049 "../src/Photo.vala"
	map = _tmp0_;
#line 3050 "../src/Photo.vala"
	_tmp1_ = map;
#line 3050 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22471 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_;
		EditingToolsRedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 3051 "../src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 3051 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3051 "../src/Photo.vala"
		_tmp3__length1 = 0;
#line 3051 "../src/Photo.vala"
		if (result_length1) {
#line 3051 "../src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 22485 "Photo.c"
		}
#line 3051 "../src/Photo.vala"
		result = _tmp3_;
#line 3051 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3051 "../src/Photo.vala"
		return result;
#line 22493 "Photo.c"
	}
#line 3054 "../src/Photo.vala"
	_tmp4_ = map;
#line 3054 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3055 "../src/Photo.vala"
	_vala_assert (num_points > 0, "num_points > 0");
#line 3057 "../src/Photo.vala"
	_tmp5_ = g_new0 (EditingToolsRedeyeInstance, num_points);
#line 3057 "../src/Photo.vala"
	res = _tmp5_;
#line 3057 "../src/Photo.vala"
	res_length1 = num_points;
#line 3057 "../src/Photo.vala"
	_res_size_ = res_length1;
#line 3059 "../src/Photo.vala"
	_tmp6_.x = 0;
#line 3059 "../src/Photo.vala"
	default_point = _tmp6_;
#line 3060 "../src/Photo.vala"
	default_point.x = -1;
#line 3061 "../src/Photo.vala"
	default_point.y = -1;
#line 22517 "Photo.c"
	{
		gint i = 0;
#line 3063 "../src/Photo.vala"
		i = 0;
#line 22522 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
#line 3063 "../src/Photo.vala"
			_tmp7_ = TRUE;
#line 3063 "../src/Photo.vala"
			while (TRUE) {
#line 22529 "Photo.c"
				gchar* center_key = NULL;
				gchar* _tmp9_;
				gchar* radius_key = NULL;
				gchar* _tmp10_;
				EditingToolsRedeyeInstance* _tmp11_;
				gint _tmp11__length1;
				KeyValueMap* _tmp12_;
				const gchar* _tmp13_;
				GdkPoint _tmp14_;
				GdkPoint _tmp15_ = {0};
				EditingToolsRedeyeInstance* _tmp16_;
				gint _tmp16__length1;
				EditingToolsRedeyeInstance _tmp17_;
				GdkPoint _tmp18_;
				GdkPoint _tmp19_;
				EditingToolsRedeyeInstance* _tmp20_;
				gint _tmp20__length1;
				EditingToolsRedeyeInstance _tmp21_;
				GdkPoint _tmp22_;
				GdkPoint _tmp23_;
				EditingToolsRedeyeInstance* _tmp24_;
				gint _tmp24__length1;
				KeyValueMap* _tmp25_;
				const gchar* _tmp26_;
				EditingToolsRedeyeInstance* _tmp27_;
				gint _tmp27__length1;
				EditingToolsRedeyeInstance _tmp28_;
#line 3063 "../src/Photo.vala"
				if (!_tmp7_) {
#line 22559 "Photo.c"
					gint _tmp8_;
#line 3063 "../src/Photo.vala"
					_tmp8_ = i;
#line 3063 "../src/Photo.vala"
					i = _tmp8_ + 1;
#line 22565 "Photo.c"
				}
#line 3063 "../src/Photo.vala"
				_tmp7_ = FALSE;
#line 3063 "../src/Photo.vala"
				if (!(i < num_points)) {
#line 3063 "../src/Photo.vala"
					break;
#line 22573 "Photo.c"
				}
#line 3064 "../src/Photo.vala"
				_tmp9_ = g_strdup_printf ("center%d", i);
#line 3064 "../src/Photo.vala"
				center_key = _tmp9_;
#line 3065 "../src/Photo.vala"
				_tmp10_ = g_strdup_printf ("radius%d", i);
#line 3065 "../src/Photo.vala"
				radius_key = _tmp10_;
#line 3067 "../src/Photo.vala"
				_tmp11_ = res;
#line 3067 "../src/Photo.vala"
				_tmp11__length1 = res_length1;
#line 3067 "../src/Photo.vala"
				_tmp12_ = map;
#line 3067 "../src/Photo.vala"
				_tmp13_ = center_key;
#line 3067 "../src/Photo.vala"
				_tmp14_ = default_point;
#line 3067 "../src/Photo.vala"
				key_value_map_get_point (_tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
#line 3067 "../src/Photo.vala"
				_tmp11_[i].center = _tmp15_;
#line 3068 "../src/Photo.vala"
				_tmp16_ = res;
#line 3068 "../src/Photo.vala"
				_tmp16__length1 = res_length1;
#line 3068 "../src/Photo.vala"
				_tmp17_ = _tmp16_[i];
#line 3068 "../src/Photo.vala"
				_tmp18_ = _tmp17_.center;
#line 3068 "../src/Photo.vala"
				_tmp19_ = default_point;
#line 3068 "../src/Photo.vala"
				_vala_assert (_tmp18_.x != _tmp19_.x, "res[i].center.x != default_point.x");
#line 3069 "../src/Photo.vala"
				_tmp20_ = res;
#line 3069 "../src/Photo.vala"
				_tmp20__length1 = res_length1;
#line 3069 "../src/Photo.vala"
				_tmp21_ = _tmp20_[i];
#line 3069 "../src/Photo.vala"
				_tmp22_ = _tmp21_.center;
#line 3069 "../src/Photo.vala"
				_tmp23_ = default_point;
#line 3069 "../src/Photo.vala"
				_vala_assert (_tmp22_.y != _tmp23_.y, "res[i].center.y != default_point.y");
#line 3071 "../src/Photo.vala"
				_tmp24_ = res;
#line 3071 "../src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 3071 "../src/Photo.vala"
				_tmp25_ = map;
#line 3071 "../src/Photo.vala"
				_tmp26_ = radius_key;
#line 3071 "../src/Photo.vala"
				_tmp24_[i].radius = key_value_map_get_int (_tmp25_, _tmp26_, -1);
#line 3072 "../src/Photo.vala"
				_tmp27_ = res;
#line 3072 "../src/Photo.vala"
				_tmp27__length1 = res_length1;
#line 3072 "../src/Photo.vala"
				_tmp28_ = _tmp27_[i];
#line 3072 "../src/Photo.vala"
				_vala_assert (_tmp28_.radius != -1, "res[i].radius != -1");
#line 3063 "../src/Photo.vala"
				_g_free0 (radius_key);
#line 3063 "../src/Photo.vala"
				_g_free0 (center_key);
#line 22643 "Photo.c"
			}
		}
	}
#line 3075 "../src/Photo.vala"
	_tmp29_ = res;
#line 3075 "../src/Photo.vala"
	_tmp29__length1 = res_length1;
#line 3075 "../src/Photo.vala"
	if (result_length1) {
#line 3075 "../src/Photo.vala"
		*result_length1 = _tmp29__length1;
#line 22655 "Photo.c"
	}
#line 3075 "../src/Photo.vala"
	result = _tmp29_;
#line 3075 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 3075 "../src/Photo.vala"
	return result;
#line 22663 "Photo.c"
}

gboolean
photo_has_redeye_transformations (Photo* self)
{
	gboolean result = FALSE;
#line 3078 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3079 "../src/Photo.vala"
	result = photo_has_transformation (self, "redeye");
#line 3079 "../src/Photo.vala"
	return result;
#line 22676 "Photo.c"
}

void
photo_add_redeye_instance (Photo* self,
                           EditingToolsRedeyeInstance* redeye)
{
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_;
	KeyValueMap* _tmp1_;
	gint num_points = 0;
	KeyValueMap* _tmp4_;
	gint _tmp5_;
	gchar* radius_key = NULL;
	gchar* _tmp6_;
	gchar* center_key = NULL;
	gchar* _tmp7_;
	KeyValueMap* _tmp8_;
	const gchar* _tmp9_;
	EditingToolsRedeyeInstance _tmp10_;
	KeyValueMap* _tmp11_;
	const gchar* _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	KeyValueMap* _tmp15_;
	KeyValueMap* _tmp16_;
#line 3083 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3083 "../src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 3084 "../src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 3084 "../src/Photo.vala"
	map = _tmp0_;
#line 3085 "../src/Photo.vala"
	_tmp1_ = map;
#line 3085 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22714 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 3086 "../src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 3086 "../src/Photo.vala"
		_key_value_map_unref0 (map);
#line 3086 "../src/Photo.vala"
		map = _tmp2_;
#line 3087 "../src/Photo.vala"
		_tmp3_ = map;
#line 3087 "../src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 22727 "Photo.c"
	}
#line 3090 "../src/Photo.vala"
	_tmp4_ = map;
#line 3090 "../src/Photo.vala"
	num_points = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 3091 "../src/Photo.vala"
	_vala_assert (num_points >= 0, "num_points >= 0");
#line 3093 "../src/Photo.vala"
	_tmp5_ = num_points;
#line 3093 "../src/Photo.vala"
	num_points = _tmp5_ + 1;
#line 3095 "../src/Photo.vala"
	_tmp6_ = g_strdup_printf ("radius%d", num_points - 1);
#line 3095 "../src/Photo.vala"
	radius_key = _tmp6_;
#line 3096 "../src/Photo.vala"
	_tmp7_ = g_strdup_printf ("center%d", num_points - 1);
#line 3096 "../src/Photo.vala"
	center_key = _tmp7_;
#line 3098 "../src/Photo.vala"
	_tmp8_ = map;
#line 3098 "../src/Photo.vala"
	_tmp9_ = radius_key;
#line 3098 "../src/Photo.vala"
	_tmp10_ = *redeye;
#line 3098 "../src/Photo.vala"
	key_value_map_set_int (_tmp8_, _tmp9_, _tmp10_.radius);
#line 3099 "../src/Photo.vala"
	_tmp11_ = map;
#line 3099 "../src/Photo.vala"
	_tmp12_ = center_key;
#line 3099 "../src/Photo.vala"
	_tmp13_ = *redeye;
#line 3099 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 3099 "../src/Photo.vala"
	key_value_map_set_point (_tmp11_, _tmp12_, &_tmp14_);
#line 3101 "../src/Photo.vala"
	_tmp15_ = map;
#line 3101 "../src/Photo.vala"
	key_value_map_set_int (_tmp15_, "num_points", num_points);
#line 3103 "../src/Photo.vala"
	_tmp16_ = map;
#line 3103 "../src/Photo.vala"
	if (photo_set_transformation (self, _tmp16_)) {
#line 22773 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 3104 "../src/Photo.vala"
		_tmp17_ = alteration_new ("image", "redeye");
#line 3104 "../src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3104 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp18_);
#line 3104 "../src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 22784 "Photo.c"
	}
#line 3083 "../src/Photo.vala"
	_g_free0 (center_key);
#line 3083 "../src/Photo.vala"
	_g_free0 (radius_key);
#line 3083 "../src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22792 "Photo.c"
}

static gboolean
photo_calculate_pixbuf_dimensions (Photo* self,
                                   Scaling* scaling,
                                   PhotoException exceptions,
                                   Dimensions* scaled_image,
                                   Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 3119 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3119 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 22810 "Photo.c"
	{
		PhotoRow* _tmp0_;
		gboolean _tmp7_ = FALSE;
#line 3121 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3121 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22818 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			gboolean _tmp4_;
#line 3123 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3123 "../src/Photo.vala"
			_tmp4_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, exceptions, &_tmp2_, &_tmp3_);
#line 3123 "../src/Photo.vala"
			_vala_scaled_image = _tmp2_;
#line 3123 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp3_;
#line 3123 "../src/Photo.vala"
			result = _tmp4_;
#line 22834 "Photo.c"
			{
				PhotoRow* _tmp5_;
#line 3121 "../src/Photo.vala"
				_tmp5_ = self->row;
#line 3121 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22841 "Photo.c"
			}
#line 3123 "../src/Photo.vala"
			if (scaled_image) {
#line 3123 "../src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 22847 "Photo.c"
			}
#line 3123 "../src/Photo.vala"
			if (scaled_to_viewport) {
#line 3123 "../src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22853 "Photo.c"
			}
#line 3123 "../src/Photo.vala"
			return result;
#line 22857 "Photo.c"
		}
		__finally212:
		{
			PhotoRow* _tmp6_;
#line 3121 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 3121 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22866 "Photo.c"
		}
#line 3121 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3121 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3121 "../src/Photo.vala"
		return _tmp7_;
#line 22874 "Photo.c"
	}
#line 3119 "../src/Photo.vala"
	if (scaled_image) {
#line 3119 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 22880 "Photo.c"
	}
#line 3119 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3119 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22886 "Photo.c"
	}
}

static gboolean
photo_locked_calculate_pixbuf_dimensions (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          Dimensions* scaled_image,
                                          Dimensions* scaled_to_viewport)
{
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	gboolean _tmp36_ = FALSE;
	Dimensions _tmp37_;
	Dimensions _tmp38_;
#line 3129 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3129 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3131 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3131 "../src/Photo.vala"
	raw = _tmp0_;
#line 3133 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 22916 "Photo.c"
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 3134 "../src/Photo.vala"
		_tmp1_ = raw;
#line 3134 "../src/Photo.vala"
		_vala_scaled_image = _tmp1_;
#line 3135 "../src/Photo.vala"
		_tmp2_ = raw;
#line 3135 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp2_;
#line 3137 "../src/Photo.vala"
		result = FALSE;
#line 3137 "../src/Photo.vala"
		if (scaled_image) {
#line 3137 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 22933 "Photo.c"
		}
#line 3137 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3137 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 22939 "Photo.c"
		}
#line 3137 "../src/Photo.vala"
		return result;
#line 22943 "Photo.c"
	}
#line 3140 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 3145 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3146 "../src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3148 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 22953 "Photo.c"
		Box crop = {0};
		Box _tmp3_ = {0};
		gboolean _tmp4_;
#line 3150 "../src/Photo.vala"
		_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 3150 "../src/Photo.vala"
		crop = _tmp3_;
#line 3150 "../src/Photo.vala"
		if (_tmp4_) {
#line 22963 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp5_;
			Box scaled_crop = {0};
			Dimensions _tmp13_ = {0};
			Dimensions _tmp14_ = {0};
			Box _tmp15_ = {0};
			Dimensions _tmp16_ = {0};
			gboolean _tmp17_ = FALSE;
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
#line 3153 "../src/Photo.vala"
			_tmp5_ = raw;
#line 3153 "../src/Photo.vala"
			rotated_raw = _tmp5_;
#line 3154 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 22981 "Photo.c"
				Orientation _tmp6_;
				Dimensions _tmp7_;
				Box _tmp8_;
				Box _tmp9_ = {0};
				Orientation _tmp10_;
				Dimensions _tmp11_;
				Dimensions _tmp12_ = {0};
#line 3155 "../src/Photo.vala"
				_tmp6_ = orientation;
#line 3155 "../src/Photo.vala"
				_tmp7_ = raw;
#line 3155 "../src/Photo.vala"
				_tmp8_ = crop;
#line 3155 "../src/Photo.vala"
				orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 3155 "../src/Photo.vala"
				crop = _tmp9_;
#line 3156 "../src/Photo.vala"
				_tmp10_ = orientation;
#line 3156 "../src/Photo.vala"
				_tmp11_ = raw;
#line 3156 "../src/Photo.vala"
				orientation_rotate_dimensions (_tmp10_, &_tmp11_, &_tmp12_);
#line 3156 "../src/Photo.vala"
				rotated_raw = _tmp12_;
#line 23007 "Photo.c"
			}
#line 3160 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp13_);
#line 3160 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp13_, &_tmp14_);
#line 3160 "../src/Photo.vala"
			box_get_scaled (&crop, &_tmp14_, &_tmp15_);
#line 3160 "../src/Photo.vala"
			scaled_crop = _tmp15_;
#line 3163 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp16_);
#line 3163 "../src/Photo.vala"
			_vala_scaled_to_viewport = _tmp16_;
#line 3166 "../src/Photo.vala"
			if (box_get_width (&crop) <= box_get_width (&scaled_crop)) {
#line 3167 "../src/Photo.vala"
				_tmp17_ = box_get_height (&crop) <= box_get_height (&scaled_crop);
#line 23025 "Photo.c"
			} else {
#line 3166 "../src/Photo.vala"
				_tmp17_ = FALSE;
#line 23029 "Photo.c"
			}
#line 3166 "../src/Photo.vala"
			if (_tmp17_) {
#line 23033 "Photo.c"
				Dimensions _tmp18_;
				Dimensions _tmp19_ = {0};
#line 3168 "../src/Photo.vala"
				_tmp18_ = raw;
#line 3168 "../src/Photo.vala"
				_vala_scaled_image = _tmp18_;
#line 3169 "../src/Photo.vala"
				box_get_dimensions (&crop, &_tmp19_);
#line 3169 "../src/Photo.vala"
				_vala_scaled_to_viewport = _tmp19_;
#line 3171 "../src/Photo.vala"
				result = FALSE;
#line 3171 "../src/Photo.vala"
				if (scaled_image) {
#line 3171 "../src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23050 "Photo.c"
				}
#line 3171 "../src/Photo.vala"
				if (scaled_to_viewport) {
#line 3171 "../src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23056 "Photo.c"
				}
#line 3171 "../src/Photo.vala"
				return result;
#line 23060 "Photo.c"
			}
#line 3176 "../src/Photo.vala"
			box_get_dimensions (&crop, &_tmp20_);
#line 3176 "../src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp21_);
#line 3176 "../src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp20_, &_tmp21_, &_tmp22_);
#line 3176 "../src/Photo.vala"
			_vala_scaled_image = _tmp22_;
#line 3180 "../src/Photo.vala"
			if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23072 "Photo.c"
				Orientation _tmp23_;
				Dimensions _tmp24_;
				Dimensions _tmp25_ = {0};
#line 3181 "../src/Photo.vala"
				_tmp23_ = orientation;
#line 3181 "../src/Photo.vala"
				_tmp24_ = _vala_scaled_image;
#line 3181 "../src/Photo.vala"
				orientation_derotate_dimensions (_tmp23_, &_tmp24_, &_tmp25_);
#line 3181 "../src/Photo.vala"
				_vala_scaled_image = _tmp25_;
#line 23084 "Photo.c"
			}
		}
	}
#line 3187 "../src/Photo.vala"
	if (!dimensions_has_area (&_vala_scaled_image)) {
#line 23090 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp26_;
		Dimensions _tmp30_;
		Dimensions _tmp31_ = {0};
		Dimensions _tmp32_;
#line 3189 "../src/Photo.vala"
		_tmp26_ = raw;
#line 3189 "../src/Photo.vala"
		rotated_raw = _tmp26_;
#line 3190 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23102 "Photo.c"
			Orientation _tmp27_;
			Dimensions _tmp28_;
			Dimensions _tmp29_ = {0};
#line 3191 "../src/Photo.vala"
			_tmp27_ = orientation;
#line 3191 "../src/Photo.vala"
			_tmp28_ = raw;
#line 3191 "../src/Photo.vala"
			orientation_rotate_dimensions (_tmp27_, &_tmp28_, &_tmp29_);
#line 3191 "../src/Photo.vala"
			rotated_raw = _tmp29_;
#line 23114 "Photo.c"
		}
#line 3194 "../src/Photo.vala"
		_tmp30_ = rotated_raw;
#line 3194 "../src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp30_, &_tmp31_);
#line 3194 "../src/Photo.vala"
		_vala_scaled_image = _tmp31_;
#line 3195 "../src/Photo.vala"
		_tmp32_ = _vala_scaled_image;
#line 3195 "../src/Photo.vala"
		_vala_scaled_to_viewport = _tmp32_;
#line 3198 "../src/Photo.vala"
		if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 23128 "Photo.c"
			Orientation _tmp33_;
			Dimensions _tmp34_;
			Dimensions _tmp35_ = {0};
#line 3199 "../src/Photo.vala"
			_tmp33_ = orientation;
#line 3199 "../src/Photo.vala"
			_tmp34_ = _vala_scaled_image;
#line 3199 "../src/Photo.vala"
			orientation_derotate_dimensions (_tmp33_, &_tmp34_, &_tmp35_);
#line 3199 "../src/Photo.vala"
			_vala_scaled_image = _tmp35_;
#line 23140 "Photo.c"
		}
	}
#line 3204 "../src/Photo.vala"
	_tmp37_ = _vala_scaled_image;
#line 3204 "../src/Photo.vala"
	_tmp38_ = raw;
#line 3204 "../src/Photo.vala"
	if (_tmp37_.width >= _tmp38_.width) {
#line 23149 "Photo.c"
		Dimensions _tmp39_;
		Dimensions _tmp40_;
#line 3204 "../src/Photo.vala"
		_tmp39_ = _vala_scaled_image;
#line 3204 "../src/Photo.vala"
		_tmp40_ = raw;
#line 3204 "../src/Photo.vala"
		_tmp36_ = _tmp39_.height >= _tmp40_.height;
#line 23158 "Photo.c"
	} else {
#line 3204 "../src/Photo.vala"
		_tmp36_ = FALSE;
#line 23162 "Photo.c"
	}
#line 3204 "../src/Photo.vala"
	if (_tmp36_) {
#line 23166 "Photo.c"
		Dimensions _tmp41_;
#line 3205 "../src/Photo.vala"
		_tmp41_ = raw;
#line 3205 "../src/Photo.vala"
		_vala_scaled_image = _tmp41_;
#line 3207 "../src/Photo.vala"
		result = FALSE;
#line 3207 "../src/Photo.vala"
		if (scaled_image) {
#line 3207 "../src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23178 "Photo.c"
		}
#line 3207 "../src/Photo.vala"
		if (scaled_to_viewport) {
#line 3207 "../src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23184 "Photo.c"
		}
#line 3207 "../src/Photo.vala"
		return result;
#line 23188 "Photo.c"
	}
#line 3210 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_image), "scaled_image.has_area ()");
#line 3211 "../src/Photo.vala"
	_vala_assert (dimensions_has_area (&_vala_scaled_to_viewport), "scaled_to_viewport.has_area ()");
#line 3213 "../src/Photo.vala"
	result = TRUE;
#line 3213 "../src/Photo.vala"
	if (scaled_image) {
#line 3213 "../src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23200 "Photo.c"
	}
#line 3213 "../src/Photo.vala"
	if (scaled_to_viewport) {
#line 3213 "../src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23206 "Photo.c"
	}
#line 3213 "../src/Photo.vala"
	return result;
#line 23210 "Photo.c"
}

static GdkPixbuf*
photo_load_raw_pixbuf (Photo* self,
                       Scaling* scaling,
                       PhotoException exceptions,
                       BackingFetchMode fetch_mode,
                       GError** error)
{
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	PhotoFileReader* _tmp0_;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp17_;
	Dimensions _tmp18_ = {0};
	GError* _inner_error0_ = NULL;
#line 3219 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3219 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3222 "../src/Photo.vala"
	_tmp0_ = photo_get_backing_reader (self, fetch_mode);
#line 3222 "../src/Photo.vala"
	loader = _tmp0_;
#line 3225 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 23248 "Photo.c"
		GdkPixbuf* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 3230 "../src/Photo.vala"
		_tmp2_ = loader;
#line 3230 "../src/Photo.vala"
		_tmp3_ = photo_file_reader_unscaled_read (_tmp2_, &_inner_error0_);
#line 3230 "../src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 3230 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3230 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3230 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3230 "../src/Photo.vala"
			return NULL;
#line 23267 "Photo.c"
		}
#line 3230 "../src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 3230 "../src/Photo.vala"
		_tmp1_ = NULL;
#line 3230 "../src/Photo.vala"
		result = _tmp4_;
#line 3230 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3230 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3230 "../src/Photo.vala"
		return result;
#line 23281 "Photo.c"
	}
#line 3235 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3235 "../src/Photo.vala"
	_tmp8_ = photo_calculate_pixbuf_dimensions (self, &_tmp5_, exceptions, &_tmp6_, &_tmp7_);
#line 3235 "../src/Photo.vala"
	scaled_image = _tmp6_;
#line 3235 "../src/Photo.vala"
	scaled_to_viewport = _tmp7_;
#line 3235 "../src/Photo.vala"
	is_scaled = _tmp8_;
#line 3237 "../src/Photo.vala"
	if (!is_scaled) {
#line 23295 "Photo.c"
		GdkPixbuf* _tmp9_ = NULL;
		PhotoFileReader* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 3242 "../src/Photo.vala"
		_tmp10_ = loader;
#line 3242 "../src/Photo.vala"
		_tmp11_ = photo_file_reader_unscaled_read (_tmp10_, &_inner_error0_);
#line 3242 "../src/Photo.vala"
		_tmp9_ = _tmp11_;
#line 3242 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3242 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3242 "../src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3242 "../src/Photo.vala"
			return NULL;
#line 23314 "Photo.c"
		}
#line 3242 "../src/Photo.vala"
		_tmp12_ = _tmp9_;
#line 3242 "../src/Photo.vala"
		_tmp9_ = NULL;
#line 3242 "../src/Photo.vala"
		result = _tmp12_;
#line 3242 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 3242 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3242 "../src/Photo.vala"
		return result;
#line 23328 "Photo.c"
	}
#line 3245 "../src/Photo.vala"
	_tmp13_ = loader;
#line 3245 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp14_);
#line 3245 "../src/Photo.vala"
	_tmp15_ = scaled_image;
#line 3245 "../src/Photo.vala"
	_tmp16_ = photo_file_reader_scaled_read (_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 3245 "../src/Photo.vala"
	pixbuf = _tmp16_;
#line 3245 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3245 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3245 "../src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3245 "../src/Photo.vala"
		return NULL;
#line 23348 "Photo.c"
	}
#line 3253 "../src/Photo.vala"
	_tmp17_ = pixbuf;
#line 3253 "../src/Photo.vala"
	dimensions_for_pixbuf (_tmp17_, &_tmp18_);
#line 3253 "../src/Photo.vala"
	_vala_assert (dimensions_approx_equals (&scaled_image, &_tmp18_, PHOTO_SCALING_FUDGE), "scaled_image.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 3255 "../src/Photo.vala"
	result = pixbuf;
#line 3255 "../src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3255 "../src/Photo.vala"
	return result;
#line 23362 "Photo.c"
}

GdkPixbuf*
photo_get_master_pixbuf (Photo* self,
                         Scaling* scaling,
                         gboolean rotate,
                         GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3260 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3260 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3261 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3261 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_MASTER, &_inner_error0_);
#line 3261 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3261 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3261 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3261 "../src/Photo.vala"
		return NULL;
#line 23393 "Photo.c"
	}
#line 3261 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3261 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3261 "../src/Photo.vala"
	result = _tmp3_;
#line 3261 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3261 "../src/Photo.vala"
	return result;
#line 23405 "Photo.c"
}

GdkPixbuf*
photo_get_unmodified_pixbuf (Photo* self,
                             Scaling* scaling,
                             gboolean rotate,
                             GError** error)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3265 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3265 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3266 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3266 "../src/Photo.vala"
	_tmp2_ = photo_get_untransformed_pixbuf (self, &_tmp1_, rotate, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error0_);
#line 3266 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3266 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3266 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3266 "../src/Photo.vala"
		return NULL;
#line 23436 "Photo.c"
	}
#line 3266 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3266 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3266 "../src/Photo.vala"
	result = _tmp3_;
#line 3266 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3266 "../src/Photo.vala"
	return result;
#line 23448 "Photo.c"
}

static GdkPixbuf*
photo_get_untransformed_pixbuf (Photo* self,
                                Scaling* scaling,
                                gboolean rotate,
                                BackingFetchMode fetch_mode,
                                GError** error)
{
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp5_;
	GdkPixbuf* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 3270 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3270 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 23470 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3284 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3284 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23477 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
#line 3285 "../src/Photo.vala"
			_tmp1_ = *scaling;
#line 3285 "../src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3285 "../src/Photo.vala"
			scaled_image = _tmp2_;
#line 3285 "../src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3287 "../src/Photo.vala"
			original_orientation = photo_get_original_orientation (self);
#line 23492 "Photo.c"
		}
		__finally213:
		{
			PhotoRow* _tmp4_;
#line 3284 "../src/Photo.vala"
			_tmp4_ = self->row;
#line 3284 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23501 "Photo.c"
		}
#line 3284 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3284 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3284 "../src/Photo.vala"
			return NULL;
#line 23509 "Photo.c"
		}
	}
#line 3291 "../src/Photo.vala"
	_tmp5_ = *scaling;
#line 3291 "../src/Photo.vala"
	_tmp6_ = photo_load_raw_pixbuf (self, &_tmp5_, PHOTO_EXCEPTION_NONE, fetch_mode, &_inner_error0_);
#line 3291 "../src/Photo.vala"
	pixbuf = _tmp6_;
#line 3291 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3291 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3291 "../src/Photo.vala"
		return NULL;
#line 23524 "Photo.c"
	}
#line 3297 "../src/Photo.vala"
	if (rotate) {
#line 23528 "Photo.c"
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 3298 "../src/Photo.vala"
		_tmp7_ = pixbuf;
#line 3298 "../src/Photo.vala"
		_tmp8_ = orientation_rotate_pixbuf (original_orientation, _tmp7_);
#line 3298 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3298 "../src/Photo.vala"
		pixbuf = _tmp8_;
#line 23539 "Photo.c"
	}
#line 3308 "../src/Photo.vala"
	result = pixbuf;
#line 3308 "../src/Photo.vala"
	return result;
#line 23545 "Photo.c"
}

static GdkPixbuf*
photo_real_get_pixbuf (PhotoSource* base,
                       Scaling* scaling,
                       GError** error)
{
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3311 "../src/Photo.vala"
	self = (Photo*) base;
#line 3311 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3312 "../src/Photo.vala"
	_tmp1_ = *scaling;
#line 3312 "../src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 3312 "../src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3312 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3312 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3312 "../src/Photo.vala"
		return NULL;
#line 23576 "Photo.c"
	}
#line 3312 "../src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3312 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3312 "../src/Photo.vala"
	result = _tmp3_;
#line 3312 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3312 "../src/Photo.vala"
	return result;
#line 23588 "Photo.c"
}

/**
     * Populates the cached version of the unmodified image.
     */
void
photo_populate_prefetched (Photo* self,
                           GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3318 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 23601 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3319 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3319 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23608 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
#line 3321 "../src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3321 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23615 "Photo.c"
				GdkPixbuf* _tmp2_ = NULL;
				Scaling _tmp3_ = {0};
				GdkPixbuf* _tmp4_;
				GdkPixbuf* _tmp5_;
				GTimer* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3322 "../src/Photo.vala"
				scaling_for_original (&_tmp3_);
#line 3322 "../src/Photo.vala"
				_tmp4_ = photo_load_raw_pixbuf (self, &_tmp3_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3322 "../src/Photo.vala"
				_tmp2_ = _tmp4_;
#line 3322 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23631 "Photo.c"
					goto __finally214;
				}
#line 3322 "../src/Photo.vala"
				_tmp5_ = _tmp2_;
#line 3322 "../src/Photo.vala"
				_tmp2_ = NULL;
#line 3322 "../src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3322 "../src/Photo.vala"
				self->priv->unmodified_precached = _tmp5_;
#line 3323 "../src/Photo.vala"
				_tmp6_ = g_timer_new ();
#line 3323 "../src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3323 "../src/Photo.vala"
				self->priv->secs_since_access = _tmp6_;
#line 3324 "../src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3325 "../src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3325 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3325 "../src/Photo.vala"
				g_debug ("Photo.vala:3325: spawning new precache timeout for %s", _tmp8_);
#line 3325 "../src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3321 "../src/Photo.vala"
				_g_object_unref0 (_tmp2_);
#line 23660 "Photo.c"
			}
		}
		__finally214:
		{
			GError* _inner_error1_ = NULL;
			GdkPixbuf* _tmp9_;
#line 3319 "../src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3319 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23671 "Photo.c"
		}
#line 3319 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3319 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3319 "../src/Photo.vala"
			return;
#line 23679 "Photo.c"
		}
	}
}

/**
     * Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf*
photo_get_prefetched_copy (Photo* self)
{
	GdkPixbuf* result = NULL;
	GError* _inner_error0_ = NULL;
#line 3335 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23696 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
#line 3336 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3336 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23703 "Photo.c"
		{
			GdkPixbuf* _tmp1_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 3337 "../src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3337 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23712 "Photo.c"
				{
#line 3339 "../src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error0_);
#line 3339 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23718 "Photo.c"
						goto __catch216_g_error;
					}
				}
				goto __finally216;
				__catch216_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_;
					gchar* _tmp3_;
#line 3338 "../src/Photo.vala"
					e = _inner_error0_;
#line 3338 "../src/Photo.vala"
					_inner_error0_ = NULL;
#line 3341 "../src/Photo.vala"
					_tmp2_ = data_object_to_string ((DataObject*) self);
#line 3341 "../src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3341 "../src/Photo.vala"
					g_warning ("Photo.vala:3341: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3341 "../src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3342 "../src/Photo.vala"
					result = NULL;
#line 3342 "../src/Photo.vala"
					_g_error_free0 (e);
#line 23744 "Photo.c"
					{
						GdkPixbuf* _tmp4_;
#line 3336 "../src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3336 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23751 "Photo.c"
					}
#line 3342 "../src/Photo.vala"
					return result;
#line 23755 "Photo.c"
				}
				__finally216:
#line 3338 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 23760 "Photo.c"
					{
						GdkPixbuf* _tmp5_;
#line 3336 "../src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3336 "../src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23767 "Photo.c"
					}
#line 3338 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3338 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 3338 "../src/Photo.vala"
					return NULL;
#line 23775 "Photo.c"
				}
			}
#line 3346 "../src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3346 "../src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3346 "../src/Photo.vala"
			result = _tmp7_;
#line 23784 "Photo.c"
			{
				GdkPixbuf* _tmp8_;
#line 3336 "../src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3336 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23791 "Photo.c"
			}
#line 3346 "../src/Photo.vala"
			return result;
#line 23795 "Photo.c"
		}
		__finally215:
		{
			GdkPixbuf* _tmp9_;
#line 3336 "../src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3336 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23804 "Photo.c"
		}
#line 3336 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3336 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3336 "../src/Photo.vala"
		return NULL;
#line 23812 "Photo.c"
	}
}

/**
     * Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean
photo_discard_prefetched (Photo* self,
                          gboolean immed)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 3355 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23829 "Photo.c"
	{
		GdkPixbuf* _tmp0_;
		gboolean _tmp12_ = FALSE;
#line 3356 "../src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3356 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23837 "Photo.c"
		{
			GTimer* _tmp1_;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_;
#line 3357 "../src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3357 "../src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3358 "../src/Photo.vala"
				result = FALSE;
#line 23851 "Photo.c"
				{
					GdkPixbuf* _tmp2_;
#line 3356 "../src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3356 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23858 "Photo.c"
				}
#line 3358 "../src/Photo.vala"
				return result;
#line 23862 "Photo.c"
			}
#line 3362 "../src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3362 "../src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3362 "../src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3362 "../src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3362 "../src/Photo.vala"
				_tmp3_ = TRUE;
#line 23874 "Photo.c"
			} else {
#line 3362 "../src/Photo.vala"
				_tmp3_ = immed;
#line 23878 "Photo.c"
			}
#line 3362 "../src/Photo.vala"
			if (_tmp3_) {
#line 23882 "Photo.c"
				gchar* _tmp7_;
				gchar* _tmp8_;
#line 3363 "../src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3363 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3363 "../src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp8_);
#line 3363 "../src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3366 "../src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3366 "../src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3367 "../src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3367 "../src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3368 "../src/Photo.vala"
				result = FALSE;
#line 23903 "Photo.c"
				{
					GdkPixbuf* _tmp9_;
#line 3356 "../src/Photo.vala"
					_tmp9_ = self->priv->unmodified_precached;
#line 3356 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23910 "Photo.c"
				}
#line 3368 "../src/Photo.vala"
				return result;
#line 23914 "Photo.c"
			}
#line 3371 "../src/Photo.vala"
			result = TRUE;
#line 23918 "Photo.c"
			{
				GdkPixbuf* _tmp10_;
#line 3356 "../src/Photo.vala"
				_tmp10_ = self->priv->unmodified_precached;
#line 3356 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23925 "Photo.c"
			}
#line 3371 "../src/Photo.vala"
			return result;
#line 23929 "Photo.c"
		}
		__finally217:
		{
			GdkPixbuf* _tmp11_;
#line 3356 "../src/Photo.vala"
			_tmp11_ = self->priv->unmodified_precached;
#line 3356 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23938 "Photo.c"
		}
#line 3356 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3356 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 3356 "../src/Photo.vala"
		return _tmp12_;
#line 23946 "Photo.c"
	}
}

/**
     * Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf*
photo_get_pixbuf_with_options (Photo* self,
                               Scaling* scaling,
                               PhotoException exceptions,
                               BackingFetchMode fetch_mode,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp22_;
	GTimer* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GdkPixbuf* _tmp26_;
	gboolean _tmp64_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 3386 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3386 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3399 "../src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3399 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3399 "../src/Photo.vala"
	if (_tmp4_) {
#line 3400 "../src/Photo.vala"
		_tmp2_ = photo_get_master_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 24007 "Photo.c"
	} else {
#line 3399 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 24011 "Photo.c"
	}
#line 3399 "../src/Photo.vala"
	if (_tmp2_) {
#line 24015 "Photo.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 3401 "../src/Photo.vala"
		if (fetch_mode == BACKING_FETCH_MODE_BASELINE) {
#line 3401 "../src/Photo.vala"
			_tmp6_ = TRUE;
#line 24022 "Photo.c"
		} else {
#line 3401 "../src/Photo.vala"
			_tmp6_ = fetch_mode == BACKING_FETCH_MODE_UNMODIFIED;
#line 24026 "Photo.c"
		}
#line 3401 "../src/Photo.vala"
		if (_tmp6_) {
#line 3401 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 24032 "Photo.c"
		} else {
#line 3402 "../src/Photo.vala"
			_tmp5_ = fetch_mode == BACKING_FETCH_MODE_SOURCE;
#line 24036 "Photo.c"
		}
#line 3401 "../src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 24040 "Photo.c"
	} else {
#line 3399 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 24044 "Photo.c"
	}
#line 3399 "../src/Photo.vala"
	if (_tmp1_) {
#line 3403 "../src/Photo.vala"
		_tmp0_ = !photo_is_raw_developer_complete (self, photo_get_raw_developer (self));
#line 24050 "Photo.c"
	} else {
#line 3399 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 24054 "Photo.c"
	}
#line 3399 "../src/Photo.vala"
	if (_tmp0_) {
#line 3404 "../src/Photo.vala"
		photo_set_raw_developer (self, photo_get_raw_developer (self));
#line 24060 "Photo.c"
	}
#line 3410 "../src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3411 "../src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3412 "../src/Photo.vala"
	redeye_instances = NULL;
#line 3412 "../src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3412 "../src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3415 "../src/Photo.vala"
	transformer = NULL;
#line 24074 "Photo.c"
	{
		PhotoRow* _tmp7_;
#line 3418 "../src/Photo.vala"
		_tmp7_ = self->row;
#line 3418 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24081 "Photo.c"
		{
			Dimensions _tmp8_ = {0};
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			Dimensions _tmp11_;
			Dimensions _tmp12_ = {0};
			Dimensions _tmp13_;
			gint _tmp14_ = 0;
			EditingToolsRedeyeInstance* _tmp15_;
			Box _tmp16_ = {0};
			gboolean _tmp17_;
			gdouble _tmp18_ = 0.0;
			gboolean _tmp19_;
#line 3419 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ALL, &_tmp8_);
#line 3419 "../src/Photo.vala"
			original = _tmp8_;
#line 3420 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, exceptions, &_tmp9_);
#line 3420 "../src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp9_, &_tmp10_);
#line 3420 "../src/Photo.vala"
			scaled = _tmp10_;
#line 3421 "../src/Photo.vala"
			_tmp11_ = scaled;
#line 3421 "../src/Photo.vala"
			scaled_to_viewport = _tmp11_;
#line 3423 "../src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 3423 "../src/Photo.vala"
			_tmp13_ = scaled;
#line 3423 "../src/Photo.vala"
			is_scaled = !dimensions_equals (&_tmp12_, &_tmp13_);
#line 3425 "../src/Photo.vala"
			_tmp15_ = photo_get_raw_redeye_instances (self, &_tmp14_);
#line 3425 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3425 "../src/Photo.vala"
			redeye_instances = _tmp15_;
#line 3425 "../src/Photo.vala"
			redeye_instances_length1 = _tmp14_;
#line 3425 "../src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3427 "../src/Photo.vala"
			_tmp17_ = photo_get_raw_crop (self, &_tmp16_);
#line 3427 "../src/Photo.vala"
			crop = _tmp16_;
#line 3427 "../src/Photo.vala"
			is_cropped = _tmp17_;
#line 3429 "../src/Photo.vala"
			_tmp19_ = photo_get_raw_straighten (self, &_tmp18_);
#line 3429 "../src/Photo.vala"
			straightening_angle = _tmp18_;
#line 3429 "../src/Photo.vala"
			is_straightened = _tmp19_;
#line 3431 "../src/Photo.vala"
			if (photo_has_color_adjustments (self)) {
#line 24139 "Photo.c"
				PixelTransformer* _tmp20_;
#line 3432 "../src/Photo.vala"
				_tmp20_ = photo_get_pixel_transformer (self);
#line 3432 "../src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3432 "../src/Photo.vala"
				transformer = _tmp20_;
#line 24147 "Photo.c"
			}
#line 3435 "../src/Photo.vala"
			orientation = photo_get_orientation (self);
#line 24151 "Photo.c"
		}
		__finally218:
		{
			PhotoRow* _tmp21_;
#line 3418 "../src/Photo.vala"
			_tmp21_ = self->row;
#line 3418 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24160 "Photo.c"
		}
#line 3418 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3418 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3418 "../src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3418 "../src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3418 "../src/Photo.vala"
			return NULL;
#line 24172 "Photo.c"
		}
	}
#line 3441 "../src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error0_);
#line 3441 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3441 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3441 "../src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3441 "../src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3441 "../src/Photo.vala"
		return NULL;
#line 24187 "Photo.c"
	}
#line 3443 "../src/Photo.vala"
	_tmp22_ = photo_get_prefetched_copy (self);
#line 3443 "../src/Photo.vala"
	pixbuf = _tmp22_;
#line 3446 "../src/Photo.vala"
	_tmp23_ = self->priv->secs_since_access;
#line 3446 "../src/Photo.vala"
	g_timer_start (_tmp23_);
#line 3447 "../src/Photo.vala"
	_tmp24_ = data_object_to_string ((DataObject*) self);
#line 3447 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 3447 "../src/Photo.vala"
	g_debug ("Photo.vala:3447: pipeline being run against %s, timer restarted.", _tmp25_);
#line 3447 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 3449 "../src/Photo.vala"
	_tmp26_ = pixbuf;
#line 3449 "../src/Photo.vala"
	_vala_assert (_tmp26_ != NULL, "pixbuf != null");
#line 3456 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_REDEYE)) {
#line 24211 "Photo.c"
		EditingToolsRedeyeInstance* _tmp27_;
		gint _tmp27__length1;
#line 3461 "../src/Photo.vala"
		_tmp27_ = redeye_instances;
#line 3461 "../src/Photo.vala"
		_tmp27__length1 = redeye_instances_length1;
#line 24218 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3461 "../src/Photo.vala"
			instance_collection = _tmp27_;
#line 3461 "../src/Photo.vala"
			instance_collection_length1 = _tmp27__length1;
#line 3461 "../src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp27__length1; instance_it = instance_it + 1) {
#line 24230 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3461 "../src/Photo.vala"
				instance = instance_collection[instance_it];
#line 24234 "Photo.c"
				{
					GdkPixbuf* _tmp28_;
					EditingToolsRedeyeInstance _tmp29_;
					GdkPixbuf* _tmp30_;
#line 3462 "../src/Photo.vala"
					_tmp28_ = pixbuf;
#line 3462 "../src/Photo.vala"
					_tmp29_ = instance;
#line 3462 "../src/Photo.vala"
					_tmp30_ = photo_do_redeye (self, _tmp28_, &_tmp29_);
#line 3462 "../src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3462 "../src/Photo.vala"
					pixbuf = _tmp30_;
#line 24249 "Photo.c"
				}
			}
		}
	}
#line 3470 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_STRAIGHTEN)) {
#line 3474 "../src/Photo.vala"
		if (is_straightened) {
#line 24258 "Photo.c"
			GdkPixbuf* _tmp31_;
			GdkPixbuf* _tmp32_;
#line 3475 "../src/Photo.vala"
			_tmp31_ = pixbuf;
#line 3475 "../src/Photo.vala"
			_tmp32_ = rotate_arb (_tmp31_, straightening_angle);
#line 3475 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3475 "../src/Photo.vala"
			pixbuf = _tmp32_;
#line 24269 "Photo.c"
		}
	}
#line 3484 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_CROP)) {
#line 3488 "../src/Photo.vala"
		if (is_cropped) {
#line 24276 "Photo.c"
			Box _tmp33_;
			GdkPixbuf* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			GdkPixbuf* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			Box _tmp41_;
			Box _tmp42_;
			GdkPixbuf* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
			Box _tmp46_;
			Box _tmp47_;
			GdkPixbuf* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			GdkPixbuf* _tmp51_;
			Box _tmp52_;
			Box _tmp53_;
			GdkPixbuf* _tmp54_;
#line 3493 "../src/Photo.vala"
			_tmp33_ = crop;
#line 3493 "../src/Photo.vala"
			_tmp34_ = pixbuf;
#line 3493 "../src/Photo.vala"
			_tmp35_ = gdk_pixbuf_get_width (_tmp34_);
#line 3493 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 3493 "../src/Photo.vala"
			crop.left = CLAMP (_tmp33_.left, 0, _tmp36_ - 2);
#line 3494 "../src/Photo.vala"
			_tmp37_ = crop;
#line 3494 "../src/Photo.vala"
			_tmp38_ = pixbuf;
#line 3494 "../src/Photo.vala"
			_tmp39_ = gdk_pixbuf_get_height (_tmp38_);
#line 3494 "../src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 3494 "../src/Photo.vala"
			crop.top = CLAMP (_tmp37_.top, 0, _tmp40_ - 2);
#line 3496 "../src/Photo.vala"
			_tmp41_ = crop;
#line 3496 "../src/Photo.vala"
			_tmp42_ = crop;
#line 3496 "../src/Photo.vala"
			_tmp43_ = pixbuf;
#line 3496 "../src/Photo.vala"
			_tmp44_ = gdk_pixbuf_get_width (_tmp43_);
#line 3496 "../src/Photo.vala"
			_tmp45_ = _tmp44_;
#line 3496 "../src/Photo.vala"
			crop.right = CLAMP (_tmp41_.right, _tmp42_.left + 1, _tmp45_ - 1);
#line 3497 "../src/Photo.vala"
			_tmp46_ = crop;
#line 3497 "../src/Photo.vala"
			_tmp47_ = crop;
#line 3497 "../src/Photo.vala"
			_tmp48_ = pixbuf;
#line 3497 "../src/Photo.vala"
			_tmp49_ = gdk_pixbuf_get_height (_tmp48_);
#line 3497 "../src/Photo.vala"
			_tmp50_ = _tmp49_;
#line 3497 "../src/Photo.vala"
			crop.bottom = CLAMP (_tmp46_.bottom, _tmp47_.top + 1, _tmp50_ - 1);
#line 3499 "../src/Photo.vala"
			_tmp51_ = pixbuf;
#line 3499 "../src/Photo.vala"
			_tmp52_ = crop;
#line 3499 "../src/Photo.vala"
			_tmp53_ = crop;
#line 3499 "../src/Photo.vala"
			_tmp54_ = gdk_pixbuf_new_subpixbuf (_tmp51_, _tmp52_.left, _tmp53_.top, box_get_width (&crop), box_get_height (&crop));
#line 3499 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3499 "../src/Photo.vala"
			pixbuf = _tmp54_;
#line 24355 "Photo.c"
		}
	}
#line 3509 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 24360 "Photo.c"
		GdkPixbuf* _tmp55_;
		GdkPixbuf* _tmp56_;
#line 3513 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3513 "../src/Photo.vala"
		_tmp56_ = orientation_rotate_pixbuf (orientation, _tmp55_);
#line 3513 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3513 "../src/Photo.vala"
		pixbuf = _tmp56_;
#line 24371 "Photo.c"
	}
#line 3526 "../src/Photo.vala"
	if (is_scaled) {
#line 24375 "Photo.c"
		GdkPixbuf* _tmp57_;
		Dimensions _tmp58_;
		Dimensions _tmp59_;
		GdkPixbuf* _tmp60_;
#line 3527 "../src/Photo.vala"
		_tmp57_ = pixbuf;
#line 3527 "../src/Photo.vala"
		_tmp58_ = scaled_to_viewport;
#line 3527 "../src/Photo.vala"
		_tmp59_ = scaled_to_viewport;
#line 3527 "../src/Photo.vala"
		_tmp60_ = gdk_pixbuf_scale_simple (_tmp57_, _tmp58_.width, _tmp59_.height, GDK_INTERP_BILINEAR);
#line 3527 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3527 "../src/Photo.vala"
		pixbuf = _tmp60_;
#line 24392 "Photo.c"
	}
#line 3532 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ADJUST)) {
#line 24396 "Photo.c"
		PixelTransformer* _tmp61_;
#line 3536 "../src/Photo.vala"
		_tmp61_ = transformer;
#line 3536 "../src/Photo.vala"
		if (_tmp61_ != NULL) {
#line 24402 "Photo.c"
			PixelTransformer* _tmp62_;
			GdkPixbuf* _tmp63_;
#line 3537 "../src/Photo.vala"
			_tmp62_ = transformer;
#line 3537 "../src/Photo.vala"
			_tmp63_ = pixbuf;
#line 3537 "../src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp62_, _tmp63_, NULL);
#line 24411 "Photo.c"
		}
	}
#line 3547 "../src/Photo.vala"
	if (is_scaled) {
#line 3547 "../src/Photo.vala"
		_tmp64_ = !is_straightened;
#line 24418 "Photo.c"
	} else {
#line 3547 "../src/Photo.vala"
		_tmp64_ = FALSE;
#line 24422 "Photo.c"
	}
#line 3547 "../src/Photo.vala"
	if (_tmp64_) {
#line 24426 "Photo.c"
		GdkPixbuf* _tmp65_;
		Dimensions _tmp66_ = {0};
#line 3548 "../src/Photo.vala"
		_tmp65_ = pixbuf;
#line 3548 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp65_, &_tmp66_);
#line 3548 "../src/Photo.vala"
		_vala_assert (dimensions_approx_equals (&scaled_to_viewport, &_tmp66_, PHOTO_SCALING_FUDGE), "scaled_to_viewport.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 24435 "Photo.c"
	}
#line 3551 "../src/Photo.vala"
	result = pixbuf;
#line 3551 "../src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3551 "../src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3551 "../src/Photo.vala"
	return result;
#line 24445 "Photo.c"
}

static gboolean
photo_real_has_user_generated_metadata (Photo* self)
{
	gboolean _tmp0_ = FALSE;
#line 3559 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3559 "../src/Photo.vala"
	return _tmp0_;
#line 24456 "Photo.c"
}

gboolean
photo_has_user_generated_metadata (Photo* self)
{
#line 3559 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3559 "../src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 24466 "Photo.c"
}

static void
photo_real_set_user_metadata_for_export (Photo* self,
                                         PhotoMetadata* metadata)
{
#line 3563 "../src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3563 "../src/Photo.vala"
	return;
#line 24477 "Photo.c"
}

void
photo_set_user_metadata_for_export (Photo* self,
                                    PhotoMetadata* metadata)
{
#line 3563 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3563 "../src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 24488 "Photo.c"
}

gchar*
photo_get_export_basename (Photo* self,
                           PhotoFileFormat* file_format)
{
	gchar* result = NULL;
#line 3570 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3571 "../src/Photo.vala"
	if (file_format != NULL) {
#line 24500 "Photo.c"
		PhotoFileFormatProperties* _tmp0_;
		PhotoFileFormatProperties* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 3572 "../src/Photo.vala"
		_tmp0_ = photo_file_format_get_properties (*file_format);
#line 3572 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3572 "../src/Photo.vala"
		_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 3572 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3572 "../src/Photo.vala"
		_tmp4_ = photo_file_format_properties_convert_file_extension (_tmp1_, _tmp3_);
#line 3572 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3572 "../src/Photo.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 3572 "../src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3572 "../src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3572 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3572 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp1_);
#line 3572 "../src/Photo.vala"
		result = _tmp7_;
#line 3572 "../src/Photo.vala"
		return result;
#line 24535 "Photo.c"
	} else {
#line 3574 "../src/Photo.vala"
		if (photo_file_format_can_write (photo_get_file_format (self))) {
#line 24539 "Photo.c"
			PhotoFileFormatProperties* _tmp8_;
			PhotoFileFormatProperties* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 3575 "../src/Photo.vala"
			_tmp8_ = photo_file_format_get_properties (photo_get_file_format (self));
#line 3575 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 3575 "../src/Photo.vala"
			_tmp10_ = media_source_get_master_file ((MediaSource*) self);
#line 3575 "../src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3575 "../src/Photo.vala"
			_tmp12_ = photo_file_format_properties_convert_file_extension (_tmp9_, _tmp11_);
#line 3575 "../src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 3575 "../src/Photo.vala"
			_tmp14_ = g_file_get_basename (_tmp13_);
#line 3575 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3575 "../src/Photo.vala"
			_g_object_unref0 (_tmp13_);
#line 3575 "../src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3575 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp9_);
#line 3575 "../src/Photo.vala"
			result = _tmp15_;
#line 3575 "../src/Photo.vala"
			return result;
#line 24574 "Photo.c"
		} else {
			PhotoFileFormatProperties* _tmp16_;
			PhotoFileFormatProperties* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 3578 "../src/Photo.vala"
			_tmp16_ = photo_file_format_get_properties (photo_file_format_get_system_default_format ());
#line 3578 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 3578 "../src/Photo.vala"
			_tmp18_ = media_source_get_master_file ((MediaSource*) self);
#line 3578 "../src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 3578 "../src/Photo.vala"
			_tmp20_ = photo_file_format_properties_convert_file_extension (_tmp17_, _tmp19_);
#line 3578 "../src/Photo.vala"
			_tmp21_ = _tmp20_;
#line 3578 "../src/Photo.vala"
			_tmp22_ = g_file_get_basename (_tmp21_);
#line 3578 "../src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3578 "../src/Photo.vala"
			_g_object_unref0 (_tmp21_);
#line 3578 "../src/Photo.vala"
			_g_object_unref0 (_tmp19_);
#line 3578 "../src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp17_);
#line 3578 "../src/Photo.vala"
			result = _tmp23_;
#line 3578 "../src/Photo.vala"
			return result;
#line 24610 "Photo.c"
		}
	}
}

static gboolean
photo_export_fullsized_backing (Photo* self,
                                GFile* file,
                                gboolean export_metadata,
                                GError** error)
{
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp24_;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp25_;
	PhotoFileFormatProperties* _tmp26_;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp27_;
	GFile* _tmp28_;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp29_;
	GFile* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	PhotoFileMetadataWriter* _tmp33_;
	PhotoFileMetadataWriter* _tmp34_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	PhotoFileMetadataWriter* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	PhotoFileReader* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp55_;
	PhotoMetadata* _tmp56_;
	PhotoMetadata* _tmp58_;
	PhotoFileMetadataWriter* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	PhotoFileMetadataWriter* _tmp81_;
	PhotoMetadata* _tmp82_;
	GError* _inner_error0_ = NULL;
#line 3584 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3584 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3587 "../src/Photo.vala"
	export_reader = NULL;
#line 3588 "../src/Photo.vala"
	is_master = TRUE;
#line 24670 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3589 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3589 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 24677 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 3590 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3590 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3590 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 24688 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 3590 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3590 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3590 "../src/Photo.vala"
				_tmp1_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp5_));
#line 24697 "Photo.c"
			} else {
#line 3590 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 24701 "Photo.c"
			}
#line 3590 "../src/Photo.vala"
			if (_tmp1_) {
#line 24705 "Photo.c"
				PhotoBackingReaders* _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 3591 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3591 "../src/Photo.vala"
				_tmp7_ = _tmp6_->editable;
#line 3591 "../src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 3591 "../src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3591 "../src/Photo.vala"
				export_reader = _tmp8_;
#line 3592 "../src/Photo.vala"
				is_master = FALSE;
#line 24721 "Photo.c"
			} else {
				gboolean _tmp9_ = FALSE;
				PhotoBackingReaders* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 3593 "../src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 3593 "../src/Photo.vala"
				_tmp11_ = _tmp10_->developer;
#line 3593 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 24732 "Photo.c"
					PhotoBackingReaders* _tmp12_;
					PhotoFileReader* _tmp13_;
#line 3593 "../src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 3593 "../src/Photo.vala"
					_tmp13_ = _tmp12_->developer;
#line 3593 "../src/Photo.vala"
					_tmp9_ = photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp13_));
#line 24741 "Photo.c"
				} else {
#line 3593 "../src/Photo.vala"
					_tmp9_ = FALSE;
#line 24745 "Photo.c"
				}
#line 3593 "../src/Photo.vala"
				if (_tmp9_) {
#line 24749 "Photo.c"
					PhotoBackingReaders* _tmp14_;
					PhotoFileReader* _tmp15_;
					PhotoFileReader* _tmp16_;
#line 3594 "../src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3594 "../src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3594 "../src/Photo.vala"
					_tmp16_ = _photo_file_adapter_ref0 (_tmp15_);
#line 3594 "../src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3594 "../src/Photo.vala"
					export_reader = _tmp16_;
#line 3595 "../src/Photo.vala"
					is_master = FALSE;
#line 24765 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 3596 "../src/Photo.vala"
					_tmp17_ = self->priv->readers;
#line 3596 "../src/Photo.vala"
					_tmp18_ = _tmp17_->master;
#line 3596 "../src/Photo.vala"
					if (photo_file_format_can_write_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp18_))) {
#line 24775 "Photo.c"
						PhotoBackingReaders* _tmp19_;
						PhotoFileReader* _tmp20_;
						PhotoFileReader* _tmp21_;
#line 3597 "../src/Photo.vala"
						_tmp19_ = self->priv->readers;
#line 3597 "../src/Photo.vala"
						_tmp20_ = _tmp19_->master;
#line 3597 "../src/Photo.vala"
						_tmp21_ = _photo_file_adapter_ref0 (_tmp20_);
#line 3597 "../src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3597 "../src/Photo.vala"
						export_reader = _tmp21_;
#line 24789 "Photo.c"
					}
				}
			}
		}
		__finally219:
		{
			PhotoBackingReaders* _tmp22_;
#line 3589 "../src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 3589 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 24801 "Photo.c"
		}
#line 3589 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24805 "Photo.c"
			gboolean _tmp23_ = FALSE;
#line 3589 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3589 "../src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3589 "../src/Photo.vala"
			return _tmp23_;
#line 24813 "Photo.c"
		}
	}
#line 3601 "../src/Photo.vala"
	_tmp24_ = export_reader;
#line 3601 "../src/Photo.vala"
	if (_tmp24_ == NULL) {
#line 3602 "../src/Photo.vala"
		result = FALSE;
#line 3602 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3602 "../src/Photo.vala"
		return result;
#line 24826 "Photo.c"
	}
#line 3605 "../src/Photo.vala"
	_tmp25_ = export_reader;
#line 3605 "../src/Photo.vala"
	_tmp26_ = photo_file_format_get_properties (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp25_));
#line 3605 "../src/Photo.vala"
	format_properties = _tmp26_;
#line 3608 "../src/Photo.vala"
	_tmp27_ = format_properties;
#line 3608 "../src/Photo.vala"
	_tmp28_ = photo_file_format_properties_convert_file_extension (_tmp27_, file);
#line 3608 "../src/Photo.vala"
	dest_file = _tmp28_;
#line 3611 "../src/Photo.vala"
	_tmp29_ = export_reader;
#line 3611 "../src/Photo.vala"
	_tmp30_ = dest_file;
#line 3611 "../src/Photo.vala"
	_tmp31_ = g_file_get_path (_tmp30_);
#line 3611 "../src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3611 "../src/Photo.vala"
	_tmp33_ = photo_file_format_create_metadata_writer (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp29_), _tmp32_, &_inner_error0_);
#line 3611 "../src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3611 "../src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3611 "../src/Photo.vala"
	writer = _tmp34_;
#line 3611 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24858 "Photo.c"
		gboolean _tmp35_ = FALSE;
#line 3611 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3611 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3611 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3611 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3611 "../src/Photo.vala"
		return _tmp35_;
#line 24870 "Photo.c"
	}
#line 3614 "../src/Photo.vala"
	_tmp36_ = data_object_to_string ((DataObject*) self);
#line 3614 "../src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 3614 "../src/Photo.vala"
	_tmp38_ = writer;
#line 3614 "../src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp38_);
#line 3614 "../src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 3614 "../src/Photo.vala"
	g_debug ("Photo.vala:3614: Exporting full-sized copy of %s to %s", _tmp37_, _tmp40_);
#line 3614 "../src/Photo.vala"
	_g_free0 (_tmp40_);
#line 3614 "../src/Photo.vala"
	_g_free0 (_tmp37_);
#line 3616 "../src/Photo.vala"
	_tmp41_ = export_reader;
#line 3616 "../src/Photo.vala"
	_tmp42_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp41_);
#line 3616 "../src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3616 "../src/Photo.vala"
	_tmp44_ = dest_file;
#line 3616 "../src/Photo.vala"
	g_file_copy (_tmp43_, _tmp44_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3616 "../src/Photo.vala"
	_g_object_unref0 (_tmp43_);
#line 3616 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24902 "Photo.c"
		gboolean _tmp45_ = FALSE;
#line 3616 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3616 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3616 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3616 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3616 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3616 "../src/Photo.vala"
		return _tmp45_;
#line 24916 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (!photo_has_alterations (self)) {
#line 3621 "../src/Photo.vala"
		_tmp50_ = is_master;
#line 24922 "Photo.c"
	} else {
#line 3621 "../src/Photo.vala"
		_tmp50_ = FALSE;
#line 24926 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (_tmp50_) {
#line 3621 "../src/Photo.vala"
		_tmp49_ = !photo_has_user_generated_metadata (self);
#line 24932 "Photo.c"
	} else {
#line 3621 "../src/Photo.vala"
		_tmp49_ = FALSE;
#line 24936 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (_tmp49_) {
#line 24940 "Photo.c"
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 3622 "../src/Photo.vala"
		_tmp51_ = media_source_get_title ((MediaSource*) self);
#line 3622 "../src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3622 "../src/Photo.vala"
		_tmp48_ = _tmp52_ == NULL;
#line 3622 "../src/Photo.vala"
		_g_free0 (_tmp52_);
#line 24951 "Photo.c"
	} else {
#line 3621 "../src/Photo.vala"
		_tmp48_ = FALSE;
#line 24955 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (_tmp48_) {
#line 24959 "Photo.c"
		gchar* _tmp53_;
		gchar* _tmp54_;
#line 3622 "../src/Photo.vala"
		_tmp53_ = media_source_get_comment ((MediaSource*) self);
#line 3622 "../src/Photo.vala"
		_tmp54_ = _tmp53_;
#line 3622 "../src/Photo.vala"
		_tmp47_ = _tmp54_ == NULL;
#line 3622 "../src/Photo.vala"
		_g_free0 (_tmp54_);
#line 24970 "Photo.c"
	} else {
#line 3621 "../src/Photo.vala"
		_tmp47_ = FALSE;
#line 24974 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (_tmp47_) {
#line 3622 "../src/Photo.vala"
		_tmp46_ = export_metadata;
#line 24980 "Photo.c"
	} else {
#line 3621 "../src/Photo.vala"
		_tmp46_ = FALSE;
#line 24984 "Photo.c"
	}
#line 3621 "../src/Photo.vala"
	if (_tmp46_) {
#line 3623 "../src/Photo.vala"
		result = TRUE;
#line 3623 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3623 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3623 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3623 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3623 "../src/Photo.vala"
		return result;
#line 25000 "Photo.c"
	}
#line 3627 "../src/Photo.vala"
	_tmp55_ = export_reader;
#line 3627 "../src/Photo.vala"
	_tmp56_ = photo_file_reader_read_metadata (_tmp55_, &_inner_error0_);
#line 3627 "../src/Photo.vala"
	metadata = _tmp56_;
#line 3627 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25010 "Photo.c"
		gboolean _tmp57_ = FALSE;
#line 3627 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3627 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3627 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3627 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3627 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3627 "../src/Photo.vala"
		return _tmp57_;
#line 25024 "Photo.c"
	}
#line 3628 "../src/Photo.vala"
	_tmp58_ = metadata;
#line 3628 "../src/Photo.vala"
	if (_tmp58_ == NULL) {
#line 25030 "Photo.c"
		PhotoFileReader* _tmp59_;
		PhotoMetadata* _tmp60_;
#line 3629 "../src/Photo.vala"
		_tmp59_ = export_reader;
#line 3629 "../src/Photo.vala"
		_tmp60_ = photo_file_format_create_metadata (photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp59_));
#line 3629 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3629 "../src/Photo.vala"
		metadata = _tmp60_;
#line 25041 "Photo.c"
	}
#line 3632 "../src/Photo.vala"
	_tmp61_ = writer;
#line 3632 "../src/Photo.vala"
	_tmp62_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp61_);
#line 3632 "../src/Photo.vala"
	_tmp63_ = _tmp62_;
#line 3632 "../src/Photo.vala"
	g_debug ("Photo.vala:3632: Updating metadata of %s", _tmp63_);
#line 3632 "../src/Photo.vala"
	_g_free0 (_tmp63_);
#line 3634 "../src/Photo.vala"
	if (media_source_get_exposure_time ((MediaSource*) self) != ((time_t) 0)) {
#line 25055 "Photo.c"
		PhotoMetadata* _tmp64_;
		MetadataDateTime* _tmp65_;
		MetadataDateTime* _tmp66_;
#line 3635 "../src/Photo.vala"
		_tmp64_ = metadata;
#line 3635 "../src/Photo.vala"
		_tmp65_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3635 "../src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 3635 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp64_, _tmp66_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3635 "../src/Photo.vala"
		_metadata_date_time_unref0 (_tmp66_);
#line 25069 "Photo.c"
	} else {
		PhotoMetadata* _tmp67_;
#line 3637 "../src/Photo.vala"
		_tmp67_ = metadata;
#line 3637 "../src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp67_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25076 "Photo.c"
	}
#line 3640 "../src/Photo.vala"
	if (export_metadata) {
#line 25080 "Photo.c"
		PhotoMetadata* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		PhotoMetadata* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		PhotoMetadata* _tmp74_;
		Dimensions _tmp75_ = {0};
		PhotoMetadata* _tmp76_;
		PhotoMetadata* _tmp77_;
		PhotoMetadata* _tmp79_;
#line 3642 "../src/Photo.vala"
		_tmp68_ = metadata;
#line 3642 "../src/Photo.vala"
		_tmp69_ = media_source_get_title ((MediaSource*) self);
#line 3642 "../src/Photo.vala"
		_tmp70_ = _tmp69_;
#line 3642 "../src/Photo.vala"
		photo_metadata_set_title (_tmp68_, _tmp70_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3642 "../src/Photo.vala"
		_g_free0 (_tmp70_);
#line 3643 "../src/Photo.vala"
		_tmp71_ = metadata;
#line 3643 "../src/Photo.vala"
		_tmp72_ = media_source_get_comment ((MediaSource*) self);
#line 3643 "../src/Photo.vala"
		_tmp73_ = _tmp72_;
#line 3643 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp71_, _tmp73_);
#line 3643 "../src/Photo.vala"
		_g_free0 (_tmp73_);
#line 3644 "../src/Photo.vala"
		_tmp74_ = metadata;
#line 3644 "../src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp75_);
#line 3644 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp74_, &_tmp75_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3645 "../src/Photo.vala"
		_tmp76_ = metadata;
#line 3645 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp76_, photo_get_orientation (self));
#line 3646 "../src/Photo.vala"
		_tmp77_ = metadata;
#line 3646 "../src/Photo.vala"
		photo_metadata_set_software (_tmp77_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3648 "../src/Photo.vala"
		if (photo_get_orientation (self) != photo_get_original_orientation (self)) {
#line 25128 "Photo.c"
			PhotoMetadata* _tmp78_;
#line 3649 "../src/Photo.vala"
			_tmp78_ = metadata;
#line 3649 "../src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp78_);
#line 25134 "Photo.c"
		}
#line 3652 "../src/Photo.vala"
		_tmp79_ = metadata;
#line 3652 "../src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp79_);
#line 25140 "Photo.c"
	} else {
		PhotoMetadata* _tmp80_;
#line 3655 "../src/Photo.vala"
		_tmp80_ = metadata;
#line 3655 "../src/Photo.vala"
		photo_metadata_clear (_tmp80_);
#line 25147 "Photo.c"
	}
#line 3658 "../src/Photo.vala"
	_tmp81_ = writer;
#line 3658 "../src/Photo.vala"
	_tmp82_ = metadata;
#line 3658 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp81_, _tmp82_, &_inner_error0_);
#line 3658 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25157 "Photo.c"
		gboolean _tmp83_ = FALSE;
#line 3658 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3658 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3658 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3658 "../src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3658 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3658 "../src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3658 "../src/Photo.vala"
		return _tmp83_;
#line 25173 "Photo.c"
	}
#line 3660 "../src/Photo.vala"
	result = TRUE;
#line 3660 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3660 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3660 "../src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3660 "../src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3660 "../src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3660 "../src/Photo.vala"
	return result;
#line 25189 "Photo.c"
}

gboolean
photo_is_export_required (Photo* self,
                          Scaling* scaling,
                          PhotoFileFormat export_format)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 3666 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3666 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3667 "../src/Photo.vala"
	if (!scaling_is_unscaled (scaling)) {
#line 3667 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 25209 "Photo.c"
	} else {
#line 3667 "../src/Photo.vala"
		_tmp2_ = photo_has_alterations (self);
#line 25213 "Photo.c"
	}
#line 3667 "../src/Photo.vala"
	if (_tmp2_) {
#line 3667 "../src/Photo.vala"
		_tmp1_ = TRUE;
#line 25219 "Photo.c"
	} else {
#line 3667 "../src/Photo.vala"
		_tmp1_ = photo_has_user_generated_metadata (self);
#line 25223 "Photo.c"
	}
#line 3667 "../src/Photo.vala"
	if (_tmp1_) {
#line 3667 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 25229 "Photo.c"
	} else {
#line 3668 "../src/Photo.vala"
		_tmp0_ = export_format != photo_get_file_format (self);
#line 25233 "Photo.c"
	}
#line 3667 "../src/Photo.vala"
	result = _tmp0_;
#line 3667 "../src/Photo.vala"
	return result;
#line 25239 "Photo.c"
}

void
photo_export (Photo* self,
              GFile* dest_file,
              Scaling* scaling,
              JpegQuality quality,
              PhotoFileFormat export_format,
              gboolean direct_copy_unmodified,
              gboolean export_metadata,
              GError** error)
{
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoFileWriter* writer = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	PhotoFileWriter* _tmp12_;
	PhotoFileWriter* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	PhotoFileWriter* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp20_ = FALSE;
	PhotoFileWriter* _tmp29_;
	GdkPixbuf* _tmp30_;
	PhotoFileWriter* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp50_ = FALSE;
	PhotoFileMetadataWriter* _tmp58_ = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_;
	PhotoFileMetadataWriter* _tmp61_;
	PhotoFileMetadataWriter* _tmp62_;
	PhotoMetadata* _tmp63_;
	GError* _inner_error0_ = NULL;
#line 3674 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3674 "../src/Photo.vala"
	g_return_if_fail (dest_file != NULL);
#line 3674 "../src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3676 "../src/Photo.vala"
	if (direct_copy_unmodified) {
#line 25292 "Photo.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3677 "../src/Photo.vala"
		_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 3677 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3677 "../src/Photo.vala"
		g_file_copy (_tmp1_, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
#line 3677 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 3677 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3677 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3677 "../src/Photo.vala"
			return;
#line 25309 "Photo.c"
		}
#line 3679 "../src/Photo.vala"
		return;
#line 25313 "Photo.c"
	}
#line 3686 "../src/Photo.vala"
	if (scaling_is_unscaled (scaling)) {
#line 25317 "Photo.c"
		gboolean _tmp5_ = FALSE;
#line 3686 "../src/Photo.vala"
		if (!photo_has_alterations (self)) {
#line 3686 "../src/Photo.vala"
			_tmp5_ = TRUE;
#line 25323 "Photo.c"
		} else {
#line 3686 "../src/Photo.vala"
			_tmp5_ = photo_only_metadata_changed (self);
#line 25327 "Photo.c"
		}
#line 3686 "../src/Photo.vala"
		_tmp4_ = _tmp5_;
#line 25331 "Photo.c"
	} else {
#line 3686 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 25335 "Photo.c"
	}
#line 3686 "../src/Photo.vala"
	if (_tmp4_) {
#line 3687 "../src/Photo.vala"
		_tmp3_ = export_format == photo_get_file_format (self);
#line 25341 "Photo.c"
	} else {
#line 3686 "../src/Photo.vala"
		_tmp3_ = FALSE;
#line 25345 "Photo.c"
	}
#line 3686 "../src/Photo.vala"
	if (_tmp3_) {
#line 3687 "../src/Photo.vala"
		_tmp2_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF;
#line 25351 "Photo.c"
	} else {
#line 3686 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 25355 "Photo.c"
	}
#line 3686 "../src/Photo.vala"
	if (_tmp2_) {
#line 25359 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3688 "../src/Photo.vala"
		_tmp6_ = photo_export_fullsized_backing (self, dest_file, export_metadata, &_inner_error0_);
#line 3688 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3688 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3688 "../src/Photo.vala"
			return;
#line 25369 "Photo.c"
		}
#line 3688 "../src/Photo.vala"
		if (_tmp6_) {
#line 3689 "../src/Photo.vala"
			return;
#line 25375 "Photo.c"
		}
	}
#line 3695 "../src/Photo.vala"
	_tmp7_ = photo_source_get_metadata ((PhotoSource*) self);
#line 3695 "../src/Photo.vala"
	metadata = _tmp7_;
#line 3696 "../src/Photo.vala"
	_tmp8_ = metadata;
#line 3696 "../src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 25386 "Photo.c"
		PhotoMetadata* _tmp9_;
#line 3697 "../src/Photo.vala"
		_tmp9_ = photo_file_format_create_metadata (export_format);
#line 3697 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3697 "../src/Photo.vala"
		metadata = _tmp9_;
#line 25394 "Photo.c"
	}
#line 3700 "../src/Photo.vala"
	if (!photo_file_format_can_write (export_format)) {
#line 3701 "../src/Photo.vala"
		export_format = photo_file_format_get_system_default_format ();
#line 25400 "Photo.c"
	}
#line 3704 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (dest_file);
#line 3704 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3704 "../src/Photo.vala"
	_tmp12_ = photo_file_format_create_writer (export_format, _tmp11_, &_inner_error0_);
#line 3704 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 3704 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 3704 "../src/Photo.vala"
	writer = _tmp13_;
#line 3704 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3704 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3704 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3704 "../src/Photo.vala"
		return;
#line 25422 "Photo.c"
	}
#line 3706 "../src/Photo.vala"
	_tmp14_ = data_object_to_string ((DataObject*) self);
#line 3706 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3706 "../src/Photo.vala"
	_tmp16_ = writer;
#line 3706 "../src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp16_);
#line 3706 "../src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 3707 "../src/Photo.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), export_format);
#line 3706 "../src/Photo.vala"
	g_debug ("Photo.vala:3706: Saving transformed version of %s to %s in file format" \
" %s", _tmp15_, _tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL);
#line 3706 "../src/Photo.vala"
	_g_free0 (_tmp18_);
#line 3706 "../src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3713 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3713 "../src/Photo.vala"
		_tmp20_ = TRUE;
#line 25446 "Photo.c"
	} else {
#line 3714 "../src/Photo.vala"
		_tmp20_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 25450 "Photo.c"
	}
#line 3713 "../src/Photo.vala"
	if (_tmp20_) {
#line 25454 "Photo.c"
		GdkPixbuf* _tmp21_ = NULL;
		Scaling _tmp22_;
		GdkPixbuf* _tmp23_;
		GdkPixbuf* _tmp24_;
#line 3715 "../src/Photo.vala"
		_tmp22_ = *scaling;
#line 3715 "../src/Photo.vala"
		_tmp23_ = photo_get_pixbuf_with_options (self, &_tmp22_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3715 "../src/Photo.vala"
		_tmp21_ = _tmp23_;
#line 3715 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3715 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3715 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3715 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3715 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3715 "../src/Photo.vala"
			return;
#line 25477 "Photo.c"
		}
#line 3715 "../src/Photo.vala"
		_tmp24_ = _tmp21_;
#line 3715 "../src/Photo.vala"
		_tmp21_ = NULL;
#line 3715 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3715 "../src/Photo.vala"
		pixbuf = _tmp24_;
#line 3713 "../src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 25489 "Photo.c"
	} else {
		GdkPixbuf* _tmp25_ = NULL;
		Scaling _tmp26_;
		GdkPixbuf* _tmp27_;
		GdkPixbuf* _tmp28_;
#line 3719 "../src/Photo.vala"
		_tmp26_ = *scaling;
#line 3719 "../src/Photo.vala"
		_tmp27_ = photo_get_pixbuf_with_options (self, &_tmp26_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error0_);
#line 3719 "../src/Photo.vala"
		_tmp25_ = _tmp27_;
#line 3719 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3719 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3719 "../src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3719 "../src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3719 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3719 "../src/Photo.vala"
			return;
#line 25513 "Photo.c"
		}
#line 3719 "../src/Photo.vala"
		_tmp28_ = _tmp25_;
#line 3719 "../src/Photo.vala"
		_tmp25_ = NULL;
#line 3719 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3719 "../src/Photo.vala"
		pixbuf = _tmp28_;
#line 3713 "../src/Photo.vala"
		_g_object_unref0 (_tmp25_);
#line 25525 "Photo.c"
	}
#line 3723 "../src/Photo.vala"
	_tmp29_ = writer;
#line 3723 "../src/Photo.vala"
	_tmp30_ = pixbuf;
#line 3723 "../src/Photo.vala"
	photo_file_writer_write (_tmp29_, _tmp30_, quality, &_inner_error0_);
#line 3723 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3723 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3723 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3723 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3723 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3723 "../src/Photo.vala"
		return;
#line 25545 "Photo.c"
	}
#line 3725 "../src/Photo.vala"
	_tmp31_ = writer;
#line 3725 "../src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp31_);
#line 3725 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 3725 "../src/Photo.vala"
	g_debug ("Photo.vala:3725: Setting EXIF for %s", _tmp33_);
#line 3725 "../src/Photo.vala"
	_g_free0 (_tmp33_);
#line 3728 "../src/Photo.vala"
	if (export_metadata) {
#line 25559 "Photo.c"
		PhotoMetadata* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		PhotoMetadata* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		PhotoMetadata* _tmp40_;
		PhotoMetadata* _tmp45_;
		PhotoMetadata* _tmp46_;
		PhotoMetadata* _tmp47_;
#line 3730 "../src/Photo.vala"
		_tmp34_ = metadata;
#line 3730 "../src/Photo.vala"
		_tmp35_ = media_source_get_title ((MediaSource*) self);
#line 3730 "../src/Photo.vala"
		_tmp36_ = _tmp35_;
#line 3730 "../src/Photo.vala"
		photo_metadata_set_title (_tmp34_, _tmp36_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3730 "../src/Photo.vala"
		_g_free0 (_tmp36_);
#line 3731 "../src/Photo.vala"
		_tmp37_ = metadata;
#line 3731 "../src/Photo.vala"
		_tmp38_ = media_source_get_comment ((MediaSource*) self);
#line 3731 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 3731 "../src/Photo.vala"
		photo_metadata_set_comment (_tmp37_, _tmp39_);
#line 3731 "../src/Photo.vala"
		_g_free0 (_tmp39_);
#line 3732 "../src/Photo.vala"
		_tmp40_ = metadata;
#line 3732 "../src/Photo.vala"
		photo_metadata_set_software (_tmp40_, _ (RESOURCES_APP_TITLE), RESOURCES_APP_VERSION);
#line 3734 "../src/Photo.vala"
		if (media_source_get_exposure_time ((MediaSource*) self) != ((time_t) 0)) {
#line 25596 "Photo.c"
			PhotoMetadata* _tmp41_;
			MetadataDateTime* _tmp42_;
			MetadataDateTime* _tmp43_;
#line 3735 "../src/Photo.vala"
			_tmp41_ = metadata;
#line 3735 "../src/Photo.vala"
			_tmp42_ = metadata_date_time_new (media_source_get_exposure_time ((MediaSource*) self));
#line 3735 "../src/Photo.vala"
			_tmp43_ = _tmp42_;
#line 3735 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp41_, _tmp43_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3735 "../src/Photo.vala"
			_metadata_date_time_unref0 (_tmp43_);
#line 25610 "Photo.c"
		} else {
			PhotoMetadata* _tmp44_;
#line 3737 "../src/Photo.vala"
			_tmp44_ = metadata;
#line 3737 "../src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp44_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25617 "Photo.c"
		}
#line 3740 "../src/Photo.vala"
		_tmp45_ = metadata;
#line 3740 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp45_, "Exif.Iop.RelatedImageWidth");
#line 3741 "../src/Photo.vala"
		_tmp46_ = metadata;
#line 3741 "../src/Photo.vala"
		photo_metadata_remove_tag (_tmp46_, "Exif.Iop.RelatedImageHeight");
#line 3742 "../src/Photo.vala"
		_tmp47_ = metadata;
#line 3742 "../src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp47_);
#line 3744 "../src/Photo.vala"
		if (photo_has_user_generated_metadata (self)) {
#line 25633 "Photo.c"
			PhotoMetadata* _tmp48_;
#line 3745 "../src/Photo.vala"
			_tmp48_ = metadata;
#line 3745 "../src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp48_);
#line 25639 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp49_;
#line 3749 "../src/Photo.vala"
		_tmp49_ = metadata;
#line 3749 "../src/Photo.vala"
		photo_metadata_clear (_tmp49_);
#line 25647 "Photo.c"
	}
#line 3756 "../src/Photo.vala"
	if (photo_get_file_format (self) == PHOTO_FILE_FORMAT_JFIF) {
#line 3756 "../src/Photo.vala"
		_tmp50_ = TRUE;
#line 25653 "Photo.c"
	} else {
#line 3757 "../src/Photo.vala"
		_tmp50_ = photo_get_file_format (self) == PHOTO_FILE_FORMAT_RAW;
#line 25657 "Photo.c"
	}
#line 3756 "../src/Photo.vala"
	if (_tmp50_) {
#line 25661 "Photo.c"
		PhotoMetadata* _tmp51_;
		Dimensions _tmp52_ = {0};
		PhotoMetadata* _tmp53_;
#line 3758 "../src/Photo.vala"
		_tmp51_ = metadata;
#line 3758 "../src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ORIENTATION, &_tmp52_);
#line 3758 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp51_, &_tmp52_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3759 "../src/Photo.vala"
		_tmp53_ = metadata;
#line 3759 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp53_, photo_get_orientation (self));
#line 25675 "Photo.c"
	} else {
		PhotoMetadata* _tmp54_;
		GdkPixbuf* _tmp55_;
		Dimensions _tmp56_ = {0};
		PhotoMetadata* _tmp57_;
#line 3762 "../src/Photo.vala"
		_tmp54_ = metadata;
#line 3762 "../src/Photo.vala"
		_tmp55_ = pixbuf;
#line 3762 "../src/Photo.vala"
		dimensions_for_pixbuf (_tmp55_, &_tmp56_);
#line 3762 "../src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp54_, &_tmp56_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3763 "../src/Photo.vala"
		_tmp57_ = metadata;
#line 3763 "../src/Photo.vala"
		photo_metadata_set_orientation (_tmp57_, ORIENTATION_TOP_LEFT);
#line 25693 "Photo.c"
	}
#line 3766 "../src/Photo.vala"
	_tmp59_ = g_file_get_path (dest_file);
#line 3766 "../src/Photo.vala"
	_tmp60_ = _tmp59_;
#line 3766 "../src/Photo.vala"
	_tmp61_ = photo_file_format_create_metadata_writer (export_format, _tmp60_, &_inner_error0_);
#line 3766 "../src/Photo.vala"
	_tmp62_ = _tmp61_;
#line 3766 "../src/Photo.vala"
	_g_free0 (_tmp60_);
#line 3766 "../src/Photo.vala"
	_tmp58_ = _tmp62_;
#line 3766 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3766 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3766 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3766 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3766 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3766 "../src/Photo.vala"
		return;
#line 25719 "Photo.c"
	}
#line 3766 "../src/Photo.vala"
	_tmp63_ = metadata;
#line 3766 "../src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp58_, _tmp63_, &_inner_error0_);
#line 3766 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3766 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3766 "../src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp58_);
#line 3766 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3766 "../src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3766 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3766 "../src/Photo.vala"
		return;
#line 25739 "Photo.c"
	}
#line 3674 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp58_);
#line 3674 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3674 "../src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3674 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 25749 "Photo.c"
}

static GFile*
photo_generate_new_editable_file (Photo* self,
                                  PhotoFileFormat* file_format,
                                  GError** error)
{
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp3_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* editable_basename = NULL;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean collision = FALSE;
	GFile* _tmp21_ = NULL;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gboolean _tmp24_ = FALSE;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GError* _inner_error0_ = NULL;
#line 3769 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25784 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 3771 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 3771 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 25791 "Photo.c"
		{
			GFile* _tmp1_;
#line 3772 "../src/Photo.vala"
			_vala_file_format = photo_get_file_format (self);
#line 3773 "../src/Photo.vala"
			_tmp1_ = media_source_get_file ((MediaSource*) self);
#line 3773 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3773 "../src/Photo.vala"
			backing = _tmp1_;
#line 25802 "Photo.c"
		}
		__finally220:
		{
			PhotoRow* _tmp2_;
#line 3771 "../src/Photo.vala"
			_tmp2_ = self->row;
#line 3771 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 25811 "Photo.c"
		}
#line 3771 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3771 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3771 "../src/Photo.vala"
			_g_object_unref0 (backing);
#line 3771 "../src/Photo.vala"
			return NULL;
#line 25821 "Photo.c"
		}
	}
#line 3776 "../src/Photo.vala"
	_tmp3_ = _vala_file_format;
#line 3776 "../src/Photo.vala"
	if (!photo_file_format_can_write (_tmp3_)) {
#line 3777 "../src/Photo.vala"
		_vala_file_format = photo_file_format_get_system_default_format ();
#line 25830 "Photo.c"
	}
#line 3781 "../src/Photo.vala"
	_tmp4_ = g_file_get_basename (backing);
#line 3781 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3781 "../src/Photo.vala"
	disassemble_filename (_tmp5_, &_tmp6_, &_tmp7_);
#line 3781 "../src/Photo.vala"
	_g_free0 (name);
#line 3781 "../src/Photo.vala"
	name = _tmp6_;
#line 3781 "../src/Photo.vala"
	_g_free0 (ext);
#line 3781 "../src/Photo.vala"
	ext = _tmp7_;
#line 3781 "../src/Photo.vala"
	_g_free0 (_tmp5_);
#line 3783 "../src/Photo.vala"
	_tmp9_ = ext;
#line 3783 "../src/Photo.vala"
	if (_tmp9_ == NULL) {
#line 3783 "../src/Photo.vala"
		_tmp8_ = TRUE;
#line 25854 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_;
		PhotoFileFormatProperties* _tmp11_;
		PhotoFileFormatProperties* _tmp12_;
		const gchar* _tmp13_;
#line 3783 "../src/Photo.vala"
		_tmp10_ = _vala_file_format;
#line 3783 "../src/Photo.vala"
		_tmp11_ = photo_file_format_get_properties (_tmp10_);
#line 3783 "../src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 3783 "../src/Photo.vala"
		_tmp13_ = ext;
#line 3783 "../src/Photo.vala"
		_tmp8_ = !photo_file_format_properties_is_recognized_extension (_tmp12_, _tmp13_);
#line 3783 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp12_);
#line 25872 "Photo.c"
	}
#line 3783 "../src/Photo.vala"
	if (_tmp8_) {
#line 25876 "Photo.c"
		PhotoFileFormat _tmp14_;
		PhotoFileFormatProperties* _tmp15_;
		PhotoFileFormatProperties* _tmp16_;
		gchar* _tmp17_;
#line 3784 "../src/Photo.vala"
		_tmp14_ = _vala_file_format;
#line 3784 "../src/Photo.vala"
		_tmp15_ = photo_file_format_get_properties (_tmp14_);
#line 3784 "../src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 3784 "../src/Photo.vala"
		_tmp17_ = photo_file_format_properties_get_default_extension (_tmp16_);
#line 3784 "../src/Photo.vala"
		_g_free0 (ext);
#line 3784 "../src/Photo.vala"
		ext = _tmp17_;
#line 3784 "../src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp16_);
#line 25895 "Photo.c"
	}
#line 3787 "../src/Photo.vala"
	_tmp18_ = name;
#line 3787 "../src/Photo.vala"
	_tmp19_ = ext;
#line 3787 "../src/Photo.vala"
	_tmp20_ = g_strdup_printf ("%s_%s.%s", _tmp18_, _ ("modified"), _tmp19_);
#line 3787 "../src/Photo.vala"
	editable_basename = _tmp20_;
#line 3790 "../src/Photo.vala"
	_tmp22_ = g_file_get_parent (backing);
#line 3790 "../src/Photo.vala"
	_tmp23_ = _tmp22_;
#line 3790 "../src/Photo.vala"
	_tmp25_ = generate_unique_file (_tmp23_, editable_basename, &_tmp24_, &_inner_error0_);
#line 3790 "../src/Photo.vala"
	collision = _tmp24_;
#line 3790 "../src/Photo.vala"
	_tmp26_ = _tmp25_;
#line 3790 "../src/Photo.vala"
	_g_object_unref0 (_tmp23_);
#line 3790 "../src/Photo.vala"
	_tmp21_ = _tmp26_;
#line 3790 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3790 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3790 "../src/Photo.vala"
		_g_free0 (editable_basename);
#line 3790 "../src/Photo.vala"
		_g_free0 (ext);
#line 3790 "../src/Photo.vala"
		_g_free0 (name);
#line 3790 "../src/Photo.vala"
		_g_object_unref0 (backing);
#line 3790 "../src/Photo.vala"
		return NULL;
#line 25933 "Photo.c"
	}
#line 3790 "../src/Photo.vala"
	_tmp27_ = _tmp21_;
#line 3790 "../src/Photo.vala"
	_tmp21_ = NULL;
#line 3790 "../src/Photo.vala"
	result = _tmp27_;
#line 3790 "../src/Photo.vala"
	_g_object_unref0 (_tmp21_);
#line 3790 "../src/Photo.vala"
	_g_free0 (editable_basename);
#line 3790 "../src/Photo.vala"
	_g_free0 (ext);
#line 3790 "../src/Photo.vala"
	_g_free0 (name);
#line 3790 "../src/Photo.vala"
	_g_object_unref0 (backing);
#line 3790 "../src/Photo.vala"
	if (file_format) {
#line 3790 "../src/Photo.vala"
		*file_format = _vala_file_format;
#line 25955 "Photo.c"
	}
#line 3790 "../src/Photo.vala"
	return result;
#line 25959 "Photo.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 3811 "../src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 25967 "Photo.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 3811 "../src/Photo.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 25975 "Photo.c"
}

static gboolean
photo_launch_editor (GFile* file,
                     PhotoFileFormat file_format,
                     const gchar* commandline,
                     GError** error)
{
	gboolean result = FALSE;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp4_;
	GAppInfo* _tmp5_;
	gchar** argv = NULL;
	gchar** _tmp10_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	GPid child_pid = 0;
	gboolean _tmp15_ = FALSE;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GPid _tmp17_ = 0;
	gboolean _tmp18_;
	GError* _inner_error0_ = NULL;
#line 3793 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3793 "../src/Photo.vala"
	g_return_val_if_fail (commandline != NULL, FALSE);
#line 3795 "../src/Photo.vala"
	if (is_string_empty (commandline)) {
#line 3796 "../src/Photo.vala"
		result = FALSE;
#line 3796 "../src/Photo.vala"
		return result;
#line 26016 "Photo.c"
	}
	{
		GAppInfo* _tmp0_ = NULL;
		GAppInfo* _tmp1_;
		GAppInfo* _tmp2_;
#line 3801 "../src/Photo.vala"
		_tmp1_ = g_app_info_create_from_commandline (commandline, "", G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 3801 "../src/Photo.vala"
		_tmp0_ = _tmp1_;
#line 3801 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26028 "Photo.c"
			goto __catch221_g_error;
		}
#line 3801 "../src/Photo.vala"
		_tmp2_ = _tmp0_;
#line 3801 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 3801 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3801 "../src/Photo.vala"
		app = _tmp2_;
#line 3800 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 26041 "Photo.c"
	}
	goto __finally221;
	__catch221_g_error:
	{
		GError* er = NULL;
#line 3800 "../src/Photo.vala"
		er = _inner_error0_;
#line 3800 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 3804 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3804 "../src/Photo.vala"
		app = NULL;
#line 3800 "../src/Photo.vala"
		_g_error_free0 (er);
#line 26057 "Photo.c"
	}
	__finally221:
#line 3800 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26062 "Photo.c"
		gboolean _tmp3_ = FALSE;
#line 3800 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3800 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3800 "../src/Photo.vala"
		return _tmp3_;
#line 26070 "Photo.c"
	}
#line 3807 "../src/Photo.vala"
	files = NULL;
#line 3808 "../src/Photo.vala"
	_tmp4_ = _g_object_ref0 (file);
#line 3808 "../src/Photo.vala"
	files = g_list_insert (files, _tmp4_, -1);
#line 3810 "../src/Photo.vala"
	_tmp5_ = app;
#line 3810 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 26082 "Photo.c"
		gboolean _tmp6_ = FALSE;
		GAppInfo* _tmp7_;
		GList* _tmp8_;
#line 3811 "../src/Photo.vala"
		_tmp7_ = app;
#line 3811 "../src/Photo.vala"
		_tmp8_ = files;
#line 3811 "../src/Photo.vala"
		_tmp6_ = g_app_info_launch (_tmp7_, _tmp8_, NULL, &_inner_error0_);
#line 3811 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26094 "Photo.c"
			gboolean _tmp9_ = FALSE;
#line 3811 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3811 "../src/Photo.vala"
			(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3811 "../src/Photo.vala"
			_g_object_unref0 (app);
#line 3811 "../src/Photo.vala"
			return _tmp9_;
#line 26104 "Photo.c"
		}
#line 3811 "../src/Photo.vala"
		result = _tmp6_;
#line 3811 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3811 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3811 "../src/Photo.vala"
		return result;
#line 26114 "Photo.c"
	}
#line 3814 "../src/Photo.vala"
	_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 3814 "../src/Photo.vala"
	argv = _tmp10_;
#line 3814 "../src/Photo.vala"
	argv_length1 = 2;
#line 3814 "../src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3815 "../src/Photo.vala"
	_tmp11_ = argv;
#line 3815 "../src/Photo.vala"
	_tmp11__length1 = argv_length1;
#line 3815 "../src/Photo.vala"
	_tmp12_ = g_strdup (commandline);
#line 3815 "../src/Photo.vala"
	_g_free0 (_tmp11_[0]);
#line 3815 "../src/Photo.vala"
	_tmp11_[0] = _tmp12_;
#line 3816 "../src/Photo.vala"
	_tmp13_ = argv;
#line 3816 "../src/Photo.vala"
	_tmp13__length1 = argv_length1;
#line 3816 "../src/Photo.vala"
	_tmp14_ = g_file_get_path (file);
#line 3816 "../src/Photo.vala"
	_g_free0 (_tmp13_[1]);
#line 3816 "../src/Photo.vala"
	_tmp13_[1] = _tmp14_;
#line 3820 "../src/Photo.vala"
	_tmp16_ = argv;
#line 3820 "../src/Photo.vala"
	_tmp16__length1 = argv_length1;
#line 3820 "../src/Photo.vala"
	_tmp18_ = g_spawn_async ("/", _tmp16_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp17_, &_inner_error0_);
#line 3820 "../src/Photo.vala"
	child_pid = _tmp17_;
#line 3820 "../src/Photo.vala"
	_tmp15_ = _tmp18_;
#line 3820 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26156 "Photo.c"
		gboolean _tmp19_ = FALSE;
#line 3820 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3820 "../src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3820 "../src/Photo.vala"
		(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3820 "../src/Photo.vala"
		_g_object_unref0 (app);
#line 3820 "../src/Photo.vala"
		return _tmp19_;
#line 26168 "Photo.c"
	}
#line 3820 "../src/Photo.vala"
	result = _tmp15_;
#line 3820 "../src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3820 "../src/Photo.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 3820 "../src/Photo.vala"
	_g_object_unref0 (app);
#line 3820 "../src/Photo.vala"
	return result;
#line 26180 "Photo.c"
}

void
photo_open_with_raw_external_editor (Photo* self,
                                     const gchar* external_editor,
                                     GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3830 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3830 "../src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3831 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 3831 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3831 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_master_file_format (self), external_editor, &_inner_error0_);
#line 3831 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3831 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3831 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3831 "../src/Photo.vala"
		return;
#line 26209 "Photo.c"
	}
}

void
photo_open_with_external_editor (Photo* self,
                                 const gchar* external_editor,
                                 GError** error)
{
	GFile* modified_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 3835 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3835 "../src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3836 "../src/Photo.vala"
	_tmp0_ = photo_get_modified_file (self, &_inner_error0_);
#line 3836 "../src/Photo.vala"
	modified_file = _tmp0_;
#line 3836 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3836 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3836 "../src/Photo.vala"
		return;
#line 26236 "Photo.c"
	}
#line 3837 "../src/Photo.vala"
	_tmp1_ = modified_file;
#line 3837 "../src/Photo.vala"
	photo_launch_editor (_tmp1_, photo_get_file_format (self), external_editor, &_inner_error0_);
#line 3837 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3837 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3837 "../src/Photo.vala"
		_g_object_unref0 (modified_file);
#line 3837 "../src/Photo.vala"
		return;
#line 26250 "Photo.c"
	}
#line 3835 "../src/Photo.vala"
	_g_object_unref0 (modified_file);
#line 26254 "Photo.c"
}

GFile*
photo_get_modified_file (Photo* self,
                         GError** error)
{
	GFile* result = NULL;
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp22_ = FALSE;
	GFile* _tmp23_;
	GFile* _tmp40_;
	GFileMonitor* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 3840 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3841 "../src/Photo.vala"
	current_editable_file = NULL;
#line 3842 "../src/Photo.vala"
	create_editable_file = NULL;
#line 26279 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 3844 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3844 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 26286 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 3845 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3845 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3845 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 26297 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
#line 3846 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3846 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3846 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3846 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3846 "../src/Photo.vala"
				current_editable_file = _tmp5_;
#line 26311 "Photo.c"
			}
#line 3849 "../src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3849 "../src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 26317 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_;
				GFile* _tmp10_;
#line 3850 "../src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error0_);
#line 3850 "../src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3850 "../src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3850 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26330 "Photo.c"
					goto __finally222;
				}
#line 3850 "../src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3850 "../src/Photo.vala"
				_tmp7_ = NULL;
#line 3850 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3850 "../src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3849 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 26343 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_;
				PhotoFileReader* _tmp12_;
#line 3852 "../src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3852 "../src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3852 "../src/Photo.vala"
				editable_file_format = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp12_);
#line 26353 "Photo.c"
			}
		}
		__finally222:
		{
			GError* _inner_error1_ = NULL;
			PhotoBackingReaders* _tmp13_;
#line 3844 "../src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 3844 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 26364 "Photo.c"
		}
#line 3844 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3844 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3844 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3844 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3844 "../src/Photo.vala"
			return NULL;
#line 26376 "Photo.c"
		}
	}
#line 3858 "../src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 3858 "../src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 26383 "Photo.c"
		GFile* _tmp17_;
#line 3858 "../src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 3858 "../src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 26389 "Photo.c"
	} else {
#line 3858 "../src/Photo.vala"
		_tmp15_ = FALSE;
#line 26393 "Photo.c"
	}
#line 3858 "../src/Photo.vala"
	if (_tmp15_) {
#line 26397 "Photo.c"
		gboolean _tmp18_ = FALSE;
		GFile* _tmp19_;
#line 3859 "../src/Photo.vala"
		_tmp19_ = current_editable_file;
#line 3859 "../src/Photo.vala"
		if (!g_file_query_exists (_tmp19_, NULL)) {
#line 3859 "../src/Photo.vala"
			_tmp18_ = TRUE;
#line 26406 "Photo.c"
		} else {
#line 3859 "../src/Photo.vala"
			_tmp18_ = photo_has_transformations (self);
#line 26410 "Photo.c"
		}
#line 3859 "../src/Photo.vala"
		_tmp14_ = _tmp18_;
#line 26414 "Photo.c"
	} else {
#line 3858 "../src/Photo.vala"
		_tmp14_ = FALSE;
#line 26418 "Photo.c"
	}
#line 3858 "../src/Photo.vala"
	if (_tmp14_) {
#line 26422 "Photo.c"
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 3860 "../src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3860 "../src/Photo.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 3860 "../src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3860 "../src/Photo.vala"
		create_editable_file = _tmp21_;
#line 26433 "Photo.c"
	}
#line 3864 "../src/Photo.vala"
	_tmp23_ = create_editable_file;
#line 3864 "../src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 26439 "Photo.c"
		PhotoFileFormat _tmp24_;
#line 3864 "../src/Photo.vala"
		_tmp24_ = editable_file_format;
#line 3864 "../src/Photo.vala"
		_tmp22_ = photo_file_format_can_write (_tmp24_);
#line 26445 "Photo.c"
	} else {
#line 3864 "../src/Photo.vala"
		_tmp22_ = FALSE;
#line 26449 "Photo.c"
	}
#line 3864 "../src/Photo.vala"
	if (_tmp22_) {
#line 26453 "Photo.c"
		PhotoFileFormat _tmp36_;
		GFile* _tmp37_;
		GFile* _tmp38_;
		GFile* _tmp39_;
#line 3865 "../src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 26460 "Photo.c"
		{
			GFile* _tmp25_;
			Scaling _tmp26_ = {0};
			PhotoFileFormat _tmp27_;
#line 3868 "../src/Photo.vala"
			_tmp25_ = create_editable_file;
#line 3868 "../src/Photo.vala"
			scaling_for_original (&_tmp26_);
#line 3868 "../src/Photo.vala"
			_tmp27_ = editable_file_format;
#line 3868 "../src/Photo.vala"
			photo_export (self, _tmp25_, &_tmp26_, JPEG_QUALITY_MAXIMUM, _tmp27_, FALSE, TRUE, &_inner_error0_);
#line 3868 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26475 "Photo.c"
				goto __catch223_g_error;
			}
		}
		goto __finally223;
		__catch223_g_error:
		{
			GError* err = NULL;
			GError* _tmp34_;
			GError* _tmp35_;
#line 3867 "../src/Photo.vala"
			err = _inner_error0_;
#line 3867 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 26489 "Photo.c"
			{
				GFile* _tmp28_;
#line 3873 "../src/Photo.vala"
				_tmp28_ = create_editable_file;
#line 3873 "../src/Photo.vala"
				g_file_delete (_tmp28_, NULL, &_inner_error0_);
#line 3873 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 26498 "Photo.c"
					goto __catch224_g_error;
				}
			}
			goto __finally224;
			__catch224_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				GError* _tmp32_;
				const gchar* _tmp33_;
#line 3872 "../src/Photo.vala"
				delete_err = _inner_error0_;
#line 3872 "../src/Photo.vala"
				_inner_error0_ = NULL;
#line 3876 "../src/Photo.vala"
				_tmp29_ = create_editable_file;
#line 3876 "../src/Photo.vala"
				_tmp30_ = g_file_get_path (_tmp29_);
#line 3876 "../src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 3876 "../src/Photo.vala"
				_tmp32_ = delete_err;
#line 3876 "../src/Photo.vala"
				_tmp33_ = _tmp32_->message;
#line 3876 "../src/Photo.vala"
				g_warning ("Photo.vala:3876: Unable to delete editable file %s after export error:" \
" %s", _tmp31_, _tmp33_);
#line 3876 "../src/Photo.vala"
				_g_free0 (_tmp31_);
#line 3872 "../src/Photo.vala"
				_g_error_free0 (delete_err);
#line 26531 "Photo.c"
			}
			__finally224:
#line 3872 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3872 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3872 "../src/Photo.vala"
				_g_error_free0 (err);
#line 3872 "../src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3872 "../src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3872 "../src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3872 "../src/Photo.vala"
				g_clear_error (&_inner_error0_);
#line 3872 "../src/Photo.vala"
				return NULL;
#line 26550 "Photo.c"
			}
#line 3880 "../src/Photo.vala"
			_tmp34_ = err;
#line 3880 "../src/Photo.vala"
			_tmp35_ = _g_error_copy0 (_tmp34_);
#line 3880 "../src/Photo.vala"
			_inner_error0_ = _tmp35_;
#line 3880 "../src/Photo.vala"
			_g_error_free0 (err);
#line 26560 "Photo.c"
			goto __finally223;
		}
		__finally223:
#line 3867 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3867 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3867 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3867 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3867 "../src/Photo.vala"
			return NULL;
#line 26574 "Photo.c"
		}
#line 3884 "../src/Photo.vala"
		_tmp36_ = editable_file_format;
#line 3884 "../src/Photo.vala"
		_tmp37_ = create_editable_file;
#line 3884 "../src/Photo.vala"
		photo_attach_editable (self, _tmp36_, _tmp37_, &_inner_error0_);
#line 3884 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3884 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3884 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3884 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3884 "../src/Photo.vala"
			return NULL;
#line 26592 "Photo.c"
		}
#line 3886 "../src/Photo.vala"
		_tmp38_ = create_editable_file;
#line 3886 "../src/Photo.vala"
		_tmp39_ = _g_object_ref0 (_tmp38_);
#line 3886 "../src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3886 "../src/Photo.vala"
		current_editable_file = _tmp39_;
#line 26602 "Photo.c"
	}
#line 3889 "../src/Photo.vala"
	_tmp40_ = current_editable_file;
#line 3889 "../src/Photo.vala"
	_vala_assert (_tmp40_ != NULL, "current_editable_file != null");
#line 3892 "../src/Photo.vala"
	_tmp41_ = self->priv->editable_monitor;
#line 3892 "../src/Photo.vala"
	if (_tmp41_ == NULL) {
#line 26612 "Photo.c"
		GFile* _tmp42_;
#line 3893 "../src/Photo.vala"
		_tmp42_ = current_editable_file;
#line 3893 "../src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp42_, &_inner_error0_);
#line 3893 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3893 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3893 "../src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3893 "../src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3893 "../src/Photo.vala"
			return NULL;
#line 26628 "Photo.c"
		}
	}
#line 3896 "../src/Photo.vala"
	result = current_editable_file;
#line 3896 "../src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3896 "../src/Photo.vala"
	return result;
#line 26637 "Photo.c"
}

void
photo_revert_to_master (Photo* self,
                        gboolean notify)
{
#line 3899 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3900 "../src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, notify);
#line 26648 "Photo.c"
}

static void
_photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                        GFile* file,
                                                        GFile* other_file,
                                                        GFileMonitorEvent event_type,
                                                        gpointer self)
{
#line 3910 "../src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 26660 "Photo.c"
}

static void
photo_start_monitoring_editable (Photo* self,
                                 GFile* file,
                                 GError** error)
{
	GFileMonitor* _tmp0_ = NULL;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3903 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3903 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3904 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3907 "../src/Photo.vala"
	library_monitor_blacklist_file (file, "Photo.start_monitoring_editable");
#line 3909 "../src/Photo.vala"
	_tmp1_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 3909 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 3909 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3909 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3909 "../src/Photo.vala"
		return;
#line 26691 "Photo.c"
	}
#line 3909 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 3909 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 3909 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3909 "../src/Photo.vala"
	self->priv->editable_monitor = _tmp2_;
#line 3910 "../src/Photo.vala"
	_tmp3_ = self->priv->editable_monitor;
#line 3910 "../src/Photo.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3903 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 26707 "Photo.c"
}

static void
photo_halt_monitoring_editable (Photo* self)
{
	GFileMonitor* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_;
	GFileMonitor* _tmp6_;
#line 3913 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3914 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3914 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3915 "../src/Photo.vala"
		return;
#line 26728 "Photo.c"
	}
#line 3919 "../src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3919 "../src/Photo.vala"
	file = _tmp1_;
#line 3920 "../src/Photo.vala"
	_tmp2_ = file;
#line 3920 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 26738 "Photo.c"
		GFile* _tmp3_;
#line 3921 "../src/Photo.vala"
		_tmp3_ = file;
#line 3921 "../src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 26744 "Photo.c"
	}
#line 3924 "../src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3924 "../src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3924 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3925 "../src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3925 "../src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3926 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3926 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3913 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 26762 "Photo.c"
}

static void
photo_attach_editable (Photo* self,
                       PhotoFileFormat file_format,
                       GFile* file,
                       GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 3929 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3929 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3934 "../src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3935 "../src/Photo.vala"
	_tmp0_ = g_file_get_path (file);
#line 3935 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3935 "../src/Photo.vala"
	_tmp2_ = photo_file_format_create_reader (file_format, _tmp1_);
#line 3935 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3935 "../src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp3_, &_inner_error0_);
#line 3935 "../src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp3_);
#line 3935 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 3935 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3935 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3935 "../src/Photo.vala"
		return;
#line 26802 "Photo.c"
	}
}

static void
photo_update_editable_attributes (Photo* self,
                                  GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3938 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3939 "../src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error0_);
#line 3939 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3939 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3939 "../src/Photo.vala"
		return;
#line 26821 "Photo.c"
	}
}

void
photo_reimport_editable (Photo* self,
                         GError** error)
{
	GError* _inner_error0_ = NULL;
#line 3942 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3943 "../src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error0_);
#line 3943 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3943 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3943 "../src/Photo.vala"
		return;
#line 26840 "Photo.c"
	}
}

static void
_vala_array_add24 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4050 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4050 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4050 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26856 "Photo.c"
	}
#line 4050 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4050 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26862 "Photo.c"
}

static void
_vala_array_add25 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4051 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4051 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4051 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26877 "Photo.c"
	}
#line 4051 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4051 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26883 "Photo.c"
}

static void
_vala_array_add26 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4054 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4054 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4054 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26898 "Photo.c"
	}
#line 4054 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4054 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26904 "Photo.c"
}

static void
_vala_array_add27 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4059 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4059 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4059 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26919 "Photo.c"
	}
#line 4059 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4059 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26925 "Photo.c"
}

static void
_vala_array_add28 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4060 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4060 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4060 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26940 "Photo.c"
	}
#line 4060 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4060 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26946 "Photo.c"
}

static void
_vala_array_add29 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 4063 "../src/Photo.vala"
	if ((*length) == (*size)) {
#line 4063 "../src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 4063 "../src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 26961 "Photo.c"
	}
#line 4063 "../src/Photo.vala"
	(*array)[(*length)++] = value;
#line 4063 "../src/Photo.vala"
	(*array)[*length] = NULL;
#line 26967 "Photo.c"
}

static void
photo_update_editable (Photo* self,
                       gboolean only_attributes,
                       PhotoFileReader* new_reader,
                       GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp5_;
	PhotoFileReader* _tmp6_;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp7_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp8_;
	GFile* _tmp9_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp10_;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_;
	gboolean _tmp77_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp86_;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp93_ = FALSE;
	gchar** _tmp100_;
	gint _tmp100__length1;
	GError* _inner_error0_ = NULL;
#line 3948 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3950 "../src/Photo.vala"
	if (only_attributes) {
#line 3950 "../src/Photo.vala"
		_tmp1_ = new_reader == NULL;
#line 27012 "Photo.c"
	} else {
#line 3950 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 27016 "Photo.c"
	}
#line 3950 "../src/Photo.vala"
	if (_tmp1_) {
#line 3950 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 27022 "Photo.c"
	} else {
#line 3950 "../src/Photo.vala"
		_tmp0_ = !only_attributes;
#line 27026 "Photo.c"
	}
#line 3950 "../src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes  &&new_reader == null) || (!only_attributes)");
#line 3952 "../src/Photo.vala"
	_tmp2_ = photo_get_editable_reader (self);
#line 3952 "../src/Photo.vala"
	old_reader = _tmp2_;
#line 3954 "../src/Photo.vala"
	_tmp3_ = new_reader;
#line 3954 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 27038 "Photo.c"
		PhotoFileReader* _tmp4_;
#line 3954 "../src/Photo.vala"
		_tmp4_ = old_reader;
#line 3954 "../src/Photo.vala"
		_tmp3_ = _tmp4_;
#line 27044 "Photo.c"
	}
#line 3954 "../src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp3_);
#line 3954 "../src/Photo.vala"
	reader = _tmp5_;
#line 3955 "../src/Photo.vala"
	_tmp6_ = reader;
#line 3955 "../src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 3956 "../src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3958 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3958 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3958 "../src/Photo.vala"
		return;
#line 27062 "Photo.c"
	}
#line 3961 "../src/Photo.vala"
	timestamp_changed = FALSE;
#line 3962 "../src/Photo.vala"
	filesize_changed = FALSE;
#line 3963 "../src/Photo.vala"
	is_new_editable = FALSE;
#line 3965 "../src/Photo.vala"
	photo_get_editable_id (self, &_tmp7_);
#line 3965 "../src/Photo.vala"
	editable_id = _tmp7_;
#line 3966 "../src/Photo.vala"
	_tmp8_ = reader;
#line 3966 "../src/Photo.vala"
	_tmp9_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp8_);
#line 3966 "../src/Photo.vala"
	file = _tmp9_;
#line 3969 "../src/Photo.vala"
	_tmp10_ = file;
#line 3969 "../src/Photo.vala"
	_tmp12_ = photo_query_backing_photo_row (self, _tmp10_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp11_, &_inner_error0_);
#line 3969 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3969 "../src/Photo.vala"
	detected = _tmp11_;
#line 3969 "../src/Photo.vala"
	backing = _tmp12_;
#line 3969 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3969 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 3969 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3969 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 3969 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3969 "../src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3969 "../src/Photo.vala"
		return;
#line 27104 "Photo.c"
	}
#line 3973 "../src/Photo.vala"
	if (backing_photo_id_is_invalid (&editable_id)) {
#line 27108 "Photo.c"
		BackingPhotoRow* _tmp13_;
#line 3975 "../src/Photo.vala"
		_tmp13_ = backing;
#line 3975 "../src/Photo.vala"
		if (_tmp13_ != NULL) {
#line 27114 "Photo.c"
			BackingPhotoTable* _tmp14_;
			BackingPhotoTable* _tmp15_;
			BackingPhotoRow* _tmp16_;
#line 3976 "../src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 3976 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 3976 "../src/Photo.vala"
			_tmp16_ = backing;
#line 3976 "../src/Photo.vala"
			backing_photo_table_add (_tmp15_, _tmp16_, &_inner_error0_);
#line 3976 "../src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 3976 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3976 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 3976 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3976 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3976 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 3976 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3976 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3976 "../src/Photo.vala"
				return;
#line 27144 "Photo.c"
			}
			{
				PhotoRow* _tmp17_;
#line 3977 "../src/Photo.vala"
				_tmp17_ = self->row;
#line 3977 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27152 "Photo.c"
				{
					PhotoTable* _tmp18_;
					PhotoTable* _tmp19_;
					PhotoRow* _tmp20_;
					BackingPhotoRow* _tmp21_;
					BackingPhotoID _tmp22_;
					BackingPhotoRow* _tmp23_;
					BackingPhotoRow* _tmp24_;
					BackingPhotoRow* _tmp25_;
					BackingPhotoRow* _tmp26_;
					BackingPhotoRow* _tmp27_;
					Orientation _tmp28_;
#line 3978 "../src/Photo.vala"
					timestamp_changed = TRUE;
#line 3979 "../src/Photo.vala"
					filesize_changed = TRUE;
#line 3981 "../src/Photo.vala"
					_tmp18_ = photo_table_get_instance ();
#line 3981 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 3981 "../src/Photo.vala"
					_tmp20_ = self->row;
#line 3981 "../src/Photo.vala"
					_tmp21_ = backing;
#line 3981 "../src/Photo.vala"
					_tmp22_ = _tmp21_->id;
#line 3981 "../src/Photo.vala"
					photo_table_attach_editable (_tmp19_, _tmp20_, &_tmp22_, &_inner_error0_);
#line 3981 "../src/Photo.vala"
					_database_table_unref0 (_tmp19_);
#line 3981 "../src/Photo.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27185 "Photo.c"
						goto __finally225;
					}
#line 3982 "../src/Photo.vala"
					_tmp23_ = backing;
#line 3982 "../src/Photo.vala"
					_tmp24_ = _backing_photo_row_ref0 (_tmp23_);
#line 3982 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3982 "../src/Photo.vala"
					self->priv->editable = _tmp24_;
#line 3983 "../src/Photo.vala"
					_tmp25_ = self->priv->editable;
#line 3983 "../src/Photo.vala"
					_tmp26_ = _backing_photo_row_ref0 (_tmp25_);
#line 3983 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3983 "../src/Photo.vala"
					self->backing_photo_row = _tmp26_;
#line 3984 "../src/Photo.vala"
					_tmp27_ = self->backing_photo_row;
#line 3984 "../src/Photo.vala"
					_tmp28_ = _tmp27_->original_orientation;
#line 3984 "../src/Photo.vala"
					photo_set_orientation (self, _tmp28_);
#line 27210 "Photo.c"
				}
				__finally225:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp29_;
#line 3977 "../src/Photo.vala"
					_tmp29_ = self->row;
#line 3977 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27220 "Photo.c"
				}
#line 3977 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3977 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 3977 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3977 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3977 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 3977 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3977 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3977 "../src/Photo.vala"
					return;
#line 27238 "Photo.c"
				}
			}
		}
#line 3987 "../src/Photo.vala"
		is_new_editable = TRUE;
#line 27244 "Photo.c"
	}
#line 3990 "../src/Photo.vala"
	if (only_attributes) {
#line 27248 "Photo.c"
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp38_;
		GTimeVal _tmp39_ = {0};
		BackingPhotoTable* _tmp40_;
		BackingPhotoTable* _tmp41_;
		BackingPhotoID _tmp42_;
		GTimeVal _tmp43_;
		GFileInfo* _tmp44_;
#line 3992 "../src/Photo.vala"
		_vala_assert (backing_photo_id_is_valid (&editable_id), "editable_id.is_valid ()");
#line 27260 "Photo.c"
		{
			GFileInfo* _tmp30_ = NULL;
			GFile* _tmp31_;
			GFileInfo* _tmp32_;
			GFileInfo* _tmp33_;
#line 3996 "../src/Photo.vala"
			_tmp31_ = file;
#line 3996 "../src/Photo.vala"
			_tmp32_ = g_file_query_filesystem_info (_tmp31_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error0_);
#line 3996 "../src/Photo.vala"
			_tmp30_ = _tmp32_;
#line 3996 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 27274 "Photo.c"
				goto __catch226_g_error;
			}
#line 3996 "../src/Photo.vala"
			_tmp33_ = _tmp30_;
#line 3996 "../src/Photo.vala"
			_tmp30_ = NULL;
#line 3996 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3996 "../src/Photo.vala"
			info = _tmp33_;
#line 3995 "../src/Photo.vala"
			_g_object_unref0 (_tmp30_);
#line 27287 "Photo.c"
		}
		goto __finally226;
		__catch226_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3995 "../src/Photo.vala"
			err = _inner_error0_;
#line 3995 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 3998 "../src/Photo.vala"
			_tmp34_ = data_object_to_string ((DataObject*) self);
#line 3998 "../src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 3998 "../src/Photo.vala"
			_tmp36_ = err;
#line 3998 "../src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 3998 "../src/Photo.vala"
			g_warning ("Photo.vala:3998: Unable to read editable filesystem info for %s: %s", _tmp35_, _tmp37_);
#line 3998 "../src/Photo.vala"
			_g_free0 (_tmp35_);
#line 3999 "../src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4001 "../src/Photo.vala"
			_g_error_free0 (err);
#line 4001 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4001 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4001 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4001 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4001 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4001 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4001 "../src/Photo.vala"
			return;
#line 27331 "Photo.c"
		}
		__finally226:
#line 3995 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3995 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 3995 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 3995 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3995 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3995 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 3995 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3995 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3995 "../src/Photo.vala"
			return;
#line 27352 "Photo.c"
		}
#line 4004 "../src/Photo.vala"
		_tmp38_ = info;
#line 4004 "../src/Photo.vala"
		g_file_info_get_modification_time (_tmp38_, &_tmp39_);
#line 4004 "../src/Photo.vala"
		timestamp = _tmp39_;
#line 4006 "../src/Photo.vala"
		_tmp40_ = backing_photo_table_get_instance ();
#line 4006 "../src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 4006 "../src/Photo.vala"
		_tmp42_ = editable_id;
#line 4006 "../src/Photo.vala"
		_tmp43_ = timestamp;
#line 4006 "../src/Photo.vala"
		_tmp44_ = info;
#line 4006 "../src/Photo.vala"
		backing_photo_table_update_attributes (_tmp41_, &_tmp42_, (time_t) _tmp43_.tv_sec, g_file_info_get_size (_tmp44_), &_inner_error0_);
#line 4006 "../src/Photo.vala"
		_database_table_unref0 (_tmp41_);
#line 4006 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4006 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 4006 "../src/Photo.vala"
			_g_object_unref0 (info);
#line 4006 "../src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 4006 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 4006 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 4006 "../src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 4006 "../src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 4006 "../src/Photo.vala"
			return;
#line 27392 "Photo.c"
		}
		{
			PhotoRow* _tmp45_;
#line 4008 "../src/Photo.vala"
			_tmp45_ = self->row;
#line 4008 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 27400 "Photo.c"
			{
				BackingPhotoRow* _tmp46_;
				GTimeVal _tmp47_;
				BackingPhotoRow* _tmp48_;
				GFileInfo* _tmp49_;
				BackingPhotoRow* _tmp50_;
				GTimeVal _tmp51_;
				BackingPhotoRow* _tmp52_;
				GFileInfo* _tmp53_;
#line 4009 "../src/Photo.vala"
				_tmp46_ = self->priv->editable;
#line 4009 "../src/Photo.vala"
				_tmp47_ = timestamp;
#line 4009 "../src/Photo.vala"
				timestamp_changed = _tmp46_->timestamp != ((time_t) _tmp47_.tv_sec);
#line 4010 "../src/Photo.vala"
				_tmp48_ = self->priv->editable;
#line 4010 "../src/Photo.vala"
				_tmp49_ = info;
#line 4010 "../src/Photo.vala"
				filesize_changed = _tmp48_->filesize != g_file_info_get_size (_tmp49_);
#line 4012 "../src/Photo.vala"
				_tmp50_ = self->priv->editable;
#line 4012 "../src/Photo.vala"
				_tmp51_ = timestamp;
#line 4012 "../src/Photo.vala"
				_tmp50_->timestamp = (time_t) _tmp51_.tv_sec;
#line 4013 "../src/Photo.vala"
				_tmp52_ = self->priv->editable;
#line 4013 "../src/Photo.vala"
				_tmp53_ = info;
#line 4013 "../src/Photo.vala"
				_tmp52_->filesize = g_file_info_get_size (_tmp53_);
#line 27434 "Photo.c"
			}
			__finally227:
			{
				PhotoRow* _tmp54_;
#line 4008 "../src/Photo.vala"
				_tmp54_ = self->row;
#line 4008 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27443 "Photo.c"
			}
#line 4008 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4008 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4008 "../src/Photo.vala"
				_g_object_unref0 (info);
#line 4008 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4008 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4008 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4008 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4008 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4008 "../src/Photo.vala"
				return;
#line 27463 "Photo.c"
			}
		}
#line 3990 "../src/Photo.vala"
		_g_object_unref0 (info);
#line 27468 "Photo.c"
	} else {
		gboolean _tmp55_ = FALSE;
#line 4017 "../src/Photo.vala"
		if (backing_photo_id_is_valid (&editable_id)) {
#line 4017 "../src/Photo.vala"
			_tmp55_ = !is_new_editable;
#line 27475 "Photo.c"
		} else {
#line 4017 "../src/Photo.vala"
			_tmp55_ = FALSE;
#line 27479 "Photo.c"
		}
#line 4017 "../src/Photo.vala"
		if (_tmp55_) {
#line 27483 "Photo.c"
			BackingPhotoRow* _tmp56_;
			BackingPhotoID _tmp57_;
			BackingPhotoTable* _tmp58_;
			BackingPhotoTable* _tmp59_;
			BackingPhotoRow* _tmp60_;
#line 4022 "../src/Photo.vala"
			_tmp56_ = backing;
#line 4022 "../src/Photo.vala"
			_tmp57_ = editable_id;
#line 4022 "../src/Photo.vala"
			_tmp56_->id = _tmp57_;
#line 4023 "../src/Photo.vala"
			_tmp58_ = backing_photo_table_get_instance ();
#line 4023 "../src/Photo.vala"
			_tmp59_ = _tmp58_;
#line 4023 "../src/Photo.vala"
			_tmp60_ = backing;
#line 4023 "../src/Photo.vala"
			backing_photo_table_update (_tmp59_, _tmp60_, &_inner_error0_);
#line 4023 "../src/Photo.vala"
			_database_table_unref0 (_tmp59_);
#line 4023 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4023 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4023 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4023 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4023 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4023 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4023 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4023 "../src/Photo.vala"
				return;
#line 27521 "Photo.c"
			}
			{
				PhotoRow* _tmp61_;
#line 4024 "../src/Photo.vala"
				_tmp61_ = self->row;
#line 4024 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27529 "Photo.c"
				{
					BackingPhotoRow* _tmp62_;
					BackingPhotoRow* _tmp63_;
					BackingPhotoRow* _tmp64_;
					BackingPhotoRow* _tmp65_;
					BackingPhotoRow* _tmp66_;
					BackingPhotoRow* _tmp67_;
					BackingPhotoRow* _tmp68_;
					BackingPhotoRow* _tmp69_;
					BackingPhotoRow* _tmp70_;
					Orientation _tmp71_;
#line 4025 "../src/Photo.vala"
					_tmp62_ = self->priv->editable;
#line 4025 "../src/Photo.vala"
					_tmp63_ = backing;
#line 4025 "../src/Photo.vala"
					timestamp_changed = _tmp62_->timestamp != _tmp63_->timestamp;
#line 4026 "../src/Photo.vala"
					_tmp64_ = self->priv->editable;
#line 4026 "../src/Photo.vala"
					_tmp65_ = backing;
#line 4026 "../src/Photo.vala"
					filesize_changed = _tmp64_->filesize != _tmp65_->filesize;
#line 4028 "../src/Photo.vala"
					_tmp66_ = backing;
#line 4028 "../src/Photo.vala"
					_tmp67_ = _backing_photo_row_ref0 (_tmp66_);
#line 4028 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 4028 "../src/Photo.vala"
					self->priv->editable = _tmp67_;
#line 4029 "../src/Photo.vala"
					_tmp68_ = self->priv->editable;
#line 4029 "../src/Photo.vala"
					_tmp69_ = _backing_photo_row_ref0 (_tmp68_);
#line 4029 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4029 "../src/Photo.vala"
					self->backing_photo_row = _tmp69_;
#line 4030 "../src/Photo.vala"
					_tmp70_ = self->backing_photo_row;
#line 4030 "../src/Photo.vala"
					_tmp71_ = _tmp70_->original_orientation;
#line 4030 "../src/Photo.vala"
					photo_set_orientation (self, _tmp71_);
#line 27575 "Photo.c"
				}
				__finally228:
				{
					PhotoRow* _tmp72_;
#line 4024 "../src/Photo.vala"
					_tmp72_ = self->row;
#line 4024 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27584 "Photo.c"
				}
#line 4024 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4024 "../src/Photo.vala"
					g_propagate_error (error, _inner_error0_);
#line 4024 "../src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 4024 "../src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 4024 "../src/Photo.vala"
					_g_object_unref0 (file);
#line 4024 "../src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 4024 "../src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 4024 "../src/Photo.vala"
					return;
#line 27602 "Photo.c"
				}
			}
		}
	}
#line 4036 "../src/Photo.vala"
	if (new_reader != NULL) {
#line 27609 "Photo.c"
		{
			PhotoBackingReaders* _tmp73_;
#line 4037 "../src/Photo.vala"
			_tmp73_ = self->priv->readers;
#line 4037 "../src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27616 "Photo.c"
			{
				PhotoBackingReaders* _tmp74_;
				PhotoFileReader* _tmp75_;
#line 4038 "../src/Photo.vala"
				_tmp74_ = self->priv->readers;
#line 4038 "../src/Photo.vala"
				_tmp75_ = _photo_file_adapter_ref0 (new_reader);
#line 4038 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp74_->editable);
#line 4038 "../src/Photo.vala"
				_tmp74_->editable = _tmp75_;
#line 27628 "Photo.c"
			}
			__finally229:
			{
				PhotoBackingReaders* _tmp76_;
#line 4037 "../src/Photo.vala"
				_tmp76_ = self->priv->readers;
#line 4037 "../src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27637 "Photo.c"
			}
#line 4037 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4037 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 4037 "../src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 4037 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 4037 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 4037 "../src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 4037 "../src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 4037 "../src/Photo.vala"
				return;
#line 27655 "Photo.c"
			}
		}
	}
#line 4042 "../src/Photo.vala"
	if (!only_attributes) {
#line 27661 "Photo.c"
		PhotoFileReader* _tmp78_;
		PhotoFileReader* _tmp79_;
#line 4042 "../src/Photo.vala"
		_tmp78_ = reader;
#line 4042 "../src/Photo.vala"
		_tmp79_ = old_reader;
#line 4042 "../src/Photo.vala"
		_tmp77_ = _tmp78_ != _tmp79_;
#line 27670 "Photo.c"
	} else {
#line 4042 "../src/Photo.vala"
		_tmp77_ = FALSE;
#line 27674 "Photo.c"
	}
#line 4042 "../src/Photo.vala"
	if (_tmp77_) {
#line 27678 "Photo.c"
		GFile* _tmp80_ = NULL;
		PhotoFileReader* _tmp81_;
		GFile* _tmp84_ = NULL;
#line 4043 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4044 "../src/Photo.vala"
		_tmp81_ = old_reader;
#line 4044 "../src/Photo.vala"
		if (_tmp81_ != NULL) {
#line 27688 "Photo.c"
			PhotoFileReader* _tmp82_;
			GFile* _tmp83_;
#line 4044 "../src/Photo.vala"
			_tmp82_ = old_reader;
#line 4044 "../src/Photo.vala"
			_tmp83_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp82_);
#line 4044 "../src/Photo.vala"
			_g_object_unref0 (_tmp80_);
#line 4044 "../src/Photo.vala"
			_tmp80_ = _tmp83_;
#line 27699 "Photo.c"
		} else {
#line 4044 "../src/Photo.vala"
			_g_object_unref0 (_tmp80_);
#line 4044 "../src/Photo.vala"
			_tmp80_ = NULL;
#line 27705 "Photo.c"
		}
#line 4045 "../src/Photo.vala"
		if (new_reader != NULL) {
#line 27709 "Photo.c"
			GFile* _tmp85_;
#line 4045 "../src/Photo.vala"
			_tmp85_ = photo_file_adapter_get_file ((PhotoFileAdapter*) new_reader);
#line 4045 "../src/Photo.vala"
			_g_object_unref0 (_tmp84_);
#line 4045 "../src/Photo.vala"
			_tmp84_ = _tmp85_;
#line 27717 "Photo.c"
		} else {
#line 4045 "../src/Photo.vala"
			_g_object_unref0 (_tmp84_);
#line 4045 "../src/Photo.vala"
			_tmp84_ = NULL;
#line 27723 "Photo.c"
		}
#line 4044 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp80_, _tmp84_);
#line 4042 "../src/Photo.vala"
		_g_object_unref0 (_tmp84_);
#line 4042 "../src/Photo.vala"
		_g_object_unref0 (_tmp80_);
#line 27731 "Photo.c"
	}
#line 4048 "../src/Photo.vala"
	_tmp86_ = g_new0 (gchar*, 0 + 1);
#line 4048 "../src/Photo.vala"
	alteration_list = _tmp86_;
#line 4048 "../src/Photo.vala"
	alteration_list_length1 = 0;
#line 4048 "../src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 4049 "../src/Photo.vala"
	if (timestamp_changed) {
#line 27743 "Photo.c"
		gchar** _tmp87_;
		gint _tmp87__length1;
		gchar* _tmp88_;
		gchar** _tmp89_;
		gint _tmp89__length1;
		gchar* _tmp90_;
#line 4050 "../src/Photo.vala"
		_tmp87_ = alteration_list;
#line 4050 "../src/Photo.vala"
		_tmp87__length1 = alteration_list_length1;
#line 4050 "../src/Photo.vala"
		_tmp88_ = g_strdup ("metadata:editable-timestamp");
#line 4050 "../src/Photo.vala"
		_vala_array_add24 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp88_);
#line 4051 "../src/Photo.vala"
		_tmp89_ = alteration_list;
#line 4051 "../src/Photo.vala"
		_tmp89__length1 = alteration_list_length1;
#line 4051 "../src/Photo.vala"
		_tmp90_ = g_strdup ("metadata:baseline-timestamp");
#line 4051 "../src/Photo.vala"
		_vala_array_add25 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp90_);
#line 4053 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 27768 "Photo.c"
			gchar** _tmp91_;
			gint _tmp91__length1;
			gchar* _tmp92_;
#line 4054 "../src/Photo.vala"
			_tmp91_ = alteration_list;
#line 4054 "../src/Photo.vala"
			_tmp91__length1 = alteration_list_length1;
#line 4054 "../src/Photo.vala"
			_tmp92_ = g_strdup ("metadata:source-timestamp");
#line 4054 "../src/Photo.vala"
			_vala_array_add26 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp92_);
#line 27780 "Photo.c"
		}
	}
#line 4058 "../src/Photo.vala"
	if (filesize_changed) {
#line 4058 "../src/Photo.vala"
		_tmp93_ = TRUE;
#line 27787 "Photo.c"
	} else {
#line 4058 "../src/Photo.vala"
		_tmp93_ = new_reader != NULL;
#line 27791 "Photo.c"
	}
#line 4058 "../src/Photo.vala"
	if (_tmp93_) {
#line 27795 "Photo.c"
		gchar** _tmp94_;
		gint _tmp94__length1;
		gchar* _tmp95_;
		gchar** _tmp96_;
		gint _tmp96__length1;
		gchar* _tmp97_;
#line 4059 "../src/Photo.vala"
		_tmp94_ = alteration_list;
#line 4059 "../src/Photo.vala"
		_tmp94__length1 = alteration_list_length1;
#line 4059 "../src/Photo.vala"
		_tmp95_ = g_strdup ("image:editable");
#line 4059 "../src/Photo.vala"
		_vala_array_add27 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp95_);
#line 4060 "../src/Photo.vala"
		_tmp96_ = alteration_list;
#line 4060 "../src/Photo.vala"
		_tmp96__length1 = alteration_list_length1;
#line 4060 "../src/Photo.vala"
		_tmp97_ = g_strdup ("image:baseline");
#line 4060 "../src/Photo.vala"
		_vala_array_add28 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp97_);
#line 4062 "../src/Photo.vala"
		if (photo_is_editable_source (self)) {
#line 27820 "Photo.c"
			gchar** _tmp98_;
			gint _tmp98__length1;
			gchar* _tmp99_;
#line 4063 "../src/Photo.vala"
			_tmp98_ = alteration_list;
#line 4063 "../src/Photo.vala"
			_tmp98__length1 = alteration_list_length1;
#line 4063 "../src/Photo.vala"
			_tmp99_ = g_strdup ("image:source");
#line 4063 "../src/Photo.vala"
			_vala_array_add29 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp99_);
#line 27832 "Photo.c"
		}
	}
#line 4067 "../src/Photo.vala"
	_tmp100_ = alteration_list;
#line 4067 "../src/Photo.vala"
	_tmp100__length1 = alteration_list_length1;
#line 4067 "../src/Photo.vala"
	if (_tmp100__length1 > 0) {
#line 27841 "Photo.c"
		gchar** _tmp101_;
		gint _tmp101__length1;
		Alteration* _tmp102_;
		Alteration* _tmp103_;
#line 4068 "../src/Photo.vala"
		_tmp101_ = alteration_list;
#line 4068 "../src/Photo.vala"
		_tmp101__length1 = alteration_list_length1;
#line 4068 "../src/Photo.vala"
		_tmp102_ = alteration_new_from_array (_tmp101_, _tmp101__length1);
#line 4068 "../src/Photo.vala"
		_tmp103_ = _tmp102_;
#line 4068 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp103_);
#line 4068 "../src/Photo.vala"
		_alteration_unref0 (_tmp103_);
#line 27858 "Photo.c"
	}
#line 3948 "../src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3948 "../src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3948 "../src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3948 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 3948 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3948 "../src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 27872 "Photo.c"
}

static void
photo_detach_editable (Photo* self,
                       gboolean delete_editable,
                       gboolean remove_transformations,
                       gboolean notify)
{
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 4072 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4073 "../src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 4075 "../src/Photo.vala"
	has_editable = FALSE;
#line 4076 "../src/Photo.vala"
	editable_file = NULL;
#line 27895 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4077 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4077 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 27902 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_;
			PhotoFileReader* _tmp2_;
#line 4078 "../src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 4078 "../src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 4078 "../src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27912 "Photo.c"
				PhotoBackingReaders* _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_;
				PhotoBackingReaders* _tmp6_;
#line 4079 "../src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 4079 "../src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 4079 "../src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 4079 "../src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 4079 "../src/Photo.vala"
				editable_file = _tmp5_;
#line 4080 "../src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 4080 "../src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 4080 "../src/Photo.vala"
				_tmp6_->editable = NULL;
#line 4081 "../src/Photo.vala"
				has_editable = TRUE;
#line 27935 "Photo.c"
			}
		}
		__finally230:
		{
			PhotoBackingReaders* _tmp7_;
#line 4077 "../src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 4077 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27945 "Photo.c"
		}
#line 4077 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4077 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4077 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4077 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4077 "../src/Photo.vala"
			return;
#line 27957 "Photo.c"
		}
	}
#line 4085 "../src/Photo.vala"
	if (has_editable) {
#line 27962 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 4086 "../src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 27966 "Photo.c"
		{
			{
				PhotoRow* _tmp8_;
#line 4088 "../src/Photo.vala"
				_tmp8_ = self->row;
#line 4088 "../src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27974 "Photo.c"
				{
					PhotoRow* _tmp9_;
					BackingPhotoID _tmp10_;
					PhotoRow* _tmp14_;
					BackingPhotoRow* _tmp15_;
					BackingPhotoRow* _tmp16_;
#line 4089 "../src/Photo.vala"
					_tmp9_ = self->row;
#line 4089 "../src/Photo.vala"
					_tmp10_ = _tmp9_->editable_id;
#line 4089 "../src/Photo.vala"
					editable_id = _tmp10_;
#line 4090 "../src/Photo.vala"
					if (backing_photo_id_is_valid (&editable_id)) {
#line 27989 "Photo.c"
						PhotoTable* _tmp11_;
						PhotoTable* _tmp12_;
						PhotoRow* _tmp13_;
#line 4091 "../src/Photo.vala"
						_tmp11_ = photo_table_get_instance ();
#line 4091 "../src/Photo.vala"
						_tmp12_ = _tmp11_;
#line 4091 "../src/Photo.vala"
						_tmp13_ = self->row;
#line 4091 "../src/Photo.vala"
						photo_table_detach_editable (_tmp12_, _tmp13_, &_inner_error0_);
#line 4091 "../src/Photo.vala"
						_database_table_unref0 (_tmp12_);
#line 4091 "../src/Photo.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28005 "Photo.c"
							goto __finally232;
						}
					}
#line 4093 "../src/Photo.vala"
					_tmp14_ = self->row;
#line 4093 "../src/Photo.vala"
					_tmp15_ = _tmp14_->master;
#line 4093 "../src/Photo.vala"
					_tmp16_ = _backing_photo_row_ref0 (_tmp15_);
#line 4093 "../src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 4093 "../src/Photo.vala"
					self->backing_photo_row = _tmp16_;
#line 28019 "Photo.c"
				}
				__finally232:
				{
					GError* _inner_error1_ = NULL;
					PhotoRow* _tmp17_;
#line 4088 "../src/Photo.vala"
					_tmp17_ = self->row;
#line 4088 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28029 "Photo.c"
				}
#line 4088 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4088 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 28035 "Photo.c"
						goto __catch231_database_error;
					}
#line 4088 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4088 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4088 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4088 "../src/Photo.vala"
					return;
#line 28046 "Photo.c"
				}
			}
		}
		goto __finally231;
		__catch231_database_error:
		{
			GError* err = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
#line 4087 "../src/Photo.vala"
			err = _inner_error0_;
#line 4087 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4096 "../src/Photo.vala"
			_tmp18_ = err;
#line 4096 "../src/Photo.vala"
			_tmp19_ = _tmp18_->message;
#line 4096 "../src/Photo.vala"
			g_warning ("Photo.vala:4096: Unable to remove editable from PhotoTable: %s", _tmp19_);
#line 4087 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28068 "Photo.c"
		}
		__finally231:
#line 4087 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4087 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4087 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4087 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4087 "../src/Photo.vala"
			return;
#line 28081 "Photo.c"
		}
		{
#line 4100 "../src/Photo.vala"
			if (backing_photo_id_is_valid (&editable_id)) {
#line 28086 "Photo.c"
				BackingPhotoTable* _tmp20_;
				BackingPhotoTable* _tmp21_;
				BackingPhotoID _tmp22_;
#line 4101 "../src/Photo.vala"
				_tmp20_ = backing_photo_table_get_instance ();
#line 4101 "../src/Photo.vala"
				_tmp21_ = _tmp20_;
#line 4101 "../src/Photo.vala"
				_tmp22_ = editable_id;
#line 4101 "../src/Photo.vala"
				backing_photo_table_remove (_tmp21_, &_tmp22_, &_inner_error0_);
#line 4101 "../src/Photo.vala"
				_database_table_unref0 (_tmp21_);
#line 4101 "../src/Photo.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4101 "../src/Photo.vala"
					if (_inner_error0_->domain == DATABASE_ERROR) {
#line 28104 "Photo.c"
						goto __catch233_database_error;
					}
#line 4101 "../src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 4101 "../src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4101 "../src/Photo.vala"
					g_clear_error (&_inner_error0_);
#line 4101 "../src/Photo.vala"
					return;
#line 28115 "Photo.c"
				}
			}
		}
		goto __finally233;
		__catch233_database_error:
		{
			GError* err = NULL;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 4099 "../src/Photo.vala"
			err = _inner_error0_;
#line 4099 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4104 "../src/Photo.vala"
			_tmp23_ = err;
#line 4104 "../src/Photo.vala"
			_tmp24_ = _tmp23_->message;
#line 4104 "../src/Photo.vala"
			g_warning ("Photo.vala:4104: Unable to remove editable from BackingPhotoTable: %s", _tmp24_);
#line 4099 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28137 "Photo.c"
		}
		__finally233:
#line 4099 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4099 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4099 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4099 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4099 "../src/Photo.vala"
			return;
#line 28150 "Photo.c"
		}
	}
#line 4108 "../src/Photo.vala"
	if (remove_transformations) {
#line 4109 "../src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 28157 "Photo.c"
	}
#line 4112 "../src/Photo.vala"
	if (has_editable) {
#line 28161 "Photo.c"
		GFile* _tmp25_;
#line 4113 "../src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 4114 "../src/Photo.vala"
		_tmp25_ = editable_file;
#line 4114 "../src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp25_, NULL);
#line 28169 "Photo.c"
	}
#line 4117 "../src/Photo.vala"
	if (delete_editable) {
#line 28173 "Photo.c"
		GFile* _tmp27_;
#line 4117 "../src/Photo.vala"
		_tmp27_ = editable_file;
#line 4117 "../src/Photo.vala"
		_tmp26_ = _tmp27_ != NULL;
#line 28179 "Photo.c"
	} else {
#line 4117 "../src/Photo.vala"
		_tmp26_ = FALSE;
#line 28183 "Photo.c"
	}
#line 4117 "../src/Photo.vala"
	if (_tmp26_) {
#line 28187 "Photo.c"
		{
			GFile* _tmp28_;
#line 4119 "../src/Photo.vala"
			_tmp28_ = editable_file;
#line 4119 "../src/Photo.vala"
			g_file_trash (_tmp28_, NULL, &_inner_error0_);
#line 4119 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28196 "Photo.c"
				goto __catch234_g_error;
			}
		}
		goto __finally234;
		__catch234_g_error:
		{
			GError* err = NULL;
			GFile* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GError* _tmp34_;
			const gchar* _tmp35_;
#line 4118 "../src/Photo.vala"
			err = _inner_error0_;
#line 4118 "../src/Photo.vala"
			_inner_error0_ = NULL;
#line 4121 "../src/Photo.vala"
			_tmp29_ = editable_file;
#line 4121 "../src/Photo.vala"
			_tmp30_ = g_file_get_path (_tmp29_);
#line 4121 "../src/Photo.vala"
			_tmp31_ = _tmp30_;
#line 4121 "../src/Photo.vala"
			_tmp32_ = data_object_to_string ((DataObject*) self);
#line 4121 "../src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 4121 "../src/Photo.vala"
			_tmp34_ = err;
#line 4121 "../src/Photo.vala"
			_tmp35_ = _tmp34_->message;
#line 4121 "../src/Photo.vala"
			g_warning ("Photo.vala:4121: Unable to trash editable %s for %s: %s", _tmp31_, _tmp33_, _tmp35_);
#line 4121 "../src/Photo.vala"
			_g_free0 (_tmp33_);
#line 4121 "../src/Photo.vala"
			_g_free0 (_tmp31_);
#line 4118 "../src/Photo.vala"
			_g_error_free0 (err);
#line 28237 "Photo.c"
		}
		__finally234:
#line 4118 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4118 "../src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 4118 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4118 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4118 "../src/Photo.vala"
			return;
#line 28250 "Photo.c"
		}
	}
#line 4126 "../src/Photo.vala"
	if (has_editable) {
#line 4126 "../src/Photo.vala"
		_tmp37_ = TRUE;
#line 28257 "Photo.c"
	} else {
#line 4126 "../src/Photo.vala"
		_tmp37_ = remove_transformations;
#line 28261 "Photo.c"
	}
#line 4126 "../src/Photo.vala"
	if (_tmp37_) {
#line 4126 "../src/Photo.vala"
		_tmp36_ = notify;
#line 28267 "Photo.c"
	} else {
#line 4126 "../src/Photo.vala"
		_tmp36_ = FALSE;
#line 28271 "Photo.c"
	}
#line 4126 "../src/Photo.vala"
	if (_tmp36_) {
#line 28275 "Photo.c"
		Alteration* _tmp38_;
		Alteration* _tmp39_;
#line 4127 "../src/Photo.vala"
		_tmp38_ = alteration_new ("image", "revert");
#line 4127 "../src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 4127 "../src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp39_);
#line 4127 "../src/Photo.vala"
		_alteration_unref0 (_tmp39_);
#line 28286 "Photo.c"
	}
#line 4072 "../src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 28290 "Photo.c"
}

static void
_photo_on_reimport_editable_one_shot_callback (gpointer self)
{
#line 4143 "../src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 28298 "Photo.c"
}

static void
_photo_on_update_editable_attributes_one_shot_callback (gpointer self)
{
#line 4152 "../src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 28306 "Photo.c"
}

static void
_photo_on_remove_editable_one_shot_callback (gpointer self)
{
#line 4161 "../src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 28314 "Photo.c"
}

static void
photo_on_editable_file_changed (Photo* self,
                                GFile* file,
                                GFile* other_file,
                                GFileMonitorEvent event)
{
	GEnumValue* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 4131 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4131 "../src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 28331 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_;
#line 4133 "../src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 4133 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28338 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 4134 "../src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 4134 "../src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 4134 "../src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 28349 "Photo.c"
				PhotoBackingReaders* _tmp4_;
				PhotoFileReader* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
#line 4134 "../src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 4134 "../src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 4134 "../src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp5_);
#line 4134 "../src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 4134 "../src/Photo.vala"
				_tmp1_ = g_file_equal (file, _tmp7_);
#line 4134 "../src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 28366 "Photo.c"
			} else {
#line 4134 "../src/Photo.vala"
				_tmp1_ = FALSE;
#line 28370 "Photo.c"
			}
#line 4134 "../src/Photo.vala"
			_vala_assert (_tmp1_, "readers.editable != null && file.equal (readers.editable.get_file ())");
#line 28374 "Photo.c"
		}
		__finally235:
		{
			PhotoBackingReaders* _tmp8_;
#line 4133 "../src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 4133 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28383 "Photo.c"
		}
#line 4133 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4133 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4133 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4133 "../src/Photo.vala"
			return;
#line 28393 "Photo.c"
		}
	}
#line 4137 "../src/Photo.vala"
	_tmp9_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), event);
#line 4137 "../src/Photo.vala"
	_tmp10_ = g_file_get_path (file);
#line 4137 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4137 "../src/Photo.vala"
	g_debug ("Photo.vala:4137: EDITABLE %s: %s", (_tmp9_ != NULL) ? _tmp9_->value_name : NULL, _tmp11_);
#line 4137 "../src/Photo.vala"
	_g_free0 (_tmp11_);
#line 4139 "../src/Photo.vala"
	switch (event) {
#line 4139 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 4139 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 28412 "Photo.c"
		{
			OneShotScheduler* _tmp12_;
			OneShotScheduler* _tmp14_;
#line 4142 "../src/Photo.vala"
			_tmp12_ = self->priv->reimport_editable_scheduler;
#line 4142 "../src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 28420 "Photo.c"
				OneShotScheduler* _tmp13_;
#line 4143 "../src/Photo.vala"
				_tmp13_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 4143 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 4143 "../src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp13_;
#line 28428 "Photo.c"
			}
#line 4147 "../src/Photo.vala"
			_tmp14_ = self->priv->reimport_editable_scheduler;
#line 4147 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp14_, (guint) 1000, TRUE);
#line 4148 "../src/Photo.vala"
			break;
#line 28436 "Photo.c"
		}
#line 4139 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 28440 "Photo.c"
		{
			OneShotScheduler* _tmp15_;
			OneShotScheduler* _tmp17_;
#line 4151 "../src/Photo.vala"
			_tmp15_ = self->priv->update_editable_attributes_scheduler;
#line 4151 "../src/Photo.vala"
			if (_tmp15_ == NULL) {
#line 28448 "Photo.c"
				OneShotScheduler* _tmp16_;
#line 4152 "../src/Photo.vala"
				_tmp16_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4152 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4152 "../src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp16_;
#line 28456 "Photo.c"
			}
#line 4156 "../src/Photo.vala"
			_tmp17_ = self->priv->update_editable_attributes_scheduler;
#line 4156 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp17_, (guint) 1000, TRUE);
#line 4157 "../src/Photo.vala"
			break;
#line 28464 "Photo.c"
		}
#line 4139 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 28468 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 4160 "../src/Photo.vala"
			_tmp18_ = self->priv->remove_editable_scheduler;
#line 4160 "../src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 28476 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 4161 "../src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4161 "../src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4161 "../src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp19_;
#line 28484 "Photo.c"
			}
#line 4165 "../src/Photo.vala"
			_tmp20_ = self->priv->remove_editable_scheduler;
#line 4165 "../src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 3000, TRUE);
#line 4166 "../src/Photo.vala"
			break;
#line 28492 "Photo.c"
		}
		default:
#line 4139 "../src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 28497 "Photo.c"
		{
#line 4171 "../src/Photo.vala"
			break;
#line 28501 "Photo.c"
		}
	}
#line 4176 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 28506 "Photo.c"
}

static void
photo_on_reimport_editable (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4179 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4181 "../src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4183 "../src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4183 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4183 "../src/Photo.vala"
	g_debug ("Photo.vala:4183: Reimporting editable for %s", _tmp1_);
#line 4183 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 28527 "Photo.c"
	{
#line 4185 "../src/Photo.vala"
		photo_reimport_editable (self, &_inner_error0_);
#line 4185 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28533 "Photo.c"
			goto __catch236_g_error;
		}
	}
	goto __finally236;
	__catch236_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 4184 "../src/Photo.vala"
		err = _inner_error0_;
#line 4184 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4187 "../src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 4187 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4187 "../src/Photo.vala"
		_tmp4_ = err;
#line 4187 "../src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4187 "../src/Photo.vala"
		g_warning ("Photo.vala:4187: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4187 "../src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4184 "../src/Photo.vala"
		_g_error_free0 (err);
#line 28563 "Photo.c"
	}
	__finally236:
#line 4184 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4184 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4184 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4184 "../src/Photo.vala"
		return;
#line 28574 "Photo.c"
	}
}

static void
photo_on_update_editable_attributes (Photo* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4192 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4193 "../src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4193 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4193 "../src/Photo.vala"
	g_debug ("Photo.vala:4193: Updating editable attributes for %s", _tmp1_);
#line 4193 "../src/Photo.vala"
	_g_free0 (_tmp1_);
#line 28594 "Photo.c"
	{
#line 4195 "../src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error0_);
#line 4195 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28600 "Photo.c"
			goto __catch237_g_error;
		}
	}
	goto __finally237;
	__catch237_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 4194 "../src/Photo.vala"
		err = _inner_error0_;
#line 4194 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4197 "../src/Photo.vala"
		_tmp2_ = err;
#line 4197 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4197 "../src/Photo.vala"
		g_warning ("Photo.vala:4197: Unable to update editable attributes: %s", _tmp3_);
#line 4194 "../src/Photo.vala"
		_g_error_free0 (err);
#line 28622 "Photo.c"
	}
	__finally237:
#line 4194 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4194 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4194 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4194 "../src/Photo.vala"
		return;
#line 28633 "Photo.c"
	}
}

static void
photo_on_remove_editable (Photo* self)
{
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 4201 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4202 "../src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4202 "../src/Photo.vala"
	reader = _tmp0_;
#line 4203 "../src/Photo.vala"
	_tmp1_ = reader;
#line 4203 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4204 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4204 "../src/Photo.vala"
		return;
#line 28663 "Photo.c"
	}
#line 4207 "../src/Photo.vala"
	_tmp2_ = reader;
#line 4207 "../src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp2_);
#line 4207 "../src/Photo.vala"
	file = _tmp3_;
#line 4208 "../src/Photo.vala"
	_tmp4_ = file;
#line 4208 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 28675 "Photo.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 4209 "../src/Photo.vala"
		_tmp5_ = data_object_to_string ((DataObject*) self);
#line 4209 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4209 "../src/Photo.vala"
		g_debug ("Photo.vala:4209: Not removing editable for %s: file exists", _tmp6_);
#line 4209 "../src/Photo.vala"
		_g_free0 (_tmp6_);
#line 4211 "../src/Photo.vala"
		_g_object_unref0 (file);
#line 4211 "../src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4211 "../src/Photo.vala"
		return;
#line 28692 "Photo.c"
	}
#line 4214 "../src/Photo.vala"
	_tmp7_ = data_object_to_string ((DataObject*) self);
#line 4214 "../src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4214 "../src/Photo.vala"
	g_debug ("Photo.vala:4214: Removing editable for %s: file no longer exists", _tmp8_);
#line 4214 "../src/Photo.vala"
	_g_free0 (_tmp8_);
#line 4215 "../src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4201 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 4201 "../src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 28708 "Photo.c"
}

void
photo_get_original_dimensions (Photo* self,
                               Dimensions* result)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Dimensions _tmp1_;
	Dimensions _tmp2_ = {0};
#line 4223 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4224 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4224 "../src/Photo.vala"
	dim = _tmp0_;
#line 4225 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4227 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4227 "../src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp1_, &_tmp2_);
#line 4227 "../src/Photo.vala"
	*result = _tmp2_;
#line 4227 "../src/Photo.vala"
	return;
#line 28736 "Photo.c"
}

void
photo_get_master_dimensions (Photo* self,
                             Dimensions* result)
{
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 4231 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4232 "../src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4232 "../src/Photo.vala"
	orientation_rotate_dimensions (photo_get_original_orientation (self), &_tmp0_, &_tmp1_);
#line 4232 "../src/Photo.vala"
	*result = _tmp1_;
#line 4232 "../src/Photo.vala"
	return;
#line 28755 "Photo.c"
}

gboolean
photo_get_crop (Photo* self,
                Box* crop,
                PhotoException exceptions)
{
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
#line 4236 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4238 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4238 "../src/Photo.vala"
	raw = _tmp0_;
#line 4238 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4239 "../src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4241 "../src/Photo.vala"
		result = FALSE;
#line 4241 "../src/Photo.vala"
		if (crop) {
#line 4241 "../src/Photo.vala"
			*crop = _vala_crop;
#line 28787 "Photo.c"
		}
#line 4241 "../src/Photo.vala"
		return result;
#line 28791 "Photo.c"
	}
#line 4244 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4244 "../src/Photo.vala"
	dim = _tmp2_;
#line 4245 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4247 "../src/Photo.vala"
	if (photo_exception_allows (exceptions, PHOTO_EXCEPTION_ORIENTATION)) {
#line 28801 "Photo.c"
		Orientation _tmp3_;
		Dimensions _tmp4_;
		Box _tmp5_;
		Box _tmp6_ = {0};
#line 4248 "../src/Photo.vala"
		_tmp3_ = orientation;
#line 4248 "../src/Photo.vala"
		_tmp4_ = dim;
#line 4248 "../src/Photo.vala"
		_tmp5_ = raw;
#line 4248 "../src/Photo.vala"
		orientation_rotate_box (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 4248 "../src/Photo.vala"
		_vala_crop = _tmp6_;
#line 28816 "Photo.c"
	} else {
		Box _tmp7_;
#line 4250 "../src/Photo.vala"
		_tmp7_ = raw;
#line 4250 "../src/Photo.vala"
		_vala_crop = _tmp7_;
#line 28823 "Photo.c"
	}
#line 4253 "../src/Photo.vala"
	result = TRUE;
#line 4253 "../src/Photo.vala"
	if (crop) {
#line 4253 "../src/Photo.vala"
		*crop = _vala_crop;
#line 28831 "Photo.c"
	}
#line 4253 "../src/Photo.vala"
	return result;
#line 28835 "Photo.c"
}

void
photo_set_crop (Photo* self,
                Box* crop)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Box derotated = {0};
	Dimensions _tmp1_;
	Box _tmp2_;
	Box _tmp3_ = {0};
	Box _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_;
	Dimensions _tmp10_;
	Box _tmp11_;
	Box _tmp12_;
	Dimensions _tmp13_;
	Box _tmp14_;
#line 4257 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4257 "../src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4258 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4258 "../src/Photo.vala"
	dim = _tmp0_;
#line 4259 "../src/Photo.vala"
	orientation = photo_get_orientation (self);
#line 4261 "../src/Photo.vala"
	_tmp1_ = dim;
#line 4261 "../src/Photo.vala"
	_tmp2_ = *crop;
#line 4261 "../src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp1_, &_tmp2_, &_tmp3_);
#line 4261 "../src/Photo.vala"
	derotated = _tmp3_;
#line 4263 "../src/Photo.vala"
	_tmp4_ = derotated;
#line 4263 "../src/Photo.vala"
	_tmp5_ = dim;
#line 4263 "../src/Photo.vala"
	derotated.left = CLAMP (_tmp4_.left, 0, _tmp5_.width - 2);
#line 4264 "../src/Photo.vala"
	_tmp6_ = derotated;
#line 4264 "../src/Photo.vala"
	_tmp7_ = derotated;
#line 4264 "../src/Photo.vala"
	_tmp8_ = dim;
#line 4264 "../src/Photo.vala"
	derotated.right = CLAMP (_tmp6_.right, _tmp7_.left, _tmp8_.width - 1);
#line 4266 "../src/Photo.vala"
	_tmp9_ = derotated;
#line 4266 "../src/Photo.vala"
	_tmp10_ = dim;
#line 4266 "../src/Photo.vala"
	derotated.top = CLAMP (_tmp9_.top, 0, _tmp10_.height - 2);
#line 4267 "../src/Photo.vala"
	_tmp11_ = derotated;
#line 4267 "../src/Photo.vala"
	_tmp12_ = derotated;
#line 4267 "../src/Photo.vala"
	_tmp13_ = dim;
#line 4267 "../src/Photo.vala"
	derotated.bottom = CLAMP (_tmp11_.bottom, _tmp12_.top, _tmp13_.height - 1);
#line 4269 "../src/Photo.vala"
	_tmp14_ = derotated;
#line 4269 "../src/Photo.vala"
	photo_set_raw_crop (self, &_tmp14_);
#line 28910 "Photo.c"
}

gboolean
photo_get_straighten (Photo* self,
                      gdouble* theta)
{
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 4272 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4273 "../src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4273 "../src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4273 "../src/Photo.vala"
	if (!_tmp1_) {
#line 4274 "../src/Photo.vala"
		result = FALSE;
#line 4274 "../src/Photo.vala"
		if (theta) {
#line 4274 "../src/Photo.vala"
			*theta = _vala_theta;
#line 28935 "Photo.c"
		}
#line 4274 "../src/Photo.vala"
		return result;
#line 28939 "Photo.c"
	}
#line 4277 "../src/Photo.vala"
	result = TRUE;
#line 4277 "../src/Photo.vala"
	if (theta) {
#line 4277 "../src/Photo.vala"
		*theta = _vala_theta;
#line 28947 "Photo.c"
	}
#line 4277 "../src/Photo.vala"
	return result;
#line 28951 "Photo.c"
}

void
photo_set_straighten (Photo* self,
                      gdouble theta)
{
#line 4280 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4281 "../src/Photo.vala"
	photo_set_raw_straighten (self, theta);
#line 28962 "Photo.c"
}

static GdkPixbuf*
photo_do_redeye (Photo* self,
                 GdkPixbuf* pixbuf,
                 EditingToolsRedeyeInstance* inst)
{
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp1_;
	gint* _tmp2_;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp7_;
	GdkPoint _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp10_;
	GdkPoint _tmp11_;
	EditingToolsRedeyeInstance _tmp12_;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp13_;
	GdkPoint _tmp14_;
	EditingToolsRedeyeInstance _tmp15_;
	gint _tmp16_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_;
	gint _tmp21_;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp41_;
	GdkPoint _tmp42_;
	EditingToolsRedeyeInstance _tmp43_;
	GdkPoint _tmp44_;
	EditingToolsRedeyeInstance _tmp45_;
	gint* _tmp46_;
	gint _tmp46__length1;
	GdkPixbuf* _tmp64_;
#line 4284 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4284 "../src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4284 "../src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4294 "../src/Photo.vala"
	_tmp0_ = *inst;
#line 4294 "../src/Photo.vala"
	r = (gdouble) _tmp0_.radius;
#line 4295 "../src/Photo.vala"
	_tmp1_ = *inst;
#line 4295 "../src/Photo.vala"
	_tmp2_ = g_new0 (gint, _tmp1_.radius + 1);
#line 4295 "../src/Photo.vala"
	x_insets_first_quadrant = _tmp2_;
#line 4295 "../src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp1_.radius + 1;
#line 4295 "../src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4297 "../src/Photo.vala"
	i = 0;
#line 29029 "Photo.c"
	{
		gdouble y = 0.0;
#line 4298 "../src/Photo.vala"
		y = r;
#line 29034 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
#line 4298 "../src/Photo.vala"
			_tmp3_ = TRUE;
#line 4298 "../src/Photo.vala"
			while (TRUE) {
#line 29041 "Photo.c"
				gdouble theta = 0.0;
				gint x = 0;
				gint* _tmp4_;
				gint _tmp4__length1;
				EditingToolsRedeyeInstance _tmp5_;
				gint _tmp6_;
#line 4298 "../src/Photo.vala"
				if (!_tmp3_) {
#line 4298 "../src/Photo.vala"
					y = y - 1.0;
#line 29052 "Photo.c"
				}
#line 4298 "../src/Photo.vala"
				_tmp3_ = FALSE;
#line 4298 "../src/Photo.vala"
				if (!(y >= 0.0)) {
#line 4298 "../src/Photo.vala"
					break;
#line 29060 "Photo.c"
				}
#line 4299 "../src/Photo.vala"
				theta = asin (y / r);
#line 4300 "../src/Photo.vala"
				x = (gint) ((r * cos (theta)) + 0.5);
#line 4301 "../src/Photo.vala"
				_tmp4_ = x_insets_first_quadrant;
#line 4301 "../src/Photo.vala"
				_tmp4__length1 = x_insets_first_quadrant_length1;
#line 4301 "../src/Photo.vala"
				_tmp5_ = *inst;
#line 4301 "../src/Photo.vala"
				_tmp4_[i] = _tmp5_.radius - x;
#line 4303 "../src/Photo.vala"
				_tmp6_ = i;
#line 4303 "../src/Photo.vala"
				i = _tmp6_ + 1;
#line 29078 "Photo.c"
			}
		}
	}
#line 4306 "../src/Photo.vala"
	_tmp7_ = *inst;
#line 4306 "../src/Photo.vala"
	_tmp8_ = _tmp7_.center;
#line 4306 "../src/Photo.vala"
	_tmp9_ = *inst;
#line 4306 "../src/Photo.vala"
	x_bounds_min = _tmp8_.x - _tmp9_.radius;
#line 4307 "../src/Photo.vala"
	_tmp10_ = *inst;
#line 4307 "../src/Photo.vala"
	_tmp11_ = _tmp10_.center;
#line 4307 "../src/Photo.vala"
	_tmp12_ = *inst;
#line 4307 "../src/Photo.vala"
	x_bounds_max = _tmp11_.x + _tmp12_.radius;
#line 4308 "../src/Photo.vala"
	_tmp13_ = *inst;
#line 4308 "../src/Photo.vala"
	_tmp14_ = _tmp13_.center;
#line 4308 "../src/Photo.vala"
	_tmp15_ = *inst;
#line 4308 "../src/Photo.vala"
	ymin = _tmp14_.y - _tmp15_.radius;
#line 4309 "../src/Photo.vala"
	if (ymin < 0) {
#line 4309 "../src/Photo.vala"
		_tmp16_ = 0;
#line 29110 "Photo.c"
	} else {
#line 4309 "../src/Photo.vala"
		_tmp16_ = ymin;
#line 29114 "Photo.c"
	}
#line 4309 "../src/Photo.vala"
	ymin = _tmp16_;
#line 4310 "../src/Photo.vala"
	_tmp17_ = *inst;
#line 4310 "../src/Photo.vala"
	_tmp18_ = _tmp17_.center;
#line 4310 "../src/Photo.vala"
	ymax = _tmp18_.y;
#line 4311 "../src/Photo.vala"
	_tmp20_ = gdk_pixbuf_get_height (pixbuf);
#line 4311 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 4311 "../src/Photo.vala"
	if (ymax > (_tmp21_ - 1)) {
#line 29130 "Photo.c"
		gint _tmp22_;
		gint _tmp23_;
#line 4311 "../src/Photo.vala"
		_tmp22_ = gdk_pixbuf_get_height (pixbuf);
#line 4311 "../src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 4311 "../src/Photo.vala"
		_tmp19_ = _tmp23_ - 1;
#line 29139 "Photo.c"
	} else {
#line 4311 "../src/Photo.vala"
		_tmp19_ = ymax;
#line 29143 "Photo.c"
	}
#line 4311 "../src/Photo.vala"
	ymax = _tmp19_;
#line 4315 "../src/Photo.vala"
	inset_index = 0;
#line 29149 "Photo.c"
	{
		gint y_it = 0;
#line 4316 "../src/Photo.vala"
		y_it = ymin;
#line 29154 "Photo.c"
		{
			gboolean _tmp24_ = FALSE;
#line 4316 "../src/Photo.vala"
			_tmp24_ = TRUE;
#line 4316 "../src/Photo.vala"
			while (TRUE) {
#line 29161 "Photo.c"
				gint xmin = 0;
				gint* _tmp26_;
				gint _tmp26__length1;
				gint _tmp27_;
				gint _tmp28_ = 0;
				gint xmax = 0;
				gint* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				gint _tmp31_ = 0;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp40_;
#line 4316 "../src/Photo.vala"
				if (!_tmp24_) {
#line 29177 "Photo.c"
					gint _tmp25_;
#line 4316 "../src/Photo.vala"
					_tmp25_ = y_it;
#line 4316 "../src/Photo.vala"
					y_it = _tmp25_ + 1;
#line 29183 "Photo.c"
				}
#line 4316 "../src/Photo.vala"
				_tmp24_ = FALSE;
#line 4316 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4316 "../src/Photo.vala"
					break;
#line 29191 "Photo.c"
				}
#line 4317 "../src/Photo.vala"
				_tmp26_ = x_insets_first_quadrant;
#line 4317 "../src/Photo.vala"
				_tmp26__length1 = x_insets_first_quadrant_length1;
#line 4317 "../src/Photo.vala"
				_tmp27_ = _tmp26_[inset_index];
#line 4317 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp27_;
#line 4318 "../src/Photo.vala"
				if (xmin < 0) {
#line 4318 "../src/Photo.vala"
					_tmp28_ = 0;
#line 29205 "Photo.c"
				} else {
#line 4318 "../src/Photo.vala"
					_tmp28_ = xmin;
#line 29209 "Photo.c"
				}
#line 4318 "../src/Photo.vala"
				xmin = _tmp28_;
#line 4319 "../src/Photo.vala"
				_tmp29_ = x_insets_first_quadrant;
#line 4319 "../src/Photo.vala"
				_tmp29__length1 = x_insets_first_quadrant_length1;
#line 4319 "../src/Photo.vala"
				_tmp30_ = _tmp29_[inset_index];
#line 4319 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp30_;
#line 4320 "../src/Photo.vala"
				_tmp32_ = gdk_pixbuf_get_width (pixbuf);
#line 4320 "../src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4320 "../src/Photo.vala"
				if (xmax > (_tmp33_ - 1)) {
#line 29227 "Photo.c"
					gint _tmp34_;
					gint _tmp35_;
#line 4320 "../src/Photo.vala"
					_tmp34_ = gdk_pixbuf_get_width (pixbuf);
#line 4320 "../src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 4320 "../src/Photo.vala"
					_tmp31_ = _tmp35_ - 1;
#line 29236 "Photo.c"
				} else {
#line 4320 "../src/Photo.vala"
					_tmp31_ = xmax;
#line 29240 "Photo.c"
				}
#line 4320 "../src/Photo.vala"
				xmax = _tmp31_;
#line 29244 "Photo.c"
				{
					gint x_it = 0;
#line 4322 "../src/Photo.vala"
					x_it = xmin;
#line 29249 "Photo.c"
					{
						gboolean _tmp36_ = FALSE;
#line 4322 "../src/Photo.vala"
						_tmp36_ = TRUE;
#line 4322 "../src/Photo.vala"
						while (TRUE) {
#line 29256 "Photo.c"
							GdkPixbuf* _tmp38_;
							GdkPixbuf* _tmp39_;
#line 4322 "../src/Photo.vala"
							if (!_tmp36_) {
#line 29261 "Photo.c"
								gint _tmp37_;
#line 4322 "../src/Photo.vala"
								_tmp37_ = x_it;
#line 4322 "../src/Photo.vala"
								x_it = _tmp37_ + 1;
#line 29267 "Photo.c"
							}
#line 4322 "../src/Photo.vala"
							_tmp36_ = FALSE;
#line 4322 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4322 "../src/Photo.vala"
								break;
#line 29275 "Photo.c"
							}
#line 4323 "../src/Photo.vala"
							_tmp38_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4323 "../src/Photo.vala"
							_tmp39_ = _tmp38_;
#line 4323 "../src/Photo.vala"
							_g_object_unref0 (_tmp39_);
#line 29283 "Photo.c"
						}
					}
				}
#line 4325 "../src/Photo.vala"
				_tmp40_ = inset_index;
#line 4325 "../src/Photo.vala"
				inset_index = _tmp40_ + 1;
#line 29291 "Photo.c"
			}
		}
	}
#line 4330 "../src/Photo.vala"
	_tmp41_ = *inst;
#line 4330 "../src/Photo.vala"
	_tmp42_ = _tmp41_.center;
#line 4330 "../src/Photo.vala"
	ymin = _tmp42_.y;
#line 4331 "../src/Photo.vala"
	_tmp43_ = *inst;
#line 4331 "../src/Photo.vala"
	_tmp44_ = _tmp43_.center;
#line 4331 "../src/Photo.vala"
	_tmp45_ = *inst;
#line 4331 "../src/Photo.vala"
	ymax = _tmp44_.y + _tmp45_.radius;
#line 4332 "../src/Photo.vala"
	_tmp46_ = x_insets_first_quadrant;
#line 4332 "../src/Photo.vala"
	_tmp46__length1 = x_insets_first_quadrant_length1;
#line 4332 "../src/Photo.vala"
	inset_index = _tmp46__length1 - 1;
#line 29315 "Photo.c"
	{
		gint y_it = 0;
#line 4333 "../src/Photo.vala"
		y_it = ymin;
#line 29320 "Photo.c"
		{
			gboolean _tmp47_ = FALSE;
#line 4333 "../src/Photo.vala"
			_tmp47_ = TRUE;
#line 4333 "../src/Photo.vala"
			while (TRUE) {
#line 29327 "Photo.c"
				gint xmin = 0;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp50_;
				gint _tmp51_ = 0;
				gint xmax = 0;
				gint* _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_;
				gint _tmp54_ = 0;
				gint _tmp55_;
				gint _tmp56_;
				gint _tmp63_;
#line 4333 "../src/Photo.vala"
				if (!_tmp47_) {
#line 29343 "Photo.c"
					gint _tmp48_;
#line 4333 "../src/Photo.vala"
					_tmp48_ = y_it;
#line 4333 "../src/Photo.vala"
					y_it = _tmp48_ + 1;
#line 29349 "Photo.c"
				}
#line 4333 "../src/Photo.vala"
				_tmp47_ = FALSE;
#line 4333 "../src/Photo.vala"
				if (!(y_it <= ymax)) {
#line 4333 "../src/Photo.vala"
					break;
#line 29357 "Photo.c"
				}
#line 4334 "../src/Photo.vala"
				_tmp49_ = x_insets_first_quadrant;
#line 4334 "../src/Photo.vala"
				_tmp49__length1 = x_insets_first_quadrant_length1;
#line 4334 "../src/Photo.vala"
				_tmp50_ = _tmp49_[inset_index];
#line 4334 "../src/Photo.vala"
				xmin = x_bounds_min + _tmp50_;
#line 4335 "../src/Photo.vala"
				if (xmin < 0) {
#line 4335 "../src/Photo.vala"
					_tmp51_ = 0;
#line 29371 "Photo.c"
				} else {
#line 4335 "../src/Photo.vala"
					_tmp51_ = xmin;
#line 29375 "Photo.c"
				}
#line 4335 "../src/Photo.vala"
				xmin = _tmp51_;
#line 4336 "../src/Photo.vala"
				_tmp52_ = x_insets_first_quadrant;
#line 4336 "../src/Photo.vala"
				_tmp52__length1 = x_insets_first_quadrant_length1;
#line 4336 "../src/Photo.vala"
				_tmp53_ = _tmp52_[inset_index];
#line 4336 "../src/Photo.vala"
				xmax = x_bounds_max - _tmp53_;
#line 4337 "../src/Photo.vala"
				_tmp55_ = gdk_pixbuf_get_width (pixbuf);
#line 4337 "../src/Photo.vala"
				_tmp56_ = _tmp55_;
#line 4337 "../src/Photo.vala"
				if (xmax > (_tmp56_ - 1)) {
#line 29393 "Photo.c"
					gint _tmp57_;
					gint _tmp58_;
#line 4337 "../src/Photo.vala"
					_tmp57_ = gdk_pixbuf_get_width (pixbuf);
#line 4337 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 4337 "../src/Photo.vala"
					_tmp54_ = _tmp58_ - 1;
#line 29402 "Photo.c"
				} else {
#line 4337 "../src/Photo.vala"
					_tmp54_ = xmax;
#line 29406 "Photo.c"
				}
#line 4337 "../src/Photo.vala"
				xmax = _tmp54_;
#line 29410 "Photo.c"
				{
					gint x_it = 0;
#line 4339 "../src/Photo.vala"
					x_it = xmin;
#line 29415 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 4339 "../src/Photo.vala"
						_tmp59_ = TRUE;
#line 4339 "../src/Photo.vala"
						while (TRUE) {
#line 29422 "Photo.c"
							GdkPixbuf* _tmp61_;
							GdkPixbuf* _tmp62_;
#line 4339 "../src/Photo.vala"
							if (!_tmp59_) {
#line 29427 "Photo.c"
								gint _tmp60_;
#line 4339 "../src/Photo.vala"
								_tmp60_ = x_it;
#line 4339 "../src/Photo.vala"
								x_it = _tmp60_ + 1;
#line 29433 "Photo.c"
							}
#line 4339 "../src/Photo.vala"
							_tmp59_ = FALSE;
#line 4339 "../src/Photo.vala"
							if (!(x_it <= xmax)) {
#line 4339 "../src/Photo.vala"
								break;
#line 29441 "Photo.c"
							}
#line 4340 "../src/Photo.vala"
							_tmp61_ = photo_red_reduce_pixel (self, pixbuf, x_it, y_it);
#line 4340 "../src/Photo.vala"
							_tmp62_ = _tmp61_;
#line 4340 "../src/Photo.vala"
							_g_object_unref0 (_tmp62_);
#line 29449 "Photo.c"
						}
					}
				}
#line 4342 "../src/Photo.vala"
				_tmp63_ = inset_index;
#line 4342 "../src/Photo.vala"
				inset_index = _tmp63_ - 1;
#line 29457 "Photo.c"
			}
		}
	}
#line 4345 "../src/Photo.vala"
	_tmp64_ = _g_object_ref0 (pixbuf);
#line 4345 "../src/Photo.vala"
	result = _tmp64_;
#line 4345 "../src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4345 "../src/Photo.vala"
	return result;
#line 29469 "Photo.c"
}

static GdkPixbuf*
photo_red_reduce_pixel (Photo* self,
                        GdkPixbuf* pixbuf,
                        gint x,
                        gint y)
{
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp13_;
#line 4348 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4348 "../src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4349 "../src/Photo.vala"
	px_start_byte_offset = (y * gdk_pixbuf_get_rowstride (pixbuf)) + (x * gdk_pixbuf_get_n_channels (pixbuf));
#line 4356 "../src/Photo.vala"
	if (x >= 0) {
#line 4356 "../src/Photo.vala"
		_tmp2_ = y >= 0;
#line 29494 "Photo.c"
	} else {
#line 4356 "../src/Photo.vala"
		_tmp2_ = FALSE;
#line 29498 "Photo.c"
	}
#line 4356 "../src/Photo.vala"
	if (_tmp2_) {
#line 29502 "Photo.c"
		gint _tmp3_;
		gint _tmp4_;
#line 4356 "../src/Photo.vala"
		_tmp3_ = gdk_pixbuf_get_width (pixbuf);
#line 4356 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4356 "../src/Photo.vala"
		_tmp1_ = x < _tmp4_;
#line 29511 "Photo.c"
	} else {
#line 4356 "../src/Photo.vala"
		_tmp1_ = FALSE;
#line 29515 "Photo.c"
	}
#line 4356 "../src/Photo.vala"
	if (_tmp1_) {
#line 29519 "Photo.c"
		gint _tmp5_;
		gint _tmp6_;
#line 4356 "../src/Photo.vala"
		_tmp5_ = gdk_pixbuf_get_height (pixbuf);
#line 4356 "../src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4356 "../src/Photo.vala"
		_tmp0_ = y < _tmp6_;
#line 29528 "Photo.c"
	} else {
#line 4356 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 29532 "Photo.c"
	}
#line 4356 "../src/Photo.vala"
	if (_tmp0_) {
#line 29536 "Photo.c"
		guchar* pixel_data = NULL;
		guint8* _tmp7_;
		gint pixel_data_length1;
		gint _pixel_data_size_;
		guchar g = '\0';
		guchar* _tmp8_;
		gint _tmp8__length1;
		guchar _tmp9_;
		guchar b = '\0';
		guchar* _tmp10_;
		gint _tmp10__length1;
		guchar _tmp11_;
		guchar r = '\0';
		guchar* _tmp12_;
		gint _tmp12__length1;
#line 4357 "../src/Photo.vala"
		_tmp7_ = gdk_pixbuf_get_pixels (pixbuf);
#line 4357 "../src/Photo.vala"
		pixel_data = _tmp7_;
#line 4357 "../src/Photo.vala"
		pixel_data_length1 = -1;
#line 4357 "../src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4367 "../src/Photo.vala"
		_tmp8_ = pixel_data;
#line 4367 "../src/Photo.vala"
		_tmp8__length1 = pixel_data_length1;
#line 4367 "../src/Photo.vala"
		_tmp9_ = _tmp8_[px_start_byte_offset + 1];
#line 4367 "../src/Photo.vala"
		g = _tmp9_;
#line 4368 "../src/Photo.vala"
		_tmp10_ = pixel_data;
#line 4368 "../src/Photo.vala"
		_tmp10__length1 = pixel_data_length1;
#line 4368 "../src/Photo.vala"
		_tmp11_ = _tmp10_[px_start_byte_offset + 2];
#line 4368 "../src/Photo.vala"
		b = _tmp11_;
#line 4370 "../src/Photo.vala"
		r = (guchar) ((g + b) / 2);
#line 4372 "../src/Photo.vala"
		_tmp12_ = pixel_data;
#line 4372 "../src/Photo.vala"
		_tmp12__length1 = pixel_data_length1;
#line 4372 "../src/Photo.vala"
		_tmp12_[px_start_byte_offset] = r;
#line 29584 "Photo.c"
	}
#line 4375 "../src/Photo.vala"
	_tmp13_ = _g_object_ref0 (pixbuf);
#line 4375 "../src/Photo.vala"
	result = _tmp13_;
#line 4375 "../src/Photo.vala"
	return result;
#line 29592 "Photo.c"
}

void
photo_unscaled_to_raw_point (Photo* self,
                             GdkPoint* unscaled_point,
                             GdkPoint* result)
{
	Orientation unscaled_orientation = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp3_ = {0};
	gboolean _tmp4_;
	GdkPoint derotated_point = {0};
	Orientation _tmp7_;
	Dimensions _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_ = {0};
#line 4378 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4378 "../src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4379 "../src/Photo.vala"
	unscaled_orientation = photo_get_orientation (self);
#line 4381 "../src/Photo.vala"
	_tmp0_ = unscaled_orientation;
#line 4381 "../src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp1_);
#line 4381 "../src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4381 "../src/Photo.vala"
	unscaled_dims = _tmp2_;
#line 4384 "../src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4385 "../src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4388 "../src/Photo.vala"
	_tmp4_ = photo_get_raw_crop (self, &_tmp3_);
#line 4388 "../src/Photo.vala"
	crop_box = _tmp3_;
#line 4388 "../src/Photo.vala"
	if (_tmp4_) {
#line 29639 "Photo.c"
		Box _tmp5_;
		Box _tmp6_;
#line 4389 "../src/Photo.vala"
		_tmp5_ = crop_box;
#line 4389 "../src/Photo.vala"
		unscaled_x_offset_raw = _tmp5_.left;
#line 4390 "../src/Photo.vala"
		_tmp6_ = crop_box;
#line 4390 "../src/Photo.vala"
		unscaled_y_offset_raw = _tmp6_.top;
#line 29650 "Photo.c"
	}
#line 4393 "../src/Photo.vala"
	_tmp7_ = unscaled_orientation;
#line 4393 "../src/Photo.vala"
	_tmp8_ = unscaled_dims;
#line 4393 "../src/Photo.vala"
	_tmp9_ = *unscaled_point;
#line 4393 "../src/Photo.vala"
	orientation_derotate_point (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 4393 "../src/Photo.vala"
	derotated_point = _tmp10_;
#line 4397 "../src/Photo.vala"
	derotated_point.x = derotated_point.x + unscaled_x_offset_raw;
#line 4398 "../src/Photo.vala"
	derotated_point.y = derotated_point.y + unscaled_y_offset_raw;
#line 4400 "../src/Photo.vala"
	*result = derotated_point;
#line 4400 "../src/Photo.vala"
	return;
#line 29670 "Photo.c"
}

void
photo_unscaled_to_raw_rect (Photo* self,
                            GdkRectangle* unscaled_rect,
                            GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp20_;
	GdkPoint _tmp21_;
	GdkPoint _tmp22_;
	GdkPoint _tmp23_;
	GdkPoint _tmp24_;
	GdkPoint _tmp25_;
#line 4403 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4403 "../src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4404 "../src/Photo.vala"
	_tmp0_.x = 0;
#line 4404 "../src/Photo.vala"
	upper_left = _tmp0_;
#line 4405 "../src/Photo.vala"
	_tmp1_.x = 0;
#line 4405 "../src/Photo.vala"
	lower_right = _tmp1_;
#line 4406 "../src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4406 "../src/Photo.vala"
	upper_left.x = _tmp2_.x;
#line 4407 "../src/Photo.vala"
	_tmp3_ = *unscaled_rect;
#line 4407 "../src/Photo.vala"
	upper_left.y = _tmp3_.y;
#line 4408 "../src/Photo.vala"
	_tmp4_ = upper_left;
#line 4408 "../src/Photo.vala"
	_tmp5_ = *unscaled_rect;
#line 4408 "../src/Photo.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 4409 "../src/Photo.vala"
	_tmp6_ = upper_left;
#line 4409 "../src/Photo.vala"
	_tmp7_ = *unscaled_rect;
#line 4409 "../src/Photo.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 4411 "../src/Photo.vala"
	_tmp8_ = upper_left;
#line 4411 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp8_, &_tmp9_);
#line 4411 "../src/Photo.vala"
	upper_left = _tmp9_;
#line 4412 "../src/Photo.vala"
	_tmp10_ = lower_right;
#line 4412 "../src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp10_, &_tmp11_);
#line 4412 "../src/Photo.vala"
	lower_right = _tmp11_;
#line 4414 "../src/Photo.vala"
	_tmp12_ = upper_left;
#line 4414 "../src/Photo.vala"
	_tmp13_ = lower_right;
#line 4414 "../src/Photo.vala"
	if (_tmp12_.x > _tmp13_.x) {
#line 29753 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 4415 "../src/Photo.vala"
		_tmp14_ = upper_left;
#line 4415 "../src/Photo.vala"
		temp = _tmp14_.x;
#line 4416 "../src/Photo.vala"
		_tmp15_ = lower_right;
#line 4416 "../src/Photo.vala"
		upper_left.x = _tmp15_.x;
#line 4417 "../src/Photo.vala"
		lower_right.x = temp;
#line 29767 "Photo.c"
	}
#line 4419 "../src/Photo.vala"
	_tmp16_ = upper_left;
#line 4419 "../src/Photo.vala"
	_tmp17_ = lower_right;
#line 4419 "../src/Photo.vala"
	if (_tmp16_.y > _tmp17_.y) {
#line 29775 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp18_;
		GdkPoint _tmp19_;
#line 4420 "../src/Photo.vala"
		_tmp18_ = upper_left;
#line 4420 "../src/Photo.vala"
		temp = _tmp18_.y;
#line 4421 "../src/Photo.vala"
		_tmp19_ = lower_right;
#line 4421 "../src/Photo.vala"
		upper_left.y = _tmp19_.y;
#line 4422 "../src/Photo.vala"
		lower_right.y = temp;
#line 29789 "Photo.c"
	}
#line 4425 "../src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4426 "../src/Photo.vala"
	_tmp20_ = upper_left;
#line 4426 "../src/Photo.vala"
	raw_rect.x = _tmp20_.x;
#line 4427 "../src/Photo.vala"
	_tmp21_ = upper_left;
#line 4427 "../src/Photo.vala"
	raw_rect.y = _tmp21_.y;
#line 4428 "../src/Photo.vala"
	_tmp22_ = lower_right;
#line 4428 "../src/Photo.vala"
	_tmp23_ = upper_left;
#line 4428 "../src/Photo.vala"
	raw_rect.width = _tmp22_.x - _tmp23_.x;
#line 4429 "../src/Photo.vala"
	_tmp24_ = lower_right;
#line 4429 "../src/Photo.vala"
	_tmp25_ = upper_left;
#line 4429 "../src/Photo.vala"
	raw_rect.height = _tmp24_.y - _tmp25_.y;
#line 4431 "../src/Photo.vala"
	*result = raw_rect;
#line 4431 "../src/Photo.vala"
	return;
#line 29817 "Photo.c"
}

PixelTransformationBundle*
photo_get_enhance_transformations (Photo* self)
{
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 4434 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4435 "../src/Photo.vala"
	pixbuf = NULL;
#line 29833 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 4442 "../src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4442 "../src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 4442 "../src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4442 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29847 "Photo.c"
			goto __catch238_g_error;
		}
#line 4442 "../src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4442 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 4442 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4442 "../src/Photo.vala"
		pixbuf = _tmp3_;
#line 4441 "../src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 29860 "Photo.c"
	}
	goto __finally238;
	__catch238_g_error:
	{
		GError* e = NULL;
#line 4441 "../src/Photo.vala"
		e = _inner_error0_;
#line 4441 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 4449 "../src/Photo.vala"
		g_warning ("Photo.vala:4449: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4451 "../src/Photo.vala"
		result = NULL;
#line 4451 "../src/Photo.vala"
		_g_error_free0 (e);
#line 4451 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4451 "../src/Photo.vala"
		return result;
#line 29880 "Photo.c"
	}
	__finally238:
#line 4441 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4441 "../src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4441 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4441 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 4441 "../src/Photo.vala"
		return NULL;
#line 29893 "Photo.c"
	}
#line 4458 "../src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4458 "../src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4458 "../src/Photo.vala"
	transformations = _tmp5_;
#line 4466 "../src/Photo.vala"
	result = transformations;
#line 4466 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4466 "../src/Photo.vala"
	return result;
#line 29907 "Photo.c"
}

gboolean
photo_enhance (Photo* self)
{
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 4469 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4470 "../src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4470 "../src/Photo.vala"
	transformations = _tmp0_;
#line 4472 "../src/Photo.vala"
	_tmp1_ = transformations;
#line 4472 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4473 "../src/Photo.vala"
		result = FALSE;
#line 4473 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4473 "../src/Photo.vala"
		return result;
#line 29934 "Photo.c"
	}
	{
		PhotoRow* _tmp2_;
#line 4479 "../src/Photo.vala"
		_tmp2_ = self->row;
#line 4479 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 29942 "Photo.c"
		{
			KeyValueMap* _tmp3_;
			KeyValueMap* _tmp4_;
			PixelTransformationBundle* _tmp5_;
#line 4480 "../src/Photo.vala"
			photo_clear_original_transforms (self);
#line 4481 "../src/Photo.vala"
			_tmp3_ = photo_get_color_adjustments_map (self);
#line 4481 "../src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 4481 "../src/Photo.vala"
			photo_set_original_transforms (self, _tmp4_);
#line 4481 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp4_);
#line 4482 "../src/Photo.vala"
			_tmp5_ = transformations;
#line 4482 "../src/Photo.vala"
			photo_set_color_adjustments (self, _tmp5_);
#line 29961 "Photo.c"
		}
		__finally239:
		{
			PhotoRow* _tmp6_;
#line 4479 "../src/Photo.vala"
			_tmp6_ = self->row;
#line 4479 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 29970 "Photo.c"
		}
#line 4479 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29974 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 4479 "../src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4479 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4479 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4479 "../src/Photo.vala"
			return _tmp7_;
#line 29984 "Photo.c"
		}
	}
#line 4489 "../src/Photo.vala"
	photo_set_enhanced (self, TRUE);
#line 4490 "../src/Photo.vala"
	result = TRUE;
#line 4490 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4490 "../src/Photo.vala"
	return result;
#line 29995 "Photo.c"
}

gboolean
photo_unenhance (Photo* self)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 4493 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30005 "Photo.c"
	{
		PhotoRow* _tmp0_;
#line 4494 "../src/Photo.vala"
		_tmp0_ = self->row;
#line 4494 "../src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 30012 "Photo.c"
		{
			PhotoRow* _tmp1_;
#line 4495 "../src/Photo.vala"
			_tmp1_ = self->row;
#line 4495 "../src/Photo.vala"
			if (_tmp1_->enhanced) {
#line 30019 "Photo.c"
				gboolean _tmp2_ = FALSE;
				PhotoRow* _tmp3_;
				GeeHashMap* _tmp4_;
#line 4496 "../src/Photo.vala"
				_tmp3_ = self->row;
#line 4496 "../src/Photo.vala"
				_tmp4_ = _tmp3_->original_transforms;
#line 4496 "../src/Photo.vala"
				if (_tmp4_ == NULL) {
#line 4496 "../src/Photo.vala"
					_tmp2_ = TRUE;
#line 30031 "Photo.c"
				} else {
					PhotoRow* _tmp5_;
					GeeHashMap* _tmp6_;
					gpointer _tmp7_;
					KeyValueMap* _tmp8_;
#line 4496 "../src/Photo.vala"
					_tmp5_ = self->row;
#line 4496 "../src/Photo.vala"
					_tmp6_ = _tmp5_->original_transforms;
#line 4496 "../src/Photo.vala"
					_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, "adjustments");
#line 4496 "../src/Photo.vala"
					_tmp8_ = (KeyValueMap*) _tmp7_;
#line 4496 "../src/Photo.vala"
					_tmp2_ = _tmp8_ == NULL;
#line 4496 "../src/Photo.vala"
					_key_value_map_unref0 (_tmp8_);
#line 30049 "Photo.c"
				}
#line 4496 "../src/Photo.vala"
				if (_tmp2_) {
#line 30053 "Photo.c"
					gboolean _result_ = FALSE;
#line 4497 "../src/Photo.vala"
					photo_remove_transformation (self, "adjustments");
#line 4498 "../src/Photo.vala"
					_result_ = FALSE;
#line 4499 "../src/Photo.vala"
					_result_ = photo_remove_transformation (self, "adjustments");
#line 4500 "../src/Photo.vala"
					_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 4500 "../src/Photo.vala"
					self->priv->adjustments = NULL;
#line 4501 "../src/Photo.vala"
					_pixel_transformer_unref0 (self->priv->transformer);
#line 4501 "../src/Photo.vala"
					self->priv->transformer = NULL;
#line 4502 "../src/Photo.vala"
					if (_result_) {
#line 30071 "Photo.c"
						Alteration* _tmp9_;
						Alteration* _tmp10_;
#line 4503 "../src/Photo.vala"
						_tmp9_ = alteration_new ("image", "color-adjustments");
#line 4503 "../src/Photo.vala"
						_tmp10_ = _tmp9_;
#line 4503 "../src/Photo.vala"
						data_object_notify_altered ((DataObject*) self, _tmp10_);
#line 4503 "../src/Photo.vala"
						_alteration_unref0 (_tmp10_);
#line 30082 "Photo.c"
					}
				} else {
					PixelTransformationBundle* _tmp11_;
					PixelTransformationBundle* _tmp12_;
#line 4506 "../src/Photo.vala"
					_tmp11_ = photo_locked_original_color_adjustments (self);
#line 4506 "../src/Photo.vala"
					_tmp12_ = _tmp11_;
#line 4506 "../src/Photo.vala"
					photo_set_color_adjustments (self, _tmp12_);
#line 4506 "../src/Photo.vala"
					_pixel_transformation_bundle_unref0 (_tmp12_);
#line 30095 "Photo.c"
				}
#line 4509 "../src/Photo.vala"
				photo_set_enhanced (self, FALSE);
#line 4510 "../src/Photo.vala"
				result = TRUE;
#line 30101 "Photo.c"
				{
					PhotoRow* _tmp13_;
#line 4494 "../src/Photo.vala"
					_tmp13_ = self->row;
#line 4494 "../src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 30108 "Photo.c"
				}
#line 4510 "../src/Photo.vala"
				return result;
#line 30112 "Photo.c"
			}
		}
		__finally240:
		{
			PhotoRow* _tmp14_;
#line 4494 "../src/Photo.vala"
			_tmp14_ = self->row;
#line 4494 "../src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 30122 "Photo.c"
		}
#line 4494 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 30126 "Photo.c"
			gboolean _tmp15_ = FALSE;
#line 4494 "../src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 4494 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 4494 "../src/Photo.vala"
			return _tmp15_;
#line 30134 "Photo.c"
		}
	}
#line 4513 "../src/Photo.vala"
	result = FALSE;
#line 4513 "../src/Photo.vala"
	return result;
#line 30141 "Photo.c"
}

gboolean
photo_get_develop_raw_photos_to_files (void)
{
	gboolean result;
#line 281 "../src/Photo.vala"
	result = photo__develop_raw_photos_to_files;
#line 281 "../src/Photo.vala"
	return result;
#line 30152 "Photo.c"
}

void
photo_set_develop_raw_photos_to_files (gboolean value)
{
#line 282 "../src/Photo.vala"
	photo__develop_raw_photos_to_files = value;
#line 30160 "Photo.c"
}

static void
photo_real_editable_replaced (Photo* self,
                              GFile* old_file,
                              GFile* new_file)
{
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 97 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "../src/Photo.vala"
		data1 = closure->data;
#line 97 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 30192 "Photo.c"
	} else {
#line 97 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "../src/Photo.vala"
		data2 = closure->data;
#line 30198 "Photo.c"
	}
#line 97 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 97 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 30204 "Photo.c"
}

static void
photo_real_raw_development_modified (Photo* self)
{
}

static void
photo_real_baseline_replaced (Photo* self)
{
}

static void
photo_real_master_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}

static void
g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 97 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "../src/Photo.vala"
		data1 = closure->data;
#line 97 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 30245 "Photo.c"
	} else {
#line 97 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "../src/Photo.vala"
		data2 = closure->data;
#line 30251 "Photo.c"
	}
#line 97 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 97 "../src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 30257 "Photo.c"
}

static void
photo_real_editable_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}

static void
photo_real_baseline_reimported (Photo* self,
                                PhotoMetadata* metadata)
{
}

static void
photo_real_source_reimported (Photo* self,
                              PhotoMetadata* metadata)
{
}

static inline gpointer
photo_photo_transformation_state_impl_get_instance_private (PhotoPhotoTransformationStateImpl* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPhotoTransformationStateImpl_private_offset);
}

static void
_photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender,
                                                                                           gpointer self)
{
#line 192 "../src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 30290 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_construct (GType object_type,
                                                 Photo* photo,
                                                 Orientation orientation,
                                                 GeeHashMap* transformations,
                                                 PixelTransformer* transformer,
                                                 PixelTransformationBundle* adjustments,
                                                 GeeHashMap* original_transformations,
                                                 gboolean enhanced)
{
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	PixelTransformer* _tmp3_;
	PixelTransformationBundle* _tmp4_;
#line 178 "../src/Photo.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 178 "../src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 181 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 181 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 181 "../src/Photo.vala"
	self->priv->photo = _tmp0_;
#line 182 "../src/Photo.vala"
	self->priv->orientation = orientation;
#line 183 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (transformations);
#line 183 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 183 "../src/Photo.vala"
	self->priv->transformations = _tmp1_;
#line 184 "../src/Photo.vala"
	_tmp2_ = photo_photo_transformation_state_impl_copy_transformations (original_transformations);
#line 184 "../src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 184 "../src/Photo.vala"
	self->priv->original_transformations = _tmp2_;
#line 185 "../src/Photo.vala"
	_tmp3_ = _pixel_transformer_ref0 (transformer);
#line 185 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 185 "../src/Photo.vala"
	self->priv->transformer = _tmp3_;
#line 186 "../src/Photo.vala"
	_tmp4_ = _pixel_transformation_bundle_ref0 (adjustments);
#line 186 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 186 "../src/Photo.vala"
	self->priv->adjustments = _tmp4_;
#line 187 "../src/Photo.vala"
	self->priv->enhanced = enhanced;
#line 188 "../src/Photo.vala"
	g_signal_connect_object (photo, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 178 "../src/Photo.vala"
	return self;
#line 30351 "Photo.c"
}

static PhotoPhotoTransformationStateImpl*
photo_photo_transformation_state_impl_new (Photo* photo,
                                           Orientation orientation,
                                           GeeHashMap* transformations,
                                           PixelTransformer* transformer,
                                           PixelTransformationBundle* adjustments,
                                           GeeHashMap* original_transformations,
                                           gboolean enhanced)
{
#line 178 "../src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments, original_transformations, enhanced);
#line 30365 "Photo.c"
}

static gboolean
photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self)
{
	gboolean result = FALSE;
#line 195 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/Photo.vala"
	result = self->priv->enhanced;
#line 196 "../src/Photo.vala"
	return result;
#line 30378 "Photo.c"
}

static Orientation
photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self)
{
	Orientation result = 0;
	Orientation _tmp0_;
#line 199 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "../src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 200 "../src/Photo.vala"
	result = _tmp0_;
#line 200 "../src/Photo.vala"
	return result;
#line 30394 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 203 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 204 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 204 "../src/Photo.vala"
	result = _tmp1_;
#line 204 "../src/Photo.vala"
	return result;
#line 30413 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 207 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/Photo.vala"
	_tmp0_ = self->priv->original_transformations;
#line 208 "../src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 208 "../src/Photo.vala"
	result = _tmp1_;
#line 208 "../src/Photo.vala"
	return result;
#line 30432 "Photo.c"
}

static PixelTransformer*
photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 211 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "../src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 212 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 30447 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_;
#line 212 "../src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 212 "../src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 212 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 30458 "Photo.c"
	} else {
#line 212 "../src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 30464 "Photo.c"
	}
#line 212 "../src/Photo.vala"
	result = _tmp0_;
#line 212 "../src/Photo.vala"
	return result;
#line 30470 "Photo.c"
}

static PixelTransformationBundle*
photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self)
{
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 215 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 216 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 30485 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_;
#line 216 "../src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 216 "../src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 216 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "../src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 30496 "Photo.c"
	} else {
#line 216 "../src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "../src/Photo.vala"
		_tmp0_ = NULL;
#line 30502 "Photo.c"
	}
#line 216 "../src/Photo.vala"
	result = _tmp0_;
#line 216 "../src/Photo.vala"
	return result;
#line 30508 "Photo.c"
}

static GeeHashMap*
photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original)
{
	GeeHashMap* result = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp0_;
#line 221 "../src/Photo.vala"
	if (original == NULL) {
#line 222 "../src/Photo.vala"
		result = NULL;
#line 222 "../src/Photo.vala"
		return result;
#line 30523 "Photo.c"
	}
#line 224 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "../src/Photo.vala"
	clone = _tmp0_;
#line 30529 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 225 "../src/Photo.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) original);
#line 225 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 225 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 225 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 225 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 225 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 225 "../src/Photo.vala"
		_object_it = _tmp5_;
#line 225 "../src/Photo.vala"
		while (TRUE) {
#line 30553 "Photo.c"
			GeeIterator* _tmp6_;
			gchar* object = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			KeyValueMap* _tmp13_;
			KeyValueMap* _tmp14_;
			KeyValueMap* _tmp15_;
#line 225 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 225 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 225 "../src/Photo.vala"
				break;
#line 30571 "Photo.c"
			}
#line 225 "../src/Photo.vala"
			_tmp7_ = _object_it;
#line 225 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 225 "../src/Photo.vala"
			object = (gchar*) _tmp8_;
#line 226 "../src/Photo.vala"
			_tmp9_ = clone;
#line 226 "../src/Photo.vala"
			_tmp10_ = object;
#line 226 "../src/Photo.vala"
			_tmp11_ = object;
#line 226 "../src/Photo.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) original, _tmp11_);
#line 226 "../src/Photo.vala"
			_tmp13_ = (KeyValueMap*) _tmp12_;
#line 226 "../src/Photo.vala"
			_tmp14_ = key_value_map_copy (_tmp13_);
#line 226 "../src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 226 "../src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp15_);
#line 226 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp15_);
#line 226 "../src/Photo.vala"
			_key_value_map_unref0 (_tmp13_);
#line 225 "../src/Photo.vala"
			_g_free0 (object);
#line 30601 "Photo.c"
		}
#line 225 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 30605 "Photo.c"
	}
#line 228 "../src/Photo.vala"
	result = clone;
#line 228 "../src/Photo.vala"
	return result;
#line 30611 "Photo.c"
}

static void
photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self)
{
#line 231 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/Photo.vala"
	if (!photo_transformation_state_is_broken ((PhotoTransformationState*) self)) {
#line 233 "../src/Photo.vala"
		g_signal_emit ((PhotoTransformationState*) self, photo_transformation_state_signals[PHOTO_TRANSFORMATION_STATE_BROKEN_SIGNAL], 0);
#line 30623 "Photo.c"
	}
}

static void
photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass,
                                                  gpointer klass_data)
{
#line 169 "../src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 169 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPhotoTransformationStateImpl_private_offset);
#line 169 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 30637 "Photo.c"
}

static void
photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self,
                                                     gpointer klass)
{
#line 169 "../src/Photo.vala"
	self->priv = photo_photo_transformation_state_impl_get_instance_private (self);
#line 30646 "Photo.c"
}

static void
photo_photo_transformation_state_impl_finalize (GObject * obj)
{
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_;
#line 169 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 192 "../src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 192 "../src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 192 "../src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 170 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 172 "../src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 173 "../src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 174 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 175 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 169 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 30675 "Photo.c"
}

static GType
photo_photo_transformation_state_impl_get_type (void)
{
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		PhotoPhotoTransformationStateImpl_private_offset = g_type_add_instance_private (photo_photo_transformation_state_impl_type_id, sizeof (PhotoPhotoTransformationStateImplPrivate));
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}

static PhotoBackingReaders*
photo_backing_readers_construct (GType object_type)
{
	PhotoBackingReaders* self = NULL;
#line 237 "../src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 237 "../src/Photo.vala"
	return self;
#line 30700 "Photo.c"
}

static PhotoBackingReaders*
photo_backing_readers_new (void)
{
#line 237 "../src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 30708 "Photo.c"
}

static void
photo_value_backing_readers_init (GValue* value)
{
#line 237 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 30716 "Photo.c"
}

static void
photo_value_backing_readers_free_value (GValue* value)
{
#line 237 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 30726 "Photo.c"
	}
}

static void
photo_value_backing_readers_copy_value (const GValue* src_value,
                                        GValue* dest_value)
{
#line 237 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 30738 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 30742 "Photo.c"
	}
}

static gpointer
photo_value_backing_readers_peek_pointer (const GValue* value)
{
#line 237 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 30751 "Photo.c"
}

static gchar*
photo_value_backing_readers_collect_value (GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
#line 237 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 30762 "Photo.c"
		PhotoBackingReaders * object;
		object = collect_values[0].v_pointer;
#line 237 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 237 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30769 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 237 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 30773 "Photo.c"
		}
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 30777 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30781 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	return NULL;
#line 30785 "Photo.c"
}

static gchar*
photo_value_backing_readers_lcopy_value (const GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	PhotoBackingReaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (!object_p) {
#line 237 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 30800 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 237 "../src/Photo.vala"
		*object_p = NULL;
#line 30806 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 237 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 30810 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 30814 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	return NULL;
#line 30818 "Photo.c"
}

static GParamSpec*
photo_param_spec_backing_readers (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags)
{
	PhotoParamSpecBackingReaders* spec;
#line 237 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 237 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 237 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 30837 "Photo.c"
}

static gpointer
photo_value_get_backing_readers (const GValue* value)
{
#line 237 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 30847 "Photo.c"
}

static void
photo_value_set_backing_readers (GValue* value,
                                 gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (v_object) {
#line 237 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 237 "../src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 30869 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30873 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (old) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 30879 "Photo.c"
	}
}

static void
photo_value_take_backing_readers (GValue* value,
                                  gpointer v_object)
{
	PhotoBackingReaders * old;
#line 237 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "../src/Photo.vala"
	if (v_object) {
#line 237 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 30900 "Photo.c"
	} else {
#line 237 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 30904 "Photo.c"
	}
#line 237 "../src/Photo.vala"
	if (old) {
#line 237 "../src/Photo.vala"
		photo_backing_readers_unref (old);
#line 30910 "Photo.c"
	}
}

static void
photo_backing_readers_class_init (PhotoBackingReadersClass * klass,
                                  gpointer klass_data)
{
#line 237 "../src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 237 "../src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 30922 "Photo.c"
}

static void
photo_backing_readers_instance_init (PhotoBackingReaders * self,
                                     gpointer klass)
{
#line 237 "../src/Photo.vala"
	self->ref_count = 1;
#line 30931 "Photo.c"
}

static void
photo_backing_readers_finalize (PhotoBackingReaders * obj)
{
	PhotoBackingReaders * self;
#line 237 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 237 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 238 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 239 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 240 "../src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 30948 "Photo.c"
}

static GType
photo_backing_readers_get_type (void)
{
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}

static gpointer
photo_backing_readers_ref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 237 "../src/Photo.vala"
	return instance;
#line 30975 "Photo.c"
}

static void
photo_backing_readers_unref (gpointer instance)
{
	PhotoBackingReaders * self;
	self = instance;
#line 237 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 237 "../src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 237 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 30989 "Photo.c"
	}
}

PhotoReimportMasterState*
photo_reimport_master_state_construct (GType object_type)
{
	PhotoReimportMasterState* self = NULL;
#line 1277 "../src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1277 "../src/Photo.vala"
	return self;
#line 31001 "Photo.c"
}

static void
photo_value_reimport_master_state_init (GValue* value)
{
#line 1277 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31009 "Photo.c"
}

static void
photo_value_reimport_master_state_free_value (GValue* value)
{
#line 1277 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1277 "../src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 31019 "Photo.c"
	}
}

static void
photo_value_reimport_master_state_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
#line 1277 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1277 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 31031 "Photo.c"
	} else {
#line 1277 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31035 "Photo.c"
	}
}

static gpointer
photo_value_reimport_master_state_peek_pointer (const GValue* value)
{
#line 1277 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31044 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
#line 1277 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31055 "Photo.c"
		PhotoReimportMasterState * object;
		object = collect_values[0].v_pointer;
#line 1277 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1277 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31062 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1277 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31066 "Photo.c"
		}
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 31070 "Photo.c"
	} else {
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31074 "Photo.c"
	}
#line 1277 "../src/Photo.vala"
	return NULL;
#line 31078 "Photo.c"
}

static gchar*
photo_value_reimport_master_state_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	PhotoReimportMasterState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1277 "../src/Photo.vala"
	if (!object_p) {
#line 1277 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31093 "Photo.c"
	}
#line 1277 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1277 "../src/Photo.vala"
		*object_p = NULL;
#line 31099 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1277 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31103 "Photo.c"
	} else {
#line 1277 "../src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 31107 "Photo.c"
	}
#line 1277 "../src/Photo.vala"
	return NULL;
#line 31111 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_master_state (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	PhotoParamSpecReimportMasterState* spec;
#line 1277 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1277 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1277 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1277 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31130 "Photo.c"
}

gpointer
photo_value_get_reimport_master_state (const GValue* value)
{
#line 1277 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1277 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31140 "Photo.c"
}

void
photo_value_set_reimport_master_state (GValue* value,
                                       gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1277 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1277 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1277 "../src/Photo.vala"
	if (v_object) {
#line 1277 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1277 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1277 "../src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 31162 "Photo.c"
	} else {
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31166 "Photo.c"
	}
#line 1277 "../src/Photo.vala"
	if (old) {
#line 1277 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 31172 "Photo.c"
	}
}

void
photo_value_take_reimport_master_state (GValue* value,
                                        gpointer v_object)
{
	PhotoReimportMasterState * old;
#line 1277 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1277 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1277 "../src/Photo.vala"
	if (v_object) {
#line 1277 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1277 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31193 "Photo.c"
	} else {
#line 1277 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31197 "Photo.c"
	}
#line 1277 "../src/Photo.vala"
	if (old) {
#line 1277 "../src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 31203 "Photo.c"
	}
}

static void
photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass,
                                        gpointer klass_data)
{
#line 1277 "../src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1277 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 31215 "Photo.c"
}

static void
photo_reimport_master_state_instance_init (PhotoReimportMasterState * self,
                                           gpointer klass)
{
#line 1277 "../src/Photo.vala"
	self->ref_count = 1;
#line 31224 "Photo.c"
}

static void
photo_reimport_master_state_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterState * self;
#line 1277 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1277 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 31235 "Photo.c"
}

GType
photo_reimport_master_state_get_type (void)
{
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}

gpointer
photo_reimport_master_state_ref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1277 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1277 "../src/Photo.vala"
	return instance;
#line 31262 "Photo.c"
}

void
photo_reimport_master_state_unref (gpointer instance)
{
	PhotoReimportMasterState * self;
	self = instance;
#line 1277 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1277 "../src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1277 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31276 "Photo.c"
	}
}

static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 1289 "../src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1289 "../src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 31290 "Photo.c"
		gchar* _tmp0_;
#line 1289 "../src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1289 "../src/Photo.vala"
		result[i] = _tmp0_;
#line 31296 "Photo.c"
	}
#line 1289 "../src/Photo.vala"
	return result;
#line 31300 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_construct (GType object_type,
                                            PhotoRow* row,
                                            PhotoMetadata* metadata,
                                            gchar** alterations,
                                            gint alterations_length1)
{
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 1286 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 1286 "../src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1287 "../src/Photo.vala"
	_tmp0_ = _photo_row_ref0 (row);
#line 1287 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1287 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1288 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1288 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1288 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1289 "../src/Photo.vala"
	_tmp2_ = (alterations != NULL) ? _vala_array_dup4 (alterations, alterations_length1) : ((gpointer) alterations);
#line 1289 "../src/Photo.vala"
	_tmp2__length1 = alterations_length1;
#line 1289 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1289 "../src/Photo.vala"
	self->alterations = _tmp2_;
#line 1289 "../src/Photo.vala"
	self->alterations_length1 = _tmp2__length1;
#line 1289 "../src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1286 "../src/Photo.vala"
	return self;
#line 31345 "Photo.c"
}

static PhotoReimportMasterStateImpl*
photo_reimport_master_state_impl_new (PhotoRow* row,
                                      PhotoMetadata* metadata,
                                      gchar** alterations,
                                      gint alterations_length1)
{
#line 1286 "../src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 31356 "Photo.c"
}

static void
photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass,
                                             gpointer klass_data)
{
#line 1280 "../src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1280 "../src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 31367 "Photo.c"
}

static void
photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self,
                                                gpointer klass)
{
	PhotoRow* _tmp0_;
#line 1281 "../src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1281 "../src/Photo.vala"
	self->row = _tmp0_;
#line 1284 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 31381 "Photo.c"
}

static void
photo_reimport_master_state_impl_finalize (PhotoReimportMasterState * obj)
{
	PhotoReimportMasterStateImpl * self;
#line 1280 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1281 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1282 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1283 "../src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1280 "../src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 31398 "Photo.c"
}

static GType
photo_reimport_master_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}

PhotoReimportEditableState*
photo_reimport_editable_state_construct (GType object_type)
{
	PhotoReimportEditableState* self = NULL;
#line 1293 "../src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1293 "../src/Photo.vala"
	return self;
#line 31422 "Photo.c"
}

static void
photo_value_reimport_editable_state_init (GValue* value)
{
#line 1293 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31430 "Photo.c"
}

static void
photo_value_reimport_editable_state_free_value (GValue* value)
{
#line 1293 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1293 "../src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 31440 "Photo.c"
	}
}

static void
photo_value_reimport_editable_state_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 1293 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1293 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 31452 "Photo.c"
	} else {
#line 1293 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31456 "Photo.c"
	}
}

static gpointer
photo_value_reimport_editable_state_peek_pointer (const GValue* value)
{
#line 1293 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31465 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 1293 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31476 "Photo.c"
		PhotoReimportEditableState * object;
		object = collect_values[0].v_pointer;
#line 1293 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1293 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31483 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1293 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31487 "Photo.c"
		}
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 31491 "Photo.c"
	} else {
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31495 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	return NULL;
#line 31499 "Photo.c"
}

static gchar*
photo_value_reimport_editable_state_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	PhotoReimportEditableState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1293 "../src/Photo.vala"
	if (!object_p) {
#line 1293 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31514 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1293 "../src/Photo.vala"
		*object_p = NULL;
#line 31520 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1293 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31524 "Photo.c"
	} else {
#line 1293 "../src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 31528 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	return NULL;
#line 31532 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_editable_state (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	PhotoParamSpecReimportEditableState* spec;
#line 1293 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1293 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1293 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1293 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31551 "Photo.c"
}

gpointer
photo_value_get_reimport_editable_state (const GValue* value)
{
#line 1293 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1293 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31561 "Photo.c"
}

void
photo_value_set_reimport_editable_state (GValue* value,
                                         gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1293 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1293 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1293 "../src/Photo.vala"
	if (v_object) {
#line 1293 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1293 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1293 "../src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 31583 "Photo.c"
	} else {
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31587 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	if (old) {
#line 1293 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 31593 "Photo.c"
	}
}

void
photo_value_take_reimport_editable_state (GValue* value,
                                          gpointer v_object)
{
	PhotoReimportEditableState * old;
#line 1293 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1293 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1293 "../src/Photo.vala"
	if (v_object) {
#line 1293 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1293 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31614 "Photo.c"
	} else {
#line 1293 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31618 "Photo.c"
	}
#line 1293 "../src/Photo.vala"
	if (old) {
#line 1293 "../src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 31624 "Photo.c"
	}
}

static void
photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass,
                                          gpointer klass_data)
{
#line 1293 "../src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1293 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 31636 "Photo.c"
}

static void
photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self,
                                             gpointer klass)
{
#line 1293 "../src/Photo.vala"
	self->ref_count = 1;
#line 31645 "Photo.c"
}

static void
photo_reimport_editable_state_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableState * self;
#line 1293 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1293 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 31656 "Photo.c"
}

GType
photo_reimport_editable_state_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}

gpointer
photo_reimport_editable_state_ref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1293 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1293 "../src/Photo.vala"
	return instance;
#line 31683 "Photo.c"
}

void
photo_reimport_editable_state_unref (gpointer instance)
{
	PhotoReimportEditableState * self;
	self = instance;
#line 1293 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1293 "../src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1293 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 31697 "Photo.c"
	}
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_construct (GType object_type,
                                              BackingPhotoRow* backing_state,
                                              PhotoMetadata* metadata)
{
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1301 "../src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 1301 "../src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1302 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing_state);
#line 1302 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1302 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1303 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1303 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1303 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1301 "../src/Photo.vala"
	return self;
#line 31727 "Photo.c"
}

static PhotoReimportEditableStateImpl*
photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state,
                                        PhotoMetadata* metadata)
{
#line 1301 "../src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 31736 "Photo.c"
}

static void
photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass,
                                               gpointer klass_data)
{
#line 1296 "../src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1296 "../src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 31747 "Photo.c"
}

static void
photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self,
                                                  gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1297 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1297 "../src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1299 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 31761 "Photo.c"
}

static void
photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState * obj)
{
	PhotoReimportEditableStateImpl * self;
#line 1296 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1297 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1298 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1296 "../src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 31776 "Photo.c"
}

static GType
photo_reimport_editable_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}

PhotoReimportRawDevelopmentState*
photo_reimport_raw_development_state_construct (GType object_type)
{
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1307 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1307 "../src/Photo.vala"
	return self;
#line 31800 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_init (GValue* value)
{
#line 1307 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31808 "Photo.c"
}

static void
photo_value_reimport_raw_development_state_free_value (GValue* value)
{
#line 1307 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1307 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 31818 "Photo.c"
	}
}

static void
photo_value_reimport_raw_development_state_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 1307 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1307 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 31830 "Photo.c"
	} else {
#line 1307 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31834 "Photo.c"
	}
}

static gpointer
photo_value_reimport_raw_development_state_peek_pointer (const GValue* value)
{
#line 1307 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31843 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 1307 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31854 "Photo.c"
		PhotoReimportRawDevelopmentState * object;
		object = collect_values[0].v_pointer;
#line 1307 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1307 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31861 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1307 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31865 "Photo.c"
		}
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 31869 "Photo.c"
	} else {
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31873 "Photo.c"
	}
#line 1307 "../src/Photo.vala"
	return NULL;
#line 31877 "Photo.c"
}

static gchar*
photo_value_reimport_raw_development_state_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	PhotoReimportRawDevelopmentState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1307 "../src/Photo.vala"
	if (!object_p) {
#line 1307 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31892 "Photo.c"
	}
#line 1307 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1307 "../src/Photo.vala"
		*object_p = NULL;
#line 31898 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1307 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31902 "Photo.c"
	} else {
#line 1307 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 31906 "Photo.c"
	}
#line 1307 "../src/Photo.vala"
	return NULL;
#line 31910 "Photo.c"
}

GParamSpec*
photo_param_spec_reimport_raw_development_state (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1307 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1307 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1307 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1307 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 31929 "Photo.c"
}

gpointer
photo_value_get_reimport_raw_development_state (const GValue* value)
{
#line 1307 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1307 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 31939 "Photo.c"
}

void
photo_value_set_reimport_raw_development_state (GValue* value,
                                                gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1307 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1307 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1307 "../src/Photo.vala"
	if (v_object) {
#line 1307 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1307 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1307 "../src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 31961 "Photo.c"
	} else {
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31965 "Photo.c"
	}
#line 1307 "../src/Photo.vala"
	if (old) {
#line 1307 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 31971 "Photo.c"
	}
}

void
photo_value_take_reimport_raw_development_state (GValue* value,
                                                 gpointer v_object)
{
	PhotoReimportRawDevelopmentState * old;
#line 1307 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1307 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1307 "../src/Photo.vala"
	if (v_object) {
#line 1307 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1307 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 31992 "Photo.c"
	} else {
#line 1307 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31996 "Photo.c"
	}
#line 1307 "../src/Photo.vala"
	if (old) {
#line 1307 "../src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 32002 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass,
                                                 gpointer klass_data)
{
#line 1307 "../src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1307 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 32014 "Photo.c"
}

static void
photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self,
                                                    gpointer klass)
{
#line 1307 "../src/Photo.vala"
	self->ref_count = 1;
#line 32023 "Photo.c"
}

static void
photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentState * self;
#line 1307 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1307 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32034 "Photo.c"
}

GType
photo_reimport_raw_development_state_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}

gpointer
photo_reimport_raw_development_state_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1307 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1307 "../src/Photo.vala"
	return instance;
#line 32061 "Photo.c"
}

void
photo_reimport_raw_development_state_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentState * self;
	self = instance;
#line 1307 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1307 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1307 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32075 "Photo.c"
	}
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_construct (GType object_type)
{
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1324 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1324 "../src/Photo.vala"
	return self;
#line 32087 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImpl*
photo_reimport_raw_development_state_impl_new (void)
{
#line 1324 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 32095 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self,
                                               BackingPhotoRow* backing,
                                               PhotoMetadata* metadata)
{
	GeeCollection* _tmp0_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp1_;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp2_;
#line 1327 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1327 "../src/Photo.vala"
	g_return_if_fail (backing != NULL);
#line 1328 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1328 "../src/Photo.vala"
	_tmp1_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (backing, metadata);
#line 1328 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1328 "../src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp2_);
#line 1328 "../src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp2_);
#line 32120 "Photo.c"
}

static gint
photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self)
{
	gint result = 0;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1331 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1332 "../src/Photo.vala"
	_tmp0_ = self->list;
#line 1332 "../src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1332 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1332 "../src/Photo.vala"
	result = _tmp2_;
#line 1332 "../src/Photo.vala"
	return result;
#line 32142 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type,
                                                                     BackingPhotoRow* backing,
                                                                     PhotoMetadata* metadata)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 1315 "../src/Photo.vala"
	g_return_val_if_fail (backing != NULL, NULL);
#line 1315 "../src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1316 "../src/Photo.vala"
	_tmp0_ = _backing_photo_row_ref0 (backing);
#line 1316 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1316 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1317 "../src/Photo.vala"
	_tmp1_ = _media_metadata_ref0 (metadata);
#line 1317 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1317 "../src/Photo.vala"
	self->metadata = _tmp1_;
#line 1315 "../src/Photo.vala"
	return self;
#line 32171 "Photo.c"
}

static PhotoReimportRawDevelopmentStateImplDevToReimport*
photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing,
                                                               PhotoMetadata* metadata)
{
#line 1315 "../src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 32180 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value)
{
#line 1311 "../src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32188 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value)
{
#line 1311 "../src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1311 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 32198 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 1311 "../src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1311 "../src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 32210 "Photo.c"
	} else {
#line 1311 "../src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32214 "Photo.c"
	}
}

static gpointer
photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value)
{
#line 1311 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32223 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 1311 "../src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32234 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport * object;
		object = collect_values[0].v_pointer;
#line 1311 "../src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1311 "../src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32241 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1311 "../src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32245 "Photo.c"
		}
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 32249 "Photo.c"
	} else {
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32253 "Photo.c"
	}
#line 1311 "../src/Photo.vala"
	return NULL;
#line 32257 "Photo.c"
}

static gchar*
photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1311 "../src/Photo.vala"
	if (!object_p) {
#line 1311 "../src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32272 "Photo.c"
	}
#line 1311 "../src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1311 "../src/Photo.vala"
		*object_p = NULL;
#line 32278 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1311 "../src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32282 "Photo.c"
	} else {
#line 1311 "../src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 32286 "Photo.c"
	}
#line 1311 "../src/Photo.vala"
	return NULL;
#line 32290 "Photo.c"
}

static GParamSpec*
photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1311 "../src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1311 "../src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1311 "../src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1311 "../src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32309 "Photo.c"
}

static gpointer
photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value)
{
#line 1311 "../src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1311 "../src/Photo.vala"
	return value->data[0].v_pointer;
#line 32319 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value,
                                                                     gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1311 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1311 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1311 "../src/Photo.vala"
	if (v_object) {
#line 1311 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1311 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1311 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 32341 "Photo.c"
	} else {
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32345 "Photo.c"
	}
#line 1311 "../src/Photo.vala"
	if (old) {
#line 1311 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 32351 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value,
                                                                      gpointer v_object)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * old;
#line 1311 "../src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1311 "../src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1311 "../src/Photo.vala"
	if (v_object) {
#line 1311 "../src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1311 "../src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32372 "Photo.c"
	} else {
#line 1311 "../src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32376 "Photo.c"
	}
#line 1311 "../src/Photo.vala"
	if (old) {
#line 1311 "../src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 32382 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass,
                                                                      gpointer klass_data)
{
#line 1311 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1311 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 32394 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self,
                                                                         gpointer klass)
{
	BackingPhotoRow* _tmp0_;
#line 1312 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1312 "../src/Photo.vala"
	self->backing = _tmp0_;
#line 1311 "../src/Photo.vala"
	self->ref_count = 1;
#line 32408 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport * obj)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1311 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1311 "../src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1312 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1313 "../src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 32423 "Photo.c"
}

GType
photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}

static gpointer
photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1311 "../src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1311 "../src/Photo.vala"
	return instance;
#line 32450 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance)
{
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
	self = instance;
#line 1311 "../src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1311 "../src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1311 "../src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32464 "Photo.c"
	}
}

static void
photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass,
                                                      gpointer klass_data)
{
#line 1310 "../src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1310 "../src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 32476 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self,
                                                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1321 "../src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1321 "../src/Photo.vala"
	self->list = (GeeCollection*) _tmp0_;
#line 1322 "../src/Photo.vala"
	self->metadata_only = FALSE;
#line 32490 "Photo.c"
}

static void
photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState * obj)
{
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1310 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1321 "../src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1310 "../src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 32503 "Photo.c"
}

static GType
photo_reimport_raw_development_state_impl_get_type (void)
{
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}

static void
photo_class_init (PhotoClass * klass,
                  gpointer klass_data)
{
#line 97 "../src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 97 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &Photo_private_offset);
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*) (Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*) (Photo*)) photo_real_notify_raw_development_modified;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*) (Photo*)) photo_real_notify_baseline_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) photo_real_internal_delete_backing;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) photo_real_get_backing_files_state;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) photo_real_get_typename;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) photo_real_get_instance_id;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*) (DataSource*)) photo_real_get_source_id;
#line 97 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 97 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) photo_real_get_file;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) photo_real_get_master_file;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) photo_real_get_timestamp;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) photo_real_get_event_id;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) photo_real_get_import_id;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) photo_real_get_master_md5;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) photo_real_set_event_id;
#line 97 "../src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) photo_real_to_string;
#line 97 "../src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*) (DataSource*, DataSource*)) photo_real_equals;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) photo_real_get_filesize;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) photo_real_get_master_filesize;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) photo_real_get_exposure_time;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*) (MediaSource*)) photo_real_get_basename;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) photo_real_get_title;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) photo_real_get_comment;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) photo_real_set_title;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) photo_real_set_comment;
#line 97 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 97 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*) (PhotoSource*)) photo_real_get_metadata;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) photo_real_rotate;
#line 97 "../src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) photo_real_has_user_generated_metadata;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 97 "../src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REPLACED_SIGNAL] = g_signal_new ("editable-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_RAW_DEVELOPMENT_MODIFIED_SIGNAL] = g_signal_new ("raw-development-modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REPLACED_SIGNAL] = g_signal_new ("baseline-replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "../src/Photo.vala"
	photo_signals[PHOTO_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 32639 "Photo.c"
}

static void
photo_dateable_interface_init (DateableIface * iface,
                               gpointer iface_data)
{
#line 97 "../src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 97 "../src/Photo.vala"
	iface->get_exposure_time = (time_t (*) (Dateable*)) photo_real_get_exposure_time;
#line 97 "../src/Photo.vala"
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) photo_real_set_exposure_time;
#line 32652 "Photo.c"
}

static void
photo_instance_init (Photo * self,
                     gpointer klass)
{
	BackingPhotoRow* _tmp0_;
	PhotoBackingReaders* _tmp1_;
#line 97 "../src/Photo.vala"
	self->priv = photo_get_instance_private (self);
#line 245 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 246 "../src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 246 "../src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 247 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 247 "../src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 247 "../src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 248 "../src/Photo.vala"
	self->priv->transformer = NULL;
#line 249 "../src/Photo.vala"
	self->priv->adjustments = NULL;
#line 251 "../src/Photo.vala"
	self->priv->file_title = NULL;
#line 252 "../src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 253 "../src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 254 "../src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 255 "../src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 257 "../src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 273 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 273 "../src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 274 "../src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 277 "../src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 277 "../src/Photo.vala"
	self->priv->developments = NULL;
#line 288 "../src/Photo.vala"
	self->backing_photo_row = NULL;
#line 32703 "Photo.c"
}

static void
photo_finalize (GObject * obj)
{
	Photo * self;
#line 97 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 245 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 245 "../src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 246 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 247 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 247 "../src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 248 "../src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 249 "../src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 251 "../src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 252 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 253 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 254 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 255 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 273 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_unmodified_precached);
#line 273 "../src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 274 "../src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 277 "../src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 277 "../src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 288 "../src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 97 "../src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 32750 "Photo.c"
}

GType
photo_get_type (void)
{
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		Photo_private_offset = g_type_add_instance_private (photo_type_id, sizeof (PhotoPrivate));
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}

static void
_vala_photo_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "../src/Photo.vala"
	switch (property_id) {
#line 32779 "Photo.c"
		default:
#line 97 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "../src/Photo.vala"
		break;
#line 32785 "Photo.c"
	}
}

static void
_vala_photo_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "../src/Photo.vala"
	switch (property_id) {
#line 32799 "Photo.c"
		default:
#line 97 "../src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "../src/Photo.vala"
		break;
#line 32805 "Photo.c"
	}
}

static inline gpointer
library_photo_source_collection_get_instance_private (LibraryPhotoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceCollection_private_offset);
}

GType
library_photo_source_collection_state_get_type (void)
{
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 4538 "../src/Photo.vala"
	return result;
#line 32836 "Photo.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4538 "../src/Photo.vala"
	return result;
#line 32848 "Photo.c"
}

static gint
_int64_compare_gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4542 "../src/Photo.vala"
	return result;
#line 32860 "Photo.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 4542 "../src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4542 "../src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4542 "../src/Photo.vala"
	return dup;
#line 32873 "Photo.c"
}

static gboolean
_int64_equal_gee_equal_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4544 "../src/Photo.vala"
	return result;
#line 32885 "Photo.c"
}

static gint64
_photo_get_photo_key_get_source_database_key (DataSource* source,
                                              gpointer self)
{
	gint64 result;
	result = photo_get_photo_key (source);
#line 4564 "../src/Photo.vala"
	return result;
#line 32896 "Photo.c"
}

static void
_library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                    GeeCollection* added,
                                                                                                    GeeCollection* removed,
                                                                                                    gpointer self)
{
#line 4566 "../src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 32907 "Photo.c"
}

static void
_library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                   GeeCollection* added,
                                                                                                   GeeCollection* removed,
                                                                                                   gpointer self)
{
#line 4567 "../src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 32918 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_construct (GType object_type)
{
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 4564 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4566 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4566 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4566 "../src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp1_, "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4566 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4567 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4567 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4567 "../src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp3_, "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4567 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4563 "../src/Photo.vala"
	return self;
#line 32949 "Photo.c"
}

LibraryPhotoSourceCollection*
library_photo_source_collection_new (void)
{
#line 4563 "../src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 32957 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4571 "../src/Photo.vala"
	return result;
#line 32969 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4570 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4571 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4571 "../src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4571 "../src/Photo.vala"
	return result;
#line 32986 "Photo.c"
}

static gboolean
_library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source,
                                                                                           Alteration* alteration,
                                                                                           gpointer self)
{
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4575 "../src/Photo.vala"
	return result;
#line 32998 "Photo.c"
}

static MediaSourceHoldingTank*
library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_;
#line 4574 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4575 "../src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4575 "../src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4575 "../src/Photo.vala"
	return result;
#line 33015 "Photo.c"
}

static MediaMonitor*
library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                           Workers* workers,
                                                           GCancellable* cancellable)
{
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	PhotoMonitor* _tmp0_;
#line 4578 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4578 "../src/Photo.vala"
	g_return_val_if_fail (workers != NULL, NULL);
#line 4578 "../src/Photo.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 4579 "../src/Photo.vala"
	_tmp0_ = photo_monitor_new (workers, cancellable);
#line 4579 "../src/Photo.vala"
	result = (MediaMonitor*) _tmp0_;
#line 4579 "../src/Photo.vala"
	return result;
#line 33038 "Photo.c"
}

static gboolean
library_photo_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                           DataSource* source)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4582 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4582 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4583 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (source, TYPE_LIBRARY_PHOTO);
#line 4583 "../src/Photo.vala"
	return result;
#line 33055 "Photo.c"
}

static gchar*
library_photo_source_collection_real_get_typename (MediaSourceCollection* base)
{
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 4586 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4587 "../src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4587 "../src/Photo.vala"
	result = _tmp0_;
#line 4587 "../src/Photo.vala"
	return result;
#line 33072 "Photo.c"
}

static gboolean
library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                         GFile* file)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
#line 4590 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4590 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4591 "../src/Photo.vala"
	result = photo_file_format_is_file_supported (file);
#line 4591 "../src/Photo.vala"
	return result;
#line 33089 "Photo.c"
}

static void
_library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                               GFile* old_file,
                                                                               GFile* new_file,
                                                                               gpointer self)
{
#line 4604 "../src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 33100 "Photo.c"
}

static void
_library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                             gpointer self)
{
#line 4613 "../src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 33109 "Photo.c"
}

static void
library_photo_source_collection_real_notify_contents_altered (DataCollection* base,
                                                              GeeIterable* added,
                                                              GeeIterable* removed)
{
	LibraryPhotoSourceCollection * self;
#line 4594 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4596 "../src/Photo.vala"
	if (added != NULL) {
#line 33122 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
#line 4597 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator (added);
#line 4597 "../src/Photo.vala"
			_object_it = _tmp0_;
#line 4597 "../src/Photo.vala"
			while (TRUE) {
#line 33132 "Photo.c"
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp4_;
				LibraryPhoto* _tmp5_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				LibraryPhoto* _tmp12_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				LibraryPhoto* _tmp24_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp25_;
				BackingPhotoRow* _tmp26_;
				BackingPhotoRow* _tmp27_;
				gint64 _tmp28_;
				gint64 _tmp29_ = 0LL;
				LibraryPhoto* _tmp30_;
				BackingPhotoRow* _tmp31_;
				BackingPhotoRow* _tmp32_;
				gboolean _tmp33_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp37_;
				LibraryPhoto* _tmp38_;
				GeeHashMap* _tmp39_;
				LibraryPhoto* _tmp40_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp45_;
				GeeCollection* _tmp46_;
				GeeCollection* _tmp47_;
#line 4597 "../src/Photo.vala"
				_tmp1_ = _object_it;
#line 4597 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 4597 "../src/Photo.vala"
					break;
#line 33175 "Photo.c"
				}
#line 4597 "../src/Photo.vala"
				_tmp2_ = _object_it;
#line 4597 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 4597 "../src/Photo.vala"
				object = (DataObject*) _tmp3_;
#line 4598 "../src/Photo.vala"
				_tmp4_ = object;
#line 4598 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4598 "../src/Photo.vala"
				photo = _tmp5_;
#line 4600 "../src/Photo.vala"
				_tmp6_ = photo;
#line 4600 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 4600 "../src/Photo.vala"
				editable = _tmp7_;
#line 4601 "../src/Photo.vala"
				_tmp8_ = editable;
#line 4601 "../src/Photo.vala"
				if (_tmp8_ != NULL) {
#line 33199 "Photo.c"
					GeeHashMap* _tmp9_;
					GFile* _tmp10_;
					LibraryPhoto* _tmp11_;
#line 4602 "../src/Photo.vala"
					_tmp9_ = self->priv->by_editable_file;
#line 4602 "../src/Photo.vala"
					_tmp10_ = editable;
#line 4602 "../src/Photo.vala"
					_tmp11_ = photo;
#line 4602 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp10_, _tmp11_);
#line 33211 "Photo.c"
				}
#line 4604 "../src/Photo.vala"
				_tmp12_ = photo;
#line 4604 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp12_, "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4606 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4606 "../src/Photo.vala"
				_tmp14_ = photo_get_raw_developer_files ((Photo*) _tmp13_);
#line 4606 "../src/Photo.vala"
				raw_list = _tmp14_;
#line 4607 "../src/Photo.vala"
				_tmp15_ = raw_list;
#line 4607 "../src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 33227 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp16_;
						GeeIterator* _tmp17_;
#line 4608 "../src/Photo.vala"
						_tmp16_ = raw_list;
#line 4608 "../src/Photo.vala"
						_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 4608 "../src/Photo.vala"
						_f_it = _tmp17_;
#line 4608 "../src/Photo.vala"
						while (TRUE) {
#line 33240 "Photo.c"
							GeeIterator* _tmp18_;
							GFile* f = NULL;
							GeeIterator* _tmp19_;
							gpointer _tmp20_;
							GeeHashMap* _tmp21_;
							GFile* _tmp22_;
							LibraryPhoto* _tmp23_;
#line 4608 "../src/Photo.vala"
							_tmp18_ = _f_it;
#line 4608 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp18_)) {
#line 4608 "../src/Photo.vala"
								break;
#line 33254 "Photo.c"
							}
#line 4608 "../src/Photo.vala"
							_tmp19_ = _f_it;
#line 4608 "../src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 4608 "../src/Photo.vala"
							f = (GFile*) _tmp20_;
#line 4609 "../src/Photo.vala"
							_tmp21_ = self->priv->by_raw_development_file;
#line 4609 "../src/Photo.vala"
							_tmp22_ = f;
#line 4609 "../src/Photo.vala"
							_tmp23_ = photo;
#line 4609 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, _tmp22_, _tmp23_);
#line 4608 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 33272 "Photo.c"
						}
#line 4608 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 33276 "Photo.c"
					}
				}
#line 4613 "../src/Photo.vala"
				_tmp24_ = photo;
#line 4613 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp24_, "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4615 "../src/Photo.vala"
				_tmp25_ = photo;
#line 4615 "../src/Photo.vala"
				_tmp26_ = photo_get_master_photo_row ((Photo*) _tmp25_);
#line 4615 "../src/Photo.vala"
				_tmp27_ = _tmp26_;
#line 4615 "../src/Photo.vala"
				_tmp28_ = _tmp27_->filesize;
#line 4615 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp27_);
#line 4615 "../src/Photo.vala"
				master_filesize = _tmp28_;
#line 4616 "../src/Photo.vala"
				_tmp30_ = photo;
#line 4616 "../src/Photo.vala"
				_tmp31_ = photo_get_editable_photo_row ((Photo*) _tmp30_);
#line 4616 "../src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 4616 "../src/Photo.vala"
				_tmp33_ = _tmp32_ != NULL;
#line 4616 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp32_);
#line 4616 "../src/Photo.vala"
				if (_tmp33_) {
#line 33307 "Photo.c"
					LibraryPhoto* _tmp34_;
					BackingPhotoRow* _tmp35_;
					BackingPhotoRow* _tmp36_;
#line 4617 "../src/Photo.vala"
					_tmp34_ = photo;
#line 4617 "../src/Photo.vala"
					_tmp35_ = photo_get_editable_photo_row ((Photo*) _tmp34_);
#line 4617 "../src/Photo.vala"
					_tmp36_ = _tmp35_;
#line 4617 "../src/Photo.vala"
					_tmp29_ = _tmp36_->filesize;
#line 4617 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp36_);
#line 33321 "Photo.c"
				} else {
#line 4618 "../src/Photo.vala"
					_tmp29_ = (gint64) -1;
#line 33325 "Photo.c"
				}
#line 4616 "../src/Photo.vala"
				editable_filesize = _tmp29_;
#line 4619 "../src/Photo.vala"
				_tmp37_ = self->priv->filesize_to_photo;
#line 4619 "../src/Photo.vala"
				_tmp38_ = photo;
#line 4619 "../src/Photo.vala"
				gee_multi_map_set (_tmp37_, &master_filesize, _tmp38_);
#line 4620 "../src/Photo.vala"
				_tmp39_ = self->priv->photo_to_master_filesize;
#line 4620 "../src/Photo.vala"
				_tmp40_ = photo;
#line 4620 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, _tmp40_, &master_filesize);
#line 4621 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 33343 "Photo.c"
					GeeMultiMap* _tmp41_;
					LibraryPhoto* _tmp42_;
					GeeHashMap* _tmp43_;
					LibraryPhoto* _tmp44_;
#line 4622 "../src/Photo.vala"
					_tmp41_ = self->priv->filesize_to_photo;
#line 4622 "../src/Photo.vala"
					_tmp42_ = photo;
#line 4622 "../src/Photo.vala"
					gee_multi_map_set (_tmp41_, &editable_filesize, _tmp42_);
#line 4623 "../src/Photo.vala"
					_tmp43_ = self->priv->photo_to_editable_filesize;
#line 4623 "../src/Photo.vala"
					_tmp44_ = photo;
#line 4623 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp43_, _tmp44_, &editable_filesize);
#line 33360 "Photo.c"
				}
#line 4626 "../src/Photo.vala"
				_tmp45_ = photo;
#line 4626 "../src/Photo.vala"
				_tmp46_ = photo_get_raw_development_photo_rows ((Photo*) _tmp45_);
#line 4626 "../src/Photo.vala"
				raw_rows = _tmp46_;
#line 4627 "../src/Photo.vala"
				_tmp47_ = raw_rows;
#line 4627 "../src/Photo.vala"
				if (_tmp47_ != NULL) {
#line 33372 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp48_;
						GeeIterator* _tmp49_;
#line 4628 "../src/Photo.vala"
						_tmp48_ = raw_rows;
#line 4628 "../src/Photo.vala"
						_tmp49_ = gee_iterable_iterator ((GeeIterable*) _tmp48_);
#line 4628 "../src/Photo.vala"
						_row_it = _tmp49_;
#line 4628 "../src/Photo.vala"
						while (TRUE) {
#line 33385 "Photo.c"
							GeeIterator* _tmp50_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp51_;
							gpointer _tmp52_;
							BackingPhotoRow* _tmp53_;
#line 4628 "../src/Photo.vala"
							_tmp50_ = _row_it;
#line 4628 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp50_)) {
#line 4628 "../src/Photo.vala"
								break;
#line 33397 "Photo.c"
							}
#line 4628 "../src/Photo.vala"
							_tmp51_ = _row_it;
#line 4628 "../src/Photo.vala"
							_tmp52_ = gee_iterator_get (_tmp51_);
#line 4628 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp52_;
#line 4629 "../src/Photo.vala"
							_tmp53_ = row;
#line 4629 "../src/Photo.vala"
							if (_tmp53_->filesize >= ((gint64) 0)) {
#line 33409 "Photo.c"
								GeeMultiMap* _tmp54_;
								BackingPhotoRow* _tmp55_;
								LibraryPhoto* _tmp56_;
								GeeMultiMap* _tmp57_;
								LibraryPhoto* _tmp58_;
								BackingPhotoRow* _tmp59_;
#line 4630 "../src/Photo.vala"
								_tmp54_ = self->priv->filesize_to_photo;
#line 4630 "../src/Photo.vala"
								_tmp55_ = row;
#line 4630 "../src/Photo.vala"
								_tmp56_ = photo;
#line 4630 "../src/Photo.vala"
								gee_multi_map_set (_tmp54_, &_tmp55_->filesize, _tmp56_);
#line 4631 "../src/Photo.vala"
								_tmp57_ = self->priv->photo_to_raw_development_filesize;
#line 4631 "../src/Photo.vala"
								_tmp58_ = photo;
#line 4631 "../src/Photo.vala"
								_tmp59_ = row;
#line 4631 "../src/Photo.vala"
								gee_multi_map_set (_tmp57_, _tmp58_, &_tmp59_->filesize);
#line 33432 "Photo.c"
							}
#line 4628 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 33436 "Photo.c"
						}
#line 4628 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 33440 "Photo.c"
					}
				}
#line 4597 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4597 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4597 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4597 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4597 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 33453 "Photo.c"
			}
#line 4597 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 33457 "Photo.c"
		}
	}
#line 4638 "../src/Photo.vala"
	if (removed != NULL) {
#line 33462 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp60_;
#line 4639 "../src/Photo.vala"
			_tmp60_ = gee_iterable_iterator (removed);
#line 4639 "../src/Photo.vala"
			_object_it = _tmp60_;
#line 4639 "../src/Photo.vala"
			while (TRUE) {
#line 33472 "Photo.c"
				GeeIterator* _tmp61_;
				DataObject* object = NULL;
				GeeIterator* _tmp62_;
				gpointer _tmp63_;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp64_;
				LibraryPhoto* _tmp65_;
				GFile* editable = NULL;
				LibraryPhoto* _tmp66_;
				GFile* _tmp67_;
				GFile* _tmp68_;
				LibraryPhoto* _tmp74_;
				guint _tmp75_;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp76_;
				GeeCollection* _tmp77_;
				GeeCollection* _tmp78_;
				LibraryPhoto* _tmp86_;
				guint _tmp87_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp88_;
				BackingPhotoRow* _tmp89_;
				BackingPhotoRow* _tmp90_;
				gint64 _tmp91_;
				gint64 _tmp92_ = 0LL;
				LibraryPhoto* _tmp93_;
				BackingPhotoRow* _tmp94_;
				BackingPhotoRow* _tmp95_;
				gboolean _tmp96_;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp100_;
				LibraryPhoto* _tmp101_;
				GeeHashMap* _tmp102_;
				LibraryPhoto* _tmp103_;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp108_;
				GeeCollection* _tmp109_;
				GeeCollection* _tmp110_;
#line 4639 "../src/Photo.vala"
				_tmp61_ = _object_it;
#line 4639 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp61_)) {
#line 4639 "../src/Photo.vala"
					break;
#line 33517 "Photo.c"
				}
#line 4639 "../src/Photo.vala"
				_tmp62_ = _object_it;
#line 4639 "../src/Photo.vala"
				_tmp63_ = gee_iterator_get (_tmp62_);
#line 4639 "../src/Photo.vala"
				object = (DataObject*) _tmp63_;
#line 4640 "../src/Photo.vala"
				_tmp64_ = object;
#line 4640 "../src/Photo.vala"
				_tmp65_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4640 "../src/Photo.vala"
				photo = _tmp65_;
#line 4642 "../src/Photo.vala"
				_tmp66_ = photo;
#line 4642 "../src/Photo.vala"
				_tmp67_ = photo_get_editable_file ((Photo*) _tmp66_);
#line 4642 "../src/Photo.vala"
				editable = _tmp67_;
#line 4643 "../src/Photo.vala"
				_tmp68_ = editable;
#line 4643 "../src/Photo.vala"
				if (_tmp68_ != NULL) {
#line 33541 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					GFile* _tmp71_;
					GFile* _tmp72_;
					gboolean _tmp73_;
#line 4644 "../src/Photo.vala"
					_tmp69_ = self->priv->by_editable_file;
#line 4644 "../src/Photo.vala"
					_tmp70_ = photo;
#line 4644 "../src/Photo.vala"
					_tmp71_ = photo_get_editable_file ((Photo*) _tmp70_);
#line 4644 "../src/Photo.vala"
					_tmp72_ = _tmp71_;
#line 4644 "../src/Photo.vala"
					_tmp73_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp69_, _tmp72_, NULL);
#line 4644 "../src/Photo.vala"
					_g_object_unref0 (_tmp72_);
#line 4644 "../src/Photo.vala"
					is_removed = _tmp73_;
#line 4645 "../src/Photo.vala"
					_vala_assert (is_removed, "is_removed");
#line 33564 "Photo.c"
				}
#line 4647 "../src/Photo.vala"
				_tmp74_ = photo;
#line 4647 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp75_, NULL, FALSE);
#line 4647 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp74_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4649 "../src/Photo.vala"
				_tmp76_ = photo;
#line 4649 "../src/Photo.vala"
				_tmp77_ = photo_get_raw_developer_files ((Photo*) _tmp76_);
#line 4649 "../src/Photo.vala"
				raw_list = _tmp77_;
#line 4650 "../src/Photo.vala"
				_tmp78_ = raw_list;
#line 4650 "../src/Photo.vala"
				if (_tmp78_ != NULL) {
#line 33582 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp79_;
						GeeIterator* _tmp80_;
#line 4651 "../src/Photo.vala"
						_tmp79_ = raw_list;
#line 4651 "../src/Photo.vala"
						_tmp80_ = gee_iterable_iterator ((GeeIterable*) _tmp79_);
#line 4651 "../src/Photo.vala"
						_f_it = _tmp80_;
#line 4651 "../src/Photo.vala"
						while (TRUE) {
#line 33595 "Photo.c"
							GeeIterator* _tmp81_;
							GFile* f = NULL;
							GeeIterator* _tmp82_;
							gpointer _tmp83_;
							GeeHashMap* _tmp84_;
							GFile* _tmp85_;
#line 4651 "../src/Photo.vala"
							_tmp81_ = _f_it;
#line 4651 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp81_)) {
#line 4651 "../src/Photo.vala"
								break;
#line 33608 "Photo.c"
							}
#line 4651 "../src/Photo.vala"
							_tmp82_ = _f_it;
#line 4651 "../src/Photo.vala"
							_tmp83_ = gee_iterator_get (_tmp82_);
#line 4651 "../src/Photo.vala"
							f = (GFile*) _tmp83_;
#line 4652 "../src/Photo.vala"
							_tmp84_ = self->priv->by_raw_development_file;
#line 4652 "../src/Photo.vala"
							_tmp85_ = f;
#line 4652 "../src/Photo.vala"
							gee_abstract_map_unset ((GeeAbstractMap*) _tmp84_, _tmp85_, NULL);
#line 4651 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 33624 "Photo.c"
						}
#line 4651 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 33628 "Photo.c"
					}
				}
#line 4656 "../src/Photo.vala"
				_tmp86_ = photo;
#line 4656 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp87_, NULL, FALSE);
#line 4656 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp86_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp87_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4658 "../src/Photo.vala"
				_tmp88_ = photo;
#line 4658 "../src/Photo.vala"
				_tmp89_ = photo_get_master_photo_row ((Photo*) _tmp88_);
#line 4658 "../src/Photo.vala"
				_tmp90_ = _tmp89_;
#line 4658 "../src/Photo.vala"
				_tmp91_ = _tmp90_->filesize;
#line 4658 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp90_);
#line 4658 "../src/Photo.vala"
				master_filesize = _tmp91_;
#line 4659 "../src/Photo.vala"
				_tmp93_ = photo;
#line 4659 "../src/Photo.vala"
				_tmp94_ = photo_get_editable_photo_row ((Photo*) _tmp93_);
#line 4659 "../src/Photo.vala"
				_tmp95_ = _tmp94_;
#line 4659 "../src/Photo.vala"
				_tmp96_ = _tmp95_ != NULL;
#line 4659 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp95_);
#line 4659 "../src/Photo.vala"
				if (_tmp96_) {
#line 33661 "Photo.c"
					LibraryPhoto* _tmp97_;
					BackingPhotoRow* _tmp98_;
					BackingPhotoRow* _tmp99_;
#line 4660 "../src/Photo.vala"
					_tmp97_ = photo;
#line 4660 "../src/Photo.vala"
					_tmp98_ = photo_get_editable_photo_row ((Photo*) _tmp97_);
#line 4660 "../src/Photo.vala"
					_tmp99_ = _tmp98_;
#line 4660 "../src/Photo.vala"
					_tmp92_ = _tmp99_->filesize;
#line 4660 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp99_);
#line 33675 "Photo.c"
				} else {
#line 4661 "../src/Photo.vala"
					_tmp92_ = (gint64) -1;
#line 33679 "Photo.c"
				}
#line 4659 "../src/Photo.vala"
				editable_filesize = _tmp92_;
#line 4662 "../src/Photo.vala"
				_tmp100_ = self->priv->filesize_to_photo;
#line 4662 "../src/Photo.vala"
				_tmp101_ = photo;
#line 4662 "../src/Photo.vala"
				gee_multi_map_remove (_tmp100_, &master_filesize, _tmp101_);
#line 4663 "../src/Photo.vala"
				_tmp102_ = self->priv->photo_to_master_filesize;
#line 4663 "../src/Photo.vala"
				_tmp103_ = photo;
#line 4663 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp102_, _tmp103_, NULL);
#line 4664 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 33697 "Photo.c"
					GeeMultiMap* _tmp104_;
					LibraryPhoto* _tmp105_;
					GeeHashMap* _tmp106_;
					LibraryPhoto* _tmp107_;
#line 4665 "../src/Photo.vala"
					_tmp104_ = self->priv->filesize_to_photo;
#line 4665 "../src/Photo.vala"
					_tmp105_ = photo;
#line 4665 "../src/Photo.vala"
					gee_multi_map_remove (_tmp104_, &editable_filesize, _tmp105_);
#line 4666 "../src/Photo.vala"
					_tmp106_ = self->priv->photo_to_editable_filesize;
#line 4666 "../src/Photo.vala"
					_tmp107_ = photo;
#line 4666 "../src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp106_, _tmp107_, NULL);
#line 33714 "Photo.c"
				}
#line 4669 "../src/Photo.vala"
				_tmp108_ = photo;
#line 4669 "../src/Photo.vala"
				_tmp109_ = photo_get_raw_development_photo_rows ((Photo*) _tmp108_);
#line 4669 "../src/Photo.vala"
				raw_rows = _tmp109_;
#line 4670 "../src/Photo.vala"
				_tmp110_ = raw_rows;
#line 4670 "../src/Photo.vala"
				if (_tmp110_ != NULL) {
#line 33726 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp111_;
						GeeIterator* _tmp112_;
#line 4671 "../src/Photo.vala"
						_tmp111_ = raw_rows;
#line 4671 "../src/Photo.vala"
						_tmp112_ = gee_iterable_iterator ((GeeIterable*) _tmp111_);
#line 4671 "../src/Photo.vala"
						_row_it = _tmp112_;
#line 4671 "../src/Photo.vala"
						while (TRUE) {
#line 33739 "Photo.c"
							GeeIterator* _tmp113_;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp114_;
							gpointer _tmp115_;
							BackingPhotoRow* _tmp116_;
#line 4671 "../src/Photo.vala"
							_tmp113_ = _row_it;
#line 4671 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp113_)) {
#line 4671 "../src/Photo.vala"
								break;
#line 33751 "Photo.c"
							}
#line 4671 "../src/Photo.vala"
							_tmp114_ = _row_it;
#line 4671 "../src/Photo.vala"
							_tmp115_ = gee_iterator_get (_tmp114_);
#line 4671 "../src/Photo.vala"
							row = (BackingPhotoRow*) _tmp115_;
#line 4672 "../src/Photo.vala"
							_tmp116_ = row;
#line 4672 "../src/Photo.vala"
							if (_tmp116_->filesize >= ((gint64) 0)) {
#line 33763 "Photo.c"
								GeeMultiMap* _tmp117_;
								BackingPhotoRow* _tmp118_;
								LibraryPhoto* _tmp119_;
								GeeMultiMap* _tmp120_;
								LibraryPhoto* _tmp121_;
								BackingPhotoRow* _tmp122_;
#line 4673 "../src/Photo.vala"
								_tmp117_ = self->priv->filesize_to_photo;
#line 4673 "../src/Photo.vala"
								_tmp118_ = row;
#line 4673 "../src/Photo.vala"
								_tmp119_ = photo;
#line 4673 "../src/Photo.vala"
								gee_multi_map_remove (_tmp117_, &_tmp118_->filesize, _tmp119_);
#line 4674 "../src/Photo.vala"
								_tmp120_ = self->priv->photo_to_raw_development_filesize;
#line 4674 "../src/Photo.vala"
								_tmp121_ = photo;
#line 4674 "../src/Photo.vala"
								_tmp122_ = row;
#line 4674 "../src/Photo.vala"
								gee_multi_map_remove (_tmp120_, _tmp121_, &_tmp122_->filesize);
#line 33786 "Photo.c"
							}
#line 4671 "../src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 33790 "Photo.c"
						}
#line 4671 "../src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 33794 "Photo.c"
					}
				}
#line 4639 "../src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4639 "../src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4639 "../src/Photo.vala"
				_g_object_unref0 (editable);
#line 4639 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4639 "../src/Photo.vala"
				_g_object_unref0 (object);
#line 33807 "Photo.c"
			}
#line 4639 "../src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 33811 "Photo.c"
		}
	}
#line 4681 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), added, removed);
#line 33816 "Photo.c"
}

static void
library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self,
                                                      Photo* photo,
                                                      GFile* old_file,
                                                      GFile* new_file)
{
#line 4684 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4684 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4685 "../src/Photo.vala"
	if (old_file != NULL) {
#line 33831 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp0_;
#line 4686 "../src/Photo.vala"
		_tmp0_ = self->priv->by_editable_file;
#line 4686 "../src/Photo.vala"
		is_removed = gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, old_file, NULL);
#line 4687 "../src/Photo.vala"
		_vala_assert (is_removed, "is_removed");
#line 33840 "Photo.c"
	}
#line 4690 "../src/Photo.vala"
	if (new_file != NULL) {
#line 33844 "Photo.c"
		GeeHashMap* _tmp1_;
#line 4691 "../src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4691 "../src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, new_file, G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 33850 "Photo.c"
	}
}

static void
library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self,
                                                             Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
#line 4695 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4695 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 4696 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 4696 "../src/Photo.vala"
	photo = _tmp0_;
#line 4697 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4697 "../src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4698 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4698 "../src/Photo.vala"
		return;
#line 33887 "Photo.c"
	}
#line 4702 "../src/Photo.vala"
	_tmp2_ = self->priv->photo_to_raw_development_filesize;
#line 4702 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4702 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 33895 "Photo.c"
		GeeMultiMap* _tmp17_;
		LibraryPhoto* _tmp18_;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 4703 "../src/Photo.vala"
			_tmp4_ = self->priv->photo_to_raw_development_filesize;
#line 4703 "../src/Photo.vala"
			_tmp5_ = photo;
#line 4703 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 4703 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 4703 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 4703 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4703 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 4703 "../src/Photo.vala"
			_s_it = _tmp9_;
#line 4703 "../src/Photo.vala"
			while (TRUE) {
#line 33924 "Photo.c"
				GeeIterator* _tmp10_;
				gint64 s = 0LL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				gint64* _tmp13_;
				gint64 _tmp14_;
				GeeMultiMap* _tmp15_;
				LibraryPhoto* _tmp16_;
#line 4703 "../src/Photo.vala"
				_tmp10_ = _s_it;
#line 4703 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 4703 "../src/Photo.vala"
					break;
#line 33939 "Photo.c"
				}
#line 4703 "../src/Photo.vala"
				_tmp11_ = _s_it;
#line 4703 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 4703 "../src/Photo.vala"
				_tmp13_ = (gint64*) _tmp12_;
#line 4703 "../src/Photo.vala"
				_tmp14_ = *_tmp13_;
#line 4703 "../src/Photo.vala"
				_g_free0 (_tmp13_);
#line 4703 "../src/Photo.vala"
				s = _tmp14_;
#line 4704 "../src/Photo.vala"
				_tmp15_ = self->priv->filesize_to_photo;
#line 4704 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4704 "../src/Photo.vala"
				gee_multi_map_remove (_tmp15_, &s, _tmp16_);
#line 33959 "Photo.c"
			}
#line 4703 "../src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 33963 "Photo.c"
		}
#line 4706 "../src/Photo.vala"
		_tmp17_ = self->priv->photo_to_raw_development_filesize;
#line 4706 "../src/Photo.vala"
		_tmp18_ = photo;
#line 4706 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp17_, _tmp18_);
#line 33971 "Photo.c"
	}
#line 4710 "../src/Photo.vala"
	_tmp19_ = photo;
#line 4710 "../src/Photo.vala"
	_tmp20_ = photo_get_raw_developer_files ((Photo*) _tmp19_);
#line 4710 "../src/Photo.vala"
	raw_list = _tmp20_;
#line 4711 "../src/Photo.vala"
	_tmp21_ = raw_list;
#line 4711 "../src/Photo.vala"
	if (_tmp21_ != NULL) {
#line 33983 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp22_;
			GeeIterator* _tmp23_;
#line 4712 "../src/Photo.vala"
			_tmp22_ = raw_list;
#line 4712 "../src/Photo.vala"
			_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
#line 4712 "../src/Photo.vala"
			_f_it = _tmp23_;
#line 4712 "../src/Photo.vala"
			while (TRUE) {
#line 33996 "Photo.c"
				GeeIterator* _tmp24_;
				GFile* f = NULL;
				GeeIterator* _tmp25_;
				gpointer _tmp26_;
				GeeHashMap* _tmp27_;
				GFile* _tmp28_;
				LibraryPhoto* _tmp29_;
#line 4712 "../src/Photo.vala"
				_tmp24_ = _f_it;
#line 4712 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp24_)) {
#line 4712 "../src/Photo.vala"
					break;
#line 34010 "Photo.c"
				}
#line 4712 "../src/Photo.vala"
				_tmp25_ = _f_it;
#line 4712 "../src/Photo.vala"
				_tmp26_ = gee_iterator_get (_tmp25_);
#line 4712 "../src/Photo.vala"
				f = (GFile*) _tmp26_;
#line 4713 "../src/Photo.vala"
				_tmp27_ = self->priv->by_raw_development_file;
#line 4713 "../src/Photo.vala"
				_tmp28_ = f;
#line 4713 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4713 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp27_, _tmp28_, _tmp29_);
#line 4712 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 34028 "Photo.c"
			}
#line 4712 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 34032 "Photo.c"
		}
	}
#line 4717 "../src/Photo.vala"
	_tmp30_ = photo;
#line 4717 "../src/Photo.vala"
	_tmp31_ = photo_get_raw_development_photo_rows ((Photo*) _tmp30_);
#line 4717 "../src/Photo.vala"
	raw_rows = _tmp31_;
#line 4718 "../src/Photo.vala"
	_tmp32_ = raw_rows;
#line 4718 "../src/Photo.vala"
	if (_tmp32_ != NULL) {
#line 34045 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp33_;
			GeeIterator* _tmp34_;
#line 4719 "../src/Photo.vala"
			_tmp33_ = raw_rows;
#line 4719 "../src/Photo.vala"
			_tmp34_ = gee_iterable_iterator ((GeeIterable*) _tmp33_);
#line 4719 "../src/Photo.vala"
			_row_it = _tmp34_;
#line 4719 "../src/Photo.vala"
			while (TRUE) {
#line 34058 "Photo.c"
				GeeIterator* _tmp35_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp36_;
				gpointer _tmp37_;
				BackingPhotoRow* _tmp38_;
#line 4719 "../src/Photo.vala"
				_tmp35_ = _row_it;
#line 4719 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp35_)) {
#line 4719 "../src/Photo.vala"
					break;
#line 34070 "Photo.c"
				}
#line 4719 "../src/Photo.vala"
				_tmp36_ = _row_it;
#line 4719 "../src/Photo.vala"
				_tmp37_ = gee_iterator_get (_tmp36_);
#line 4719 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp37_;
#line 4720 "../src/Photo.vala"
				_tmp38_ = row;
#line 4720 "../src/Photo.vala"
				if (_tmp38_->filesize > ((gint64) 0)) {
#line 34082 "Photo.c"
					GeeMultiMap* _tmp39_;
					BackingPhotoRow* _tmp40_;
					LibraryPhoto* _tmp41_;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					BackingPhotoRow* _tmp44_;
#line 4721 "../src/Photo.vala"
					_tmp39_ = self->priv->filesize_to_photo;
#line 4721 "../src/Photo.vala"
					_tmp40_ = row;
#line 4721 "../src/Photo.vala"
					_tmp41_ = photo;
#line 4721 "../src/Photo.vala"
					gee_multi_map_set (_tmp39_, &_tmp40_->filesize, _tmp41_);
#line 4722 "../src/Photo.vala"
					_tmp42_ = self->priv->photo_to_raw_development_filesize;
#line 4722 "../src/Photo.vala"
					_tmp43_ = photo;
#line 4722 "../src/Photo.vala"
					_tmp44_ = row;
#line 4722 "../src/Photo.vala"
					gee_multi_map_set (_tmp42_, _tmp43_, &_tmp44_->filesize);
#line 34105 "Photo.c"
				}
#line 4719 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 34109 "Photo.c"
			}
#line 4719 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 34113 "Photo.c"
		}
	}
#line 4695 "../src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4695 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4695 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 34122 "Photo.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 4738 "../src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 34130 "Photo.c"
}

static void
library_photo_source_collection_real_items_altered (DataCollection* base,
                                                    GeeMap* items)
{
	LibraryPhotoSourceCollection * self;
#line 4728 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4728 "../src/Photo.vala"
	g_return_if_fail (items != NULL);
#line 34142 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4729 "../src/Photo.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 4729 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4729 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4729 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4729 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4729 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4729 "../src/Photo.vala"
		_object_it = _tmp4_;
#line 4729 "../src/Photo.vala"
		while (TRUE) {
#line 34166 "Photo.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			gboolean _tmp12_ = FALSE;
			Alteration* _tmp13_;
#line 4729 "../src/Photo.vala"
			_tmp5_ = _object_it;
#line 4729 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4729 "../src/Photo.vala"
				break;
#line 34185 "Photo.c"
			}
#line 4729 "../src/Photo.vala"
			_tmp6_ = _object_it;
#line 4729 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4729 "../src/Photo.vala"
			object = (DataObject*) _tmp7_;
#line 4730 "../src/Photo.vala"
			_tmp8_ = object;
#line 4730 "../src/Photo.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 4730 "../src/Photo.vala"
			alteration = (Alteration*) _tmp9_;
#line 4732 "../src/Photo.vala"
			_tmp10_ = object;
#line 4732 "../src/Photo.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4732 "../src/Photo.vala"
			photo = _tmp11_;
#line 4734 "../src/Photo.vala"
			_tmp13_ = alteration;
#line 4734 "../src/Photo.vala"
			if (alteration_has_detail (_tmp13_, "image", "master")) {
#line 4734 "../src/Photo.vala"
				_tmp12_ = TRUE;
#line 34211 "Photo.c"
			} else {
				Alteration* _tmp14_;
#line 4734 "../src/Photo.vala"
				_tmp14_ = alteration;
#line 4734 "../src/Photo.vala"
				_tmp12_ = alteration_has_detail (_tmp14_, "image", "editable");
#line 34218 "Photo.c"
			}
#line 4734 "../src/Photo.vala"
			if (_tmp12_) {
#line 34222 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp15_;
				LibraryPhoto* _tmp16_;
				gpointer _tmp17_;
				gint64* _tmp18_;
				gint64 _tmp19_;
				gint64* _tmp20_ = NULL;
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GeeMultiMap* _tmp30_;
				LibraryPhoto* _tmp31_;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp36_;
				BackingPhotoRow* _tmp37_;
				BackingPhotoRow* _tmp38_;
				gint64 _tmp39_;
				gint64 _tmp40_ = 0LL;
				LibraryPhoto* _tmp41_;
				BackingPhotoRow* _tmp42_;
				BackingPhotoRow* _tmp43_;
				gboolean _tmp44_;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp48_;
				LibraryPhoto* _tmp49_;
				GeeMultiMap* _tmp50_;
				LibraryPhoto* _tmp51_;
#line 4735 "../src/Photo.vala"
				_tmp15_ = self->priv->photo_to_master_filesize;
#line 4735 "../src/Photo.vala"
				_tmp16_ = photo;
#line 4735 "../src/Photo.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 4735 "../src/Photo.vala"
				_tmp18_ = (gint64*) _tmp17_;
#line 4735 "../src/Photo.vala"
				_tmp19_ = *_tmp18_;
#line 4735 "../src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4735 "../src/Photo.vala"
				old_master_filesize = _tmp19_;
#line 4736 "../src/Photo.vala"
				_tmp21_ = self->priv->photo_to_editable_filesize;
#line 4736 "../src/Photo.vala"
				_tmp22_ = photo;
#line 4736 "../src/Photo.vala"
				if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp21_, _tmp22_)) {
#line 34272 "Photo.c"
					GeeHashMap* _tmp23_;
					LibraryPhoto* _tmp24_;
					gpointer _tmp25_;
#line 4737 "../src/Photo.vala"
					_tmp23_ = self->priv->photo_to_editable_filesize;
#line 4737 "../src/Photo.vala"
					_tmp24_ = photo;
#line 4737 "../src/Photo.vala"
					_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, _tmp24_);
#line 4737 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4737 "../src/Photo.vala"
					_tmp20_ = (gint64*) _tmp25_;
#line 34286 "Photo.c"
				} else {
					gint64 _tmp26_;
					gint64* _tmp27_;
#line 4738 "../src/Photo.vala"
					_tmp26_ = (gint64) -1;
#line 4738 "../src/Photo.vala"
					_tmp27_ = __int64_dup0 (&_tmp26_);
#line 4738 "../src/Photo.vala"
					_g_free0 (_tmp20_);
#line 4738 "../src/Photo.vala"
					_tmp20_ = _tmp27_;
#line 34298 "Photo.c"
				}
#line 4736 "../src/Photo.vala"
				old_editable_filesize = *_tmp20_;
#line 4740 "../src/Photo.vala"
				_tmp28_ = self->priv->photo_to_master_filesize;
#line 4740 "../src/Photo.vala"
				_tmp29_ = photo;
#line 4740 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp28_, _tmp29_, NULL);
#line 4741 "../src/Photo.vala"
				_tmp30_ = self->priv->filesize_to_photo;
#line 4741 "../src/Photo.vala"
				_tmp31_ = photo;
#line 4741 "../src/Photo.vala"
				gee_multi_map_remove (_tmp30_, &old_master_filesize, _tmp31_);
#line 4742 "../src/Photo.vala"
				if (old_editable_filesize >= ((gint64) 0)) {
#line 34316 "Photo.c"
					GeeHashMap* _tmp32_;
					LibraryPhoto* _tmp33_;
					GeeMultiMap* _tmp34_;
					LibraryPhoto* _tmp35_;
#line 4743 "../src/Photo.vala"
					_tmp32_ = self->priv->photo_to_editable_filesize;
#line 4743 "../src/Photo.vala"
					_tmp33_ = photo;
#line 4743 "../src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp32_, _tmp33_, NULL);
#line 4744 "../src/Photo.vala"
					_tmp34_ = self->priv->filesize_to_photo;
#line 4744 "../src/Photo.vala"
					_tmp35_ = photo;
#line 4744 "../src/Photo.vala"
					gee_multi_map_remove (_tmp34_, &old_editable_filesize, _tmp35_);
#line 34333 "Photo.c"
				}
#line 4747 "../src/Photo.vala"
				_tmp36_ = photo;
#line 4747 "../src/Photo.vala"
				_tmp37_ = photo_get_master_photo_row ((Photo*) _tmp36_);
#line 4747 "../src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 4747 "../src/Photo.vala"
				_tmp39_ = _tmp38_->filesize;
#line 4747 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp38_);
#line 4747 "../src/Photo.vala"
				master_filesize = _tmp39_;
#line 4748 "../src/Photo.vala"
				_tmp41_ = photo;
#line 4748 "../src/Photo.vala"
				_tmp42_ = photo_get_editable_photo_row ((Photo*) _tmp41_);
#line 4748 "../src/Photo.vala"
				_tmp43_ = _tmp42_;
#line 4748 "../src/Photo.vala"
				_tmp44_ = _tmp43_ != NULL;
#line 4748 "../src/Photo.vala"
				_backing_photo_row_unref0 (_tmp43_);
#line 4748 "../src/Photo.vala"
				if (_tmp44_) {
#line 34359 "Photo.c"
					LibraryPhoto* _tmp45_;
					BackingPhotoRow* _tmp46_;
					BackingPhotoRow* _tmp47_;
#line 4749 "../src/Photo.vala"
					_tmp45_ = photo;
#line 4749 "../src/Photo.vala"
					_tmp46_ = photo_get_editable_photo_row ((Photo*) _tmp45_);
#line 4749 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 4749 "../src/Photo.vala"
					_tmp40_ = _tmp47_->filesize;
#line 4749 "../src/Photo.vala"
					_backing_photo_row_unref0 (_tmp47_);
#line 34373 "Photo.c"
				} else {
#line 4750 "../src/Photo.vala"
					_tmp40_ = (gint64) -1;
#line 34377 "Photo.c"
				}
#line 4748 "../src/Photo.vala"
				editable_filesize = _tmp40_;
#line 4751 "../src/Photo.vala"
				_tmp48_ = self->priv->photo_to_master_filesize;
#line 4751 "../src/Photo.vala"
				_tmp49_ = photo;
#line 4751 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp48_, _tmp49_, &master_filesize);
#line 4752 "../src/Photo.vala"
				_tmp50_ = self->priv->filesize_to_photo;
#line 4752 "../src/Photo.vala"
				_tmp51_ = photo;
#line 4752 "../src/Photo.vala"
				gee_multi_map_set (_tmp50_, &master_filesize, _tmp51_);
#line 4753 "../src/Photo.vala"
				if (editable_filesize >= ((gint64) 0)) {
#line 34395 "Photo.c"
					GeeHashMap* _tmp52_;
					LibraryPhoto* _tmp53_;
					GeeMultiMap* _tmp54_;
					LibraryPhoto* _tmp55_;
#line 4754 "../src/Photo.vala"
					_tmp52_ = self->priv->photo_to_editable_filesize;
#line 4754 "../src/Photo.vala"
					_tmp53_ = photo;
#line 4754 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp52_, _tmp53_, &editable_filesize);
#line 4755 "../src/Photo.vala"
					_tmp54_ = self->priv->filesize_to_photo;
#line 4755 "../src/Photo.vala"
					_tmp55_ = photo;
#line 4755 "../src/Photo.vala"
					gee_multi_map_set (_tmp54_, &editable_filesize, _tmp55_);
#line 34412 "Photo.c"
				}
#line 4734 "../src/Photo.vala"
				_g_free0 (_tmp20_);
#line 34416 "Photo.c"
			}
#line 4729 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4729 "../src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4729 "../src/Photo.vala"
			_g_object_unref0 (object);
#line 34424 "Photo.c"
		}
#line 4729 "../src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 34428 "Photo.c"
	}
#line 4760 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), items);
#line 34432 "Photo.c"
}

static void
library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base,
                                                                 GeeCollection* media_sources)
{
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_;
#line 4764 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4764 "../src/Photo.vala"
	g_return_if_fail (media_sources != NULL);
#line 4765 "../src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4765 "../src/Photo.vala"
	map = _tmp0_;
#line 34450 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 4766 "../src/Photo.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4766 "../src/Photo.vala"
		_media_it = _tmp1_;
#line 4766 "../src/Photo.vala"
		while (TRUE) {
#line 34460 "Photo.c"
			GeeIterator* _tmp2_;
			MediaSource* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp5_;
			LibraryPhoto* _tmp6_;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp7_;
			PhotoMetadata* _tmp8_;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp9_;
			HierarchicalTagIndex* htag_index = NULL;
			PhotoMetadata* _tmp10_;
			LibraryPhoto* _tmp15_;
			GeeCollection* _tmp16_;
			GeeCollection* _tmp17_;
			gboolean _tmp18_;
			PhotoMetadata* _tmp49_;
#line 4766 "../src/Photo.vala"
			_tmp2_ = _media_it;
#line 4766 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 4766 "../src/Photo.vala"
				break;
#line 34486 "Photo.c"
			}
#line 4766 "../src/Photo.vala"
			_tmp3_ = _media_it;
#line 4766 "../src/Photo.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 4766 "../src/Photo.vala"
			media = (MediaSource*) _tmp4_;
#line 4767 "../src/Photo.vala"
			_tmp5_ = media;
#line 4767 "../src/Photo.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4767 "../src/Photo.vala"
			photo = _tmp6_;
#line 4768 "../src/Photo.vala"
			_tmp7_ = photo;
#line 4768 "../src/Photo.vala"
			_tmp8_ = photo_source_get_metadata ((PhotoSource*) _tmp7_);
#line 4768 "../src/Photo.vala"
			metadata = _tmp8_;
#line 4771 "../src/Photo.vala"
			_tmp9_ = hierarchical_tag_index_get_global_index ();
#line 4771 "../src/Photo.vala"
			global_index = _tmp9_;
#line 4778 "../src/Photo.vala"
			htag_index = NULL;
#line 4779 "../src/Photo.vala"
			_tmp10_ = metadata;
#line 4779 "../src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp10_)) {
#line 34516 "Photo.c"
				PhotoMetadata* _tmp11_;
				GeeSet* _tmp12_;
				GeeSet* _tmp13_;
				HierarchicalTagIndex* _tmp14_;
#line 4780 "../src/Photo.vala"
				_tmp11_ = metadata;
#line 4780 "../src/Photo.vala"
				_tmp12_ = photo_metadata_get_hierarchical_keywords (_tmp11_);
#line 4780 "../src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 4780 "../src/Photo.vala"
				_tmp14_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp13_);
#line 4780 "../src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4780 "../src/Photo.vala"
				htag_index = _tmp14_;
#line 4780 "../src/Photo.vala"
				_g_object_unref0 (_tmp13_);
#line 34535 "Photo.c"
			}
#line 4784 "../src/Photo.vala"
			_tmp15_ = photo;
#line 4784 "../src/Photo.vala"
			_tmp16_ = library_photo_get_import_keywords (_tmp15_);
#line 4784 "../src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 4784 "../src/Photo.vala"
			_tmp18_ = _tmp17_ != NULL;
#line 4784 "../src/Photo.vala"
			_g_object_unref0 (_tmp17_);
#line 4784 "../src/Photo.vala"
			if (_tmp18_) {
#line 34549 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp19_;
					GeeCollection* _tmp20_;
					GeeCollection* _tmp21_;
					GeeIterator* _tmp22_;
					GeeIterator* _tmp23_;
#line 4785 "../src/Photo.vala"
					_tmp19_ = photo;
#line 4785 "../src/Photo.vala"
					_tmp20_ = library_photo_get_import_keywords (_tmp19_);
#line 4785 "../src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 4785 "../src/Photo.vala"
					_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 4785 "../src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 4785 "../src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 4785 "../src/Photo.vala"
					_keyword_it = _tmp23_;
#line 4785 "../src/Photo.vala"
					while (TRUE) {
#line 34573 "Photo.c"
						GeeIterator* _tmp24_;
						gchar* keyword = NULL;
						GeeIterator* _tmp25_;
						gpointer _tmp26_;
						gboolean _tmp27_ = FALSE;
						HierarchicalTagIndex* _tmp28_;
						gchar* name = NULL;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						HierarchicalTagIndex* _tmp33_;
						const gchar* _tmp34_;
						const gchar* _tmp43_;
#line 4785 "../src/Photo.vala"
						_tmp24_ = _keyword_it;
#line 4785 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp24_)) {
#line 4785 "../src/Photo.vala"
							break;
#line 34592 "Photo.c"
						}
#line 4785 "../src/Photo.vala"
						_tmp25_ = _keyword_it;
#line 4785 "../src/Photo.vala"
						_tmp26_ = gee_iterator_get (_tmp25_);
#line 4785 "../src/Photo.vala"
						keyword = (gchar*) _tmp26_;
#line 4786 "../src/Photo.vala"
						_tmp28_ = htag_index;
#line 4786 "../src/Photo.vala"
						if (_tmp28_ != NULL) {
#line 34604 "Photo.c"
							HierarchicalTagIndex* _tmp29_;
							const gchar* _tmp30_;
#line 4786 "../src/Photo.vala"
							_tmp29_ = htag_index;
#line 4786 "../src/Photo.vala"
							_tmp30_ = keyword;
#line 4786 "../src/Photo.vala"
							_tmp27_ = hierarchical_tag_index_is_tag_in_index (_tmp29_, _tmp30_);
#line 34613 "Photo.c"
						} else {
#line 4786 "../src/Photo.vala"
							_tmp27_ = FALSE;
#line 34617 "Photo.c"
						}
#line 4786 "../src/Photo.vala"
						if (_tmp27_) {
#line 4787 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4787 "../src/Photo.vala"
							continue;
#line 34625 "Photo.c"
						}
#line 4790 "../src/Photo.vala"
						_tmp31_ = keyword;
#line 4790 "../src/Photo.vala"
						_tmp32_ = tag_prep_tag_name (_tmp31_);
#line 4790 "../src/Photo.vala"
						name = _tmp32_;
#line 4792 "../src/Photo.vala"
						_tmp33_ = global_index;
#line 4792 "../src/Photo.vala"
						_tmp34_ = name;
#line 4792 "../src/Photo.vala"
						if (hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_)) {
#line 34639 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp35_;
							const gchar* _tmp36_;
							gchar* _tmp37_;
							GeeHashMultiMap* _tmp38_;
							const gchar* _tmp39_;
							Tag* _tmp40_;
							Tag* _tmp41_;
							LibraryPhoto* _tmp42_;
#line 4793 "../src/Photo.vala"
							_tmp35_ = global_index;
#line 4793 "../src/Photo.vala"
							_tmp36_ = name;
#line 4793 "../src/Photo.vala"
							_tmp37_ = hierarchical_tag_index_get_path_for_name (_tmp35_, _tmp36_);
#line 4793 "../src/Photo.vala"
							most_derived_path = _tmp37_;
#line 4794 "../src/Photo.vala"
							_tmp38_ = map;
#line 4794 "../src/Photo.vala"
							_tmp39_ = most_derived_path;
#line 4794 "../src/Photo.vala"
							_tmp40_ = tag_for_path (_tmp39_);
#line 4794 "../src/Photo.vala"
							_tmp41_ = _tmp40_;
#line 4794 "../src/Photo.vala"
							_tmp42_ = photo;
#line 4794 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp38_, _tmp41_, _tmp42_);
#line 4794 "../src/Photo.vala"
							_g_object_unref0 (_tmp41_);
#line 4795 "../src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4795 "../src/Photo.vala"
							_g_free0 (name);
#line 4795 "../src/Photo.vala"
							_g_free0 (keyword);
#line 4795 "../src/Photo.vala"
							continue;
#line 34679 "Photo.c"
						}
#line 4798 "../src/Photo.vala"
						_tmp43_ = name;
#line 4798 "../src/Photo.vala"
						if (_tmp43_ != NULL) {
#line 34685 "Photo.c"
							GeeHashMultiMap* _tmp44_;
							const gchar* _tmp45_;
							Tag* _tmp46_;
							Tag* _tmp47_;
							LibraryPhoto* _tmp48_;
#line 4799 "../src/Photo.vala"
							_tmp44_ = map;
#line 4799 "../src/Photo.vala"
							_tmp45_ = name;
#line 4799 "../src/Photo.vala"
							_tmp46_ = tag_for_path (_tmp45_);
#line 4799 "../src/Photo.vala"
							_tmp47_ = _tmp46_;
#line 4799 "../src/Photo.vala"
							_tmp48_ = photo;
#line 4799 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp44_, _tmp47_, _tmp48_);
#line 4799 "../src/Photo.vala"
							_g_object_unref0 (_tmp47_);
#line 34705 "Photo.c"
						}
#line 4785 "../src/Photo.vala"
						_g_free0 (name);
#line 4785 "../src/Photo.vala"
						_g_free0 (keyword);
#line 34711 "Photo.c"
					}
#line 4785 "../src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 34715 "Photo.c"
				}
			}
#line 4804 "../src/Photo.vala"
			_tmp49_ = metadata;
#line 4804 "../src/Photo.vala"
			if (photo_metadata_has_hierarchical_keywords (_tmp49_)) {
#line 34722 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp50_;
					GeeCollection* _tmp51_;
					GeeCollection* _tmp52_;
					GeeIterator* _tmp53_;
					GeeIterator* _tmp54_;
#line 4805 "../src/Photo.vala"
					_tmp50_ = htag_index;
#line 4805 "../src/Photo.vala"
					_tmp51_ = hierarchical_tag_index_get_all_paths (_tmp50_);
#line 4805 "../src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 4805 "../src/Photo.vala"
					_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 4805 "../src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 4805 "../src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 4805 "../src/Photo.vala"
					_path_it = _tmp54_;
#line 4805 "../src/Photo.vala"
					while (TRUE) {
#line 34746 "Photo.c"
						GeeIterator* _tmp55_;
						gchar* path = NULL;
						GeeIterator* _tmp56_;
						gpointer _tmp57_;
						gchar* name = NULL;
						const gchar* _tmp58_;
						gchar* _tmp59_;
						const gchar* _tmp60_;
#line 4805 "../src/Photo.vala"
						_tmp55_ = _path_it;
#line 4805 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp55_)) {
#line 4805 "../src/Photo.vala"
							break;
#line 34761 "Photo.c"
						}
#line 4805 "../src/Photo.vala"
						_tmp56_ = _path_it;
#line 4805 "../src/Photo.vala"
						_tmp57_ = gee_iterator_get (_tmp56_);
#line 4805 "../src/Photo.vala"
						path = (gchar*) _tmp57_;
#line 4806 "../src/Photo.vala"
						_tmp58_ = path;
#line 4806 "../src/Photo.vala"
						_tmp59_ = tag_prep_tag_name (_tmp58_);
#line 4806 "../src/Photo.vala"
						name = _tmp59_;
#line 4807 "../src/Photo.vala"
						_tmp60_ = name;
#line 4807 "../src/Photo.vala"
						if (_tmp60_ != NULL) {
#line 34779 "Photo.c"
							GeeHashMultiMap* _tmp61_;
							const gchar* _tmp62_;
							Tag* _tmp63_;
							Tag* _tmp64_;
							LibraryPhoto* _tmp65_;
#line 4808 "../src/Photo.vala"
							_tmp61_ = map;
#line 4808 "../src/Photo.vala"
							_tmp62_ = name;
#line 4808 "../src/Photo.vala"
							_tmp63_ = tag_for_path (_tmp62_);
#line 4808 "../src/Photo.vala"
							_tmp64_ = _tmp63_;
#line 4808 "../src/Photo.vala"
							_tmp65_ = photo;
#line 4808 "../src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp61_, _tmp64_, _tmp65_);
#line 4808 "../src/Photo.vala"
							_g_object_unref0 (_tmp64_);
#line 34799 "Photo.c"
						}
#line 4805 "../src/Photo.vala"
						_g_free0 (name);
#line 4805 "../src/Photo.vala"
						_g_free0 (path);
#line 34805 "Photo.c"
					}
#line 4805 "../src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 34809 "Photo.c"
				}
			}
#line 4766 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4766 "../src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4766 "../src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4766 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4766 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 34822 "Photo.c"
		}
#line 4766 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 34826 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp66_;
#line 4814 "../src/Photo.vala"
		_tmp66_ = gee_iterable_iterator ((GeeIterable*) media_sources);
#line 4814 "../src/Photo.vala"
		_media_it = _tmp66_;
#line 4814 "../src/Photo.vala"
		while (TRUE) {
#line 34837 "Photo.c"
			GeeIterator* _tmp67_;
			MediaSource* media = NULL;
			GeeIterator* _tmp68_;
			gpointer _tmp69_;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp70_;
			LibraryPhoto* _tmp71_;
			LibraryPhoto* _tmp72_;
#line 4814 "../src/Photo.vala"
			_tmp67_ = _media_it;
#line 4814 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp67_)) {
#line 4814 "../src/Photo.vala"
				break;
#line 34852 "Photo.c"
			}
#line 4814 "../src/Photo.vala"
			_tmp68_ = _media_it;
#line 4814 "../src/Photo.vala"
			_tmp69_ = gee_iterator_get (_tmp68_);
#line 4814 "../src/Photo.vala"
			media = (MediaSource*) _tmp69_;
#line 4815 "../src/Photo.vala"
			_tmp70_ = media;
#line 4815 "../src/Photo.vala"
			_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4815 "../src/Photo.vala"
			photo = _tmp71_;
#line 4816 "../src/Photo.vala"
			_tmp72_ = photo;
#line 4816 "../src/Photo.vala"
			library_photo_clear_import_keywords (_tmp72_);
#line 4814 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 4814 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 34874 "Photo.c"
		}
#line 4814 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 34878 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp73_;
		GeeSet* _tmp74_;
		GeeSet* _tmp75_;
		GeeIterator* _tmp76_;
		GeeIterator* _tmp77_;
#line 4819 "../src/Photo.vala"
		_tmp73_ = map;
#line 4819 "../src/Photo.vala"
		_tmp74_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp73_);
#line 4819 "../src/Photo.vala"
		_tmp75_ = _tmp74_;
#line 4819 "../src/Photo.vala"
		_tmp76_ = gee_iterable_iterator ((GeeIterable*) _tmp75_);
#line 4819 "../src/Photo.vala"
		_tmp77_ = _tmp76_;
#line 4819 "../src/Photo.vala"
		_g_object_unref0 (_tmp75_);
#line 4819 "../src/Photo.vala"
		_tag_it = _tmp77_;
#line 4819 "../src/Photo.vala"
		while (TRUE) {
#line 34903 "Photo.c"
			GeeIterator* _tmp78_;
			Tag* tag = NULL;
			GeeIterator* _tmp79_;
			gpointer _tmp80_;
			Tag* _tmp81_;
			GeeHashMultiMap* _tmp82_;
			Tag* _tmp83_;
			GeeCollection* _tmp84_;
			GeeCollection* _tmp85_;
#line 4819 "../src/Photo.vala"
			_tmp78_ = _tag_it;
#line 4819 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp78_)) {
#line 4819 "../src/Photo.vala"
				break;
#line 34919 "Photo.c"
			}
#line 4819 "../src/Photo.vala"
			_tmp79_ = _tag_it;
#line 4819 "../src/Photo.vala"
			_tmp80_ = gee_iterator_get (_tmp79_);
#line 4819 "../src/Photo.vala"
			tag = (Tag*) _tmp80_;
#line 4820 "../src/Photo.vala"
			_tmp81_ = tag;
#line 4820 "../src/Photo.vala"
			_tmp82_ = map;
#line 4820 "../src/Photo.vala"
			_tmp83_ = tag;
#line 4820 "../src/Photo.vala"
			_tmp84_ = gee_multi_map_get ((GeeMultiMap*) _tmp82_, _tmp83_);
#line 4820 "../src/Photo.vala"
			_tmp85_ = _tmp84_;
#line 4820 "../src/Photo.vala"
			tag_attach_many (_tmp81_, _tmp85_);
#line 4820 "../src/Photo.vala"
			_g_object_unref0 (_tmp85_);
#line 4819 "../src/Photo.vala"
			_g_object_unref0 (tag);
#line 34943 "Photo.c"
		}
#line 4819 "../src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 34947 "Photo.c"
	}
#line 4822 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), media_sources);
#line 4764 "../src/Photo.vala"
	_g_object_unref0 (map);
#line 34953 "Photo.c"
}

static void
library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4826 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4827 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 34965 "Photo.c"
}

void
library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4826 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4826 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 34977 "Photo.c"
}

static void
library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4831 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4832 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 34989 "Photo.c"
}

void
library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4831 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4831 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 35001 "Photo.c"
}

static void
library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                               LibraryPhoto* photo,
                                                               PhotoMetadata* metadata)
{
#line 4836 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4837 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 35013 "Photo.c"
}

void
library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4836 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4836 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 35025 "Photo.c"
}

static void
library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                                 LibraryPhoto* photo,
                                                                 PhotoMetadata* metadata)
{
#line 4841 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4842 "../src/Photo.vala"
	g_signal_emit (self, library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL], 0, photo, metadata);
#line 35037 "Photo.c"
}

void
library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                            LibraryPhoto* photo,
                                                            PhotoMetadata* metadata)
{
#line 4841 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4841 "../src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 35049 "Photo.c"
}

static MediaSource*
library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                          gint64 numeric_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	PhotoID _tmp0_ = {0};
	LibraryPhoto* _tmp1_;
#line 4845 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4846 "../src/Photo.vala"
	photo_id_init (&_tmp0_, numeric_id);
#line 4846 "../src/Photo.vala"
	_tmp1_ = library_photo_source_collection_fetch (self, &_tmp0_);
#line 4846 "../src/Photo.vala"
	result = (MediaSource*) _tmp1_;
#line 4846 "../src/Photo.vala"
	return result;
#line 35070 "Photo.c"
}

static void
library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self,
                                                              GeeCollection* added,
                                                              GeeCollection* removed)
{
#line 4849 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4851 "../src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 35082 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4855 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4855 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4855 "../src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4856 "../src/Photo.vala"
	result = media_source_is_trashed ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4856 "../src/Photo.vala"
	return result;
#line 35101 "Photo.c"
}

static void
library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self,
                                                             GeeCollection* added,
                                                             GeeCollection* removed)
{
#line 4859 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4861 "../src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 35113 "Photo.c"
}

static gboolean
library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self,
                                                        DataSource* source,
                                                        Alteration* alteration)
{
	gboolean result = FALSE;
#line 4865 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4865 "../src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4865 "../src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4866 "../src/Photo.vala"
	result = media_source_is_offline ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4866 "../src/Photo.vala"
	return result;
#line 35132 "Photo.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 35155 "Photo.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 35164 "Photo.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 35183 "Photo.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 35187 "Photo.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 35193 "Photo.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 35203 "Photo.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 35211 "Photo.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 35215 "Photo.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 35221 "Photo.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 35231 "Photo.c"
}

static MediaSource*
library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base,
                                                         const gchar* source_id)
{
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gchar* numeric_only = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	MediaSource* _tmp3_;
#line 4869 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4869 "../src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4870 "../src/Photo.vala"
	_vala_assert (g_str_has_prefix (source_id, PHOTO_TYPENAME), "source_id.has_prefix (Photo.TYPENAME)");
#line 4871 "../src/Photo.vala"
	_tmp0_ = strlen (PHOTO_TYPENAME);
#line 4871 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4871 "../src/Photo.vala"
	_tmp2_ = string_substring (source_id, (glong) _tmp1_, (glong) -1);
#line 4871 "../src/Photo.vala"
	numeric_only = _tmp2_;
#line 4873 "../src/Photo.vala"
	_tmp3_ = media_source_collection_fetch_by_numeric_id ((MediaSourceCollection*) self, parse_int64 (numeric_only, 16));
#line 4873 "../src/Photo.vala"
	result = _tmp3_;
#line 4873 "../src/Photo.vala"
	_g_free0 (numeric_only);
#line 4873 "../src/Photo.vala"
	return result;
#line 35267 "Photo.c"
}

static GeeCollection*
library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                           EventID* event_id)
{
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
#line 4876 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4876 "../src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4877 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4877 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4877 "../src/Photo.vala"
	_tmp2_ = *event_id;
#line 4877 "../src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4877 "../src/Photo.vala"
	_tmp4_ = (GeeCollection*) _tmp3_;
#line 4877 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4877 "../src/Photo.vala"
	result = _tmp4_;
#line 4877 "../src/Photo.vala"
	return result;
#line 35301 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                       PhotoID* photo_id)
{
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	DataSource* _tmp1_;
#line 4880 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4880 "../src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4881 "../src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4881 "../src/Photo.vala"
	_tmp1_ = database_source_collection_fetch_by_key ((DatabaseSourceCollection*) self, _tmp0_.id);
#line 4881 "../src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4881 "../src/Photo.vala"
	return result;
#line 35323 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self,
                                                        GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4884 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4884 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4885 "../src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4885 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4885 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4885 "../src/Photo.vala"
	return result;
#line 35345 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self,
                                                               GFile* file)
{
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 4888 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4888 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4889 "../src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4889 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 4889 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp1_;
#line 4889 "../src/Photo.vala"
	return result;
#line 35367 "Photo.c"
}

static void
library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self,
                                                 LibraryPhoto* photo,
                                                 GFileInfo* info,
                                                 GeeCollection* matches_master,
                                                 GeeCollection* matches_editable,
                                                 GeeCollection* matches_development)
{
	BackingPhotoRow* _tmp0_;
	BackingPhotoRow* _tmp1_;
	gboolean _tmp2_;
	BackingPhotoRow* editable = NULL;
	BackingPhotoRow* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BackingPhotoRow* _tmp5_;
	GeeCollection* development = NULL;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
#line 4892 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4892 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4892 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4892 "../src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4892 "../src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4892 "../src/Photo.vala"
	g_return_if_fail (matches_development != NULL);
#line 4895 "../src/Photo.vala"
	_tmp0_ = photo_get_master_photo_row ((Photo*) photo);
#line 4895 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4895 "../src/Photo.vala"
	_tmp2_ = backing_photo_row_matches_file_info (_tmp1_, info);
#line 4895 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp1_);
#line 4895 "../src/Photo.vala"
	if (_tmp2_) {
#line 4896 "../src/Photo.vala"
		gee_collection_add (matches_master, photo);
#line 35412 "Photo.c"
	}
#line 4899 "../src/Photo.vala"
	_tmp3_ = photo_get_editable_photo_row ((Photo*) photo);
#line 4899 "../src/Photo.vala"
	editable = _tmp3_;
#line 4900 "../src/Photo.vala"
	_tmp5_ = editable;
#line 4900 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 35422 "Photo.c"
		BackingPhotoRow* _tmp6_;
#line 4900 "../src/Photo.vala"
		_tmp6_ = editable;
#line 4900 "../src/Photo.vala"
		_tmp4_ = backing_photo_row_matches_file_info (_tmp6_, info);
#line 35428 "Photo.c"
	} else {
#line 4900 "../src/Photo.vala"
		_tmp4_ = FALSE;
#line 35432 "Photo.c"
	}
#line 4900 "../src/Photo.vala"
	if (_tmp4_) {
#line 4901 "../src/Photo.vala"
		gee_collection_add (matches_editable, photo);
#line 35438 "Photo.c"
	}
#line 4904 "../src/Photo.vala"
	_tmp7_ = photo_get_raw_development_photo_rows ((Photo*) photo);
#line 4904 "../src/Photo.vala"
	development = _tmp7_;
#line 4905 "../src/Photo.vala"
	_tmp8_ = development;
#line 4905 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 35448 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_;
#line 4906 "../src/Photo.vala"
			_tmp9_ = development;
#line 4906 "../src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 4906 "../src/Photo.vala"
			_row_it = _tmp10_;
#line 4906 "../src/Photo.vala"
			while (TRUE) {
#line 35461 "Photo.c"
				GeeIterator* _tmp11_;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				BackingPhotoRow* _tmp14_;
#line 4906 "../src/Photo.vala"
				_tmp11_ = _row_it;
#line 4906 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 4906 "../src/Photo.vala"
					break;
#line 35473 "Photo.c"
				}
#line 4906 "../src/Photo.vala"
				_tmp12_ = _row_it;
#line 4906 "../src/Photo.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 4906 "../src/Photo.vala"
				row = (BackingPhotoRow*) _tmp13_;
#line 4907 "../src/Photo.vala"
				_tmp14_ = row;
#line 4907 "../src/Photo.vala"
				if (backing_photo_row_matches_file_info (_tmp14_, info)) {
#line 4908 "../src/Photo.vala"
					gee_collection_add (matches_development, photo);
#line 4910 "../src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4910 "../src/Photo.vala"
					break;
#line 35491 "Photo.c"
				}
#line 4906 "../src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35495 "Photo.c"
			}
#line 4906 "../src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35499 "Photo.c"
		}
	}
#line 4892 "../src/Photo.vala"
	_g_object_unref0 (development);
#line 4892 "../src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 35506 "Photo.c"
}

void
library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self,
                                                           GFileInfo* info,
                                                           GeeCollection* matches_master,
                                                           GeeCollection* matches_editable,
                                                           GeeCollection* matched_development)
{
#line 4918 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4918 "../src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4918 "../src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4918 "../src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4918 "../src/Photo.vala"
	g_return_if_fail (matched_development != NULL);
#line 35526 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 4920 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4920 "../src/Photo.vala"
		_tmp1_ = g_file_info_get_size (info);
#line 4920 "../src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4920 "../src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4920 "../src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4920 "../src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4920 "../src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4920 "../src/Photo.vala"
		_photo_it = _tmp5_;
#line 4920 "../src/Photo.vala"
		while (TRUE) {
#line 35553 "Photo.c"
			GeeIterator* _tmp6_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			LibraryPhoto* _tmp9_;
#line 4920 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4920 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 4920 "../src/Photo.vala"
				break;
#line 35565 "Photo.c"
			}
#line 4920 "../src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4920 "../src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 4920 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 4921 "../src/Photo.vala"
			_tmp9_ = photo;
#line 4921 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp9_, info, matches_master, matches_editable, matched_development);
#line 4920 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 35579 "Photo.c"
		}
#line 4920 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 35583 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_;
		GeeIterator* _tmp13_;
#line 4924 "../src/Photo.vala"
		_tmp10_ = media_source_collection_get_offline_bin_contents ((MediaSourceCollection*) self);
#line 4924 "../src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 4924 "../src/Photo.vala"
		_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 4924 "../src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 4924 "../src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 4924 "../src/Photo.vala"
		_media_it = _tmp13_;
#line 4924 "../src/Photo.vala"
		while (TRUE) {
#line 35605 "Photo.c"
			GeeIterator* _tmp14_;
			MediaSource* media = NULL;
			GeeIterator* _tmp15_;
			gpointer _tmp16_;
			MediaSource* _tmp17_;
#line 4924 "../src/Photo.vala"
			_tmp14_ = _media_it;
#line 4924 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp14_)) {
#line 4924 "../src/Photo.vala"
				break;
#line 35617 "Photo.c"
			}
#line 4924 "../src/Photo.vala"
			_tmp15_ = _media_it;
#line 4924 "../src/Photo.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 4924 "../src/Photo.vala"
			media = (MediaSource*) _tmp16_;
#line 4925 "../src/Photo.vala"
			_tmp17_ = media;
#line 4925 "../src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_LIBRARY_PHOTO, LibraryPhoto), info, matches_master, matches_editable, matched_development);
#line 4924 "../src/Photo.vala"
			_g_object_unref0 (media);
#line 35631 "Photo.c"
		}
#line 4924 "../src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 35635 "Photo.c"
	}
}

void
library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize,
                                                                 PhotoID* result)
{
	PhotoID _tmp15_ = {0};
#line 4929 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4929 "../src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 35650 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 4930 "../src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4930 "../src/Photo.vala"
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
#line 4930 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4930 "../src/Photo.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 4930 "../src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4930 "../src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 4930 "../src/Photo.vala"
		_photo_it = _tmp4_;
#line 4930 "../src/Photo.vala"
		while (TRUE) {
#line 35674 "Photo.c"
			GeeIterator* _tmp5_;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			LibraryPhoto* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
#line 4930 "../src/Photo.vala"
			_tmp5_ = _photo_it;
#line 4930 "../src/Photo.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 4930 "../src/Photo.vala"
				break;
#line 35690 "Photo.c"
			}
#line 4930 "../src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4930 "../src/Photo.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 4930 "../src/Photo.vala"
			photo = (LibraryPhoto*) _tmp7_;
#line 4931 "../src/Photo.vala"
			_tmp8_ = photo;
#line 4931 "../src/Photo.vala"
			_tmp9_ = media_source_get_master_file ((MediaSource*) _tmp8_);
#line 4931 "../src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 4931 "../src/Photo.vala"
			_tmp11_ = g_file_get_basename (_tmp10_);
#line 4931 "../src/Photo.vala"
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
#line 4931 "../src/Photo.vala"
			_g_object_unref0 (_tmp10_);
#line 4931 "../src/Photo.vala"
			if (_tmp12_) {
#line 35712 "Photo.c"
				LibraryPhoto* _tmp13_;
				PhotoID _tmp14_ = {0};
#line 4932 "../src/Photo.vala"
				_tmp13_ = photo;
#line 4932 "../src/Photo.vala"
				photo_get_photo_id ((Photo*) _tmp13_, &_tmp14_);
#line 4932 "../src/Photo.vala"
				*result = _tmp14_;
#line 4932 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 4932 "../src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4932 "../src/Photo.vala"
				return;
#line 35727 "Photo.c"
			}
#line 4930 "../src/Photo.vala"
			_g_object_unref0 (photo);
#line 35731 "Photo.c"
		}
#line 4930 "../src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 35735 "Photo.c"
	}
#line 4936 "../src/Photo.vala"
	photo_id_init (&_tmp15_, PHOTO_ID_INVALID);
#line 4936 "../src/Photo.vala"
	*result = _tmp15_;
#line 4936 "../src/Photo.vala"
	return;
#line 35743 "Photo.c"
}

gboolean
library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self,
                                                                 const gchar* basename,
                                                                 gint64 filesize)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 4940 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4940 "../src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4941 "../src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
#line 4941 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 4941 "../src/Photo.vala"
	return result;
#line 35763 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4944 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4944 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4945 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4945 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4945 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4945 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4945 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4945 "../src/Photo.vala"
	photo = _tmp3_;
#line 4946 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4946 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 35797 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4947 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4947 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4947 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4947 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4947 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4947 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 35813 "Photo.c"
	}
#line 4951 "../src/Photo.vala"
	result = photo;
#line 4951 "../src/Photo.vala"
	return result;
#line 35819 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4954 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4954 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4955 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4955 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4955 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4955 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4955 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4955 "../src/Photo.vala"
	result = _tmp3_;
#line 4955 "../src/Photo.vala"
	return result;
#line 35849 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                     GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
#line 4958 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4958 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4959 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4959 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4959 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, file);
#line 4959 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4959 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4959 "../src/Photo.vala"
	photo = _tmp3_;
#line 4960 "../src/Photo.vala"
	_tmp4_ = photo;
#line 4960 "../src/Photo.vala"
	if (_tmp4_ == NULL) {
#line 35883 "Photo.c"
		MediaSourceHoldingTank* _tmp5_;
		LibraryPhotoSourceHoldingTank* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 4961 "../src/Photo.vala"
		_tmp5_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4961 "../src/Photo.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4961 "../src/Photo.vala"
		_tmp7_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp6_, file);
#line 4961 "../src/Photo.vala"
		_g_object_unref0 (photo);
#line 4961 "../src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4961 "../src/Photo.vala"
		_source_holding_tank_unref0 (_tmp6_);
#line 35899 "Photo.c"
	}
#line 4965 "../src/Photo.vala"
	result = photo;
#line 4965 "../src/Photo.vala"
	return result;
#line 35905 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                    const gchar* md5)
{
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSource* _tmp2_;
	LibraryPhoto* _tmp3_;
#line 4968 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4968 "../src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4969 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4969 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4969 "../src/Photo.vala"
	_tmp2_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, md5);
#line 4969 "../src/Photo.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4969 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4969 "../src/Photo.vala"
	result = _tmp3_;
#line 4969 "../src/Photo.vala"
	return result;
#line 35935 "Photo.c"
}

gint
library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self)
{
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_;
#line 4972 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 4973 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4973 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4973 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 4973 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4973 "../src/Photo.vala"
	result = _tmp2_;
#line 4973 "../src/Photo.vala"
	return result;
#line 35959 "Photo.c"
}

LibraryPhoto*
library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                   GFile* file,
                                                   LibraryPhotoSourceCollectionState* state)
{
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSource* _tmp0_;
	LibraryPhoto* _tmp1_;
	LibraryPhoto* _tmp2_;
	LibraryPhoto* _tmp3_;
	LibraryPhoto* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	LibraryPhoto* _tmp7_;
	LibraryPhoto* _tmp8_;
	LibraryPhoto* _tmp9_;
	LibraryPhoto* _tmp10_;
	LibraryPhoto* _tmp11_;
#line 4976 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4976 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4977 "../src/Photo.vala"
	_tmp0_ = media_source_collection_fetch_by_master_file ((MediaSourceCollection*) self, file);
#line 4977 "../src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4978 "../src/Photo.vala"
	_tmp1_ = photo;
#line 4978 "../src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 4979 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4981 "../src/Photo.vala"
		result = photo;
#line 4981 "../src/Photo.vala"
		if (state) {
#line 4981 "../src/Photo.vala"
			*state = _vala_state;
#line 36002 "Photo.c"
		}
#line 4981 "../src/Photo.vala"
		return result;
#line 36006 "Photo.c"
	}
#line 4984 "../src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch_by_editable_file (self, file);
#line 4984 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4984 "../src/Photo.vala"
	photo = _tmp2_;
#line 4985 "../src/Photo.vala"
	_tmp3_ = photo;
#line 4985 "../src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 4986 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4988 "../src/Photo.vala"
		result = photo;
#line 4988 "../src/Photo.vala"
		if (state) {
#line 4988 "../src/Photo.vala"
			*state = _vala_state;
#line 36026 "Photo.c"
		}
#line 4988 "../src/Photo.vala"
		return result;
#line 36030 "Photo.c"
	}
#line 4991 "../src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_raw_development_file (self, file);
#line 4991 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4991 "../src/Photo.vala"
	photo = _tmp4_;
#line 4992 "../src/Photo.vala"
	_tmp5_ = photo;
#line 4992 "../src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4993 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4995 "../src/Photo.vala"
		result = photo;
#line 4995 "../src/Photo.vala"
		if (state) {
#line 4995 "../src/Photo.vala"
			*state = _vala_state;
#line 36050 "Photo.c"
		}
#line 4995 "../src/Photo.vala"
		return result;
#line 36054 "Photo.c"
	}
#line 4998 "../src/Photo.vala"
	_tmp6_ = library_photo_source_collection_get_trashed_by_file (self, file);
#line 4998 "../src/Photo.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp6_) : NULL;
#line 4998 "../src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4998 "../src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 36064 "Photo.c"
	}
#line 4998 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 4998 "../src/Photo.vala"
	photo = _tmp7_;
#line 4999 "../src/Photo.vala"
	_tmp8_ = photo;
#line 4999 "../src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 5000 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 5002 "../src/Photo.vala"
		result = photo;
#line 5002 "../src/Photo.vala"
		if (state) {
#line 5002 "../src/Photo.vala"
			*state = _vala_state;
#line 36082 "Photo.c"
		}
#line 5002 "../src/Photo.vala"
		return result;
#line 36086 "Photo.c"
	}
#line 5005 "../src/Photo.vala"
	_tmp9_ = library_photo_source_collection_get_offline_by_file (self, file);
#line 5005 "../src/Photo.vala"
	_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 5005 "../src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 5005 "../src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 36096 "Photo.c"
	}
#line 5005 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 5005 "../src/Photo.vala"
	photo = _tmp10_;
#line 5006 "../src/Photo.vala"
	_tmp11_ = photo;
#line 5006 "../src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 5007 "../src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 5009 "../src/Photo.vala"
		result = photo;
#line 5009 "../src/Photo.vala"
		if (state) {
#line 5009 "../src/Photo.vala"
			*state = _vala_state;
#line 36114 "Photo.c"
		}
#line 5009 "../src/Photo.vala"
		return result;
#line 36118 "Photo.c"
	}
#line 5012 "../src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 5014 "../src/Photo.vala"
	result = NULL;
#line 5014 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 5014 "../src/Photo.vala"
	if (state) {
#line 5014 "../src/Photo.vala"
		*state = _vala_state;
#line 36130 "Photo.c"
	}
#line 5014 "../src/Photo.vala"
	return result;
#line 36134 "Photo.c"
}

static gboolean
library_photo_source_collection_real_has_backlink (SourceCollection* base,
                                                   SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	gboolean _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSourceHoldingTank* _tmp4_;
	gboolean _tmp5_;
#line 5017 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 5017 "../src/Photo.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 5018 "../src/Photo.vala"
	if (SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink)) {
#line 5019 "../src/Photo.vala"
		result = TRUE;
#line 5019 "../src/Photo.vala"
		return result;
#line 36159 "Photo.c"
	}
#line 5022 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 5022 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5022 "../src/Photo.vala"
	_tmp2_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 5022 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 5022 "../src/Photo.vala"
	if (_tmp2_) {
#line 5023 "../src/Photo.vala"
		result = TRUE;
#line 5023 "../src/Photo.vala"
		return result;
#line 36175 "Photo.c"
	}
#line 5026 "../src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 5026 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5026 "../src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp4_, backlink);
#line 5026 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 5026 "../src/Photo.vala"
	if (_tmp5_) {
#line 5027 "../src/Photo.vala"
		result = TRUE;
#line 5027 "../src/Photo.vala"
		return result;
#line 36191 "Photo.c"
	}
#line 5030 "../src/Photo.vala"
	result = FALSE;
#line 5030 "../src/Photo.vala"
	return result;
#line 36197 "Photo.c"
}

static void
library_photo_source_collection_real_remove_backlink (SourceCollection* base,
                                                      SourceBacklink* backlink)
{
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
#line 5033 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 5033 "../src/Photo.vala"
	g_return_if_fail (backlink != NULL);
#line 5034 "../src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 5034 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5034 "../src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp1_, backlink);
#line 5034 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 5035 "../src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 5035 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5035 "../src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp3_, backlink);
#line 5035 "../src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 5037 "../src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), backlink);
#line 36231 "Photo.c"
}

static TransactionController*
library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 4528 "../src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4529 "../src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4529 "../src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 36247 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 4530 "../src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new ((MediaSourceCollection*) self);
#line 4530 "../src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4530 "../src/Photo.vala"
		self->priv->_transaction_controller = (TransactionController*) _tmp1_;
#line 36255 "Photo.c"
	}
#line 4533 "../src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4533 "../src/Photo.vala"
	result = _tmp2_;
#line 4533 "../src/Photo.vala"
	return result;
#line 36263 "Photo.c"
}

static void
library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4551 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 36273 "Photo.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4517 "../src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4517 "../src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4517 "../src/Photo.vala"
		data1 = closure->data;
#line 4517 "../src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 36298 "Photo.c"
	} else {
#line 4517 "../src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4517 "../src/Photo.vala"
		data2 = closure->data;
#line 36304 "Photo.c"
	}
#line 4517 "../src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4517 "../src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 36310 "Photo.c"
}

static void
library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4554 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 36320 "Photo.c"
}

static void
library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self,
                                                          LibraryPhoto* photo,
                                                          PhotoMetadata* metadata)
{
#line 4557 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 36330 "Photo.c"
}

static void
library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self,
                                                        LibraryPhoto* photo,
                                                        PhotoMetadata* metadata)
{
#line 4560 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 36340 "Photo.c"
}

static void
library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass,
                                            gpointer klass_data)
{
#line 4517 "../src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4517 "../src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4517 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceCollection_private_offset);
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4517 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4517 "../src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4517 "../src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*) (MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*) (LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*) (MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4517 "../src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4517 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4517 "../src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*) (SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4517 "../src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4517 "../src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4517 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_MASTER_REIMPORTED_SIGNAL] = g_signal_new ("master-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4517 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_EDITABLE_REIMPORTED_SIGNAL] = g_signal_new ("editable-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4517 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_BASELINE_REIMPORTED_SIGNAL] = g_signal_new ("baseline-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4517 "../src/Photo.vala"
	library_photo_source_collection_signals[LIBRARY_PHOTO_SOURCE_COLLECTION_SOURCE_REIMPORTED_SIGNAL] = g_signal_new ("source-reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 36407 "Photo.c"
}

static void
library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self,
                                               gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
#line 4517 "../src/Photo.vala"
	self->priv = library_photo_source_collection_get_instance_private (self);
#line 4537 "../src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4538 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4538 "../src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4540 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4540 "../src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4542 "../src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4542 "../src/Photo.vala"
	self->priv->filesize_to_photo = (GeeMultiMap*) _tmp2_;
#line 4544 "../src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4544 "../src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4546 "../src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4546 "../src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4548 "../src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4548 "../src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = (GeeMultiMap*) _tmp5_;
#line 36448 "Photo.c"
}

static void
library_photo_source_collection_finalize (DataCollection * obj)
{
	LibraryPhotoSourceCollection * self;
#line 4517 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4537 "../src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4538 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4540 "../src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4542 "../src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4544 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4546 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4548 "../src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4517 "../src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 36473 "Photo.c"
}

GType
library_photo_source_collection_get_type (void)
{
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		LibraryPhotoSourceCollection_private_offset = g_type_add_instance_private (library_photo_source_collection_type_id, sizeof (LibraryPhotoSourceCollectionPrivate));
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}

static inline gpointer
library_photo_get_instance_private (LibraryPhoto* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhoto_private_offset);
}

static void
_library_photo_generate_thumbnails_one_shot_callback (gpointer self)
{
#line 5065 "../src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 36501 "Photo.c"
}

static LibraryPhoto*
library_photo_construct (GType object_type,
                         PhotoRow* row)
{
	LibraryPhoto * self = NULL;
	OneShotScheduler* _tmp0_;
#line 5060 "../src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 5061 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, row);
#line 5063 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5063 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 5065 "../src/Photo.vala"
	_tmp0_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5065 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5065 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp0_;
#line 5068 "../src/Photo.vala"
	if ((row->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 36526 "Photo.c"
		LibraryPhotoSourceCollection* _tmp1_;
		const gchar* _tmp2_;
#line 5069 "../src/Photo.vala"
		_tmp1_ = library_photo_global;
#line 5069 "../src/Photo.vala"
		_tmp2_ = row->backlinks;
#line 5069 "../src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp1_, _tmp2_);
#line 36535 "Photo.c"
	}
#line 5060 "../src/Photo.vala"
	return self;
#line 36539 "Photo.c"
}

static LibraryPhoto*
library_photo_new (PhotoRow* row)
{
#line 5060 "../src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 36547 "Photo.c"
}

static LibraryPhoto*
library_photo_construct_from_import_params (GType object_type,
                                            PhotoImportParams* import_params)
{
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow* _tmp4_;
#line 5073 "../src/Photo.vala"
	g_return_val_if_fail (import_params != NULL, NULL);
#line 5074 "../src/Photo.vala"
	_tmp0_ = import_params->row;
#line 5074 "../src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 5076 "../src/Photo.vala"
	_tmp1_ = import_params->keywords;
#line 5076 "../src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 5076 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5076 "../src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 5077 "../src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 5077 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5077 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 5080 "../src/Photo.vala"
	_tmp4_ = import_params->row;
#line 5080 "../src/Photo.vala"
	if ((_tmp4_->flags & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 36584 "Photo.c"
		LibraryPhotoSourceCollection* _tmp5_;
		PhotoRow* _tmp6_;
		const gchar* _tmp7_;
#line 5081 "../src/Photo.vala"
		_tmp5_ = library_photo_global;
#line 5081 "../src/Photo.vala"
		_tmp6_ = import_params->row;
#line 5081 "../src/Photo.vala"
		_tmp7_ = _tmp6_->backlinks;
#line 5081 "../src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp5_, _tmp7_);
#line 36596 "Photo.c"
	}
#line 5073 "../src/Photo.vala"
	return self;
#line 36600 "Photo.c"
}

static LibraryPhoto*
library_photo_new_from_import_params (PhotoImportParams* import_params)
{
#line 5073 "../src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 36608 "Photo.c"
}

void
library_photo_init (ProgressMonitor monitor,
                    gpointer monitor_target)
{
	LibraryPhotoSourceCollection* _tmp0_;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_;
	PhotoTable* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_;
	gint count = 0;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	LibraryPhotoSourceCollection* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_;
	GeeCollection* _tmp27_;
	LibraryPhotoSourceCollection* _tmp28_;
	GeeArrayList* _tmp29_;
	LibraryPhotoSourceCollection* _tmp30_;
	GeeArrayList* _tmp31_;
#line 5086 "../src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 5086 "../src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 5086 "../src/Photo.vala"
	library_photo_global = _tmp0_;
#line 5090 "../src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 5090 "../src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 5090 "../src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 5090 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5090 "../src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 5090 "../src/Photo.vala"
	all = _tmp4_;
#line 5091 "../src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5091 "../src/Photo.vala"
	all_photos = _tmp5_;
#line 5092 "../src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5092 "../src/Photo.vala"
	trashed_photos = _tmp6_;
#line 5093 "../src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 5093 "../src/Photo.vala"
	offline_photos = _tmp7_;
#line 5094 "../src/Photo.vala"
	_tmp8_ = all;
#line 5094 "../src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 5094 "../src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 5094 "../src/Photo.vala"
	count = _tmp10_;
#line 36677 "Photo.c"
	{
		gint ctr = 0;
#line 5095 "../src/Photo.vala"
		ctr = 0;
#line 36682 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 5095 "../src/Photo.vala"
			_tmp11_ = TRUE;
#line 5095 "../src/Photo.vala"
			while (TRUE) {
#line 36689 "Photo.c"
				PhotoRow* row = NULL;
				GeeArrayList* _tmp13_;
				gpointer _tmp14_;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp15_;
				LibraryPhoto* _tmp16_;
				guint64 flags = 0ULL;
				PhotoRow* _tmp17_;
#line 5095 "../src/Photo.vala"
				if (!_tmp11_) {
#line 36700 "Photo.c"
					gint _tmp12_;
#line 5095 "../src/Photo.vala"
					_tmp12_ = ctr;
#line 5095 "../src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 36706 "Photo.c"
				}
#line 5095 "../src/Photo.vala"
				_tmp11_ = FALSE;
#line 5095 "../src/Photo.vala"
				if (!(ctr < count)) {
#line 5095 "../src/Photo.vala"
					break;
#line 36714 "Photo.c"
				}
#line 5096 "../src/Photo.vala"
				_tmp13_ = all;
#line 5096 "../src/Photo.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, ctr);
#line 5096 "../src/Photo.vala"
				row = (PhotoRow*) _tmp14_;
#line 5097 "../src/Photo.vala"
				_tmp15_ = row;
#line 5097 "../src/Photo.vala"
				_tmp16_ = library_photo_new (_tmp15_);
#line 5097 "../src/Photo.vala"
				photo = _tmp16_;
#line 5098 "../src/Photo.vala"
				_tmp17_ = row;
#line 5098 "../src/Photo.vala"
				flags = _tmp17_->flags;
#line 5100 "../src/Photo.vala"
				if ((flags & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 36734 "Photo.c"
					GeeArrayList* _tmp18_;
					LibraryPhoto* _tmp19_;
#line 5101 "../src/Photo.vala"
					_tmp18_ = trashed_photos;
#line 5101 "../src/Photo.vala"
					_tmp19_ = photo;
#line 5101 "../src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 36743 "Photo.c"
				} else {
#line 5102 "../src/Photo.vala"
					if ((flags & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 36747 "Photo.c"
						GeeArrayList* _tmp20_;
						LibraryPhoto* _tmp21_;
#line 5103 "../src/Photo.vala"
						_tmp20_ = offline_photos;
#line 5103 "../src/Photo.vala"
						_tmp21_ = photo;
#line 5103 "../src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 36756 "Photo.c"
					} else {
						GeeArrayList* _tmp22_;
						LibraryPhoto* _tmp23_;
#line 5105 "../src/Photo.vala"
						_tmp22_ = all_photos;
#line 5105 "../src/Photo.vala"
						_tmp23_ = photo;
#line 5105 "../src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 36766 "Photo.c"
					}
				}
#line 5108 "../src/Photo.vala"
				if (monitor != NULL) {
#line 5109 "../src/Photo.vala"
					monitor ((guint64) ctr, (guint64) count, TRUE, monitor_target);
#line 36773 "Photo.c"
				}
#line 5095 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5095 "../src/Photo.vala"
				_photo_row_unref0 (row);
#line 36779 "Photo.c"
			}
		}
	}
#line 5113 "../src/Photo.vala"
	_tmp24_ = library_photo_global;
#line 5113 "../src/Photo.vala"
	_tmp25_ = all_photos;
#line 5113 "../src/Photo.vala"
	_tmp26_ = data_collection_add_many ((DataCollection*) _tmp24_, (GeeCollection*) _tmp25_, NULL, NULL);
#line 5113 "../src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 5113 "../src/Photo.vala"
	_g_object_unref0 (_tmp27_);
#line 5114 "../src/Photo.vala"
	_tmp28_ = library_photo_global;
#line 5114 "../src/Photo.vala"
	_tmp29_ = trashed_photos;
#line 5114 "../src/Photo.vala"
	media_source_collection_add_many_to_trash ((MediaSourceCollection*) _tmp28_, (GeeCollection*) _tmp29_);
#line 5115 "../src/Photo.vala"
	_tmp30_ = library_photo_global;
#line 5115 "../src/Photo.vala"
	_tmp31_ = offline_photos;
#line 5115 "../src/Photo.vala"
	media_source_collection_add_many_to_offline ((MediaSourceCollection*) _tmp30_, (GeeCollection*) _tmp31_);
#line 5085 "../src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 5085 "../src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 5085 "../src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 5085 "../src/Photo.vala"
	_g_object_unref0 (all);
#line 36813 "Photo.c"
}

void
library_photo_terminate (void)
{
}

ImportResult
library_photo_import_create (PhotoImportParams* params,
                             LibraryPhoto* * photo)
{
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_;
	PhotoTable* _tmp1_;
	PhotoRow* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	LibraryPhoto* _tmp5_;
#line 5125 "../src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 5127 "../src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 5127 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5127 "../src/Photo.vala"
	_tmp2_ = params->row;
#line 5127 "../src/Photo.vala"
	photo_table_add (_tmp1_, _tmp2_, &_tmp3_);
#line 5127 "../src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 5127 "../src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 5127 "../src/Photo.vala"
	photo_id = _tmp4_;
#line 5128 "../src/Photo.vala"
	if (photo_id_is_invalid (&photo_id)) {
#line 5129 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 5129 "../src/Photo.vala"
		_vala_photo = NULL;
#line 5131 "../src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 5131 "../src/Photo.vala"
		if (photo) {
#line 5131 "../src/Photo.vala"
			*photo = _vala_photo;
#line 36862 "Photo.c"
		} else {
#line 5131 "../src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 36866 "Photo.c"
		}
#line 5131 "../src/Photo.vala"
		return result;
#line 36870 "Photo.c"
	}
#line 5135 "../src/Photo.vala"
	_tmp5_ = library_photo_new_from_import_params (params);
#line 5135 "../src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 5135 "../src/Photo.vala"
	_vala_photo = _tmp5_;
#line 5137 "../src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 5137 "../src/Photo.vala"
	if (photo) {
#line 5137 "../src/Photo.vala"
		*photo = _vala_photo;
#line 36884 "Photo.c"
	} else {
#line 5137 "../src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 36888 "Photo.c"
	}
#line 5137 "../src/Photo.vala"
	return result;
#line 36892 "Photo.c"
}

void
library_photo_import_failed (LibraryPhoto* photo)
{
	GError* _inner_error0_ = NULL;
#line 5140 "../src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 36901 "Photo.c"
	{
		PhotoTable* _tmp0_;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
#line 5142 "../src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 5142 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5142 "../src/Photo.vala"
		photo_get_photo_id ((Photo*) photo, &_tmp2_);
#line 5142 "../src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
#line 5142 "../src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 5142 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5142 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 36920 "Photo.c"
				goto __catch241_database_error;
			}
#line 5142 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5142 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5142 "../src/Photo.vala"
			return;
#line 36929 "Photo.c"
		}
	}
	goto __finally241;
	__catch241_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
#line 5141 "../src/Photo.vala"
		err = _inner_error0_;
#line 5141 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5144 "../src/Photo.vala"
		_tmp3_ = err;
#line 5144 "../src/Photo.vala"
		app_window_database_error (_tmp3_);
#line 5141 "../src/Photo.vala"
		_g_error_free0 (err);
#line 36947 "Photo.c"
	}
	__finally241:
#line 5141 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5141 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5141 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5141 "../src/Photo.vala"
		return;
#line 36958 "Photo.c"
	}
}

static void
library_photo_real_notify_master_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5148 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5149 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5151 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5151 "../src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp0_, self, metadata);
#line 36976 "Photo.c"
}

static void
library_photo_real_notify_editable_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5154 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5155 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5157 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5157 "../src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp0_, self, metadata);
#line 36993 "Photo.c"
}

static void
library_photo_real_notify_source_reimported (Photo* base,
                                             PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5160 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5161 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5163 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5163 "../src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp0_, self, metadata);
#line 37010 "Photo.c"
}

static void
library_photo_real_notify_baseline_reimported (Photo* base,
                                               PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	LibraryPhotoSourceCollection* _tmp0_;
#line 5166 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5167 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), metadata);
#line 5169 "../src/Photo.vala"
	_tmp0_ = library_photo_global;
#line 5169 "../src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp0_, self, metadata);
#line 37027 "Photo.c"
}

static void
library_photo_generate_thumbnails (LibraryPhoto* self)
{
	GError* _inner_error0_ = NULL;
#line 5172 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 37036 "Photo.c"
	{
#line 5174 "../src/Photo.vala"
		thumbnail_cache_import_from_source ((ThumbnailSource*) self, TRUE, &_inner_error0_);
#line 5174 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37042 "Photo.c"
			goto __catch242_g_error;
		}
	}
	goto __finally242;
	__catch242_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5173 "../src/Photo.vala"
		err = _inner_error0_;
#line 5173 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5176 "../src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 5176 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5176 "../src/Photo.vala"
		_tmp2_ = err;
#line 5176 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5176 "../src/Photo.vala"
		g_warning ("Photo.vala:5176: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5176 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5173 "../src/Photo.vala"
		_g_error_free0 (err);
#line 37072 "Photo.c"
	}
	__finally242:
#line 5173 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5173 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5173 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5173 "../src/Photo.vala"
		return;
#line 37083 "Photo.c"
	}
#line 5180 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 37087 "Photo.c"
}

GeeCollection*
library_photo_get_import_keywords (LibraryPhoto* self)
{
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 5184 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5185 "../src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5185 "../src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5185 "../src/Photo.vala"
	result = _tmp1_;
#line 5185 "../src/Photo.vala"
	return result;
#line 37106 "Photo.c"
}

void
library_photo_clear_import_keywords (LibraryPhoto* self)
{
#line 5188 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5189 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5189 "../src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 37118 "Photo.c"
}

static void
library_photo_real_notify_altered (DataObject* base,
                                   Alteration* alteration)
{
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
#line 5192 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5192 "../src/Photo.vala"
	g_return_if_fail (alteration != NULL);
#line 5194 "../src/Photo.vala"
	if (!self->priv->block_thumbnail_generation) {
#line 5194 "../src/Photo.vala"
		_tmp0_ = alteration_has_subject (alteration, "image");
#line 37135 "Photo.c"
	} else {
#line 5194 "../src/Photo.vala"
		_tmp0_ = FALSE;
#line 37139 "Photo.c"
	}
#line 5194 "../src/Photo.vala"
	if (_tmp0_) {
#line 37143 "Photo.c"
		OneShotScheduler* _tmp1_;
#line 5195 "../src/Photo.vala"
		_tmp1_ = self->priv->thumbnail_scheduler;
#line 5195 "../src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp1_, G_PRIORITY_LOW);
#line 37149 "Photo.c"
	}
#line 5197 "../src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), alteration);
#line 37153 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_preview_pixbuf (MediaSource* base,
                                       Scaling* scaling,
                                       GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 5200 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5200 "../src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5201 "../src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) self, (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
#line 5201 "../src/Photo.vala"
	pixbuf = _tmp0_;
#line 5201 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5201 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5201 "../src/Photo.vala"
		return NULL;
#line 37181 "Photo.c"
	}
#line 5203 "../src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5203 "../src/Photo.vala"
	result = _tmp1_;
#line 5203 "../src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5203 "../src/Photo.vala"
	return result;
#line 37191 "Photo.c"
}

static void
library_photo_real_rotate (Photo* base,
                           Rotation rotation)
{
	LibraryPhoto * self;
	GError* _inner_error0_ = NULL;
#line 5206 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5208 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5209 "../src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), rotation);
#line 5210 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 37208 "Photo.c"
	{
#line 5218 "../src/Photo.vala"
		thumbnail_cache_rotate ((ThumbnailSource*) self, rotation, &_inner_error0_);
#line 5218 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37214 "Photo.c"
			goto __catch243_g_error;
		}
	}
	goto __finally243;
	__catch243_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 5217 "../src/Photo.vala"
		err = _inner_error0_;
#line 5217 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5221 "../src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 5221 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5221 "../src/Photo.vala"
		_tmp2_ = err;
#line 5221 "../src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 5221 "../src/Photo.vala"
		g_warning ("Photo.vala:5221: Unable to update thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 5221 "../src/Photo.vala"
		_g_free0 (_tmp1_);
#line 5217 "../src/Photo.vala"
		_g_error_free0 (err);
#line 37244 "Photo.c"
	}
	__finally243:
#line 5217 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5217 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5217 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5217 "../src/Photo.vala"
		return;
#line 37255 "Photo.c"
	}
#line 5224 "../src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 37259 "Photo.c"
}

static GdkPixbuf*
library_photo_real_get_thumbnail (ThumbnailSource* base,
                                  gint scale,
                                  GError** error)
{
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 5228 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5229 "../src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch ((ThumbnailSource*) self, scale, &_inner_error0_);
#line 5229 "../src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5229 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5229 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5229 "../src/Photo.vala"
		return NULL;
#line 37285 "Photo.c"
	}
#line 5229 "../src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 5229 "../src/Photo.vala"
	_tmp0_ = NULL;
#line 5229 "../src/Photo.vala"
	result = _tmp2_;
#line 5229 "../src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5229 "../src/Photo.vala"
	return result;
#line 37297 "Photo.c"
}

static void
_library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes,
                                                              gint64 total_num_bytes,
                                                              gpointer self)
{
#line 5242 "../src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 37307 "Photo.c"
}

static void
library_photo_duplicate_backing_photo (LibraryPhoto* self,
                                       BackingPhotoRow* backing,
                                       BackingPhotoID* result,
                                       GError** error)
{
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	GFile* file = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 5234 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5235 "../src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5236 "../src/Photo.vala"
	if (backing == NULL) {
#line 5236 "../src/Photo.vala"
		_tmp0_ = TRUE;
#line 37331 "Photo.c"
	} else {
		const gchar* _tmp1_;
#line 5236 "../src/Photo.vala"
		_tmp1_ = backing->filepath;
#line 5236 "../src/Photo.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 37338 "Photo.c"
	}
#line 5236 "../src/Photo.vala"
	if (_tmp0_) {
#line 5237 "../src/Photo.vala"
		*result = backing_id;
#line 5237 "../src/Photo.vala"
		return;
#line 37346 "Photo.c"
	}
#line 5240 "../src/Photo.vala"
	_tmp2_ = backing->filepath;
#line 5240 "../src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 5240 "../src/Photo.vala"
	file = _tmp3_;
#line 5241 "../src/Photo.vala"
	_tmp4_ = file;
#line 5241 "../src/Photo.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 37358 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp7_;
		DetectedPhotoInformation* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_;
		BackingPhotoRow* _tmp10_;
#line 5242 "../src/Photo.vala"
		_tmp5_ = file;
#line 5242 "../src/Photo.vala"
		_tmp6_ = library_files_duplicate (_tmp5_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5242 "../src/Photo.vala"
		dupe_file = _tmp6_;
#line 5242 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5242 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5242 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5242 "../src/Photo.vala"
			return;
#line 37382 "Photo.c"
		}
#line 5245 "../src/Photo.vala"
		_tmp7_ = dupe_file;
#line 5245 "../src/Photo.vala"
		_tmp9_ = photo_query_backing_photo_row ((Photo*) self, _tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp8_, &_inner_error0_);
#line 5245 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5245 "../src/Photo.vala"
		detected = _tmp8_;
#line 5245 "../src/Photo.vala"
		state = _tmp9_;
#line 5245 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5245 "../src/Photo.vala"
			g_propagate_error (error, _inner_error0_);
#line 5245 "../src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5245 "../src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5245 "../src/Photo.vala"
			_g_object_unref0 (file);
#line 5245 "../src/Photo.vala"
			return;
#line 37406 "Photo.c"
		}
#line 5247 "../src/Photo.vala"
		_tmp10_ = state;
#line 5247 "../src/Photo.vala"
		if (_tmp10_ != NULL) {
#line 37412 "Photo.c"
			BackingPhotoTable* _tmp11_;
			BackingPhotoTable* _tmp12_;
			BackingPhotoRow* _tmp13_;
			BackingPhotoRow* _tmp14_;
			BackingPhotoID _tmp15_;
#line 5248 "../src/Photo.vala"
			_tmp11_ = backing_photo_table_get_instance ();
#line 5248 "../src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 5248 "../src/Photo.vala"
			_tmp13_ = state;
#line 5248 "../src/Photo.vala"
			backing_photo_table_add (_tmp12_, _tmp13_, &_inner_error0_);
#line 5248 "../src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 5248 "../src/Photo.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5248 "../src/Photo.vala"
				g_propagate_error (error, _inner_error0_);
#line 5248 "../src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5248 "../src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5248 "../src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5248 "../src/Photo.vala"
				_g_object_unref0 (file);
#line 5248 "../src/Photo.vala"
				return;
#line 37442 "Photo.c"
			}
#line 5249 "../src/Photo.vala"
			_tmp14_ = state;
#line 5249 "../src/Photo.vala"
			_tmp15_ = _tmp14_->id;
#line 5249 "../src/Photo.vala"
			backing_id = _tmp15_;
#line 37450 "Photo.c"
		}
#line 5241 "../src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5241 "../src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5241 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 37458 "Photo.c"
	}
#line 5253 "../src/Photo.vala"
	*result = backing_id;
#line 5253 "../src/Photo.vala"
	_g_object_unref0 (file);
#line 5253 "../src/Photo.vala"
	return;
#line 37466 "Photo.c"
}

LibraryPhoto*
library_photo_duplicate (LibraryPhoto* self,
                         GError** error)
{
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_;
	BackingPhotoRow* _tmp5_;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_;
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_;
	BackingPhotoRow* _tmp9_;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_;
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_;
	BackingPhotoRow* _tmp13_;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_;
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_;
	BackingPhotoRow* _tmp17_;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_;
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_;
	PhotoTable* _tmp21_;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BackingPhotoID _tmp26_;
	BackingPhotoID _tmp27_;
	BackingPhotoID _tmp28_;
	BackingPhotoID _tmp29_;
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_;
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_;
	PhotoTable* _tmp33_;
	PhotoID _tmp34_;
	PhotoRow* _tmp35_;
	PhotoRow* _tmp36_;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_;
	LibraryPhoto* _tmp38_;
	LibraryPhoto* _tmp39_;
	LibraryPhotoSourceCollection* _tmp40_;
	LibraryPhoto* _tmp41_;
	LibraryPhoto* _tmp42_;
	Event* _tmp43_;
	Event* _tmp44_;
	gboolean _tmp45_;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_;
	GeeList* _tmp51_;
	GeeCollection* _tmp52_;
	GError* _inner_error0_ = NULL;
#line 5256 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5258 "../src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 5258 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5258 "../src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error0_);
#line 5258 "../src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5258 "../src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5258 "../src/Photo.vala"
	dupe_file = _tmp3_;
#line 5258 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5258 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5258 "../src/Photo.vala"
		return NULL;
#line 37553 "Photo.c"
	}
#line 5261 "../src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row ((Photo*) self);
#line 5261 "../src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5261 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error0_);
#line 5261 "../src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5261 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5261 "../src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5261 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5261 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5261 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5261 "../src/Photo.vala"
		return NULL;
#line 37575 "Photo.c"
	}
#line 5262 "../src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_SHOTWELL);
#line 5262 "../src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5262 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error0_);
#line 5262 "../src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5262 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5262 "../src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5262 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5262 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5262 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5262 "../src/Photo.vala"
		return NULL;
#line 37597 "Photo.c"
	}
#line 5264 "../src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_CAMERA);
#line 5264 "../src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5264 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error0_);
#line 5264 "../src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5264 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5264 "../src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5264 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5264 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5264 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5264 "../src/Photo.vala"
		return NULL;
#line 37619 "Photo.c"
	}
#line 5266 "../src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_EMBEDDED);
#line 5266 "../src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5266 "../src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error0_);
#line 5266 "../src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5266 "../src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5266 "../src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5266 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5266 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5266 "../src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5266 "../src/Photo.vala"
		return NULL;
#line 37641 "Photo.c"
	}
#line 5270 "../src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5270 "../src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5270 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp22_);
#line 5270 "../src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5270 "../src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5270 "../src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5270 "../src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5270 "../src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5270 "../src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5270 "../src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5270 "../src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5270 "../src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5270 "../src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5270 "../src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5270 "../src/Photo.vala"
	dupe_id = _tmp31_;
#line 5272 "../src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5272 "../src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5272 "../src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5272 "../src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5272 "../src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5272 "../src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5272 "../src/Photo.vala"
	dupe_row = _tmp36_;
#line 5275 "../src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5275 "../src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5275 "../src/Photo.vala"
	dupe = _tmp38_;
#line 5278 "../src/Photo.vala"
	_tmp39_ = dupe;
#line 5278 "../src/Photo.vala"
	thumbnail_cache_duplicate ((ThumbnailSource*) self, (ThumbnailSource*) _tmp39_);
#line 5281 "../src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5281 "../src/Photo.vala"
	_tmp41_ = dupe;
#line 5281 "../src/Photo.vala"
	data_collection_add ((DataCollection*) _tmp40_, (DataObject*) _tmp41_);
#line 5284 "../src/Photo.vala"
	_tmp42_ = dupe;
#line 5284 "../src/Photo.vala"
	_tmp43_ = media_source_get_event ((MediaSource*) _tmp42_);
#line 5284 "../src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5284 "../src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5284 "../src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5284 "../src/Photo.vala"
	if (_tmp45_) {
#line 37715 "Photo.c"
		LibraryPhoto* _tmp46_;
		Event* _tmp47_;
		Event* _tmp48_;
		LibraryPhoto* _tmp49_;
#line 5285 "../src/Photo.vala"
		_tmp46_ = dupe;
#line 5285 "../src/Photo.vala"
		_tmp47_ = media_source_get_event ((MediaSource*) _tmp46_);
#line 5285 "../src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5285 "../src/Photo.vala"
		_tmp49_ = dupe;
#line 5285 "../src/Photo.vala"
		event_attach (_tmp48_, (MediaSource*) _tmp49_);
#line 5285 "../src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 37732 "Photo.c"
	}
#line 5288 "../src/Photo.vala"
	_tmp50_ = tag_global;
#line 5288 "../src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, (MediaSource*) self);
#line 5288 "../src/Photo.vala"
	tags = (GeeCollection*) _tmp51_;
#line 5289 "../src/Photo.vala"
	_tmp52_ = tags;
#line 5289 "../src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 37744 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
#line 5290 "../src/Photo.vala"
			_tmp53_ = tags;
#line 5290 "../src/Photo.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 5290 "../src/Photo.vala"
			_tag_it = _tmp54_;
#line 5290 "../src/Photo.vala"
			while (TRUE) {
#line 37757 "Photo.c"
				GeeIterator* _tmp55_;
				Tag* tag = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				Tag* _tmp58_;
				LibraryPhoto* _tmp59_;
#line 5290 "../src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5290 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp55_)) {
#line 5290 "../src/Photo.vala"
					break;
#line 37770 "Photo.c"
				}
#line 5290 "../src/Photo.vala"
				_tmp56_ = _tag_it;
#line 5290 "../src/Photo.vala"
				_tmp57_ = gee_iterator_get (_tmp56_);
#line 5290 "../src/Photo.vala"
				tag = (Tag*) _tmp57_;
#line 5291 "../src/Photo.vala"
				_tmp58_ = tag;
#line 5291 "../src/Photo.vala"
				_tmp59_ = dupe;
#line 5291 "../src/Photo.vala"
				tag_attach (_tmp58_, (MediaSource*) _tmp59_);
#line 5290 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 37786 "Photo.c"
			}
#line 5290 "../src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 37790 "Photo.c"
		}
	}
#line 5295 "../src/Photo.vala"
	result = dupe;
#line 5295 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5295 "../src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5295 "../src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5295 "../src/Photo.vala"
	return result;
#line 37803 "Photo.c"
}

static void
library_photo_on_duplicate_progress (LibraryPhoto* self,
                                     gint64 current,
                                     gint64 total)
{
#line 5298 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5299 "../src/Photo.vala"
	spin_event_loop ();
#line 37815 "Photo.c"
}

static gboolean
library_photo_real_is_trashed (MediaSource* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5303 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5304 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH);
#line 5304 "../src/Photo.vala"
	return result;
#line 37829 "Photo.c"
}

static void
library_photo_real_trash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5307 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5308 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 37840 "Photo.c"
}

static void
library_photo_real_untrash (MediaSource* base)
{
	LibraryPhoto * self;
#line 5311 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5312 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 37851 "Photo.c"
}

static gboolean
library_photo_real_is_offline (Monitorable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5315 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5316 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5316 "../src/Photo.vala"
	return result;
#line 37865 "Photo.c"
}

static void
library_photo_real_mark_offline (Monitorable* base)
{
	LibraryPhoto * self;
#line 5319 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5320 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 37876 "Photo.c"
}

static void
library_photo_real_mark_online (Monitorable* base)
{
	LibraryPhoto * self;
#line 5323 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5324 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 37887 "Photo.c"
}

static gboolean
library_photo_real_is_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
#line 5327 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5328 "../src/Photo.vala"
	result = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5328 "../src/Photo.vala"
	return result;
#line 37901 "Photo.c"
}

static void
library_photo_real_mark_flagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5331 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5332 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5332 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5332 "../src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5332 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 37920 "Photo.c"
}

static void
library_photo_real_mark_unflagged (Flaggable* base)
{
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 5335 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5336 "../src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5336 "../src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5336 "../src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5336 "../src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 37939 "Photo.c"
}

static gboolean
library_photo_real_internal_delete_backing (DataSource* base,
                                            GError** error)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 5339 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5342 "../src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_inner_error0_);
#line 5342 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 37956 "Photo.c"
		gboolean _tmp1_ = FALSE;
#line 5342 "../src/Photo.vala"
		g_propagate_error (error, _inner_error0_);
#line 5342 "../src/Photo.vala"
		return _tmp1_;
#line 37962 "Photo.c"
	}
#line 5342 "../src/Photo.vala"
	if (!_tmp0_) {
#line 5343 "../src/Photo.vala"
		result = FALSE;
#line 5343 "../src/Photo.vala"
		return result;
#line 37970 "Photo.c"
	}
#line 5346 "../src/Photo.vala"
	result = media_source_delete_original_file ((MediaSource*) self);
#line 5346 "../src/Photo.vala"
	return result;
#line 37976 "Photo.c"
}

static void
library_photo_real_destroy (DataSource* base)
{
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
#line 5349 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5350 "../src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp0_);
#line 5350 "../src/Photo.vala"
	photo_id = _tmp0_;
#line 5353 "../src/Photo.vala"
	thumbnail_cache_remove ((ThumbnailSource*) self);
#line 37994 "Photo.c"
	{
		PhotoTable* _tmp1_;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 5359 "../src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5359 "../src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5359 "../src/Photo.vala"
		_tmp3_ = photo_id;
#line 5359 "../src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
#line 5359 "../src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5359 "../src/Photo.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5359 "../src/Photo.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 38013 "Photo.c"
				goto __catch244_database_error;
			}
#line 5359 "../src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5359 "../src/Photo.vala"
			g_clear_error (&_inner_error0_);
#line 5359 "../src/Photo.vala"
			return;
#line 38022 "Photo.c"
		}
	}
	goto __finally244;
	__catch244_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 5358 "../src/Photo.vala"
		err = _inner_error0_;
#line 5358 "../src/Photo.vala"
		_inner_error0_ = NULL;
#line 5361 "../src/Photo.vala"
		_tmp4_ = err;
#line 5361 "../src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5358 "../src/Photo.vala"
		_g_error_free0 (err);
#line 38040 "Photo.c"
	}
	__finally244:
#line 5358 "../src/Photo.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5358 "../src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 5358 "../src/Photo.vala"
		g_clear_error (&_inner_error0_);
#line 5358 "../src/Photo.vala"
		return;
#line 38051 "Photo.c"
	}
#line 5364 "../src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 38055 "Photo.c"
}

gboolean
library_photo_has_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format)
{
	gboolean result = FALSE;
	PhotoID _tmp0_ = {0};
#line 5369 "../src/Photo.vala"
	library_photo_get_nontrash_duplicate (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5369 "../src/Photo.vala"
	result = photo_id_is_valid (&_tmp0_);
#line 5369 "../src/Photo.vala"
	return result;
#line 38072 "Photo.c"
}

void
library_photo_get_nontrash_duplicate (GFile* file,
                                      const gchar* thumbnail_md5,
                                      const gchar* full_md5,
                                      PhotoFileFormat file_format,
                                      PhotoID* result)
{
	PhotoID* ids = NULL;
	gint _tmp0_ = 0;
	PhotoID* _tmp1_;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp2_ = FALSE;
	PhotoID* _tmp3_;
	gint _tmp3__length1;
	PhotoID* _tmp6_;
	gint _tmp6__length1;
	PhotoID _tmp13_ = {0};
#line 5374 "../src/Photo.vala"
	_tmp1_ = photo_get_duplicate_ids (file, thumbnail_md5, full_md5, file_format, &_tmp0_);
#line 5374 "../src/Photo.vala"
	ids = _tmp1_;
#line 5374 "../src/Photo.vala"
	ids_length1 = _tmp0_;
#line 5374 "../src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5376 "../src/Photo.vala"
	_tmp3_ = ids;
#line 5376 "../src/Photo.vala"
	_tmp3__length1 = ids_length1;
#line 5376 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 5376 "../src/Photo.vala"
		_tmp2_ = TRUE;
#line 38109 "Photo.c"
	} else {
		PhotoID* _tmp4_;
		gint _tmp4__length1;
#line 5376 "../src/Photo.vala"
		_tmp4_ = ids;
#line 5376 "../src/Photo.vala"
		_tmp4__length1 = ids_length1;
#line 5376 "../src/Photo.vala"
		_tmp2_ = _tmp4__length1 == 0;
#line 38119 "Photo.c"
	}
#line 5376 "../src/Photo.vala"
	if (_tmp2_) {
#line 38123 "Photo.c"
		PhotoID _tmp5_ = {0};
#line 5377 "../src/Photo.vala"
		photo_id_init (&_tmp5_, PHOTO_ID_INVALID);
#line 5377 "../src/Photo.vala"
		*result = _tmp5_;
#line 5377 "../src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5377 "../src/Photo.vala"
		return;
#line 38133 "Photo.c"
	}
#line 5380 "../src/Photo.vala"
	_tmp6_ = ids;
#line 5380 "../src/Photo.vala"
	_tmp6__length1 = ids_length1;
#line 38139 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5380 "../src/Photo.vala"
		id_collection = _tmp6_;
#line 5380 "../src/Photo.vala"
		id_collection_length1 = _tmp6__length1;
#line 5380 "../src/Photo.vala"
		for (id_it = 0; id_it < _tmp6__length1; id_it = id_it + 1) {
#line 38151 "Photo.c"
			PhotoID id = {0};
#line 5380 "../src/Photo.vala"
			id = id_collection[id_it];
#line 38155 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp7_;
				PhotoID _tmp8_;
				LibraryPhoto* _tmp9_;
				gboolean _tmp10_ = FALSE;
				LibraryPhoto* _tmp11_;
#line 5381 "../src/Photo.vala"
				_tmp7_ = library_photo_global;
#line 5381 "../src/Photo.vala"
				_tmp8_ = id;
#line 5381 "../src/Photo.vala"
				_tmp9_ = library_photo_source_collection_fetch (_tmp7_, &_tmp8_);
#line 5381 "../src/Photo.vala"
				photo = _tmp9_;
#line 5382 "../src/Photo.vala"
				_tmp11_ = photo;
#line 5382 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 38175 "Photo.c"
					LibraryPhoto* _tmp12_;
#line 5382 "../src/Photo.vala"
					_tmp12_ = photo;
#line 5382 "../src/Photo.vala"
					_tmp10_ = !media_source_is_trashed ((MediaSource*) _tmp12_);
#line 38181 "Photo.c"
				} else {
#line 5382 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 38185 "Photo.c"
				}
#line 5382 "../src/Photo.vala"
				if (_tmp10_) {
#line 5383 "../src/Photo.vala"
					*result = id;
#line 5383 "../src/Photo.vala"
					_g_object_unref0 (photo);
#line 5383 "../src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5383 "../src/Photo.vala"
					return;
#line 38197 "Photo.c"
				}
#line 5380 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 38201 "Photo.c"
			}
		}
	}
#line 5387 "../src/Photo.vala"
	photo_id_init (&_tmp13_, PHOTO_ID_INVALID);
#line 5387 "../src/Photo.vala"
	*result = _tmp13_;
#line 5387 "../src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5387 "../src/Photo.vala"
	return;
#line 38213 "Photo.c"
}

static gboolean
library_photo_real_has_user_generated_metadata (Photo* base)
{
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp9_;
	GeeSet* _tmp10_;
	gint _tmp11_ = 0;
	GeeList* _tmp12_;
	gint tags_count = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_;
	gint keywords_count = 0;
	gboolean _tmp21_ = FALSE;
	GeeList* _tmp22_;
#line 5390 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5391 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5391 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5391 "../src/Photo.vala"
	tags = _tmp1_;
#line 5393 "../src/Photo.vala"
	_tmp2_ = photo_source_get_metadata ((PhotoSource*) self);
#line 5393 "../src/Photo.vala"
	metadata = _tmp2_;
#line 5394 "../src/Photo.vala"
	_tmp3_ = metadata;
#line 5394 "../src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 38254 "Photo.c"
		gboolean _tmp4_ = FALSE;
		GeeList* _tmp5_;
#line 5395 "../src/Photo.vala"
		_tmp5_ = tags;
#line 5395 "../src/Photo.vala"
		if (_tmp5_ != NULL) {
#line 5395 "../src/Photo.vala"
			_tmp4_ = TRUE;
#line 38263 "Photo.c"
		} else {
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 5395 "../src/Photo.vala"
			_tmp6_ = tags;
#line 5395 "../src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5395 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5395 "../src/Photo.vala"
			_tmp4_ = _tmp8_ > 0;
#line 38276 "Photo.c"
		}
#line 5395 "../src/Photo.vala"
		result = _tmp4_;
#line 5395 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5395 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5395 "../src/Photo.vala"
		return result;
#line 38286 "Photo.c"
	}
#line 5398 "../src/Photo.vala"
	_tmp9_ = metadata;
#line 5398 "../src/Photo.vala"
	_tmp10_ = photo_metadata_get_keywords (_tmp9_, NULL, NULL, NULL);
#line 5398 "../src/Photo.vala"
	keywords = _tmp10_;
#line 5399 "../src/Photo.vala"
	_tmp12_ = tags;
#line 5399 "../src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 38298 "Photo.c"
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 5399 "../src/Photo.vala"
		_tmp13_ = tags;
#line 5399 "../src/Photo.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 5399 "../src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 5399 "../src/Photo.vala"
		_tmp11_ = _tmp15_;
#line 38310 "Photo.c"
	} else {
#line 5399 "../src/Photo.vala"
		_tmp11_ = 0;
#line 38314 "Photo.c"
	}
#line 5399 "../src/Photo.vala"
	tags_count = _tmp11_;
#line 5400 "../src/Photo.vala"
	_tmp17_ = keywords;
#line 5400 "../src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 38322 "Photo.c"
		GeeSet* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 5400 "../src/Photo.vala"
		_tmp18_ = keywords;
#line 5400 "../src/Photo.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 5400 "../src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 5400 "../src/Photo.vala"
		_tmp16_ = _tmp20_;
#line 38334 "Photo.c"
	} else {
#line 5400 "../src/Photo.vala"
		_tmp16_ = 0;
#line 38338 "Photo.c"
	}
#line 5400 "../src/Photo.vala"
	keywords_count = _tmp16_;
#line 5402 "../src/Photo.vala"
	if (tags_count != keywords_count) {
#line 5403 "../src/Photo.vala"
		result = TRUE;
#line 5403 "../src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5403 "../src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5403 "../src/Photo.vala"
		_g_object_unref0 (tags);
#line 5403 "../src/Photo.vala"
		return result;
#line 38354 "Photo.c"
	}
#line 5406 "../src/Photo.vala"
	_tmp22_ = tags;
#line 5406 "../src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 38360 "Photo.c"
		GeeSet* _tmp23_;
#line 5406 "../src/Photo.vala"
		_tmp23_ = keywords;
#line 5406 "../src/Photo.vala"
		_tmp21_ = _tmp23_ != NULL;
#line 38366 "Photo.c"
	} else {
#line 5406 "../src/Photo.vala"
		_tmp21_ = FALSE;
#line 38370 "Photo.c"
	}
#line 5406 "../src/Photo.vala"
	if (_tmp21_) {
#line 38374 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp24_;
			GeeList* _tmp25_;
			gint _tag_size = 0;
			GeeList* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gint _tag_index = 0;
#line 5407 "../src/Photo.vala"
			_tmp24_ = tags;
#line 5407 "../src/Photo.vala"
			_tmp25_ = _g_object_ref0 (_tmp24_);
#line 5407 "../src/Photo.vala"
			_tag_list = _tmp25_;
#line 5407 "../src/Photo.vala"
			_tmp26_ = _tag_list;
#line 5407 "../src/Photo.vala"
			_tmp27_ = gee_collection_get_size ((GeeCollection*) _tmp26_);
#line 5407 "../src/Photo.vala"
			_tmp28_ = _tmp27_;
#line 5407 "../src/Photo.vala"
			_tag_size = _tmp28_;
#line 5407 "../src/Photo.vala"
			_tag_index = -1;
#line 5407 "../src/Photo.vala"
			while (TRUE) {
#line 38402 "Photo.c"
				Tag* tag = NULL;
				GeeList* _tmp29_;
				gpointer _tmp30_;
				GeeSet* _tmp31_;
				Tag* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gboolean _tmp37_;
#line 5407 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5407 "../src/Photo.vala"
				if (!(_tag_index < _tag_size)) {
#line 5407 "../src/Photo.vala"
					break;
#line 38419 "Photo.c"
				}
#line 5407 "../src/Photo.vala"
				_tmp29_ = _tag_list;
#line 5407 "../src/Photo.vala"
				_tmp30_ = gee_list_get (_tmp29_, _tag_index);
#line 5407 "../src/Photo.vala"
				tag = (Tag*) _tmp30_;
#line 5408 "../src/Photo.vala"
				_tmp31_ = keywords;
#line 5408 "../src/Photo.vala"
				_tmp32_ = tag;
#line 5408 "../src/Photo.vala"
				_tmp33_ = data_object_get_name ((DataObject*) _tmp32_);
#line 5408 "../src/Photo.vala"
				_tmp34_ = _tmp33_;
#line 5408 "../src/Photo.vala"
				_tmp35_ = g_utf8_normalize (_tmp34_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5408 "../src/Photo.vala"
				_tmp36_ = _tmp35_;
#line 5408 "../src/Photo.vala"
				_tmp37_ = !gee_collection_contains ((GeeCollection*) _tmp31_, _tmp36_);
#line 5408 "../src/Photo.vala"
				_g_free0 (_tmp36_);
#line 5408 "../src/Photo.vala"
				_g_free0 (_tmp34_);
#line 5408 "../src/Photo.vala"
				if (_tmp37_) {
#line 5409 "../src/Photo.vala"
					result = TRUE;
#line 5409 "../src/Photo.vala"
					_g_object_unref0 (tag);
#line 5409 "../src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5409 "../src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5409 "../src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5409 "../src/Photo.vala"
					_g_object_unref0 (tags);
#line 5409 "../src/Photo.vala"
					return result;
#line 38461 "Photo.c"
				}
#line 5407 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 38465 "Photo.c"
			}
#line 5407 "../src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 38469 "Photo.c"
		}
	}
#line 5414 "../src/Photo.vala"
	result = FALSE;
#line 5414 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5414 "../src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5414 "../src/Photo.vala"
	_g_object_unref0 (tags);
#line 5414 "../src/Photo.vala"
	return result;
#line 38482 "Photo.c"
}

static void
library_photo_real_set_user_metadata_for_export (Photo* base,
                                                 PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
#line 5417 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5417 "../src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5418 "../src/Photo.vala"
	_tmp0_ = tag_global;
#line 5418 "../src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5418 "../src/Photo.vala"
	photo_tags = _tmp1_;
#line 5419 "../src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5419 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 38508 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_;
		GeeCollection* _tmp15_;
#line 5420 "../src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5420 "../src/Photo.vala"
		string_tags = (GeeCollection*) _tmp3_;
#line 38516 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			gint _tag_size = 0;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_index = 0;
#line 5421 "../src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5421 "../src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5421 "../src/Photo.vala"
			_tag_list = _tmp5_;
#line 5421 "../src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5421 "../src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5421 "../src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5421 "../src/Photo.vala"
			_tag_size = _tmp8_;
#line 5421 "../src/Photo.vala"
			_tag_index = -1;
#line 5421 "../src/Photo.vala"
			while (TRUE) {
#line 38544 "Photo.c"
				Tag* tag = NULL;
				GeeList* _tmp9_;
				gpointer _tmp10_;
				GeeCollection* _tmp11_;
				Tag* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 5421 "../src/Photo.vala"
				_tag_index = _tag_index + 1;
#line 5421 "../src/Photo.vala"
				if (!(_tag_index < _tag_size)) {
#line 5421 "../src/Photo.vala"
					break;
#line 38558 "Photo.c"
				}
#line 5421 "../src/Photo.vala"
				_tmp9_ = _tag_list;
#line 5421 "../src/Photo.vala"
				_tmp10_ = gee_list_get (_tmp9_, _tag_index);
#line 5421 "../src/Photo.vala"
				tag = (Tag*) _tmp10_;
#line 5422 "../src/Photo.vala"
				_tmp11_ = string_tags;
#line 5422 "../src/Photo.vala"
				_tmp12_ = tag;
#line 5422 "../src/Photo.vala"
				_tmp13_ = data_object_get_name ((DataObject*) _tmp12_);
#line 5422 "../src/Photo.vala"
				_tmp14_ = _tmp13_;
#line 5422 "../src/Photo.vala"
				gee_collection_add (_tmp11_, _tmp14_);
#line 5422 "../src/Photo.vala"
				_g_free0 (_tmp14_);
#line 5421 "../src/Photo.vala"
				_g_object_unref0 (tag);
#line 38580 "Photo.c"
			}
#line 5421 "../src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 38584 "Photo.c"
		}
#line 5424 "../src/Photo.vala"
		_tmp15_ = string_tags;
#line 5424 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, _tmp15_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5419 "../src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 38592 "Photo.c"
	} else {
#line 5426 "../src/Photo.vala"
		photo_metadata_set_keywords (metadata, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 38596 "Photo.c"
	}
#line 5417 "../src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 38600 "Photo.c"
}

static void
library_photo_real_apply_user_metadata_for_reimport (Photo* base,
                                                     PhotoMetadata* metadata)
{
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	GeeCollection* keywords = NULL;
	GeeSet* _tmp3_;
	GeeCollection* _tmp4_;
	HierarchicalTagIndex* _tmp31_;
#line 5430 "../src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5430 "../src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5431 "../src/Photo.vala"
	new_htag_index = NULL;
#line 5433 "../src/Photo.vala"
	if (photo_metadata_has_hierarchical_keywords (metadata)) {
#line 38621 "Photo.c"
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		HierarchicalTagIndex* _tmp2_;
#line 5434 "../src/Photo.vala"
		_tmp0_ = photo_metadata_get_hierarchical_keywords (metadata);
#line 5434 "../src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 5434 "../src/Photo.vala"
		_tmp2_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp1_);
#line 5434 "../src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5434 "../src/Photo.vala"
		new_htag_index = _tmp2_;
#line 5434 "../src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 38637 "Photo.c"
	}
#line 5438 "../src/Photo.vala"
	_tmp3_ = photo_metadata_get_keywords (metadata, NULL, NULL, NULL);
#line 5438 "../src/Photo.vala"
	keywords = (GeeCollection*) _tmp3_;
#line 5439 "../src/Photo.vala"
	_tmp4_ = keywords;
#line 5439 "../src/Photo.vala"
	if (_tmp4_ != NULL) {
#line 38647 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
#line 5440 "../src/Photo.vala"
			_tmp5_ = keywords;
#line 5440 "../src/Photo.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 5440 "../src/Photo.vala"
			_keyword_it = _tmp6_;
#line 5440 "../src/Photo.vala"
			while (TRUE) {
#line 38660 "Photo.c"
				GeeIterator* _tmp7_;
				gchar* keyword = NULL;
				GeeIterator* _tmp8_;
				gpointer _tmp9_;
				gboolean _tmp10_ = FALSE;
				HierarchicalTagIndex* _tmp11_;
				gchar* safe_keyword = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				TagSourceCollection* _tmp18_;
				const gchar* _tmp19_;
				TagSourceCollection* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp28_;
				Tag* _tmp29_;
				Tag* _tmp30_;
#line 5440 "../src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 5440 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp7_)) {
#line 5440 "../src/Photo.vala"
					break;
#line 38686 "Photo.c"
				}
#line 5440 "../src/Photo.vala"
				_tmp8_ = _keyword_it;
#line 5440 "../src/Photo.vala"
				_tmp9_ = gee_iterator_get (_tmp8_);
#line 5440 "../src/Photo.vala"
				keyword = (gchar*) _tmp9_;
#line 5441 "../src/Photo.vala"
				_tmp11_ = new_htag_index;
#line 5441 "../src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 38698 "Photo.c"
					HierarchicalTagIndex* _tmp12_;
					const gchar* _tmp13_;
#line 5441 "../src/Photo.vala"
					_tmp12_ = new_htag_index;
#line 5441 "../src/Photo.vala"
					_tmp13_ = keyword;
#line 5441 "../src/Photo.vala"
					_tmp10_ = hierarchical_tag_index_is_tag_in_index (_tmp12_, _tmp13_);
#line 38707 "Photo.c"
				} else {
#line 5441 "../src/Photo.vala"
					_tmp10_ = FALSE;
#line 38711 "Photo.c"
				}
#line 5441 "../src/Photo.vala"
				if (_tmp10_) {
#line 5442 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5442 "../src/Photo.vala"
					continue;
#line 38719 "Photo.c"
				}
#line 5445 "../src/Photo.vala"
				_tmp14_ = keyword;
#line 5445 "../src/Photo.vala"
				_tmp15_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp14_);
#line 5445 "../src/Photo.vala"
				safe_keyword = _tmp15_;
#line 5446 "../src/Photo.vala"
				_tmp16_ = safe_keyword;
#line 5446 "../src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp16_);
#line 5446 "../src/Photo.vala"
				promoted_keyword = _tmp17_;
#line 5449 "../src/Photo.vala"
				_tmp18_ = tag_global;
#line 5449 "../src/Photo.vala"
				_tmp19_ = safe_keyword;
#line 5449 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp18_, _tmp19_, FALSE)) {
#line 38739 "Photo.c"
					const gchar* _tmp20_;
					Tag* _tmp21_;
					Tag* _tmp22_;
#line 5450 "../src/Photo.vala"
					_tmp20_ = safe_keyword;
#line 5450 "../src/Photo.vala"
					_tmp21_ = tag_for_path (_tmp20_);
#line 5450 "../src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5450 "../src/Photo.vala"
					tag_attach (_tmp22_, (MediaSource*) self);
#line 5450 "../src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 5451 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5451 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5451 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5451 "../src/Photo.vala"
					continue;
#line 38761 "Photo.c"
				}
#line 5454 "../src/Photo.vala"
				_tmp23_ = tag_global;
#line 5454 "../src/Photo.vala"
				_tmp24_ = promoted_keyword;
#line 5454 "../src/Photo.vala"
				if (tag_source_collection_exists (_tmp23_, _tmp24_, FALSE)) {
#line 38769 "Photo.c"
					const gchar* _tmp25_;
					Tag* _tmp26_;
					Tag* _tmp27_;
#line 5455 "../src/Photo.vala"
					_tmp25_ = promoted_keyword;
#line 5455 "../src/Photo.vala"
					_tmp26_ = tag_for_path (_tmp25_);
#line 5455 "../src/Photo.vala"
					_tmp27_ = _tmp26_;
#line 5455 "../src/Photo.vala"
					tag_attach (_tmp27_, (MediaSource*) self);
#line 5455 "../src/Photo.vala"
					_g_object_unref0 (_tmp27_);
#line 5456 "../src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5456 "../src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5456 "../src/Photo.vala"
					_g_free0 (keyword);
#line 5456 "../src/Photo.vala"
					continue;
#line 38791 "Photo.c"
				}
#line 5459 "../src/Photo.vala"
				_tmp28_ = keyword;
#line 5459 "../src/Photo.vala"
				_tmp29_ = tag_for_path (_tmp28_);
#line 5459 "../src/Photo.vala"
				_tmp30_ = _tmp29_;
#line 5459 "../src/Photo.vala"
				tag_attach (_tmp30_, (MediaSource*) self);
#line 5459 "../src/Photo.vala"
				_g_object_unref0 (_tmp30_);
#line 5440 "../src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5440 "../src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5440 "../src/Photo.vala"
				_g_free0 (keyword);
#line 38809 "Photo.c"
			}
#line 5440 "../src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 38813 "Photo.c"
		}
	}
#line 5463 "../src/Photo.vala"
	_tmp31_ = new_htag_index;
#line 5463 "../src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 38820 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_;
			GeeIterator* _tmp36_;
#line 5464 "../src/Photo.vala"
			_tmp32_ = new_htag_index;
#line 5464 "../src/Photo.vala"
			_tmp33_ = hierarchical_tag_index_get_all_paths (_tmp32_);
#line 5464 "../src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 5464 "../src/Photo.vala"
			_tmp35_ = gee_iterable_iterator ((GeeIterable*) _tmp34_);
#line 5464 "../src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 5464 "../src/Photo.vala"
			_g_object_unref0 (_tmp34_);
#line 5464 "../src/Photo.vala"
			_path_it = _tmp36_;
#line 5464 "../src/Photo.vala"
			while (TRUE) {
#line 38844 "Photo.c"
				GeeIterator* _tmp37_;
				gchar* path = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				const gchar* _tmp40_;
				Tag* _tmp41_;
				Tag* _tmp42_;
#line 5464 "../src/Photo.vala"
				_tmp37_ = _path_it;
#line 5464 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5464 "../src/Photo.vala"
					break;
#line 38858 "Photo.c"
				}
#line 5464 "../src/Photo.vala"
				_tmp38_ = _path_it;
#line 5464 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5464 "../src/Photo.vala"
				path = (gchar*) _tmp39_;
#line 5465 "../src/Photo.vala"
				_tmp40_ = path;
#line 5465 "../src/Photo.vala"
				_tmp41_ = tag_for_path (_tmp40_);
#line 5465 "../src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5465 "../src/Photo.vala"
				tag_attach (_tmp42_, (MediaSource*) self);
#line 5465 "../src/Photo.vala"
				_g_object_unref0 (_tmp42_);
#line 5464 "../src/Photo.vala"
				_g_free0 (path);
#line 38878 "Photo.c"
			}
#line 5464 "../src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 38882 "Photo.c"
		}
	}
#line 5430 "../src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5430 "../src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 38889 "Photo.c"
}

static void
library_photo_class_init (LibraryPhotoClass * klass,
                          gpointer klass_data)
{
#line 5045 "../src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 5045 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhoto_private_offset);
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 5045 "../src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*) (DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*) (Photo*, Rotation)) library_photo_real_rotate;
#line 5045 "../src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) library_photo_real_is_trashed;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) library_photo_real_trash;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) library_photo_real_untrash;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) library_photo_real_is_offline;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) library_photo_real_mark_offline;
#line 5045 "../src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) library_photo_real_mark_online;
#line 5045 "../src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 5045 "../src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) library_photo_real_destroy;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*) (Photo*)) library_photo_real_has_user_generated_metadata;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 5045 "../src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*) (Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 5045 "../src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 38940 "Photo.c"
}

static void
library_photo_flaggable_interface_init (FlaggableIface * iface,
                                        gpointer iface_data)
{
#line 5045 "../src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 5045 "../src/Photo.vala"
	iface->is_flagged = (gboolean (*) (Flaggable*)) library_photo_real_is_flagged;
#line 5045 "../src/Photo.vala"
	iface->mark_flagged = (void (*) (Flaggable*)) library_photo_real_mark_flagged;
#line 5045 "../src/Photo.vala"
	iface->mark_unflagged = (void (*) (Flaggable*)) library_photo_real_mark_unflagged;
#line 38955 "Photo.c"
}

static void
library_photo_monitorable_interface_init (MonitorableIface * iface,
                                          gpointer iface_data)
{
#line 5045 "../src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 5045 "../src/Photo.vala"
	iface->is_offline = (gboolean (*) (Monitorable*)) library_photo_real_is_offline;
#line 5045 "../src/Photo.vala"
	iface->mark_offline = (void (*) (Monitorable*)) library_photo_real_mark_offline;
#line 5045 "../src/Photo.vala"
	iface->mark_online = (void (*) (Monitorable*)) library_photo_real_mark_online;
#line 5045 "../src/Photo.vala"
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 5045 "../src/Photo.vala"
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) photo_set_master_file;
#line 38974 "Photo.c"
}

static void
library_photo_instance_init (LibraryPhoto * self,
                             gpointer klass)
{
#line 5045 "../src/Photo.vala"
	self->priv = library_photo_get_instance_private (self);
#line 5056 "../src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 5057 "../src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 38987 "Photo.c"
}

static void
library_photo_finalize (GObject * obj)
{
	LibraryPhoto * self;
#line 5045 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 5057 "../src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 5058 "../src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5045 "../src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 39002 "Photo.c"
}

GType
library_photo_get_type (void)
{
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		LibraryPhoto_private_offset = g_type_add_instance_private (library_photo_type_id, sizeof (LibraryPhotoPrivate));
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}

static inline gpointer
library_photo_source_holding_tank_get_instance_private (LibraryPhotoSourceHoldingTank* self)
{
	return G_STRUCT_MEMBER_P (self, LibraryPhotoSourceHoldingTank_private_offset);
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_construct (GType object_type,
                                             LibraryPhotoSourceCollection* sources,
                                             SourceHoldingTankCheckToKeep check_to_keep,
                                             gpointer check_to_keep_target,
                                             GetSourceDatabaseKey get_key,
                                             gpointer get_key_target)
{
	LibraryPhotoSourceHoldingTank* self = NULL;
#line 5481 "../src/Photo.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 5483 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, (MediaSourceCollection*) sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 5481 "../src/Photo.vala"
	return self;
#line 39044 "Photo.c"
}

LibraryPhotoSourceHoldingTank*
library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources,
                                       SourceHoldingTankCheckToKeep check_to_keep,
                                       gpointer check_to_keep_target,
                                       GetSourceDatabaseKey get_key,
                                       gpointer get_key_target)
{
#line 5481 "../src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 39056 "Photo.c"
}

LibraryPhoto*
library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self,
                                                         GFile* file)
{
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	LibraryPhoto* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
#line 5486 "../src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5486 "../src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 5487 "../src/Photo.vala"
	ret = NULL;
#line 5488 "../src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5488 "../src/Photo.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, file);
#line 5488 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5488 "../src/Photo.vala"
	ret = (LibraryPhoto*) _tmp1_;
#line 5489 "../src/Photo.vala"
	_tmp2_ = ret;
#line 5489 "../src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 5490 "../src/Photo.vala"
		result = ret;
#line 5490 "../src/Photo.vala"
		return result;
#line 39092 "Photo.c"
	}
#line 5493 "../src/Photo.vala"
	_tmp3_ = self->priv->development_file_map;
#line 5493 "../src/Photo.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, file);
#line 5493 "../src/Photo.vala"
	result = (LibraryPhoto*) _tmp4_;
#line 5493 "../src/Photo.vala"
	_g_object_unref0 (ret);
#line 5493 "../src/Photo.vala"
	return result;
#line 39104 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender,
                                                                                 GFile* old_file,
                                                                                 GFile* new_file,
                                                                                 gpointer self)
{
#line 5517 "../src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 39115 "Photo.c"
}

static void
_library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender,
                                                                                               gpointer self)
{
#line 5518 "../src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 39124 "Photo.c"
}

static void
library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base,
                                                                GeeCollection* added,
                                                                GeeCollection* removed)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5496 "../src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) base;
#line 5498 "../src/Photo.vala"
	if (added != NULL) {
#line 39137 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp0_;
#line 5499 "../src/Photo.vala"
			_tmp0_ = gee_iterable_iterator ((GeeIterable*) added);
#line 5499 "../src/Photo.vala"
			_source_it = _tmp0_;
#line 5499 "../src/Photo.vala"
			while (TRUE) {
#line 39147 "Photo.c"
				GeeIterator* _tmp1_;
				DataSource* source = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp4_;
				LibraryPhoto* _tmp5_;
				LibraryPhoto* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
				gboolean _tmp9_;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				LibraryPhoto* _tmp34_;
				LibraryPhoto* _tmp35_;
#line 5499 "../src/Photo.vala"
				_tmp1_ = _source_it;
#line 5499 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp1_)) {
#line 5499 "../src/Photo.vala"
					break;
#line 39171 "Photo.c"
				}
#line 5499 "../src/Photo.vala"
				_tmp2_ = _source_it;
#line 5499 "../src/Photo.vala"
				_tmp3_ = gee_iterator_get (_tmp2_);
#line 5499 "../src/Photo.vala"
				source = (DataSource*) _tmp3_;
#line 5500 "../src/Photo.vala"
				_tmp4_ = source;
#line 5500 "../src/Photo.vala"
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5500 "../src/Photo.vala"
				photo = _tmp5_;
#line 5503 "../src/Photo.vala"
				_tmp6_ = photo;
#line 5503 "../src/Photo.vala"
				_tmp7_ = photo_get_editable_file ((Photo*) _tmp6_);
#line 5503 "../src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 5503 "../src/Photo.vala"
				_tmp9_ = _tmp8_ != NULL;
#line 5503 "../src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 5503 "../src/Photo.vala"
				if (_tmp9_) {
#line 39197 "Photo.c"
					GeeHashMap* _tmp10_;
					LibraryPhoto* _tmp11_;
					GFile* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
					GeeMultiMap* _tmp15_;
					LibraryPhoto* _tmp16_;
					LibraryPhoto* _tmp17_;
					GFile* _tmp18_;
					GFile* _tmp19_;
#line 5504 "../src/Photo.vala"
					_tmp10_ = self->priv->editable_file_map;
#line 5504 "../src/Photo.vala"
					_tmp11_ = photo;
#line 5504 "../src/Photo.vala"
					_tmp12_ = photo_get_editable_file ((Photo*) _tmp11_);
#line 5504 "../src/Photo.vala"
					_tmp13_ = _tmp12_;
#line 5504 "../src/Photo.vala"
					_tmp14_ = photo;
#line 5504 "../src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp13_, _tmp14_);
#line 5504 "../src/Photo.vala"
					_g_object_unref0 (_tmp13_);
#line 5505 "../src/Photo.vala"
					_tmp15_ = self->priv->reverse_editable_file_map;
#line 5505 "../src/Photo.vala"
					_tmp16_ = photo;
#line 5505 "../src/Photo.vala"
					_tmp17_ = photo;
#line 5505 "../src/Photo.vala"
					_tmp18_ = photo_get_editable_file ((Photo*) _tmp17_);
#line 5505 "../src/Photo.vala"
					_tmp19_ = _tmp18_;
#line 5505 "../src/Photo.vala"
					gee_multi_map_set (_tmp15_, _tmp16_, _tmp19_);
#line 5505 "../src/Photo.vala"
					_g_object_unref0 (_tmp19_);
#line 39236 "Photo.c"
				}
#line 5509 "../src/Photo.vala"
				_tmp20_ = photo;
#line 5509 "../src/Photo.vala"
				_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 5509 "../src/Photo.vala"
				raw_files = _tmp21_;
#line 5510 "../src/Photo.vala"
				_tmp22_ = raw_files;
#line 5510 "../src/Photo.vala"
				if (_tmp22_ != NULL) {
#line 39248 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp23_;
						GeeIterator* _tmp24_;
#line 5511 "../src/Photo.vala"
						_tmp23_ = raw_files;
#line 5511 "../src/Photo.vala"
						_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 5511 "../src/Photo.vala"
						_f_it = _tmp24_;
#line 5511 "../src/Photo.vala"
						while (TRUE) {
#line 39261 "Photo.c"
							GeeIterator* _tmp25_;
							GFile* f = NULL;
							GeeIterator* _tmp26_;
							gpointer _tmp27_;
							GeeHashMap* _tmp28_;
							GFile* _tmp29_;
							LibraryPhoto* _tmp30_;
							GeeMultiMap* _tmp31_;
							LibraryPhoto* _tmp32_;
							GFile* _tmp33_;
#line 5511 "../src/Photo.vala"
							_tmp25_ = _f_it;
#line 5511 "../src/Photo.vala"
							if (!gee_iterator_next (_tmp25_)) {
#line 5511 "../src/Photo.vala"
								break;
#line 39278 "Photo.c"
							}
#line 5511 "../src/Photo.vala"
							_tmp26_ = _f_it;
#line 5511 "../src/Photo.vala"
							_tmp27_ = gee_iterator_get (_tmp26_);
#line 5511 "../src/Photo.vala"
							f = (GFile*) _tmp27_;
#line 5512 "../src/Photo.vala"
							_tmp28_ = self->priv->development_file_map;
#line 5512 "../src/Photo.vala"
							_tmp29_ = f;
#line 5512 "../src/Photo.vala"
							_tmp30_ = photo;
#line 5512 "../src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
#line 5513 "../src/Photo.vala"
							_tmp31_ = self->priv->reverse_development_file_map;
#line 5513 "../src/Photo.vala"
							_tmp32_ = photo;
#line 5513 "../src/Photo.vala"
							_tmp33_ = f;
#line 5513 "../src/Photo.vala"
							gee_multi_map_set (_tmp31_, _tmp32_, _tmp33_);
#line 5511 "../src/Photo.vala"
							_g_object_unref0 (f);
#line 39304 "Photo.c"
						}
#line 5511 "../src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 39308 "Photo.c"
					}
				}
#line 5517 "../src/Photo.vala"
				_tmp34_ = photo;
#line 5517 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp34_, "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5518 "../src/Photo.vala"
				_tmp35_ = photo;
#line 5518 "../src/Photo.vala"
				g_signal_connect ((Photo*) _tmp35_, "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5499 "../src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5499 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5499 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 39325 "Photo.c"
			}
#line 5499 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 39329 "Photo.c"
		}
	}
#line 5522 "../src/Photo.vala"
	if (removed != NULL) {
#line 39334 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp36_;
#line 5523 "../src/Photo.vala"
			_tmp36_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 5523 "../src/Photo.vala"
			_source_it = _tmp36_;
#line 5523 "../src/Photo.vala"
			while (TRUE) {
#line 39344 "Photo.c"
				GeeIterator* _tmp37_;
				DataSource* source = NULL;
				GeeIterator* _tmp38_;
				gpointer _tmp39_;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				GeeMultiMap* _tmp64_;
				LibraryPhoto* _tmp65_;
				GeeMultiMap* _tmp66_;
				LibraryPhoto* _tmp67_;
				LibraryPhoto* _tmp68_;
				guint _tmp69_;
				LibraryPhoto* _tmp70_;
				guint _tmp71_;
#line 5523 "../src/Photo.vala"
				_tmp37_ = _source_it;
#line 5523 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp37_)) {
#line 5523 "../src/Photo.vala"
					break;
#line 39366 "Photo.c"
				}
#line 5523 "../src/Photo.vala"
				_tmp38_ = _source_it;
#line 5523 "../src/Photo.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 5523 "../src/Photo.vala"
				source = (DataSource*) _tmp39_;
#line 5524 "../src/Photo.vala"
				_tmp40_ = source;
#line 5524 "../src/Photo.vala"
				_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5524 "../src/Photo.vala"
				photo = _tmp41_;
#line 39380 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeCollection* _tmp44_;
					GeeCollection* _tmp45_;
					GeeIterator* _tmp46_;
					GeeIterator* _tmp47_;
#line 5525 "../src/Photo.vala"
					_tmp42_ = self->priv->reverse_editable_file_map;
#line 5525 "../src/Photo.vala"
					_tmp43_ = photo;
#line 5525 "../src/Photo.vala"
					_tmp44_ = gee_multi_map_get (_tmp42_, _tmp43_);
#line 5525 "../src/Photo.vala"
					_tmp45_ = _tmp44_;
#line 5525 "../src/Photo.vala"
					_tmp46_ = gee_iterable_iterator ((GeeIterable*) _tmp45_);
#line 5525 "../src/Photo.vala"
					_tmp47_ = _tmp46_;
#line 5525 "../src/Photo.vala"
					_g_object_unref0 (_tmp45_);
#line 5525 "../src/Photo.vala"
					_f_it = _tmp47_;
#line 5525 "../src/Photo.vala"
					while (TRUE) {
#line 39407 "Photo.c"
						GeeIterator* _tmp48_;
						GFile* f = NULL;
						GeeIterator* _tmp49_;
						gpointer _tmp50_;
						GeeHashMap* _tmp51_;
						GFile* _tmp52_;
#line 5525 "../src/Photo.vala"
						_tmp48_ = _f_it;
#line 5525 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp48_)) {
#line 5525 "../src/Photo.vala"
							break;
#line 39420 "Photo.c"
						}
#line 5525 "../src/Photo.vala"
						_tmp49_ = _f_it;
#line 5525 "../src/Photo.vala"
						_tmp50_ = gee_iterator_get (_tmp49_);
#line 5525 "../src/Photo.vala"
						f = (GFile*) _tmp50_;
#line 5526 "../src/Photo.vala"
						_tmp51_ = self->priv->editable_file_map;
#line 5526 "../src/Photo.vala"
						_tmp52_ = f;
#line 5526 "../src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp51_, _tmp52_, NULL);
#line 5525 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 39436 "Photo.c"
					}
#line 5525 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 39440 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp53_;
					LibraryPhoto* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 5529 "../src/Photo.vala"
					_tmp53_ = self->priv->reverse_development_file_map;
#line 5529 "../src/Photo.vala"
					_tmp54_ = photo;
#line 5529 "../src/Photo.vala"
					_tmp55_ = gee_multi_map_get (_tmp53_, _tmp54_);
#line 5529 "../src/Photo.vala"
					_tmp56_ = _tmp55_;
#line 5529 "../src/Photo.vala"
					_tmp57_ = gee_iterable_iterator ((GeeIterable*) _tmp56_);
#line 5529 "../src/Photo.vala"
					_tmp58_ = _tmp57_;
#line 5529 "../src/Photo.vala"
					_g_object_unref0 (_tmp56_);
#line 5529 "../src/Photo.vala"
					_f_it = _tmp58_;
#line 5529 "../src/Photo.vala"
					while (TRUE) {
#line 39468 "Photo.c"
						GeeIterator* _tmp59_;
						GFile* f = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						GeeHashMap* _tmp62_;
						GFile* _tmp63_;
#line 5529 "../src/Photo.vala"
						_tmp59_ = _f_it;
#line 5529 "../src/Photo.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 5529 "../src/Photo.vala"
							break;
#line 39481 "Photo.c"
						}
#line 5529 "../src/Photo.vala"
						_tmp60_ = _f_it;
#line 5529 "../src/Photo.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 5529 "../src/Photo.vala"
						f = (GFile*) _tmp61_;
#line 5530 "../src/Photo.vala"
						_tmp62_ = self->priv->development_file_map;
#line 5530 "../src/Photo.vala"
						_tmp63_ = f;
#line 5530 "../src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp62_, _tmp63_, NULL);
#line 5529 "../src/Photo.vala"
						_g_object_unref0 (f);
#line 39497 "Photo.c"
					}
#line 5529 "../src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 39501 "Photo.c"
				}
#line 5533 "../src/Photo.vala"
				_tmp64_ = self->priv->reverse_editable_file_map;
#line 5533 "../src/Photo.vala"
				_tmp65_ = photo;
#line 5533 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp64_, _tmp65_);
#line 5534 "../src/Photo.vala"
				_tmp66_ = self->priv->reverse_development_file_map;
#line 5534 "../src/Photo.vala"
				_tmp67_ = photo;
#line 5534 "../src/Photo.vala"
				gee_multi_map_remove_all (_tmp66_, _tmp67_);
#line 5536 "../src/Photo.vala"
				_tmp68_ = photo;
#line 5536 "../src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp69_, NULL, FALSE);
#line 5536 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp68_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp69_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5537 "../src/Photo.vala"
				_tmp70_ = photo;
#line 5537 "../src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp71_, NULL, FALSE);
#line 5537 "../src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp70_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp71_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5523 "../src/Photo.vala"
				_g_object_unref0 (photo);
#line 5523 "../src/Photo.vala"
				_g_object_unref0 (source);
#line 39531 "Photo.c"
			}
#line 5523 "../src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 39535 "Photo.c"
		}
	}
#line 5541 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), added, removed);
#line 39540 "Photo.c"
}

static void
library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self,
                                                        Photo* _photo,
                                                        GFile* old_file,
                                                        GFile* new_file)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp7_;
	LibraryPhoto* _tmp8_;
#line 5544 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5544 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5545 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5545 "../src/Photo.vala"
	photo = _tmp0_;
#line 5546 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5546 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5548 "../src/Photo.vala"
	if (old_file != NULL) {
#line 39568 "Photo.c"
		GeeHashMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		LibraryPhoto* _tmp4_;
#line 5549 "../src/Photo.vala"
		_tmp2_ = self->priv->editable_file_map;
#line 5549 "../src/Photo.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, old_file, NULL);
#line 5550 "../src/Photo.vala"
		_tmp3_ = self->priv->reverse_editable_file_map;
#line 5550 "../src/Photo.vala"
		_tmp4_ = photo;
#line 5550 "../src/Photo.vala"
		gee_multi_map_remove (_tmp3_, _tmp4_, old_file);
#line 39582 "Photo.c"
	}
#line 5553 "../src/Photo.vala"
	if (new_file != NULL) {
#line 39586 "Photo.c"
		GeeHashMap* _tmp5_;
		LibraryPhoto* _tmp6_;
#line 5554 "../src/Photo.vala"
		_tmp5_ = self->priv->editable_file_map;
#line 5554 "../src/Photo.vala"
		_tmp6_ = photo;
#line 5554 "../src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, new_file, _tmp6_);
#line 39595 "Photo.c"
	}
#line 5556 "../src/Photo.vala"
	_tmp7_ = self->priv->reverse_editable_file_map;
#line 5556 "../src/Photo.vala"
	_tmp8_ = photo;
#line 5556 "../src/Photo.vala"
	gee_multi_map_set (_tmp7_, _tmp8_, new_file);
#line 5544 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 39605 "Photo.c"
}

static void
library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self,
                                                               Photo* _photo)
{
	LibraryPhoto* photo = NULL;
	LibraryPhoto* _tmp0_;
	LibraryPhoto* _tmp1_;
	GeeMultiMap* _tmp2_;
	LibraryPhoto* _tmp3_;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp17_;
	GeeCollection* _tmp18_;
	GeeCollection* _tmp19_;
#line 5559 "../src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5559 "../src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5560 "../src/Photo.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_photo, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _photo) : NULL);
#line 5560 "../src/Photo.vala"
	photo = _tmp0_;
#line 5561 "../src/Photo.vala"
	_tmp1_ = photo;
#line 5561 "../src/Photo.vala"
	_vala_assert (_tmp1_ != NULL, "photo != null");
#line 5564 "../src/Photo.vala"
	_tmp2_ = self->priv->reverse_development_file_map;
#line 5564 "../src/Photo.vala"
	_tmp3_ = photo;
#line 5564 "../src/Photo.vala"
	if (gee_multi_map_contains (_tmp2_, _tmp3_)) {
#line 39639 "Photo.c"
		GeeMultiMap* _tmp15_;
		LibraryPhoto* _tmp16_;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp4_;
			LibraryPhoto* _tmp5_;
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_;
			GeeIterator* _tmp9_;
#line 5565 "../src/Photo.vala"
			_tmp4_ = self->priv->reverse_development_file_map;
#line 5565 "../src/Photo.vala"
			_tmp5_ = photo;
#line 5565 "../src/Photo.vala"
			_tmp6_ = gee_multi_map_get (_tmp4_, _tmp5_);
#line 5565 "../src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 5565 "../src/Photo.vala"
			_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 5565 "../src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5565 "../src/Photo.vala"
			_g_object_unref0 (_tmp7_);
#line 5565 "../src/Photo.vala"
			_f_it = _tmp9_;
#line 5565 "../src/Photo.vala"
			while (TRUE) {
#line 39668 "Photo.c"
				GeeIterator* _tmp10_;
				GFile* f = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				GeeHashMap* _tmp13_;
				GFile* _tmp14_;
#line 5565 "../src/Photo.vala"
				_tmp10_ = _f_it;
#line 5565 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 5565 "../src/Photo.vala"
					break;
#line 39681 "Photo.c"
				}
#line 5565 "../src/Photo.vala"
				_tmp11_ = _f_it;
#line 5565 "../src/Photo.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 5565 "../src/Photo.vala"
				f = (GFile*) _tmp12_;
#line 5566 "../src/Photo.vala"
				_tmp13_ = self->priv->development_file_map;
#line 5566 "../src/Photo.vala"
				_tmp14_ = f;
#line 5566 "../src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp13_, _tmp14_, NULL);
#line 5565 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 39697 "Photo.c"
			}
#line 5565 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 39701 "Photo.c"
		}
#line 5568 "../src/Photo.vala"
		_tmp15_ = self->priv->reverse_development_file_map;
#line 5568 "../src/Photo.vala"
		_tmp16_ = photo;
#line 5568 "../src/Photo.vala"
		gee_multi_map_remove_all (_tmp15_, _tmp16_);
#line 39709 "Photo.c"
	}
#line 5572 "../src/Photo.vala"
	_tmp17_ = photo;
#line 5572 "../src/Photo.vala"
	_tmp18_ = photo_get_raw_developer_files ((Photo*) _tmp17_);
#line 5572 "../src/Photo.vala"
	raw_list = _tmp18_;
#line 5573 "../src/Photo.vala"
	_tmp19_ = raw_list;
#line 5573 "../src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 39721 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp20_;
			GeeIterator* _tmp21_;
#line 5574 "../src/Photo.vala"
			_tmp20_ = raw_list;
#line 5574 "../src/Photo.vala"
			_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 5574 "../src/Photo.vala"
			_f_it = _tmp21_;
#line 5574 "../src/Photo.vala"
			while (TRUE) {
#line 39734 "Photo.c"
				GeeIterator* _tmp22_;
				GFile* f = NULL;
				GeeIterator* _tmp23_;
				gpointer _tmp24_;
				GeeHashMap* _tmp25_;
				GFile* _tmp26_;
				LibraryPhoto* _tmp27_;
				GeeMultiMap* _tmp28_;
				LibraryPhoto* _tmp29_;
				GFile* _tmp30_;
#line 5574 "../src/Photo.vala"
				_tmp22_ = _f_it;
#line 5574 "../src/Photo.vala"
				if (!gee_iterator_next (_tmp22_)) {
#line 5574 "../src/Photo.vala"
					break;
#line 39751 "Photo.c"
				}
#line 5574 "../src/Photo.vala"
				_tmp23_ = _f_it;
#line 5574 "../src/Photo.vala"
				_tmp24_ = gee_iterator_get (_tmp23_);
#line 5574 "../src/Photo.vala"
				f = (GFile*) _tmp24_;
#line 5575 "../src/Photo.vala"
				_tmp25_ = self->priv->development_file_map;
#line 5575 "../src/Photo.vala"
				_tmp26_ = f;
#line 5575 "../src/Photo.vala"
				_tmp27_ = photo;
#line 5575 "../src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp27_);
#line 5576 "../src/Photo.vala"
				_tmp28_ = self->priv->reverse_development_file_map;
#line 5576 "../src/Photo.vala"
				_tmp29_ = photo;
#line 5576 "../src/Photo.vala"
				_tmp30_ = f;
#line 5576 "../src/Photo.vala"
				gee_multi_map_set (_tmp28_, _tmp29_, _tmp30_);
#line 5574 "../src/Photo.vala"
				_g_object_unref0 (f);
#line 39777 "Photo.c"
			}
#line 5574 "../src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 39781 "Photo.c"
		}
	}
#line 5559 "../src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5559 "../src/Photo.vala"
	_g_object_unref0 (photo);
#line 39788 "Photo.c"
}

static void
library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass,
                                              gpointer klass_data)
{
#line 5471 "../src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5471 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5471 "../src/Photo.vala"
	g_type_class_adjust_private_offset (klass, &LibraryPhotoSourceHoldingTank_private_offset);
#line 5471 "../src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*) (SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 39803 "Photo.c"
}

static void
library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self,
                                                 gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeHashMultiMap* _tmp3_;
#line 5471 "../src/Photo.vala"
	self->priv = library_photo_source_holding_tank_get_instance_private (self);
#line 5472 "../src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5472 "../src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5474 "../src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5474 "../src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5476 "../src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5476 "../src/Photo.vala"
	self->priv->reverse_editable_file_map = (GeeMultiMap*) _tmp2_;
#line 5478 "../src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5478 "../src/Photo.vala"
	self->priv->reverse_development_file_map = (GeeMultiMap*) _tmp3_;
#line 39832 "Photo.c"
}

static void
library_photo_source_holding_tank_finalize (SourceHoldingTank * obj)
{
	LibraryPhotoSourceHoldingTank * self;
#line 5471 "../src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5472 "../src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5474 "../src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5476 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5478 "../src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5471 "../src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 39851 "Photo.c"
}

GType
library_photo_source_holding_tank_get_type (void)
{
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		LibraryPhotoSourceHoldingTank_private_offset = g_type_add_instance_private (library_photo_source_holding_tank_type_id, sizeof (LibraryPhotoSourceHoldingTankPrivate));
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

